//*CID://+v5eqR~:                             update#=   50;       //+v5eqR~
//******************************************************           //~v57GI~
//v5eq:041030 ebc<-->sjis:CP290 option(katakana extended)          //+v5eqI~
//v5ep:041030 (BUG)ebc<-->sjis:ebc "?" should be 0x6f (not 3f)     //~v5epI~
//v5em:041026 ebc<-->sjis chkprint also sbcs tbl                   //~v5emI~
//v5ek:041026 ebc<-->sjis dbcs support;option of asume SO top of line//~v5ekI~
//v5ej:041023 ebc<-->sjis dbcs support;delete rep any char by so/si//~v5eiI~
//v5ei:041023 ebc<-->sjis dbcs support;xe cont line support        //~v5eiI~
//v5eh:041023 ebc<-->sjis dbcs support;length chk option(before set conversion out)//~v5ehI~
//v5eg:041023 ebc<-->sjis dbcs support;sosi isrt/del/rep option support//~v5egI~
//v5ef:041023 ebc<-->sjis dbcs support,dbcs errrep char support    //~v5efI~
//v5ed:041020 ebc<-->sjis dbcs support                             //~v5edI~
//v57V:030727 conv ascii<->ebc ctl char option                     //~v57SI~
//v57U:030726 conv ascii-->ebc(CP1027pg)                 //~v57SI~
//v57S:030726 hankaku katakana<-->alphabet small letter conversion //~v57SI~
//v57G:030607 for EBCDIC-->ASCII conversion                        //~v57GI~
//******************************************************           //~v57GI~
#define CHAR_SO    0x0e    //shift out                             //~v5edI~
#define CHAR_SI    0x0f    //shift in                              //~v5edI~
#define CHAR_EBC_SPACE   0x40    //ebcdic space                    //~v5eiI~
#define CHAR_EBC_ERR     0x6f    //ebcdic "?"                      //~v5epI~
//******************************************************           //~v5edI~
unsigned char *ucvebc_gettrte2a(void);                             //~v57GI~
//*******************************************************          //~v57GI~
//int ucvebc_2asc(int Popt,unsigned char *Pibuff,unsigned char *Pobuff,int Plen);//~v57SR~
//int ucvebc2asc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,unsigned char *Pobuff,int Plen,UCHAR Prepchar);//~v5efR~
//int ucvasc2ebc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,unsigned char *Pobuff,int Plen,UCHAR Prepchar);//~v5efR~
//int ucvebc2asc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,unsigned char *Pobuff,int Plen,int Prepchar);//~v5eiR~
//int ucvasc2ebc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,unsigned char *Pobuff,int Plen,int Prepchar);//~v5eiR~
int ucvebc2asc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,//~v5eiI~
               unsigned char *Pobuff,int Plen,int Prepchar,int *Ppoutlen);//~v5eiI~
int ucvasc2ebc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,//~v5eiI~
				unsigned char *Pobuff,int Plen,int Prepchar,int *Ppoutlen);//~v5eiR~
#define EBC2ASC_CRLF   0x01                                        //~v57GI~
#define EBC2ASC_A2E    0x02    	//ascii-->ebc                      //~v57SI~
#define EBC2ASC_CTL    0x04    	//ctl char conv                    //~v57SI~
#define EBC2ASC_CP290  0x08    	//ebc2asc use cp290(not cp1027)    //+v5eqI~
#define EBC2ASC_NEC      0x10    //dbcs map to nec area            //~v5edR~
#define EBC2ASC_IBM      0x20    //dbcs map to ibm area            //~v5edR~
#define EBC2ASC_OLD      0x40    //oldjis(78) seq                  //~v5edR~
#define EBC2ASC_NEW      0x80    //newjis(83) seq                  //~v5edR~
#define EBC2ASC_DBCS   0x0100     //newjis(83) seq                 //~v5edI~
#define EBC2ASC_SOSI   0x0200     //default;isrt(a2e),rep by space(e2a)//~v5eiR~
#define EBC2ASC_SOSIAS 0x0400     //asume so before the line top(e2a)//~v5ekR~
#define EBC2ASC_SOSID  0x0800     //del sosi(e2a/a2e)              //~v5eiI~
#define EBC2ASC_SOSIOS 0x1000     //override boundary space(a2e)   //~v5ekR~
#define EBC2ASC_BUFTOP 0x2000     //previous byte can not be rep by SO for a2e//~v5egR~
#define EBC2ASC_LNCONT 0x4000     //line continued to next         //~v5eiR~
#define EBC2ASC_SOCONT 0x8000     //SO status continuing           //~v5eiR~
                                                                   //~v5eiI~
#define EBC2ASC_RC_ERRREP    0x01                                  //~v5eiM~
#define EBC2ASC_RC_HALFBYTE  0x04                                  //~v5eiM~
#define EBC2ASC_RC_ISRTSO    0x08   //SO inserted because rep not avail//~v5eiM~
#define EBC2ASC_RC_ISRTSI    0x10   //SI inserted because rep not avail//~v5eiM~
#define EBC2ASC_RC_SIPEND    0x20   //SI set pending by end of line of continuening line//~v5eiR~
#define EBC2ASC_RC_DBCSFOUND 0x40   //line has dbcs                //~v5eiI~
#define EBC2ASC_RC_ISRTTOPSO 0x80   //SO is inserted to top of line//~v5eiR~
//*******************************************************          //~v57SI~
int ucvkandl(int Popt,unsigned char *Pibuff,unsigned char *Pobuff,int Plen);//~v57SR~
#define KANDL_K2L      0x01                                        //~v57SI~
#define KANDL_RC_DBCSSPLIT   -1    //for conv;last is dbcs 1st byte only//~v57SI~
#define KANDL_RC_WILLCONV    -2    //for chk only;exist char to be converted//~v57SI~
//*******************************************************          //~v5emI~
int ucvebc2_chkprintsbcs(int Popt,int Prepchar);                   //~v5emR~
