//*CID://+v5i7R~:                             update#=  119;       //~v5i7R~
//**************************************************
//*DBCS first byte chk
//*parm :char to be checked
//*     :if 0,return 1 if dbcs environment exist                   //~v024I~
//*rc   :0-not DBCS first byte,1:DBCS first byte
//**************************************************
//v5i7:060601 (LNX:FC5)utf8 not yet supported but set no EUC flag but set utf8 flag//~v5i7I~
//v5g7:050613 (XXE)xxe support;no ttychk required for xxe,use LANG only//~v5g7I~
//v5ad:040105 support TZ=hhmm and DBCS=EUC/SJIS                    //~v582I~
//v582:030808 (LNX)under X;kterm/gterm(rh9)support EUC dbcs        //~v582I~
//v57p:030118 (AIX)display all ms932 char                          //~v57pI~
//v57f:021229 (BUG)last esc(B create invalid sjis                  //~v57fI~
//v57e:021228 sjis-->jis conv support                              //~v57eI~
//v57d:021228 sjis<->euc conv contline support                     //~v57dI~
//v570:021205 (WXE)get codepage by WIN API                         //~v570I~
//v570:020824 wxe support                                          //~v570I~
//v56x:020805 (BUG)editfilename DBCS support                       //~v56xI~
//v560:020619 jis decoding support                                 //~v560I~
//v550:020413 string len change by euc<->sjis conv;consider for tabid on dbcstbl//~v550I~
//v549:020409 tabkeep should keep also tabexp id                   //~v549I~
//            (set sbcs when !noclear or dbcs1/2)                  //~v549I~
//v548:020406 (BUG)EUC hankaku-katakana(x8e+sjis-katakana) should drop x8e//~v548I~
//            when euc-->sjis with no zenkaku conv option          //~v548I~
//v513:011211 dbcs combination chk for AIX                         //~v513I~
//v512:011208 v511 for AIX                                         //~v513R~
//v511:011208 (BUG)no clear should be for tab only                 //~v511I~
//v50Y:011202 no clear option of ueucchk                           //~v50YI~
//v50b:010324 LINUX:ajust after merge                              //~v50bI~
//v40v:010122 AIX support:sjis chk(allow up to 2nd level kanji)    //~v40vI~
//v40o:001128 AIX support:DBCS 1stbyte/2nd byte split process required//~v40oI~
//v39P:010121 LINUX support:for xsub set sbcs even if euc when tty(not pty)//~v39PI~
//v39N:010121 LINUX support:jis X 208 chk(jis tbl chk)             //~v39NI~
//v39H:010120 LINUX support:drop undefined from jis range          //~v39HI~
//v39G:010114 LINUX support:under kon,chk max jis kanji <=0x7424 for SW3.5//~v39GI~
//v39F:010114 LINUX support:under kon,set unprintable when sbcs>=0x80 for screen stability//~v39FI~
//v39D:010114 LINUX support:dbcs err chk to avoid screen destroy unker kon//~v39DI~
//v39C:010114 LINUX support:rtn to clear dbcs tbl for force english even if euc//~v39CI~
//v39z:010113 LINUX support:dbcschk by euc code                    //~v39xI~
//v39x:010113 LINUX support:euc conversion(from jconv by  Ken R. Lunde)//~v39xI~
//v39k:001202 LINUX support:ujis chk for unprintable char          //~v39kI~
//v326 000813:LINUX support(DBCS code)                             //~v326R~
//v198:980926 parm may better be uusigned int for sjis to jis conv func//~v198I~
//v166:980426 (BUG)codepage 942(japan SAA) is also japanese on os2 //~v166I~
//v150:980119 need differrentiate codepage and dbcs tbl            //~v150I~
//            w95J codepdge 437 hase dbcs table and first half of DBCS on//~v150I~
//            rightmost column effect on first column of next line //~v150I~
//v140:980110 (W32)codepage 437 support(japanese=932)              //~v140I~
//                 GetCPInfo return system  default,use GetConsolCP for each consol//~v140I~
//v122:971124 add usjis2jis(shift jis to jis)                      //~v122I~
//v061:970208:(BUG)OS/2 only UDBCS table returned by DosQueryDBCSEnv length shortage//~v061I~
//            destroy naighborhood(for ex swsw3 for xprint)        //~v061I~
//v053:970107:gcc version(control by DPMI)                         //~v053I~
//            -dos memory reff by DPMI func                        //~v053I~
//v051:961204:dbcs 2nd byte chk function                           //~v051I~
//v024 960901:dosquerydbcsenv-->udosquerydbcsenv                   //~v024R~
//            because dosquerydbcsenv need /NOI for link parm,     //~v024I~
//            or it must be declare as static.                     //~v024I~
//v022:960727:WIN32(CONSOLE api)                                   //~v022I~
//**************************************************               //~v022I~
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifdef UNX                                                         //~v39PI~
	#include <unistd.h>                                            //~v39PI~
#endif                                                             //~v39PI~
//*************************************************************
#ifdef UNX                                                         //~v326R~
	#ifdef LNX                                                     //~v582I~
        #include <term.h>                                          //~v582I~
    #endif                                                         //~v582R~
#else        //!LINUX                                              //~v326I~
#ifdef DOS
	#include <dos.h>
#else
    #ifdef W32                                                     //~v022I~
    	#include <windows.h>                                       //~v022I~
      #ifdef WXE                                                   //~v570I~
    	#include <winnls.h>                                        //~v570I~
      #endif                                                       //~v570I~
    #else                                                          //~v022I~
	    #define INCL_BASE                                          //~v022R~
    	#include <os2.h>                                           //~v022R~
	#endif                                                         //~v022I~
#endif
#endif     //!UNX                                                  //~v326I~
//*************************************************************
#include <ulib.h>
#include <uerr.h>
#define UDBCSCHK_GBLDEF                                            //~v39kI~
#include <udbcschk.h>
#include <ustring.h>
#ifdef DPMI					//DPMI version                         //~v053I~
	#include <udpmisub.h>                                          //~v053I~
#else                       //not DPMI                             //~v053I~
#endif                      //DPMI or not                          //~v053I~
#include <utrace.h>                                                //~v57eI~
#ifndef DOSDOS                                                     //~v57pI~
	#include <ucvucs.h>                                            //~v57pI~
#endif                                                             //~v57pI~
#ifdef UNX                                                         //~v582R~
	#include <ukbdl.h>                                             //~v582I~
#endif                                                             //~v582I~
//*******************************************************          //~v024I~
//#define MAX_JIS   0x7424  //max for SW3.5                        //~v39HR~
#define SJIS        5                                              //~v39xI~
#define EUC         4                                              //~v39xI~
//int uhan2zen(unsigned char Pkatakana,unsigned char **Ppnext,unsigned char *Pend,int Popt);//~v50bR~
int uhan2zen(unsigned int Pkatakana,unsigned char **Ppnext,unsigned char *Pend,int Popt);//~v50bI~
                                                                   //~v39PI~
#ifdef UNX                                                         //~v39PI~
	int udbcschktty(void);                                         //~v39PI~
#endif                                                             //~v39PI~
                                                                   //~v39PI~
//*******************************************************          //~v39xI~
static	UCHAR *Sdbcsenv=NULL;                                      //~v024M~
static	char   Sdbcstbl[256];	                                   //~v024I~
#ifdef UNX                                                         //~v39HI~
#else                                                              //~v39HI~
static	char   Sjistbl[256]={//04:dbcs 1st ,08:dbcs 2nd            //~v122I~
//       0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f            //~v122I~
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   //00    //~v122I~
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   //10    //~v122I~
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   //20    //~v122I~
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   //30    //~v122I~
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,   //40    //~v122I~
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,   //50    //~v122I~
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,   //60    //~v122I~
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 0,   //70    //~v122I~
         8,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,   //80    //~v122I~
        12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,   //90    //~v122I~
         8,10,10,10,10,10, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,   //a0    //~v122I~
         9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,   //b0    //~v122I~
         9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,   //c0    //~v122I~
         9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,   //d0    //~v122I~
        12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,   //e0    //~v122I~
        12,12,12,12,12,12,12,12,12,12,12,12,12, 0, 0, 0};  //f0    //~v39xR~
#endif                                                             //~v39HI~
//*******************************************************
int udbcschk(UCHAR Pchar)
{
//**********************
	UCHAR *pc;
	int i;
//**********************
	if (!Sdbcsenv)
	{
		Sdbcsenv=udosquerydbcsenv();                               //~v024R~

		for (pc=Sdbcsenv;*pc;pc+=2)
		{
			for (i=*pc;i<=*(pc+1);i++)
				Sdbcstbl[i]=1;	//DBCS
		}
	}
	return (int)Sdbcstbl[Pchar];	//dbcs id=1
}//dbcschk	

//*******************************************************          //~v39CI~
//*force english mode                                              //~v39CI~
//*parm:none                                                       //~v39CI~
//*******************************************************          //~v39CI~
void udbcschk_forceenglish(void)                                   //~v39CI~
{                                                                  //~v39CI~
	memset(Sdbcstbl,0,sizeof(Sdbcstbl));                           //~v39CI~
	return;                                                        //~v39CI~
}//udbcschk_forceenglish(void)                                     //~v39CI~
//*******************************************************          //~v150I~
//*chk dbcsenvtable and codepage *                                 //~v150I~
//*parm:none                                                       //~v150I~
//*rc  :0:no dbcstbl or codepage is not 932 nor 942                //~v166R~
//*    :1:dbctbl and cp eq 932 or 942                              //~v166R~
//*******************************************************          //~v150I~
int udbcschkcp(void)                                               //~v150I~
{                                                                  //~v150I~
//#ifndef WXE                                                      //~v570R~
    int cp;                                                        //~v166I~
//#endif                                                           //~v570R~
//**********************                                           //~v150I~
	if (!udbcsenv())                                               //~v150I~
      if (!(Gudbcschk_flag & UDBCSCHK_UTF8))	//not utf8(utf8 return null dbcstbl but dbcs chk required)//+v5i7I~
    	return 0;                                                  //~v150I~
//  if (ugetcp()!=932)                                             //~v166R~
//#ifndef WXE                                                      //~v570R~
    cp=ugetcp();                                                   //~v166I~
    if (cp!=932 && cp !=942)                                       //~v166I~
    	return 0;		    //english mode under japnaese env      //~v150I~
//#endif                                                           //~v570R~
    if (cp==932)                                                   //~v57pI~
    	if (!(Gudbcschk_flag & UDBCSCHK_EUC))	//not euc          //~v57pI~
    	if (!(Gudbcschk_flag & UDBCSCHK_UTF8))	//not utf8         //+v5i7R~
    		Gudbcschk_flag|=UDBCSCHK_MS932;	//ms932 chk            //~v57pI~
	return 1;           	//full japanese                        //~v150I~
}//udbcschkcp                                                      //~v150I~
//#ifndef WXE                                                      //~v570R~
//*******************************************************          //~v150I~
//*get codepage                                                    //~v150I~
//*parm:none                                                       //~v150I~
//*rc  :code page                                                  //~v150I~
//*******************************************************          //~v150I~
int ugetcp(void)                                                   //~v150I~
{                                                                  //~v150I~
#ifdef UNX                                                         //~v326R~
    UCHAR *plang;                                                  //~v326I~
#else        //!LINUX                                              //~v326I~
#ifdef DOS  					//v7.0a                            //~v150I~
	union REGS	 reg;                                              //~v150I~
#else							//v7.0a                            //~v150I~
	#ifdef W32                                                     //~v150I~
      #ifdef WXE                                                   //~v570I~
        int rc;                                                    //~v570I~
      	char cpgetwk[16];                                          //~v570I~
      #endif                                                       //~v570I~
	#else                                                          //~v150I~
        ULONG cplist[8];                                           //~v150I~
        ULONG cpsize;                                              //~v150I~
		APIRET apiret;                                             //~v150I~
	#endif							//v7.0a                        //~v150I~
#endif							//v7.0a                            //~v150I~
#endif		//!UNX                                                 //~v326R~
//**********************                                           //~v150I~
#ifdef UNX                                                         //~v326R~
	if (!(plang=getenv("LANG")))                                   //~v326I~
    	return 437;                                                //~v326I~
//  if (!ustrstri(plang,"JP"))                                     //~v40oR~
    if (!strstr(plang,"Ja_JP")) //!SJIS                            //~v39kR~
  {//!sjis                                                         //~v582I~
    if (strstr(plang,"ja_JP")) //!EUC                              //~v39kR~
    {                                                              //~v39kI~
      if (strstr(plang,"UTF-8")) //utf8                            //~v5i7I~
    	Gudbcschk_flag|=UDBCSCHK_UTF8;                             //~v5i7I~
      else                                                         //~v5i7I~
    	Gudbcschk_flag|=UDBCSCHK_EUC;					           //~v39xR~
#ifdef LNX                                                         //~v39kI~
  #ifndef XXE                                                      //~v5g7I~
//  	return 437;                                                //~v39xR~
      if (udbcschktty())    //tty(not pty) /dev/tty_               //~v39PI~
    	return 437;                                                //~v39PI~
      else                  //pty          /dev/ttyp               //~v39PI~
    	return 932; 				//japanese                     //~v39xI~
   #endif   //!XXE                                                 //~v5g7I~
#endif                                                             //~v39kI~
    }                                                              //~v39kI~
    else							//EUC                          //~v39kI~
    	return 437;                                                //~v326I~
  }//!sjis                                                         //~v582I~
    return 932;                                                    //~v326I~
#else        //!LINUX                                              //~v326I~
#ifdef DOS  					//v7.0a                            //~v150I~
    memset(&reg,0,sizeof(reg));                                    //~v150I~
    reg.x.ax=0x6601;				  //get DBCS vector            //~v150I~
	#ifdef DPMI					//DPMI version                     //~v150I~
    	udpmiint86(0x21,&reg,&reg); //DS:SI point dbcs tbl         //~v150I~
  	#else                       //not DPMI                         //~v150I~
    	intdos(&reg,&reg);                                         //~v150I~
    #endif                                                         //~v150I~
    return reg.x.bx;        //global code page(DX:system code page)//~v150I~
#else                                                              //~v150I~
	#ifdef W32                                                     //~v150I~
      #ifdef WXE                                                   //~v570I~
	    rc=GetLocaleInfo(LOCALE_SYSTEM_DEFAULT,                    //~v570I~
						LOCALE_IDEFAULTANSICODEPAGE,//   0x00001004   // default ansi code page//~v570I~
		     			cpgetwk,sizeof(cpgetwk));                  //~v570I~
        if (!rc)	//number of byte outout to buff                //~v570I~
        	return 0;                                              //~v570I~
        return atoi(cpgetwk);                                      //~v570I~
      #else                                                        //~v570I~
		return (int)GetConsoleCP();                                //~v150I~
      #endif                                                       //~v570I~
	#else                                                          //~v150I~
        apiret=DosQueryCp(sizeof(cplist),cplist,&cpsize);          //~v150I~
		if (apiret)                                                //~v150I~
			uerrexit("DosQueryCp failed,rc=%d",                    //~v150R~
					 "DosQueryCp API̎s(r.c=%d)",               //~v150R~
					 apiret);                                      //~v150I~
		return (int)cplist[0];                                     //~v150R~
    #endif                                                         //~v150I~
#endif                                                             //~v150I~
#endif		//!UNX                                                 //~v326R~
}//ugetcp                                                          //~v150I~
//#endif	//!WXE                                                 //~v570R~
//*******************************************************          //~v024I~
//*udbcsenv*                                                       //~v024I~
//*return 256 byte table : x00-sbcs x01:dbcs first byte            //~v024I~
//*       null if no dbcs env                                      //~v024I~
//*******************************************************          //~v024I~
char *udbcsenv(void)                                               //~v024I~
{                                                                  //~v024I~
//**********************                                           //~v024I~
	udbcschk(0);		//create static table                      //~v024I~
	if (*Sdbcsenv)                                                 //~v024I~
    	return Sdbcstbl;                                           //~v024I~
	return 0;                                                      //~v024I~
}//udbcsenv                                                        //~v024I~
                                                                   //~v024I~
//**************************************************
//*get DBCS first byte range tbl
//**************************************************
UCHAR *udosquerydbcsenv(void)                                      //~v024R~
{
#ifdef UNX                                                         //~v326R~
  #ifdef LNX                                                       //~v39xI~
	static UCHAR Seuc[]={0xa1,0xfe,0,0};//a1-fe euc dbcs 1st/2nd byte//~v39xI~
  #else                                                            //~v39xI~
    static UCHAR Sdefaulttbl[]={0x81,0x9f,0xe0,0xfc,0,0};          //~v326I~
  #endif                                                           //~v39xI~
    static UCHAR Snulltbl[]={0,0};                                 //~v326I~
    UCHAR *plang;                                                  //~v326I~
#else        //!LINUX                                              //~v326I~
#ifdef DOS  					//v7.0a
	union REGS	 reg;
	struct SREGS sreg;
  #ifdef DPMI					//DPMI version                     //~v053I~
    static UCHAR Sdbcsvector[16];                                  //~v053R~
  #else                       //not DPMI                           //~v053I~
	unsigned char far **fpc;
	USHORT fpi[2];
  #endif                      //DPMI or not                        //~v053M~
#else							//v7.0a
	#ifdef W32                                                     //~v022I~
 static CPINFO cpi;                                                //~v140R~
//        UINT   cpno;                                             //~v150R~
        BOOL   success;                                            //~v022I~
	#else                                                          //~v022I~
//static	UCHAR  dbcstbl[8];                                     //~v061R~
static	UCHAR  dbcstbl[12];                                        //~v061I~
	COUNTRYCODE countrycode={0,0}; 
	APIRET apiret;
	#endif							//v7.0a                        //~v022I~
#endif							//v7.0a
#endif				//!LINUX                                       //~v326I~
//*********************
#ifdef UNX                                                         //~v326R~
	if (!(plang=getenv("LANG")))                                   //~v326I~
    	return Snulltbl;                                           //~v326R~
//  if (!ustrstri(plang,"JP"))                                     //~v40oR~
    if (!strstr(plang,"Ja_JP")) 	//SJIS                         //~v39kR~
  {//!sjis                                                         //~v582I~
    if (strstr(plang,"ja_JP")) 	//EUC                              //~v39kR~
    {                                                              //~v39kI~
      if (strstr(plang,"UTF-8")) //utf8                            //~v5i7I~
    	Gudbcschk_flag|=UDBCSCHK_UTF8;                             //~v5i7I~
      else                                                         //~v5i7I~
    	Gudbcschk_flag|=UDBCSCHK_EUC;                              //~v39xR~
#ifdef LNX                                                         //~v39kI~
    	if (Gudbcschk_flag&UDBCSCHK_UTF8)                          //~v5i7I~
	    	return Snulltbl;	//cannot determined by 1st byte    //~v5i7I~
//  	return Snulltbl;                                           //~v39xR~
    	return Seuc;                                               //~v39xI~
#endif                                                             //~v39kI~
    }                                                              //~v39kI~
    else                                                           //~v39kI~
    	return Snulltbl;                                           //~v326I~
  }//!sjis                                                         //~v582I~
//  return Sdefaulttbl;                                            //~v326I~
	#ifdef LNX	                                                   //~v40oI~
    	return Snulltbl;                                           //~v39kR~
	#else                                                          //~v40oI~
		return Sdefaulttbl;                                        //~v40oI~
    #endif                                                         //~v40oI~
#else        //!LINUX                                              //~v326I~
#ifdef DOS  
    memset(&reg,0,sizeof(reg));                                    //~v053I~
    memset(&sreg,0,sizeof(sreg));                                  //~v053I~
    reg.x.ax=0x6300;				  //get DBCS vector
  #ifdef DPMI					//DPMI version                     //~v053M~
    udpmiint86s(0x21,&reg,&reg,&sreg); //DS:SI point dbcs tbl      //~v053R~
    udpmidosmemget(Sdbcsvector,(int)sreg.ds,(int)reg.x.si,sizeof(Sdbcsvector));//~v053R~
    return Sdbcsvector;                                            //~v053M~
  #else                       //not DPMI                           //~v053M~
    intdosx(&reg,&reg,&sreg);	
 	fpi[0]=reg.x.si;					//DS:SI=vector tbl addr
 	fpi[1]=sreg.ds;						//DS:SI=vector tbl addr
	fpc=(unsigned char far **)(void*)fpi;			//as far ptr
	return *fpc;
  #endif                      //DPMI or not                        //~v053I~
#else
	#ifdef W32                                                     //~v022I~
    	success=GetCPInfo(CP_ACP,&cpi);                            //~v022I~
    	if (!success)                  	//false                    //~v022R~
    		uerrexit("GetCPInfo failed",0);                        //~v022R~
//        cpno=GetConsoleCP();                                     //~v150R~
//        if (cpno!=932)                                           //~v150R~
//            memset(&cpi,0,sizeof(cpi));                          //~v150R~
    	return cpi.LeadByte;                                       //~v022I~
	#else                                                          //~v022I~
	apiret=DosQueryDBCSEnv(12,&countrycode,dbcstbl);
	if (apiret)
		uerrexit("DosQueryDBCSEnv failed,rc=%d",
				 "DosQueryDBCSEnv API̎s(r.c=%d)",
				 apiret);
	return dbcstbl;
	#endif	                                                       //~v022I~
#endif	
#endif       //!LINUX                                              //~v326I~
}//querydbcsenv
                                                                   //~v051I~
//*******************************************************          //~v051I~
//*udbcschk2                                                       //~v051R~
//* dbcs check of specified offset of char on the string           //~v051R~
//* parm1 :buffer                                                  //~v051I~
//* parm2 :char offset                                             //~v051I~
//* return:0:no dbcs,1:dbcs 1st byte,2:dbcs 2nd byte               //~v051R~
//******************************************************           //~v051I~
int udbcschk2(char *Pbuff,int Poffs)                               //~v051R~
{                                                                  //~v051I~
	char *pc,*pc2;                                                 //~v051R~
    int  dbcstype=0;                                                 //~v051I~
//*********************************                                //~v051I~
	pc2=Pbuff+Poffs+1;	//end addr                                 //~v051R~
	for (pc=Pbuff;pc<pc2;pc++)                                     //~v051R~
    {                                                              //~v051I~
		if ((dbcstype=udbcschk(*pc)),dbcstype)	//dbcs 1st byte    //~v051R~
    		pc++;                                                  //~v051I~
	}                                                              //~v051I~
    if (pc!=pc2)	//it is 1st byte        (1st)|next             //~v051R~
    	return 1;                                                  //~v051I~
    if (dbcstype)	//  1st,(2nd)|                                 //~v051I~
    	return 2;                                                  //~v051I~
	else                                                           //~v051I~
		return 0;	//  any,(sbcs)|                                //~v051R~
}//udbcschk2                                                       //~v051R~
//*******************************************************          //~v39NI~
//*ujischkx208                                                     //~v39NR~
//* jis X 208 tbl chk                                              //~v39NI~
//* parm1 :jis code 1st byte                                       //~v39NI~
//* parm2 :jis code 2nd byte                                       //~v39NI~
//* return:1:jis ok,0:err                                          //~v39NI~
//******************************************************           //~v39NI~
int ujischkx208(int P1,int P2)                                     //~v39NR~
{                                                                  //~v39NI~
#define JIS1_START   0x21                                          //~v39NR~
#define JIS1_END     0x74                                          //~v39NR~
#define JIS2_START   0x21                                          //~v39NR~
#define JIS2_END     0x7e                                          //~v39NR~
#define JIS1_SIZE   (JIS1_END-JIS1_START+1)                        //~v39NR~
#define JIS2_SIZE   (JIS2_END-JIS2_START+1)                        //~v39NR~
static char Sjis_22[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,         //20       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,         //30       //~v39NI~
               1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,         //40       //~v39NI~
               1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,         //60       //~v39NI~
               0,0,1,1,1,1,1,1,1,1,0,0,0,0,1  };        //70       //~v39NI~
static char Sjis_23[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //20       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,         //30       //~v39NI~
               0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NR~
               1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,         //50       //~v39NI~
               0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,0,0,0,0  };        //70       //~v39NI~
static char Sjis_24[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //20       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //30       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,0,0,0,0,0,0,0,0,0,0,0  };        //70       //~v39NI~
static char Sjis_25[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //20       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //30       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,1,1,1,0,0,0,0,0,0,0,0  };        //70       //~v39NI~
static char Sjis_26[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //20       //~v39NI~
               1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,         //30       //~v39NI~
               0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NR~
               1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,         //50       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //60       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  };        //70       //~v39NI~
static char Sjis_27[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //20       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //30       //~v39NI~
               1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //40       //~v39NI~
               0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,0,0,0,0,0,0,0,0,0,0,0,0,0  };        //70       //~v39NI~
static char Sjis_28[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //20       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //30       //~v39NI~
               1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //40       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //50       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //60       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  };        //70       //~v39NI~
static char Sjis_4f[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //20       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //30       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,         //50       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //60       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  };        //70       //~v39NI~
static char Sjis_74[JIS2_SIZE]={                                   //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
                 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,         //20       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //30       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //40       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //50       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //60       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  };        //70       //~v39NI~
typedef struct _jistbl {int jis1stsw;char *jis2ndtbl;} jistbl;     //~v39NR~
static jistbl Sjis208tbl[JIS1_SIZE]={                              //~v50bR~
//0     1     2     3     4     5     6     7     8     9     a     b     c     d     e     f//~v39NI~
        {1,0},                                                                                    //20//~v39NI~
              {2,Sjis_22},                                         //~v39NI~
                    {2,Sjis_23},                                   //~v39NI~
                          {2,Sjis_24},                             //~v39NI~
                                {2,Sjis_25},                       //~v39NI~
                                      {2,Sjis_26},                 //~v39NI~
                                            {2,Sjis_27},           //~v39NI~
                                                  {2,Sjis_28},     //~v39NI~
                                                        {0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},//20//~v39NI~
  {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},//30//~v39NI~
  {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},      //40//~v39NI~
                                                                                            {2,Sjis_4f},//40//~v39NI~
  {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},//50//~v39NI~
  {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},//60//~v39NI~
  {1,0},{1,0},{1,0},{1,0},                                                                        //70//~v39NI~
                          {2,Sjis_74}};//70                        //~v39NI~
//*********************************                                //~v39NI~
	P1-=JIS1_START;                                                //~v39NR~
    if (P1<0 || P1>=JIS1_SIZE)                                     //~v39NR~
    	return 0;				//err                              //~v39NI~
	P2-=JIS2_START;                                                //~v39NR~
    if (P2<0 || P2>=JIS2_SIZE)                                     //~v39NR~
    	return 0;				//err                              //~v39NI~
    switch(Sjis208tbl[P1].jis1stsw)                                //~v50bR~
    {                                                              //~v39NI~
    case 1:		//full,0x21-->0x7e                                 //~v39NI~
    	return 1;                                                  //~v39NI~
    case 2:		//partial                                          //~v39NI~
    	return (int)*(Sjis208tbl[P1].jis2ndtbl+P2);                //~v50bR~
    }                                                              //~v39NI~
    return 0;                                                      //~v39NI~
}//ujischkx208                                                     //~v39NR~
//*******************************************************          //~v39NI~
//*usjischkx208                                                    //~v39NR~
//* jis X 208 by sjis tbl chk                                      //~v39NI~
//* parm1 :sjis code 1st byte                                      //~v39NI~
//* parm2 :sjis code 2nd byte                                      //~v39NI~
//* return:1:sjis ok,0:err                                         //~v39NI~
//******************************************************           //~v39NI~
int usjischkx208(int P1,int P2)                                    //~v39NR~
{                                                                  //~v39NI~
#define SJIS1_START   0x81                                         //~v39NR~
#define SJIS1_END     0xea                                         //~v39NR~
#define SJIS2_START   0x40                                         //~v39NR~
#define SJIS2_END     0xfc                                         //~v39NR~
#define SJIS1_SIZE   (SJIS1_END-SJIS1_START+1)                     //~v39NR~
#define SJIS2_SIZE   (SJIS2_END-SJIS2_START+1)                     //~v39NR~
static char Ssjis_81[SJIS2_SIZE]={                                 //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,         //70       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //80       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //90       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,         //a0       //~v39NI~
               0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,         //b0       //~v39NI~
               0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,         //c0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,         //d0       //~v39NI~
               1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,         //e0       //~v39NI~
               1,1,1,1,1,1,1,1,0,0,0,0,1      };        //f0       //~v39NI~
static char Ssjis_82[SJIS2_SIZE]={                                 //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,         //70       //~v39NI~
               0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //80       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,         //90       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //a0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //b0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //c0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //d0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //e0       //~v39NI~
               1,1,0,0,0,0,0,0,0,0,0,0,0      };        //f0       //~v39NI~
static char Ssjis_83[SJIS2_SIZE]={                                 //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,         //70       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //80       //~v39NI~
               1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,         //90       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //a0       //~v39NI~
               1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,         //b0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //c0       //~v39NI~
               1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,         //d0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //e0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0      };        //f0       //~v39NI~
static char Ssjis_84[SJIS2_SIZE]={                                 //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //60       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,         //70       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //80       //~v39NI~
               1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,         //90       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //a0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,         //b0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //c0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //d0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //e0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0      };        //f0       //~v39NI~
#ifdef PC98                                                        //~v39NI~
static char Ssjis_87[SJIS2_SIZE]={       //pc98 gaiji              //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,         //70       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //80       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,         //90       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //a0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //b0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //c0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //d0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //e0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0      };        //f0       //~v39NI~
#endif                                                             //~v39NI~
static char Ssjis_88[SJIS2_SIZE]={                                 //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //40       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //50       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //60       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //70       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //80       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,         //90       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //a0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //b0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //c0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //d0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //e0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1      };        //f0       //~v39NI~
static char Ssjis_98[SJIS2_SIZE]={                                 //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,         //70       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //80       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,         //90       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //a0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //b0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //c0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //d0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //e0       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1      };        //f0       //~v39NI~
static char Ssjis_ea[SJIS2_SIZE]={                                 //~v39NR~
//             0 1 2 3 4 5 6 7 8 9 a b c d e f                     //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //40       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //50       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //60       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,         //70       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //80       //~v39NI~
               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,         //90       //~v39NI~
               1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,         //a0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //b0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //c0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //d0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,         //e0       //~v39NI~
               0,0,0,0,0,0,0,0,0,0,0,0,0      };        //f0       //~v39NI~
typedef struct _ssjistbl {int sjis1stsw;char *sjis2ndtbl;} sjistbl;//~v39NR~
static sjistbl Ssjistbl[SJIS1_SIZE]={                              //~v39NR~
//0     1     2     3     4     5     6     7     8     9     a     b     c     d     e     f//~v39NI~
        {2,Ssjis_81},                                                                              //80//~v39NR~
              {2,Ssjis_82},                                        //~v39NI~
                    {2,Ssjis_83},                                  //~v39NI~
                          {2,Ssjis_84},                            //~v39NI~
                                {0,0},{0,0},                       //~v39NI~
#ifdef PC98                                                        //~v39NI~
                                            {2,Ssjis_87},          //~v39NI~
#else                                                              //~v39NI~
                                            {0,0},                 //~v39NI~
#endif                                                             //~v39NI~
                                                  {2,Ssjis_88},    //~v39NI~
                                                        {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},//80//~v39NI~
  {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},                                                //90//~v39NI~
                                                  {2,Ssjis_98},    //~v39NI~
                                                        {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},//90//~v39NI~
  {0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},//a0//~v39NI~
  {0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},//b0//~v39NI~
  {0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},//c0//~v39NI~
  {0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},//d0//~v39NI~
  {1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},{1,0},                                    //e0//~v39NI~
                                                              {2,Ssjis_ea}};                      //e0//~v39NI~
//*********************************                                //~v39NI~
#if defined(AIX) || defined(W32)                                   //~v57pI~
    if (Gudbcschk_flag & UDBCSCHK_MS932)	//ms932 chk            //~v57pI~
        return (ucp932sjis2ucs((P1<<8)+P2)!=UCVERRUCS);//chk sjis->ucs copnv tbl//~v57pR~
#endif                                                             //~v57pI~
	P1-=SJIS1_START;                                               //~v39NR~
    if (P1<0 || P1>=SJIS1_SIZE)                                    //~v39NR~
    	return 0;				//err                              //~v39NI~
	P2-=SJIS2_START;                                               //~v39NR~
    if (P2<0 || P2>=SJIS2_SIZE)                                    //~v39NR~
    	return 0;				//err                              //~v39NI~
    switch(Ssjistbl[P1].sjis1stsw)                                 //~v39NR~
    {                                                              //~v39NI~
    case 1:		//full,0x40-->0x7e,0x80-->0xfc                     //~v39NI~
    	return (P2!=(0x7f-SJIS2_START));                           //~v39NR~
    case 2:		//partial                                          //~v39NI~
    	return (int)*(Ssjistbl[P1].sjis2ndtbl+P2);                 //~v39NR~
    }                                                              //~v39NI~
    return 0;                                                      //~v39NI~
}//usjischkx208                                                    //~v39NR~
//*******************************************************          //~v122I~
//*usjis2jis                                                       //~v122I~
//* dbcs code conversion,shift jis to jis;regardless dbcs environment//~v122I~
//* parm1 :shift jis code(dbcs1st+2nd)                             //~v122I~
//* return:jis code;0 if code err                                  //~v122I~
//******************************************************           //~v122I~
unsigned int usjis2jis(unsigned int Psjis)                         //~v198R~
{                                                                  //~v122I~
    unsigned int c1,c2;                                            //~v198R~
//*********************************                                //~v122I~
	c1=((Psjis & 0xff00)>>8);                                      //~v122I~
	c2=(Psjis & 0xff);                                             //~v122I~
#ifdef UNX                                                         //~v39HI~
	if (!usjischkx208(c1,c2))	//JIS X 208                        //~v39NR~
    	return 0;                                                  //~v39HI~
#else                                                              //~v39HI~
    if (!(Sjistbl[c1] & 0x04))	//dbcs 1st byte                    //~v122I~
    	return 0;                                                  //~v122I~
    if (!(Sjistbl[c2] & 0x08))  //dbcs 2nd byte                    //~v122I~
    	return 0;                                                  //~v122I~
#endif                                                             //~v39HI~
                                                                   //~v122I~
	if (c1>=0xa0)			//2nd part                             //~v122I~
    	c1-=0xc1;                                                  //~v122I~
	else                    //1st part                             //~v122I~
    	c1-=0x81;                                                  //~v122I~
                                                                   //~v122I~
    if (c2>=0x9f)			                                       //~v122I~
    {                                                              //~v122I~
    	c1+=0x11;                                                  //~v122I~
        c1<<=9;                                                    //~v122I~
        c2-=0x7e;                                                  //~v122I~
    }                                                              //~v122I~
    else                                                           //~v122I~
    {                                                              //~v122I~
        if (c2<=0x7e)                                              //~v122I~
        	c2-=0x1f;                                              //~v122I~
        else                                                       //~v122I~
        	c2-=0x20;                                              //~v122I~
        c1<<=9;                                                    //~v122I~
        c1+=0x2100;                                                //~v122R~
    }                                                              //~v122I~
	return c1+c2;                                                  //~v122I~
}//usjis2jis                                                       //~v122I~
//*******************************************************          //~v39xI~
//*ujis2sjis                                                       //~v39xI~
//* dbcs code conversion,jis to shift jis;regardless dbcs environment//~v39xI~
//* parm1 :jis code(dbcs1st+2nd)                                   //~v39xI~
//* return:shift jis code,0 if err                                 //~v39xI~
//******************************************************           //~v39xI~
unsigned int ujis2sjis(unsigned int Psjis)                         //~v39xR~
{                                                                  //~v39xI~
    unsigned int c1,c2,sjis;                                       //~v39GR~
  	int rowOffset,cellOffset;                                      //~v39xI~
//*********************************                                //~v39xI~
	c1=((Psjis & 0xff00)>>8);                                      //~v39xI~
	c2=(Psjis & 0xff);                                             //~v39xI~
#ifdef UNX                                                         //~v39HI~
//  if (!JIS1(c1) || !JIS2(c2))	//JIS X208 chk                     //~v39NR~
    if (!ujischkx208(c1,c2))       	//JIS X208 chk                 //~v39NR~
        return 0;                                                  //~v39HI~
#endif                                                             //~v39HI~
  	rowOffset = c1 < 0x5f ? 0x70 : 0xb0;                           //~v39xI~
  	cellOffset = c1 % 2 ? (c2 > 0x5f ? 0x20 : 0x1f) : 0x7e;        //~v39xI~
  	c1 = ((c1 + 1) >> 1) + rowOffset;                              //~v39xI~
  	c2 += cellOffset;                                              //~v39xI~
                                                                   //~v39xI~
#ifdef UNX                                                         //~v39HI~
#else                                                              //~v39HI~
    if (!(Sjistbl[c1] & 0x04))  //dbcs 1st byte                    //~v39HR~
        return 0;                                                  //~v39HR~
    if (!(Sjistbl[c2] & 0x08))  //dbcs 2nd byte                    //~v39HR~
        return 0;                                                  //~v39HR~
#endif                                                             //~v39HI~
    sjis=(c1<<8)+c2;                                               //~v39GR~
//    if (sjis>MAX_JIS)                                            //~v39HR~
//        return 0;                                                //~v39HR~
    return sjis;                                                   //~v39GI~
}//ujis2sjis                                                       //~v39xI~
//*******************************************************          //~v560M~
//*ustrjis2sjis                                                    //~v560M~
//* convert jis string to sjis string                              //~v560M~
//*parm1:opt:conv to sjis or euc                                   //~v560M~
//*parm2:input jis string                                          //~v560M~
//*parm3:input len,if 0 use strlen and set ouput null term.        //~v560I~
//*parm4:output string                                             //~v560M~
//*parm5:output outarea len                                        //~v560M~
//*rc   :                 02:dbcs err,10:hankaku found,20:dbcs found//~v560I~
//*******************************************************          //~v560M~
int ustrjis2sjis(int Popt,UCHAR *Pjisstr,int Plen,UCHAR *Poutstr,int *Poutlen)//~v560M~
{                                                                  //~v560M~
  	UCHAR *pci,*pco,*pce,hankana;                                  //~v560R~
    UINT  sjis;                                                    //~v560M~
    int   codetype=CT_ASCII,len,rc=0;                              //~v560R~
    int contlinesw,parmcodetype;                                   //~v57dR~
//******************************                                   //~v560M~
    contlinesw=(Popt & UDBCSCHK_CONTLINE);                         //~v57dI~
	parmcodetype=(Popt & UDBCSCHK_JISMODE);	//codetype parm for contined line//~v57dI~
	if (parmcodetype)	//codetype parm for contined line          //~v57dI~
		codetype=(int)((UINT)parmcodetype>>UDBCSCHK_RC_JISMODESHIFT);	//return jismode for cont line//~v5i7R~
	len=Plen;                                                      //~v560M~
    if (!len)                                                      //~v560M~
    	len=(int)strlen(Pjisstr);                                  //~v560M~
	for (pci=Pjisstr,pce=pci+len,pco=Poutstr;pci<pce;pci++)        //~v560M~
    {                                                              //~v560M~
//      len=(int)((ULONG)pci-(ULONG)Pjisstr);                      //~v57dR~
        len=(int)((ULONG)pce-(ULONG)pci);                          //~v57dR~
UTRACEP("jis2sjis len=%d\n",len);                                  //~v57eI~
//  	if (*pci==0x1b && len>3)                                   //~v57fR~
    	if (*pci==0x1b && len>=3)                                  //~v57fI~
        {                                                          //~v560M~
UTRACEP("jis2sjis 1b len=%d\n",len);                               //~v57eI~
        	switch(*(pci+1))                                       //~v560M~
            {                                                      //~v560M~
            case '$':                                              //~v560M~
	        	switch(*(pci+2))                                   //~v560M~
    	        {                                                  //~v560M~
                case 'B':			//ESC$B   //JISx0208 1983      //~v560M~
                    codetype=CT_JIS83;                             //~v560M~
                    pci+=2;                                        //~v560M~
                	continue;                                      //~v560M~
                case '@':			//ESC$@   //JISx0208 1978      //~v560M~
                    codetype=CT_JIS78;                             //~v560M~
                    pci+=2;                                        //~v560M~
                	continue;                                      //~v560M~
    	        }                                                  //~v560M~
            	break;                                             //~v560M~
            case '(':                                              //~v560M~
	        	switch(*(pci+2))                                   //~v560M~
    	        {                                                  //~v560M~
                case 'B':			//ESC(B   //ASCII              //~v560M~
                    codetype=CT_ASCII;                             //~v560M~
                    pci+=2;                                        //~v560M~
                	continue;                                      //~v560M~
                case 'J':			//ESC(J   //JISx0201 ROMAN     //~v560M~
                    codetype=CT_ROMAN;                             //~v560R~
                    pci+=2;                                        //~v560R~
                	continue;                                      //~v560M~
                case 'I':			//ESC(I   //JISx0201 katakana  //~v560M~
                    codetype=CT_KATAKANA;                          //~v560M~
                    pci+=2;                                        //~v560M~
                	continue;                                      //~v560M~
    	        }                                                  //~v560M~
            	break;                                             //~v560M~
            case '&':                                              //~v560I~
	        	if (*(pci+2)=='@')   //ESC&@   //jis90             //~v560I~
                    continue;                                      //~v560I~
            	break;                                             //~v560I~
            }//ESC$ or ESC(                                        //~v560M~
        }//ESC                                                     //~v560M~
        else                                                       //~v57dI~
//  	if (*pci==0x1b && len<=3 && contlinesw) //spli line        //~v57fR~
    	if (*pci==0x1b && len<3 && contlinesw) //spli line         //~v57fI~
        {                                                          //~v57dI~
        	rc|=(len<<UDBCSCHK_RC_JISSPLITSHIFT);	//UDBCSCHK_RC_JISSPLIT//~v57dR~
UTRACEP("jis2sjis 1b len=%d,rc=5x\n",len,rc);                      //~v57eI~
            break;                                                 //~v57dI~
        }                                                          //~v57dI~
        else	//not ESC                                          //~v560M~
        {                                                          //~v560M~
            switch(codetype)                                       //~v560M~
            {                                                      //~v560M~
            case CT_JIS78:                                         //~v560M~
            case CT_JIS83:                                         //~v560M~
			  if (len<2)	//no dbcs len                          //~v57dI~
              {                                                    //~v57dI~
                	if (contlinesw)                                //~v57dI~
	            		rc|=UDBCSCHK_RC_DBCSSPLIT;                 //~v57dI~
                    else                                           //~v57dI~
		            	rc|=UDBCSCHK_RC_DBCSERR;                   //~v57dI~
			  }                                                    //~v57dI~
              else                                                 //~v57dI~
              {                                                    //~v57dI~
				sjis=ujis2sjis((UINT)((*pci<<8)+*(pci+1)));        //~v57pR~
                if (sjis)	//valid dbcs code                      //~v560M~
                {                                                  //~v560M~
                	*pco++=(UCHAR)(sjis>>8);                       //~v560R~
                	*pco++=(UCHAR)(sjis&255);                      //~v560R~
                    pci++;   		//skip 1st byte                //~v560M~
                    rc|=UDBCSCHK_RC_DBCSFOUND;                     //~v560I~
                    continue;                                      //~v560M~
                }                                                  //~v560M~
              }                                                    //~v57dI~
            	rc|=UDBCSCHK_RC_DBCSERR;                           //~v560I~
            	break;                                             //~v560M~
            case CT_KATAKANA:               //ESC(I  7bit code input//~v560M~
            	*pco++=hankana=(UCHAR)(*pci|0x80);                 //~v560R~
        		if (HANKATA(hankana))                              //~v560I~
	                rc|=UDBCSCHK_RC_HANKANAFOUND;                  //~v560I~
                continue;                                          //~v560M~
            case CT_ROMAN:                  //ESC(J  8bit          //~v560M~
                if (*pci==0x0e)       //ESC(J+S/O                  //~v560R~
                {                                                  //~v560I~
                 	codetype=CT_ROMAN7;                            //~v560I~
                   	continue;                                      //~v560I~
                }                                                  //~v560I~
            	*pco++=hankana=*pci;                               //~v560R~
        		if (HANKATA(hankana))                              //~v560I~
	                rc|=UDBCSCHK_RC_HANKANAFOUND;                  //~v560I~
                continue;                                          //~v560M~
            case CT_ROMAN7:                  //ESC(J+S/O  7 bit    //~v560M~
            	if (*pci==0x0f)                                    //~v560M~
                {                                                  //~v560I~
                	codetype=CT_ASCII;                             //~v560M~
                   	continue;                                      //~v560I~
                }                                                  //~v560I~
                *pco++=hankana=(UCHAR)(*pci|0x80);                 //~v560R~
                if (HANKATA(hankana))                              //~v560R~
                    rc|=UDBCSCHK_RC_HANKANAFOUND;                  //~v560R~
                continue;                                          //~v560M~
            }//code type                                           //~v560M~
        }//ESC or else                                             //~v560M~
	    if (rc & UDBCSCHK_RC_DBCSSPLIT)                            //~v57dI~
        	break;	//loop exit                                    //~v57dI~
        *pco++=*pci;		//ASCII or fmt err case                //~v560M~
    }//string loop                                                 //~v560M~
    if (!Plen)              //input is strz                        //~v560M~
        *pco=0;             //null term                            //~v560M~
    *Poutlen=(int)((ULONG)pco-(ULONG)Poutstr);                     //~v560M~
	rc|=(codetype<<UDBCSCHK_RC_JISMODESHIFT);	//return jismode for cont line//~v57dI~
	return rc;                                                     //~v560R~
}//ustrjis2sjis                                                    //~v560M~
//*******************************************************          //~v57eI~
//*ustrsjis2jis                                                    //~v57eI~
//* dbcs code conversion,shift jis to jis                          //~v57eI~
//*parm1:opt:                                                      //~v57eI~
//*parm2:input sjis string                                         //~v57eI~
//*parm3:input len,if 0 use strlen and set ouput null term.        //~v57eI~
//*parm4:output string                                             //~v57eI~
//*parm5:output outarea len                                        //~v57eI~
//* return:output euc string len                                   //~v57eI~
//*rc   :02:dbcs err,10:hankaku found,20:dbcs found                //~v57eI~
//******************************************************           //~v57eI~
int ustrsjis2jis(int Popt,unsigned char *Psjisstr,int Plen,unsigned char *Pjis,int *Poutlen)//~v57eI~
{                                                                  //~v57eI~
  	unsigned int p1,p2,jis,sjis;                                   //~v57eI~
    int codetype=CT_ASCII,len,rc=0,parmcodetype,hkcsw;             //~v57eR~
  	int contlinesw;                                                //~v57eI~
  	unsigned char *pci,*pco,*pce;                                  //~v57eR~
//*********************************                                //~v57eI~
    hkcsw=(Popt & UDBCSCHK_EUCHKCONV);      //hanzen conv          //~v57eI~
    contlinesw=(Popt & UDBCSCHK_CONTLINE);                         //~v57eI~
	parmcodetype=(Popt & UDBCSCHK_JISMODE);	//codetype parm for contined line//~v57eI~
	if (parmcodetype)	//codetype parm for contined line          //~v57eI~
		codetype=(int)((UINT)parmcodetype>>UDBCSCHK_RC_JISMODESHIFT);	//return jismode for cont line//~v5i7R~
	len=Plen;                                                      //~v57eI~
    if (!len)                                                      //~v57eI~
    	len=(int)strlen(Psjisstr);                                 //~v57eI~
  	for (pci=Psjisstr,pco=Pjis,pce=pci+len;pci<pce;)               //~v57eR~
    {                                                              //~v57eI~
    	p1=*pci++;                                                 //~v57eI~
    	if (SJIS1(p1) & (pci<pce))                                 //~v57eI~
		{                                                          //~v57eI~
      		p2=*pci++;                                             //~v57eI~
      		if (SJIS2(p2))                                         //~v57eI~
			{                                                      //~v57eI~
        		jis=usjis2jis((p1<<8)+p2);                         //~v57eI~
                if (jis)//success                                  //~v57eI~
                {                                                  //~v57eI~
                	if (codetype!=CT_JIS83)                        //~v57eI~
                    {                                              //~v57eI~
	            		if (codetype==CT_ROMAN7)                   //~v57eI~
    	            		*pco++=0x0f;	//shift in,close 8bit mode//~v57eI~
		            	codetype=CT_JIS83;                         //~v57eI~
                        *pco++=0x1b;                               //~v57eI~
                        *pco++='$';                                //~v57eI~
                        *pco++='B';	//esc$B jis83                  //~v57eI~
                    }                                              //~v57eI~
                    *pco++=(UCHAR)(jis>>8);                        //~v57eR~
                    *pco++=(UCHAR)(jis&255);                       //~v57eR~
                    rc|=UDBCSCHK_RC_DBCSFOUND;                     //~v57eI~
                    continue;                                      //~v57eI~
                }                                                  //~v57eI~
      		}                                                      //~v57eI~
            rc|=UDBCSCHK_RC_DBCSERR;                               //~v57eI~
        }                                                          //~v57eI~
    	else                                                       //~v57eI~
        if (HANKATA(p1))                                           //~v57eI~
        {                                                          //~v57eI~
            rc|=UDBCSCHK_RC_HANKANAFOUND;                          //~v57eI~
            if (hkcsw)	//conv to zenkaku                          //~v57eI~
            {                                                      //~v57eI~
                sjis=(unsigned int)uhan2zen(p1,&pci,pce,SJIS);     //~v57eI~
                jis=usjis2jis(sjis);                               //~v57eI~
                if (codetype!=CT_JIS83)                            //~v57eI~
                {                                                  //~v57eI~
	            	if (codetype==CT_ROMAN7)                       //~v57eI~
    	            	*pco++=0x0f;	//shift in,close 8bit mode //~v57eI~
                    codetype=CT_JIS83;                             //~v57eI~
                    *pco++=0x1b;                                   //~v57eI~
                    *pco++='$';                                    //~v57eI~
                    *pco++='B'; //esc$B jis83                      //~v57eI~
                }                                                  //~v57eI~
                *pco++=(UCHAR)(jis>>8);                            //~v57eR~
                *pco++=(UCHAR)(jis&255);                           //~v57eR~
	            continue;                                          //~v57eI~
            }                                                      //~v57eI~
        }//hankaku katakana                                        //~v57eI~
        else                                                       //~v57eI~
    	if (pci==pce)	//last byte                                //~v57eI~
	    	if (SJIS1(p1) && contlinesw)                           //~v57eI~
            {                                                      //~v57eI~
                rc|=UDBCSCHK_RC_DBCSSPLIT;                         //~v57eI~
                break;                                             //~v57eI~
            }                                                      //~v57eI~
        if (p1 & 0x80)                                             //~v57eI~
        {                                                          //~v57eI~
            if (codetype!=CT_ROMAN7)                               //~v57eI~
            {                                                      //~v57eI~
                codetype=CT_ROMAN7;                                //~v57eI~
                *pco++=0x1b;                                       //~v57eI~
                *pco++='(';                                        //~v57eI~
                *pco++='J'; //esc(J 8bit display                   //~v57eI~
                *pco++=0x0e;	//shift out                        //~v57eI~
            }                                                      //~v57eI~
            p1 &=0x7f;      //7bit display                         //~v57eI~
        }                                                          //~v57eI~
        else                                                       //~v57eI~
        {                                                          //~v57eI~
            if (codetype!=CT_ASCII)                                //~v57eI~
            {                                                      //~v57eI~
            	if (codetype==CT_ROMAN7)                           //~v57eI~
                	*pco++=0x0f;	//shift in,close 8bit mode     //~v57eI~
                codetype=CT_ASCII;                                 //~v57eI~
                *pco++=0x1b;                                       //~v57eI~
                *pco++='(';                                        //~v57eI~
                *pco++='B'; //7bit mode                            //~v57eI~
            }                                                      //~v57eI~
        }                                                          //~v57eI~
        *pco++=(unsigned char)p1;                                  //~v57eI~
  	}//loop                                                        //~v57eI~
    if (Poutlen)                                                   //~v57eI~
		*Poutlen=(int)((ULONG)pco-(ULONG)Pjis);                    //~v57eI~
	rc|=(codetype<<UDBCSCHK_RC_JISMODESHIFT);	//return jismode for cont line//~v57eI~
    return rc;                                                     //~v57eI~
}//ustrsjis2jis                                                    //~v57eR~
//*******************************************************          //~v39xI~
//*ushift2euc                                                      //~v39xI~
//* dbcs code conversion,shift jis to euc;regardless dbcs environment//~v39xR~
//* parm1 :sjis string                                             //~v39xI~
//* parm2 :optional input dbcstbl                                  //~v550I~
//* parm3 :sjis string len                                         //~v39xI~
//* parm4 :out area addr                                           //~v550I~
//* parm5 :optional dbcs id tbl                                    //~v550R~
//* parm6 :optional out len                                        //~v550I~
//* parm7 :option;conv hankaku katakana,keep tabid                 //~v550R~
//* return:output euc string len                                   //~v39xI~
//******************************************************           //~v39xI~
int ushift2euc(unsigned char *Psjis,unsigned char *Pdbcsi,int Plen,//~v550R~
				unsigned char *Peuc,unsigned char *Pdbcs,int *Poutlen,int Popt)//~v550I~
{                                                                  //~v39xI~
  	unsigned int p1,p2,jis,sjis;                                   //~v39xR~
  	int hkcsw;                                                     //~v39xR~
  	int hkconlysw;                                                 //~v550I~
  	int noclearsw;                                                 //~v549I~
  	int contlinesw;                                                //~v57dI~
  	int rc=0;                                                      //~v550I~
  	unsigned char *pci,*pco,*pcd,*pce;                             //~v39xR~
  	unsigned char *pcdi;                                           //~v550R~
//*********************************                                //~v39xI~
    hkcsw=(Popt & UDBCSCHK_EUCHKCONV);                             //~v39xI~
    hkconlysw=(Popt & UDBCSCHK_KANAONLY);                          //~v550I~
    noclearsw=(Popt & UDBCSCHK_NOCLEAR);                           //~v549I~
    contlinesw=(Popt & UDBCSCHK_CONTLINE);                         //~v57dI~
    pcdi=Pdbcsi;                                                   //~v550I~
  	for (pci=Psjis,pco=Peuc,pcd=Pdbcs,pce=pci+Plen;pci<pce;)       //~v39xR~
    {                                                              //~v39xI~
    	p1=*pci++;                                                 //~v39xI~
        pcdi++;                                                    //~v550R~
    	if (SJIS1(p1) & (pci<pce))                                 //~v39xR~
		{                                                          //~v39xI~
      		p2=*pci++;                                             //~v39xI~
    	    pcdi++;                                                //~v550R~
      		if (SJIS2(p2))                                         //~v39xI~
			{                                                      //~v39xI~
        		jis=usjis2jis((p1<<8)+p2);                         //~v39xR~
                if (jis)//success                                  //~v39xI~
                {                                                  //~v39xI~
                  if (hkconlysw)	                               //~v550I~
                  {                                                //~v550I~
                    *pco++=(UCHAR)p1;                              //~v550R~
                    *pco++=(UCHAR)p2;                              //~v550R~
                  }                                                //~v550I~
                  else                                             //~v550I~
                  {                                                //~v550I~
                    *pco++=(UCHAR)((jis>>8)+0x80);                 //~v39xR~
                    *pco++=(UCHAR)((jis&255)+0x80);                //~v39xR~
                  }                                                //~v550I~
                    if (pcd)                                       //~v39xR~
                    {                                              //~v39xR~
                        *pcd++=UDBCSCHK_DBCS1ST;                   //~v39xR~
                        *pcd++=UDBCSCHK_DBCS2ND;                   //~v39xR~
                    }                                              //~v39xR~
                    rc|=UDBCSCHK_RC_DBCSFOUND;                     //~v550I~
                    continue;                                      //~v39xI~
                }                                                  //~v39xI~
      		}                                                      //~v39xI~
            rc|=UDBCSCHK_RC_DBCSERR;                               //~v550I~
        }                                                          //~v39xI~
    	else                                                       //~v39xI~
        if (HANKATA(p1))                                           //~v39xR~
        {                                                          //~v39xR~
            if (hkcsw)	//conv to zenkaku                          //~v39xR~
            {                                                      //~v39xR~
                sjis=(unsigned int)uhan2zen(p1,&pci,pce,SJIS);     //~v40vR~
              if (hkconlysw)                                       //~v550I~
              {                                                    //~v550I~
                *pco++=(UCHAR)(sjis>>8);                           //~v550I~
                *pco++=(UCHAR)(sjis&255);                          //~v550I~
              }                                                    //~v550I~
              else                                                 //~v550I~
              {                                                    //~v550I~
                jis=usjis2jis(sjis);                               //~v39xR~
                *pco++=(UCHAR)((jis>>8)+0x80);                     //~v39xR~
                *pco++=(UCHAR)((jis&255)+0x80);                    //~v39xR~
              }                                                    //~v550I~
                if (pcd)                                           //~v39xR~
                {                                                  //~v39xR~
                    *pcd++=UDBCSCHK_DBCS1ST;                       //~v39xR~
                    *pcd++=UDBCSCHK_DBCS2ND;                       //~v39xR~
                }                                                  //~v39xR~
            }                                                      //~v39xR~
            else                                                   //~v39xR~
            {                                                      //~v39xR~
        		*pco++=SS2;                                        //~v39xI~
        		*pco++=(UCHAR)p1;                                  //~v39xI~
                if (pcd)                                           //~v39xR~
                {                                                  //~v39xR~
                    *pcd++=UDBCSCHK_HK1;                           //~v39xR~
                    *pcd++=UDBCSCHK_HK2;                           //~v39xR~
                }                                                  //~v39xR~
            }                                                      //~v39xR~
            rc|=UDBCSCHK_RC_HANKANAFOUND;                          //~v550I~
            continue;                                              //~v39xI~
        }//hankaku katakana                                        //~v39xR~
        else                                                       //~v57dI~
    	if (pci==pce)	//last byte                                //~v57dI~
	    	if (SJIS1(p1) && contlinesw)                           //~v57dI~
            {                                                      //~v57dI~
                rc|=UDBCSCHK_RC_DBCSSPLIT;                         //~v57dR~
                break;                                             //~v57dI~
            }                                                      //~v57dI~
        *pco++=(unsigned char)p1;                                  //~v39xI~
        if (pcd)                                                   //~v39xR~
        {                                                          //~v549I~
//          *pcd=UDBCSCHK_SBCS;                                    //~v549I~
//        	if (!noclearsw                                         //~v550R~
//        	||  *pcd==UDBCSCHK_DBCS1ST||*pcd==UDBCSCHK_DBCS2ND)    //~v550R~
//      		*pcd=UDBCSCHK_SBCS;                                //~v550R~
            if (noclearsw)                                         //~v550I~
            {                                                      //~v550I~
              if (Pdbcsi)                                          //~v550I~
				if (*(pcdi-1)==UDBCSCHK_DBCS1ST||*(pcdi-1)==UDBCSCHK_DBCS2ND)//~v550R~
		            *pcd=UDBCSCHK_SBCS;                            //~v550I~
                else                                               //~v550I~
		        	*pcd=*(pcdi-1);		//keep tabid               //~v550R~
              else                                                 //~v550I~
              	if (*pcd==UDBCSCHK_DBCS1ST||*pcd==UDBCSCHK_DBCS2ND)//~v550I~
		            *pcd=UDBCSCHK_SBCS;                            //~v550I~
            }                                                      //~v550I~
            else                                                   //~v550I~
		        *pcd=UDBCSCHK_SBCS;                                //~v550I~
        	pcd++;                                                 //~v550R~
        }                                                          //~v549I~
  	}//loop                                                        //~v39xI~
//  return (int)((ULONG)pco-(ULONG)Peuc);                          //~v550R~
    if (Poutlen)                                                   //~v550I~
		*Poutlen=(int)((ULONG)pco-(ULONG)Peuc);                    //~v550I~
    return rc;                                                     //~v550I~
}//ushift2euc                                                      //~v39xI~
//*******************************************************          //~v582I~
//*ushift2euccount                                                 //~v582I~
//* count output(EUC string) length                                //~v582I~
//* parm1 :sjis string                                             //~v582I~
//* parm2 :sjis string len                                         //~v582I~
//* parm3 :opt                                                     //~v582I~
//* return:output euc string len                                   //~v582I~
//******************************************************           //~v582I~
int ushift2euccount(unsigned char *Psjis,int Plen,int *Poutlen,int Popt)//~v582I~
{                                                                  //~v582I~
  	unsigned int p1,p2,jis;                                        //~v582R~
  	int contlinesw,pco;                                            //~v582R~
  	int rc=0;                                                      //~v582I~
  	unsigned char *pci,*pce;                                       //~v582R~
//*********************************                                //~v582I~
    contlinesw=(Popt & UDBCSCHK_CONTLINE);                         //~v582I~
  	for (pci=Psjis,pco=0,pce=pci+Plen;pci<pce;)                    //~v582R~
    {                                                              //~v582I~
    	p1=*pci++;                                                 //~v582I~
    	if (SJIS1(p1) & (pci<pce))                                 //~v582I~
		{                                                          //~v582I~
      		p2=*pci++;                                             //~v582I~
      		if (SJIS2(p2))                                         //~v582I~
			{                                                      //~v582I~
        		jis=usjis2jis((p1<<8)+p2);                         //~v582I~
                if (jis)//success                                  //~v582I~
                {                                                  //~v582I~
                    pco++;                                         //~v582I~
                    pco++;                                         //~v582I~
                    rc|=UDBCSCHK_RC_DBCSFOUND;                     //~v582I~
                    continue;                                      //~v582I~
                }                                                  //~v582I~
      		}                                                      //~v582I~
            rc|=UDBCSCHK_RC_DBCSERR;                               //~v582I~
        }                                                          //~v582I~
    	else                                                       //~v582I~
        if (HANKATA(p1))                                           //~v582I~
        {                                                          //~v582I~
            pco++;                                                 //~v582I~
            pco++;                                                 //~v582I~
            rc|=UDBCSCHK_RC_HANKANAFOUND;                          //~v582I~
            continue;                                              //~v582I~
        }//hankaku katakana                                        //~v582I~
        else                                                       //~v582I~
    	if (pci==pce)	//last byte                                //~v582I~
	    	if (SJIS1(p1) && contlinesw)                           //~v582I~
            {                                                      //~v582I~
                rc|=UDBCSCHK_RC_DBCSSPLIT;                         //~v582I~
                break;                                             //~v582I~
            }                                                      //~v582I~
        pco++;                                                     //~v582R~
  	}//loop                                                        //~v582I~
    if (Poutlen)                                                   //~v582I~
		*Poutlen=pco;                                              //~v582R~
    return rc;                                                     //~v582I~
}//ushift2euccount                                                 //~v582I~
//*******************************************************          //~v40vI~
//*usjischk                                                        //~v40vI~
//* sjis string dbcs chk by jis X 208                              //~v40vR~
//* parm1 :sjis string                                             //~v40vI~
//* parm2 :sjis string len                                         //~v40vI~
//* parm3 :optional output dbcs id tbl                             //~v550R~
//* parm4 :optional output hankaku-katakana ctr                    //~v550R~
//* parm5 :option;sbcs is >0x80 only,dbcs errchk,keep tabid on dbcstbl//~v550R~
//* return:rc                                                      //~v40vI~
//*        dbcsfound,hankana found,dbcs err,ascii err              //~v550I~
//******************************************************           //~v40vI~
int usjischk(unsigned char *Psjis,int Plen,                        //~v550R~
				unsigned char *Pdbcs,int *Phankanactr,int Popt)    //~v550R~
{                                                                  //~v40vI~
  	unsigned int p1,p2;                                            //~v39NR~
#ifdef UNX                                                         //~v39NI~
#else                                                              //~v39NI~
  	unsigned int sjis;                                             //~v39NI~
#endif                                                             //~v39NI~
  	int sbcsasciisw,errsw=0;                                       //~v40vI~
  	unsigned char *pci,*pcd,*pce;                                  //~v40vI~
  	int noclearsw;                                                 //~v512I~
  	int errdbcschk,dbcserr;                                        //~v513I~
    int hankanactr=0;                                              //~v550I~
//*********************************                                //~v40vI~
    sbcsasciisw=(Popt & UDBCSCHK_ASCIISBCS);//sbcs is valid when <0x80//~v40vI~
    noclearsw=(Popt & UDBCSCHK_NOCLEAR);                           //~v512I~
    errdbcschk=(Popt & UDBCSCHK_ERRDBCSCHK);                       //~v513I~
  	for (pci=Psjis,pcd=Pdbcs,pce=pci+Plen;pci<pce;)                //~v40vI~
    {                                                              //~v40vI~
    	p1=*pci++;                                                 //~v40vI~
        dbcserr=0;                                                 //~v513I~
    	if (SJIS1(p1))                                             //~v40vI~
		{                                                          //~v40vI~
        	dbcserr=1;                                             //~v513I~
			if (pci<pce)                                           //~v40vI~
      			p2=*pci;                                           //~v40vR~
            else                                                   //~v40vI~
            	p2=0;                                              //~v40vI~
      		if (SJIS2(p2))                                         //~v40vI~
			{                                                      //~v40vI~
#ifdef UNX                                                         //~v39NI~
                if (usjischkx208(p1,p2))//success                  //~v39NR~
#else                                                              //~v39NI~
        		sjis=(p1<<8)+p2;                                   //~v40vI~
                if (SJISX208(sjis))//success                       //~v40vR~
#endif                                                             //~v39NI~
                {                                                  //~v40vI~
                  if (pcd)                                         //~v549I~
                  {                                                //~v549I~
                    *pcd++=UDBCSCHK_DBCS1ST;                       //~v40vI~
                    *pcd++=UDBCSCHK_DBCS2ND;                       //~v40vI~
                  }                                                //~v549I~
                    pci++;                                         //~v40vI~
                    errsw|=UDBCSCHK_RC_DBCSFOUND;                  //~v550I~
                    continue;                                      //~v40vI~
                }                                                  //~v40vI~
      		}                                                      //~v40vI~
            errsw|=UDBCSCHK_RC_DBCSERR;                            //~v550I~
        }                                                          //~v40vI~
        if (HANKATA(p2))                                           //~v550I~
        {                                                          //~v550I~
            errsw|=UDBCSCHK_RC_HANKANAFOUND;                       //~v550I~
            hankanactr++;                                          //~v550I~
        }                                                          //~v550I~
        if (sbcsasciisw && p1>=0x80)                               //~v40vI~
        {                                                          //~v40vI~
          if (pcd)                                                 //~v549I~
            *pcd++=UDBCSCHK_HKDBCSERR;                             //~v40vI~
//          errsw=1;                                               //~v550R~
            errsw|=UDBCSCHK_RC_ASCIIERR;                           //~v550I~
        }                                                          //~v40vI~
        else                                                       //~v40vI~
          if (pcd)                                                 //~v549I~
          {                                                        //~v549I~
        if (dbcserr && errdbcschk)                                 //~v513I~
            *pcd++=UDBCSCHK_HKDBCSERR;                             //~v513I~
        else                                                       //~v513I~
        {                                                          //~v549I~
//        if (!(noclearsw && *pcd==UDBCSCHK_TAB))	//keep prev value//~v549R~
          if (!noclearsw                                           //~v549I~
          ||  *pcd==UDBCSCHK_DBCS1ST||*pcd==UDBCSCHK_DBCS2ND)      //~v549I~
//          *pcd++=UDBCSCHK_SBCS;                                  //~v549R~
            *pcd=UDBCSCHK_SBCS;                                    //~v549I~
            pcd++;                                                 //~v549I~
        }                                                          //~v549I~
          }                                                        //~v549I~
  	}//loop                                                        //~v40vI~
    if (Phankanactr)                                               //~v550R~
	    *Phankanactr=hankanactr;                                   //~v550R~
	return errsw;                                                  //~v40vR~
}//usjischk                                                        //~v40vI~
//*******************************************************          //~v39xI~
//*ueuc2shift                                                      //~v39xI~
//* dbcs code conversion,jis to shift jis;regardless dbcs environment//~v39xI~
//* parm1 :euc string                                              //~v39xI~
//* parm2 :optional input dbcs id tbl                              //~v550I~
//* parm3 :sjis string len                                         //~v550R~
//* parm4 :optional out area addr                                  //~v550R~
//* parm5 :optional output dbcs id tbl                             //~v550R~
//* parm6 :optional output len                                     //~v550I~
//* parm7 :option to converst hankaku katakana to Euc zenkaku katakana//~v550R~
//*        (if 0 hankaku katakana is conversted to 0x8E+xx)        //~v39xI~
//* return:rc                                                      //~v550R~
//*        0x01:hankaku err,02:dbcs err,10:hankaku found,20:dbcs found//~v550R~
//******************************************************           //~v39xI~
int ueuc2shift(unsigned char *Peuc,unsigned char *Pdbcsi,int Plen, //~v550R~
				unsigned char *Psjis,unsigned char *Pdbcs,int *Poutlen,int Popt)//~v550R~
{                                                                  //~v39xI~
  	unsigned int p1,p2,sjis,jis;                                   //~v550R~
  	int hkcsw,errsw,olen=0,sbcsasciisw,hkerr;                      //~v39FR~
  	int noclearsw;                                                 //~v50YI~
  	unsigned char *pci,*pco,*pcd,*pce;                             //~v39xI~
  	unsigned char *pcdi;                                           //~v550R~
    int rc=0;                                                      //~v550I~
    int hkconlysw;  //kana conv only                               //~v550I~
  	int contlinesw;                                                //~v57dI~
//*********************************                                //~v39xI~
    hkcsw=(Popt & UDBCSCHK_EUCHKCONV);                             //~v39xI~
    hkconlysw=(Popt & UDBCSCHK_KANAONLY);                          //~v550I~
    hkerr=(Popt & UDBCSCHK_EUCHKERR);                              //~v39FI~
    sbcsasciisw=(Popt & UDBCSCHK_ASCIISBCS);//sbcs is valid when <0x80//~v39FR~
    noclearsw=(Popt & UDBCSCHK_NOCLEAR);                           //~v50YI~
    contlinesw=(Popt & UDBCSCHK_CONTLINE);                         //~v57dI~
    pcdi=Pdbcsi;                                                   //~v550I~
  	for (pci=Peuc,pco=Psjis,pcd=Pdbcs,pce=pci+Plen;pci<pce;)       //~v39xI~
    {                                                              //~v39xI~
    	errsw=1;	//ignore when continued                        //~v39DI~
    	p1=*pci++;                                                 //~v39xI~
        pcdi++;                                                    //~v550R~
    	if (ISEUC(p1) && pci<pce)                                  //~v39xR~
		{                                                          //~v39xI~
      		p2 = *pci++;                                           //~v39xI~
	        pcdi++;                                                //~v550R~
      		if (ISEUC(p2))                                         //~v39xI~
			{                                                      //~v39xI~
//            if (pco)  //conv req                                 //~v550R~
        		sjis=ujis2sjis(((p1-0x80)<<8)+(p2-0x80));          //~v39xR~
//            else      //chk req                                  //~v550R~
//  			sjis=(unsigned int)ujischkx208((int)(p1-0x80),(int)(p2-0x80));       	//JIS X208 chk,0:err//~v550R~
                if (sjis)                                          //~v39xI~
                {                                                  //~v39xI~
                    olen+=2;                                       //~v39DI~
                  if (hkconlysw)                                   //~v550I~
                  {                                                //~v550I~
                    	*pco++=(UCHAR)p1;                          //~v550R~
                    	*pco++=(UCHAR)p2;                          //~v550R~
                  }                                                //~v550I~
                  else                                             //~v550I~
                  {                                                //~v550I~
//              	if (pco)                                       //~v550R~
//                  {                                              //~v550R~
                    	*pco++=(UCHAR)(sjis>>8);                   //~v39DR~
                    	*pco++=(UCHAR)(sjis&255);                  //~v39DR~
//                  }                                              //~v550R~
                  }                                                //~v550I~
                    if (pcd)                                       //~v39xR~
                    {                                              //~v39xR~
                        *pcd++=UDBCSCHK_DBCS1ST;                   //~v39xR~
                        *pcd++=UDBCSCHK_DBCS2ND;                   //~v39xR~
                    }                                              //~v39xR~
                    rc|=UDBCSCHK_RC_DBCSFOUND;                     //~v550I~
                    continue;                                      //~v39xI~
                }                                                  //~v39xI~
                rc|=UDBCSCHK_RC_DBCSERR;                           //~v550I~
      		}                                                      //~v39xI~
            pci--;  //back to before 2nd byte                      //~v39DI~
            pcdi--;  //back to before 2nd byte                     //~v550R~
    	}                                                          //~v39xI~
    	else                                                       //~v39xI~
        if (p1==SS2 && !hkerr && pci<pce)                          //~v39FR~
        {                                                          //~v39xR~
            p2 = *pci++;                                           //~v39xR~
            pcdi++;                                                //~v550R~
            if (HANKATA(p2))                                       //~v39xR~
            {                                                      //~v39xR~
                if (hkcsw)	//conv to zenkaku                      //~v39xR~
                {                                                  //~v39xR~
                    sjis=(unsigned int)uhan2zen(p2,&pci,pce,EUC);  //~v40vR~
                    olen+=2;                                       //~v39DI~
                  if (hkconlysw)                                   //~v550I~
                  {                                                //~v550I~
                	jis=usjis2jis(sjis);                           //~v550I~
                	*pco++=(UCHAR)((jis>>8)+0x80);                 //~v550I~
                	*pco++=(UCHAR)((jis&255)+0x80);                //~v550I~
                  }                                                //~v550I~
                  else                                             //~v550I~
                  {                                                //~v550I~
//                  if (pco)                                       //~v550R~
//                  {                                              //~v550R~
                    	*pco++=(UCHAR)(sjis>>8);                   //~v39DR~
                    	*pco++=(UCHAR)(sjis & 255);                //~v39DR~
//                  }                                              //~v550R~
                  }                                                //~v550I~
                    if (pcd)                                       //~v39xR~
                    {                                              //~v39xR~
                        *pcd++=UDBCSCHK_DBCS1ST;                   //~v39xR~
                        *pcd++=UDBCSCHK_DBCS2ND;                   //~v39xR~
                    }                                              //~v39xR~
                }//conv to xenkaku                                 //~v39xR~
                else                                               //~v39xI~
                {                                                  //~v39DI~
//                    olen+=2;                                     //~v548R~
//                    if (pco)                                     //~v548R~
//                    {                                            //~v548R~
//                        *pco++=(UCHAR)p1;                        //~v548R~
//                        *pco++=(UCHAR)p2;                        //~v548R~
//                    }                                            //~v548R~
//                    if (pcd)                                     //~v548R~
//                    {                                            //~v548R~
//                        *pcd++=UDBCSCHK_HK1;                     //~v548R~
//                        *pcd++=UDBCSCHK_HK2;                     //~v548R~
//                    }                                            //~v548R~
                    olen+=1;                                       //~v548I~
//                  if (pco)                                       //~v550R~
                        *pco++=(UCHAR)p2;                          //~v548I~
                    if (pcd)                                       //~v548I~
                    {                                              //~v549I~
//         			  if (!(noclearsw && *pcd==UDBCSCHK_TAB))	//keep prev value//~v549R~
//                      if (!noclearsw                             //~v550R~
//                      ||  *pcd==UDBCSCHK_DBCS1ST||*pcd==UDBCSCHK_DBCS2ND)//~v550R~
                        *pcd++=UDBCSCHK_SBCS;                      //~v550R~
                    }                                              //~v549I~
                }                                                  //~v39DI~
                rc|=UDBCSCHK_RC_HANKANAFOUND;                      //~v550I~
                continue;                                          //~v39DI~
            }//hankaku katakana                                    //~v39xR~
            rc|=UDBCSCHK_RC_HANKANAERR;                            //~v550I~
            pci--;  //back to before 2nd byte                      //~v39DI~
            pcdi--;  //back to before 2nd byte                     //~v550R~
        }                                                          //~v39xR~
        else                                                       //~v39DI~
        {                                                          //~v57dI~
    		if (pci==pce)	//last byte                            //~v57dI~
	    		if (contlinesw)                                    //~v57dI~
                    if (ISEUC(p1)                                  //~v57dR~
                    || (p1==SS2 && !hkerr))                        //~v57dI~
                    {                                              //~v57dI~
                        rc|=UDBCSCHK_RC_DBCSSPLIT;                 //~v57dR~
                        break;                                     //~v57dI~
                    }                                              //~v57dI~
          if (!sbcsasciisw || (p1<0x80))      //sbcs is valid when <0x80//~v39FR~
        	errsw=0;		//sbcs                                 //~v39DI~
        }                                                          //~v57dI~
        olen++;                                                    //~v39DI~
//      if (pco)                                                   //~v550R~
        	*pco++=(unsigned char)p1;                              //~v39DR~
        if (pcd)                                                   //~v39xR~
        {                                                          //~v582I~
          if (errsw)	                                           //~v39DI~
            *pcd++=UDBCSCHK_HKDBCSERR;                             //~v39DI~
          else                                                     //~v39DI~
          {                                                        //~v549I~
//         if (!noclearsw)	//keep prev value                      //~v511R~
//         if (!(noclearsw && *pcd==UDBCSCHK_TAB))	//keep prev value//~v549R~
//         if (!noclearsw                                          //~v550R~
//         ||  *pcd==UDBCSCHK_DBCS1ST||*pcd==UDBCSCHK_DBCS2ND)     //~v550R~
//          *pcd++=UDBCSCHK_SBCS;                                  //~v549R~
            if (noclearsw)                                         //~v550R~
            {                                                      //~v550I~
              if (Pdbcsi)                                          //~v550I~
				if (*(pcdi-1)==UDBCSCHK_DBCS1ST||*(pcdi-1)==UDBCSCHK_DBCS2ND)//~v550R~
		            *pcd=UDBCSCHK_SBCS;                            //~v550I~
                else                                               //~v550I~
		        	*pcd=*(pcdi-1);		//keep tabid               //~v550R~
              else                                                 //~v550I~
              	if (*pcd==UDBCSCHK_DBCS1ST||*pcd==UDBCSCHK_DBCS2ND)//~v550I~
		            *pcd=UDBCSCHK_SBCS;                            //~v550I~
            }                                                      //~v550I~
            else                                                   //~v550I~
            *pcd=UDBCSCHK_SBCS;                                    //~v549I~
            pcd++;                                                 //~v550R~
          }                                                        //~v549I~
        }//pcd                                                     //~v582I~
  	}//loop                                                        //~v39xI~
//  return olen;                                                   //~v550R~
	if (Poutlen)                                                   //~v550I~
	    *Poutlen=olen;                                             //~v550R~
    return rc;                                                     //~v550I~
}//ueuc2shift                                                      //~v39xI~
//*******************************************************          //~v39DI~
//*ueucchk                                                         //~v39DI~
//* euc code chk                                                   //~v39DI~
//* parm1 :euc string                                              //~v39DI~
//* parm2 :euc string len                                          //~v550R~
//* parm3 :optional output dbcs id tbl                             //~v550R~
//* parm4 :hankaku kana ctr                                        //~v550R~
//* parm5 :option;hankana err,keep tabid,sbcs is valid when <x80 only//~v550R~
//* return:output sjis string len                                  //~v39DI~
//******************************************************           //~v39DI~
int ueucchk(unsigned char *Peuc,int Plen,                          //~v550R~
			unsigned char *Pdbcs,int *Phankanactr,int Popt)        //~v550R~
{                                                                  //~v39DI~
  	unsigned int p1,p2,sjis;                                       //~v550I~
  	int errsw,hankanactr=0,sbcsasciisw,hkerr;                      //~v550R~
  	int noclearsw;                                                 //~v550I~
  	unsigned char *pci,*pcd,*pce;                                  //~v550I~
    int rc=0;                                                      //~v550I~
//*********************************                                //~v550I~
    hkerr=(Popt & UDBCSCHK_EUCHKERR);  //set err when hankaku katakana//~v550I~
    sbcsasciisw=(Popt & UDBCSCHK_ASCIISBCS);//sbcs is valid when <0x80//~v550I~
    noclearsw=(Popt & UDBCSCHK_NOCLEAR);                           //~v550I~
  	for (pci=Peuc,pcd=Pdbcs,pce=pci+Plen;pci<pce;)                 //~v550I~
    {                                                              //~v550I~
    	errsw=1;	//ignore when continued                        //~v550I~
    	p1=*pci++;                                                 //~v550I~
    	if (ISEUC(p1) && pci<pce)                                  //~v550I~
		{                                                          //~v550I~
      		p2 = *pci++;                                           //~v550I~
      		if (ISEUC(p2))                                         //~v550I~
			{                                                      //~v550I~
    			sjis=(unsigned int)ujischkx208((int)(p1-0x80),(int)(p2-0x80));       	//JIS X208 chk,0:err//~v550I~
                if (sjis)                                          //~v550I~
                {                                                  //~v550I~
                    if (pcd)                                       //~v550I~
                    {                                              //~v550I~
                        *pcd++=UDBCSCHK_DBCS1ST;                   //~v550I~
                        *pcd++=UDBCSCHK_DBCS2ND;                   //~v550I~
                    }                                              //~v550I~
                    rc|=UDBCSCHK_RC_DBCSFOUND;                     //~v550I~
                    continue;                                      //~v550I~
                }                                                  //~v550I~
      		}                                                      //~v550I~
            rc|=UDBCSCHK_RC_DBCSERR;                               //~v550I~
            pci--;  //back to before 2nd byte                      //~v550I~
    	}                                                          //~v550I~
    	else                                                       //~v550I~
        if (p1==SS2 && !hkerr && pci<pce)                          //~v550I~
        {                                                          //~v550I~
            p2 = *pci++;                                           //~v550I~
            if (HANKATA(p2))                                       //~v550I~
            {                                                      //~v550I~
                hankanactr++;                                      //~v550I~
                if (pcd)                                           //~v550I~
                    *pcd++=UDBCSCHK_SBCS;                          //~v550R~
                rc|=UDBCSCHK_RC_HANKANAFOUND;                      //~v550I~
                continue;                                          //~v550I~
            }//hankaku katakana                                    //~v550I~
            rc|=UDBCSCHK_RC_HANKANAERR;                            //~v550I~
            pci--;  //back to before 2nd byte                      //~v550I~
        }                                                          //~v550I~
        else                                                       //~v550I~
          	if (!sbcsasciisw || (p1<0x80))      //sbcs is valid when <0x80//~v550I~
        		errsw=0;		//sbcs                             //~v550I~
        if (pcd)                                                   //~v550I~
        {                                                          //~v550I~
          	if (errsw)                                             //~v550I~
            	*pcd=UDBCSCHK_HKDBCSERR;                           //~v550I~
          	else                                                   //~v550I~
            	if (noclearsw)                                     //~v550I~
                {                                                  //~v550I~
              		if (*pcd==UDBCSCHK_DBCS1ST||*pcd==UDBCSCHK_DBCS2ND)//~v550I~
		            	*pcd=UDBCSCHK_SBCS;                        //~v550I~
                }                                                  //~v550I~
            	else                                               //~v550I~
            		*pcd=UDBCSCHK_SBCS;                            //~v550I~
            pcd++;                                                 //~v550R~
    	}                                                          //~v550I~
  	}//loop                                                        //~v550I~
	if (Phankanactr)                                               //~v550I~
	    *Phankanactr=hankanactr;                                   //~v550I~
    return rc;                                                     //~v550I~
}//ueucchk                                                         //~v39DI~
//*******************************************************          //~v39xI~
//*uhan2zen                                                        //~v40vR~
//* hankaku to zenkaku                                             //~v39xI~
//* parm1 :katakana code; should be 0xa1--0xdf                     //~v39xR~
//* parm2 :addr of next byte addr                                  //~v39xI~
//* parm3 :end of string addr                                      //~v39xI~
//* parm4 :source code type	 SJIS/EUC                              //~v39xR~
//* return:xenkaku sjis code                                       //~v39xI~
//******************************************************           //~v39xI~
//int uhan2zen(unsigned char Pkatakana,unsigned char **Ppnext,unsigned char *Pend,int Pscode)//~v50bR~
int uhan2zen(unsigned int Pkatakana,unsigned char **Ppnext,unsigned char *Pend,int Pscode)//~v50bI~
{                                                                  //~v39xI~
//ka--to||ha--ho||u                                                //~v39xI~
#define ISNIGORI(A) ((A >= 0xb6 && A <= 0xc4) || (A >= 0xca && A <= 0xce) || (A == 0xb3))//~v39xI~
//ha--ho                                                           //~v39xI~
#define ISMARU(A)   (A >= 0xca && A <= 0xce)                       //~v39xI~
                                                                   //~v39xI~
static int Sdbcskatakanatbl[][2] = {                               //~v39xR~
    {0x81,0x42},{0x81,0x75},{0x81,0x76},{0x81,0x41},{0x81,0x45},{0x83,0x92},//~v39xR~
  // Bmaru      u l-kakko  vr-kakko   Aten       Echuten    wo//~v39xI~
    {0x83,0x40},{0x83,0x42},{0x83,0x44},{0x83,0x46},{0x83,0x48},{0x83,0x83},//~v39xI~
  // @ xa       B xi       D xu       F xe       H xo        xya//~v39xI~
    {0x83,0x85},{0x83,0x87},{0x83,0x62},{0x81,0x5b},{0x83,0x41},{0x83,0x43},//~v39xI~
  //  xyu       xyo      b xtu      [ bar      A a        C i//~v39xI~
    {0x83,0x45},{0x83,0x47},{0x83,0x49},{0x83,0x4a},{0x83,0x4c},{0x83,0x4e},//~v39xI~
  // E u        G e        I o        J ka       L ki       N ku//~v39xI~
    {0x83,0x50},{0x83,0x52},{0x83,0x54},{0x83,0x56},{0x83,0x58},{0x83,0x5a},//~v39xI~
  // P ke       R lo       T sa       V si       X su       Z se//~v39xI~
    {0x83,0x5c},{0x83,0x5e},{0x83,0x60},{0x83,0x63},{0x83,0x65},{0x83,0x67},//~v39xI~
  // \ so       ^ ta       ` ti       c tu       e te       g to//~v39xI~
    {0x83,0x69},{0x83,0x6a},{0x83,0x6b},{0x83,0x6c},{0x83,0x6d},{0x83,0x6e},//~v39xI~
  // i na       j ni       k nu       l ne       m no       n ha//~v39xI~
    {0x83,0x71},{0x83,0x74},{0x83,0x77},{0x83,0x7a},{0x83,0x7d},{0x83,0x7e},//~v39xI~
  // q hi       t fu       w he       z ho       } ma       ~ mi//~v39xI~
    {0x83,0x80},{0x83,0x81},{0x83,0x82},{0x83,0x84},{0x83,0x86},{0x83,0x88},//~v39xI~
  //  mu        me        mo        ya        yu        yo//~v39xI~
    {0x83,0x89},{0x83,0x8a},{0x83,0x8b},{0x83,0x8c},{0x83,0x8d},{0x83,0x8f},//~v39xI~
  //  ra        ri        ru        re        ro        wa//~v39xI~
    {0x83,0x93},{0x81,0x4a},{0x81,0x4b}                            //~v39xI~
  //  nn       J dakuten   K handakuten                        //~v39xI~
    };                                                             //~v39xI~
  	int p1,p2,maru = 0,nigori = 0;                                 //~v39xR~
    unsigned char *pnext;                                          //~v39xI~
//*********************************                                //~v39xI~
	pnext=*Ppnext;                                                 //~v39xI~
  	if (Pscode==SJIS)	//source code is sjis                      //~v39xR~
	{                                                              //~v39xI~
    	if (pnext<Pend)                                            //~v39xR~
        {                                                          //~v39xI~
            p2=*pnext;                                             //~v39xR~
            if (p2==0xde && ISNIGORI(Pkatakana))    //allow dakuten//~v39xR~
            {                                                      //~v39xI~
            	nigori=1;                                          //~v39xR~
                pnext++;                                           //~v39xR~
            }                                                      //~v39xR~
            else                                                   //~v39xR~
            if (p2 == 0xdf && ISMARU(Pkatakana))                   //~v39xR~
            {                                                      //~v39xI~
            	maru=1;                                            //~v39xR~
                pnext++;                                           //~v39xR~
            }                                                      //~v39xR~
        }                                                          //~v39xI~
  	}                                                              //~v39xI~
  	else		//euc                                              //~v39xR~
	{                                                              //~v39xI~
    	if (pnext+1<Pend	//next is hankaku katakana             //~v39xR~
        &&  *pnext==SS2)                                           //~v39xI~
        {                                                          //~v39xI~
        	p2=*pnext;                                             //~v39xR~
            if (p2==0xde && ISNIGORI(Pkatakana))                   //~v39xR~
            {                                                      //~v39xI~
                nigori=1;                                          //~v39xR~
                pnext+=2;                                          //~v39xR~
            }                                                      //~v39xR~
            else                                                   //~v39xR~
            if (p2 == 0xdf && ISMARU(Pkatakana))                   //~v39xR~
            {                                                      //~v39xI~
                maru=1;                                            //~v39xR~
                pnext+=2;                                          //~v39xI~
            }                                                      //~v39xR~
        }//next is katakana                                        //~v39xI~
  	}                                                              //~v39xI~
    p1 = Sdbcskatakanatbl[Pkatakana - 0xa1][0];                    //~v39xR~
    p2 = Sdbcskatakanatbl[Pkatakana - 0xa1][1];                    //~v39xR~
	if (nigori)                                                    //~v39xI~
	{                                                              //~v39xI~
    	if ((p2 >= 0x4a && p2 <= 0x67) || (p2 >= 0x6e && p2 <= 0x7a))//ka-to,ha-ho//~v39xR~
      		p2++;                       //ga-do,ba-bo              //~v39xR~
    	else                                                       //~v39xI~
		if (p1 == 0x83 && p2 == 0x45)	//u                        //~v39xR~
      		p2 = 0x94;                  //vu                       //~v39xR~
  	}                                                              //~v39xI~
  	else                                                           //~v39xI~
	if (maru && p2 >= 0x6e && p2 <= 0x7a)//ha-ho                   //~v39xR~
    	p2 += 2;                         //pa-po                   //~v39xR~
    *Ppnext=pnext;                                                 //~v39xI~
    return (p1<<8)+p2;                                             //~v39xI~
}//uhan2zen                                                        //~v39xI~
#ifdef UNX                                                         //~v39PI~
//*****************************************************************//~v39PI~
//*return 1 if tty else 0(/dev/ttyp_)                              //~v39PI~
//*****************************************************************//~v39PI~
int udbcschktty(void)                                              //~v39PI~
{                                                                  //~v39PI~
	char *pc;                                                      //~v39PI~
    int termid;                                                    //~v582I~
//***************************                                      //~v39PI~
	pc=ttyname(0);                                                 //~v39PI~
    if (!pc)                                                       //~v39PI~
    	return 0;                                                  //~v39PI~
    if (strstr(pc,"ttyp"))                                         //~v39PI~
    	return 0;                                                  //~v39PI~
    if (strstr(pc,"pts"))	//under X                              //~v582I~
    {                                                              //~v582I~
    	termid=ukbdl_gettermid() & TERM_SIMID;                     //~v582I~
        if (termid!=TERM_XTERMSIM)	//kterm or gterm(tl6 gterm dose not support DBCS but)//~v582I~
    		return 0;                                              //~v582I~
    }                                                              //~v582I~
    return 1;                                                      //~v39PI~
}//udbcschktty(void)                                               //~v39PI~
#endif                                                             //~v39PI~
//*******************************************************          //~v56xI~
//*dbcs tbl output                                                 //~v56xI~
//*******************************************************          //~v56xI~
int usetdbcstbl(int Popt,UCHAR *Ppdata,UCHAR *Ppdbcs,int Plen)     //~v56xR~
{                                                                  //~v56xI~
    int ii,rc=0;                                                   //~v56xR~
//***************                                                  //~v56xI~
    switch(Popt & USDT_CODE_TYPE)                                  //~v56xI~
    {                                                              //~v56xI~
    case USDT_CODE_SJISX208:                                       //~v56xI~
    	usjischk(Ppdata,Plen,Ppdbcs,0,0);                          //~v56xI~
    	break;                                                     //~v56xI~
    case USDT_CODE_EUC:                                            //~v56xI~
    	ueucchk(Ppdata,Plen,Ppdbcs,0,0);                           //~v56xR~
    	break;                                                     //~v56xI~
    case USDT_CODE_SJIS:                                           //~v56xI~
        for (ii=0;ii<Plen;ii++,Ppdata++,Ppdbcs++)                  //~v56xR~
        {                                                          //~v56xR~
            if (SJIS1(*Ppdata))	//1st byte range chk only          //~v56xR~
            {                                                      //~v56xR~
                *Ppdbcs++=UDBCSCHK_DBCS1ST;                        //~v56xR~
                if (ii<(Plen-1))                                   //~v56xI~
                	*Ppdbcs  =UDBCSCHK_DBCS2ND;                    //~v56xR~
                Ppdata++;                                          //~v56xR~
                ii++;                                              //~v56xR~
            }                                                      //~v56xR~
            else                                                   //~v56xR~
                *Ppdbcs=0;                                         //~v56xR~
        }                                                          //~v56xR~
    	break;                                                     //~v56xI~
    case USDT_CODE_SJIS2:                                          //~v56xI~
        for (ii=0;ii<Plen;ii++,Ppdata++,Ppdbcs++)                  //~v56xI~
        {                                                          //~v56xI~
            if (SJIS1(*Ppdata)	//1st byte range chk only          //~v56xI~
            && ii<(Plen-1)                                         //~v56xI~
            &&  SJIS2(*(Ppdata+1)))	//1st byte range chk only      //~v56xI~
            {                                                      //~v56xI~
                *Ppdbcs++=UDBCSCHK_DBCS1ST;                        //~v56xR~
                *Ppdbcs  =UDBCSCHK_DBCS2ND;                        //~v56xR~
                Ppdata++;                                          //~v56xI~
                ii++;                                              //~v56xI~
            }                                                      //~v56xI~
            else                                                   //~v56xI~
                *Ppdbcs=0;                                         //~v56xI~
        }                                                          //~v56xI~
    	break;                                                     //~v56xI~
    default:                                                       //~v56xI~
        rc=16;                                                     //~v56xI~
    }//code type                                                   //~v56xI~
    return rc;                                                     //~v56xR~
}//usetdbcstbl                                                     //~v56xR~
