//*CID://+v5i7R~:                             update#=   55;       //+v5i7R~
//**************************************************
//v5i7:060601 (LNX:FC5)utf8 not yet supported but set no EUC flag but set utf8 flag//+v5i7I~
//v57p:030118 (AIX)display all ms932 char                          //~v57pI~
//v57e:021228 sjis-->jis conv support                              //~v57eI~
//v57d:021228 sjis<->euc conv contline support                     //~v57dI~
//v56x:020805 (BUG)editfilename DBCS support                       //~v56xI~
//v560:020619 jis decoding support                                 //~v560I~
//v551:020413 kana hankaku-->zenkaku conv only(no dbcs conv)       //~v551I~
//v550:020413 string len change by euc<->sjis conv;consider for tabid on dbcstbl//~v550I~
//v513:011211 dbcs combination chk for AIX                         //~v513I~
//v511:011208 (BUG)no clear should be for tab only                 //~v511I~
//v50Y:011202 no clear option of ueucchk                           //~v50YI~
//v40v:010122 AIX support:sjis chk(allow up to 2nd level kanji)    //~v40vI~
//v39H:010120 LINUX support:drop undefined from jis range          //~v39HI~
//v39F:010114 LINUX support:under kon,set unprintable when sbcs>=0x80 for screen stability//~v39FI~
//v39D:010114 LINUX support:dbcs err chk to avoid screen destroy unker kon//~v39DI~
//v39C:010114 LINUX support:rtn to clear dbcs tbl for force english even if euc//~v39CI~
//v39z:010113 LINUX support:dbcschk by euc code                    //~v39zI~
//v39x:010113 LINUX support:euc conversion(from jconv by  Ken R. Lunde)//~v39xI~
//v39k:001202 LINUX support:ujis chk for unprintable char          //~v198I~
//v198:980926 parm may better be uusigned int for sjis to jis conv func//~v198I~
//v150:980119 need differrentiate codepage and dbcs tbl            //~v150I~
//            w95J codepdge 437 hase dbcs table and first half of DBCS on//~v150I~
//            rightmost column effect on first column of next line //~v150I~
//v051:961204:dbcs 2nd byte chk function                           //~v050I~
//v024:960831:udbcschk return dbcs env if parm is 0                //~v024I~
//**************************************************               //~v39kR~
#ifdef UDBCSCHK_GBLDEF                                             //~v39kR~
    int Gudbcschk_flag;                                            //~v39kR~
#else                                                              //~v39kR~
    extern int Gudbcschk_flag;                                     //~v39kR~
#endif                                                             //~v39kR~
#define UDBCSCHK_EUC       0x01                                    //~v39zR~
#define UDBCSCHK_MS932     0x02     //full ms932 display           //~v57pI~
#define UDBCSCHK_UTF8      0x04     //utf-8 for linux              //+v5i7I~
                                                                   //~v39xI~
#define SS2         0x8e					//hankaku katakana escape code//~v39xI~
#define HANKATA(A)  (A >=0xa1 && A <=0xdf)  //hankaku katakana range//~v39xI~
#define ISEUC(A)    (A >=0xa1 && A <=0xfe)                         //~v39xI~
#define SJIS1(A)    ((A >=0x81 && A <=0x9f) || (A >=0xe0 && A <=0xfc))//sjis 1st byte//~v39xI~
#define SJIS2(A)    (A >=0x40 && A <=0xfc)   //sjis 2nd byte       //~v39xI~
#define SJIS88START 0x9f                                           //~v39HI~
#define SJISX208(A) ((A >=0x8140 && A <=0x84fc) \
                   ||(A >=0x889f && A <=0x9ffc) \
                   ||(A >=0xe040 && A <=0xeafc))//JIS X 208        //~v39HI~
#define JIS1(A)     ((A >=0x21 && A <=0x28) || (A >=0x30 && A <=0x74)) //JIS X 208//~v39HI~
#define JIS2(A)     (A >=0x21 && A <=0x7e) //JIS X 208             //~v39HI~
#define UDBCSCHK_DBCS1ST     '1'     //on dbcs tbl                 //~v39xI~
#define UDBCSCHK_DBCS2ND     '2'     //on dbcs tbl                 //~v39xI~
#define UDBCSCHK_TAB         '\t'    //tab id on dbcs tbl          //~v511I~
#define UDBCSCHK_HK1         'h'     //hankaku katakana prefix of euc//~v39xI~
#define UDBCSCHK_HK2         'k'     //hankaku katakana code of euc//~v39xI~
#define UDBCSCHK_HKDBCSERR   'e'     //2 byte code conbination err //~v39DI~
#define UDBCSCHK_SBCS         0      //on dbcs tbl                 //~v39xI~
#define UDBCSCHK_EUCHKCONV     0x01	//hankaku katakana conv to zenkaku katakana//~v39xI~
#define UDBCSCHK_ASCIISBCS     0x02	//sbcs is valid when <0x80     //~v39FR~
#define UDBCSCHK_EUCHKERR      0x04	//set unprintable hankaku katakana//~v39FI~
#define UDBCSCHK_NOCLEAR       0x08	//no set sbcs id on dbcs tbl   //~v50YI~
#define UDBCSCHK_ERRDBCSCHK    0x10	//chk dbcs 2 byte combination  //~v513I~
#define UDBCSCHK_KANAONLY      0x20	//kana hankaku-->zenkaku conv only//~v551I~
#define UDBCSCHK_CONTLINE      0x40	//return rc if last byte is dbcs split//~v57dI~
#define UDBCSCHK_JISMODE      0x3f00 //jis mode for next of contline//~v57eR~
#define UDBCSCHK_RC_HANKANAERR   0x01	//hankaku katakana err     //~v550I~
#define UDBCSCHK_RC_DBCSERR      0x02	//err dbcs                 //~v550I~
#define UDBCSCHK_RC_ASCIIERR     0x04	//sbcs>=0x'80'             //~v550I~
#define UDBCSCHK_RC_HANKANAFOUND 0x10	//hankaku katakana found   //~v550I~
#define UDBCSCHK_RC_DBCSFOUND    0x20	//dbcs found               //~v550I~
#define UDBCSCHK_RC_DBCSSPLIT    0x40	//last byte is dbcs split  //~v57dI~
#define UDBCSCHK_RC_JISSPLIT   0xc000	//jis split residual len mask//~v57eR~
#define UDBCSCHK_RC_JISSPLITSHIFT  14 	//jis split residual len mask//~v57eR~
#define UDBCSCHK_RC_JISMODE    0x3f00 //continued jis mode         //~v57eR~
#define UDBCSCHK_RC_JISMODESHIFT    8 	//jis mode shift bit       //~v57dI~
#define CT_SBCS     0x10                                           //~v57eM~
#define CT_DBCS     0x20                                           //~v57eM~
#define CT_JIS78     (CT_DBCS+0)                                   //~v57eM~
#define CT_JIS83     (CT_DBCS+1)                                   //~v57eM~
#define CT_JIS90     (CT_DBCS+2)                                   //~v57eM~
#define CT_ASCII     (CT_SBCS+0)                                   //~v57eM~
#define CT_ROMAN     (CT_SBCS+1)   //jis x0201 roman(diff \ and ~ with ascii)//~v57eM~
#define CT_ROMAN7    (CT_SBCS+2)   //so,si change to katakana      //~v57eM~
#define CT_KATAKANA  (CT_SBCS+3)                                   //~v57eM~
//**************************************************               //~v198I~
int  udbcschk(unsigned char);
//**************************************************               //~v39CI~
void udbcschk_forceenglish(void);                                  //~v39CI~
//**************************************************               //~v150I~
int udbcschkcp(void);                                              //~v150I~
//*******************************************************          //~v150I~
int ugetcp(void);                                                  //~v150R~
//*******************************************************          //~v024I~
char *udbcsenv(void);                                              //~v024I~
//**************************************************               //~v024I~
UCHAR *udosquerydbcsenv(void);                                     //~v024I~
//*******************************************************          //~v051I~
int udbcschk2(char *Pbuff,int Poffs);                              //~v051I~
//*******************************************************          //~v051I~
unsigned int usjis2jis(unsigned int Psjis);                        //~v198R~
//*******************************************************          //~v39xI~
unsigned int ujis2sjis(unsigned int Pjis);                         //~v39xI~
//*******************************************************          //~v560I~
int ustrsjis2jis(int Popt,unsigned char *Psjisstr,int Plen,unsigned char *Pjis,int *Poutlen);//~v57eI~
//*******************************************************          //~v57eI~
int ustrjis2sjis(int Popt,UCHAR *Pjisstr,int Plen,UCHAR *Poutstr,int *Poutlen);//~v560I~
//*******************************************************          //~v39xI~
//int usjischk(unsigned char *Psjis,int Plen,unsigned char *Pdbcs,int Popt);//~v550R~
int usjischk(unsigned char *Psjis,int Plen,                        //~v550I~
				unsigned char *Pdbcs,int *Poutlen,int Popt);       //~v550I~
//*******************************************************          //~v40vI~
//int ushift2euc(unsigned char *Psjis,int Plen,unsigned char *Peuc,//~v550R~
//				unsigned char *Pdbcs,int Popt);                    //~v550R~
int ushift2euc(unsigned char *Psjis,unsigned char *Pdbcsi,int Plen,//~v550I~
				unsigned char *Peuc,unsigned char *Pdbcs,int *Poutlen,int Popt);//~v550R~
//*******************************************************          //~v57pI~
int ushift2euccount(unsigned char *Psjis,int Plen,int *Poutlen,int Popt);//~v57pI~
//*******************************************************          //~v39xI~
//int ueuc2shift(unsigned char *Peuc,int Plen,unsigned char *Psjis,//~v550R~
//				unsigned char *Pdbcs,int Popt);                    //~v550R~
int ueuc2shift(unsigned char *Peuc,unsigned char *Pdbcsi,int Plen, //~v550I~
				unsigned char *Psjis,unsigned char *Pdbcs,int *Poutlen,int Popt);//~v550R~
//*******************************************************          //~v39DI~
//int ueucchk(unsigned char *Peuc,int Plen,unsigned char *Pdbcs,int Popt);//~v550R~
int ueucchk(unsigned char *Peuc,int Plen,                          //~v550I~
			unsigned char *Pdbcs,int *Phankanactr,int Popt);       //~v550I~
//*******************************************************          //~v56xI~
int usetdbcstbl(int Popt,UCHAR *Ppdata,UCHAR *Ppdbcs,int Plen);    //~v56xR~
#define USDT_CODE_TYPE        0x0f                                 //~v56xI~
#define USDT_CODE_EUC         0x01                                 //~v56xI~
#define USDT_CODE_SJIS        0x02  //chk 1st byte only            //~v56xR~
#define USDT_CODE_SJIS2       0x03  //chk 2nd byte also            //~v56xI~
#define USDT_CODE_SJISX208    0x04                                 //~v56xR~
#ifdef UNX                                                         //~v56xI~
	#ifdef LNX                                                     //~v56xI~
		#define USDT_CODE_DEFAULT  USDT_CODE_EUC                   //~v56xR~
    #else                                                          //~v56xI~
		#define USDT_CODE_DEFAULT  USDT_CODE_SJIS2  //aix          //~v56xR~
    #endif                                                         //~v56xI~
#else                                                              //~v56xI~
	#define USDT_CODE_DEFAULT  USDT_CODE_SJIS2      //dos          //~v56xR~
#endif                                                             //~v56xI~
