//*CID://+v5fuR~:                             update#=  162;       //+v5fuR~
//*************************************************************
//*ufile1l.c                                                       //~v59nR~
//*************************************************************
//v5fu:050322 dispaly filetime when copy bypass by /d option       //+v5fuI~
//v5d9:040530 (FTP)skip upload for r2r to bypass not found msg if downloaded no entry//~v5d9I~
//v5c7:040330 (UNX)always ignore slink err(put on udirlist)        //~v5c7I~
//            (err occurs when edit rc=40:too many,rc=2:not found etc))//~v5c7I~
//v5c4:040330 (UNX:BUG)xdd fail if slink err(no entry on udirlist if slink err)//~v5c4I~
//v5b9:040202 (BUG) fullpath for ~/../ (home base)                 //~v5b9I~
//v5ai:040108 clear not used slink area clear on ufstat            //~v5aiI~
//v5af:040106 pass PUFTPHOST as parm not but nodename to chk TZ,SJIS option etc//~v5afI~
//v5a6:040104 (UNX,FTP)save slink uid,gid,uname,gname on dirlist for xe dirlist//~v5a6I~
//v5a4:040103 (BUG:AIX)dummy should be set to 0;filetime compare fail.//~v5a4I~
//v59y:040101 (UNX,FTP)use slink source uname/gname                //~v59yI~
//v59x:040101 (UNX,FTP)save slink timestamp and size for dirlist for xe//~v59xI~
//v59n:031109 ftp support:ufstat,udirlist                          //~v59nI~
//v578:021207 (UNX)udirlist performance tuning(stat call on the current dir)//~v578R~
//v575:021128 (UNX:BUG)wild select fail when dir is also SYSTEM attr;no set hidden/system bit//~v575I~
//v573:021009 (UNX)slink err msg bypass option(u#110)              //~v573I~
//v56y:020807 (BUG)add ufilewildcomp func;wildcomp DBCS support    //~v56yI~
//v56s:020712 (UNX)allow to udirlist select non-reguler file       //~v56sI~
//v56r:020712 (UNX)udirwalk slink err chk by S_ISLNK but no slink name,the skip process//~v56rI~
//v56q:020712 (UNX)slink loop chk(v56k) at udir walk not ufstat.(allow xe dir list display)//~v56qI~
//v56n:020711 (UNX:BUG) xff loop by FIFO file.it is slink,so not chked.//~v56nI~
//v56k:020711 (UNX)own logic for s-link loop detection for performance up//~v56kI~
//v56h:020711 (UNX)not found msg when lstat ok buf fstat err(rc=2) //~v56hI~
//v56g:020711 (UNX)ELOOP msg for lstat                             //~v56gI~
//v56c:020710 (UNX:BUG)attr select;dir is selected when Hidden/System bit on//~v56cI~
//v56a:020710 dirlist:skip readdir when "." is permission err to avoid too many errmsg//~v56aI~
//v55n:020503 (AIX)disket support                                  //~v55nI~
//v55f:020429 (UNX)mcd(cd for mdos disk) support                   //~v55fI~
//v533:020313 (BUG)FILE_SYSTEM bit cause unmatch for attrselect    //~v533I~
//v529:020302 api "stat" dose not return ENOTDIR even if path err; //~v529I~
//            check it by myself and issue path not found msg      //~v529I~
//v50N:010908 (BUG:UNX) if "~" is /, "~/" --> "//"                 //~v50NI~
//v50J:010625 dirlist option for socket/Pipe etc                   //~v50JI~
//v50G:010618 LNX:disket support(using mtools)                     //~v50GI~
//v50E:010616 return symbolic link attr/name for dir list          //~v50EI~
//v50x:010520 (BUG)udosfindfirst fail(not found) for dir but not wildcard//~v50xI~
//v50t:010414 localtime may return 0 when too large seconds        //~v3a2I~
//v3a2:010305 LINUX support:ignore fstat err when dirlist(err when slink)//~v3a2I~
//v39Y:010204 LINUX support:chnage v39T;no need to set FILE_DIRECTORY for wild card.//~v39YI~
//            To avoid file with wildcard char(*,?) is treated as wildcard operation//~v39YI~
//            Such the case "d" dlcmd on filename "*" delete all file.//~v39YI~
//v39V:010204 LINUX support:HIDDEN file attr for .xxx file(start by .)//~v39VI~
//v39T:010204 LINUX support:(BUG) filename containing wild card is treated as dir//~v39TI~
//v39g:001125 LINUX support:linux/ulibent.h is included from dirent.h//~v39gI~
//v397:001111 LINUX support:(BUG)dirname only on notfound errmsg when wildcard findfirst//~v397I~
//v390:001015 LINUX support(BUG:stat fail when wild card;so ufstat use findfirst)//~v390I~
//v387:001009 LINUX support(BUG:dosfindfirst issue apierr when no entry)//~v387I~
//v371:000928 LINUX support(stat may return EACCES for dir with no x-bit)//~v371I~
//            udosfindnext now return err(dont errexit)            //~v371I~
//v370:000928 LINUX support(permission err msg for opendir(EACCES))//~v370I~
//v364:000927 LINUX support(file system chk)                       //~v364I~
//v349:000926 LINUX support(ufstat now returns more info for copy info;fsid,timestamp etc)//~v349I~
//v341:000924 LINUX support(filename may contain "." or ".."; chk "./" or "../"//~v341I~
//v339:000917 LINUX support(home dir(~) support for ufullpath      //~v339I~
//v327 000820:LINUX support;move followings from ufilel.c
//            ufstat,ufullpath,ugetcwd,uchdir
//            udosfindfirst,udosfindnext
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/vfs.h>                                               //~v364I~
#include <errno.h>
#include <unistd.h>
#include <dirent.h>
//#include <linux/dirent.h>                                        //~v39gR~
//*******************************************************
#include <ulib.h>
#include <uque.h>                                                  //~v59nI~
#include <ufile.h>
#include <ufile1l.h>                                               //~0901R~
#include <ufile1l2.h>                                              //~v50GI~
#include <ufile5.h>                                                //~0901I~
#include <uerr.h>
#include <ufemsg.h>
#include <uparse.h>
#include <ustring.h>
#include <utrace.h>
#include <uunxsub.h>
#include <ualloc.h>                                                //~v50GI~
#ifdef FTPSUPP                                                     //~v59nI~
	#include <uftp.h>                                              //~v59nR~
	#include <ufile1f.h>                                           //~v59nR~
#endif                                                             //~v59nI~
//*******************************************************
#define SPECIAL_DIRID    '.'                                       //~v341I~
#define MAXHDIR 100
                                                                   //~v50GI~
typedef struct dirent *PDIRENT;

static int  Shdirindex=0;	//Shdir searced index                  //~v529R~
                                                                   //~v50GI~
static HDIR Shdirtbl[MAXHDIR];
static UINT Shdirtattr[MAXHDIR];
static int  Shdirpathlen[MAXHDIR];                                 //~0901I~
static PUDIRLIST Shdirpudl[MAXHDIR];	//current mdir line pos    //~v50GI~
static UCHAR Shdirpath[MAXHDIR][_MAX_PATH];                        //~0827I~
static  HDIR Shdirfirst;                                           //~0827R~
static char Snomsgff;   //no err msg version                       //~0827R~
//static char Swildname;  //filename may contain wildcard char     //~v39YR~
//*******************************************************
//void ufilegetftime(FTIME* Pft,FDATE *Pfd,time_t Ptime_t);        //+v5fuR~
int ufilelnxgetmembfstat(FILEFINDBUF3 *Ppffb3,PDIRENT Ppde,UCHAR *Ppath,int Ppathlen);//~v371R~
int  ufilelnxwildselect(UCHAR *Pfname,UCHAR *Pwildcard,int Pcasesw);//~v55nR~
int ufilelnxsavehdir(HDIR Phdir,ULONG Pattr,UCHAR *Ppath,int Ppathlen);//~0901R~
int ufilelnxsrchhdir(HDIR Phdir,ULONG *Ppattr,UCHAR **Pppath,int *Pppathlen);//~0901R~
int ufilelnxclosehdir(HDIR Phdir);
//*******************************************************
//*get file status(size,time stmp)
//*parm 1:file name
//*parm 2:output file info addr(optional)
//*******************************************************
unsigned int ufstat(char *Ppfile,FILEFINDBUF3 *Ppffb3)
{
    FILEFINDBUF3 ft;
    FILEFINDBUF3 *pft;
    struct stat statbuff;   //output file information              //~0827R~
    struct stat statbuff2;   //for slink file                      //~v50EI~
    int pathlen,rc;                                                //~0901R~
//  int dirsw=0;                                                   //~v56sR~
    int len;                                                       //~v50EI~
    char pathname[_MAX_PATH];                                      //~v529I~
    char *statfnm;                                                 //~v578I~
#ifdef FTPSUPP                                                     //~v5afI~
    PUFTPHOST puftph;                                              //~v5afI~
#endif                                                             //~v5afI~
//*********************************
#ifdef FTPSUPP                                                     //~v59nM~
  	if (uftpisremote(Ppfile,&puftph))	//ftp filename             //~v5afR~
		return uftpfstat(puftph,Ppfile,Ppffb3);                    //~v5afR~
#endif                                                             //~v59nM~
    if (!(pft=Ppffb3))  //optional parm
        pft=&ft;                        //use internal work
    memset(pft,0,sizeof(FILEFINDBUF3));                            //~v5aiI~
//if (!Swildname)  //filename may not contain wildcard char        //~v39YR~
    if (WILDCARD(Ppfile))                                          //~v390I~
    {                                                              //~v390I~
//  	if (rc=udosfindfirstnomsg(Ppfile,0,FILE_ALL,Ppffb3),rc)    //~v56sR~
    	if (rc=udosfindfirstnomsg(Ppfile,0,FILE_ALLSP,Ppffb3),rc)  //~v56sI~
        	return rc;                                             //~v390I~
// 		pft->attrFile|=FILE_DIRECTORY;	//force dir                //~v39YR~
        return 0;                                                  //~v390I~
    }                                                              //~v390I~
                                                                   //~v50GI~
  	if (MDOSDISK(Ppfile) && Gufile_opt & GFILEOPT_LNXMTOOL)	//use mtool//~v50GR~
		return ufstat_mdos(Ppfile,Ppffb3);                         //~v50GI~
    pathlen=PATHLEN(Ppfile);                                       //~v529I~
    if (pathlen<0)    //no / found(not fullpath name)              //~v529I~
        pathlen=0;                                                 //~v529I~
//*not wild card                                                   //~v390I~
//  if (stat(Ppfile,&statbuff))                                    //~v50ER~
//  if (lstat(Ppfile,&statbuff))                                   //~v578I~
    if (Gufile_opt & GFILEOPT_STATCD)                              //~v578I~
		statfnm=Ppfile+pathlen;                                    //~v578I~
    else                                                           //~v578I~
		statfnm=Ppfile;                                            //~v578I~
    if (lstat(statfnm,&statbuff))                                  //~v578I~
    {                                                              //~v390R~
        rc=errno;                                                  //~v390R~
        if (rc==EACCES)                                            //~v390R~
//          return ufilenopermission("stat",Ppfile,rc);            //~v50ER~
            return ufilenopermission("lstat",Ppfile,rc);           //~v50EI~
        if(rc!=ENOENT && rc!=ENOTDIR) //not found or no more file  //~v390R~
//          return ufileapierr("stat",Ppfile,rc);                  //~v50ER~
            return ufileapierr("lstat",Ppfile,rc);                 //~v50EI~
        if(rc==ENOENT)                                             //~v529I~
            if (pathlen)                                           //~v529I~
	        {                                                      //~v529I~
        	    memcpy(pathname,Ppfile,(UINT)pathlen);             //~v529R~
     	       	*(pathname+pathlen)=0;                             //~v529R~
    			if (lstat(pathname,&statbuff2))                    //~v529R~
            		if (errno==ENOENT)                             //~v529R~
                		rc=ENOTDIR;                                //~v529R~
	        }                                                      //~v529R~
        return rc;                                                 //~v390R~
    }                                                              //~v390R~
    *(pft->slink)=0;                                               //~v50ER~
    pft->srcattr=0;   	//slink source file attr                   //~v56nI~
    pft->uid=statbuff.st_uid;                                      //~v59yI~
    pft->gid=statbuff.st_gid;                                      //~v59yI~
    if (S_ISLNK(statbuff.st_mode))//symbolic link                  //~v50EI~
    {                                                              //~v50EI~
//      len=readlink(Ppfile,pft->slink,sizeof(pft->slink)-1);//return string len//~v578R~
        len=readlink(statfnm,pft->slink,sizeof(pft->slink)-1);//return string len//~v578I~
        if (len>0)	//success                                      //~v50EI~
        	*(pft->slink+len)=0;                                   //~v50ER~
//        if (!strcmp(pft->slink,".")  //                          //~v56qR~
//        ||  !strcmp(pft->slink,"..")  //                         //~v56qR~
//        ||  (*pft->slink==DIR_SEPC && strstr(Ppfile,pft->slink))) //slink loop(source path is upper level of target)//~v56qR~
//        {                                                        //~v56qR~
//            uerrmsg("S-Link loop;%s --> %s",0,                   //~v56qR~
//                        Ppfile,pft->slink);                      //~v56qR~
//            rc=ELOOP;                                            //~v56qR~
//            return rc;                                           //~v56qR~
//        }                                                        //~v56qR~
//      if (stat(Ppfile,&statbuff2)) 	//to chk directory         //~v578R~
        if (stat(statfnm,&statbuff2)) 	//to chk directory         //~v578I~
        {                                                          //~v50EI~
        	rc=errno;                                              //~v50EI~
        	if (rc==EACCES)                                        //~v50EI~
            	return ufilenopermission("stat",Ppfile,rc);        //~v50EI~
            if (rc==ELOOP)                                         //~v56gI~
            {                                                      //~v56kI~
            	ufileslinkloop("stat",Ppfile);                     //~v56gI~
//              return rc;                                         //~v56rR~
            }                                                      //~v56kI~
            else                                                   //~v56gI~
            if (rc==ENOENT)                                        //~v56hI~
            {                                                      //~v573I~
      		  if (!(Gufile_opt & GFILEOPT_NOSLINKERRMSG))          //~v573I~
                uerrmsg("Invalid S-Link ? %s link defined but not found",0,//~v56hI~
                            Ppfile);                               //~v56hI~
            }                                                      //~v573I~
            else                                                   //~v56hI~
        	if(rc!=ENOENT && rc!=ENOTDIR) //not found or no more file//~v50EI~
            	ufileapierr("stat",Ppfile,rc);                     //~v50ER~
//    	  if (!(Gufile_opt & GFILEOPT_IGNORESLINKERR))  //not ignore slinkerr//~v5c7R~
//          if (rc!=ELOOP)                                         //~v5c7R~
//          	return rc;                                         //~v5c7R~
            memset(&statbuff2,0,sizeof(statbuff2));                //~v50JR~
        }                                                          //~v50EI~
//      if (S_ISDIR(statbuff2.st_mode))	//directory                //~v56sR~
//      	dirsw=FILE_DIRECTORY;                                  //~v56sR~
//  	pft->srcattr=FILE_SETMODEATTR(statbuff2.st_mode,dirsw);    //permissyon etc//~v56sR~
    	pft->srcattr=FILE_SETMODEATTR(statbuff2.st_mode,0);    //permissyon etc//~v56sI~
    	pft->slinksize=statbuff2.st_size;                          //~v59xI~
	    pft->slinkmtime=statbuff2.st_mtime;	//modified             //~v59xI~
    	ufilegetftime(&pft->slinkftime,&pft->slinkfdate,statbuff2.st_mtime);//~v59xI~
    	pft->uid=statbuff2.st_uid;                                 //~v59yI~
    	pft->gid=statbuff2.st_gid;                                 //~v59yI~
        pft->slinkuid=statbuff2.st_uid;                            //~v5a6I~
        pft->slinkgid=statbuff2.st_gid;                            //~v5a6I~
    }                                                              //~v50EI~
//conv stat to findbuf3
//  pft->uid=statbuff.st_uid;                                      //~v59yR~
//  pft->gid=statbuff.st_gid;                                      //~v59yR~
    pft->fsid=statbuff.st_dev;	//file system id                   //~v349I~
    pft->atime=statbuff.st_atime;	//access                       //~v349I~
    pft->mtime=statbuff.st_mtime;	//modified                     //~v349I~
    pft->ctime=statbuff.st_ctime;	//correct                      //~v349I~
//  pft->attrFile=FILE_SETMODEATTR(statbuff.st_mode,0);    //permissyon etc//~v50ER~
//  pft->attrFile=FILE_SETMODEATTR(statbuff.st_mode,dirsw);    //permissyon etc//~v56sR~
    pft->attrFile=FILE_SETMODEATTR(statbuff.st_mode,0);    //permissyon etc//~v56sI~
    *pft->uname=0;                                                 //~v59nI~
    *pft->gname=0;                                                 //~v59nI~
//  ufilemode2attr(pft);                                           //~v39VR~

    ufilegetftime(&pft->ftimeLastWrite,&pft->fdateLastWrite,       //~0827R~
                    statbuff.st_mtime);                            //~0827R~
    pft->cbFile=statbuff.st_size;
//  pathlen=PATHLEN(Ppfile);                                       //~v529R~
//  if (pathlen<0)    //no / found(not fullpath name)              //~v529R~
//      pathlen=0;                                                 //~v529R~
    strncpy(pft->achName,Ppfile+pathlen,sizeof(pft->achName));
    ufilemode2attr(pft);    //after filename set to chk .xxx(hidden file)//~v39VI~
    return 0;                                                      //~0827R~
}//ufstat
//*******************************************************
//*file system compare                                             //~v364R~
//*p1:file 1 to compare                                            //~v364I~
//*p2:file 2 to compare (optional)                                 //~v364I~
//*ret:4:err,1:unmatch,0 match                                     //~v364I~
//*******************************************************
int ufilefscomp(char *Pfile1,char *Pfile2)                         //~v364R~
{
    int fsid1,fsid2;                                               //~v364R~
//*******************
    if ((fsid1=ufilegetfsid(Pfile1))==-1)                          //~v364R~
    	return 4;                                                  //~v364I~
    if ((fsid2=ufilegetfsid(Pfile2))==-1)                          //~v364I~
    	return 4;                                                  //~v364I~
    return (fsid1!=fsid2);	//1 when unmatch                       //~v364R~
}//ufilefscomp                                                     //~v364I~
//*******************************************************          //~v364I~
//*get file system id from stat buff                               //~v364I~
//*p1:filename                                                     //~v364I~
//*ret:fsid(dev_t),-1:err                                          //~v364I~
//*******************************************************          //~v364I~
int ufilegetfsid(char *Pfile)                                      //~v364I~
{                                                                  //~v364I~
    char fnm[_MAX_PATH];                                           //~v364I~
    struct stat statbuff;   //output file information              //~v364I~
    int pathlen;                                                   //~v364I~
//*******************                                              //~v364I~
	ustrncpyz(fnm,Pfile,_MAX_PATH);                                //~v364I~
    while(stat(fnm,&statbuff))                                     //~v364R~
    {                                                              //~v364I~
        if ((pathlen=PATHLEN(fnm))<=1)  //reached to root          //~v364I~
            return -1;       //no upper path                       //~v364I~
        *(fnm+pathlen-1)=0;     //up dir level                     //~v364I~
    }                                                              //~v364I~
    return (int)statbuff.st_dev;	//file system id               //~v364I~
}//ufilegetfsid                                                    //~v364I~
//*******************************************************          //~v364I~
//*conv time_t to file time fmt                                    //~v364I~
//*******************************************************          //~v364I~
void ufilegetftime(FTIME* Pft,FDATE *Pfd,time_t Ptime_t)           //~v364I~
{                                                                  //~v364I~
    struct tm *ptm; //yy,mm,dd,hh,mm,ss,...                        //~v364I~
//*******************                                              //~v364I~
    ptm=localtime(&Ptime_t);                                       //~0827R~
    if (!ptm)                                                      //~v50tR~
    {                                                              //~v50tR~
    Pft->twosecs=0;                                                //~v50tR~
    Pft->minutes=0;                                                //~v50tR~
    Pft->hours  =0;                                                //~v50tR~
    Pfd->day    =0;                                                //~v50tR~
    Pfd->month  =0;                                                //~v50tR~
    Pfd->year   =0;                                                //~v50tR~
    }                                                              //~v50tR~
    else                                                           //~v50tR~
    {                                                              //~v50tR~
    Pft->twosecs=ptm->tm_sec/2;     //by 2 seconds                 //~0827R~
    Pft->minutes=ptm->tm_min;
    Pft->hours  =ptm->tm_hour;
    Pfd->day    =ptm->tm_mday;
    Pfd->month  =ptm->tm_mon+1;
    Pfd->year   =ptm->tm_year-80;   //ajust from 1900(UNX)-->from 1980(DOS)//~0827R~
    };                                                             //~v50tR~
#ifdef AIX                                                         //~v5a4R~
    Pft->dummy  =0;                                                //~v5a4R~
    Pfd->dummy  =0;                                                //~v5a4R~
#endif                                                             //~v5a4R~
    return;
}//ufilegetftime

//*******************************************************
//*get file fullpath name
//*parm 1:output full pth mame
//*parm 2:input partial filename
//*parm 3:output buff len
//*return:output buff addr or NULL if err
//*******************************************************
char *ufullpath(char *Pfullpath,char *Pfilename,size_t Plen)
{
    char wk[_MAX_PATH],*pwk,*home;                                 //~v339R~
    int  rootsw;                                                   //~0827R~
    UINT len;                                                      //~v339R~
    char wkdropq[_MAX_PATH];    //drop quataition work             //~0827R~
    char *pc;                                                      //~0827R~
    int mdossw,rootpos=ROOTDIRPOS;                                 //~v50GR~
#ifdef FTPSUPP                                                     //~v5afI~
    PUFTPHOST puftph;                                              //~v5afI~
#endif                                                             //~v5afI~
//*********************************
//*drp quatation encloser
#ifdef FTPSUPP                                                     //~v59nI~
  	if (uftpisremote(Pfilename,&puftph))	//ftp filename         //~v5afR~
		return uftpfullpath(puftph,Pfullpath,Pfilename,Plen);      //~v5afR~
#endif                                                             //~v59nI~
    uparsefname(0,Pfilename,wkdropq,0,0);//no opd,no need delmpos,outlen
    pc=wkdropq;
    len=strlen(pc);
    mdossw=MDOSDISKOK(pc);                                         //~v50GI~
//*dir path
//    if (*pc=='~') //homedir                                      //~v5b9R~
//    {                                                            //~v5b9R~
//        if (!(home=getenv("HOME")))                              //~v5b9R~
//            return 0;                                            //~v5b9R~
//        strcpy(wk,home);                                         //~v5b9R~
//        if ((*home=='/' && !*(home+1))  //home is root           //~v5b9R~
//        &&  *(pc+1)=='/')               // parm is "~/"          //~v5b9R~
//            strcpy(wk+1,pc+2);                                   //~v5b9R~
//        else                                                     //~v5b9R~
//        strcat(wk,pc+1);                                         //~v5b9R~
//    }                                                            //~v5b9R~
//    else                                                         //~v5b9R~
    if (mdossw)                                                    //~v50GI~
    {                                                              //~v50GI~
    	rootpos=MDOSROOTDIRPOS;                                    //~v50GI~
        memset(wk,0,sizeof(wk));                                   //~v50GI~
	    strcpy(wk,pc);                                             //~v50GI~
        pc +=2;                                                    //~v50GI~
        len -=2;                                                   //~v50GI~
    	if (*pc!='/')                                              //~v50GI~
        {                                                          //~v50GI~
        	if (ugetcwd_mdos(wk)>1)                                //~v50GI~
            {                                                      //~v50GI~
   	        	uerrmsg("ufullpath:get current dir failed for MDOS",//~v50GI~
                	    "ufullpath:MDOS sfBNg[擾̎s,");//~v50GI~
	            return 0;                                          //~v50GI~
            }                                                      //~v50GI~
//process "../"                                                    //~v50GI~
            pwk=wk;                                                //~v50GI~
            while ((len>=2 && *pc==SPECIAL_DIRID && *(pc+1)==SPECIAL_DIRID)//~v50GI~
                && (len==2 || *(pc+2)==DIR_SEPC)) //.. or ../      //~v50GI~
            {                                                      //~v50GI~
                pc+=2;                                             //~v50GI~
                len-=2;                                            //~v50GI~
                if (len)                                           //~v50GI~
                {                                                  //~v50GI~
                    pc++;                                          //~v50GI~
                    len--;                                         //~v50GI~
                }                                                  //~v50GI~
                pwk=wk+PATHLEN(wk)-1;                              //~v50GI~
                memset(pwk+1,0,strlen(pwk+1));                     //~v50GI~
                if (pwk!=wk)    //not yet reached to root          //~v50GI~
                    *pwk=0;    //drop parent dir                   //~v50GI~
            }//loop process parent                                 //~v50GI~
//*                                                                //~v50GI~
            if (len)//filename on input                            //~v50GI~
            {                                                      //~v50GI~
                rootsw=(strlen(wk)==3);                            //~v50GI~
                if ((len && *pc==SPECIAL_DIRID)                    //~v50GI~
                &&  (len==1 || *(pc+1)==DIR_SEPC)) //. or ./       //~v50GI~
                {                                                  //~v50GI~
                    pc++;                                          //~v50GI~
                    len--;                                         //~v50GI~
                    if (len)                                       //~v50GI~
                    {                                              //~v50GI~
                        pc++;                                      //~v50GI~
                        len--;                                     //~v50GI~
                    }                                              //~v50GI~
                    if (len)                                       //~v50GI~
                    {                                              //~v50GI~
                        pwk=wk+strlen(wk);                         //~v50GI~
                        if (!rootsw)    //curr is not to root      //~v50GI~
                            *pwk++='/';                            //~v50GI~
                        memcpy(pwk,pc,len);                        //~v50GI~
                    }                                              //~v50GI~
                }//.                                               //~v50GI~
                else    //not special .                            //~v50GI~
                {                                                  //~v50GI~
                    pwk+=strlen(pwk);                              //~v50GI~
                    if (!rootsw)    //curr is not root             //~v50GI~
                        *pwk++='/';     //add intermediate         //~v50GI~
                    memcpy(pwk,pc,len);                            //~v50GI~
                }                                                  //~v50GI~
            }//not all space                                       //~v50GI~
        }//not from root                                           //~v50GI~
    }                                                              //~v50GI~
    else                                                           //~v50GI~
    if ((*pc)=='/')                //from root                     //~v50GR~
        strcpy(wk,pc);                                             //~0901R~
    else                        //from cur dir                     //~0827R~
    {                                                              //~0827R~
        memset(wk,0,sizeof(wk));                                   //~0827R~
        if (*pc=='~' //homedir                                     //~v5b9I~
        &&  (*(pc+1)=='/' || *(pc+1)==0)) // ~ or ~/               //~v5b9R~
        {                                                          //~v5b9I~
            if (!(home=getenv("HOME")))                            //~v5b9I~
                return 0;                                          //~v5b9I~
            strcpy(wk,home);                                       //~v5b9I~
            pc++;                                                  //~v5b9I~
            len--;                                                 //~v5b9I~
            if (len)               // parm is "~/"                 //~v5b9I~
                pc++,len--;                                        //~v5b9I~
        }                                                          //~v5b9I~
        else                                                       //~v5b9I~
        if (!ugetcwd(wk))                                          //~v50GI~
        {                                                          //~0827R~
            uerrmsg("ufullpath:get current dir for %s failed,rc=%d",//~v50GR~
                    "ufullpath:%s ̌sfBNg[擾̎s,rc=%d",//~v50GR~
                    Pfilename,errno);                              //~0827R~
            return 0;
        }                                                          //~0827R~
//process "../"
        pwk=wk;
        while ((len>=2 && *pc==SPECIAL_DIRID && *(pc+1)==SPECIAL_DIRID)//~v341R~
            && (len==2 || *(pc+2)==DIR_SEPC)) //.. or ../          //~v341I~
        {                                                          //~0827R~
            pc+=2;                                                 //~v341I~
            len-=2;                                                //~v341I~
        	if (len)                                               //~v341R~
            {                                                      //~v341I~
            	pc++;                                              //~v341I~
                len--;                                             //~v341I~
            }                                                      //~v341I~
            pwk=wk+PATHLEN(wk)-1;                                  //~0827R~
            memset(pwk+1,0,strlen(pwk+1));
            if (pwk!=wk)    //not yet reached to root              //~0827R~
                *pwk=0;    //drop parent dir
        }//loop process parent                                     //~0827R~
//*
        if (len)//filename on input                                //~0827R~
        {                                                          //~0827R~
            rootsw=(strlen(wk)==1);                                //~0827R~
            if ((len && *pc==SPECIAL_DIRID)                        //~v341R~
            &&  (len==1 || *(pc+1)==DIR_SEPC)) //. or ./           //~v341R~
            {
                pc++;                                              //~v341I~
                len--;                                             //~v341I~
                if (len)                                           //~v341R~
                {                                                  //~v341I~
                    pc++;                                          //~v341I~
                    len--;                                         //~v341I~
                }                                                  //~v341I~
                if (len)
                {
                    pwk=wk+strlen(wk);                             //~0827R~
                    if (!rootsw)    //curr is not to root          //~0827R~
                        *pwk++='/';                                //~0827R~
                    memcpy(pwk,pc,len);                            //~0827R~
                }                                                  //~0827R~
            }//.                                                   //~0827R~
            else    //not special .                                //~0827R~
            {                                                      //~0827R~
                pwk+=strlen(pwk);                                  //~0827R~
                if (!rootsw)    //curr is not root                 //~0827R~
                    *pwk++='/';     //add intermediate             //~0827R~
                memcpy(pwk,pc,len);                                //~0827R~
            }                                                      //~0827R~
        }//not all space                                           //~0827R~
    }//not root dir specified                                      //~0827R~
    if ((len=strlen(wk))>rootpos+1 		//not root                 //~v50GR~
    &&  PATHLEN(wk)==len)   //last is '/'                          //~0827R~
    {
        *(wk+len-1)=0;                                             //~0827R~
        len--;
    }
    if (Plen<=len)
        return 0;                                                  //~0827R~
    strcpy(Pfullpath,wk);                                          //~0827R~
    return Pfullpath;                                              //~0827R~
}//ufullpath
//*******************************************************
//*get file path name length(length containing last '/' from top)
//*parm 1:filename
//*return:length, <0 if err
//*******************************************************
int upathlen(char *Pfilename)
{
    char *pc;                                                      //~0827R~
//*********************************
    if (pc=ustrrchr2(Pfilename,'/'),!pc)
        return -16;     //avoid -1                                 //~0827R~
    return (int)((ULONG)pc-(ULONG)Pfilename)+1;                    //~0827R~
}//upathlen
//*******************************************************
//*get current dir fullpath
//*parm  :output buff
//*return:ptr to buff
//*******************************************************
char *ugetcwd(unsigned char *Pbuff)
{
//*********************************
    return getcwd(Pbuff,_MAX_PATH);
}//ugetcwd
//*******************************************************
//*change current directory
//*parm 1:path name
//*return:0:ok else err
//*******************************************************
//int uchdir(unsigned char *Ppath)                                 //~v578R~
int uchdir(int Popt,unsigned char *Ppath)                          //~v578I~
{
    int rc;                                                        //~0827R~
#ifdef FTPSUPP                                                     //~v5afI~
    PUFTPHOST puftph;                                              //~v5afI~
#endif                                                             //~v5afI~
//*********************************
#ifdef FTPSUPP                                                     //~v59nI~
  	if (uftpisremote(Ppath,&puftph))	//ftp filename             //~v5afR~
 		return uftpchdir(puftph,Popt,Ppath);                       //~v5afR~
#endif                                                             //~v59nI~
  if (MDOSDISKOK(Ppath))                                           //~v55fR~
  {                                                                //~v55nI~
    rc=uchdir_mdos(Ppath);                                         //~v55fR~
#ifdef AIX                                                         //~v55nI~
    if (rc==ENOSYS)                                                //~v55nI~
        return rc;                                                 //~v55nI~
#endif                                                             //~v55nI~
  }                                                                //~v55nI~
  else                                                             //~v55fR~
    rc=chdir(Ppath);
    if (rc)                                                        //~0827R~
    {
        rc=errno;                                                  //~0827R~
      if (!(Popt & UCHD_NOMSG))		//not no errmsg option         //~v578I~
        uerrmsg("Set current directory failed for %s(rc=%d)",      //~0827R~
                "sfBNg[ݒ̎s(%s,rc=%d)",
                Ppath,rc);
    }                                                              //~0827R~
    return rc;                                                     //~0827R~
}//uchdir
//**********************************************************************
// udosfindfirstnomsg(no notfound err msg)
// parm1  :file name
// parm2  :HDIR ptr,if no contention,specify 0.for dos specify always 0
// parm3  :search file attribute
// parm4  :found file info
// return :r.c
//**********************************************************************
unsigned udosfindfirstnomsg(char *Ppfname,HDIR *Pphdir,unsigned int Pattr,
                        FILEFINDBUF3 *Ppfstat3)                    //~0827R~
{
    unsigned rc;                                                   //~0827R~
//*********************************
    Snomsgff=1;                                                    //~0827R~
    rc=udosfindfirst(Ppfname,Pphdir,Pattr,Ppfstat3);               //~0827R~
    Snomsgff=0;                                                    //~0827R~
    return rc;
}//udosfindfirstnomsg
//**********************************************************************
// find first
// parm1  :file name
//         opendir fail if wild card for UNX                       //~0901I~
// parm2  :HDIR ptr,if no contention,specify 0.for dos specify always 0
// parm3  :search file attribute
// parm4  :found file info
// return :r.c
//**********************************************************************
unsigned udosfindfirst(char *Ppfname,HDIR *Pphdir,unsigned int Pattr,
                        FILEFINDBUF3 *Ppfstat3)                    //~0827R~
{
    HDIR   *phdir;
    unsigned rc;                                                   //~0827R~
    int pathlen,wildsw,mdossw;                                     //~v55nR~
    UCHAR dirnm[_MAX_PATH],*pdirnm;                                //~0901I~
    PUDIRLIST  pudl;                                               //~v50GR~
#ifdef FTPSUPP                                                     //~v59nI~
    int ftpopt;                                                    //~v59nR~
    PUFTPHOST puftph;                                              //~v5afI~
#endif                                                             //~v59nI~
//*********************************
#ifdef FTPSUPP                                                     //~v59nI~
  	if (uftpisremote(Ppfname,&puftph))	//ftp filename             //~v5afR~
    {                                                              //~v59nI~
        ftpopt=UFTPFF_NOMSG*(Snomsgff!=0);	//no delete ok msg sw  //~v59nI~
    	return uftpfindfirst(puftph,ftpopt,Ppfname,Pphdir,Pattr,Ppfstat3);//~v5afR~
    }                                                              //~v59nI~
#endif                                                             //~v59nI~
  	mdossw=MDOSDISKOK(Ppfname);                                    //~v55nI~
    if (!(phdir=Pphdir))
        phdir=&Shdirfirst;
    if (pathlen=PATHLEN(Ppfname),pathlen<0)                        //~v50JM~
    	pathlen=0;                                                 //~v50JM~
//if (MDOSDISK(Ppfname) && Gufile_opt & GFILEOPT_LNXMTOOL)	//use mtool//~v55nR~
//{                                                                //~v55nR~
//  Pattr|=FILE_MDOSDISK;                                          //~v55nR~
//  rc=udosfindfirst_mdos(Ppfname,&pudl,Pattr);                    //~v55nR~
//  *phdir=(HDIR)(ULONG)pudl;                                      //~v55nR~
//  if (!WILDCARD(Ppfname+pathlen))  //opendir fail if wild card   //~v55nR~
//      pathlen=strlen(Ppfname);                                   //~v55nR~
//}                                                                //~v55nR~
//else                                                             //~v55nR~
//{                                                                //~v55nR~
    if (WILDCARD(Ppfname+pathlen))  //opendir fail if wild card    //~0901R~
    {                                                              //~0901I~
    	wildsw=1;                                                  //~0901I~
    	if (!pathlen)    //no / found(not fullpath name)           //~0901R~
            strcpy(dirnm,"./"); //curr dir                         //~0901I~
        else                                                       //~0901I~
        {                                                          //~0901I~
        	memcpy(dirnm,Ppfname,(UINT)pathlen);                   //~0901R~
//with last "/",permision err when no x-bit                        //~v371R~
//without last "/",permision err when stat of member (".")         //~v371I~
        	*(dirnm+pathlen)=0;                                    //~v371I~
        }                                                          //~0901I~
        pdirnm=dirnm;                                              //~0901I~
    }                                                              //~0901I~
    else                                                           //~0901I~
    {                                                              //~0901I~
    	wildsw=0;                                                  //~0901I~
        pathlen=strlen(Ppfname);                                   //~v50xI~
        pdirnm=Ppfname;                                            //~0901I~
    }                                                              //~0901I~
  if (mdossw)                                                      //~v55nR~
  {                                                                //~v55nI~
    Pattr|=FILE_MDOSDISK;                                          //~v55nI~
    rc=uopendir_mdos(pdirnm,&pudl);                                //~v55nR~
    *phdir=(HDIR)(ULONG)pudl;                                      //~v55nI~
  }                                                                //~v55nI~
  else                                                             //~v55nI~
  {                                                                //~v55nI~
    *phdir=(ULONG)opendir(pdirnm);                                 //~0901R~
  }//mdos or not                                                   //~v50GI~
    if (!*phdir)
    {                                                              //~0901I~
	  if (!(Pattr & FILE_MDOSDISK))                                //~v50GI~
      {                                                            //~v50GI~
        rc=errno;
        if (rc==ENOTDIR && !wildsw)    //may be file(not wildcard case)//~0901R~
            if (!ufstat(Ppfname,Ppfstat3))  //exist as file        //~0901R~
//              if (ufilelnxattrselect(Ppfstat3->attrFile,Pattr))   //attr match//~v56nR~
                if (ufilelnxattrselect(Ppfstat3->attrFile,Ppfstat3->srcattr,Pattr))   //attr match//~v56nR~
                    return 0;                                      //~0901R~
        if (rc==EACCES)                                            //~v371M~
        	return ufilenopermission("opendir",pdirnm,rc);         //~v371I~
      }//not disket                                                //~v50GI~
    }                                                              //~0901I~
    else
    {
        if (rc=ufilelnxsavehdir(*phdir,Pattr,Ppfname,pathlen),rc)  //~0901R~
            return rc;
        rc=udosfindnext(*phdir,Ppfstat3);
        if (rc==4)                                                 //~v387R~
//          rc=ERROR_FILE_NOT_FOUND;                               //~v5d9R~
            rc=ERROR_NO_MORE_FILES;                                //~v5d9I~
        if (!rc)
            if (!Pphdir)     //handle return not required for find next
                if (rc=ufilelnxclosehdir(*phdir),rc)//free handle
                    return rc;
    }
    if(rc)                                                         //~0827R~
    {                                                              //~0827R~
        if(rc==ERROR_NO_MORE_FILES                                 //~0827R~
        || rc==ERROR_FILE_NOT_FOUND                                //~0827R~
        || rc==ERROR_PATH_NOT_FOUND)                               //~0827R~
        {
          if (!Snomsgff)                                           //~0827R~
          {                                                        //~v5d9I~
//          ufilenotfound(pdirnm,(int)rc);                         //~v397R~
           if(rc==ERROR_NO_MORE_FILES)                             //~v5d9R~
            rc=ufileerrnoentry(Ppfname,ERROR_FILE_NOT_FOUND);      //~v5d9I~
           else                                                    //~v5d9I~
            ufilenotfound(Ppfname,(int)rc);                        //~v397I~
          }//msgsw                                                 //~v5d9I~
        }                                                          //~0827R~
        else                                                       //~0827R~
        	if (rc!=EACCES)	//not yet msg                          //~v371I~
            	ufileapierr("udosfindfirst",Ppfname,(int)rc);      //~v371R~
    }                                                              //~0827R~
    return rc;                                                     //~0827R~
}//udosfindfirst
//**********************************************************************
// find next
// parm1  :HDIR specified at findfirst. for dos specify always 0
// parm2  :found file info
// return :r.c  0:found 4:no more file else errno                  //~v371R~
//**********************************************************************
unsigned udosfindnext(HDIR Phdir,FILEFINDBUF3 *Ppfstat3)
{
    HDIR   hdir;
    PDIRENT pde;
    ULONG attr;
    UCHAR *path;                                                   //~0827I~
    int    rc,pathlen;                                             //~0901R~
    int rc2;                                                       //~v56nR~
    int mdossw;                                                    //~v55nR~
//*********************************
#ifdef FTPSUPP                                                     //~v59nI~
    if (((ULONG)Phdir & FTP_HDIRMASK)==FTP_HDIRID)	//special hdir for FTP//~v59nI~
 		return uftpfindnext(Phdir,Ppfstat3);                       //~v59nR~
#endif                                                             //~v59nI~
    if (!(hdir=Phdir))
        hdir=Shdirfirst;
    if (rc=ufilelnxsrchhdir(hdir,&attr,&path,&pathlen),rc)         //~0901R~
        return rc;
//if (attr & FILE_MDOSDISK)                                        //~v55nR~
//  	rc=udosfindnext_mdos(&Shdirpudl[Shdirindex],path,pathlen,attr,Ppfstat3);//~v55nR~
    mdossw=(attr & FILE_MDOSDISK);                                 //~v55nI~
//else                                                             //~v55nR~
//{                                                                //~v55nR~
    for (;;)
    {
        errno=0;
      if (mdossw)                                                  //~v55nI~
      {                                                            //~v55nI~
    	rc=ureaddir_mdos(&Shdirpudl[Shdirindex],path,pathlen,attr,Ppfstat3);//~v55nI~
        if (rc)                                                    //~v55nI~
            break;                                                 //~v55nI~
        if (WILDCARD(path+pathlen))	//wildcard                     //~v55nI~
	        if (!ufilelnxwildselect(Ppfstat3->achName,path+pathlen,mdossw))//~v55nR~
            	continue;		//wildcard unmatch                 //~v55nI~
      }                                                            //~v55nI~
      else                                                         //~v55nI~
      {                                                            //~v55nI~
        pde=readdir((DIR*)hdir);
        if (!pde)
        {
            rc=errno;                                              //~0827R~
            if (!rc)    //no err                                   //~0827R~
                rc=ERROR_NO_MORE_FILES;                            //~0827R~
            break;
        }
//printf("read dir name=%s\n",pde->d_name);                        //~0901R~
        if (WILDCARD(pde->d_name))	//wildcard file/dirname        //~v39YI~
            continue;               //ignore it,it cause segfault by double closedir//~v39YI~
        rc=0;
        if (WILDCARD(path+pathlen))	//wildcard                     //~0901R~
	        if (!ufilelnxwildselect(pde->d_name,path+pathlen,mdossw))//~v55nR~
            	continue;		//wildcard unmatch                 //~0901I~
//      if (rc=ufilelnxgetmembfstat(Ppfstat3,pde,path,pathlen),rc) //~v3a2R~
//      	break;                                                 //~v3a2R~
//      if (ufilelnxgetmembfstat(Ppfstat3,pde,path,pathlen))       //~v56aR~
//          continue;                                              //~v56aR~
        rc2=ufilelnxgetmembfstat(Ppfstat3,pde,path,pathlen);       //~v56aI~
        if (rc2)                                                   //~v56aI~
        {                                                          //~v56aI~
        	if (rc2==EACCES)                                       //~v56rR~
            	if (!strcmp(pde->d_name,"."))	//cur dir	permission err//~v56aI~
                {                                                  //~v56aI~
		        	rc=rc2;		//EACCES                           //~v56aI~
                	break;	//stop readdir                         //~v56aI~
                }                                                  //~v56aI~
            continue;                                              //~v56aI~
        }                                                          //~v56aI~
      }//mdos                                                      //~v55nI~
//      if (ufilelnxattrselect(Ppfstat3->attrFile,attr))    //attr match//~v56nR~
        if (ufilelnxattrselect(Ppfstat3->attrFile,Ppfstat3->srcattr,attr))    //attr match//~v56nI~
            break;
    }
//}//msdos or else                                                 //~v55nR~

    if (rc==ERROR_NO_MORE_FILES)                                   //~0827R~
    {                                                              //~0827R~
        ufilelnxclosehdir(hdir);
        return 4;  //no more file                                  //~0827R~
    }                                                              //~0827R~
    else                                                           //~0827R~
        if (rc)                                                    //~0827R~
        {                                                          //~v371I~
	        ufilelnxclosehdir(hdir);                               //~v371I~
//          uerrexit("udosfindnext failed,rc=%d",                  //~v371R~
            if (rc!=EACCES) //not yet msg                          //~v371I~
            	uerrmsg("udosfindnext failed,rc=%d",               //~v371I~
                        "udosfindnext ̎s,^[R[h=%d",   //~0827R~
                        rc);                                       //~0827R~
            return rc;                                             //~v371I~
        }                                                          //~v371I~
    return 0;                                                      //~0827R~
}//udosfindnext
//*******************************************************          //~0901I~
//*get dir member stat                                             //~0901I~
//*parm 1:filename                                                 //~v55nR~
//*parm 2:wildcard patern                                          //~v55nR~
//*parm 3:mdos sw                                                  //~v55nR~
//*return:1:filename matched to wildcard,0:unmatch                 //~0901I~
//*******************************************************          //~0901I~
int ufilelnxwildselect(UCHAR *Pfname,UCHAR *Pwildcard,int Pmdossw) //~v55nR~
{                                                                  //~0901I~
//  UCHAR targetname[_MAX_PATH];                                   //~v56yR~
    int wcopt;                                                     //~v56yI~
//*************                                                    //~0901I~
//  ufileeditname(Pfname,Pwildcard,targetname);                    //~v56yR~
    wcopt=UFWC_DOS_DEFAULT | UFWC_CASE_DEFAULT | UFWC_0BYTE;       //~v56yI~
    if (Pmdossw)                                                   //~v55nI~
    	wcopt&=~UFWC_CASE;  //case insensitive                     //~v56yI~
//  	return !stricmp(targetname,Pfname);                        //~v56yR~
//  return !strcmp(targetname,Pfname);                             //~v56yR~
    return ufilewildcomp(wcopt,Pfname,Pwildcard,0)==0;             //~v56yR~
}//ufilelnxwildselect                                              //~0901I~
//*******************************************************          //~0901I~
//*select member by attr specified                                 //~0901I~
//*parm 1:file attr                                                //~0901I~
//*parm 2:file attr of slink src                                   //~v56nI~
//*parm 3:parm attr(select req)                                    //~v56nR~
//*return:1:ok,0:ng                                                //~0901I~
//*******************************************************          //~0901I~
//int ufilelnxattrselect(ULONG Pfattr,ULONG Ppattr)                //~v56nR~
int ufilelnxattrselect(ULONG Pfattr,ULONG Pfattrsrc,ULONG Ppattr)  //~v56nI~
{                                                                  //~0901I~
//  unsigned int wattrf,wattrp,modef,modep;                        //~v56cR~
    unsigned int modef,modep;                                      //~v56cI~
//*********************************                                //~0901I~
  if (!(Pfattr & FILE_MDOSDISK))                                   //~v56nR~
  {                                                                //~v56nI~
    modef=FILE_GETMODE(Pfattr);                                    //~v50JI~
    modep=FILE_GETMODE(Ppattr);                                    //~v50JI~
   if (!(Ppattr & FILE_SPECIAL))  //select reguler file only       //~v56sR~
   {                                                               //~v56sI~
    if (Pfattr & FILE_SPECIAL)  //select reguler file only         //~v56sR~
    	return 0;                                                  //~v56sI~
   }                                                               //~v56sI~
   else                                                            //~v56sI~
   {                                                               //~v56sI~
    if (S_ISLNK(modef))//symbolic link                             //~v56nR~
    	modef=FILE_GETMODE(Pfattrsrc);                             //~v56nI~
//  if (S_ISCHR(modef) && !S_ISCHR(modep))                         //~v56sR~
    if (S_ISCHR(modep))       //req char only                      //~v56sR~
      if (!S_ISCHR(modef))                                         //~v56sI~
    	return 0;                                                  //~v50JI~
//  if (S_ISBLK(modef) && !S_ISBLK(modep))                         //~v56sR~
    if (S_ISBLK(modep))       //req blk only                       //~v56sI~
	  if (!S_ISBLK(modef))                                         //~v56sI~
    	return 0;                                                  //~v50JI~
//  if (S_ISFIFO(modef) && !S_ISFIFO(modep))                       //~v56sR~
    if (S_ISFIFO(modep))      //req fifo only                      //~v56sI~
      if (!S_ISFIFO(modef))                                        //~v56sI~
    	return 0;                                                  //~v50JI~
//  if (S_ISSOCK(modef) && !S_ISSOCK(modep))                       //~v56sR~
    if (S_ISSOCK(modep))                                           //~v56sI~
      if (!S_ISSOCK(modef))                                        //~v56sI~
    	return 0;                                                  //~v50JI~
   }//non reg                                                      //~v56sI~
  }//not MDOS DISK                                                 //~v56nI~
//  wattrf=(Pfattr & (FILE_HIDDEN|FILE_SYSTEM|FILE_DIRECTORY));    //~v56cR~
//  wattrp=(Ppattr & (FILE_HIDDEN|FILE_SYSTEM|FILE_DIRECTORY));    //~v56cR~
//  if (!wattrf     //select A,R attr file unconditionaly          //~v56cR~
//  ||  (wattrp & wattrf)==wattrf)  //file bit included in parm attr//~v533R~
//  ||  (wattrp & wattrf))  //file bit included in parm attr       //~v56cR~
//      return 1;                                                  //~v56cR~
//  return 0;                                                      //~v56cI~
    if (Pfattr & FILE_DIRECTORY)	//file is dir                  //~v56cI~
    	if (!(Ppattr & FILE_DIRECTORY))		//dir not specified    //~v56cI~
       		return 0;					//no select                //~v56cI~
    if (Pfattr & FILE_HIDDEN)	//file is dir                      //~v56cR~
    	if (!(Ppattr & FILE_HIDDEN))		//dir not specified    //~v56cI~
       		return 0;					//no select                //~v56cI~
    if (Pfattr & FILE_SYSTEM)	//file is dir                      //~v56cI~
    	if (!(Ppattr & FILE_SYSTEM))		//dir not specified    //~v56cI~
       		return 0;					//no select                //~v56cI~
    return 1;                                                      //~v56cI~
}//ufilelnxattrselect                                              //~0901I~
//*******************************************************
//*get dir member stat                                             //~0901R~
//*parm 1:output ffb3                                              //~0901R~
//*parm 2:result of readdir                                        //~0901R~
//*parm 3:dir name                                                 //~0901I~
//*parm 4:pathlen(0 when not wildcard)                             //~0901I~
//*return:none
//*******************************************************
int ufilelnxgetmembfstat(FILEFINDBUF3 *Ppffb3,PDIRENT Ppde,UCHAR *Ppath,int Ppathlen)//~v371R~
{
    UCHAR pathfnm[_MAX_PATH*2];                                    //~0827R~
    int rc;                                                        //~v39TI~
//*************
    memcpy(pathfnm,Ppath,Ppathlen);                                //~0901R~
    if (Ppathlen >0 && *(pathfnm+Ppathlen-1)!='/')                 //~0901R~
        *(pathfnm+Ppathlen++)='/';                                 //~0901R~
    strcpy(pathfnm+Ppathlen,Ppde->d_name);                         //~0901R~
//  return ufstat(pathfnm,Ppffb3);                                 //~v39TR~
//	Swildname=1;  //filename may contain wildcard char             //~v39YR~
    rc=ufstat(pathfnm,Ppffb3);                                     //~v39TI~
//	Swildname=0;  //filename may not contain wildcard char         //~v39YR~
    return rc;                                                     //~v39TI~
}//ufilelnxgetmembfstat                                            //~0901R~
//*******************************************************
//*save hdir and requested attrib for findnext
//*parm 1:HDIR
//*parm 2:attr
//*parm 3:fullpath name(may contain wildcard)                      //~0901I~
//*parm 4:pathlen(0 for not wildcard)                              //~0901I~
//*return:0 or ERROR_TOO_MANY_OPEN_FILES
//*******************************************************
int ufilelnxsavehdir(HDIR Phdir,ULONG Pattr,UCHAR *Ppath,int Ppathlen)//~0901R~
{
    int ii;
//*************
    for (ii=0;ii<MAXHDIR;ii++)                                     //~0827R~
        if (Phdir==Shdirtbl[ii] || !Shdirtbl[ii])                  //~0827R~
        {
            Shdirtbl[ii]=Phdir;                                    //~0827R~
            Shdirtattr[ii]=Pattr;                                  //~0827R~
            Shdirpathlen[ii]=Ppathlen;                             //~0901R~
            strncpy(Shdirpath[ii],Ppath,_MAX_PATH);                //~0827I~
	        Shdirpudl[ii]=(PUDIRLIST)Phdir;	//top addr for mdir    //~v50GI~
			Shdirindex=ii;	//search index                         //~v50GI~
            break;
        }                                                          //~0827R~
    if (ii==MAXHDIR)                                               //~0827R~
    {
        uerrmsg("Pending FindFirst HANDLE overflow(max %d)",       //~0827R~
                "d|蒆 FindFirst ̐(ő %d)",        //~0827R~
                    MAXHDIR);                                      //~0827R~
        return ERROR_TOO_MANY_OPEN_FILES;                          //~0827R~
    }                                                              //~0827R~
    return 0;                                                      //~0827R~
}//ufilelnxsavehdir                                                //~0827R~
//*******************************************************
//*search hdir table when findnext
//*parm 1:HDIR
//*parm 2:attr
//*return:0 or 4(not found)
//*******************************************************
int ufilelnxsrchhdir(HDIR Phdir,ULONG *Ppattr,UCHAR **Pppath,int *Pppathlen)//~0901R~
{
    int ii;
//*************
	Shdirindex=0;	//mdos current pos                             //~v50GI~
    if (!Phdir)                                                    //~0827R~
        return ERROR_INVALID_HANDLE;                               //~0827R~
    for (ii=0;ii<MAXHDIR;ii++)                                     //~0827R~
        if (Phdir==Shdirtbl[ii])                                   //~0827R~
            break;
    if (ii==MAXHDIR)                                               //~0827R~
        return ERROR_INVALID_HANDLE;                               //~0827R~
    *Ppattr=Shdirtattr[ii];                                        //~0827R~
    *Pppath=Shdirpath[ii];                                         //~0827I~
    *Pppathlen=Shdirpathlen[ii];                                   //~0901R~
	Shdirindex=ii;	//mdos current pos                             //~v50GI~
    return 0;                                                      //~0827R~
}//ufilelnxsrchhdir
//*******************************************************
//*clear hdir table when findclose
//*parm 1:HDIR
//*return:0 or 4(not found)
//*******************************************************
int ufilelnxclosehdir(HDIR Phdir)
{
    int ii,rc;
//*************
    if (!Phdir)                                                    //~0827R~
        return ERROR_INVALID_HANDLE;                               //~0827R~
    for (ii=0;ii<MAXHDIR;ii++)                                     //~v50GM~
        if (Phdir==Shdirtbl[ii])                                   //~v50GM~
            break;                                                 //~v50GM~
  if (ii!=MAXHDIR && (Shdirtattr[ii] & FILE_MDOSDISK))             //~v50GR~
  {                                                                //~v50GI~
  	ufree((void*)Phdir);		//free mdir list,top word is ptr   //~v50GR~
  }                                                                //~v50GI~
  else                                                             //~v50GI~
  {                                                                //~v50GI~
    rc=closedir((DIR *)Phdir);        //relese  handle             //~0827R~
    if (rc)                                                        //~0827R~
    {                                                              //~0827R~
        rc=errno;                                                  //~0827R~
        uerrexit("FindClose failed,rc=%d",                         //~0827R~
                    "FindClose ̎s,^[R[h=%d",          //~0827R~
                    rc);                                           //~0827R~
    }                                                              //~0827R~
  }                                                                //~v50GI~
    if (ii==MAXHDIR)                                               //~0827R~
        return ERROR_INVALID_HANDLE;                               //~0827R~
    Shdirtattr[ii]=0;                                              //~0827R~
    Shdirtbl[ii]=0;
    Shdirpath[ii][0]=0;                                            //~0827R~
    return 0;                                                      //~0827R~
}//ufilelnxclosehdir
//*******************************************************          //~0827I~
//*get attr from mode                                              //~0827I~
//*parm :findbuff3                                                 //~0827R~
//*return:rc                                                       //~0827R~
//*******************************************************          //~0827I~
ULONG ufilemode2attr(FILEFINDBUF3 *Ppft)                           //~0827R~
{                                                                  //~0827I~
    ULONG attr=0;                                                  //~0827R~
    mode_t mode;                                                   //~0827R~
    mode_t modew;                                                  //~v56sI~
//  uid_t  uid;                                                    //~v59nR~
//  gid_t  gid;                                                    //~v59nR~
//  char *pc;                                                      //~v578R~
//*************                                                    //~0827I~
    mode=FILE_GETMODE(Ppft->attrFile);                             //~0901R~
//  ugetugid(&uid,&gid);                                           //~v59nR~
//  if (S_ISLNK(mode))                                             //~v56sR~
//      attr=Ppft->attrFile & FILE_DIRECTORY;	//dir mask already set//~v56sR~
    if (S_ISLNK(mode))                                             //~v56sI~
    	modew=FILE_GETMODE(Ppft->srcattr);	//slink attr           //~v56sI~
    else                                                           //~v56sI~
    	modew=mode;                                                //~v56sI~
    if (S_ISDIR(modew))                                            //~v56sR~
        attr|=FILE_DIRECTORY;                                      //~0827I~
    if (S_ISCHR(modew) 	//char device                              //~v56sI~
    ||  S_ISBLK(modew)  //blk device                               //~v56sI~
    ||  S_ISFIFO(modew) //pipe                                     //~v56sI~
    ||  S_ISSOCK(modew)) //socket                                  //~v56sI~
        attr|=FILE_SPECIAL;                                        //~v56sI~
    if (!((mode & S_IWOTH) || (mode & S_IWGRP) || (mode & S_IWUSR))//~0827R~
    &&   ((mode & S_IROTH) || (mode & S_IRGRP) || (mode & S_IRUSR)))//~0827R~
        attr|=FILE_READONLY;                                       //~0827I~
//  if (!(mode & S_IRWXO)                                          //~v39VR~
//  &&   ((gid!=Ppft->gid && uid)||!(mode & S_IRWXG))              //~v39VR~
//  &&   ((uid!=Ppft->uid && uid)||!(mode & S_IRWXU)))             //~v39VR~
//      attr|=FILE_HIDDEN;                                         //~v39VI~
//    if (gid!=Ppft->gid)                                          //~v575R~
//    {                                                            //~v575R~
//        if (!(mode & S_IWOTH))//not root and no write for others //~v575R~
//            attr|=FILE_SYSTEM;                                   //~v575R~
//    }                                                            //~v575R~
//    else                                                         //~v575R~
//        if (uid!=Ppft->uid) //                                   //~v575R~
//            if (!(mode & S_IWGRP))                               //~v575R~
//                attr|=FILE_SYSTEM;                               //~v575R~
//    pc=Ppft->achName;                                            //~v575R~
//    if (*pc++=='.')                                              //~v575R~
//        if (*pc!=0 && *pc!='.') //not cur dir or parent dir      //~v575R~
//            attr|=FILE_HIDDEN;                                   //~v575R~
    Ppft->attrFile=FILE_SETMODEATTR(mode,attr);                    //~0901R~
    return attr;                                                   //~0827R~
}//ufilemode2attr                                                  //~0827I~
//*******************************************************          //~0827I~
//*conv file time to time_t                                        //~0827I~
//*******************************************************          //~0827I~
time_t ufilemktime(FDATE Pfd,FTIME Pft)                            //~0827R~
{                                                                  //~0827I~
    struct tm wktm; //yy,mm,dd,hh,mm,ss,...                        //~0827I~
//*******************                                              //~0827I~
    memset(&wktm,0,sizeof(wktm));                                  //~0901R~
    wktm.tm_sec   =Pft.twosecs*2;                                  //~0827R~
    wktm.tm_min   =Pft.minutes;                                    //~0827R~
    wktm.tm_hour  =Pft.hours;                                      //~0827R~
    wktm.tm_mday  =Pfd.day;                                        //~0827R~
    wktm.tm_mon   =Pfd.month-1;                                    //~0827R~
    wktm.tm_year  =Pfd.year+80;                                    //~0827R~
    return mktime(&wktm);                                          //~0827I~
}//ufilemktime                                                     //~0827I~
