//*CID://+v5fbR~:                             update#=    9;       //+v5fbR~
//******************************************************        //~5826I~
//*ufile2.h                                                     //~5826I~
//******************************************************        //~5826I~
//v5fb:050101 avoid duplicated ronly chk of del for ftp del performance//+v5fbI~
//v5am:040110 (FTP)del file in a dir at once for performance       //~v5amI~
//v59q:031124 (UNX)xdd protection for dir/file owned by root group user//~v59pI~
//v59e:031103 ftp support(4 byte udirlist attr for ! UNX)          //~v59eI~
//v56s:020712 (UNX)allow to udirlist select non-reguler file       //~v56sI~
//v55r:020525 (UNX)no fd option for xdd cmd                        //~v55rI~
//v55d:020428 (UNX:BUG)not found msg when diskfull for move(target is not created yet)//~v55dI~
//v520:011228 support move override                                //~v520I~
//v327 000820:LINUX support                                        //~v327I~
//v281:990911 xdd confirm each support                             //~v281I~
//v277:990813 rename:wildcard target support                       //~v277I~
//v011:960131:add xdd function(parm chk,call xdelete and issue msg)//~v011I~
//v010:960120:uxdelete,read only chk option,force del  read only option//~v010I~
//******************************************************        //~v010I~
typedef int (WILDAPPLYFUNC)(UCHAR *,PUDIRLIST,void*);           //~5916R~
//******************************************************        //~5826I~
//****************************************************************//~5909I~
int umkdir(UCHAR *Pdirname);                                    //~5909I~
#ifdef FTPSUPP                                                     //~v59pI~
	#ifndef UNX		//for unit see ufile2l.h                       //~v59pI~
		int umkdirmode(UCHAR *Pdirname,ULONG Pmode,ULONG *Pprmode);//~v59pI~
		int uattrxon(UCHAR *Pfname);                               //~v59pI~
		int uattrxchk(UCHAR *Pfname,int Popt);                     //~v59pI~
    #endif                                                         //~v59pI~
#endif                                                             //~v59pI~
                                                                //~5909I~
//****************************************************************//~5909I~
int urmdir(UCHAR *Pdirname);                                    //~5909I~
                                                                //~5909I~
//******************************************************************//~v011I~
char *uxddpchk(char *Ppgmver,int Pparmc,char *Pparm,            //~v011R~
                int *Pxdelopt,int *Pxddopt,int *Pposparmno);    //~v011R~
                                                                //~v011I~
//******************************************************************//~v011I~
int uxddsub(char *Pname,int Pxdelopt,int Pxddopt,char *Pfullpath);//~v011R~
#define UXDDNOCONF  0x01        //not no confirm for xddopt     //~v011I~
#define UXDDENGLISH 0x02        //force english                    //~v281I~
                                                                //~v011I~
//****************************************************************//~5B12I~
int uxdelete(UCHAR *Pfile,unsigned Pattrmask,int Popt,          //~v010I~
            int *Ppprocctr,int *Ppronlyctr,int *Ppdelctr);      //~v010I~
#ifdef UNX                                                         //~v56sI~
#define UXDELDIR   (((unsigned)-1)-FILE_MDOSDISK-FILE_SPECIAL)   //for Pattrmask//~v56sI~
#else                                                              //~v56sI~
#define UXDELDIR   ((unsigned)-1)   //for Pattrmask             //~6121R~
#endif                                                             //~v56sI~
                                                                   //~v55dI~
#define UXDELNOMSG      0x00        //for Popt,no deleate/read only msg//~v010R~
#define UXDELMSG        0x01        //for Popt,deleate/read only msg//~v010R~
#define UXDELRONLYCHK   0x02        //for Popt,read only check only//~v010R~
#define UXDELFORCE      0x04        //for Popt,continue proces even if ronly//~v010R~
#define UXDELSKIPRONLY  0x08        //for Popt,skip ronly file delete//~v010I~
#define UXDELCONFEACH   0x10        //for Popt,confirm each member of top level//~v281I~
#define UXDELNONOTFMSG  0x20        //for Popt,bypass source file not found msg//~v55dI~
#ifdef UNX                                                         //~v55rI~
#define UXDELNOTFD      0x40        //no floppy support            //~v55rI~
#define UXDELFORCEROOT  0x80        //force delete object of root user grp//~v59pI~
#endif                                                             //~v55rI~
#define UXDELRONLYCHKOK 0x0100      //ronly chk done for no delforce nand skipronly//+v5fbI~
                                                                //~5B12I~
//****************************************************************//~5826I~
int uremovenomsg(UCHAR *Pfilename);                                //~v5amI~
//**************************************************************** //~v5amI~
int uremove(UCHAR *Pfilename);                                  //~5826I~
//****************************************************************//~5826I~
int urename(UCHAR *Poldname,UCHAR *Pnewname,UCHAR *Pnewspec);      //~v277I~
//**************************************************************** //~v520I~
int urename2(UCHAR *Poldname,UCHAR *Pnewname,UCHAR *Pnewspec);     //~v520I~
//****************************************************************//~5910I~
int ugetftime(UCHAR *Pfname,FDATE *Ppdate,FTIME *Pptime);       //~5910I~
//****************************************************************//~5910I~
int usetftime(UCHAR *Pfname,FDATE Pdate,FTIME Ptime);           //~5910I~
//****************************************************************//~5910I~
int ucopypathinfo(UCHAR *Psource,UCHAR *Ptarget);               //~5910R~
//****************************************************************//~5903I~
//#ifdef UNX                                                       //~v59eR~
int uattrib(UCHAR *Pfname,ULONG Pattron,ULONG Pattroff,ULONG *Poutattr);//~v327M~
//#else                                                            //~v59eR~
//int uattrib(UCHAR *Pfname,UCHAR Pattron,UCHAR Pattroff,UCHAR *Poutattr);//~v59eR~
//#endif                                                           //~v59eR~
//****************************************************************//~5916I~
int uwildfunc(int Popt,UCHAR *Psource,unsigned Pattrmask,       //~5916I~
                WILDAPPLYFUNC *Pfunc,void *Pparm,int *Pfilectr);//~5916R~
//****************************************************************//~5B12I~
int ufilecdirchk(UCHAR *Pfullpath);                             //~5B12I~
//****************************************************************//~5B12I~
int ufiledelpath(UCHAR *Pfname,int Prc);                        //~5B12I~
//****************************************************************//~5910I~
int ufilereadonly(UCHAR *Pfname,int Prc);                       //~5910I~
//****************************************************************//~5910I~
int ufileshare(UCHAR *Pfname,int Prc);                          //~5910I~
//****************************************************************//~5910I~
int ufileexist(UCHAR *Pfname,int Prc);                          //~5910I~
//****************************************************************//~5A14I~
int ufileexist2(UCHAR *Pfname,UCHAR *Pdir,int Prc);             //~5A14I~
//****************************************************************//~5910I~
int ufilenotdir(UCHAR *Pfname,int Prc);                         //~5910I~
//****************************************************************//~5910I~
int ufilediskfull(UCHAR *Pfname,int Prc);                       //~5910I~
//****************************************************************//~5B11I~
int ufilewildtarget(int Prc);                                   //~5B11R~
//**************************************************************** //~v327I~
int ufilespfnchk(UCHAR *Pfname,int Pop);    //if special file      //~v327M~
