//*CID://+v5i0R~:                             update#=  113;       //~v5i0R~
//*************************************************************
//*ufile4.c                                                        //~v083R~
//*  utempnam udirwalk ugetdiskfree ufileishpfs ufileisvfat ufileisntfs//~v5i0R~
//*************************************************************
//v5i0:060419 add ufileisntfs                                      //~v5i0I~
//v5b5:040124 (LNX)TuboLinux6 dose not support mktempd             //~v5b5I~
//v5b0:040115 (LNX:BUG)mkstmp is for file only,mkdtmp is required for temp dir//~v5b0I~
//v5a6:040104 (UNX,FTP)save slink uid,gid,uname,gname on dirlist for xe dirlist//~v5a6I~
//v5a5:040103 (BUG:UNX)dirlist missing slink size/ts               //~v5a5I~
//v59x:040101 (UNX,FTP)save slink timestamp and size for dirlist for xe//~v59xI~
//v59i:031108 ftp support:add username etc to windows udirlist/ffb3//~v59iI~
//v59e:031103 ftp support(4 byte udirlist attr for ! UNX)          //~v59eI~
//v59d:030816 ftp support                                          //~v59dI~
//v583:030808 (LNX)by link warning msg "use mkstemp as alternative of tempnam"//~v583I~
//v57a:021210 udirwalk:apply dir top mask also to top level file   //~v57aI~
//v579:021207 performance tuning(get dir entry at once if avail)   //~v578I~
//v578:021207 (UNX)udirlist performance tuning(stat call on the current dir)//~v579R~
//v573:021009 (UNX)slink err msg bypass option(u#48)               //~v573I~
//v572:020929 (WIN)by the reason of v571;del "TMP" env var temporary//~v572I~
//v571:020923 (WIN)tempnam should be _tempnam for prefix use.      //~v571I~
//            (but,dir parm is ignored if env var TMP is specified)//~v571I~
//v56A:020809 (BUG)S-link loop chk;for the case slinked to looped path(over update#33)//~v56AR~
//v56z:020809 (BUG)S-link loop chk;it should be chked fullname.    //~v56zI~
//v56u:020722 topmask apply to top subdir only(for xds)            //~v56uI~
//v56t:020712 (UNX)udirwalk slink skip option                      //~v56tI~
//v56r:020712 (UNX)udirwalk slink err chk by S_ISLNK but no slink name,the skip process//~v56rI~
//v56q:020712 (UNX)slink loop chk(v56k) at udirwalk not ufstat.(allow xe dir list display)//~v56rR~
//v56p:020711 (UNX) udirwalk;chk permission before udirlist to avoid double err msg.//~v56pI~
//v56m:020711 udirwalk;option to skip dir by rc=-5 from user func  //~v56mI~
//v56f:020710 XDS require EOF call even if long name err           //~v56fI~
//v56e:020710 udirwalk;slink loop protection                       //~v56eI~
//v56d:020710 (BUG)udirwalk;process in the dir is stopped when subdir has no member//~v56dI~
//v56b:020710 dirwalk:limit no msg option to not found msg only(use dirlistnomsg)//~v56bI~
//v569:020706 dirwalk missing ufree(causing xff storage shortage)  //~v569I~
//v55c:020428 (UNX:BUG)ROOTDIR chk for mdos disket                 //~v55cI~
//v553:020414 udirwalk missed accesstime etc for dir top;(v545,v547 is required to udirwalk)//~v553I~
//v528:020217 option to apply mask 1st level only for xds          //~v528I~
//v50G:010618 LNX:disket support(using mtools)                     //~v50GI~
//v377:000930 LINUX support(dir seperater is "/" not "\")          //~v377I~
//v372:000928 LINUX support(keep uid/gid/fsid in dirlist)          //~v372I~
//v369:000927 LINUX support("*" mean all member,"*.*" require intermediate ".";//~v369I~
//            under windows those are same effect)                 //~v369I~
//v350:000926 LINUX support(no drive id)                           //~v350I~
//v348:000926 LINUX support(ugetdiskfree now returns file system id additionaly)//~v348I~
//v327 000820:LINUX support                                        //~v327I~
//v202:981101 udirwalk:end of list call support for uds(dir size calc)//~v201I~
//v201:981101 (BUG)udirwalk:level shoud be down(increment only bug)//~v201I~
//v194:980920 (BUG of WIN)win allow filename ".aaa"                //~v194I~
//v120:971116 (BUG:GCC)when env var LFN changed N to Y,it is needed to force//~v120I~
//                     call _get_volume_info at _use_lfn.          //~v120I~
//                     new option to ufileisvfat                   //~v120I~
//v101:971009 long filename                                        //~v101I~
//            ufile4.c/h:add ufileishpfs(return file system id)    //~v101I~
//                       lfn and alias for W95                     //~v101I~
//            ufilevfat for DOS/W95                                //~v101I~
//v083:970508 add ugetdiskfree                                     //~v083I~
//v063:970210:udirwalk function add                                //~v063I~
//v050:961201:add utempnam                                         //~v050I~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>                                              //~5B12I~
                                                                   //~v063I~
//*******************************************************
#ifdef UNX                                                         //~v327I~
	#include <sys/vfs.h>                                           //~v327I~
	#include <sys/stat.h>                                          //~v56rI~
#else                                                              //~v327I~
#ifdef DOS
    #include <dos.h>                                               //~v083I~
    #ifdef DPMI                                                    //~v083I~
        #include <fcntl.h>  //_USE_LFN macro                       //~v101R~
        #include <errno.h>                                         //~v101I~
    #endif                                                         //~v083I~
#else
    #ifdef W32                                                     //~v022I~
        #include <dos.h>                                           //~v063I~
        #include <windows.h>                                       //~v083I~
    #else                                                          //~v022I~
        #define INCL_DOSFILEMGR                                    //~v083I~
        #define INCL_BASE                                          //~v083I~
        #include <os2.h>                                           //~v083I~
    #endif                                                         //~v022I~
#endif
#endif                                                             //~v327I~

//*******************************************************
#include <ulib.h>
#include <ufile.h>
#include <ufile2.h>                                                //~v5b5I~
#include <ufemsg.h>                                                //~v083I~
#include <ufile4.h>                                                //~v063I~
#include <uerr.h>
#include <utrace.h>                                                //~v063M~
#include <ualloc.h>                                                //~v063M~
#ifdef UNX                                                         //~v50GI~
    #include <ufile1l2.h>                                          //~v50GI~
#endif                                                             //~v50GI~
//**********************************************************************//~v063I~
#ifdef LNX                                                         //~v5b0I~
	static int Stempnamdsw=0;                                      //~v5b0I~
	static int Stempnamder=0;                                      //~v5b0I~
#endif                                                             //~v5b0I~
static  int  Sopt;                                                 //~v063I~
static  char *Sdirmask;                                            //~v063I~
static  char *Sfilemask;                                           //~v063I~
static  int Sattrmask;                                             //~v063I~
static  int (*Sfunc)(char *Pdir,char *Pfullpath,UDIRLIST *Ppudirlist,//~v063R~
                int Pdepth,void *Pdata,int *Papplrc);              //~v063I~
static  void *Sdata;                                               //~v063I~
static  int  *Sapplrc;                                             //~v063I~
//static  int  Sdirlevel;                                          //~v201R~
static  int  Sstopdepth;                                           //~v063I~
static  int  Scallctr;                                             //~v063I~
static  int  Sapplytopmask=0;                                      //~v528I~
//*                                                                //~v063I~
//int udirwalksub(char *Pdir,PUDIRLIST Ppudirlist);                //~v201R~
int udirwalksub(char *Pdir,PUDIRLIST Ppudirlist,int Plevel);       //~v201I~
//*******************************************************
//*dummy for lib(same name as file)                     *
//*******************************************************
void ufile4(void)                                                  //~v050R~
{
    return;
}

//****************************************************************//~5913I~
//utempnam                                                         //~v050R~
//* return temp file name                                          //~v050R~
//*****                                                         //~5913I~
//*parm1:dir name                                                  //~v050R~
//*parm2:filename prefix                                           //~v050R~
//*parm3:optional output addr,if 0 you must free returned addr     //~v050I~
//*retrn:tem file name ptr                                         //~v050R~
//****************************************************************//~5913I~
char *utempnam(char *Pdir,char *Pprefix,char *Ptempfile)           //~v050R~
{                                                               //~5913I~
    char *temp;                                                    //~v050I~
#ifdef W32                                                         //~v572I~
	int  putenvsw=0;                                               //~v572I~
    char *pc,envtmpdir[_MAX_PATH+8];                               //~v572I~
#endif                                                             //~v572I~
#ifdef LNX                                                         //~v583I~
    #ifdef LNXLC2   //new version                                  //~v583I~
        int rc;                                                    //~v583I~
	    char tempwk[_MAX_PATH];                                    //~v583R~
    #endif                                                         //~v583I~
#else                                                              //~v59dI~
  #ifdef UNX                                                       //~v59xI~
  #else                                                            //~v59xI~
   #ifdef W32                                                      //~v59dI~
    char *temptmp;                                                 //~v59dI~
   #endif                                                          //~v59dI~
  #endif                                                           //~v59xI~
#endif                                                             //~v583I~
//********************                                          //~5913I~
#ifdef UNX                                                         //~v327I~
	if (!(Pdir && *Pdir))                                          //~v59dI~
    	Pdir="/tmp";                                               //~v59dI~
  #ifdef LNX                                                       //~v583I~
    #ifdef LNXLC2   //new version                                  //~v583I~
    	sprintf(tempwk,"%s/%sXXXXXX",Pdir,Pprefix);	//mkstemp fmt  //~v583R~
      if (Stempnamdsw)                                             //~v5b0I~
      {                                                            //~v5b0I~
#ifdef LNXLC2TL6     //turblinux6 dose no support mkdtemp          //~v5b5I~
    	rc=mkstemp(tempwk); //rc fdno                              //~v5b5R~
        Stempnamder=errno;                                         //~v5b5I~
        if (rc!=-1)                                                //~v5b5R~
        {                                                          //~v5b5I~
        	rc=uremove(tempwk);                                    //~v5b5I~
	        Stempnamder=errno;                                     //~v5b5I~
            if (rc)                                                //~v5b5I~
	        	rc=-1;                                             //~v5b5I~
            else                                                   //~v5b5I~
            {                                                      //~v5b5I~
		     	Stempnamder=rc=umkdir(tempwk);                     //~v5b5I~
                if (rc)                                            //~v5b5I~
                	rc=-1;                                         //~v5b5I~
            }                                                      //~v5b5I~
        }                                                          //~v5b5I~
#else                                                              //~v5b5I~
    	if (mkdtemp(tempwk))                                       //~v5b0R~
        	rc=0;                                                  //~v5b0I~
        else                                                       //~v5b0I~
        	rc=-1;                                                 //~v5b0R~
        Stempnamder=errno;                                         //~v5b0I~
#endif                                                             //~v5b5I~
		if (rc)                                                    //~v5b5I~
        	ufileapierr("mkdtemp",tempwk,Stempnamder);             //~v5b5I~
      }                                                            //~v5b0I~
      else                                                         //~v5b0I~
    	rc=mkstemp(tempwk);                                        //~v583R~
        if (rc==-1)                                                //~v583I~
        	temp=0;       //err id                                 //~v583I~
        else                                                       //~v583I~
        {                                                          //~v583I~
        	temp=malloc(strlen(tempwk)+1);                         //~v583I~
        	strcpy(temp,tempwk);                                   //~v583R~
        }                                                          //~v583I~
    #else                                                          //~v583I~
    	temp=tempnam(Pdir,Pprefix);                                //~v583I~
    #endif                                                         //~v583I~
  #else                                                            //~v583I~
    temp=tempnam(Pdir,Pprefix);                                    //~v327I~
  #endif                                                           //~v583I~
#else                                                              //~v327I~
  #ifdef W32                                                       //~v59dI~
    temptmp=0;                                                     //~v59dI~
	if (!(Pdir && *Pdir))                                          //~v59dI~
    {                                                              //~v59dI~
    	pc=getenv("TMP");                                          //~v59dR~
        if (!pc)                                                   //~v59dI~
        	pc=getenv("TEMP");                                     //~v59dR~
        if (!pc)                                                   //~v59dI~
        	pc="c:\\";                                             //~v59dR~
        Pdir=temptmp=pc;                                           //~v59dI~
    }                                                              //~v59dI~
  #endif //W32                                                     //~v59dI~
#ifdef DOS                                                         //~v050R~
    temp=tempnam(Pdir,Pprefix);                                    //~v050I~
#else                                                           //~5917I~
    #ifdef W32                                                     //~v050I~
//      temp=tempnam(Pdir,Pprefix);                                //~v571R~
      if (!temptmp)	//not null dir parm                            //~v59dI~
        if (Pdir && *Pdir)                                         //~v572I~
            if (pc=getenv("TMP"),pc)                               //~v572R~
            {                                                      //~v572R~
                putenvsw=1;                                        //~v572R~
                sprintf(envtmpdir,"TMP=%s",pc);                    //~v572R~
                putenv("TMP=");                                    //~v572R~
            }                                                      //~v572R~
        temp=_tempnam(Pdir,Pprefix);                               //~v571I~
    	if (putenvsw)                                              //~v572I~
    		putenv(envtmpdir);	//restore                          //~v572I~
    #else                                                          //~v050I~
        temp=_tempnam(Pdir,Pprefix);                               //~v050I~
    #endif                                                         //~v050R~
#endif                                                             //~v050I~
#endif                                                             //~v327I~
    if (temp)                                                      //~v050I~
    {                                                              //~v050I~
        if (Ptempfile)                                             //~v050I~
        {                                                          //~v050I~
            strcpy(Ptempfile,temp);                                //~v050I~
            free(temp);                                            //~v050I~
            temp=Ptempfile;                                        //~v050I~
        }                                                          //~v050I~
    }                                                              //~v050I~
    return temp;                                                   //~v050I~
}//utempnam                                                        //~v050R~
#ifdef LNX                                                         //~v5b0I~
//**************************************************************** //~v5b0I~
//utempnamd                                                        //~v5b0I~
//* return temp dir name(it is already mkdir'ed)                   //~v5b0I~
//**************************************************************** //~v5b0I~
char *utempnamd(char *Pdir,char *Pprefix,char *Ptempfile)          //~v5b0I~
{                                                                  //~v5b0I~
	char *temp;                                                    //~v5b0I~
//********************                                             //~v5b0I~
	Stempnamdsw=1;                                                 //~v5b0I~
	temp=utempnam(Pdir,Pprefix,Ptempfile);                         //~v5b0R~
//  if (!temp)                                                     //~v5b5R~
//      ufileapierr("mkdtemp",Pdir,Stempnamder);                   //~v5b5R~
	Stempnamdsw=0;                                                 //~v5b0I~
    return temp;                                                   //~v5b0I~
}//utempnamd                                                       //~v5b0I~
#endif                                                             //~v5b0R~
//**************************************************************** //~v050I~
//ufgetpos                                                         //~v050I~
//* get current position                                           //~v050I~
//*****                                                            //~v050I~
//*parm1:FILE *                                                    //~v050I~
//*retrn:pos_t,-1 if err                                           //~v050I~
//**************************************************************** //~v050I~
long ufgetpos(FILE *Pfh)                                           //~v050R~
{                                                                  //~v050I~
//********************                                             //~v050I~
#ifdef DOS                                                         //~v050I~
#else                                                              //~v050I~
    #ifdef W32                                                     //~v050I~
    #else                                                          //~v050I~
    #endif                                                         //~v050I~
#endif                                                             //~v050I~
    return ftell(Pfh);                                             //~v050R~
}//ufgetpos                                                        //~v050I~
                                                                   //~v050I~
//**********************************************************************//~v063I~
//* udirwalk                                                       //~v063I~
//*  parm1:option(see define value)                                //~v063I~
//*  parm2:starting dir                                            //~v063I~
//*  parm3:sub dir name mask or 0(*.*)                             //~v063I~
//*  parm4:file name mask or 0(*.*)                                //~v063I~
//*  parm5:file attribute mask                                     //~v063I~
//*        if dir bit on,dir passed as file entry regardless parm1 option//~v063I~
//*  parm6:stop depth,0 for starting dir                           //~v194R~
//*  parm7:addr of func:rc func(dir-name,fullpath,UDIRLIST*,dir-nest-level,func-data)//~v063R~
//*         rc       :0 contine walk,else stop with the rc         //~v063I~
//*         dir-name :fullpath name without last \ padded except root//~v063I~
//*         fullpath :0 for dir entry,-1 for end of dir-list entry //~v201R~
//*         udirlist :0 if empty call and file call only req       //~v063I~
//*                   "\" of file name mean root dir               //~v063I~
//*         dir-depth:0 means start dir,1 mean file/dir under that //~v063I~
//*         func-data:pointer passed to func                       //~v063I~
//*         appl rc  :pointer appl rc set area                     //~v063I~
//*  parm8:user data pointer passed to func(option)                //~v063I~
//*  parm9:func rc area(option)                                    //~v063I~
//*  rc   :see define value                                        //~v063I~
//**********************************************************************//~v063I~
int  udirwalk(int Popt,char *Pstartdir,char *Pdirmask,char *Pfilemask,//~v063I~
                int Pattrmask,int Pstopdepth,                      //~v063I~
               int (*Pfunc)(char *Pdir,char *Pfullpath,UDIRLIST *Pudirlist,//~v063R~
                            int Pdepth,void *Pdata,int *Papplrc),  //~v063I~
               void *Pfuncdata,int *Prc)                           //~v063I~
{                                                                  //~v063I~
    FILEFINDBUF3 fstat3;                                           //~v063I~
    char fullpath[_MAX_PATH];                                      //~v063I~
    char curpath[_MAX_PATH];                                       //~v063I~
    int rc=0;                                                      //~v063R~
//  char msgoptand;                                                //~v56bR~
    UDIRLIST  udirlists;                                           //~v063R~
#ifndef UNX                                                        //~v327I~
    char curdrive;                                                 //~v063I~
#endif                                                             //~v327I~
//*******************************                                  //~v063I~
//*save parm to avoid pass through walk                            //~v063I~
    Sopt=Popt;                                                     //~v063I~
	Sapplytopmask=(Popt & UDIRWALK_TOPMASK);                       //~v528I~
    Sfunc=Pfunc;                                                   //~v063I~
    Sdirmask=Pdirmask;                                             //~v063I~
    if (!Sdirmask || !*Sdirmask)                                   //~v063I~
//      Sdirmask="*.*";                                            //~v369R~
        Sdirmask=DIR_ALLMEMB;                                      //~v369I~
    Sfilemask=Pfilemask;                                           //~v063I~
    if (!Sfilemask || !*Sfilemask)                                 //~v063I~
//      Sfilemask="*.*";                                           //~v369R~
        Sfilemask=DIR_ALLMEMB;                                     //~v369I~
    Sattrmask=Pattrmask;                                           //~v063I~
    Sstopdepth=Pstopdepth;                                         //~v063I~
    Sdata=Pfuncdata;                                               //~v063I~
    Sapplrc=Prc;                                                   //~v063R~
//*                                                                //~v063I~
    if (!ufullpath(fullpath,Pstartdir,sizeof(fullpath)))    //drop last \ except root//~v063I~
        rc=UDIRWALK_RC_NAME;                                       //~v063I~
    else                                                           //~v063I~
    {                                                              //~v063I~
        memset(&udirlists,0,sizeof(udirlists));                    //~v063R~
//      if (ROOTDIR(fullpath))                                     //~v55cR~
        if (ROOTDIR2(fullpath))                                    //~v55cI~
        {                                                          //~v063I~
//          strcpy(udirlists.name,fullpath+2);  //"\" root id      //~v350R~
            strcpy(udirlists.name,fullpath+ROOTDIRPOS);  //"\" root id//~v350I~
            udirlists.attr=0xff;    //mean root                    //~v063R~
        }                                                          //~v063I~
        else                                                       //~v063I~
        {                                                          //~v063I~
            if (ufstat(fullpath,&fstat3))                          //~v063I~
            {                                                      //~v063I~
                uerrmsg("%s is not found",                         //~v063I~
                        "%s ݂܂",                     //~v063I~
                        fullpath);                                 //~v063I~
                rc=UDIRWALK_RC_NOTF;                               //~v063I~
            }                                                      //~v063I~
            else                                                   //~v063I~
                if (!(fstat3.attrFile & FILE_DIRECTORY))           //~v063I~
                {                                                  //~v063I~
                    uerrmsg("%s is not directory",                 //~v063I~
                            "%s ̓fBNg[ł͂܂",   //~v063I~
                            fullpath);                             //~v063I~
                    rc=UDIRWALK_RC_NOTDIR;                         //~v063I~
                }                                                  //~v063I~
            if (!rc)                                               //~v063I~
            {                                                      //~v063I~
#ifdef W32                                                         //~v101I~
                memcpy(udirlists.name,fstat3.cFileName,sizeof(udirlists.name));//~v101R~
                memcpy(udirlists.alias,fstat3.achName,sizeof(udirlists.alias));//~v101R~
                udirlists.srcattr=fstat3.srcattr;                  //~v59iR~
                memcpy(udirlists.uname,fstat3.uname,sizeof(udirlists.uname));//~v59iI~
                memcpy(udirlists.gname,fstat3.gname,sizeof(udirlists.gname));//~v59iI~
                memcpy(udirlists.slink,fstat3.slink,sizeof(udirlists.slink));//~v59iR~
                udirlists.slinksize=fstat3.slinksize;              //~v59xI~
                udirlists.slinkfdate=fstat3.slinkfdate;            //~v59xI~
                udirlists.slinkftime=fstat3.slinkftime;            //~v59xI~
            	memcpy(udirlists.slinkuname,fstat3.slinkuname,sizeof(udirlists.slinkuname));//~v5a6I~
            	memcpy(udirlists.slinkgname,fstat3.slinkgname,sizeof(udirlists.slinkgname));//~v5a6I~
#else                                                              //~v101I~
                strcpy(udirlists.name,fstat3.achName);             //~v063R~
#endif                                                             //~v101I~
                                                                   //~v372I~
#ifdef UNX                                                         //~v372I~
                udirlists.srcattr=fstat3.srcattr;                  //~v59iI~
                memcpy(udirlists.slink,fstat3.slink,sizeof(udirlists.slink));//~v59iI~
                udirlists.attr=fstat3.attrFile;                    //~v372R~
                udirlists.fsid=fstat3.fsid;                        //~v372R~
                udirlists.uid =fstat3.uid;                         //~v372R~
                udirlists.gid =fstat3.gid;                         //~v372R~
            	udirlists.atime=fstat3.atime;                      //~v553R~
            	udirlists.mtime=fstat3.mtime;                      //~v553R~
            	udirlists.ctime=fstat3.ctime;                      //~v553R~
            	udirlists.slinkmtime=fstat3.slinkmtime;            //~v5a5I~
            	udirlists.slinkfdate=fstat3.slinkfdate;            //~v5a5I~
            	udirlists.slinkftime=fstat3.slinkftime;            //~v5a5I~
            	udirlists.slinksize =fstat3.slinksize ;            //~v5a5I~
                udirlists.slinkuid  =fstat3.slinkuid;              //~v5a6I~
                udirlists.slinkgid  =fstat3.slinkgid;              //~v5a6I~
#else  //!UNX                                                      //~v372I~
//              udirlists.attr=(char)fstat3.attrFile;              //~v59eR~
                udirlists.attr=(ULONG)fstat3.attrFile;             //~v59eI~
	#ifdef W32                                                     //~v553I~
    			udirlists.ftCreationTime  =fstat3.ftCreationTime;  //~v553R~
    			udirlists.ftLastAccessTime=fstat3.ftLastAccessTime;//~v553R~
    			udirlists.ftLastWriteTime =fstat3.ftLastWriteTime; //~v553R~
    #endif                                                         //~v553I~
    #ifdef OS2                                                     //~v553I~
    			udirlists.ctime =fstat3.ftimeCreation;             //~v553R~
    			udirlists.cdate =fstat3.fdateCreation;             //~v553R~
    			udirlists.atime =fstat3.ftimeLastAccess;           //~v553R~
    			udirlists.adate =fstat3.fdateLastAccess;           //~v553R~
    #endif                                                         //~v553I~
#endif //!UNX                                                      //~v372I~
                                                                   //~v372I~
                udirlists.time=fstat3.ftimeLastWrite;              //~v063R~
                udirlists.date=fstat3.fdateLastWrite;              //~v063R~
                udirlists.size=fstat3.cbFile;                      //~v063R~
            }                                                      //~v063I~
        }//not rootdir                                             //~v063I~
    }//fullpath ok                                                 //~v063I~
    if (!rc)                                                       //~v063I~
    {                                                              //~v063I~
        if (Sopt & UDIRWALK_CD)     //change dir opt               //~v063R~
        {                                                          //~v063I~
#ifndef UNX                                                        //~v327I~
            curdrive=ugetdrive();   //save curr drive              //~v063I~
            uchdrive(*fullpath);    //change                       //~v063I~
#endif                                                             //~v327I~
            ugetcwd(curpath);       //save curr path on the drive  //~v063I~
        }                                                          //~v063I~
//      Sdirlevel=0;    //top is 0                                 //~v201R~
        Scallctr=0;                                                //~v063I~
//msg ignore option                                                //~v063I~
//        msgoptand=0xff;     //at return and mask                 //~v56bR~
//        if (!UCBITCHK(Guerropt,GBL_UERR_NOMSGOUT)  //msgout now  //~v56bR~
//        &&  (Sopt & UDIRWALK_NOMSG))    //no msg out req         //~v56bR~
//        {                                                        //~v56bR~
//            UCBITON(Guerropt,GBL_UERR_NOMSGOUT); //*edit only,no output to any//~v56bR~
//            UCBITOFF(msgoptand,GBL_UERR_NOMSGOUT);  //reset it at return//~v56bR~
//        }                                                        //~v56bR~
                                                                   //~v063M~
//      rc=udirwalksub(fullpath,&udirlists);                       //~v201R~
        rc=udirwalksub(fullpath,&udirlists,0);  //level start from 0//~v201I~
                                                                   //~v063I~
//        Guerropt=(UCHAR)(Guerropt&msgoptand); //recover no msg option//~v56bR~
                                                                   //~v063I~
        if (Prc)                                                   //~v063I~
            *Prc=rc;                                               //~v063I~
        if (Sopt & UDIRWALK_CD)     //change dir opt               //~v063R~
        {                                                          //~v063I~
//          uchdir(curpath);    //restore                          //~v579R~
            uchdir(0,curpath);    //restore                        //~v579I~
#ifndef UNX                                                        //~v327I~
            uchdrive(curdrive); //restore                          //~v063I~
#endif                                                             //~v327I~
        }                                                          //~v063I~
        if (!Scallctr)                                             //~v063I~
        {                                                          //~v063I~
            uerrmsg("%s has no such file/dir (dir-mask=%s,file-mask=%s)\n",//~v063I~
                    "%s ɂ͊Y܂(dir-mask=%s,file-mask=%s)\n",//~v063I~
                    Pstartdir,Sdirmask,Sfilemask);                 //~v063I~
            rc=UDIRWALK_RC_EMPTY;                                  //~v063I~
        }                                                          //~v063I~
    }                                                              //~v063I~
    return rc;                                                     //~v063I~
}//udirwalk                                                        //~v063I~
//**********************************************************************//~v063I~
//* udirwalksub                                                    //~v063I~
//*  parm1:fullpath name of dir                                    //~v063I~
//*  parm2:udirlist of dir                                         //~v063I~
//*  parm3:curr dir level                                          //~v201I~
//*  rc   :0 continue walk,else stop walk by appl rc               //~v56fR~
//**********************************************************************//~v063I~
int udirwalksub(char *Pdir,PUDIRLIST Ppudirlist,int Plevel)        //~v201R~
{                                                                  //~v063I~
    int  ii,rc=0;                                                  //~v327R~
//  int  rc2;                                                      //~v56fR~
    int pathlen;    //len without last "\"                         //~v063I~
    int entryno,filectr,dirctr,sorttype;                           //~v063R~
    int attrmask;                                                  //~v063I~
    int level;                                                     //~v201I~
#ifdef UNX                                                         //~v57aI~
    int cdoksw=0;                                                  //~v579M~
#endif                                                             //~v57aI~
//  char fullpath[_MAX_PATH];                                      //~v56fR~
    char fullpath[_MAX_PATH+64]; //for mask concat space           //~v56fI~
    char fullpathw[_MAX_PATH];//filemask dir mask chkwk            //~v579R~
    PUDIRLIST pudirlist,pudirlist0,pudirlists;                     //~v063R~
    PUDIRLIST pudirlist0s;                                         //~v579R~
#ifdef UNX                                                         //~v56pI~
//  int len;                                                       //~v56AR~
    int  rcudirlist;                                               //~v56pR~
    char curdir[_MAX_PATH];//cur dir to be restored                //~v57aM~
#endif                                                             //~v56pI~
//*******************************                                  //~v063I~
    level=Plevel+1;                                                //~v201I~
    pathlen=(int)strlen(Pdir);                                     //~v063I~
    memcpy(fullpath,Pdir,(UINT)pathlen);    //with last "\" for root//~v063R~
//  if (*Ppudirlist->name!='\\') //not root dir                    //~v377R~
//      *(fullpath+pathlen++)='\\';                                //~v377R~
    if (*Ppudirlist->name!=DIR_SEPC) //not root dir                //~v377I~
        *(fullpath+pathlen++)=DIR_SEPC;                            //~v377I~
    *(fullpath+pathlen)=0;                                         //~v063I~
    sorttype=(Sopt & UDIRWALK_SORT_MASK);                          //~v063I~
    if (Sopt & UDIRWALK_SORT_REV) //reverse sort sw                //~v063I~
        sorttype=-sorttype;                                        //~v063I~
//for own dir                                                      //~v063I~
#ifdef UNX                                                         //~v57aI~
    if (Sopt & UDIRWALK_TEMPCD)//change dir opt                    //~v57aR~
    {                                                              //~v578I~
		ugetcwd(curdir);	//to be restored before each dirwalk   //~v57aI~
        if (strcmp(curdir,Pdir))  //not of current dir             //~v57aR~
			if (!uchdir(UCHD_NOMSG,Pdir))                          //~v57aR~
    	    	cdoksw=2;   //should be restore                    //~v57aR~
//printf("udirwalk1 curdir=%s,cdoksw=%d,errno=%d,-->%s\n",curdir,cdoksw,errno,Pdir);//~v57aR~
    }                                                              //~v578I~
    else                                                           //~v578I~
#endif                                                             //~v57aI~
    if (Sopt & UDIRWALK_CD)     //change dir opt                   //~v063R~
    {                                                              //~v578I~
//      uchdir(Pdir);   //change to the dir                        //~v579R~
#ifdef UNX                                                         //~v578I~
		if (!uchdir(0,Pdir))                                       //~v578I~
        	cdoksw=1;                                              //~v578I~
#else                                                              //~v578I~
        uchdir(0,Pdir);   //change to the dir                      //~v578R~
#endif                                                             //~v578I~
    }                                                              //~v578I~
    if (Sopt & UDIRWALK_DIRCALL)                                   //~v063I~
    {                                                              //~v063I~
        Scallctr++;                                                //~v063I~
//      if (rc=Sfunc(Pdir,0,Ppudirlist,Sdirlevel,Sdata,Sapplrc),rc)//~v201R~
        if (rc=Sfunc(Pdir,0,Ppudirlist,Plevel,Sdata,Sapplrc),rc)//by curr level//~v201I~
        {                                                          //~v56mI~
			if (rc==UDIRWALK_URC_SKIPDIR) //user requested skip this dir//~v56mI~
            	return 0;                                          //~v56mI~
            return rc;                                             //~v063I~
        }                                                          //~v56mI~
    }                                                              //~v063I~
//  Sdirlevel++;                                                   //~v201R~
//  if (Sdirlevel>Sstopdepth)                                      //~v201R~
    if (level>Sstopdepth)                                          //~v201I~
        return 0;                                                  //~v063I~
//for all file                                                     //~v063I~
	fullpathw[0]=0;                                                //~v579R~
    pudirlist0s=0;                                                 //~v579I~
    attrmask=(Sattrmask | FILE_DIRECTORY);  //also dir at once     //~v579R~
    if (Sopt & UDIRWALK_FILECALL)                                  //~v063I~
    {                                                              //~v063I~
//      attrmask=Sattrmask; //may contain dir                      //~v579R~
//        if (Sapplytopmask)                                       //~v56uR~
//        {                                                        //~v56uR~
//            if (Sapplytopmask & 4)  //dir mask applyed           //~v56uR~
//                strcpy(fullpath+pathlen,DIR_ALLMEMB);            //~v56uR~
//            else        //1st dir mask apply                     //~v56uR~
////              strcpy(fullpath+pathlen,Sdirmask);               //~v56uR~
//                strcpy(fullpath+pathlen,Sfilemask);              //~v56uR~
//            Sapplytopmask |= 4; //dir mask applyed               //~v56uR~
//        }                                                        //~v56uR~
//        else                                                     //~v56uR~
//printf("Sdirmask=%s\n",Sdirmask);                                //~v56uR~
//    if (!Sapplytopmask      //                                   //~v57aR~
//    ||  (Sapplytopmask & 4)  //not top level                     //~v57aR~
//    ||  !Sdirmask)           //no mask on dirname parm           //~v57aR~
//    {                                                            //~v57aR~
	  if ((Sapplytopmask & UDIRWALK_TOPMASK)	//apply dir mask to top level option//~v57aI~
	  &&  !(Sapplytopmask & 4))  //top level                       //~v57aI~
        strcpy(fullpath+pathlen,Sdirmask);                         //~v57aI~
      else                                                         //~v57aI~
        strcpy(fullpath+pathlen,Sfilemask);                        //~v063I~
	    strcpy(fullpathw,fullpath); //to compare with dir mask     //~v579R~
#ifdef UNX                                                         //~v578I~
		if (cdoksw)                                                //~v578I~
        	Gufile_opt|=GFILEOPT_STATCD;//issue stat by not fullpathname//~v578I~
#endif                                                             //~v578I~
      if (Sopt & UDIRWALK_NOMSG)    //no msg out req               //~v56bI~
        entryno=udirlistnomsg(fullpath,(UINT)attrmask,&pudirlist0,sorttype);//~v56bI~
      else                                                         //~v56bI~
        entryno=udirlist(fullpath,(UINT)attrmask,&pudirlist0,sorttype);//~v063R~
#ifdef UNX                                                         //~v578I~
     	Gufile_opt&=~GFILEOPT_STATCD;                              //~v578I~
		if (cdoksw==2)  //tempcd                                   //~v57aI~
			uchdir(UCHD_NOMSG,curdir);                             //~v57aR~
//printf("udirwalk1 back curdir=%s,chngsw=%d,errno=%d\n",curdir,cdoksw,errno);//~v57aR~
#endif                                                             //~v578I~
#ifdef UNX                                                         //~v56pM~
		rcudirlist=errno;	//to avoid double errmsg               //~v56pI~
#endif                                                             //~v56pM~
        if (entryno!=-1)    //list not created                     //~v063R~
        {                                                          //~v063I~
//apply for all file                                               //~v063I~
            for (ii=0,filectr=0,pudirlist=pudirlist0;ii<entryno;ii++,pudirlist++)//~v063R~
            {                                                      //~v063I~
//              if (*pudirlist->name=='.')                         //~v194I~
                if (!strcmp(pudirlist->name,".")                   //~v194I~
                ||  !strcmp(pudirlist->name,".."))                 //~v194I~
                    continue;                                      //~v063I~
#ifdef UNX                                                         //~v56tI~
              	if (Sopt & UDIRWALK_SKIPSLINK  //skip slink        //~v56tI~
              	&&  S_ISLNK(FILE_GETMODE(pudirlist->attr)))        //~v56tI~
                    continue;                                      //~v56tI~
#endif                                                             //~v56tI~
                if (pudirlist->attr & FILE_DIRECTORY)              //~v579I~
                    continue;                                      //~v579I~
              if ((strlen(pudirlist->name)+pathlen)>=_MAX_PATH)    //~v56fI~
              {                                                    //~v56fI~
                  uerrmsg("too long filename; %.*s%s",0,           //~v56fI~
                          pathlen,fullpath,pudirlist->name);       //~v56fI~
              }                                                    //~v56fI~
              else                                                 //~v56fI~
              {                                                    //~v56fI~
                filectr++;                                         //~v063I~
                strcpy(fullpath+pathlen,pudirlist->name);          //~v063I~
                Scallctr++;                                        //~v063I~
//              if (rc=Sfunc(Pdir,fullpath,pudirlist,Sdirlevel,Sdata,Sapplrc),rc)//~v201R~
                if (rc=Sfunc(Pdir,fullpath,pudirlist,level,Sdata,Sapplrc),rc)//by +1 level//~v201I~
                    break;                                         //~v063I~
              }                                                    //~v56fI~
            }//for all file                                        //~v063I~
//          ufree(pudirlist0);                                     //~v579R~
            if (rc)                                                //~v063I~
            {                                                      //~v579I~
		        ufree(pudirlist0);                                 //~v579I~
                return rc;                                         //~v063I~
            }                                                      //~v579I~
            pudirlist0s=pudirlist0;	//reuse if avail               //~v579I~
        }                                                          //~v063I~
        if (entryno==-1 || !filectr)                               //~v063R~
            if (Sopt & UDIRWALK_EMPTYCALL                          //~v063I~
            &&  !(Sopt & UDIRWALK_DIRCALL)) //not called once      //~v063I~
            {                                                      //~v063I~
                Scallctr++;                                        //~v063I~
//              if (rc=Sfunc(Pdir,0,0,Sdirlevel-1,Sdata,Sapplrc),rc)//~v201R~
                if (rc=Sfunc(Pdir,0,0,Plevel,Sdata,Sapplrc),rc)    //~v201I~
                {                                                  //~v579I~
        			if (entryno!=-1)    //list not created         //~v579I~
				        ufree(pudirlist0);                         //~v579I~
                    return rc;                                     //~v063I~
                }                                                  //~v579I~
            }                                                      //~v063I~
//    }//not the case wild card dir name and top level of xds(TOPMASK)//~v57aR~
      Sapplytopmask |= 4; //dir mask applyed                       //~v56uR~
    }//file call                                                   //~v063I~
//create subdir list                                               //~v063I~
//  attrmask=(Sattrmask | FILE_DIRECTORY);                         //~v579R~
//  if (Sapplytopmask)                                             //~v57aR~
    if (Sapplytopmask & UDIRWALK_TOPMASK)	//apply dir mask to top level option//~v57aR~
    {                                                              //~v528I~
		if (Sapplytopmask & 2)	//dir mask applyed                 //~v528I~
	    	strcpy(fullpath+pathlen,DIR_ALLMEMB);                  //~v528I~
        else		//1st dir mask apply                           //~v528I~
		    strcpy(fullpath+pathlen,Sdirmask);                     //~v528I~
		Sapplytopmask |= 2;	//dir mask applyed                     //~v528I~
    }                                                              //~v528I~
    else                                                           //~v528I~
    strcpy(fullpath+pathlen,Sdirmask);                             //~v063I~
#ifdef UNX                                                         //~v56pI~
 if (rcudirlist==EACCES)	//find 1st permission err              //~v56rR~
    	entryno=-1;                                                //~v56pI~
 else                                                              //~v56pI~
 {                                                                 //~v578I~
#endif                                                             //~v56pI~
  if (!strcmp(fullpathw,fullpath))//same as prev udirlist          //~v579I~
  {                                                                //~v579I~
 	pudirlist0=pudirlist0s;                                        //~v579I~
  }                                                                //~v579I~
  else                                                             //~v579I~
  {                                                                //~v579I~
    if (pudirlist0s)                                               //~v579I~
    	ufree(pudirlist0s);                                        //~v579R~
#ifdef UNX                                                         //~v578I~
	if (cdoksw)                                                    //~v578I~
    {                                                              //~v57aI~
        if (cdoksw==2)                                             //~v57aM~
			if (!uchdir(UCHD_NOMSG,Pdir))                          //~v57aM~
        		cdoksw=0;   //should be restore                    //~v57aM~
      if (cdoksw)                                                  //~v57aI~
    	Gufile_opt|=GFILEOPT_STATCD;                               //~v578I~
    }                                                              //~v57aI~
#endif                                                             //~v578I~
  if (Sopt & UDIRWALK_NOMSG)    //no msg out req                   //~v56bI~
    entryno=udirlistnomsg(fullpath,(UINT)attrmask,&pudirlist0,sorttype);//~v56bI~
  else                                                             //~v56bI~
    entryno=udirlist(fullpath,(UINT)attrmask,&pudirlist0,sorttype);//~v063R~
#ifdef UNX                                                         //~v578I~
     	Gufile_opt&=~GFILEOPT_STATCD;                              //~v578I~
        if (cdoksw==2)                                             //~v57aI~
			uchdir(UCHD_NOMSG,curdir);                             //~v57aI~
//printf("udirwalk2 curdir=%s,chngsw=%d,-->%s\n",curdir,cdoksw,Pdir);//~v57aR~
#endif                                                             //~v578I~
  }                                                                //~v579I~
#ifdef UNX                                                         //~v578I~
 }                                                                 //~v578I~
#endif                                                             //~v578I~
//  printf("dir entryno=%d,fullpath=%s\n",entryno,fullpath);       //~v063R~
    if (entryno!=-1)    //list created                             //~v063R~
    {                                                              //~v063I~
        for (ii=0,dirctr=0,pudirlist=pudirlist0;ii<entryno;ii++,pudirlist++)//~v063R~
        {                                                          //~v063I~
//  printf("dir filectr=%d,name=%s\n",ii,pudirlist->name);         //~v063R~
//          if ((*pudirlist->name=='.')                            //~v194I~
            if (!strcmp(pudirlist->name,".")                       //~v194I~
            ||  !strcmp(pudirlist->name,"..")                      //~v194I~
            ||  !(pudirlist->attr & FILE_DIRECTORY))               //~v063I~
                continue;                                          //~v063I~
            dirctr++;                                              //~v063I~
        }//for all subdir                                          //~v063I~
//  printf("dir ctr=%d\n",dirctr);                                 //~v063R~
        rc=0;   //for the case dirctr=0;                           //~v569I~
        if (dirctr)                                                //~v063I~
        {                                                          //~v063I~
//reduce table size for recursive call                             //~v063I~
            pudirlists=umalloc((UINT)(dirctr*sizeof(UDIRLIST)));   //~v063R~
            for (ii=0,dirctr=0,pudirlist=pudirlist0;ii<entryno;ii++,pudirlist++)//~v063R~
            {                                                      //~v063I~
#ifdef UNX                                                         //~v56tI~
              	if (Sopt & UDIRWALK_SKIPSLINK  //skip slink        //~v56tI~
              	&&  S_ISLNK(FILE_GETMODE(pudirlist->attr)))        //~v56tI~
                    continue;               //skip slink           //~v56tI~
#endif                                                             //~v56tI~
//              if ((*pudirlist->name=='.')                        //~v194I~
                if (!strcmp(pudirlist->name,".")                   //~v194I~
                ||  !strcmp(pudirlist->name,"..")                  //~v194I~
                ||  !(pudirlist->attr & FILE_DIRECTORY))           //~v063I~
                    continue;                                      //~v063I~
                *(pudirlists+dirctr++)=*pudirlist;                 //~v063I~
            }//for all subdir                                      //~v063I~
            ufree(pudirlist0);                                     //~v063I~
            pudirlist0=pudirlists;                                 //~v063I~
//  printf("dir ctr2=%d\n",dirctr);                                //~v063R~
            entryno=dirctr;                                        //~v063R~
//apply to subdir                                                  //~v063I~
            for (ii=0,pudirlist=pudirlist0;ii<entryno;ii++,pudirlist++)//~v063R~
            {                                                      //~v063I~
              if ((strlen(pudirlist->name)+pathlen)>=_MAX_PATH)    //~v56eR~
              {                                                    //~v56eI~
                  	uerrmsg("too long filename; %.*s%s",0,         //~v56eR~
                          pathlen,fullpath,pudirlist->name);       //~v56eR~
//#ifdef UNX                                                       //~v56fR~
//                    rc2=ENAMETOOLONG;                            //~v56fR~
//#else                                                            //~v56fR~
//    #ifdef DOS                                                   //~v56fR~
//        #ifdef DPMI                                              //~v56fR~
//                    rc2=ENAMETOOLONG;                            //~v56fR~
//        #else                                                    //~v56fR~
//                    rc2=E2BIG;                                   //~v56fR~
//        #endif                                                   //~v56fR~
//    #else                                                        //~v56fR~
//        #ifdef W32                                               //~v56fR~
//                    rc2=ENAMETOOLONG;                            //~v56fR~
//        #else       //os/2                                       //~v56fR~
//                    rc2=EBADNAME;                                //~v56fR~
//        #endif                                                   //~v56fR~
//    #endif                                                       //~v56fR~
//#endif  //UNX                                                    //~v56fR~
              }                                                    //~v56eI~
              else                                                 //~v56eI~
              {                                                    //~v56eI~
                strcpy(fullpath+pathlen,pudirlist->name);          //~v063I~
#ifdef UNX                                                         //~v56qI~
//               if (!strcmp(pudirlist->slink,".")  //             //~v56AR~
//               ||  !strcmp(pudirlist->slink,"..")  //            //~v56AR~
////             ||  (*pudirlist->slink==DIR_SEPC && strstr(fullpath,pudirlist->slink))) //slink loop(source path is upper level of target)//~v56AR~
//               ||  (*pudirlist->slink==DIR_SEPC                  //~v56AR~
//                    && (len=(int)strlen(pudirlist->slink),       //~v56AR~
//                        memcmp(fullpath,pudirlist->slink,(UINT)len)==0)//~v56AR~
//                    && (*(fullpath+len)==DIR_SEPC||!*(fullpath+len))))//~v56AR~
//               {                                                 //~v56AR~
//                  uerrmsg("Skipped by S-Link loop;(%s --> %s)",0,//~v56AR~
//                              fullpath,pudirlist->slink);        //~v56AR~
//               }                                                 //~v56AR~
//               else                                              //~v56AR~
             if (!ufileslinkchk(Pdir,pudirlist->name,pudirlist->slink))//loop chk//~v56AR~
             {                                                     //~v59xI~
			   if (S_ISLNK(FILE_GETMODE(pudirlist->attr))//symbolic link//~v56rI~
    		   &&  !*pudirlist->slink)	//readlink failed          //~v56rI~
               		;	//skip                                     //~v56rI~
               else                                                //~v56qI~
               {                                                   //~v56qI~
#endif                                                             //~v56qI~
//              if (rc=udirwalksub(fullpath,pudirlist),rc)         //~v201R~
//              if (rc=udirwalksub(fullpath,pudirlist,level),rc)   //~v56dR~
//                  break;                                         //~v56dR~
//              rc2=udirwalksub(fullpath,pudirlist,level);         //~v56fR~
                if (rc=udirwalksub(fullpath,pudirlist,level),rc)   //~v56fI~
                    break;                                         //~v56fI~
#ifdef UNX                                                         //~v56qI~
               }//slink loop chk                                   //~v56qI~
             }//slinkchk                                           //~v59xM~
#endif                                                             //~v56qI~
              }                                                    //~v56eI~
//                if (rc2)                                         //~v56fR~
//                    if (!rc)                                     //~v56fR~
//                        rc=rc2; //continue process               //~v56fR~
            }//for all subdir                                      //~v063I~
//          ufree(pudirlist0);                                     //~v569R~
//          if (rc)                                                //~v569R~
//              return rc;                                         //~v569R~
        }//dir exist                                               //~v063I~
        ufree(pudirlist0);                                         //~v569I~
        if (rc)                                                    //~v569I~
            return rc;                                             //~v569I~
    }//list created                                                //~v063I~
    if (Sopt & UDIRWALK_EOLCALL)                                   //~v201R~
        if (rc=Sfunc(Pdir,(char*)(-1),0,Plevel,Sdata,Sapplrc),rc)//by curr level//~v201R~
            return rc;                                             //~v201R~
    return 0;                                                      //~v063I~
}//dirwalksub                                                      //~v063I~
                                                                   //~v083I~
#ifdef UNX                                                         //~v327I~
//*******************************************************          //~v56AR~
//*ugetdiskfree:return file system info of the pathname            //~v56AR~
//*parm 1:dir name                                                 //~v56AR~
//*parm 2:dir member                                               //~v56AR~
//*parm 3:slink to                                                 //~v56AR~
//*ret   :rc: 0(OK)  4:loop detected                               //~v56AR~
//*******************************************************          //~v56AR~
int ufileslinkchk(char *Pdir,char *Pmember,char *Pslink)           //~v56AR~
{                                                                  //~v56AR~
	int rc=0,len;                                                  //~v56AR~
    char *path;                                                    //~v56AR~
    char fpathwk[_MAX_PATH];                                       //~v56AR~
    char dirnm[_MAX_PATH];                                         //~v56AR~
	FILEFINDBUF3 ffb3;                                             //~v56AR~
//*******************                                              //~v56AR~
    if (!*Pslink)                                                  //~v56AR~
        return 0;                                                  //~v56AR~
    len=(int)strlen(Pdir);                                         //~v56AR~
    memcpy(dirnm,Pdir,(UINT)len);                                  //~v56AR~
    if (len>1 && *(Pdir+len-1)==DIR_SEPC)                          //~v56AR~
    	*(dirnm+len-1)=0;                                          //~v56AR~
    else                                                           //~v56AR~
    	*(dirnm+len)=0;                                            //~v56AR~
	if (!strcmp(Pslink,".")  //                                    //~v56AR~
    ||  !strcmp(Pslink,"..")  //                                   //~v56AR~
    ||  !strcmp(Pslink,DIR_SEPS))  //root                          //~v56AR~
    	rc=4;	                                                   //~v56AR~
    else                                                           //~v56AR~
    if (*Pslink==DIR_SEPC)                                         //~v56AR~
    {                                                              //~v56AR~
    	len=strlen(Pmember);                                       //~v56AR~
		for (path=dirnm;path=strstr(path,Pmember),path;path+=len)  //~v56AR~
    	{                                                          //~v56AR~
        	if (*(path-1)!=DIR_SEPC || *(path+len)!=DIR_SEPC)	//full match?//~v56AR~
            	continue;                                          //~v56AR~
            memcpy(fpathwk,dirnm,(ULONG)path-(ULONG)dirnm+len);    //~v56AR~
            *(fpathwk+(ULONG)path-(ULONG)dirnm+len)=0;             //~v56AR~
			if (ufstat(fpathwk,&ffb3))                             //~v56AR~
            	continue;                                          //~v56AR~
            if (*ffb3.slink && !strcmp(ffb3.slink,Pslink))	//match//~v56AR~
            {	                                                   //~v56AR~
            	rc=4;	//loop                                     //~v56AR~
                break;                                             //~v56AR~
            }                                                      //~v56AR~
        }                                                          //~v56AR~
    }                                                              //~v56AR~
    if (rc)                                                        //~v56AR~
      if (!(Gufile_opt & GFILEOPT_NOSLINKERRMSG))                  //~v573I~
    	uerrmsg("Skipped by S-Link loop;(%s/%s --> %s)",0,         //~v56AR~
                      dirnm,Pmember,Pslink);                       //~v56AR~
    return rc;                                                     //~v56AR~
}//ufileslinkchk                                                   //~v56AR~
//*******************************************************          //~v327I~
//*ugetdiskfree:return file system info of the pathname            //~v327I~
//*parm 1:pathname,0 for curr dir                                  //~v327R~
//*parm 2:output dispspace structure                               //~v327I~
//*ret   :rc: 0(OK)  or else ERR(errno or APIRET)                  //~v327I~
//*******************************************************          //~v327I~
unsigned int ugetdiskfree(char *Pfname,UDISKINFO *Pudiskinfo)      //~v327I~
{                                                                  //~v327I~
    struct statfs sfs;                                             //~v327I~
    unsigned int rc;                                               //~v327I~
    UCHAR *pfn;                                                    //~v327R~
//*******************                                              //~v327I~
    memset(Pudiskinfo,0,sizeof(UDISKINFO)); //clear for err        //~v327I~
    if (!(pfn=Pfname))                                             //~v327I~
    	pfn="./";		//current dir                              //~v327I~
//  if (statfs(pfn,&sfs))                                          //~v50GI~
    if (MDOSDISKOK(pfn))                                           //~v50GI~
    {                                                              //~v50GI~
        rc=ustatfs_mdos(pfn,&sfs);                                 //~v50GI~
        errno=rc;                                                  //~v50GI~
    }                                                              //~v50GI~
    else                                                           //~v50GI~
    	rc=statfs(pfn,&sfs);                                       //~v50GR~
    if (rc)                                                        //~v50GI~
    {                                                              //~v327I~
    	rc=errno;                                                  //~v327I~
        switch(rc)                                                 //~v327I~
        {                                                          //~v327I~
        case ENOENT:                                               //~v327I~
        case ENOTDIR:                                              //~v327I~
            return ufilenotfound(pfn,rc);                          //~v327R~
        }                                                          //~v327I~
        return rc;                                                 //~v327I~
    }                                                              //~v327I~
    Pudiskinfo->total_clusters=sfs.f_blocks;    //total block cnt  //~v327I~
//  Pudiskinfo->avail_clusters=sfs.f_bfree;     //not assigned block cnt//~v327R~
    Pudiskinfo->avail_clusters=sfs.f_bavail;    //avail block cnt for non prev user//~v327I~
    Pudiskinfo->sectors_per_cluster=1;          //no cluster       //~v327I~
    Pudiskinfo->bytes_per_sector=sfs.f_bsize;   //block size       //~v327I~
    Pudiskinfo->filesystemid=sfs.f_fsid;  		//filesystemid     //~v348I~
    return 0;                                                      //~v327R~
}//ugetdiskfree                                                    //~v327I~
#else   //!UNX                                                     //~v327I~
//*******************************************************          //~v083I~
//*ugetdiskfree                                                    //~v083I~
//*parm 1:drive letter('A' or 'a' etc,0 for current)               //~v083I~
//*parm 2:output dispspace structure                               //~v083R~
//*ret   :rc: 0(OK)  or else ERR(errno or APIRET)                  //~v083I~
//*******************************************************          //~v083I~
unsigned int ugetdiskfree(char Pdletter,UDISKINFO *Pudiskinfo)     //~v083I~
{                                                                  //~v083I~
    char drivestr[4];                                              //~v083I~
#ifdef DOS                                                         //~v083I~
    unsigned int driveid;                                          //~v083I~
    struct diskfree_t diskspace;                                   //~v083M~
#else                                                              //~v083I~
    #ifdef W32                                                     //~v083I~
        char *pc;                                                  //~v083I~
        DWORD sectornum,unitnum,unitavail,bytesnum;                //~v083I~
    #else   //os/2                                                 //~v083I~
typedef struct _FSPINFO{                                           //~v083I~
                        ULONG   filesysid;                         //~v083I~
                        ULONG   sectornum;                         //~v083I~
                        ULONG   unitnum;                           //~v083I~
                        ULONG   unitavail;                         //~v083I~
                        USHORT  bytesnum;                          //~v083I~
                      } FSPINFO;                                   //~v083I~
        FSPINFO fspinfo;                                           //~v083I~
        unsigned int driveid;                                      //~v083I~
    #endif                                                         //~v083I~
#endif                                                             //~v083I~
    unsigned int rc;                                               //~v083I~
                                                                   //~v083I~
//*******************                                              //~v083I~
    memset(Pudiskinfo,0,sizeof(UDISKINFO)); //clear for err        //~v083I~
#ifdef W32                                                         //~v083I~
    if (Pdletter)                                                  //~v083I~
    {                                                              //~v083I~
        drivestr[0]=Pdletter;                                      //~v083I~
        drivestr[1]=':';                                           //~v083I~
        drivestr[2]='\\';                                          //~v083I~
        drivestr[3]=0;                                             //~v083I~
        pc=drivestr;                                               //~v083I~
    }                                                              //~v083I~
    else                                                           //~v083I~
        pc=0;                                                      //~v083I~
#else                                                              //~v083I~
    if ((driveid=(UINT)Pdletter),driveid)                          //~v083I~
        driveid=(unsigned)(toupper(driveid)-'A'+1);                //~v083I~
#endif                                                             //~v083I~
#ifdef DOS                                                         //~v083I~
    rc=_dos_getdiskfree(driveid,&diskspace);                       //~v083I~
    if (rc)                                                        //~v083I~
    {                                                              //~v083I~
        rc=errno;                                                  //~v083I~
        sprintf(drivestr,"%c:",Pdletter);                          //~v083I~
        ufileapierr("_dos_getdiskfree",drivestr,rc);               //~v083I~
    }                                                              //~v083I~
    else                                                           //~v083I~
    {                                                              //~v083I~
        Pudiskinfo->total_clusters=diskspace.total_clusters;       //~v083I~
        Pudiskinfo->avail_clusters=diskspace.avail_clusters;       //~v083I~
        Pudiskinfo->sectors_per_cluster=diskspace.sectors_per_cluster;//~v083I~
        Pudiskinfo->bytes_per_sector=diskspace.bytes_per_sector;   //~v083I~
    }                                                              //~v083I~
#else                                                              //~v083I~
    #ifdef W32                                                     //~v083I~
        rc=GetDiskFreeSpace(pc,&sectornum,&bytesnum,&unitavail,&unitnum);//~v083I~
        if (rc==TRUE)                                              //~v083I~
        {                                                          //~v083I~
            Pudiskinfo->total_clusters=unitnum;                    //~v083R~
            Pudiskinfo->avail_clusters=unitavail;                  //~v083R~
            Pudiskinfo->sectors_per_cluster=sectornum;             //~v083R~
            Pudiskinfo->bytes_per_sector=bytesnum;                 //~v083R~
            rc=0;                                                  //~v083I~
        }                                                          //~v083I~
        else                                                       //~v083I~
        {                                                          //~v083I~
            rc=GetLastError();                                     //~v083I~
            ufileapierr("GetDiskFreeSpace",drivestr,(int)rc);      //~v083R~
        }                                                          //~v083I~
    #else                                                          //~v083I~
        rc=DosQueryFSInfo(driveid,(ULONG)FSIL_ALLOC,&fspinfo,sizeof(fspinfo));//~v083I~
        if (!rc)                                                   //~v083I~
        {                                                          //~v083I~
            Pudiskinfo->total_clusters=fspinfo.unitnum;            //~v083R~
            Pudiskinfo->avail_clusters=fspinfo.unitavail;          //~v083R~
            Pudiskinfo->sectors_per_cluster=fspinfo.sectornum;     //~v083R~
            Pudiskinfo->bytes_per_sector=(UINT)fspinfo.bytesnum;   //~v083R~
        }                                                          //~v083I~
        else                                                       //~v083I~
        {                                                          //~v083I~
            sprintf(drivestr,"%c:",Pdletter);                      //~v083I~
            ufileapierr("DosQueryFSInfo",drivestr,(int)rc);        //~v083R~
        }                                                          //~v083I~
    #endif                                                         //~v083I~
#endif                                                             //~v083I~
                                                                   //~v083I~
    return rc;                                                     //~v083I~
}//ugetdiskfree                                                    //~v083I~
#endif //not UNX                                                   //~v327I~
                                                                   //~v327I~
#ifdef OS2                                                         //~v101I~
//*******************************************************          //~v101I~
//*ufileishpfs                                                     //~v101I~
//*parm 1:drive letter('A' or 'a' etc,0 for current)               //~v101I~
//*ret   :rc: 0:FAT,1(HPFS),4(aoi err)                             //~v101I~
//*******************************************************          //~v101I~
int ufileishpfs(char Pdletter)                                     //~v101I~
{                                                                  //~v101I~
    unsigned int rc;                                               //~v101I~
    FSQBUFFER2 *pfsqb2;                                            //~v101R~
    ULONG buffsz;                                                  //~v101M~
    char buff[256];                                                //~v101R~
    char driveid[3];                                               //~v101I~
//*******************                                              //~v101I~
    driveid[0]=Pdletter;                                           //~v101I~
    driveid[1]=':';                                                //~v101I~
    driveid[2]=0;                                                  //~v101I~
    buffsz=sizeof(buff);                                           //~v101R~
    pfsqb2=(void*)buff;                                            //~v101I~
    rc=DosQueryFSAttach(driveid,1,(ULONG)FSAIL_QUERYNAME,pfsqb2,&buffsz);//~v101R~
    if (rc)                                                        //~v101I~
    {                                                              //~v101I~
        ufileapierr("DosQueryFSAttach",driveid,(int)rc);           //~v101I~
        rc=4;                                                      //~v101I~
    }                                                              //~v101I~
    else                                                           //~v101I~
    {                                                              //~v101I~
        if (stricmp(buff+(8+pfsqb2->cbName+1),"HPFS"))             //~v101R~
            rc=0;                                                  //~v101I~
        else                                                       //~v101I~
            rc=1;                                                  //~v101I~
    }                                                              //~v101I~
    return (int)rc;                                                //~v101R~
}//ufileishpfs                                                     //~v101I~
#else   //not OS2                                                  //~v101I~
//*******************************************************          //~v101I~
//*ufileisvfat                                                     //~v101I~
//*parm  :option                                                   //~v120R~
//*ret   :rc: 0:FAT,1(VFAT)                                        //~v101R~
//*******************************************************          //~v101I~
int ufileisvfat(int Popt)                                          //~v120R~
{                                                                  //~v101I~
#ifdef DPMI                                                        //~v101I~
    int rc;                                                        //~v101I~
#endif                                                             //~v101I~
//*******************                                              //~v101I~
#ifdef W32                                                         //~v101I~
    return 1;                                                      //~v101I~
#else                                                              //~v101I~
    #ifdef DPMI                                                    //~v101I~
      if (Popt & ISVFAT_FORCE)                                     //~v120I~
        rc=_use_lfn("\\");  //force same_drive_as_last_time=0      //~v120I~
      else                                                         //~v120I~
        rc=(_USE_LFN!=0);                                          //~v101R~
        if (!rc && (Popt & ISVFAT_ERRMSG))                         //~v120R~
            ufilenotvfat();                                        //~v101I~
        return rc;                                                 //~v101I~
    #else                                                          //~v101I~
        if (Popt & ISVFAT_ERRMSG)                                  //~v120R~
            ufilenotvfat();                                        //~v101I~
        return 0;                                                  //~v101I~
    #endif                                                         //~v101I~
#endif                                                             //~v101I~
}//ufileisvfat                                                     //~v101I~
#endif //DOS,W32                                                   //~v101R~
                                                                   //~v5i0I~
//*******************************************************          //~v5i0I~
//*ufileisntfs                                                     //~v5i0I~
//*parm  :driveid cahr                                             //~v5i0I~
//*ret   :rc: 0:NOT NTFS, 1:NTFS, -1:err                           //~v5i0I~
//*******************************************************          //~v5i0I~
int ufileisntfs(int Pdriveletter)                                  //~v5i0I~
{                                                                  //~v5i0I~
#ifndef W32                                                        //~v5i0I~
    return 0;                                                      //~v5i0I~
#else                                                              //~v5i0I~
                                                                   //~v5i0I~
static char Sntfsidtbl[26];	//0:not yet chked,1:not ntfs,2:ntfs    //~v5i0I~
    char rootdir[4];                                               //~v5i0I~
    DWORD maxcomplen,systemflag,rc;                                //~v5i0I~
    int driveid,ntfsid;                                            //~v5i0I~
   	char fsname[32];                                               //~v5i0I~
//*******************                                              //~v5i0I~
	driveid=toupper(Pdriveletter)-'A';                             //~v5i0I~
    if (driveid<0||driveid>=sizeof(Sntfsidtbl))                    //~v5i0I~
    	return -1;		//parm err                                 //~v5i0I~
    if (driveid<2)      	//a: b: is floppy                      //+v5i0I~
    	return 0;                                                  //+v5i0I~
    ntfsid=Sntfsidtbl[driveid];                                    //~v5i0I~
    if (!ntfsid)	//not yet chked                                //~v5i0I~
    {                                                              //~v5i0I~
        rootdir[0]=Pdriveletter;                                   //~v5i0R~
        rootdir[1]=':';                                            //~v5i0I~
        rootdir[2]='\\';                                           //~v5i0I~
        rootdir[3]=0;                                              //~v5i0I~
      	rc=GetVolumeInformation(rootdir,   //c:\  etc              //~v5i0R~
                                NULL,   //volume name buff         //~v5i0I~
                                0,      //volume name buff len     //~v5i0I~
                                NULL,   //volume serial DWORD ptr  //~v5i0I~
                                &maxcomplen,	//pathname component length//~v5i0I~
                                &systemflag,	//system flag      //~v5i0I~
                                fsname,			//file system name "FAT","NTFS" etc//~v5i0I~
                                sizeof(fsname));                   //~v5i0I~
        if (!rc)	//failed                                       //~v5i0R~
        	return -(int)GetLastError();                           //~v5i0R~
        ntfsid=(strcmp(fsname,"NTFS")==0)+1;                       //~v5i0I~
	    Sntfsidtbl[driveid]=ntfsid;                                //~v5i0I~
//  	printf("root=%s,fs=%s,rc=%d,stat=%d\n",rootdir,fsname,rc,ntfsid);//~v5i0R~
    }                                                              //~v5i0I~
    return ntfsid-1;                                               //~v5i0I~
#endif                                                             //~v5i0I~
}//ufileisvfat                                                     //~v5i0I~
