//CID://+v321R~:                                                   //~v321R~
//*********************************************************************
//* common routine hdr                                             //~v021R~
//*********************************************************************
//v321 000729:UNIX support                                         //+v321R~
//v246:990620 disas:DOS MZ support                                 //~v246I~
//v131:971220 OSTYPE macro to ulibdef.h                            //~v131I~
//v053:970107:gcc version(control by DPMI)                         //~v053R~
//            -not used macro _CDECL                               //~v053I~
//            -change macro name FP_SEGOFF-->DOS_MAKE_FLAT to chck dos mem refer//~v053I~
//            -del macro name FLATADDR that is for 16:16 model     //~v053I~
//            -lack of function mkdir,memicmp etc                  //~v053I~
//v027:960917:dos dump sub                                         //~v027I~
//v021:960727:WIN32 BCC(_CDECL-->_cdecl)                           //~v021I~
//v001:960602 for MSC6,c2 define _CDECL cdecl,msc6 use _cdecl.     //~6602I~
//*********************************************************************//~6602I~
//* DEF MACRO *******************************

#ifdef UNX                                                         //~v321R~
    #include <ulibdef.h>		//UCHAR etc                        //~v321R~
#else                                                              //~v321R~
#ifdef DOS
    #ifdef C6                   //MS C6                            //~6706R~
        #define _CDECL _cdecl                                      //~6706R~
    #endif                                                         //~6706R~
    #ifdef DPMI                 //DPMI                             //~v053R~
        #define _CDECL                                             //~v053R~
    #endif                                                         //~v053I~
    #include <ulibdef.h>		//UCHAR etc                        //~v021I~

  #ifdef DPMI                                                      //~v053R~
    #include <udpmilib.h>		//c function not supported on libc.a//~v053I~
    #define DOS_MAKE_FLAT(Seg,Offset) (((Seg)<<4)+(Offset))        //~v053R~
  #else                                                            //~v053I~
   	#define FP_SEGOFF(Seg,Offset)							\
   				((PVOID)(((ULONG)Seg<<16)+(ULONG)(Offset)))
    #define FLATADDR(pc) (((ULONG)FP_SEG(pc)<<4)+(ULONG)FP_OFF(pc))//~v027M~
  #endif                                                           //~v053I~
#else                                                              //~v021I~
   	#define FP_SEGOFF(Seg,Offset)							\
   				((PVOID)(((ULONG)Seg<<16)+(ULONG)(Offset)))        //~v246I~
    #define FLATADDR(pc) (((ULONG)FP_SEG(pc)<<4)+(ULONG)FP_OFF(pc))//~v246I~
    #define DOS_MAKE_FLAT(Seg,Offset) ((ULONG)(((ULONG)(Seg)<<4)+(ULONG)(Offset)))//~v246I~
    #ifdef W32                   //WIN32 by BC                     //~v021I~
        #define _CDECL _cdecl                                      //~v021I~
        #define doserrno _doserrno                                 //~v021I~
                                                                   //~v021I~
		#include <ulibdef.h>		//UCHAR etc                    //~v021R~
    #else                           /*os2*/                        //~v021I~
//*for compiler warning when MSC_VER is used without unde ifdef W32//~v027I~
        #define _MSC_VER 0                                         //~v027I~
	    #ifndef __OS2_H__            //no os2.h     included       //~v021I~
		    #include <ulibdef.h>		//UCHAR etc                //~v021I~
	    #endif                                                     //~v021I~
    #endif                                                         //~v021M~
#endif
#endif   //!UNX                                                    //~v321R~
//* MCARO     ******************************
//*1 byte bit operation ***
#define UCBITCHK(uc,bit)		\
		(UCHAR)((uc) & (bit))                                   //~5225R~
#define UCBITON(uc,bit)		\
		uc=(UCHAR)((uc) | (bit))                                //~5225R~
#define UCBITOFF(uc,bit)		\
		uc=(UCHAR)((uc) & ~(bit))                               //~5225R~
#define UCBITXOR(uc,bit)		\
		uc=(UCHAR)((uc) ^ (bit))                                //~5225I~
//*2 byte bit operation ***                                     //~5110I~
#define USBITCHK(uc,bit)		\
		(USHORT)((uc) & (bit))                                  //~5225R~
#define USBITON(uc,bit)		\
		uc=(USHORT)((uc) | (bit))                               //~5225R~
#define USBITOFF(uc,bit)		\
		uc=(USHORT)((uc) & ~(bit))                              //~5225R~
#define USBITXOR(uc,bit)		\
		uc=(USHORT)((uc) ^ (bit))                               //~5225I~
//*4 byte bit operation ***                                     //~5110I~
#define ULBITCHK(uc,bit)		\
		(ULONG)((uc) & (bit))                                   //~5225R~
#define ULBITON(uc,bit)		\
		uc=(ULONG)((uc) | (bit))                                //~5225R~
#define ULBITOFF(uc,bit)		\
		uc=(ULONG)((uc) & ~(bit))                               //~5225R~
#define ULBITXOR(uc,bit)		\
		uc=(ULONG)((uc) ^ (bit))                                //~5225I~
//*1/2/4 byte move operation ***
#define UMOVSB(destptr,sourceptr)		\
		*((UCHAR *)(PVOID)(destptr))=*((UCHAR *)(PVOID)(sourceptr))
#define UMOVSW(destptr,sourceptr)		\
		*((USHORT *)(PVOID)(destptr))=*((USHORT *)(PVOID)(sourceptr))
#define UMOVSD(destptr,sourceptr)		\
		*((ULONG *)(PVOID)(destptr))=*((ULONG *)(PVOID)(sourceptr))
#define ISNUMSTR(str)                                   \
		(*(UCHAR*)(str) && strspn((UCHAR*)(str),"0123456789")==strlen((UCHAR*)(str)))//~5501R~
//*integer reverse load
#define  USTRLOAD(pstr)                            \
         ( ((*(ULONG*)(PVOID)(pstr)<<24))              \
          |((*(ULONG*)(PVOID)(pstr)<< 8) & 0x00ff0000) \
          |((*(ULONG*)(PVOID)(pstr)>> 8) & 0x0000ff00) \
          |((*(ULONG*)(PVOID)(pstr)>>24))              \
         )
//* DATA TYPE ******************************
//* FUNCTION *******************************
#include <ulibdefc.h>		//common for all version               //~v131I~
//* Global variable *********************************************
