//CID://+v5fkR~:                                                   //~v5fkR~
//*************************************************************
//*ustring.c 
//*  ustrncpyz                                                     //~v111I~
//*  ustrnpbrk/ustrnstr/ustrnspn                                //~4C21I~
//*  ustrrspn /ustrrspni /ustrstri /ustrrstri                   //~4C21R~
//*  ustrnrspn/ustrnrspni/ustrnstri/ustrnrstri				    //~4C21R~
//*  ustrchr2/ustrnchr2/ustrrchr2/ustrnrchr2                       //~v017I~
//*  ustrnlen                                                      //~v094R~
//*  umemrspn,umemrspnc,umemspnc                                   //~v097R~
//*  umemrchr/umemchr2/umemrchar2                                  //~v093R~
//*  umemmem/umemmemi/umemstr/umemstri                             //~v093M~
//*  umemrmem/umemrmemi/umemrstr/umemrstri                         //~v093I~
//*  umemrpbrk/umempbrk                                            //~v57sR~
//*************************************************************
//v5h4:051015 (BUG)umempbrk miss if delm in strdelm is adjacent    //+v5fkI~
//v5fk:050226 (BUG)unumlen abend by overrun end of string          //~v5fkI~
//v57s:030125 add umempbrk                                         //~v57sI~
//v517:011219 umemrchr performance up(for the case char continued,everytime//~v516I~
//            memchr called)                                       //~v516I~
//v516:011219 add umemrpblk;search last pos of char ins parm string//~v516I~
//v327 000820:LINUX support                                        //~v327I~
//v292:991029 no upper case search required when 1st char is case insensitive//~v292I~
//v111:971103 ustrncpyz strncpy gualantied with last null and only one null//~v111I~
//v098:970723 split uparse fro ustring to uparse.c                 //~v098I~
//v097:970720 umemspnc,umemrspnc                                   //~v097I~
//v094:970706 umemrspn(umemspn is same meaning as ustrnspn)        //~v094I~
//            ustrnrspn must trate parm1 as string                 //~v094I~
//v093:970706 (BUG)set null out of range may corrupt naboring area(ustrnchar2,ustrnrchr2)//~v093R~
//            and conbine to umemchar2,umemrchr2)                  //~v093I~
//v092:970705 umemmem/umemmemi/umemstr/umemstri/umemrmem/umemrmemi/umemrstr/umemrstri//~v092I~
//v091:970705 add ustrnlen(max n)                                  //~v091I~
//v088:970621 add umemrchr                                         //~v088I~
//v081:970503 (BUG)uparse rc=1 for case quate enclosed             //~v081I~
//v080:970503 add uparsein to enclabe string by quate for dlcmd to dcmd//~v080I~
//            ustring.c                                            //~v080I~
//v069:970330:uparsev(output by argv format)                       //~v069I~
//v053:970107:gcc version(control by DPMI)                         //~v053I~
//            -warning if mixed &&,||                              //~v053I~
//v046:961123:uparse2 no malloc output area option(malloc at out of function)//~v046I~
//           :uparse:malloc only when long string                  //~v046I~
//           :uparse:delm lost when pre/post space exist.          //~6B23R~
//                   add option to set delm except for ","         //~6B23R~
//v022:960727:WIN32(CONSOLE api)                                   //~v022I~
//v017:960714:add ustrchr2(strchr protecting detect dbcs 2nd byte) //~v017I~
//            add ustrnchr2=(ustrchr2 with length)                 //~v017I~
//            add ustrrchr2(search last char protecting detect dbcs 2nd byte)//~v017I~
//            add ustrnrchr2=(ustrrchr2 with length)               //~v017I~
//960324:(BUG)delm after quate("abc",vvv) cannot drop quate.    //~6324I~
//960324:uparse2:with delm/qaute return function                //~6324R~
//950930:malloc/calloc rc chk for dos                           //~5930I~
//*950503 bug loop when all space(quate init value set)         //~5430R~
//*950430 uparse delm tbl support                               //~5430R~
//*950307 uparse "" null string support                         //~5430I~
//************************************************************* //~5307I~
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
//*******************************************************
#ifdef UNX                                                         //~v327R~
	#include <ugcclib.h>                                           //~v327I~
#else   //!UNX                                                     //~v327R~
#ifdef DOS
#else
    #ifdef W32                                                     //~v022I~
	#else                                                          //~v022I~
//  #define INCL_BASE                                              //~v022R~
//  #include <os2.h>                                               //~v022R~
	#endif                                                         //~v022I~
#endif
#endif  //!UNX                                                     //~v327R~
//*******************************************************
#include <ulib.h>
#include <ustring.h>
#include <ualloc.h>
#include <udbcschk.h>                                              //~v017I~
//*******************************************************
//*******************************************************       //~4C19I~
//*ustring
//* dummy for LIB
//******************************************************
void ustring(void)
{
	return;
}//ustring

//*******************************************************       //~4C20I~
//*ustrnpbrk                                                    //~4C21R~
//* search first char which is on parm2 string                  //~4C21R~
//* parm1 :string to be serached                                //~4C20I~
//* parm2 :string specify check char string                     //~4C21R~
//* parm3 :parm1 len                                            //~4C20I~
//* return:pointer to the first char,null in not found          //~4C21R~
//******************************************************        //~4C20I~
char *ustrnpbrk(const char *Pbuff,const char *Pkey,unsigned int Plen)//~4C21R~
{                                                               //~4C20I~
	char ch,*pc,*pco,*pcl;                                      //~4C21R~
//******************                                            //~4C20I~
    Plen=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
    if (!Plen)                                                  //~4C20I~
    	return 0;                                               //~4C20I~
	if (strchr(Pkey,*(pc=(char*)(ULONG)Pbuff+Plen-1)))	//on parm2 //~v5fkR~
		pcl=pc;	//last cadidate                                 //~4C21R~
	else                                                        //~4C20I~
		pcl=0;                                                  //~4C21R~
	ch=*pc;				//save last byte                        //~4C20I~
	*pc=0;				//create string for ustrrspn            //~4C20I~
	pco=strpbrk(Pbuff,Pkey);                                    //~4C21R~
	*pc=ch;				//restore last byte                     //~4C20I~
	if (!pco)           //not founf                             //~4C21R~
		pco=pcl;                                                //~4C21R~
	return pco;                                                 //~4C21R~
}//ustrnpbrk                                                       //~v093R~
                                                                //~4C21I~
//*******************************************************       //~4C21I~
//*ustrnspn                                                     //~4C21I~
//* search first char which is not on parm2 string              //~4C21I~
//* parm1 :string to be serached                                //~4C21I~
//* parm2 :string specify exception char string                 //~4C21I~
//* parm3 :parm1 len                                            //~4C21I~
//* return:offset to the last char,length if all match          //~4C21I~
//******************************************************        //~4C21I~
size_t ustrnspn(const char *Pbuff,const char *Pxstr,unsigned int Plen)//~4C21I~
{                                                               //~4C21I~
	char ch,*pc;                                                //~4C21I~
	size_t  offs,offsl;                                         //~4C21I~
//******************                                            //~4C21I~
    Plen=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
    if (!Plen)                                                  //~4C21I~
    	return 0;                                               //~4C21I~
	if (!strchr(Pxstr,*(pc=(char*)(ULONG)Pbuff+Plen-1)))	//not on parm2//~v5fkR~
		offsl=Plen-1;	//last cadidate                         //~4C21I~
	else                                                        //~4C21I~
		offsl=Plen;                                             //~4C21I~
	ch=*pc;				//save last byte                        //~4C21I~
	*pc=0;				//create string for ustrrspn            //~4C21I~
	offs=strspn(Pbuff,Pxstr);                                   //~4C21I~
	*pc=ch;				//restore last byte                     //~4C21I~
	if (offs==Plen-1)                                           //~4C21I~
		offs=offsl;                                             //~4C21I~
	return offs;                                                //~4C21I~
}//ustrnspn                                                     //~4C21I~
                                                                //~4C20I~
//*******************************************************
//*ustrrspn
//* search last char which is not on parm2 string
//* parm1 :string to be serached
//* parm2 :string specify exception char string                 //~4C19R~
//* return:offset to the last char(-1 if not found)
//******************************************************
size_t ustrrspn(const char *Pbuff,const char *Pxstr)
{
	const char *pcb;
	size_t     lenb;
//******************
	lenb=strlen(Pbuff);
	pcb=Pbuff+lenb-1;		//last char
	while(lenb)
	{
		if (!strchr(Pxstr,*pcb))		//not found
			break;
		lenb--;
		pcb--;
	}
	return --lenb;
}//ustrrspn

//*******************************************************       //~4C20I~
//*ustrnrspn                                                    //~4C20I~
//* search last char which is not on parm2 string               //~4C20I~
//* parm1 :string to be serached                                //~4C20I~
//* parm2 :string specify exception char string                 //~4C20I~
//* parm3 :parm1 len                                            //~4C20I~
//* return:len of last span                                        //~v094R~
//******************************************************        //~4C20I~
size_t ustrnrspn(const char *Pbuff,const char *Pxstr,unsigned int Plen)//~4C20I~
{                                                               //~4C20I~
	const char *pcb;                                               //~v094R~
	size_t     lenb;                                            //~4C20I~
	size_t     span;                                               //~v094I~
//******************                                            //~4C20I~
//  lenb=Plen;                                                     //~v094R~
    lenb=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
	pcb=Pbuff+lenb-1;		//last char                         //~4C20I~
    span=0;                                                        //~v094I~
	while(lenb)                                                 //~4C20I~
	{                                                           //~4C20I~
		if (!strchr(Pxstr,*pcb))		//not found             //~4C20I~
			break;                                              //~4C20I~
		lenb--;                                                 //~4C20I~
		pcb--;                                                  //~4C20I~
        span++;                                                    //~v094I~
	}                                                           //~4C20I~
//  return --lenb;                                                 //~v094R~
    return span;                                                   //~v094I~
}//ustrnrspn                                                    //~4C20I~
                                                                //~4C20I~
//*******************************************************          //~v094I~
//*umemrspn                                                        //~v094I~
//* search last char which is not on parm2 string                  //~v094I~
//* parm1 :string to be serached                                   //~v094I~
//* parm2 :string specify exception char string                    //~v094I~
//* parm3 :parm1 len                                               //~v094I~
//* return:len of last span                                        //~v094I~
//******************************************************           //~v094I~
size_t umemrspn(char *Pbuff,char *Pxstr,unsigned int Plen)         //~v094I~
{                                                                  //~v094I~
	char *pcb;                                                     //~v094I~
	size_t     lenb,lenk,span=0;                                   //~v094I~
//******************                                               //~v094I~
	lenk=strlen(Pxstr);                                            //~v094I~
    lenb=Plen;                                                     //~v094I~
	pcb=Pbuff+lenb-1;		//last char                            //~v094I~
	while(lenb)                                                    //~v094I~
	{                                                              //~v094I~
		if (!memchr(Pxstr,*pcb,lenk))		//not found            //~v094I~
			break;                                                 //~v094I~
		lenb--;                                                    //~v094I~
		pcb--;                                                     //~v094I~
        span++;                                                    //~v094I~
	}                                                              //~v094I~
	return span;                                                   //~v094I~
}//umemrspn                                                        //~v094I~
                                                                   //~v094I~
//*******************************************************          //~v097I~
//*umemspnc                                                        //~v097I~
//* get span of char                                               //~v097I~
//* parm1 :area to be serached                                     //~v097I~
//* parm2 :char                                                    //~v097I~
//* parm3 :parm1 len                                               //~v097I~
//* return:span                                                    //~v097I~
//******************************************************           //~v097I~
size_t umemspnc(char *Pbuff,char Pchr,unsigned int Plen)           //~v097I~
{                                                                  //~v097I~
	char *pc,*pce;                                                 //~v097I~
//******************                                               //~v097I~
	for (pc=Pbuff,pce=Pbuff+Plen;pc<pce;pc++)                      //~v097I~
		if (*pc!=Pchr)                                             //~v097I~
			break;                                                 //~v097I~
	return (UINT)((ULONG)pc-(ULONG)Pbuff);                         //~v097I~
}//umemspnc                                                        //~v097I~
                                                                   //~v097I~
//*******************************************************          //~v097I~
//*umemrspnc                                                       //~v097I~
//* get span of char of last part of area                          //~v097I~
//* parm1 :area to be serached                                     //~v097I~
//* parm2 :char                                                    //~v097I~
//* parm3 :parm1 len                                               //~v097I~
//* return:span                                                    //~v097I~
//******************************************************           //~v097I~
size_t umemrspnc(char *Pbuff,char Pchr,unsigned int Plen)          //~v097I~
{                                                                  //~v097I~
	char *pc,*pce;                                                 //~v097R~
//******************                                               //~v097I~
	for (pce=pc=Pbuff+Plen-1;pc>=Pbuff;pc--)                       //~v097R~
		if (*pc!=Pchr)                                             //~v097I~
			break;                                                 //~v097I~
	return (UINT)((ULONG)pce-(ULONG)pc);                           //~v097R~
}//umemrspnc                                                       //~v097I~
                                                                   //~v097I~
//*******************************************************       //~4C20I~
//*ustrnstr                                                     //~4C20I~
//* search parm2 string on parm1 string                         //~4C20I~
//* parm1 :string to be serached                                //~4C20I~
//* parm2 :search key string                                    //~4C20I~
//* parm3 :parm1 len                                            //~4C20I~
//* return:pinter to string on parm1 string,or NULL if not found//~4C20I~
//*        return top addr if parm2 is null string              //~4C20I~
//******************************************************        //~4C20I~
char *ustrnstr(const char *Pbuff,const char *Pkey,unsigned int Plen)//~4C20I~
{                                                               //~4C20I~
	char *pc,*pco,*pcl;                                         //~4C20I~
	char ch;                                                    //~4C20I~
	unsigned int lenk;                                          //~4C20I~
//******************                                            //~4C20I~
    Plen=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
	if (!(lenk=strlen(Pkey)))                                   //~4C20I~
		return (char*)(ULONG)Pbuff;                                //~v5fkR~
    if (lenk>Plen)                                              //~4C20I~
    	return 0;                                               //~4C20I~
	if (memcmp(pcl=(char*)(ULONG)Pbuff+Plen-lenk,Pkey,lenk))	//match at last//~v5fkR~
		pcl=0;                           		//last unmatch  //~4C20I~
	ch=*(pc=(char*)(ULONG)Pbuff+Plen-1);	//save last byte       //~v5fkR~
	*pc=0;					//create string for ustrrspn        //~4C20I~
	pco=strstr(Pbuff,Pkey);                                     //~4C20I~
	*pc=ch;					//restore last byte                 //~4C20I~
	if (!pco)  				//not found                         //~4C20I~
		pco=pcl;          	//set result of last chk            //~4C20I~
	return pco;                                                 //~4C20I~
}//ustrnstr                                                     //~4C20I~
                                                                //~4C20I~
//*******************************************************       //~4C19I~
//*ustrrstr                                                     //~4C19I~
//* search last parm2 string on parm1 string                    //~4C19I~
//* parm1 :string to be serached                                //~4C19I~
//* parm2 :search key string                                    //~4C19I~
//* return:pinter to string on parm1 string,or NULL if not found//~4C19I~
//*        null char addr if parm2 is null char                 //~4C20I~
//******************************************************        //~4C19I~
char *ustrrstr(const char *Pbuff,const char *Pkey)              //~4C19I~
{                                                               //~4C19I~
	char *pc,*pco;                                              //~4C19I~
//******************                                            //~4C19I~
    if (!*Pkey)			//null key                              //~4C20I~
		return (char*)(ULONG)Pbuff+strlen(Pbuff);                  //~v5fkR~
	for (pco=0,pc=(char *)(ULONG)Pbuff;pc=strstr(pc,Pkey),pc;pc++) //~v5fkR~
		pco=pc;                                                 //~4C19I~
	return pco;                                                 //~4C19I~
}//ustrrstr                                                     //~4C19I~
                                                                //~4C19I~
//*******************************************************       //~4C20I~
//*ustrnrstr                                                    //~4C20I~
//* search last parm2 string on parm1 string                    //~4C20I~
//* parm1 :string to be serached                                //~4C20I~
//* parm2 :search key string                                    //~4C20I~
//* parm3 :parm1 length                                         //~4C20I~
//* return:pinter to string on parm1 string,or NULL if not found//~4C20I~
//*        null char addr if parm2 is null char                 //~4C20I~
//******************************************************        //~4C20I~
char *ustrnrstr(const char *Pbuff,const char *Pkey,unsigned int Plen)//~4C20I~
{                                                               //~4C20I~
	char *pc,*pco;                                              //~4C20I~
	char ch;                                                    //~4C20I~
	unsigned int lenk;                                          //~4C20I~
//******************                                            //~4C20I~
    Plen=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
	lenk=strlen(Pkey);                                          //~4C20I~
    if (lenk>Plen)                                              //~4C20I~
    	return 0;                                               //~4C20I~
	if (!memcmp(Pbuff+Plen-lenk,Pkey,lenk))	//match at last     //~4C20I~
		return (char*)(ULONG)Pbuff+Plen-lenk;                      //~v5fkR~
	ch=*(pc=(char*)(ULONG)Pbuff+Plen-1);	//save last byte       //~v5fkR~
	*pc=0;					//create string for ustrrspn        //~4C20I~
	pco=ustrrstr(Pbuff,Pkey);                                   //~4C20I~
	*pc=ch;					//restore last byte                 //~4C20I~
	return pco;                                                 //~4C20I~
}//ustrnrstr                                                    //~4C20I~
                                                                //~4C20I~
//*******************************************************       //~4C19I~
//*ustrstri                                                     //~4C19I~
//* search parm2 string on parm1 string by case insensitive     //~4C19I~
//* parm1 :string to be serached                                //~4C19I~
//* parm2 :search key string                                    //~4C19I~
//* return:pinter to string on parm1 string,or NULL if not found//~4C19I~
//*        null char addr if parm2 is null char                 //~4C20I~
//******************************************************        //~4C19I~
char *ustrstri(const char *Pbuff,const char *Pkey)              //~4C19I~
{                                                               //~4C19I~
	char topchar[3];                                            //~4C19I~
	char *pc,*pce;                                              //~4C19I~
	int  lenk;                                                  //~4C19I~
//******************                                            //~4C19I~
	topchar[0]=(char)toupper(*Pkey);                            //~4C19I~
	topchar[1]=(char)tolower(*Pkey);                            //~4C19I~
	topchar[2]=0;                                               //~4C19I~
	if (!(lenk=(int)strlen(Pkey)))                              //~4C20R~
      	return (char*)(ULONG)Pbuff+strlen(Pbuff);                  //~v5fkR~
	for (pc=(char *)(ULONG)Pbuff,pce=(char *)(ULONG)Pbuff+strlen(Pbuff)-lenk;//~v5fkR~
		 (pc=strpbrk(pc,topchar),pc) && pc<=pce;)      //~4C19I~
	{                                                           //~4C19I~
		if (!memicmp(pc,(char*)(ULONG)Pkey,(UINT)lenk))//match case insensitive//~v5fkR~
 			break;                                              //~4C19I~
		if (++pc>pce)                                           //~4C19I~
    		break;
	}                                                           //~4C19I~
	if (pc>pce)                                           //~4C19I~
    	pc=0;                                              //~4C19I~
	return pc;                                                  //~4C19I~
}//ustrstri                                                     //~4C19R~
                                                                //~4C19I~
//*******************************************************       //~4C20I~
//*ustrnstri                                                    //~4C20I~
//* search parm2 string on parm1 string by case insensitive     //~4C20I~
//* parm1 :string to be serached                                //~4C20I~
//* parm2 :search key string                                    //~4C20I~
//* parm3 :parm1 string len                                     //~4C20I~
//* return:pinter to string on parm1 string,or NULL if not found//~4C20I~
//*        null char addr if parm2 is null char                 //~4C20I~
//******************************************************        //~4C20I~
char *ustrnstri(const char *Pbuff,const char *Pkey,unsigned int Plen)//~4C20I~
{                                                               //~4C20I~
	char *pc,*pco,*pcl;                                         //~4C20I~
	char ch;                                                    //~4C20I~
	unsigned int lenk;                                          //~4C20I~
//******************                                            //~4C20I~
    Plen=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
	lenk=strlen(Pkey);                                          //~4C20I~
    if (lenk>Plen)                                              //~4C20I~
    	return 0;                                               //~4C20I~
	if (memicmp(pcl=(char*)(ULONG)Pbuff+Plen-lenk,(char*)(ULONG)Pkey,lenk))	//not match at last//~v5fkR~
		pcl=0;                           		//last unmatch  //~4C20I~
	ch=*(pc=(char*)(ULONG)Pbuff+Plen-1);	//save last byte       //~v5fkR~
	*pc=0;					//create string for ustrrspn        //~4C20I~
	pco=ustrstri(Pbuff,Pkey);                                   //~4C20I~
	*pc=ch;					//restore last byte                 //~4C20I~
	if (!pco)  				//not found                         //~4C20I~
		pco=pcl;          	//set result of last chk            //~4C20I~
	return pco;                                                 //~4C20I~
}//ustrnstri                                                    //~4C20I~
                                                                //~4C20I~
//*******************************************************       //~4C19I~
//*ustrrstri                                                    //~4C19I~
//* search last parm2 string on parm1 string  case insensitve   //~4C19I~
//* parm1 :string to be serached                                //~4C19I~
//* parm2 :search key string                                    //~4C19I~
//* return:pinter to string on parm1 string,or NULL if not found//~4C19I~
//*        null char addr if parm2 is null char                 //~4C20I~
//******************************************************        //~4C19I~
char *ustrrstri(const char *Pbuff,const char *Pkey)             //~4C19I~
{                                                               //~4C19I~
	char *pc,*pco;                                              //~4C19I~
//******************                                            //~4C19I~
    if (!*Pkey)			//null key                              //~4C20I~
		return (char*)(ULONG)Pbuff+strlen(Pbuff);                  //~v5fkR~
	for (pco=0,pc=(char *)(ULONG)Pbuff;pc=ustrstri(pc,Pkey),pc;pc++)//~v5fkR~
		pco=pc;                                                 //~4C19I~
	return pco;                                                 //~4C19I~
}//ustrrstri                                                    //~4C19I~
                                                                //~4C19I~
//*******************************************************       //~4C19I~
//*ustrnrstri                                                   //~4C19I~
//* search last parm2 string on parm1 string  case insensitve   //~4C19I~
//* parm1 :string to be serached                                //~4C19I~
//* parm2 :search key string                                    //~4C19I~
//* parm3 :parm1 len                                            //~4C19I~
//* return:pinter to string on parm1 string,or NULL if not found//~4C19I~
//*        null char addr if parm2 is null char                 //~4C20I~
//******************************************************        //~4C19I~
char *ustrnrstri(const char *Pbuff,const char *Pkey,unsigned int Plen)//~4C19I~
{                                                               //~4C19I~
	char *pc,*pco;                                              //~4C20R~
	char ch;                                                    //~4C20I~
	unsigned int lenk;                                          //~4C20I~
//******************                                            //~4C20I~
    Plen=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
	lenk=strlen(Pkey);                                          //~4C20I~
    if (lenk>Plen)                                              //~4C20I~
    	return 0;                                               //~4C20I~
	if (!memicmp((char*)(ULONG)Pbuff+Plen-lenk,(char*)(ULONG)Pkey,lenk))//match at last//~v5fkR~
		return (char*)(ULONG)Pbuff+Plen-lenk;                      //~v5fkR~
	ch=*(pc=(char*)(ULONG)Pbuff+Plen-1);	//save last byte       //~v5fkR~
	*pc=0;					//create string for ustrrspn        //~4C20I~
	pco=ustrrstri(Pbuff,Pkey);                                  //~4C20R~
	*pc=ch;					//restore last byte                 //~4C20I~
	return pco;                                                 //~4C20I~
}//ustrnrstri                                                   //~4C20R~
                                                                //~4C19I~
//*******************************************************       //~4C23I~
//*ustrnrchr                                                    //~4C23R~
//* search last char on parm1                                   //~4C23I~
//* parm1 :string to be checked                                 //~4C23I~
//* parm2 :search key char                                      //~4C23I~
//* parm3 :parm1 len                                            //~4C23I~
//* return:pinter to char on parm1 string,or NULL if not found  //~4C23I~
//*        NULL return if parm1 len=0                           //~4C23I~
//******************************************************        //~4C23I~
char *ustrnrchr(const char *Pbuff,UCHAR Pch,size_t Plen)        //~4C23R~
{                                                               //~4C23I~
	char *pc,*pco;                                              //~4C23I~
	char ch;                                                    //~4C23I~
//******************                                            //~4C23I~
    Plen=ustrnlen((char*)(ULONG)Pbuff,Plen);                       //~v5fkR~
	if (!Plen)                                                  //~4C23I~
		return 0;                                               //~4C23I~
    ch=*(pc=(char*)(ULONG)Pbuff+Plen-1);		//save char        //~v5fkR~
   	if (ch==Pch)                                                //~4C23I~
		return pc;                                              //~4C23I~
	*pc=0;                                                      //~4C23I~
    pco=strrchr(Pbuff,Pch);                                     //~4C23I~
	*pc=ch;			//restore                                   //~4C23I~
	if (Pch)		//not null search                           //~4C23I~
		return pco;                                             //~4C23I~
	else 			//null search                               //~4C23I~
		if (pco==pc)		//match with replaced char          //~4C23I~
			if (ch)			//original is not null              //~4C23I~
				return 0;                                       //~4C23I~
			else                                                //~4C23I~
				return pc;                                      //~4C23I~
		else                                                    //~4C23I~
			return pco;                                         //~4C23I~
}//ustrnrchr                                                    //~4C23R~
                                                                //~4C23I~
//*******************************************************          //~v017I~
//*ustrchr2                                                        //~v017I~
//* search SBCS char protecting to detect DBCS 2nd byte            //~v017I~
//* parm1 :string to be checked                                    //~v017I~
//* parm2 :search key SBCS char                                    //~v017I~
//* return:pinter to char on parm1 string,or NULL if not found     //~v017I~
//*        NULL return if parm1 len=0                              //~v017I~
//******************************************************           //~v017I~
char *ustrchr2(char *Pbuff,char Pch)                               //~v017I~
{                                                                  //~v017I~
	char *pc,*pc2;                                                 //~v017I~
//*********************************                                //~v017I~
	if (pc=strchr(Pbuff,Pch),!pc)                                  //~v022R~
    	return 0;                                                  //~v017I~
  	if (pc==Pbuff  //first byte match                              //~v017I~
    ||  !udbcschk((unsigned char)(*(pc-1))))  //prev is not dbcs 1st byte//~v022R~
    	return pc;                                                 //~v017I~
	pc2=Pbuff+strlen(Pbuff);	//end addr                         //~v017I~
	for (pc=Pbuff;pc<pc2;pc++)                                     //~v017I~
    {                                                              //~v017I~
    	if (*pc==Pch)                                              //~v017I~
        	return pc;			//found                            //~v017I~
		if (udbcschk(*pc))	//dbcs 1st byte                        //~v017I~
    		pc++;                                                  //~v017I~
	}                                                              //~v017I~
	return 0;                                                      //~v017I~
}//ustrchr2                                                        //~v017I~
                                                                   //~v017I~
//*******************************************************          //~v017I~
//*ustrnchr2                                                       //~v017I~
//* search SBCS char protecting to detect DBCS 2nd byte with length//~v017I~
//* parm1 :string to be checked                                    //~v017I~
//* parm2 :search key SBCS char                                    //~v017I~
//* parm3 :str length                                              //~v017I~
//* return:pinter to char on parm1 string,or NULL if not found     //~v017I~
//*        NULL return if parm1 len=0                              //~v017I~
//******************************************************           //~v017I~
char *ustrnchr2(char *Pbuff,char Pch,size_t Plen)                  //~v093R~
{                                                                  //~v017I~
//  char pch,ch,*pc;                                               //~v093R~
//  int plen;                                                      //~v093R~
//*********************************                                //~v017I~
//  plen=Plen;			//to protect destroyed by 0 set following  //~v093R~
//  pch=Pch;			//to protect destroyed by 0 set following  //~v093R~
//  ch=*(Pbuff+plen);	//save for 0                               //~v093R~
//  *(Pbuff+plen)=0;                                               //~v093R~
//  pc=ustrchr2(Pbuff,pch);                                        //~v093R~
//  *(Pbuff+plen)=ch;                                              //~v093R~
//  return pc;                                                     //~v093I~
	return umemchr2(Pbuff,Pch,ustrnlen(Pbuff,Plen));               //~v093R~
}//ustrnchr2                                                       //~v017I~
                                                                   //~v017I~
//*******************************************************          //~v093I~
//*umemchr2                                                        //~v093I~
//* search SBCS char protecting to detect DBCS 2nd byte with length//~v093I~
//* parm1 :string to be checked                                    //~v093I~
//* parm2 :search key SBCS char                                    //~v093I~
//* parm3 :mem length                                              //~v093I~
//* return:pinter to char on parm1 string,or NULL if not found     //~v093I~
//*        NULL return if parm1 len=0                              //~v093I~
//******************************************************           //~v093I~
char *umemchr2(char *Pbuff,char Pch,size_t Plen)                   //~v093R~
{                                                                  //~v093I~
	char *pc,*pc2;                                                 //~v093I~
//*********************************                                //~v093I~
	if (pc=memchr(Pbuff,Pch,(UINT)Plen),!pc)                       //~v093I~
    	return 0;                                                  //~v093I~
  	if (pc==Pbuff  //first byte match                              //~v093I~
    ||  !udbcschk((unsigned char)(*(pc-1))))  //prev is not dbcs 1st byte//~v093I~
    	return pc;                                                 //~v093I~
	pc2=Pbuff+Plen;	//end addr                                     //~v093I~
	for (pc=Pbuff;pc<pc2;pc++)                                     //~v093I~
    {                                                              //~v093I~
    	if (*pc==Pch)                                              //~v093I~
        	return pc;			//found                            //~v093I~
		if (udbcschk(*pc))	//dbcs 1st byte                        //~v093I~
    		pc++;                                                  //~v093I~
	}                                                              //~v093I~
	return 0;                                                      //~v093I~
}//umemchr2                                                        //~v093I~
                                                                   //~v093I~
//*******************************************************          //~v017I~
//*ustrrchr2                                                       //~v017I~
//* search last SBCS char protecting to detect DBCS 2nd byte       //~v017I~
//* parm1 :string to be checked                                    //~v017I~
//* parm2 :search key SBCS char                                    //~v017I~
//* return:pinter to char on parm1 string,or NULL if not found     //~v017I~
//*        NULL return if parm1 len=0                              //~v017I~
//******************************************************           //~v017I~
char *ustrrchr2(char *Pbuff,char Pch)                              //~v017R~
{                                                                  //~v017I~
	char *pc,*pc2,*pc3;                                            //~v017R~
//*********************************                                //~v017I~
	if (pc=strrchr(Pbuff,(int)Pch),!pc)                            //~v022R~
    	return 0;                                                  //~v017I~
  	if (pc==Pbuff  //first byte match                              //~v017I~
    ||  !udbcschk(*(pc-1)))  //prev is not dbcs 1st byte           //~v017I~
    	return pc;                                                 //~v017I~
	pc2=pc;		//end addr                                         //~v017I~
	for (pc=Pbuff,pc3=0;pc<=pc2;pc++)                              //~v017R~
    {                                                              //~v017I~
    	if (*pc==Pch)                                              //~v017I~
        	pc3=pc;			//last match                           //~v017I~
		if (udbcschk(*pc))	//dbcs 1st byte                        //~v017I~
    		pc++;                                                  //~v017I~
	}                                                              //~v017I~
    return pc3;                                                    //~v017R~
}//ustrrchr2                                                       //~v017I~
                                                                   //~v017I~
//*******************************************************          //~v017I~
//*ustrnrchr2                                                      //~v017I~
//* search last SBCS char protecting to detect DBCS 2nd byte with length//~v017I~
//* parm1 :string to be checked                                    //~v017I~
//* parm2 :search key SBCS char                                    //~v017I~
//* parm3 :str length                                              //~v017I~
//* return:pinter to char on parm1 string,or NULL if not found     //~v017I~
//*        NULL return if parm1 len=0                              //~v017I~
//******************************************************           //~v017I~
char *ustrnrchr2(char *Pbuff,char Pch,size_t Plen)                 //~v093R~
{                                                                  //~v017I~
//  char pch,ch,*pc;                                               //~v093R~
//  int plen;                                                      //~v093R~
//*********************************                                //~v017I~
//  plen=Plen;			//to protect destroyed by 0 set following  //~v093R~
//  pch=Pch;			//to protect destroyed by 0 set following  //~v093R~
//  ch=*(Pbuff+plen);	//save for 0                               //~v093R~
//  *(Pbuff+plen)=0;                                               //~v093R~
//  pc=ustrrchr2(Pbuff,pch);                                       //~v093R~
//  *(Pbuff+plen)=ch;                                              //~v093R~
//  return pc;                                                     //~v093R~
	return umemchr2(Pbuff,Pch,ustrnlen(Pbuff,Plen));               //~v093I~
}//ustrnrchr2                                                      //~v017I~
                                                                   //~v017I~
//*******************************************************          //~v093I~
//*umemrchr2                                                       //~v093I~
//* search last SBCS char protecting to detect DBCS 2nd byte with length//~v093I~
//* parm1 :string to be checked                                    //~v093I~
//* parm2 :search key SBCS char                                    //~v093I~
//* parm3 :mem length                                              //~v093I~
//* return:pinter to char on parm1 string,or NULL if not found     //~v093I~
//*        NULL return if parm1 len=0                              //~v093I~
//******************************************************           //~v093I~
char *umemrchr2(char *Pbuff,char Pch,size_t Plen)                  //~v093R~
{                                                                  //~v093I~
	char *pc,*pc2,*pc3;                                            //~v093I~
//*********************************                                //~v093I~
	if (!memchr(Pbuff,(int)Pch,(UINT)Plen))                        //~v093I~
    	return 0;                                                  //~v093I~
	pc2=Pbuff+Plen;		//end addr                                 //~v093I~
	for (pc=Pbuff,pc3=0;pc<pc2;pc++)                               //~v093I~
    {                                                              //~v093I~
    	if (*pc==Pch)                                              //~v093I~
        	pc3=pc;			//last match                           //~v093I~
		if (udbcschk(*pc))	//dbcs 1st byte                        //~v093I~
    		pc++;                                                  //~v093I~
	}                                                              //~v093I~
    return pc3;                                                    //~v093I~
}//umemrchr2                                                       //~v093I~
                                                                   //~v093I~
//*******************************************************          //~v088I~
//*umemrchr                                                        //~v088I~
//* search last char on parm1                                      //~v088I~
//* parm1 :buff to be checked                                      //~v088I~
//* parm2 :search key char                                         //~v088I~
//* parm3 :parm1 len                                               //~v088I~
//* return:pointer to char on parm1,or NULL if not found           //~v088I~
//*        NULL return if parm1 len=0                              //~v088I~
//******************************************************           //~v088I~
char *umemrchr(char *Pbuff,UCHAR Pch,size_t Plen)                  //~v088I~
{                                                                  //~v088I~
//    char *pc,*pco;                                               //~v516R~
//    UINT len;                                                    //~v516R~
////******************                                             //~v516R~
//    for (pco=0,pc=Pbuff,len=Plen;len;)                           //~v516R~
//    {                                                            //~v516R~
//        if (!(pc=memchr(pc,Pch,len)))                            //~v516R~
//            return pco;                                          //~v516R~
//        pco=pc;                                                  //~v516R~
//        pc++;                                                    //~v516R~
//        len=Plen-(UINT)((ULONG)pc-(ULONG)Pbuff);                 //~v516R~
//    }                                                            //~v516R~
//    return pco;                                                  //~v516R~
	UCHAR *pc;                                                     //~v516I~
//******************                                               //~v516I~
	for (pc=Pbuff+Plen-1;pc>=(UCHAR*)Pbuff;pc--)                   //~v516R~
    {                                                              //~v516I~
    	if (*pc==Pch)                                              //~v516I~
        	return pc;                                             //~v516I~
	}                                                              //~v516I~
    return 0;                                                      //~v516I~
}//umemrchr                                                        //~v088I~
                                                                   //~v088I~
//*******************************************************          //~v57sI~
//*umempbrk                                                        //~v57sI~
//* search pos of char on parm string                              //~v57sI~
//* parm1 :buff to be checked                                      //~v57sI~
//* parm2 :search char string                                      //~v57sI~
//* parm3 :parm1 len                                               //~v57sI~
//* return:pointer to char on parm1,or NULL if not found           //~v57sI~
//*        NULL return if parm1 len=0                              //~v57sI~
//******************************************************           //~v57sI~
char *umempbrk(char *Pbuff,UCHAR *Pstr,size_t Plen)                //~v57sR~
{                                                                  //~v57sI~
	char *pcb,*pcs,*pcbn,*pco=0;                                   //~v57sI~
    UINT len;                                                      //~v57sI~
//******************                                               //~v57sI~
	pcb=Pbuff;                                                     //~v57sI~
    len=Plen;                                                      //~v57sI~
//  for (pcs=Pstr;*pcs && len;pcs++)                               //~v5fkR~
    for (pcs=Pstr;len && *pcs;pcs++)                               //~v5fkI~
    {                                                              //~v57sI~
    	if (pcbn=memchr(pcb,*pcs,len),pcbn)                        //~v57sR~
        {                                                          //~v57sI~
			pco=pcbn;                                              //~v57sI~
            if (pcbn==pcb)  //fopund at top                        //~v57sI~
            	break;                                             //~v57sM~
//      	len=(ULONG)pco-(ULONG)pcb-1;                           //+v5fkR~
        	len=(ULONG)pco-(ULONG)pcb;                             //+v5fkI~
        }                                                          //~v57sI~
	}                                                              //~v57sI~
    return pco;                                                    //~v57sI~
}//umempbrk                                                        //~v57sR~
                                                                   //~v57sI~
//*******************************************************          //~v516I~
//*umemrpbrk                                                       //~v516I~
//* search last pos of char on parm string                         //~v516I~
//* parm1 :buff to be checked                                      //~v516I~
//* parm2 :search char string                                      //~v516I~
//* parm3 :parm1 len                                               //~v516I~
//* return:pointer to char on parm1,or NULL if not found           //~v516I~
//*        NULL return if parm1 len=0                              //~v516I~
//******************************************************           //~v516I~
char *umemrpbrk(char *Pbuff,UCHAR *Pstr,size_t Plen)               //~v516I~
{                                                                  //~v516I~
	char *pcb,*pcs,*pcbn,*pco=0,*pce;                              //~v516R~
    UINT len;                                                      //~v516I~
//******************                                               //~v516I~
	pcb=Pbuff;                                                     //~v516I~
    pce=pcb+Plen;		//end addr                                 //~v516I~
    len=Plen;                                                      //~v516I~
//  for (pcs=Pstr;*pcs && len;pcs++)                               //~v5fkR~
    for (pcs=Pstr;len && *pcs;pcs++)                               //~v5fkI~
    {                                                              //~v516I~
    	if (pcbn=umemrchr(pcb,*pcs,len),pcbn)                      //~v516R~
        {                                                          //~v516I~
			pco=pcbn;                                              //~v516R~
        	pcb=pcbn+1;                                            //~v516R~
        	len=(ULONG)pce-(ULONG)pcb;                             //~v516I~
        }                                                          //~v516I~
	}                                                              //~v516I~
    return pco;                                                    //~v516I~
}//umemrpbrk                                                       //~v516I~
                                                                   //~v516I~
//*******************************************************          //~v091I~
//*ustrnlen                                                        //~v091I~
//* strlen but max is up to parm                                   //~v091I~
//* parm1 :string to be serached null                              //~v091I~
//* parm2 :string max len                                          //~v091I~
//* return:len                                                     //~v091I~
//******************************************************           //~v091I~
size_t ustrnlen(char *Pbuff,unsigned int Plen)                     //~v091I~
{                                                                  //~v091I~
	char *pc;                                                      //~v091R~
//******************                                               //~v091I~
	pc=memchr(Pbuff,0,Plen);                                       //~v091R~
	if (!pc)	//not found                                        //~v091R~
    	return Plen;                                               //~v091I~
	return (UINT)((ULONG)pc-(ULONG)Pbuff);                         //~v091R~
}//ustrnlen                                                        //~v091I~
                                                                   //~v091I~
//*******************************************************          //~v092I~
//*umemstr                                                         //~v092I~
//* search string parm2 on mem parm1                               //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key string case sensitive                        //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemstr(char *Pbuff,char *Pkey,unsigned int Plen)            //~v092I~
{                                                                  //~v092I~
//******************                                               //~v092I~
	return umemmem(Pbuff,Pkey,Plen,strlen(Pkey));                  //~v092I~
}//umemstr                                                         //~v092I~
                                                                   //~v092I~
//*******************************************************          //~v092I~
//*umemstri                                                        //~v092I~
//* search string parm2 on mem parm1                               //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key string case insensitiv                       //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemstri(char *Pbuff,char *Pkey,unsigned int Plen)           //~v092I~
{                                                                  //~v092I~
//******************                                               //~v092I~
	return umemmemi(Pbuff,Pkey,Plen,strlen(Pkey));                 //~v092I~
}//umemstri                                                        //~v092I~
                                                                   //~v092I~
//*******************************************************          //~v092I~
//*umemrstr                                                        //~v092I~
//* search string parm2 on mem parm1                               //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key string case sensitive from last              //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemrstr(char *Pbuff,char *Pkey,unsigned int Plen)           //~v092I~
{                                                                  //~v092I~
//******************                                               //~v092I~
	return umemrmem(Pbuff,Pkey,Plen,strlen(Pkey));                 //~v092I~
}//umemrstr                                                        //~v093R~
                                                                   //~v092I~
//*******************************************************          //~v092I~
//*umemrstri                                                       //~v092I~
//* search string parm2 on mem parm1                               //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key string case insensitiv from last             //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemrstri(char *Pbuff,char *Pkey,unsigned int Plen)          //~v092I~
{                                                                  //~v092I~
//******************                                               //~v092I~
	return umemrmemi(Pbuff,Pkey,Plen,strlen(Pkey));                //~v092I~
}//umemrstri                                                       //~v092I~
                                                                   //~v092I~
//*******************************************************          //~v092I~
//*umemmem                                                         //~v092I~
//* search mem parm2 on mem parm1                                  //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key case sensitive                               //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* parm4 :parm2 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemmem(char *Pbuff,char *Pkey,unsigned int Plen,unsigned int Plenk)//~v092I~
{                                                                  //~v092I~
	char *pc,*pce,top;                                             //~v092R~
	unsigned int len;                                              //~v092I~
//******************                                               //~v092I~
	if (!Plenk)                                                    //~v092I~
		return Pbuff;                                              //~v092I~
	top=*Pkey;                                                     //~v092I~
    pc=Pbuff;                                                      //~v092R~
    pce=Pbuff+Plen;                                                //~v092I~
    for (;;)                                                       //~v092R~
    {                                                              //~v092I~
        len=((ULONG)pce-(ULONG)pc);                                //~v092I~
    	pc=memchr(pc,top,len);                                     //~v092R~
        if (!pc)                                                   //~v092I~
        	break;                                                 //~v092I~
		if (pc+Plenk>pce)                                          //~v092R~
            return 0;                                              //~v092I~
		if (!memcmp(pc,Pkey,Plenk))                                //~v093R~
        	break;                                                 //~v092R~
    	pc++;                                                      //~v092I~
	}                                                              //~v092I~
	return pc;                                                     //~v092R~
}//umemmem                                                         //~v092I~
                                                                   //~v092I~
//*******************************************************          //~v092I~
//*umemmemi                                                        //~v092I~
//* search parm2 string on parm1 storage                           //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key case insensitive                             //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* parm4 :parm2 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemmemi(char *Pbuff,char *Pkey,unsigned int Plen,unsigned int Plenk)//~v092I~
{                                                                  //~v092I~
	unsigned char *pc,*pce,topl,topu,*pcu;                         //~v092R~
	unsigned int len;                                              //~v092I~
//******************                                               //~v092I~
	if (!Plenk)                                                    //~v092I~
		return Pbuff;                                              //~v092I~
	topu=(UCHAR)toupper((int)*Pkey);                               //~v092I~
	topl=(UCHAR)tolower((int)*Pkey);                               //~v092I~
    pce=Pbuff+Plen;                                                //~v092I~
    pc=Pbuff;                                                      //~v092I~
//search by upper                                                  //~v092I~
    for (;;)                                                       //~v092I~
    {                                                              //~v092I~
        len=(ULONG)pce-(ULONG)pc;                                  //~v092I~
    	if (pc=memchr(pc,topu,len),!pc)                            //~v092R~
	    	break;                                                 //~v092I~
        if (pc+Plenk>pce)                                          //~v092R~
        {                                                          //~v092I~
            pc=0;                                                  //~v092I~
            break;                                                 //~v092I~
        }                                                          //~v092I~
		if (!memicmp(pc,Pkey,Plenk))	//found                    //~v092I~
	    	break;                                                 //~v092I~
    	pc++;                                                      //~v092I~
	}                                                              //~v092I~
//serach by lower                                                  //~v092I~
	pcu=pc;                                                        //~v092I~
    if (topu==topl)     //top is case insensitive                  //~v292I~
        return pcu;     //not required by lower case               //~v292I~
	if (pcu)				//found                                //~v092I~
    	pce=pcu+Plenk;                                             //~v092I~
    pc=Pbuff;                                                      //~v092R~
    for (;;)                                                       //~v092I~
    {                                                              //~v092I~
        len=(ULONG)pce-(ULONG)pc;                                  //~v092I~
    	if (pc=memchr(pc,topl,len),!pc)                            //~v092R~
	    	break;                                                 //~v092I~
    	if (pc+Plenk>pce)                                          //~v092R~
        {                                                          //~v092I~
            pc=0;                                                  //~v092I~
        	break;                                                 //~v092I~
        }                                                          //~v092I~
		if (!memicmp(pc,Pkey,Plenk))                               //~v092I~
        	break;                                                 //~v092I~
    	pc++;                                                      //~v092I~
	}                                                              //~v092I~
    if (pc)                                                        //~v092I~
    	return pc;                                                 //~v092I~
	else                                                           //~v092I~
    	return pcu;                                                //~v092I~
}//umemmemi                                                        //~v092I~
                                                                   //~v092I~
//*******************************************************          //~v092I~
//*umemrmem                                                        //~v092I~
//* search mem parm2 on mem parm1                                  //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key case sensitive reverse search                //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* parm4 :parm2 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemrmem(char *Pbuff,char *Pkey,unsigned int Plen,unsigned int Plenk)//~v092I~
{                                                                  //~v092I~
	char *pc,*pce,*pcl,top;                                        //~v092R~
	unsigned int len;                                              //~v092I~
//******************                                               //~v092I~
	if (!Plenk)                                                    //~v092I~
		return Pbuff;                                              //~v092I~
	top=*Pkey;                                                     //~v092I~
    pc=Pbuff;                                                      //~v092R~
    pce=Pbuff+Plen;                                                //~v092I~
    pcl=0;				//last found                               //~v092R~
    for (;;)                                                       //~v092R~
    {                                                              //~v092I~
        len=(ULONG)pce-(ULONG)pc;                                  //~v092I~
    	pc=memchr(pc,top,len);                                     //~v092R~
        if (!pc)                                                   //~v092I~
        	break;                                                 //~v092I~
		if (pc+Plenk>pce)                                          //~v092R~
        	break;                                                 //~v092I~
		if (!memcmp(pc,Pkey,Plenk))                                //~v093R~
        	pcl=pc;                                                //~v092I~
    	pc++;                                                      //~v092I~
	}                                                              //~v092I~
	return pcl;                                                    //~v092I~
}//umemrmem                                                        //~v093R~
                                                                   //~v092I~
//*******************************************************          //~v092I~
//*umemrmemi                                                       //~v092I~
//* search parm2 string on parm1 storage                           //~v092I~
//* parm1 :mem                                                     //~v092I~
//* parm2 :search key case insensitive reverse search              //~v092I~
//* parm3 :parm1 len                                               //~v092I~
//* parm4 :parm2 len                                               //~v092I~
//* return:pointer to mem on parm1,or NULL if not found            //~v092I~
//*        return top addr if parm2 len=0                          //~v092I~
//******************************************************           //~v092I~
char *umemrmemi(char *Pbuff,char *Pkey,unsigned int Plen,unsigned int Plenk)//~v092I~
{                                                                  //~v092I~
	unsigned char *pc,*pce,*pcl,topl,topu;                         //~v092R~
	unsigned int len;                                              //~v092I~
//******************                                               //~v092I~
	if (!Plenk)                                                    //~v092I~
		return Pbuff;                                              //~v092I~
	topu=(UCHAR)toupper((int)*Pkey);                               //~v092I~
	topl=(UCHAR)tolower((int)*Pkey);                               //~v092I~
    pc=Pbuff;                                                      //~v092I~
    pce=Pbuff+Plen;                                                //~v092I~
    pcl=0;                                                         //~v092I~
//search by upper                                                  //~v092I~
    for (;;)                                                       //~v092R~
    {                                                              //~v092I~
        len=(ULONG)pce-(ULONG)pc;                                  //~v092I~
    	if (pc=memchr(pc,topu,len),!pc)                            //~v092R~
	       	break;                                                 //~v092R~
		if (pc+Plenk>pce)                                          //~v092R~
        	break;                                                 //~v092I~
		if (!memicmp(pc,Pkey,Plenk))                               //~v093R~
        	pcl=pc;                                                //~v092I~
    	pc++;                                                      //~v092I~
	}                                                              //~v092I~
//serach by lower                                                  //~v092I~
    if (topu==topl)     //top is case insensitive                  //~v292I~
        return pcl;     //not required by lower case               //~v292I~
	if (pcl)                                                       //~v092I~
    	pc=pcl+1;                                                  //~v092R~
    else                                                           //~v092I~
        pc=Pbuff;                                                  //~v092I~
    for (;;)                                                       //~v092R~
    {                                                              //~v092I~
        len=(ULONG)pce-(ULONG)pc;                                  //~v092I~
    	if (pc=memchr(pc,topl,len),!pc)                            //~v092R~
	    	break;                                                 //~v092R~
		if (pc+Plenk>pce)                                          //~v092R~
	    	break;                                                 //~v092I~
		if (!memicmp(pc,Pkey,Plenk))                               //~v092I~
        	pcl=pc;                                                //~v092I~
    	pc++;                                                      //~v092I~
	}                                                              //~v092I~
	return pcl;                                                    //~v092I~
}//umemrmemi                                                       //~v092I~
                                                                   //~v092I~
//*******************************************************          //~v111I~
//*ustrncpyz                                                       //~v111I~
//* strncpy +(1) last null is gualantied (2) only one null is added//~v111I~
//* parm1 :target                                                  //~v111I~
//* parm2 :source                                                  //~v111I~
//* parm3 :targetlen                                               //~v111I~
//* return:target ptr                                              //~v111I~
//******************************************************           //~v111I~
char *ustrncpyz(char *Ptarget,char *Psource,unsigned int Plen)     //~v111I~
{                                                                  //~v111I~
	unsigned int len;                                              //~v111I~
//******************                                               //~v111I~
	if ((int)Plen<=0)                                              //~v5fkR~
    	return Ptarget;                                            //~v111I~
	len=strlen(Psource);                                           //~v111I~
    if (len>=Plen)                                                 //~v111I~
    {                                                              //~v111I~
    	memcpy(Ptarget,Psource,Plen-1);		//for last null        //~v111I~
        *(Ptarget+Plen-1)=0;                                       //~v111I~
	}                                                              //~v111I~
    else                                                           //~v111I~
    	memcpy(Ptarget,Psource,len+1);		//with last null       //~v111I~
	return Psource;                                                //~v111I~
}//ustrncpyz                                                       //~v111I~
