//*CID://+v0etR~:**                                                //~v0etR~
//*************************************************************
//*xechar.c                                                     //~v04dR~
//*************************************************************
//v0et:970921 split char12 from char                               //~v0etI~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifdef DOS
#else
//  #define INCL_BASE                                              //~v07sR~
//  #include <os2.h>                                               //~v07sR~
#endif
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <uque.h>
#include <ualloc.h>
#include <ufile.h>                                              //~5318I~
                                                                //~5318I~
#include "xe.h"
#include "xescr.h"
#include "xefile.h"
#include "xefile12.h"                                              //~v0dhI~
#include "xechar.h"                                             //~5124I~
#include "xechar12.h"                                              //~v0etR~
//*******************************************************
//*******************************************************       //~v04dI~
//**************************************************            //~v020I~
//*charfieldfullerr                                             //~v020I~
//* errmsg for field full                                       //~v020I~
//*parm  :none                                                  //~v020I~
//*return:4                                                     //~v020I~
//**************************************************            //~v020I~
int charfieldfullerr(void)                                      //~v020I~
{                                                               //~v020I~
//****************************                                  //~v020I~
	uerrmsg("Field Full",                                       //~v020I~
			"");                                            //~v020I~
	return 4;                                                   //~v020I~
}//charfieldfull                                                //~v020I~
                                                                //~v020I~
//**************************************************            //~5125I~
//*chartabclear                                                 //~5125I~
//* reset tab to space                                          //~5125I~
//*parm1  :dbcs tbl                                             //~5125I~
//*parm2  :len                                                  //~5125I~
//*return:none                                                  //~5125I~
//**************************************************            //~5125I~
void chartabclear(UCHAR *Pdbcs,int Plen)                        //~5125I~
{                                                               //~5125I~
	int ii;	                                                    //~5125I~
//****************************                                  //~5125I~
	for (ii=0;ii<Plen;ii++,Pdbcs++)                             //~5125R~
		if (*Pdbcs==TABCHAR || *Pdbcs==TABPADCHAR)              //~5125I~
			*Pdbcs=0;                                           //~5125I~
	return;                                                     //~5125I~
}//chartabclear                                                 //~5125I~
                                                                   //~v09jI~
//**************************************************               //~v09jI~
//*charcleartabdbcs                                                //~v09jI~
//* clear dbcs tbl of tab                                          //~v09jI~
//*parm1  :dbcs tbl                                                //~v09jI~
//*return :reset length                                            //~v09jI~
//**************************************************               //~v09jI~
int charcleartabdbcs(UCHAR *Pdbcs)                                 //~v09jI~
{                                                                  //~v09jI~
	int ii;                                                        //~v09jI~
//****************************                                     //~v09jI~
	for (ii=0;;ii++)                                               //~v09jR~
    {                                                              //~v09jI~
		if (*Pdbcs==TABCHAR)                                       //~v09jI~
        {                                                          //~v09jI~
            if (ii)         //continued tab                        //~v09jI~
                break;                                             //~v09jI~
        }                                                          //~v09jI~
        else                                                       //~v09jI~
			if (*Pdbcs!=TABPADCHAR)                                //~v09jI~
            	break;                                             //~v09jI~
		*Pdbcs++=0;                                                //~v09jI~
	}                                                              //~v09jI~
	return ii;                                                     //~v09jI~
}//charcleartabdbcs                                                //~v09jI~
                                                                   //~v09jI~
//**************************************************               //~v09jI~
//*chargettablen                                                   //~v09jI~
//* get tab length on dbcs tbl                                     //~v09jI~
//*parm1  :dbcs tbl                                                //~v09jI~
//*return :tab length                                              //~v09jI~
//**************************************************               //~v09jI~
int chargettablen(UCHAR *Pdbcs)                                    //~v09jI~
{                                                                  //~v09jI~
	int ii;                                                        //~v09jI~
//****************************                                     //~v09jI~
	for (ii=0;;ii++,Pdbcs++)                                       //~v09jI~
		if (*Pdbcs==TABCHAR)                                       //~v09jR~
        {                                                          //~v09jI~
            if (ii)         //continued tab                        //~v09jI~
                break;                                             //~v09jI~
        }                                                          //~v09jI~
        else                                                       //~v09jI~
			if (*Pdbcs!=TABPADCHAR)                                //~v09jI~
            	break;                                             //~v09jI~
	return ii;                                                     //~v09jI~
}//chargettablen                                                   //~v09jI~
