//*CID://+v720R~:                             update#=   51;       //+v720R~
//*************************************************************    //~v690I~
//*xedir4.c                                                        //~v690I~
//* description                                                    //~v690I~
//*************************************************************    //~v690I~
//v720:061116 3270:listds fail by 'sys1.*' because sys1.duplex has no dsorg recfm//~v718I~
//            trate as special file for SYS1.VMASTCAT(VSAM) etc    //~v718I~
//v718:061003 dirlist description for remotefile is not supported(ignore option)//~v718I~
//v693:060423 (BUG)when scr resized,remains previous image         //~v693I~
//v690:060418 display file-description support on dir-list panel   //~v690I~
//*************************************************************    //~v690I~
#include <time.h>                                                  //~v690I~
#include <stdio.h>                                                 //~v690I~
#include <stddef.h>                                                //~v690I~
#include <stdlib.h>                                                //~v690I~
#include <ctype.h>                                                 //~v690I~
#include <string.h>                                                //~v690I~
#ifdef UNX                                                         //~v690I~
	#include <sys/stat.h>                                          //~v690I~
#else  //!UNX                                                      //~v690I~
#ifdef DOS                                                         //~v690I~
#else                                                              //~v690I~
	#ifdef W32                                                     //~v690I~
    	#include <dos.h>                                           //~v690I~
		#include <windows.h>                                       //~v690I~
	#else                                                          //~v690I~
	#endif                                                         //~v690I~
#endif                                                             //~v690I~
#endif //!UNX                                                      //~v690I~
//*******************************************************          //~v690I~
#include <ulib.h>                                                  //~v690I~
#include <uerr.h>                                                  //~v690I~
#include <uque.h>                                                  //~v690I~
#include <ufile.h>                                                 //~v690I~
#include <ualloc.h>                                                //~v690I~
#include <ustring.h>                                               //~v690I~
                                                                   //~v690I~
#ifdef UNX                                                         //~v690I~
	#include <uunxsub.h>                                           //~v690I~
#endif //UNX                                                       //~v690I~
                                                                   //~v690I~
#include "xe.h"                                                    //~v690I~
#include "xescr.h"                                                 //~v690I~
#include "xefunc.h"                                                //~v690I~
#include "xefile.h"                                                //~v690I~
#include "xepan.h"                                                 //~v690I~
#include "xedir.h"                                                 //~v690I~
#include "xedir3.h"                                                //~v690I~
#include "xedir4.h"                                                //~v690I~
#include "xedlcmd.h"                                               //~v690R~
#include "xedlcmd2.h"                                              //~v690I~
#include "xesub.h"                                                 //~v690I~
//**************************************************************** //~v690I~
int dirgetdescfromfile(char *Pfpath,char *Pbuff,int Pbufflen);     //~v690I~
int dirdescdbcschk(char *Pdesc,char *Pdbcs,int Plen);              //~v690I~
int dirgetstream(char *Pfpath,char *Pbuff,int Pbufflen);           //~v690R~
//**************************************************************** //~6418M~
//func_desc_dir                                                    //~6418M~
// toggle file description display(on DirList only)                //~6418M~
//*parm1:pcw                                                       //~6418M~
//*ret  :rc                                                        //~6418M~
//**************************************************************** //~6418M~
int func_desc_dir(PUCLIENTWE Ppcw)                                 //~6418M~
{                                                                  //~6418M~
	PUFILEC pfc;                                                   //~6418M~
	PUFILEH pfh;                                                   //~6418M~
//****************************                                     //~6418M~
    pfc=Ppcw->UCWpfc;                                              //~6418M~
	pfh=pfc->UFCpfh;                                               //~6418M~
#ifdef FTPSUPP                                                     //~v690R~
    if (FILEISREMOTE(pfh))                                         //~6418M~
    {                                                              //~6418M~
    	uerrmsg("DisplayFileDescription dose not support remote file",//~6418M~
        		"t@C\x95\\̓[gt@CT|[gĂ܂");//~6418M~
        return 4;                                                  //~6418M~
    }                                                              //~6418M~
#endif                                                             //~6418M~
    if (UCBITCHK(pfh->UFHflag7,UFHF7DESC))	//in that mode         //~v690R~
    {                                                              //~6418M~
    	UCBITOFF(pfh->UFHflag7,UFHF7DESC);	//normal size/timestamp display mode//~v690R~
    	uerrmsg("Reset FileDescriptionDisplay mode",               //~6418M~
        		"t@C\x95\\[hB");             //~6418M~
    }                                                              //~6418M~
    else                                                           //~6418M~
    {                                                              //~6418M~
    	UCBITON(pfh->UFHflag7,UFHF7DESC);	//normal size/timestamp display mode//~v690R~
    	uerrmsg("Set FileDescriptionDisplay mode",                 //~6418M~
        		"t@C\x95\\[hɐݒB");             //~6418M~
    }                                                              //~6418M~
    scrfulldraw(Ppcw);  //draw if another split screen exist       //~v690I~
//  dirddresetallsub(Ppcw,pfh);				//request line reset draw//~v693R~
    dirddresetallsub(DDRESET_DESC,Ppcw,pfh);				//request line reset draw//~v693I~
    return 0;                                                      //~6418M~
}//func_desc_dir                                                   //~6418M~
//**************************************************************** //~6418M~
//setup each file description for dirlist entry                    //~6418M~
//return description string                                        //~v690R~
//**************************************************************** //~6418M~
char *dirgetdesc(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,PUDIRLH Ppdh)//~v690R~
{                                                                  //~6418M~
    char   fpath[_MAX_PATH];                                       //~v690R~
    char   desc[UDIRLDSZ];                                         //~v690I~
    char   dbcswk[UDIRLDSZ];                                       //~v690R~
    char   *pdesc;                                                 //~v690I~
    int desclen=0,maxdesclen=UDDDESCSZ;                            //~v690R~
//*****************                                                //~6418M~
    if (FILEISREMOTE(Ppfh))                                        //~v718R~
        return 0;                                                  //~v718I~
    if (UCBITCHK(Ppdh->UDHupdatetype,UDHUTNOTEXIST))	//deleted or moved or renamed//~6418M~
    	return 0;                                                  //~6418M~
    pdesc=Ppdh->UDHpdesc;                                          //~v690I~
    if (pdesc)                                                     //~v690I~
        if (!UCBITCHK(Ppdh->UDHflag2,UDHF2REFRESH))	//not refresh req//~v690I~
	        return pdesc;                                          //~v690R~
    UCBITOFF(Ppdh->UDHflag2,UDHF2REFRESH);	//refreshed            //~v690I~
    if (dlcgetfullname(Ppdh,fpath))                                //~6418M~
    	return 0;                                                  //~6418M~
	if (UCBITCHK(Ppfh->UFHflag7,UFHF7NTFS))	//drive is ntfs        //~v690R~
		desclen=dirgetstream(fpath,desc,maxdesclen+1);             //~v690R~
    if (!desclen && Ppdh->UDHtype!=UDHTFILE)	//dir etc          //~6418M~
		return 0;                                                  //~6418M~
    if (!desclen)			//no stream data                       //~6418M~
    {                                                              //~6418M~
//#ifdef UNX                                                       //+v720R~
#ifdef FTPSUPP                                                     //+v720R~
    	if (Ppdh->UDHattr & FILE_SPECIAL)                          //~6418M~
        {	                                                       //~6418M~
        	strcpy(desc,"Special File");                           //~6418M~
            desclen=strlen(desc);                                  //~6418M~
        }                                                          //~6418M~
        else                                                       //~6418M~
        {                                                          //~6418M~
#endif                                                             //~6418M~
			*(desc+UDDDESCSZ)=0;	//null term                    //~v690I~
			desclen=dirgetdescfromfile(fpath,desc,maxdesclen+1);	//get description from file line//~v690R~
//#ifdef UNX                                                       //+v720R~
#ifdef FTPSUPP                                                     //+v720I~
        }                                                          //~6418M~
#endif                                                             //~6418M~
    }                                                              //~6418M~
    if (desclen)                                                   //~v690R~
	    desclen=dirdescdbcschk(desc,dbcswk,desclen);	//dbcs split ,ctl char rep//~v690R~
    if (!pdesc) //initial                                          //~v690R~
    {                                                              //~6418M~
    	Ppdh->UDHpdesc=pdesc=umalloc(UDDDESCSZ+1);                 //~6418M~
        if (!pdesc)  	//malloc failed                            //~6418M~
        	return 0;                                              //~6418M~
    }                                                              //~6418M~
    Ppdh->UDHdesclen=desclen;	//net length                       //~v690I~
    if (desclen)                                                   //~v690I~
	    memcpy(pdesc,desc,(UINT)desclen);                          //~v690R~
    if ((UINT)desclen<UDDDESCSZ)                                   //~v690R~
	    memset(pdesc+desclen,' ',(UINT)(UDDDESCSZ-desclen));       //~v690I~
    desclen=UDDDESCSZ;                                             //~v690I~
    *(pdesc+desclen)=0;                                            //~v690I~
    return pdesc;                                                  //~v690R~
}//dirgetdesc                                                      //~v690R~
//**************************************************************** //~v690M~
//read stream data as file description                             //~v690M~
//return description string len                                    //~v690M~
//**************************************************************** //~v690M~
int dirgetstream(char *Pfpath,char *Pbuff,int Pbufflen)            //~v690I~
{                                                                  //~v690M~
#ifndef W32                                                        //~v690I~
	return 0;                                                      //~v690I~
#else                                                              //~v690I~
static char Sstreamname[]={XESTREAMNAME};                          //~v690R~
    HANDLE  hStream;                                               //~v690M~
	char snm[_MAX_PATH+32];                                        //~v690M~
    int outmaxlen,readlen;                                         //~v690M~
//*********************************                                //~v690M~
	outmaxlen=Pbufflen-1;                                          //~v690M~
    *(Pbuff+outmaxlen)=0;	//strz                                 //~v690M~
    *Pbuff=':';                                                    //~v690I~
    outmaxlen--;                                                   //~v690I~
	sprintf(snm,"%s:%s",Pfpath,Sstreamname);                       //~v690M~
    hStream=CreateFile(snm,GENERIC_READ,FILE_SHARE_READ,NULL,      //~v690M~
                            OPEN_EXISTING,0,NULL);                 //~v690M~
    if( hStream==INVALID_HANDLE_VALUE )                            //~v690M~
    	return 0;	//no stream                                    //~v690M~
    ReadFile(hStream,Pbuff+1,outmaxlen,&readlen,NULL);             //~v690R~
    *(Pbuff+1+readlen)=0;                                          //~v690R~
    CloseHandle(hStream);                                          //~v690M~
    return readlen+1;                                              //~v690R~
#endif                                                             //~v690M~
}//dirgetstream                                                    //~v690M~
//**************************************************************** //~6418M~
//setup each file description for dirlist entry                    //~6418M~
//return description string len                                    //~v690R~
//**************************************************************** //~6418M~
int dirgetdescfromfile(char *Pfpath,char *Pbuff,int Pbufflen)      //~v690R~
{                                                                  //~6418M~
	FILE *fh;                                                      //~v690I~
	char buff[DESCRIPTIONRANGE],*pc,*pce;                          //~v690R~
static  char Sdescid[]={DESCRIPTIONID};                            //~v690I~
	int fsz,outlenmax,len,ch;                                      //~v690R~
//***************************                                      //~v690I~
	outlenmax=Pbufflen-1;                                          //~v690I~
    *(Pbuff+outlenmax)=0;	//set null term                        //~v690R~
	fh=fopen(Pfpath,"rb");                                         //~v690I~
    if (!fh)                                                       //~v690I~
    {                                                              //~v690I~
    	strncpy(Pbuff,"Cannot Open",(UINT)Pbufflen);               //~v693R~
        return (int)strlen(Pbuff);                                 //~v690I~
    }                                                              //~v690I~
    fsz=(int)fread(buff,1,DESCRIPTIONRANGE,fh);                    //~v693R~
    pc=umemmem(buff,Sdescid,(UINT)fsz,sizeof(Sdescid)-1);          //~v693R~
    if (pc)                                                        //~v690I~
    	pc+=sizeof(Sdescid)-1;                                     //~v690I~
    else                                                           //~v690I~
    {                                                              //~v690I~
        for (pc=buff,pce=pc+fsz;pc<pce;pc++)	//skip top null line//~v690R~
        {                                                          //~v690I~
        	ch=*pc;                                                //~v690I~
    		if (ch!=' '&&ch!='\t'&&ch!='\r'&&ch!='\n')             //~v690R~
            	break;                                             //~v690I~
        }                                                          //~v690I~
    }                                                              //~v690I~
    len=(int)(fsz-((ULONG)pc-(ULONG)buff));                        //~v693R~
    len=min(outlenmax,len);                                        //~v690R~
    memcpy(Pbuff,pc,(UINT)len);                                    //~v693R~
    if (pc=memchr(Pbuff,'\r',(UINT)len),pc)  //MAC or PC  (x0d)    //~v690R~
        len=(int)((ULONG)pc-(ULONG)Pbuff);                         //~v693R~
    else                                                           //~v690I~
    if (pc=umemrchr(Pbuff,'\n',(UINT)len),pc)  //UNIX       (x0a)  //~v690R~
        len=(int)((ULONG)pc-(ULONG)Pbuff);                         //~v693R~
    fclose(fh);                                                    //~v690I~
    return len;                                                    //~v690R~
}//dirgetdescfromfile                                              //~v690R~
//**************************************************************** //~v690I~
//rep ctl char by "." with chk DBCS                                //~v690R~
//return description string len                                    //~v690I~
//**************************************************************** //~v690I~
int dirdescdbcschk(char *Pdesc,char *Pdbcs,int Plen)               //~v690I~
{                                                                  //~v690I~
	int len;                                                       //~v690I~
    char *pc,*pcd,*pce;                                            //~v690I~
//***************************                                      //~v690I~
	len=Plen;                                                      //~v690I~
	setdbcstbl(Pdesc,Pdbcs,Plen);                                  //~v690I~
    for (pc=Pdesc,pcd=Pdbcs,pce=pc+len;pc<pce;pc++,pcd++)          //~v690I~
    {                                                              //~v690I~
    	switch(*pcd)                                               //~v690I~
        {                                                          //~v690I~
        case DBCS1STCHAR:	//end with first byte                  //~v690I~
  		case DBCS2NDCHAR:	//start with second byte               //~v690I~
            break;                                                 //~v690I~
        default:                                                   //~v690I~
            if (*pcd)       //UDBCSCHK_HKDBCSERR                   //~v690I~
            	*pc='.';	//rep by period                        //~v690I~
            else                                                   //~v690I~
        	if (*pc<0x20||*pc>0x7f) //not ascii                    //~v690R~
            	*pc='.';	//rep by period                        //~v690I~
        }                                                          //~v690I~
    }                                                              //~v690I~
    if (*(pcd-1)==DBCS1STCHAR)	//dbcs split                       //~v690I~
    {                                                              //~v690I~
    	len--;                                                     //~v690I~
    	*(pc-1)=0;                                                 //~v690R~
    }                                                              //~v690I~
    return len;                                                    //~v690I~
}//dirdescdbcschk                                                  //~v690I~
