//CID://+v62QR~:                                                   //~v62QR~
//*************************************************************
//* xeerr.c
//*************************************************************
//v62Q:050419 errmsg for split width is over MAXLINEDATA           //~v62QI~
//v62f:050314 change matching specification "*= & n "-->"*=Mn"     //~v62fI~
//v60y:050202 exe cmd *2 option(use other split screen file)       //~v60yI~
//v60v:050201 virtual hex display option(/Mx,HEX on/off,prev HEX is XIN)//~v60vI~
//v50E:030126 (DOS)no TC cmd support for memory                    //~v50EI~
//v50m:030102 accept tab cmd on any screen                         //~v50mI~
//v43m:011101 conflict err msg                                     //~v43mI~
//v417:010729 allow lineno fld when not protected for spf file     //~v417I~
//v155:000318 numeric calc func                                    //~v155I~
//v10v:990326 chng browse binary mode:"2" -->"1",and add "2" as edit binary mode//~v10vI~
//v0i8:980522 move csrposerr to xeerr                              //~v0i8I~
//v098:970413:(BUG)avail update on browse line(but its is not saved)//~v098I~
//            by Shift+Ins/Del/F10(rep)/Enter(Split).              //~v098I~
//            (move errmsg to xeerr.c from xecap.c)                //~v098I~
//v07s:960825:new ulib.h/ulibdef.h(no need base def by os2.h)      //~v07sI~
//            to speed up compile,drop include(caused by WIN95 modify)//~v07sI~
//v03b:950730:zenkaku err msg for lineno,scroll fld etc         //~v03bI~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
//*************************************************************
#ifdef DOS
#else
//  #define INCL_BASE                                              //~v07sR~
//  #include <os2.h>                                               //~v07sR~
#endif
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <uque.h>                                                  //~v60yI~
                                                                   //~v60yI~
#include "xe.h"                                                    //~v60yI~
//*******************************************************
//****************************************************************
// errmissing
//*parm  :none
//*rc    :4
//****************************************************************
int errmissing(void)
{
	uerrmsg("Missing operand",
			"Iyh܂");                          //~v03bR~
	return 4;
}
//****************************************************************
// errtoomany
//*parm  :none
//*rc    :4
//****************************************************************
int errtoomany(void)
{
	uerrmsg("Too many operand",
    		"Iyh߂܂");
	return 4;
}
//****************************************************************
// errinvalid
//*parm1 :operand string
//*rc    :4
//****************************************************************
int errinvalid(UCHAR *Popd)
{
	uerrmsg("Invalid operand value(%s)",
			"Iyȟ(%s)",                             //~5715R~
			Popd);                                              //~5715I~
	return 4;
}
//****************************************************************//~v03bI~
// errdbcsinput                                                 //~v03bI~
//*parm1 :none                                                  //~v03bI~
//*rc    :4                                                     //~v03bI~
//****************************************************************//~v03bI~
int errdbcsinput(void)                                          //~v03bI~
{                                                               //~v03bI~
	uerrmsg("DBCS not avail",                                   //~v03bI~
			"Sp͕s");                                    //~v03bI~
	return 4;                                                   //~v03bI~
}                                                               //~v03bI~
//****************************************************************//~v03bI~
// errtoolong                                                   //~v03bI~
//*parm1 :none                                                  //~v03bI~
//*rc    :4                                                     //~v03bI~
//****************************************************************//~v03bI~
int errtoolong(void)                                            //~v03bI~
{                                                               //~v03bI~
	uerrmsg("Too long input",                                   //~v03bI~
			"߂");                                    //~v03bI~
	return 4;                                                   //~v03bI~
}                                                               //~v03bI~
//****************************************************************//~v03bI~
// errlcmd (lcmd format err)                                    //~v03bI~
//*parm1 :none                                                  //~v03bI~
//*rc    :4                                                     //~v03bI~
//****************************************************************//~v03bI~
int errlcmd(void)                                               //~v03bI~
{                                                               //~v03bI~
	uerrmsg("Invalid line cmd",                                 //~v03bI~
			"sR}h`G[");                            //~v03bI~
	return 4;				//cmd err                           //~v03bI~
}                                                               //~v03bI~
//****************************************************************//~v03bI~
// erralready (already requested status)                        //~v03bI~
//*parm1 :none                                                  //~v03bI~
//*rc    :4                                                     //~v03bI~
//****************************************************************//~v03bI~
int erralready(void)                                            //~v03bI~
{                                                               //~v03bI~
	uerrmsg("Already in the status",                            //~v03bI~
			"ɗvꂽ󋵂ɂ܂");                    //~v03bI~
	return 4;				//cmd err                           //~v03bI~
}                                                               //~v03bI~
                                                                   //~v098I~
//*******************************************************          //~v098I~
//* errbrowsemode                                                  //~v098I~
//* parm:none                                                      //~v098I~
//* retrn:4                                                        //~v098I~
//*******************************************************          //~v098I~
int errbrowsemode(void)                                            //~v098I~
{                                                                  //~v098I~
//*******************                                              //~v098I~
	uerrmsg("The panel is browse mode",                            //~v098I~
//			"ʂ͕\[hł");                               //~v095R~,//~v098I~
  			"ʂ\x95\\[hł");                           //~v095I~,//~v098I~
	return 4;                                                      //~v098I~
}//errbrowsemode                                                   //~v098I~
                                                                   //~v0i8I~
//*******************************************************          //~v0i8I~
//!errcsrpos                                                       //~v60yR~
//* capcsrposerr                                                   //~v0i8I~
//* parm:none                                                      //~v0i8I~
//* retrn:4                                                        //~v0i8I~
//*******************************************************          //~v0i8I~
int errcsrpos(void)                                                //~v0i8I~
{                                                                  //~v0i8I~
//*******************                                              //~v0i8I~
	uerrmsg("Invalid cursor position",                             //~v0i8I~
//  		"J[\ʒǔ");                                 //~v0i8I~
    		"J[\x83\\ʒǔ");                             //~v0i8I~
	return 4;                                                      //~v0i8I~
}//errcsrpos                                                       //~v0i8I~
//*******************************************************          //~v10vI~
//!errdir(void)                                                    //~v10vI~
//* parm:none                                                      //~v10vI~
//* retrn:4                                                        //~v10vI~
//*******************************************************          //~v10vI~
int errdir(UCHAR *Pfnm)                                            //~v10vI~
{                                                                  //~v10vI~
//*******************                                              //~v10vI~
	uerrmsg("%s is directory",                                     //~v10vI~
			"%s ̓fBNg[ł",Pfnm);                       //~v10vI~
	return 4;                                                      //~v10vI~
}//errdir                                                          //~v10vI~
                                                                   //~v155I~
//*******************************************************          //~v155I~
//!errdir(void)                                                    //~v155I~
//* parm:none                                                      //~v155I~
//* retrn:4                                                        //~v155I~
//*******************************************************          //~v155I~
int errformat(UCHAR *Pdata)                                        //~v155I~
{                                                                  //~v155I~
//*******************                                              //~v155I~
	uerrmsg("Format error:%s",                                     //~v155I~
			"`G[:%s",                                       //~v155I~
			Pdata);                                                //~v155I~
	return 4;                                                      //~v155I~
}//errdir                                                          //~v155I~
//*******************************************************          //~v62QI~
//!errovermax                                                      //~v62QI~
//* retrn:4                                                        //~v62QI~
//*******************************************************          //~v62QI~
int errovermax(UCHAR *Pdataname,char *Pparm,char *Pcomp,LONG Pmax) //+v62QR~
{                                                                  //~v62QI~
//*******************                                              //~v62QI~
	uerrmsg("%s parm (%s) is limitted.(%s%ld)",                    //+v62QR~
			"%s p[^(%s)̐lᔽ(%s%ld)",                //+v62QR~
			Pdataname,Pparm,Pcomp,Pmax);                           //+v62QR~
	return 4;                                                      //~v62QI~
}//errovermax                                                      //~v62QI~
//*******************************************************          //~v417I~
//!errdir(void)                                                    //~v417I~
//* parm:none                                                      //~v417I~
//* retrn:4                                                        //~v417I~
//*******************************************************          //~v417I~
int errprotected(void)                                                 //~v417I~
{                                                                  //~v417I~
//*******************                                              //~v417I~
	uerrmsg("Field Protected",                                     //~v417I~
			"ݕی엓");                                     //~v417R~
	return 4;                                                      //~v417I~
}//errdir                                                          //~v417I~
//*******************************************************          //~v417M~
//!errmarginboundary                                               //~v417I~
//* errmsg issue                                                   //~v417M~
//* parm:none                                                      //~v417M~
//* retrn:4                                                        //~v417M~
//*******************************************************          //~v417M~
int errmarginboundary(void)                                        //~v417I~
{                                                                  //~v417M~
//*******************                                              //~v417M~
    uerrmsg("Margin boundary",                                     //~v417M~
            "}[WE");                                       //~v417M~
    return 4;                                                      //~v417M~
}//errmarginboundary                                               //~v417I~
//**************************************************************** //~v43mI~
// errinvalid                                                      //~v43mI~
//*parm1 :operand string                                           //~v43mI~
//*rc    :4                                                        //~v43mI~
//**************************************************************** //~v43mI~
int errconflict(UCHAR *Popd1,UCHAR *Popd2)                         //~v43mI~
{                                                                  //~v43mI~
//**************                                                   //~v43mI~
	if (Popd2)                                                     //~v43mR~
		uerrmsg("%s is in conflict with %s",                       //~v43mR~
				"%s  %s Ɩ܂",                           //~v43mR~
				Popd1,Popd2);                                      //~v43mR~
    else                                                           //~v43mI~
		uerrmsg("%s is in conflict with other parm or status",     //~v43mR~
				"%s  ̎w,󋵂Ɩ܂",                 //~v43mR~
				Popd1,Popd2);                                      //~v43mI~
	return 4;                                                      //~v43mI~
}                                                                  //~v43mI~
//**************************************************************** //~v50mI~
// errscrtype                                                      //~v50mI~
//*parm1 :cmd string                                               //~v50mI~
//*rc    :4                                                        //~v50mI~
//**************************************************************** //~v50mI~
int errscrtype(UCHAR *Pcmd)                                        //~v50mI~
{                                                                  //~v50mI~
	uerrmsg("\"%s\" is not a valid command for this panel",        //~v50mI~
			"\"%s\" ͂̉ʂł͎gpł܂",                 //~v50mI~
			Pcmd);                                                 //~v50mI~
    return 4;                                                      //~v50mI~
}//errscrtype                                                      //~v50mI~
//**************************************************************** //~v50EI~
// errnotsupported                                                 //~v50EI~
//*parm1 :cmd string                                               //~v50EI~
//*rc    :4                                                        //~v50EI~
//**************************************************************** //~v50EI~
int errnotsupported(UCHAR *Pcmd,UCHAR *Pcond)                      //~v50EI~
{                                                                  //~v50EI~
	uerrmsg("\"%s\" is not supported for %s.",                     //~v50EI~
			"\"%s\"  %s ł̓T||g܂B",               //~v50EI~
			Pcmd,Pcond);                                           //~v50EI~
    return 4;                                                      //~v50EI~
}//errnotsupported                                                 //~v50EI~
//**************************************************************** //~v60yI~
// errscrnotsplited                                                //~v60yI~
//*rc    :4                                                        //~v60yI~
//**************************************************************** //~v60yI~
//int errscrnotsplited(void)                                       //~v62fR~
int errscrnotsplited(char *Pparm)                                  //~v62fI~
{                                                                  //~v60yI~
 	uerrmsg("parm(%s) err,screen is not splitted",                 //~v60yI~
            "p[^(%s)G[Bʂ͕Ă܂B",    //~v60yI~
//          FNMOF2NDSCR);                                          //~v62fR~
            Pparm);                                                //~v62fI~
    return 4;                                                      //~v60yI~
}                                                                  //~v60yI~
//**************************************************************** //~v60yI~
// err2ndscrisnotfile                                              //~v60yI~
//*rc    :4                                                        //~v60yI~
//**************************************************************** //~v60yI~
//int err2ndscrisnotfile(void)                                     //~v62fR~
int err2ndscrisnotfile(char *Pparm)                                //~v62fI~
{                                                                  //~v60yI~
    uerrmsg("parm(%s) err,another screen is not file ones",        //~v60yI~
            "p[^(%s)G[B̉ʂt@CʂłȂB",//~v60yI~
//                  	FNMOF2NDSCR);                              //~v62fR~
	                  	Pparm);                                    //~v62fI~
    return 4;                                                      //~v60yI~
}                                                                  //~v60yI~
//**************************************************************** //~v60vI~
//errnotvalidhexchar                                               //~v60vI~
//invalid hex digit input                                          //~v60vI~
//*rc    :4                                                        //~v60vI~
//**************************************************************** //~v60vI~
int errnotvalidhexchar(void)                                       //~v60vI~
{                                                                  //~v60vI~
	uerrmsg("Invalid Hex digit input",                             //~v60vI~
    		"HEX͂̌");                                  //~v60vI~
    return 4;                                                      //~v60vI~
}//errnotvalidhexchar                                              //~v60vI~
