//*CID://+v635R~:**                                                //~v635R~
//*************************************************************
//*xefcmd23.c
//*  find sub                                                      //~v635R~
//****************************************************************
//v635:050428 move fcmdgetstartplhoffs from xefcmd2.c xefcmd23.c   //~v635I~
//v43g:011030 save each find word len for multiple word search case//~v43gI~
//            (spanded or *& case)                                 //~v43gI~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

//*******************************************************
#include <ulib.h>
#include <ualloc.h>
#include <uque.h>
#include <uerr.h>
#include <uparse.h>
#include <ustring.h>
#include <ufile.h>

#include "xe.h"
#include "xescr.h"
#include "xefile.h"
#include "xefile6.h"
#include "xefcmd2.h"
#include "xefcmd23.h"
#include "xeundo.h"
#include "xedir.h"                                                 //+v635I~
//**************************************************
int fcmdtabcmp(char *Pdata,char *Psrch,int Psrchlen,char *Pdbcs);
//**************************************************
//!search on binary file
//*parm1:plh
//*parm2:search start offs
//*parm3:search word
//*parm4:search word len
//*parm5:search word containe tab sw
//*parm6:dest id(prev/next)
//*parm7:case sensitive sw
//*parm8:output match pos
//*parm9:optional output last plh
//*parm10:optional output word end addr
//*ret  :0:unmatch,1:match in the line,2:match by concatinated,UALLOC FAILED
//**************************************************
int fcmdsplitsrch(PULINEH Pplh,int Poffs,char *Psrch,int Psrchlen,
                    int Ptabsrchsw,int Pdirection,int Pcasesw,UCHAR **Ppos,//~v13pR~
					PULINEH *Pwordplh,UCHAR **Pwordend)            //~v13pR~
{
	PULINEH plh;
    char *pc,*pcl,*pc0,*pce,*srch1,*pcd,*pcd0,*wordtop,*wordend;
    char chru,chrl;
    int  srchlen1,reslen,linelen,complen,rc;
//*********************************
    if (!(pcd0=Pplh->ULHdbcs))
    {
    	if (filechktabdbcs(Pplh)==UALLOC_FAILED)//expand before compare
        	return UALLOC_FAILED;
		pcd0=Pplh->ULHdbcs;
	}
	pc0=Pplh->ULHdata;
    linelen=Pplh->ULHlen;
    srchlen1=Psrchlen-1;

	if (Pdirection==SUBCMD_PREV)
	    chru=*(Psrch+srchlen1);
    else
	    chru=*Psrch;
	if (Pcasesw)
    	chrl=0;				//no 2nd srch
    else
    {
    	chrl=(char)tolower(chru);                                  //~v13pR~
    	chru=(char)toupper(chru);                                  //~v13pR~
    	if (chru==chrl)
            chrl=0;         //id of no 2nd srch
	}
	if (Pdirection==SUBCMD_PREV)
    {
//****************
//* prev srch    *
//****************
        if (Poffs>linelen)
	        reslen=linelen;
        else
	        reslen=Poffs;
		if (!reslen)
        	return 0;
	    while(reslen)
    	{
        	if (chru==TABCHAR)
            {
                pc=umemrchr(pcd0,TABCHAR,(UINT)reslen); //srch by last char//~v13pR~
                if (pc)
                	pc=pc0+((ULONG)pc-(ULONG)pcd0);
			}
            else
            {
                pc=umemrchr(pc0,chru,(UINT)reslen); //srch by last char//~v13pR~
                if (chrl)
                {
                    pcl=umemrchr(pc0,chrl,(UINT)reslen);           //~v13pR~
                    if (pcl>pc)
                    	pc=pcl;
                }
			}
            if (!pc)
                return 0;
            if (Psrchlen==1)
            {
                *Ppos=pc;
                return 1;
            }
            wordend=pc+1;
            srch1=Psrch+srchlen1;
            reslen=(int)((ULONG)pc-(ULONG)pc0);                    //~v13pR~
            if (srchlen1<=reslen)
            	complen=srchlen1;
            else
            	complen=reslen;
            if (!complen)       //last byte matched to line top
                break;          //chk prev line
            srch1-=complen;
            pc-=complen;
            if (Ptabsrchsw)
                rc=fcmdtabcmp(pc,srch1,complen,pcd0+((ULONG)pc-(ULONG)pc0));
            else
                if (Pcasesw)
                    rc=memcmp(pc,srch1,(UINT)complen);
                else
                    rc=memicmp(pc,srch1,(UINT)complen);
            if (!rc)
            {
            	if (complen!=srchlen1)	//not fully compared
                {
                    srchlen1-=complen;
                	break;
                }
                *Ppos=pc;
                return 1;
			}
        }//until line end
//        concatsw=UCBITCHK(Pplh->ULHflag2,ULHF2SPLIT2);//has prev
        plh=Pplh;
		while (srchlen1)
        {
            while(plh=UGETQPREV(plh),plh)
                if (plh->ULHtype==ULHTDATA)
                    break;
            if (!plh)
                return 0;
//            if (concatsw)
//                if (!UCBITCHK(plh->ULHflag2,ULHF2SPLIT1)) //not follower
//                    return 0;
    		if (!plh->ULHdbcs)
	            if (filechktabdbcs(plh)==UALLOC_FAILED)//expand before compare
    	            return UALLOC_FAILED;
            linelen=plh->ULHlen;
            if (srchlen1<linelen)
            	complen=srchlen1;
            else
            	complen=linelen;
            pc=plh->ULHdata+linelen-complen;
            srch1-=complen;
            srchlen1-=complen;
            if (Ptabsrchsw)
                rc=fcmdtabcmp(pc,srch1,complen,plh->ULHdbcs+linelen-complen);
            else
                if (Pcasesw)
                    rc=memcmp(pc,srch1,(UINT)complen);
                else
                    rc=memicmp(pc,srch1,(UINT)complen);
            if (rc)
                return 0;       //unmatch
        }
        wordtop=pc;         //return word top addr
	}//bwd
    else 	//forward search
	{
//****************
//* next srch    *
//****************
        if (Poffs>=linelen)
	        return 0;		//not found
        if (Poffs<0)
        	Poffs=0;
        pce=pc0+linelen;      //end addr
	    pcd0+=Poffs;
    	pc0+=Poffs;
        srch1=Psrch+1;
	    while(pc0<pce)
    	{
            reslen=(int)((ULONG)pce-(ULONG)pc0);                   //~v13pR~
        	if (chru==TABCHAR)
            {
                pcd=memchr(pcd0,TABCHAR,(UINT)reslen); //srch by last char//~v13pR~
            	if (!pcd)
                	return 0;
                pc=pc0+((ULONG)pcd-(ULONG)pcd0);
			}
            else
            {
            	pc=memchr(pc0,chru,(UINT)reslen);                  //~v13pR~
                if (chrl)
                {
                    pcl=memchr(pc0,chrl,(UINT)reslen);             //~v13pR~
                    if (pcl && (!pc || pcl<pc))
                    	pc=pcl;
                }
	            if (!pc)
    	            return 0;
                pcd=pcd0+((ULONG)pc-(ULONG)pc0);
            }
            if (Psrchlen==1)
            {
                *Ppos=pc;
                return 1;
            }
            wordtop=pc;
            pc0=pc+1;	//next srch start addr
            pcd0=pcd+1;	//next srch start addr
            reslen=(int)((ULONG)pce-(ULONG)pc0);                   //~v13pR~
            if (srchlen1<=reslen)
            	complen=srchlen1;
            else
            	complen=reslen;
            if (!complen)
                break;          //chk next line
            if (Ptabsrchsw)
                rc=fcmdtabcmp(pc0,srch1,complen,pcd0);
            else
                if (Pcasesw)
                    rc=memcmp(pc0,srch1,(UINT)complen);
                else
                    rc=memicmp(pc0,srch1,(UINT)complen);
            if (!rc)
            {
            	if (complen!=srchlen1)
                {
                    srchlen1-=complen;
                    srch1+=complen;
                	break;
                }
                *Ppos=pc;
                return 1;
            }
        }//until line end
//compare second half
//        concatsw=UCBITCHK(Pplh->ULHflag2,ULHF2SPLIT1);//has next
        plh=Pplh;
		while (srchlen1)
        {
            while(plh=UGETQNEXT(plh),plh)
                if (plh->ULHtype==ULHTDATA)
                    break;
            if (!plh)
                return 0;
//            if (concatsw)
//                if (!UCBITCHK(plh->ULHflag2,ULHF2SPLIT2)) //not follower
//                    return 0;
    		if (!plh->ULHdbcs)
            	if (filechktabdbcs(plh)==UALLOC_FAILED)//expand before compare
                	return UALLOC_FAILED;
            linelen=plh->ULHlen;
            if (srchlen1<linelen)
            	complen=srchlen1;
            else
            	complen=linelen;
            pc=plh->ULHdata;
            if (Ptabsrchsw)
                rc=fcmdtabcmp(pc,srch1,complen,plh->ULHdbcs);
            else
                if (Pcasesw)
                    rc=memcmp(pc,srch1,(UINT)complen);
                else
                    rc=memicmp(pc,srch1,(UINT)complen);
            if (rc)
            	return 0;
            srchlen1-=complen;
            srch1+=complen;
            wordend=pc+complen;
        }//srchlen
	}//fwd
    *Ppos=wordtop;
    if (Pwordplh)
	    *Pwordplh=plh;
    if (Pwordend)
	    *Pwordend=wordend;
    return 2;
}//fcmdsplitsrch                                                   //~v13pR~
//**************************************************
//!fcmdtabcmp
//*parm1:line data
//*parm2:srch string
//*parm3:compare len
//*parm4:line dbcs
//*ret  :rc 0 match,1:unmatch
//**************************************************
int fcmdtabcmp(char *Pdata,char *Pstring,int Psrchlen,char *Pdbcs)
{
    int    ii;
    UCHAR  ch2,*pc,*pc1,*pc2;
//*********************************
    for (pc1=Pdata,pc2=Pdbcs,pc=Pstring,ii=Psrchlen;ii;ii--,pc1++,pc2++,pc++)
    {
        ch2=*pc;
        if (ch2==TABCHAR)
        {
            if (TABCHAR!=*pc2)
                return 1;		//unmatch
        }
        else
            if (ch2!=*pc1)
                return 1;		//unmatch
    }
    return 0;
}//fcmdtabcmp
//**************************************************
//!fcmdnextofspan
//*parm1:in/out current offset
//*parm2:in     advance step count
//*parm3:in/out current plh/wordend plh
//*ret  :rc 0 no plh updated,1:plh changed
//**************************************************
int fcmdnextofspan(int *Poffs,int Pstep,PULINEH *Ppplh)
{
	PULINEH plh;
    int     len,linelen,offs;
//*********************************
	plh=*Ppplh;
    offs=*Poffs;
	len=plh->ULHlen;
    if ((len-=offs)<=0)
    	return 0;
    if (len>=Pstep)	//in the first plh
    {
    	*Poffs=offs+Pstep;		//advance in the line
    	return 0;
	}
    linelen=0;		//for compiler warning                         //~v13pI~
    for (len=Pstep-len;len;len-=linelen)
    {
    	while (plh=UGETQNEXT(plh),plh)
        	if (plh->ULHtype==ULHTDATA)
            	break;
        if (!plh)
        	return 0;
		linelen=plh->ULHlen;
        if (len<=linelen)
        	break;
    }
    *Ppplh=plh;
    *Poffs=len;
    return 1;
}//fcmdnextofspan
//**************************************************               //~v13pI~
//!fcmdsplitdispaly                                                //~v13pI~
//*parm1:pfh                                                       //~v43gR~
//*parm2:plh of 1st line                                           //~v43gI~
//*parm3:plh of spaned last line                                   //~v43gR~
//*parm4:word offset                                               //~v43gR~
//*parm5:word len                                                  //~v43gR~
//*parm6:locatesw                                                  //~v43gR~
//*ret  :0                                                         //~v43gR~
//**************************************************               //~v13pI~
int fcmdsplitdisplay(PUFILEH Ppfh,PULINEH Pplh,PULINEH Plastplh,int Poffs,int Plen,int Plocatesw)//~v43gR~
{                                                                  //~v13pI~
	PULINEH plh;                                                   //~v13pI~
    int     reslen,spanlen,linelen,minlen;                         //~v43gR~
//*********************************                                //~v13pI~
	reslen=Pplh->ULHlen-Poffs;	//len on the 1st line              //~v13pI~
	spanlen=Plen-reslen;	//spaned len                           //~v13pI~
//  Pplh->ULHrevlen=(USHORT)reslen;                                //~v43gR~
    fcmdsetfindhighlight(Ppfh,Pplh,Plocatesw,0, //no linesrch      //~v43gI~
			Poffs,reslen,0);    //recursive with no spanplh        //~v43gI~
    linelen=0;                                                     //~v13pI~
    for (plh=Pplh;plh=UGETQNEXT(plh),plh;spanlen-=linelen)         //~v13pR~
    {                                                              //~v13pI~
		linelen=plh->ULHlen;                                       //~v13pI~
        if (spanlen<0)                                             //~v13pI~
        	spanlen=0;                                             //~v13pR~
//  	plh->ULHrevlen=(USHORT)min(spanlen,linelen);               //~v43gR~
//  	UCBITOFF(plh->ULHflag2,ULHF2MFOUND);//reset multiple       //~v43gR~
//  	plh->ULHrevctr=Pfindctr;//find cmd ctr for disply current; //~v43gR~
//  	UCBITON(plh->ULHflag,ULHFDRAW|ULHFCURFOUND);//draw word after wordrep//~v43gR~
//  	UCBITOFF(plh->ULHflag,ULHFCURCAP);//reset hilight reason cap//~v43gR~
    	minlen=min(spanlen,linelen);                               //~v43gI~
    	fcmdsetfindhighlight(Ppfh,plh,0,0, //no locate,no linesrch //~v43gR~
							0,minlen,0);    //offs=0,recursive with no spanplh//~v43gR~
        if (plh==Plastplh)                                         //~v13pI~
        	break;                                                 //~v13pI~
    }                                                              //~v13pI~
    return 0;                                                      //~v43gR~
}//fcmdsplitdisplay                                                //~v13pR~
//**************************************************
//!fcmdsplitrep
//* cut spaned area by wordrep(rep word is set to 1st line)
//*parm1:plh of 1st line
//*parm2:len on the following line
//*ret  :rc 4:err or UALLOC_FAILED
//**************************************************
int fcmdsplitrep(PUCLIENTWE Ppcw,PULINEH Pplh,int Pspanlen)
{
	PULINEH plh;
    int     len,linelen,spanlen;
    char   *pc,*pcd;
//*********************************
	len=0;                                                         //~v13pI~
    for (spanlen=Pspanlen,plh=Pplh;spanlen;spanlen-=len)
    {
    	while (plh=UGETQNEXT(plh),plh)
        	if (plh->ULHtype==ULHTDATA)
            	break;
        if (!plh)
        	return 4;
		linelen=plh->ULHlen;
        if (spanlen<=linelen)
        	len=spanlen;
        else
        	len=linelen;
        if (!len)
            continue;
    	if (undoupdate(Ppcw,plh,UUHTREP)==UALLOC_FAILED)
    		return UALLOC_FAILED;
        pc=plh->ULHdata;
        pcd=plh->ULHdbcs;                                          //~v13pR~
        linelen-=len;
        memcpy(pc, pc +len,(UINT)linelen);//left shift
        memcpy(pcd,pcd+len,(UINT)linelen);//left shift
        plh->ULHlen=linelen;                                       //~v13pR~
    }
    return 0;
}//fcmdsplitrep
//****************************************************************//~4C30I~
//!get start offset from current csr pos                        //~4C30I~
//* parm1 :pcw                                                  //~4C30I~
//* parm2 :output plh addr search start                         //~4C30I~
//* parm3 :output record pos search strat                       //~4C30I~
//* parm4 :0:line search sw                                        //~v47iR~
//* rc    :0:csr is  on client area, 4:csr is out of client area   //~v47iI~
//         1:cout of client area but line is on client area        //~v09eI~
//****************************************************************//~4C30I~
int fcmdgetstartplhoffs(PUCLIENTWE Ppcw,PULINEH *Ppplh,int *Ppoffset,int Popt)//~v47iR~
{                                                               //~4C30I~
	int offset,rc;                                              //~4C30I~
	PULINEH plh;                                                //~4C30I~
	PUFILEC pfc;                                                //~4C30I~
//*****************                                             //~4C30I~
	rc=4;                                                       //~4C30I~
	offset=0;                                                   //~4C30I~
	pfc=Ppcw->UCWpfc;                                           //~4C30I~
//  if (Ppcw->UCWrcsry<FILEHDRLINENO)                              //~v11NR~
    if (Ppcw->UCWrcsry<Ppcw->UCWfilehdrlineno)                     //~v11NI~
    {                                                              //~v09eI~
		plh=pfc->UFCcurtop;                                     //~4C30I~
//      if (Sulsrchsw)                                             //~v47iR~
        if (Popt)                                                  //~v47iI~
//      	offset=1;		//before client area                   //~v41rR~
        	offset=OFFS_TOP;		//before client area           //~v41rI~
	}                                                              //~v09eI~
	else                                                        //~4C30I~
		if (plh=(Ppcw->UCWpsd+Ppcw->UCWrcsry)->USDbuffc,plh)    //~4C30I~
		{                                                       //~4C30I~
	        if (Ppcw->UCWtype==UCWTDIR)     //on dir list       //~v05wI~
            {                                                   //~v05wI~
				if (Ppcw->UCWrcsrx>=UDHLINENOSZ)                //~v05wI~
				{                                               //~v05wI~
					rc=0;                                       //~v05wI~
					offset=Ppcw->UCWrcsrx-UDHLINENOSZ;          //~v05wI~
				}                                               //~v05wI~
			}                                                   //~v05wI~
            else                                                //~v05wI~
			if (Ppcw->UCWrcsrx>=Ppcw->UCWlinenosz)              //~v069R~
			{                                                   //~4C30I~
				rc=0;                                           //~4C30I~
				offset=pfc->UFCleft+Ppcw->UCWrcsrx-Ppcw->UCWlinenosz;//~v069R~
			}                                                   //~4C30I~
            else                                                //~4C30I~
            {                                                      //~v09eI~
				offset=pfc->UFCleft;                            //~4C30I~
                rc=1;		//on lineno fld                        //~v09eI~
			}                                                      //~v09eI~
//          if (Sulsrchsw)                                         //~v47iR~
//		    if (Popt)                                              //~v62dR~
  		    if (Popt && Popt!=LINE_SAMEMATCH)	//column is meaning for matching//~v62dR~
            	offset=0;		//on client area                   //~v09eI~
		}                                                       //~4C30I~
		else	//out of end of file                            //~4C30I~
		{                                                       //~4C30I~
			plh=UGETQPREV(UGETQEND(&pfc->UFCpfh->UFHlineque));  //~4C30I~
			offset=plh->ULHlen;                                 //~4C30I~
//          if (Sulsrchsw)                                         //~v47iR~
  		    if (Popt)                                              //~v47iI~
//          	offset=2;		//after client area                //~v41rR~
            	offset=OFFS_LAST;		//after client area        //~v41rI~
		}                                                       //~4C30I~
	*Ppplh=plh;                                                 //~4C30I~
	*Ppoffset=offset;                                           //~4C30I~
	return rc;                                                  //~4C30I~
}//fcmdgetstartplhoffs                                             //~v47iR~
