//*CID://+v66tR~:                             update#=  165;       //~v66tR~
//*************************************************************
//*xefcmd24.c                                                      //~v42hR~
//*  same,xx,ppsrch                                                //~v42hR~
//****************************************************************
//v66t:051119 (BUG) pair search match with dbcs 2nd byte for []{} search//~v66tI~
//v62f:050314 change matching specification "*= & n "-->"*=Mn"     //~v62fI~
//v62d:050312 matching cmd;find *= col1 col2 & ^* col3 col4        //~v62dI~
//v62b:050312 for -m[n] option of find cmd;assign mfwtbl for each pfh to avoid copy and copyback each time//~v62bI~
//v62a:050311 -m[n] option of find cmd to keep previous reverse;n:multi rev from next//~v62aI~
//v52i:030831 dos and os2 compiler waring                          //~v52iR~
//v49b:020623 support *= for not only "(i)x all" but also "(i)find"//~v49bI~
//v498:020617 XX cmd support .a .b                                 //~v498I~
//v494:020616 xx cmd;too many operand err chk                      //~v494I~
//v47h:020223 (BUG)compiler allow like as #endif//                 //~v47hI~
//            c1021 means no # allowd before identifier.           //~v47hI~
//            identifier is letter,digit,"_".                      //~v47hI~
//v47g:020223 (BUG)macro pair serach reverse offset err when cont type macro//~v47gI~
//v47f:020223 (BUG)macro pair serach err when nested backword search//~v47fI~
//            sequence of #if,#elid,#elsif,#else                   //~v47fI~
//v47e:020223 (BUG)macro pair serach err when nested backword search//~v47eI~
//            sequence of #else,#if,#endif                         //~v47eI~
//v45t:011215 #if/#endif pair search                               //~v45tI~
//v43h:011030 (BUG)no highlight pair when on the same line         //~v43hI~
//v42w:010929 pair-parenthesis search  by alt+, except excluded line//~v42wI~
//v42h:010929 pair-parenthesis search  by alt+.                    //~v42hI~
//v40L:010716 add option to "x *= all" of minimum same lineno      //~v40LI~
//v40z:010625 column range support for x =all(same as above)       //~v40zI~
//v40p:010603 add x *= (exclude same as above line)
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <ualloc.h>

#ifdef DOS
#else
#endif
//*******************************************************
#include <ulib.h>
#include <uque.h>
#include <uerr.h>
#include <uparse.h>
#include <ustring.h>
#include <ufile.h>
#include <uedit.h>
#include <utrace.h>

#include "xe.h"
#include "xescr.h"
#include "xefile.h"
#include "xefile2.h"
#include "xefile3.h"                                               //~v42hI~
#include "xefile6.h"
#include "xefunc.h"
#include "xefcmd2.h"
#include "xefcmd22.h"
#include "xefcmd24.h"                                              //~v498I~
#include "xefcmd3.h"                                               //~v498I~
#include "xelcmd.h"
#include "xelcmd2.h"
#include "xelcmd4.h"                                               //~v62dI~
#include "xeerr.h"
#include "xefsub.h"
//*******************************************************
#define MACTR          6                                           //~v45tI~
#define MAC_IF         0                                           //~v45tI~
#define MAC_IFDEF      1                                           //~v45tI~
#define MAC_IFNDEF     2                                           //~v45tI~
#define MAC_ELSE       3                                           //~v45tI~
#define MAC_ENDIF      4                                           //~v45tI~
#define MAC_ELIF       5                                           //~v45tI~
static char *Smacname[MACTR]={"if","ifdef","ifndef","else","endif","elif"};//~v45tR~
static int   Smacdest[MACTR]={1   ,1      ,1       ,0     ,-1     ,0     };//~v45tR~
static int   Smaclen [MACTR]={2   ,5      ,6       ,4     ,5      ,4     };//~v45tR~
                                                                   //~v45tI~
static char Snxsw=0;  //cmd id of NX search                        //~v42wR~
static int Soldkbdinpctr=0;	  //to chk continuous input            //~v45tI~
static int Sstartmacdest;	  //dest id by macro type              //~v45tR~
//*******************************************************
//****************************************************************
//LONG saasrchstring(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,PULINEH Pplhend,//~v49bR~
//					PULINEH *Ppplhs,PULINEH *Ppplhe,               //~v49bR~
//  				int Pcasesw,SHORT Prange1,SHORT Prange2);      //~v49bR~
int ppsrchsub(PUCLIENTWE Ppcw,PULINEH Pplh,int Poffset,int Pppsrch,int Pppsrch2,int Pdest);//~v42hI~
int ppsrchsub2(PUCLIENTWE Ppcw,PULINEH *Ppplh,int *Ppoffset,int Pppsrch,int Pppsrch2,int Pdest);//~v42hR~
int ppsrchmac(PUCLIENTWE Ppcw,PULINEH *Ppplh,int *Ppoffset,int *Ppmactype,int *Ppdest);//~v45tR~
int ppsrchmacrochk(int Pinitsw,PULINEH Pplh,int *Ppoffset,int *Prevlen,//~v45tI~
					int *Ppmactype,int *Ppdest,int *Pporgdest);    //~v45tI~
////****************************************************************//~v49bR~
////!fcmdxallsame                                                  //~v49bR~
////*find command                                                  //~v49bR~
////* parm1 :pcw                                                   //~v49bR~
////* parm2 :pfh                                                   //~v49bR~
////* parm3 :1:case sensitive                                      //~v49bR~
////* parm4 :column start                                          //~v49bR~
////* parm5 :column end                                            //~v49bR~
////* parm6 :minimum line count to be excluded(same line count -1) //~v49bR~
////* ret   :rc                                                    //~v49bR~
////****************************************************************//~v49bR~
//int fcmdxallsame(PUCLIENTWE Ppcw,PUFILEH Ppfh,int Pcasesw,       //~v49bR~
//                SHORT Prange1,SHORT Prange2,int Pminsame)        //~v49bR~
//{                                                                //~v49bR~
//    PULINEH plh,plhs,plhe,plh0,plhx,plhend;                      //~v49bR~
//    int rc;                                                      //~v49bR~
//    LONG xline,totxline=0;                                       //~v49bR~
////*********************************                              //~v49bR~
////*set linerange                                                 //~v49bR~
////  if (Ppcw->UCWtype!=UCWTFILE)                                 //~v49bR~
////  {                                                            //~v49bR~
////      uerrmsg("\"eXclude same line\" cmd is file screen only", //~v49bR~
////              "es̔\x95\\R}h̓t@Cʂł̂ݗL");//~v49bR~
////      return 4;                                                //~v49bR~
////  }                                                            //~v49bR~
//    plh=UGETQNEXT(UGETQTOP(&Ppfh->UFHlineque));                  //~v49bR~
//    rc=fcmdsetabrange(Ppcw,Ppfh,SUBCMD_ALL,&plh,&plhend);//set from/to plh//~v49bR~
////*plhend is next line of label                                  //~v49bR~
//    if (rc>=4)  //label err,not found                            //~v49bR~
//            return 4;                                            //~v49bR~
//    if (rc==2)  //label not found                                //~v49bR~
//        return 1;                                                //~v49bR~
////*search                                                        //~v49bR~
//    for (;;)                                                     //~v49bR~
//    {                                                            //~v49bR~
////      xline=saasrchstring(Ppcw,Ppfh,plh,plhend,&plhs,&plhe,Pcasesw,Prange1,Prange2);//~v49bR~
//        xline=0;    //no stop at minsame count                   //~v49bR~
//        rc=fcmdsamesrch(Ppcw,Ppfh,plh,plhend,&plhs,&plhe,Pcasesw,Prange1,Prange2,Pminsame,SUBCMD_ALL,&xline,1);//~v49bR~
////      if (!xline)                                              //~v49bR~
//        if (rc)         //not found                              //~v49bR~
//            break;                                               //~v49bR~
////    if (xline>=Pminsame)                                       //~v49bR~
////    {                                                          //~v49bR~
//        plhx=UGETQNEXT(plhs);   //exclude from next              //~v49bR~
//        if (lcmdexcsame(Ppcw,plhx,plhe)==UALLOC_FAILED)  //excluded one line//~v49bR~
//            return UALLOC_FAILED;                                //~v49bR~
//        if (!totxline)                                           //~v49bR~
//            plh0=plhs;                                           //~v49bR~
//        totxline+=xline;                                         //~v49bR~
////    }                                                          //~v49bR~
//        plh=UGETQNEXT(plhe);                                     //~v49bR~
//        if (plhend==plhe)    //reached to label end line         //~v49bR~
//            break;                                               //~v49bR~
//    }                                                            //~v49bR~
//    if (totxline)           //exclude/include occured            //~v49bR~
//    {                                                            //~v49bR~
//        UPCTRREQ(Ppfh);                                          //~v49bR~
//        fcmdscrollpage(Ppcw,plh0); //to 2nd line                 //~v49bR~
//        filesetcsr(Ppcw,plh0,0,0);      //csr set by lcmdexc     //~v49bR~
//        rc=0;                                                    //~v49bR~
//    }//first time                                                //~v49bR~
//    else                                                         //~v49bR~
//        rc=4;                                                    //~v49bR~
//    uerrmsg("Excluded %d lines",                                 //~v49bR~
//            "%d s \x95\\",                                //~v49bR~
//            totxline);                                           //~v49bR~
//    return rc;                                                   //~v49bR~
//}//fcmdxallsame                                                  //~v49bR~
//****************************************************************
//!fcmdsamesrch                                                    //~v49bR~
//*search same as above line                                       //~v49bR~
//* parm1 :pcw
//* parm2 :plh search start                                        //~v49bR~
//* parm3 :plh search end(next of label line)                      //~v49bR~
//* parm4 :output plh 1st same line                                //~v49bR~
//* parm5 :optional output plh last same line                      //~v49bR~
//* parm6 :case sw                                                 //~v49bR~
//* parm7 :col range start                                         //~v49bR~
//* parm8 :col range end                                           //~v49bR~
//* parm9 :same minimum count                                      //~v49bR~
//* parm10:subcmdid                                                //~v49bR~
//* parm11:input:search stop line count,optional output same line count//~v49bR~
//* parm12:excludesw                                               //~v49bI~
//*rc     :rc 0,4,UALLOC_FAILED;                                   //~v49bR~
//****************************************************************
//LONG saasrchstring(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,PULINEH Pplhend,//~v49bR~
int fcmdsamesrch(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,PULINEH Pplhend,//~v49bR~
					PULINEH *Ppplhs,PULINEH *Ppplhe,               //~v40zI~
//      			int Pcasesw,SHORT Prange1,SHORT Prange2)       //~v49bR~
        			int Pcasesw,SHORT Prange1,SHORT Prange2,int Pminsame,//~v49bR~
					int Psubcmdid,LONG *Psamelinectr,int Pexcludesw)//~v49bI~
{
	PULINEH plhs,plhe,plh;
	PULINEH plh2,plhn=0;                                           //~v52iR~
    int len,lens,rc;                                               //~v40zR~
    int stoplinectr;                                               //~v49bI~
    LONG xline;
//*****************
	if (Psamelinectr)                                              //~v49bI~
    	stoplinectr=*Psamelinectr;                                 //~v49bI~
    else                                                           //~v49bI~
    	stoplinectr=0;                                             //~v49bI~
    for (plh=Pplh;plh;)
    {
//      for (plhs=0,xline=0;plh;plh=UGETQNEXT(plh))                //~v49bR~
        for (plhs=0,xline=0;plh;plh=plhn)                          //~v49bR~
        {
            if (Psubcmdid==SUBCMD_PREV)                            //~v49bM~
				plhn=UGETQPREV(plh);                               //~v49bM~
            else                                                   //~v49bM~
				plhn=UGETQNEXT(plh);                               //~v49bM~
        	if (plh==Pplhend)                                      //~v40zI~
                break;                                             //~v40zI~
//          if (plh->ULHtype==ULHTEXCLUDE)	//exclude hdr          //~v49bR~
//          {                                                      //~v49bR~
//          	if (xline) 		//same line continuing             //~v49bR~
//              	break;                                         //~v49bR~
//          	for (;plh=UGETQNEXT(plh),plh;)                     //~v49bR~
//          		if (!UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED)) //skip exluded//~v49bR~
//              		break;                                     //~v49bR~
//          }                                                      //~v49bR~
            if (plh->ULHtype!=ULHTDATA)     //hdr nochk
                continue;
            if (!plh->ULHdbcs) //not displayed
                if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len
                    return UALLOC_FAILED;
            len=plh->ULHlen;
            if (!plhs)
            {
	            if (len<Prange1)	//short line                   //~v40zR~
    	        	continue;                                      //~v40zI~
              if (len>Prange2)                                     //~v40zR~
                lens=Prange2;                                      //~v40zI~
              else                                                 //~v40zI~
                lens=len;   //start line len
                plhs=plh;   //top data line
                continue;
            }
            if (len<Prange1)	//short line after 1st line        //~v40zR~
            	break;                                             //~v40zI~
          	if (len>Prange2)                                       //~v40zR~
          		len=Prange2;                                       //~v40zR~
            if (len!=lens)  //length match
                break;
            len-=Prange1;                                          //~v40zI~
            if (Pcasesw)
                rc=memcmp(plh->ULHdata+Prange1,plhs->ULHdata+Prange1,(UINT)len);//~v40zR~
            else
                rc=memicmp(plh->ULHdata+Prange1,plhs->ULHdata+Prange1,(UINT)len);//~v40zR~
            if (rc)        //same line
                break;
//          if (xline)                                             //~v49bR~
//          	lcmdclearlcmd(Ppfh,plh); //clear pending cmd for to be excluded//~v49bR~
            xline++;
            plhe=plh;		//last matched
            if (stoplinectr)                                       //~v49bI~
            	if (stoplinectr==xline)	//reached to stop line ctr //~v49bR~
                	break;                                         //~v49bI~
        }//until unmatch line appear
//      if (xline)                                                 //~v49bR~
        if (xline && xline>=Pminsame)                              //~v49bR~
        {                                                          //~v49bR~
        	if (Pexcludesw)                                        //~v49bI~
                for (plh2=plhs;plh2;plh2=plhn)                     //~v49bR~
                {                                                  //~v49bR~
            		if (Psubcmdid==SUBCMD_PREV)                    //~v49bI~
						plhn=UGETQPREV(plh2);                      //~v49bR~
            		else                                           //~v49bI~
						plhn=UGETQNEXT(plh2);                      //~v49bR~
                    lcmdclearlcmd(Ppfh,plh2); //clear pending cmd for to be excluded//~v49bR~
                    if (plh2==plhe)                                //~v49bR~
                        break;                                     //~v49bR~
                }                                                  //~v49bR~
        	break;                                                 //~v49bR~
        }                                                          //~v49bR~
        if (!plh)
        	break;
        if (plh==Pplhend)                                          //~v40zI~
            break;                                                 //~v40zI~
    }//until eof
    *Ppplhs=plhs;
  if (Ppplhe)                                                      //~v49bR~
    *Ppplhe=plhe;
    if (Psamelinectr)                                              //~v49bR~
    	*Psamelinectr=xline;                                       //~v49bR~
//  return xline;                                                  //~v49bR~
    if (!xline || xline<Pminsame)                                  //~v49bR~
        return 4;                                                  //~v49bR~
    return 0;                                                      //~v49bR~
}//fcmdsamesrch                                                    //~v49bR~
//**************************************************************** //~v62dI~
//!fcmdsamematch                                                   //~v62dI~
//*search word of 2nd scr file                                     //~v62dI~
//* parm1 :pcw                                                     //~v62dI~
//* parm2 :plh search start                                        //~v62dI~
//* parm3 :plh search end(next of label line)                      //~v62dI~
//* parm4 :case sw                                                 //~v62dI~
//* parm5 :col range start                                         //~v62dI~
//* parm6 :col range end                                           //~v62dI~
//* parm7 :subcmdid                                                //~v62dI~
//* parm8 :excludesw                                               //~v62dI~
//*rc     :rc 0:matched,1:bypass this line(not DATA),4:notf ,UALLOC_FAILED;//~v62dR~
//**************************************************************** //~v62dI~
int fcmdsamematch(PUCLIENTWE Ppcw,PUFILEH Ppfh,PUFILEH Ppfh2,PULINEH Pplh,PULINEH Pplhend,//~v62dI~
        		int Pcasesw,int Pexcludesw,SHORT Prange1,SHORT Prange2,int Pkeypos)//~v62fR~
{                                                                  //~v62dI~
	PULINEH plh;                                                   //~v62dR~
    char *psrc;                                                    //~v62dI~
    int  lens,rc,range1,range2,ulhlen;                             //~v62dR~
//*****************                                                //~v62dI~
    if (Pplh->ULHtype!=ULHTDATA)     //hdr nochk                   //~v62dI~
    	return 1;					//continue                     //~v62dI~
    if (!Pplh->ULHdbcs) //not displayed                            //~v62dI~
    	if (filechktabdbcs(Pplh)==UALLOC_FAILED)//expand data len  //~v62dI~
        	return UALLOC_FAILED;                                  //~v62dI~
    ulhlen=Pplh->ULHlen;                                           //~v62dI~
	if (ulhlen<Prange2)	//short line                               //~v62dI~
    	return 4;       //for ! search                             //~v62dI~
    psrc=Pplh->ULHdata+Prange1;                                    //~v62dI~
    lens=Prange2-Prange1;                                          //~v62dI~
    range1=Pkeypos;                                                //~v62fR~
    range2=range1+lens;	//same len as source                       //~v62dI~
    plh=UGETQTOP(&Ppfh2->UFHlineque);                              //~v62dR~
    for (;plh;plh=UGETQNEXT(plh))                                  //~v62fR~
    {                                                              //~v62dI~
    	if (plh->ULHtype!=ULHTDATA)     //hdr nochk                //~v62dR~
        	continue;                                              //~v62dR~
        if (!plh->ULHdbcs) //not displayed                         //~v62dR~
        	if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v62dR~
            	return UALLOC_FAILED;                              //~v62dR~
        ulhlen=plh->ULHlen;                                        //~v62dR~
	    if (ulhlen<range2)	//short line                           //~v62dR~
    		continue;                                              //~v62dR~
        if (Pcasesw)                                               //~v62dR~
            rc=memcmp(plh->ULHdata+range1,psrc,(UINT)lens);        //~v62dR~
        else                                                       //~v62dR~
            rc=memicmp(plh->ULHdata+range1,psrc,(UINT)lens);       //~v62dR~
        if (!rc)        //matched                                  //~v62dR~
            break;                                                 //~v62dR~
    }//until eof                                                   //~v62dI~
    if (plh)                                                       //~v62dI~
    {                                                              //~v62dI~
		lcmdshifterr(plh,0,0);//no exclude line highlight,no output 1st err line//~v62dI~
    	return 0;		//matched                                  //~v62dI~
    }                                                              //~v62dI~
    return 4;			//unmatch                                  //~v62dR~
}//fcmdsamematch                                                   //~v62dI~
//**************************************************************** //~v40LI~
// exclude line exchange                                           //~v40LI~
//*rc   :                                                          //~v40LI~
//**************************************************************** //~v40LI~
int func_xx_file(PUCLIENTWE Ppcw)                                  //~v40LI~
{                                                                  //~v40LI~
    PUFILEH pfh;                                                   //~v40LI~
    PULINEH plh,plh1,plh2=0,plhx;                                    //~v40LR~
    PULINEH plhend,plhn;                                           //~v498R~
    PUFILEC pfc;                                                   //~v40LI~
    int     rc,opdno,plhendsw=0;                                   //~v498R~
    long   xctr=0,nxctr=0;                                         //~v498I~
    long   incfctr=0;                                              //~v498I~
//*********************************                                //~v40LI~
//  if (Ppcw->UCWparm)		//operand                              //~v498R~
//  	return errtoomany();                                       //~v498R~
    opdno=Ppcw->UCWopdno;           //funccmd created already      //~v498I~
	pfc=Ppcw->UCWpfc;                                              //~v40LI~
	pfh=pfc->UFCpfh;                                               //~v40LI~
    if (pfh->UFHtype==UFHTKFI)	//menu opt file                    //~v40LI~
    	return 4;                                                  //~v40LI~
//*set linerange                                                   //~v498I~
    plh=UGETQTOP(&pfh->UFHlineque);//search from first if no label //~v498I~
    if (rc=fcmdgetabplh(Ppcw,pfh,&plh,&plhend,0),rc)//set from/to plh(0:end is plh on label)//~v498R~
    	return rc;                                                 //~v498I~
    if (plhend)                                                    //~v498I~
    {                                                              //~v498I~
    	if (opdno!=2)                                              //~v498I~
			return errtoomany();                                   //~v498I~
    }                                                              //~v498I~
    else                                                           //~v498I~
    	if (opdno)                                                 //~v498I~
			return errtoomany();                                   //~v498I~
    UPCTRREQ(pfh);                                                 //~v40LI~
//  plh=UGETQTOP(&pfh->UFHlineque);//search from first             //~v498R~
//for the case label plh is in excluded line                       //~v498I~
	if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))                     //~v498I~
        for(plhn=0;plh && UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED);plh=plhn)//~v498R~
        {                                                          //~v498I~
            plhn=UGETQNEXT(plh);    //                             //~v498I~
			if (lcmdincm(Ppcw,plh)==UALLOC_FAILED)	//display excluded line//~v498I~
                return UALLOC_FAILED;                              //~v498I~
            nxctr++;                                               //~v498I~
        	if (plh==plhend)                                       //~v498R~
            {                                                      //~v498I~
		        plhendsw=1;                                        //~v498I~
                break;                                             //~v498I~
            }                                                      //~v498I~
        }                                                          //~v498I~
  if (!plhendsw)                                                   //~v498I~
  {                                                                //~v498I~
    for (plh1=0;plh;)                                              //~v40LR~
	{                                                              //~v40LI~
        plhendsw=(plh==plhend);                                    //~v498I~
        switch(plh->ULHtype)                                       //~v40LI~
        {                                                          //~v40LI~
        case ULHTHDR:       	//hdr line                         //~v40LI~
	    	plh=UGETQNEXT(plh);                                    //~v40LI~
        	break;                                                 //~v40LI~
        case ULHTEXCLUDE:       //excluded line hdr                //~v40LI~
            plhx=plh;                                              //~v40LI~
		    plh=UGETQNEXT(plh);                                    //~v40LI~
            incfctr=0;                                             //~v498I~
			for(;plh && UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED);plh=UGETQNEXT(plh))//~v40LI~
            {                                                      //~v498I~
	        	nxctr++;                                           //~v40LI~
                incfctr++;                                         //~v498I~
        		if (plh==plhend)                                   //~v498I~
                {                                                  //~v498I~
        			plhendsw=2;                                    //~v498I~
                    break;                                         //~v498I~
                }                                                  //~v498I~
            }                                                      //~v498I~
          if (plhendsw==2)  //end at intermediate of excluded      //~v498I~
          {                                                        //~v498I~
			if (lcmdincf(Ppcw,plhx,(int)incfctr,0)==UALLOC_FAILED)	//excluded one line//~v52iR~
	        	return UALLOC_FAILED;                              //~v498I~
          }                                                        //~v498I~
          else                                                     //~v498I~
			if (lcmdincall(Ppcw,plhx,plhx,1)==UALLOC_FAILED)	//excluded one line//~v40LI~
	        		return UALLOC_FAILED;                          //~v40LI~
            if (plh1) 		//prev display line                    //~v40LR~
            {                                                      //~v40LI~
				if (lcmdexc(Ppcw,plh1,plh2,0)==UALLOC_FAILED)	//excluded one line//~v40LI~
	        		return UALLOC_FAILED;                          //~v40LI~
            	plh1=0;		//excluded previous display line       //~v40LI~
    		}	                                                   //~v40LI~
        	break;                                                 //~v40LI~
        default:				//not excluded data line           //~v40LI~
		    for (plh1=plh,plh2=0;plh;plh2=plh,plh=UGETQNEXT(plh))  //~v40LI~
            {                                                      //~v40LI~
				if (plh->ULHtype!=ULHTDATA)      //not displayed line//~v40LI~
                	break;                                         //~v40LI~
                xctr++;                                            //~v40LI~
        		if (plh==plhend)                                   //~v498I~
                {                                                  //~v498I~
                    plh2=plh;                                      //~v498I~
        			plhendsw=1;                                    //~v498I~
                    break;                                         //~v498I~
                }                                                  //~v498I~
            }                                                      //~v40LI~
		}                                                          //~v40LI~
        if (plhendsw)                                              //~v498I~
        	break;                                                 //~v498I~
	}//                                                            //~v40LI~
    if (plh1)       //prev display line                            //~v40LR~
        if (lcmdexc(Ppcw,plh1,plh2,0)==UALLOC_FAILED)   //excluded one line//~v40LI~
            return UALLOC_FAILED;                                  //~v40LI~
                                                                   //~v40LI~
  }                                                                //~v498I~
    UPCTRREQ(pfh);                                                 //~v40LI~
    uerrmsg("X=%ld,NX=%ld",0,                                      //~v40LI~
        		xctr,nxctr);                                       //~v40LI~
	return 0;                                                      //~v40LI~
}//func_xx_file                                                    //~v40LI~
//**************************************************************** //~v42wI~
// parethesis search except excluded                               //~v42wI~
//*rc   :                                                          //~v42wI~
//**************************************************************** //~v42wI~
int func_ppsrchnx(PUCLIENTWE Ppcw)                                 //~v42wI~
{                                                                  //~v42wI~
	int rc;                                                        //~v42wI~
//*********************************                                //~v42wI~
	Snxsw=1;                                                       //~v42wI~
	rc=func_ppsrch(Ppcw);                                          //~v42wR~
	Snxsw=0;                                                       //~v42wI~
    return rc;                                                     //~v42wI~
}//func_ppsrchnx                                                   //~v42wR~
//**************************************************************** //~v42hI~
// parethesis search                                               //~v42wR~
//*rc   :                                                          //~v42hI~
//**************************************************************** //~v42hI~
int func_ppsrch(PUCLIENTWE Ppcw)                                   //~v42hI~
{                                                                  //~v42hI~
#define COMMENT_SLASH      '/'                                     //~v42hR~
#define COMMENT_AST        '*'                                     //~v42hR~
#define MACRO_ID           '#'        //macro                      //~v45tI~
//static char Sparenid[]  ="()[]{}<>/*";                           //~v45tR~
static char Sparenid[]  ="()[]{}<>/*#";                            //~v45tI~
//static char Sparenid2[] =")(][}{><**";                           //~v45tR~
static char Sparenid2[] =")(][}{><**#";                            //~v45tI~
//static int  Sparendest[]={1,-1,1,-1,1,-1,1,-1,2,-2};             //~v45tR~
static int  Sparendest[]={1,-1,1,-1,1,-1,1,-1,2,-2,0};//dest and string len//~v45tI~
    PUFILEH pfh;                                                   //~v42hI~
    PULINEH plh;                                                   //~v42hR~
    PUFILEC pfc;                                                   //~v42hI~
	PUSCRD psd;                                                    //~v42hI~
	int offset;                                                    //~v42hR~
	int rc,ppsrch,ppsrch2,ppdest;                                  //~v42hR~
    int lrecl,ii;                                                  //~v42hR~
    int macrotype,revlen;                                          //~v45tR~
	UCHAR *pdata;                                                  //~v42hR~
//*********************************                                //~v42hI~
	pfc=Ppcw->UCWpfc;                                              //~v42hI~
	pfh=pfc->UFCpfh;                                               //~v42hI~
	if (UCBITCHK(pfh->UFHflag4,UFHF4BIN))                          //~v42hI~
    {                                                              //~v42hI~
    	uerrmsg("parenthesis search is not supported for binary file",//~v42hI~
        		"oCi[t@C͊ʒTł܂B");       //~v42hI~
        return 4;                                                  //~v42hI~
    }                                                              //~v42hI~
	if (!CSRONFILELINE(Ppcw))	//chk csr on file line             //~v42hI~
   		return errcsrpos();				//not on file client area  //~v42hR~
	psd=Ppcw->UCWpsd+Ppcw->UCWrcsry;                               //~v42hI~
    offset=pfc->UFCleft+Ppcw->UCWrcsrx-Ppcw->UCWlinenosz;          //~v42hI~
	plh=psd->USDbuffc;                                             //~v42hI~
    pdata=plh->ULHdata;                                            //~v42hI~
    lrecl=plh->ULHlen;                                             //~v42hI~
    if (offset>=lrecl)                                             //~v42hI~
    	return errcsrpos();			//no filedata                  //~v42hR~
    if (plh->ULHtype!=ULHTDATA)                                    //~v42hI~
        return errcsrpos();                                        //~v42hR~
//*chk srch char                                                   //~v42hI~
    ppsrch=*(pdata+offset);                                        //~v42hR~
    for (ii=0;ii<sizeof(Sparenid);ii++)                            //~v42hI~
    	if (ppsrch==Sparenid[ii])                                  //~v42hR~
        	break;                                                 //~v42hI~
    if (ii>=sizeof(Sparenid))                                      //~v42hI~
    {                                                              //~v42hI~
    	uerrmsg("\"%c\" is not a parenthesis.\"%s\".",             //~v42hR~
        		"\"%c\" ͊ʒTΏۊO\"%s\".",                  //~v42hR~
                ppsrch,Sparenid);                                  //~v42hI~
        return 4;                                                  //~v42hI~
    }                                                              //~v42hI~
    rc=0;                                                          //~v42hI~
    switch(ppsrch)                                                 //~v42hI~
    {                                                              //~v42hI~
    case COMMENT_SLASH:			// "/" of  "/*"                    //~v42hR~
    	if (offset>=lrecl-1 || *(pdata+offset+1)!=COMMENT_AST)     //~v42hR~
        	rc=4;                                                  //~v42hI~
    	break;                                                     //~v42hI~
    case COMMENT_AST:			//  "*" of "*/"                    //~v42hR~
    	if (offset>=lrecl-1 || *(pdata+offset+1)!=COMMENT_SLASH)   //~v42hR~
        	rc=4;                                                  //~v42hI~
    	break;                                                     //~v42hI~
    }                                                              //~v42hI~
    if (rc)                                                        //~v42hI~
    {                                                              //~v42hI~
        uerrmsg("Cursor is not on \"/*\" nor \"*/\"",0);           //~v42hR~
        return 4;                                                  //~v42hI~
    }                                                              //~v42hI~
    if (ppsrch==MACRO_ID)       //macro seach                      //~v45tI~
    {                                                              //~v45tI~
		if (ppsrchmacrochk(1,plh,&offset,&revlen,&macrotype,&ppdest,&Sstartmacdest))	//initial chk//~v45tR~
    		return 4;			//invalid macro stmt               //~v45tI~
        if (ppdest>0)                                              //~v45tI~
        	ppdest=revlen;                                         //~v45tI~
        else                                                       //~v45tI~
        	ppdest=-revlen;                                        //~v45tI~
        ppsrch2=macrotype;                                         //~v45tI~
    }                                                              //~v45tI~
    else                                                           //~v45tI~
    {                                                              //~v45tI~
    ppsrch2=Sparenid2[ii];                                         //~v42hR~
    ppdest=Sparendest[ii];                                         //~v42hI~
        Sstartmacdest=1;    //not use but avoid 0                  //~v45tI~
    }                                                              //~v45tI~
//search                                                           //~v42hI~
	if (rc=ppsrchsub(Ppcw,plh,offset,ppsrch,ppsrch2,ppdest),rc)    //~v42hR~
		return rc;                                                 //~v42hI~
	return 0;                                                      //~v42hI~
}//func_ppsrch                                                     //~v42hI~
//**************************************************************** //~v42hI~
// ppsrchsub                                                       //~v42hI~
// parm1:pcw                                                       //~v45tI~
// parm2:plh                                                       //~v45tI~
// parm3:start offset on plhdata                                   //~v45tI~
// parm4:one of pair                                               //~v45tI~
// parm5:another of pair to be serached/macro type for macro search//~v45tI~
// parm6:dest id and contain len of search word                    //~v45tR~
//*rc   :                                                          //~v42hI~
//**************************************************************** //~v42hI~
int ppsrchsub(PUCLIENTWE Ppcw,PULINEH Pplh,int Poffset,int Pppsrch,int Pppsrch2,int Pdest)//~v42hR~
{                                                                  //~v42hI~
	int offset,rc,width,scrollsz,nest;                             //~v42hR~
    int mactype,dest,locatesw;                                     //~v45tR~
    PULINEH plh;                                                   //~v42hI~
    PUFILEH pfh;                                                   //~v42hI~
    PUFILEC pfc;                                                   //~v42hI~
//**************************************                           //~v42hI~
	pfc=Ppcw->UCWpfc;                                              //~v42hM~
	pfh=pfc->UFCpfh;                                               //~v42hR~
	plh=Pplh;                                                      //~v42hR~
	offset=Poffset;                                                //~v42hR~
    nest=1;                                                        //~v42hI~
    mactype=Pppsrch2;	//for the case macro search                //~v45tI~
    dest=Pdest;                                                    //~v45tI~
    while(nest)                                                    //~v42hR~
    {                                                              //~v42hI~
      if (Pppsrch==MACRO_ID)                                       //~v45tR~
		rc=ppsrchmac(Ppcw,&plh,&offset,&mactype,&dest);//dest determined by macro itself//~v45tR~
      else                                                         //~v45tM~
      {                                                            //~v45tI~
	    if (Pdest>0)                                               //~v42hR~
    		offset+=Pdest;     //skip current char                 //~v42hI~
		rc=ppsrchsub2(Ppcw,&plh,&offset,Pppsrch,Pppsrch2,Pdest);   //~v42hI~
      }                                                            //~v45tI~
        switch(rc)                                                 //~v42hI~
        {                                                          //~v42hI~
        case UALLOC_FAILED:                                        //~v42hR~
        	return rc;                                             //~v42hI~
        case 0:			//found                                    //~v42hI~
        	nest--;                                                //~v42hI~
            break;                                                 //~v42hI~
        case 1:         //nested                                   //~v42hI~
        	nest++;                                                //~v42hI~
            rc=0;                                                  //~v42hI~
            break;                                                 //~v42hI~
        case 2:         //cont found(else etc);exit only when nest==1//~v45tI~
        	if (nest==1)	//same level                           //~v45tI~
            	nest=0;     //exit loop                            //~v45tR~
            rc=0;                                                  //~v45tI~
            break;                                                 //~v45tI~
        default:                                                   //~v42hI~
        	break;                                                 //~v42hI~
        }                                                          //~v42hI~
        if (rc)       //not found                                  //~v42hR~
            break;                                                 //~v42hI~
    }//nest loop                                                   //~v42hI~
    if (nest)                                                      //~v42hI~
    {                                                              //~v42hI~
    	uerrmsg("No corresponding for %c found(nest=%d)",          //~v47hR~
				"%c ̑肪܂(nest=%d)",              //~v47hR~
                Pppsrch,nest);                                     //~v42hR~
        return 4;                                                  //~v42hI~
    }                                                              //~v42hI~
	if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))                     //~v42hI~
    {                                                              //~v42hI~
        UPCTRREQ(pfh);                                             //~v42hR~
		if (lcmdincm(Ppcw,plh)==UALLOC_FAILED)	//display excluded line//~v42hI~
        	return UALLOC_FAILED;                                  //~v42hI~
    	UPCTRREQ(pfh);                                             //~v42hR~
	}                                                              //~v42hI~
//*move page to the line if not on current page                    //~v42hI~
	fcmdscrollpagemid(Ppcw,plh);                                   //~v42hI~
	width=Ppcw->UCWwidth-Ppcw->UCWlinenosz;                        //~v42hI~
	if (offset<pfc->UFCleft                                        //~v42hI~
	|| 	offset>=pfc->UFCleft+width)                                //~v42hI~
    {                                                              //~v42hI~
        if (UCBITCHK(pfh->UFHflag2,UFHF2SPFNUMOK))                 //~v42hI~
        {                                                          //~v42hI~
            if (offset>=pfc->UFCleft+width)                        //~v42hI~
                filepgrighthalf(Ppcw);                             //~v42hI~
        }                                                          //~v42hI~
        else                                                       //~v42hI~
        {                                                          //~v42hI~
            scrollsz=filehalfhscrollsz(Ppcw);//half scroll size    //~v42hI~
            pfc->UFCleft=max(0,(offset/scrollsz)*scrollsz-scrollsz);//~v42hI~
            UCBITON(Ppcw->UCWflag,UCWFDRAW);                       //~v42hI~
        }                                                          //~v42hI~
    }                                                              //~v42hI~
	filesetcsr(Ppcw,plh,1,offset-pfc->UFCleft);//csr set           //~v42hI~
//  plh->ULHrevoffs=(USHORT)offset;                                //~v43hR~
    if (Pdest<0)                                                   //~v45tR~
        Pdest=-Pdest;                                              //~v45tR~
  	if (Pppsrch!=MACRO_ID)                                         //~v45tI~
    	dest=Pdest;                                                //~v45tI~
    if (dest<0)                                                    //~v45tM~
        dest=-dest;                                                //~v45tM~
//  plh->ULHrevlen=(USHORT)Pdest;//reverse len  //same upctr as prev//~v43hR~
//  UCBITOFF(plh->ULHflag2,ULHF2MFOUND);//reset multiple           //~v43hR~
//  plh->ULHrevctr=pfh->UFHfindctr;//find cmd ctr for disply current;//~v43hR~
//  UCBITON(plh->ULHflag,ULHFDRAW|ULHFCURFOUND);//draw word after wordrep//~v43hR~
//  UCBITOFF(plh->ULHflag,ULHFCURCAP);//reset hilight reason cap   //~v43hR~
//  fcmdsetfindhighlight(pfh,Pplh,1,0, 	//1:locate,0:no linesrch   //~v45tR~
    if (!Sstartmacdest		//start from else etc                  //~v45tR~
    &&  (Soldkbdinpctr+1)==Gkbdinpctr)	//continued input          //~v45tR~
    	locatesw=0;                                                //~v45tI~
    else                                                           //~v45tI~
    	locatesw=1;                                                //~v45tI~
    locatesw|=FCMDSFHOPT_NOMULTIREV;        //reset multiple reverse//~v62aI~
    fcmdsetfindhighlight(pfh,Pplh,locatesw,0, 	//1:locate,0:no linesrch//~v45tI~
			Poffset,Pdest,0);			//no span ;first char      //~v43hR~
//  fcmdsetfindhighlight(pfh,plh,0,0, 	//0:no locate,0:no linesrch//~v62aR~
    fcmdsetfindhighlight(pfh,plh,FCMDSFHOPT_NOMULTIREV,0, 	//0:no locate,0:no linesrch//~v62aI~
//  		offset,Pdest,0);			//no span                  //~v45tR~
    		offset,dest,0);			//no span                      //~v45tI~
//  if (fcmdcpymfwt(pfh))                                          //~v62bR~
//      return 8;                                                  //~v62bR~
	Soldkbdinpctr=Gkbdinpctr;	//save for double ESC chk          //~v45tI~
	return 0;                                                      //~v42hR~
}//ppsrchsub                                                       //~v42hI~
//**************************************************************** //~v42hI~
// ppsrchsub2                                                      //~v43hR~
//*rc   :                                                          //~v42hI~
//**************************************************************** //~v42hI~
int ppsrchsub2(PUCLIENTWE Ppcw,PULINEH *Ppplh,int *Ppoffset,int Pppsrch,int Pppsrch2,int Pdest)//~v42hR~
{                                                                  //~v42hI~
	int offset,rc,srchlen,nestsw=0;                                //~v42hR~
    PULINEH plh;                                                   //~v42hI~
    UCHAR *pc,*pcd,*pcnest;                                        //~v42hR~
//**************************************                           //~v42hI~
	plh=*Ppplh;                                                    //~v42hI~
	offset=*Ppoffset;                                              //~v42hI~
	if (Pdest<0)                                                   //~v42hI~
	{                                                              //~v42hI~
    	Pdest=-Pdest;  		//0 or 1                               //~v42hI~
        for (;plh;(plh=UGETQPREV(plh))?offset=plh->ULHlen:0)       //~v42hI~
        {                                                          //~v42hI~
            if (plh->ULHtype!=ULHTDATA)                            //~v42hI~
                continue;                                          //~v42hI~
            if (Snxsw) 				//not excluded search          //~v42wI~
				if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))         //~v42wI~
	                continue;                                      //~v42wI~
            if (offset<Pdest-1)   //may not match                  //~v42hI~
                continue;                                          //~v42hI~
            for (;;)                                               //~v42hI~
            {                                                      //~v42hI~
                pc=plh->ULHdata;                                   //~v42hI~
                pcd=plh->ULHdbcs;                                  //~v42hI~
                if (Pppsrch2!=COMMENT_AST)     //nest chk require  //~v42hR~
//              	pcnest=umemrchr(pc,(UCHAR)Pppsrch,(UINT)offset);//nest chk//~v66tR~
                	pcnest=umemrchr2(pc,(UCHAR)Pppsrch,(UINT)offset);//nest chk//~v66tI~
                else                                               //~v42hI~
                	pcnest=0;                                      //~v42hR~
//              pc=umemrchr(pc,(UCHAR)Pppsrch2,(UINT)offset);      //~v66tR~
                pc=umemrchr2(pc,(UCHAR)Pppsrch2,(UINT)offset);     //~v66tI~
                if (pcnest)                                        //~v42hI~
                	if (pc<pcnest)                                 //~v42hI~
                    {                                              //~v42hI~
                        pc=pcnest;                                 //~v42hI~
                        nestsw=1;                                  //~v42hI~
                    }                                              //~v42hI~
                if (pc)                                            //~v42hI~
                	if (Pppsrch2==COMMENT_AST)     //csr on "*/"   //~v42hR~
                    {                                              //~v42hI~
                		if (pc==plh->ULHdata                       //~v42hI~
                        ||  *(pc-1)!=COMMENT_SLASH)                //~v42hI~
                        	pc=0;		//not "/*"                 //~v42hI~
                    }                                              //~v42hI~
                rc=0;                                              //~v42hI~
                if (!pc||pcd)   //not found or found under tab expanded//~v42hI~
                    break;                                         //~v42hI~
                rc=filechktabdbcs(plh);    //no tab or tab processed//~v42hI~
                if (rc==UALLOC_FAILED)                             //~v42hI~
                    return UALLOC_FAILED;                          //~v42hI~
                offset=plh->ULHlen; //after tab expand for nor csr line//~v42hI~
            }//for                                                 //~v42hI~
            if (pc) //found last                                   //~v42hI~
            {                                                      //~v42hI~
                offset=(int)((ULONG)pc-(ULONG)plh->ULHdata);       //~v42hI~
                if (Pppsrch2==COMMENT_AST)     //csr on "*/"       //~v42hR~
                    offset --;          //to "/" of "/*"           //~v42hI~
                break;                                             //~v42hI~
            }                                                      //~v42hI~
        }//all plh                                                 //~v42hI~
	}//prev                                                        //~v42hI~
	else			//not prev                                     //~v42hI~
	{				//next                                         //~v42hI~
        for (;plh;plh=UGETQNEXT(plh),offset=0)                     //~v42hI~
        {                                                          //~v42hI~
            if (plh->ULHtype!=ULHTDATA)                            //~v42hI~
                continue;                                          //~v42hI~
            if (Snxsw) 				//not excluded search          //~v42wI~
				if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))         //~v42wI~
	                continue;                                      //~v42wI~
            if (plh->ULHlen-offset<Pdest)   //may not match        //~v42hI~
                continue;                                          //~v42hI~
            for (;;)                                               //~v42hI~
            {                                                      //~v42hI~
                pc=plh->ULHdata;                                   //~v42hI~
                pcd=plh->ULHdbcs;                                  //~v42hI~
                pc+=offset;                                        //~v42hI~
                srchlen=plh->ULHlen-offset;                        //~v42hI~
                if (Pppsrch2!=COMMENT_AST)     //nest chk require  //~v42hR~
//              	pcnest=memchr(pc,Pppsrch,(UINT)srchlen);//nest chk//~v66tR~
                	pcnest=umemchr2(pc,(char)Pppsrch,(UINT)srchlen);//nest chk//+v66tR~
                else                                               //~v42hI~
                	pcnest=0;                                      //~v42hR~
//              pc=memchr(pc,Pppsrch2,(UINT)srchlen);              //~v66tR~
                pc=umemchr2(pc,(char)Pppsrch2,(UINT)srchlen);      //+v66tR~
                if (pcnest)                                        //~v42hI~
					if (!pc || pc>pcnest)                          //~v42hI~
                	{                                              //~v42hI~
                        nestsw=1;                                  //~v42hI~
                        pc=pcnest;                                 //~v42hI~
                    }                                              //~v42hI~
                if (pc)                                            //~v42hI~
                	if (Pppsrch2==COMMENT_AST)     //csr on "/*"   //~v42hR~
                    {                                              //~v42hI~
                		if (pc==plh->ULHdata+plh->ULHlen-1         //~v42hI~
                        ||  *(pc+1)!=COMMENT_SLASH)                //~v42hI~
                        	pc=0;		//not "*/"                 //~v42hI~
                    }                                              //~v42hI~
                rc=0;                                              //~v42hI~
                if (!pc || pcd)                                    //~v42hI~
                    break;                                         //~v42hI~
                rc=filechktabdbcs(plh);                            //~v42hI~
                if (rc==UALLOC_FAILED)                             //~v42hI~
                    return UALLOC_FAILED;                          //~v42hI~
                offset=0;                                          //~v42hI~
            }//for                                                 //~v42hI~
            if (pc)                                                //~v42hI~
            {                                                      //~v42hI~
                offset=(int)((ULONG)pc-(ULONG)plh->ULHdata);       //~v42hI~
                break;                                             //~v42hI~
            }                                                      //~v42hI~
        }//all plh                                                 //~v42hI~
    }//prev/next                                                   //~v42hI~
    if (!plh)                                                      //~v42hI~
    	return 4;                                                  //~v42hI~
    *Ppplh=plh;                                                    //~v42hI~
    *Ppoffset=offset;                                              //~v42hI~
    return nestsw;                                                 //~v42hI~
}//ppsrchsub2                                                      //~v42hI~
//**************************************************************** //~v45tI~
// ppsrchmac                                                       //~v45tR~
// search for macro                                                //~v45tI~
//   # must be first char(preceding allowed is space and tab)      //~v45tI~
//parm1:pce                                                        //~v45tI~
//parm2:&plh                                                       //~v45tR~
//parm3:&offset found offset of #                                  //~v45tR~
//parm4:current line macrotype                                     //~v45tI~
//parm5:&dest(dest and reverse len)                                //~v45tR~
//*rc   :0:found,1:nest found,2:found but continue(else etc),      //~v45tR~
//       4:reached to eof                                          //~v45tI~
//**************************************************************** //~v45tI~
int ppsrchmac(PUCLIENTWE Ppcw,PULINEH *Ppplh,int *Ppoffset,int *Ppmactype,int *Ppdest)//~v45tR~
{                                                                  //~v45tI~
	int offset,rc,dest,nestsw=0,mactype,revlen;                    //~v45tR~
    PULINEH plh;                                                   //~v45tI~
//**************************************                           //~v45tI~
	plh=*Ppplh;                                                    //~v45tI~
    dest=*Ppdest;                                                  //~v45tI~
    mactype=*Ppmactype;                                            //~v45tI~
	if (dest<0)                                                    //~v45tI~
	{                                                              //~v45tI~
        for (;plh=UGETQPREV(plh),plh;)                             //~v45tR~
        {                                                          //~v45tI~
            if (plh->ULHtype!=ULHTDATA)                            //~v45tI~
                continue;                                          //~v45tI~
            if (Snxsw) 				//not excluded search          //~v45tI~
				if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))         //~v45tI~
	                continue;                                      //~v45tI~
            if (ppsrchmacrochk(0,plh,&offset,&revlen,&mactype,0,0))//next line search//~v45tR~
                continue;                                          //~v45tI~
//macro line found                                                 //~v45tI~
            switch(*Ppmactype)                                     //~v45tR~
            {                                                      //~v45tI~
            case  MAC_ELSE:         //-->else                      //~v45tI~
                switch(mactype)                                    //~v45tI~
                {                                                  //~v45tI~
                case  MAC_ELSE:                                    //~v45tI~
                    nestsw=4;       //else-->else;err              //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ENDIF:                                   //~v45tI~
                    nestsw=1;       //endif-->else;nested          //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ELIF:                                    //~v45tI~
//                  nestsw=0;       //elif-->else;found cont       //~v47fR~
                    nestsw=2;       //elif-->else;found cont       //~v47fI~
                    break;                                         //~v45tI~
                default:            //if,ifdef,ifndef              //~v45tI~
                    nestsw=0;       //if -->else;found             //~v45tI~
                }                                                  //~v45tI~
                break;                                             //~v45tI~
            case  MAC_ENDIF:        //-->endif                     //~v45tI~
                switch(mactype)                                    //~v45tI~
                {                                                  //~v45tI~
                case  MAC_ELSE:                                    //~v45tI~
                    nestsw=2;       //else-->endif;cont found      //~v45tR~
                    break;                                         //~v45tI~
                case  MAC_ENDIF:                                   //~v45tI~
                    nestsw=1;       //endif-->endif;nested         //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ELIF:                                    //~v45tI~
//                  nestsw=0;       //elif-->endif;found           //~v47fR~
                    nestsw=2;       //elif-->endif;cont found      //~v47fI~
                    break;                                         //~v45tI~
                default:            //if,ifdef,ifndef              //~v45tI~
                    nestsw=0;       //if-->endif;found             //~v45tI~
                }                                                  //~v45tI~
                break;                                             //~v45tI~
            default:				//-->elif                      //~v45tI~
                switch(mactype)                                    //~v45tI~
                {                                                  //~v45tI~
                case  MAC_ELSE:                                    //~v45tI~
                  if (*Ppmactype==MAC_ELIF)                        //~v47eI~
                    nestsw=4;       //else-->elif;err              //~v45tI~
                  else                                             //~v47eI~
                    nestsw=2;       //else-->if                    //~v47eI~
                    break;                                         //~v45tI~
                case  MAC_ENDIF:                                   //~v45tI~
                    nestsw=1;       //endif-->elif;nested          //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ELIF:                                    //~v45tI~
                    nestsw=2;       //elif-->elif;cont found       //~v45tR~
                    break;                                         //~v45tI~
                default:            //if,ifdef,ifndef              //~v45tI~
                    nestsw=0;       //if-->elif;found              //~v45tI~
                }                                                  //~v45tI~
                break;                                             //~v45tI~
            }//by Pmactype                                         //~v45tR~
            break;                                                 //~v45tI~
        }//all plh                                                 //~v45tI~
	}//prev                                                        //~v45tI~
	else			//not prev                                     //~v45tI~
	{				//next                                         //~v45tI~
        for (;plh=UGETQNEXT(plh),plh;)                             //~v45tI~
        {                                                          //~v45tI~
            if (plh->ULHtype!=ULHTDATA)                            //~v45tI~
                continue;                                          //~v45tI~
            if (Snxsw) 				//not excluded search          //~v45tI~
				if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))         //~v45tI~
	                continue;                                      //~v45tI~
            if (ppsrchmacrochk(0,plh,&offset,&revlen,&mactype,0,0))//next line search//~v45tR~
                continue;                                          //~v45tI~
            switch(*Ppmactype)                                     //~v45tI~
            {                                                      //~v45tI~
            case  MAC_ELSE:         //else-->                      //~v45tR~
                switch(mactype)                                    //~v45tI~
                {                                                  //~v45tI~
                case  MAC_ELSE:                                    //~v45tI~
                    nestsw=4;       //else-->else;err              //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ENDIF:                                   //~v45tI~
                    nestsw=0;       //else-->endif;found           //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ELIF:                                    //~v45tI~
                    nestsw=4;       //else-->elif;err              //~v45tI~
                    break;                                         //~v45tI~
                default:            //if,ifdef,ifndef              //~v45tI~
                    nestsw=1;       //else-->if;nested             //~v45tI~
                }                                                  //~v45tI~
                break;                                             //~v45tI~
            case  MAC_ELIF: 		//elif-->                      //~v45tR~
                switch(mactype)                                    //~v45tI~
                {                                                  //~v45tI~
                case  MAC_ELSE:                                    //~v45tI~
                    nestsw=2;       //elif-->else;cont found       //~v45tR~
                    break;                                         //~v45tI~
                case  MAC_ENDIF:                                   //~v45tI~
                    nestsw=0;       //elif-->endif;found           //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ELIF:                                    //~v45tI~
                    nestsw=2;       //elif-->elif;cont found       //~v45tR~
                    break;                                         //~v45tI~
                default:            //if,ifdef,ifndef              //~v45tI~
                    nestsw=1;       //elif-->if;nested             //~v45tI~
                }                                                  //~v45tI~
                break;                                             //~v45tI~
            default:            //if,ifdef,ifndef                  //~v45tI~
                switch(mactype)     //if-->                        //~v45tI~
                {                                                  //~v45tI~
                case  MAC_ELSE:                                    //~v45tI~
                    nestsw=2;       //if-->else;cont found         //~v45tR~
                    break;                                         //~v45tI~
                case  MAC_ENDIF:                                   //~v45tI~
                    nestsw=0;       //if-->endif;found             //~v45tI~
                    break;                                         //~v45tI~
                case  MAC_ELIF:                                    //~v45tI~
                    nestsw=2;       //if-->elif;cont found         //~v45tR~
                    break;                                         //~v45tI~
                default:            //if,ifdef,ifndef              //~v45tI~
                    nestsw=1;       //if-->if;nested               //~v45tI~
                }                                                  //~v45tI~
            }//by Pmactype                                         //~v45tR~
            break;                                                 //~v45tI~
        }//all plh                                                 //~v45tI~
    }//prev/next                                                   //~v45tI~
    if (!plh)                                                      //~v45tI~
    	return 4;                                                  //~v45tI~
    if (!plh->ULHdbcs)                                             //~v45tI~
//      if (!nestsw)        //found                                //~v47gR~
        if (!nestsw||nestsw==2)        //found or cont             //~v47gR~
        {                                                          //~v45tI~
            rc=filechktabdbcs(plh); //expand tab                   //~v45tI~
            if (rc==UALLOC_FAILED)                                 //~v45tI~
                return UALLOC_FAILED;                              //~v45tI~
            ppsrchmacrochk(0,plh,&offset,&revlen,&mactype,0,0);//next line search//~v45tR~
        }                                                          //~v45tI~
    *Ppplh=plh;                                                    //~v45tI~
    *Ppoffset=offset;                                              //~v45tI~
    *Ppmactype=mactype;                                            //~v45tI~
    if (dest>0)                                                    //~v45tR~
	    *Ppdest=revlen;                                            //~v45tI~
    else                                                           //~v45tI~
	    *Ppdest=-revlen;                                           //~v45tI~
    return nestsw;                                                 //~v45tI~
}//ppsrchmac                                                       //~v45tI~
//**************************************************************** //~v45tI~
// ppsrchmacrochk                                                  //~v45tI~
// chk macro statement                                             //~v45tI~
//   # must be first char(preceding allowed is space and tab)      //~v45tI~
//parm1:initial sw; 1:initial chk of csr pos, 0:next line macro search//~v45tI~
//parm2:plh                                                        //~v45tI~
//parm3:&offset of #                                               //~v45tI~
//parm4:&reverse len;until next space                              //~v45tI~
//parm5:&macro type                                                //~v45tI~
//parm6:&dest,set at init case                                     //~v45tR~
//parm7:original dest by mac type                                  //~v45tI~
//*rc   :1:not macro line,4:non space before macro or invalid macro//~v45tI~
//**************************************************************** //~v45tI~
int ppsrchmacrochk(int Pinitsw,PULINEH Pplh,int *Ppoffset,int *Pprevlen,//~v45tR~
					int *Ppmactype,int *Ppdest,int *Pporgdest)     //~v45tR~
{                                                                  //~v45tI~
static int  Sprevdest=0;                                           //~v45tI~
	int ii,maclen,rlen,plhlen,offset,skiplen,dest;                 //~v45tR~
    char *pdata0,*pdata;                                           //~v45tI~
//**************************************                           //~v45tI~
	offset=*Ppoffset;                                              //~v45tI~
    pdata=pdata0=Pplh->ULHdata;                                    //~v45tI~
    plhlen=Pplh->ULHlen;                                           //~v45tI~
//chk space before csr                                             //~v45tI~
    if (Pinitsw)                                                   //~v45tI~
    {                                                              //~v45tI~
		if (offset)			//csr pos is #                         //~v45tR~
    		if ((int)ustrnspn(pdata," \t",(UINT)offset)!=offset)   //~v45tR~
        	{                                                      //~v45tI~
        		uerrmsg("Non-space char before",                   //~v45tI~
            			"Oɋ󔒈ȊO̕");                     //~v45tI~
            	return 4;                                          //~v45tI~
            }                                                      //~v45tI~
        pdata+=offset;                                             //~v45tR~
    }                                                              //~v45tI~
    else                                                           //~v45tI~
    {                                                              //~v45tI~
	    pdata+=ustrnspn(pdata," \t",(UINT)plhlen);                 //~v45tI~
        if (*pdata!=MACRO_ID)                                      //~v45tI~
        	return 1;		//bypass line                          //~v45tI~
    }                                                              //~v45tI~
//chk macro stmt                                                   //~v45tI~
    *Ppoffset=(int)((ULONG)pdata-(ULONG)pdata0);	//offset of #  //~v47hR~
    pdata++;	//next of #                                        //~v45tI~
    rlen=plhlen-*Ppoffset-1;            //len after #              //~v45tI~
    skiplen=(int)ustrnspn(pdata," \t",(UINT)rlen);                 //~v47hR~
    pdata+=skiplen;                                                //~v45tI~
    rlen-=skiplen;                                                 //~v45tI~
    for (ii=0;ii<MACTR;ii++)                                       //~v45tI~
    {                                                              //~v45tI~
        maclen=Smaclen[ii];                                        //~v45tI~
    	if (rlen>=maclen                                           //~v45tR~
		&& !memcmp(Smacname[ii],pdata,(UINT)maclen)                //~v45tI~
//  	&& (rlen==maclen||*(pdata+maclen)==' '||*(pdata+maclen)=='\t'))//~v47hR~
    	&& (rlen==maclen||                                         //~v47hI~
                   (*(pdata+maclen)!='_' && !isalnum(*(pdata+maclen)))))//~v47hR~
        	break;                                                 //~v45tI~
    }                                                              //~v45tI~
    if (ii>=MACTR)	//notfound                                     //~v45tR~
    {                                                              //~v62fI~
    	if (Pinitsw)                                               //~v45tI~
        {                                                          //~v45tI~
        	uerrmsg("Not a valid macro stmt to be searched",       //~v45tI~
                "TΏۊÕ}N");                           //~v45tI~
        	return 4;                                              //~v45tI~
        }                                                          //~v45tI~
        else                                                       //~v45tI~
        	return 1;                                              //~v45tI~
    }                                                              //~v62fR~
    *Ppmactype=ii;		//macro type                               //~v45tI~
    if (Pinitsw)                                                   //~v45tR~
    {                                                              //~v45tI~
		dest=Smacdest[ii];                                         //~v45tI~
        if (Pporgdest)                                             //~v45tI~
        	*Pporgdest=dest;                                       //~v45tI~
        if (!dest)                                                 //~v45tI~
        {                                                          //~v45tI~
		    dest=Sprevdest;                                        //~v45tR~
            if (!dest)                                             //~v45tI~
                dest=1;     //at first                             //~v45tI~
        }                                                          //~v45tI~
        if (Ppdest)                                                //~v45tI~
        	*Ppdest=dest;                                          //~v45tI~
		Sprevdest=dest;                                            //~v45tI~
    }                                                              //~v45tI~
    if (Pprevlen)                                                  //~v45tI~
    	*Pprevlen=(int)((ULONG)pdata-(ULONG)pdata0+maclen-*Ppoffset);//~v47hR~
	return 0;                                                      //~v45tI~
}//ppsrchmacrochk                                                  //~v45tI~
//**************************************************************** //~v498I~
// get label plh                                                   //~v498I~
//* parm1:pcw                                                      //~v498I~
//* parm2:pfh                                                      //~v498I~
//* parm3:output start plh                                         //~v498I~
//* parm4:output end   plh;0 if no label specified                 //~v498I~
//* parm5:option;1:set endplh to next of label plh                 //~v498I~
//*rc   :0                                                         //~v498I~
//**************************************************************** //~v498I~
int fcmdgetabplh(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH *Pplhs,PULINEH *Pplhe,int Popt)//~v498I~
{                                                                  //~v498I~
    int ii,opdno;                                                  //~v498I~
	UCHAR *pc;                                                     //~v498I~
    int lblcnt=0;                                                  //~v498I~
    UCHAR labelt[2][ULHLINENOSZ+1];                                //~v498I~
    PULINEH plht[2];			//output of lcmdgetabplh           //~v498I~
    int rc;                                                        //~v498I~
//*********************************                                //~v498I~
	*Pplhe=0;						//for the case no label        //~v498R~
    opdno=Ppcw->UCWopdno;           //funccmd created already      //~v498I~
    pc=Ppcw->UCWopdpot;                                            //~v498I~
	for (ii=0;ii<opdno;ii++,pc+=strlen(pc)+1)	//next operand addr//~v498I~
	{                                                              //~v498I~
      	if (*pc!=ULCCMDLABEL)    //start by '.'                    //~v498I~
        	continue;                                              //~v498I~
        if (lblcnt>=2)                                             //~v498I~
            return fcmdlabelerr(pc);                               //~v498I~
        strncpy(labelt[lblcnt],pc,ULHLINENOSZ);                    //~v498I~
        labelt[lblcnt][ULHLINENOSZ]=0;                             //~v498I~
        lblcnt++;                                                  //~v498I~
	}//loop by operand no                                          //~v498I~
	if (!lblcnt)	//odd number                                   //~v498I~
    	return 0;                                                  //~v498I~
    if (lblcnt!=2)                                                 //~v498R~
    	return fcmdlabelerr("Need From/To");                       //~v498I~
    if (rc=fcmdgetlabelrange(Ppfh,lblcnt,labelt,plht,Popt),rc)	//1:get next of label//~v498R~
    	return rc;                                                 //~v498I~
    *Pplhs=plht[0];  //start plh                                   //~v498I~
    *Pplhe=plht[1];  //endplh(o next of endplh)                    //~v498I~
	return 0;                                                      //~v498I~
}//fcmdgetabplh                                                    //~v498I~
//**************************************************************** //~v62dI~
//  get 2nd scr pfh for matching                                   //~v62dI~
//*ret :pfh or 0 if err                                            //~v62dI~
//**************************************************************** //~v62dI~
//PUFILEH fcmdget2ndpfh(PUCLIENTWE Ppcw)                           //~v62fR~
PUFILEH fcmdget2ndpfh(PUCLIENTWE Ppcw,char *Pparm)                 //~v62fI~
{                                                                  //~v62dI~
	PUCLIENTWE pcw;                                                //~v62dI~
	PUFILEH    pfh;                                                //~v62dI~
//*********************************                                //~v62dI~
    pcw=scrgetcw(-1);  //another screen                            //~v62dI~
    if (!pcw)                                                      //~v62dI~
    {                                                              //~v62dI~
//      errscrnotsplited();                                        //~v62fR~
        errscrnotsplited(Pparm);                                   //~v62fI~
        return 0;                                                  //~v62dI~
    }                                                              //~v62dI~
    if (pcw->UCWtype!=UCWTFILE)                                    //~v62dI~
    {                                                              //~v62dI~
//      err2ndscrisnotfile();                                      //~v62fR~
        err2ndscrisnotfile(Pparm);                                 //~v62fI~
        return 0;                                                  //~v62dI~
    }                                                              //~v62dI~
    pfh=UGETPFHFROMPCW(pcw);                                       //~v62dI~
    return pfh;                                                    //~v62dI~
}//fcmget2ndpfh                                                    //~v62dI~
