//*CID://+v71UR~:                             update#=   36;       //~v71UR~
//*************************************************************
//*xefile6.c  *                                                 //~v04dR~
//* tab                                                            //~v0bzR~
//*************************************************************
//v71U:061112 (BUG)accept insert in short(<mergin) record of margined file//~v71UI~
//            even if result is over margin but overflow is space only//~v71UI~
//v66f:051021 support standard mode cut & paste,assign Ctrl+v for stream insert.(split xecap.c to xecap2.c)//~v66fI~
//                     None   OpenBlock  ClosedBlock   OpenRegion ClosedRegion//~v66fI~
//            C+v    RgnIns   NoBlockErr BlockClearRep OpenRgnErr RgnDel+Ins//~v66fI~
//            A+Ins  BlockIns NoBlockErr GetBlock+Ins  OpenRgnErr RgnDel+Ins//~v66fI~
//            A+Rep  BlockRep NoBlockErr GetBlock+Rep  OpenRgnErr RgnDel+Ins//~v66fI~
//v61x:050308 xprint for binfile(rep to "." from crlf etc ctlchar) //~v61xI~
//v50j:021230 cv cmd:ajust conv err pos by tab expand              //~v50jI~
//v50f:021229 (BUG)tab disappear by cv cmd                         //~v50fI~
//v44a:011202 (BUG)hex input replace another tab char to space     //~v44aI~
//v43y:011122 7bit dump mode                                       //~v43yI~
//v21m:010114 LINUX support:rigid euc chk to avoid screen destroy  //~v21mI~
//v21k:010113 LINUX support:dbcs ctl should be under kon even if euc//~v21kI~
//v21i:010113 LINUX support:euc code dbcs support                  //~v21iI~
//v20U:001119 display tab and dbcs space when binary mode          //~v20UI~
//v106:981212 no tab expand when binaly file                       //~v106I~
//v0hQ:980429 (BUG)filetabcler clear next 09(it may be winNT malloc len on hdr)//~v0hQI~
//            under NT issue area destroy at ufree.                //~v0hQI~
//v0hJ:980418 support "tab clear" cmd                              //~v0hJM~
//v0ev:970922 abondan /v0ep/v0er/v0es/v0eu;                        //~v0evI~
//            use filetabexp2(expand in mergin only)               //~v0evI~
//v0bz:970728 if last is tab,expandlen over mergin cause expand err.//~v0bzI~
//            but it can be cut in mergin and set cid on normal pos.//~v0bzI~
//v0bb:970726 limit tabctr max 12,and tab expand limit chk         //~v0bbI~
//v0b3:970723 clear tab when shift,it is easy to expectate.        //~v0b3I~
//v0av:970720-fixed lrecl support(mergin support,MAXLEN=nn[N])     //~v0avI~
//           -expand pre chk(split file2 to file6)
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifdef DOS
#else
//  #define INCL_BASE                                              //~v07sR~
//  #include <os2.h>                                               //~v07sR~
#endif
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <uque.h>
#include <ufile.h>                                              //~5318R~
#include <utrace.h>                                                //~v06yI~
#include <ualloc.h>
#include <udbcschk.h>                                              //~v21mI~
                                                                //~5318I~
#include "xe.h"
#include "xescr.h"
#include "xefile.h"
#include "xefile6.h"
#include "xeundo.h"                                                //~v0hJI~
#include "xesub.h"                                                 //~v0avI~
#include "xegbl.h"                                                 //~v21iI~
//*******************************************************
//#define DBCSSPACE1    0x81    //dbcs space first byte            //~v21iR~
//#define DBCSSPACE2    0x40    //dbcs space second byte           //~v21iR~
//**************************************************************** //~v0bbI~
static int Smerginoffs=0;                                          //~v43yR~
//**************************************************************** //~v0evI~
int filetabexpanderr(void);                                        //~v0bbI~
//****************************************************************
//!filechktabdbcs                                               //~v04dR~
//*full line tab chk and expand                                 //~4C30R~
//*parm1:PUCLIENTWE
//*rc   :0:tab expanded,4:no tab or already expanded for FIND cmd//~5102R~
//*     :UALLOC_FAILED if storage shortage                      //~v04dI~
//****************************************************************
int filechktabdbcs(PULINEH Pplh)                                //~5102R~
{
	int len,tabskip,rc;                                         //~v04dR~
    PUFILEH pfh;                                                   //~v106I~
//************************
    pfh=UGETPFH(Pplh);                                             //~v106I~
  if (UCBITCHK(pfh->UFHflag4,UFHF4BIN))                            //~v106I~
    tabskip=1;                                                     //~v106I~
  else                                                             //~v106I~
	tabskip=max(Gfiletabskip,1);
	len=Pplh->ULHlen;                                           //~5102I~
	if (UCBITCHK(Pplh->ULHflag2,ULHF2TABCHKED))	//not first time
	{
		if (UCBITCHK(Pplh->ULHflag2,ULHF2TABFOUND))//once tab detected
		{
			if (Pplh->ULHtabskip==tabskip)	//tabskip not changed
				return 4;		//no need setdbcs               //~5102R~
			if (rc=filetabexp(1,Pplh,0,&len),rc)//re-expand     //~v04dR~
			{                                                   //~5102I~
                if (rc==UALLOC_FAILED)                          //~v04dI~
                	return UALLOC_FAILED;                       //~v04dI~
				UCBITOFF(Pplh->ULHflag2,ULHF2TABFOUND);	//reset tab exist//~5102I~
				return 4;                                       //~5102I~
			}                                                   //~5102I~
		}
		else	//no tab detected
			return 4;                                           //~4C30R~
	}
	else
	{                                                           //~5102I~
		if (!Pplh->ULHdbcs)	//not yet created dbcstbl           //~5102R~
		{                                                       //~5102I~
			Pplh->ULHdbcs=UALLOCC(1,(UINT)Pplh->ULHbufflen);    //~v04dR~
		    UALLOCCHK(Pplh->ULHdbcs,UALLOC_FAILED);   //return 0 if storage shortage//~v04dI~
//  		setdbcstbl(Pplh->ULHdata,Pplh->ULHdbcs,len);           //~v09YR~
//  		filesetdbcstbl(Pplh->ULHdata,Pplh->ULHdbcs,len);       //~v44aR~
    		filesetdbcstbl(Pplh->ULHdata,Pplh->ULHdbcs,len,0);//no chk tab//~v44aI~
		}                                                       //~5102I~
		if (rc=filetabexp(0,Pplh,0,&len),rc)//initial           //~v04dR~
        {                                                       //~v04dI~
            if (rc==UALLOC_FAILED)                              //~v04dI~
               	return UALLOC_FAILED;                           //~v04dI~
			return 4;                                       //~5102I~
        }                                                       //~v04dI~
	}//not tab chked                                            //~5102I~
	return 0;                                                   //~4C30R~
}//filechktabdbcs                                               //~5102R~
                                                                //~4C30I~
//****************************************************************
//!filetabexp                                                   //~v04dR~
//*expand tab
//*parm1:opt 0:init,1:re-expand                                 //~5102R~
//*parm2:plh                                                    //~5102I~
//*parm3:column                                                 //~5102I~
//*parm4:len                                                    //~5102I~
//*rc   :0:tab detected,4:no tab detected or UALLOC_FAILED      //~v04dR~
//****************************************************************
int filetabexp(int Preexpsw,PULINEH Pplh,int Pcol,int *Plen)    //~5102R~
{
	int ii,len,reslen;
	int tabskip;
    int binsw;                                                     //~v106I~
	UCHAR *pc,*pco,*pc2,*pcd,*pcdo,*pcd2;                       //~5102R~
	UCHAR *pc2e;			//limit addr                           //~v0bbI~
    PUFILEH pfh;                                                   //~v106I~
//*****************
    pfh=UGETPFH(Pplh);                                             //~v106I~
  if (UCBITCHK(pfh->UFHflag4,UFHF4BIN))                            //~v106I~
  {                                                                //~v106I~
    tabskip=1;                                                     //~v106I~
    binsw=1;                                                       //~v106I~
  }	                                                               //~v106I~
  else                                                             //~v106I~
  {                                                                //~v106I~
    binsw=0;                                                       //~v106I~
	tabskip=max(Gfiletabskip,1);
  }                                                                //~v106I~
	UCBITON(Pplh->ULHflag2,ULHF2TABCHKED);//not first time      //~5102I~
	pc2=Gfilebuff;                                              //~5102R~
    pc2e=Gfilebuff+GFILEBUFFSZ-TABCTRMAX;                          //~v0bbR~
	pcd2=Gfilebuff2;                                            //~5102I~
	pc=Pplh->ULHdata+Pcol;                                      //~5102R~
	pcd=Pplh->ULHdbcs+Pcol;                                     //~5102I~
	reslen=*Plen;                                        //~5102R~
	while(reslen)                                               //~4C23R~
	{
		pco=pc;
		pcdo=pcd;                                               //~5102I~
		if (Preexpsw)                                           //~5102I~
		{                                                       //~5102I~
			if (!(pcd=memchr(pcd,TABCHAR,(UINT)reslen)))        //~5102I~
				break;                                          //~5102I~
			len=(int)((ULONG)pcd-(ULONG)pcdo);                 //~4C23R~
			pc+=len;
		}                                                       //~5102I~
		else    
		{                                                //~5102I~
			if (!(pc=memchr(pc,TABCHAR,(UINT)reslen)))          //~5102R~
				break;                                          //~5102R~
			len=(int)((ULONG)pc-(ULONG)pco);                    //~4C23R~
			pcd+=len;
		}
        if (pc2+len>pc2e)				//buff overflow            //~v0bbI~
			return filetabexpanderr();                             //~v0bbI~
		memcpy(pc2,pco,(UINT)len);                              //~4C23R~
		memcpy(pcd2,pcdo,(UINT)len);                            //~5102I~
		pc2+=len;                                               //~4C23R~
		pcd2+=len;                                              //~5102I~
        reslen-=len;                                            //~4C23I~
		*pc2++=' ';                                             //~5102R~
		pc++;				//skip tab char                     //~4C23R~
		*pcd2++=TABCHAR;                                        //~5102I~
		pcd++;				//skip tab char                     //~5102I~
        reslen--;                                               //~4C23I~
//  	ii=TABSKIPCTR((int)((ULONG)pc2-(ULONG)Gfilebuff-1+Pcol));  //~v106R~
    	ii=TABSKIPCTR2(binsw,(int)((ULONG)pc2-(ULONG)Gfilebuff-1+Pcol));//~v106I~
        				//0 if binfile                             //~v106I~
		for (;ii>0;ii--)                                        //~4C23R~
		{                                                       //~5102I~
			*pc2++=' ';                                         //~5102R~
			*pcd2++=TABPADCHAR;                                 //~5102I~
		}                                                       //~5102I~
		if (Preexpsw)                                           //~5102I~
			while(reslen && *pcd==TABPADCHAR)	//drop previous tab advance char//~5102I~
			{                                                   //~5102I~
				pc++;                                           //~5102I~
				pcd++;                                          //~5102I~
				reslen--;                                       //~5102I~
			}                                                   //~5102I~
	}//end of string
	if (pc2==Gfilebuff)	//no tab detected                       //~5102R~
		return 4;
	memcpy(pc2,pco,(UINT)reslen);	//last residual             //~4C23R~
	memcpy(pcd2,pcdo,(UINT)reslen);	//last residual             //~5102I~
	*Plen=len=(int)((ULONG)pc2-(ULONG)Gfilebuff)+reslen;        //~5102R~
                                                                //~5102I~
	Pplh->ULHtabskip=tabskip;	//not first,tabskip when checked//~5102I~
	UCBITON(Pplh->ULHflag2,ULHF2TABFOUND);	//chk at file write //~5102I~
	if (Smerginoffs)//from fileimtabexp                            //~v0evR~
    {                                                              //~v0evI~
        if (len>Smerginoffs)                                       //~v0evR~
        	setobtabdbcs(Gfilebuff,Gfilebuff2,len,Smerginoffs,len-Smerginoffs);//~v0evR~
    	len=Smerginoffs;                                           //~v0evR~
	}                                                              //~v0evI~
    else                                                           //~v0evM~
    {                                                              //~v0evI~
	if (Pcol+len>Pplh->ULHbufflen)                                 //~v08bI~
		if (fileexpandbuff(Pplh,Pcol+len)==UALLOC_FAILED)	//expand if buff over//~v04dR~
        	return UALLOC_FAILED;                               //~v04dI~
	Pplh->ULHlen=Pcol+len;                                         //~v0evR~
    }                                                              //~v0evI~
	memcpy(Pplh->ULHdata+Pcol,Gfilebuff,(UINT)len);	//all record//~5102I~
	memcpy(Pplh->ULHdbcs+Pcol,Gfilebuff2,(UINT)len);	//all record//~5102I~
	return 0;
}//filetabexp
                                                                //~5102I~
//**************************************************************** //~v0evI~
//!fileimtabexp                                                    //~v0evI~
//*parm1:plh                                                       //~v0evI~
//*parm2:column                                                    //~v0evI~
//*parm3:expand chk len,out:expanded len(optional)                 //~v0evR~
//*parm4:mergin                                                    //~v0evI~
//*rc   :0:tab detected,4:no tab detected                          //~v0evR~
//**************************************************************** //~v0evI~
int fileimtabexp(PULINEH Pplh,int Pcol,int *Pplen,int Pmergin)     //~v0evR~
{                                                                  //~v0evI~
	int rc;                                                        //~v0evI~
    int len;                                                       //~v0evI~
//************************                                         //~v0evI~
	Smerginoffs=Pmergin-Pcol;                                      //~v0evR~
    if (Pplen)                                                     //~v0evI~
    	len=*Pplen;                                                //~v0evI~
    else                                                           //~v0evI~
    	len=Pmergin;                                               //~v0evI~
	rc=filetabexp(1,Pplh,Pcol,&len);                               //~v0evR~
	Smerginoffs=0;                                                 //~v0evR~
    if (Pplen)                                                     //~v0evI~
    	*Pplen=len;                                                //~v0evI~
    return rc;                                                     //~v0evI~
}                                                                  //~v0evI~
//fileimtabexp                                                     //~v0evI~
//**************************************************************** //~v0avI~
//!filegettabexplen                                                //~v0avR~
//*calculate tab expand length                                     //~v0avI~
//*parm1:plh                                                       //~v0avI~
//*parm2:offset                                                    //~v0avI~
//*parm3:adddata                                                   //~v0avR~
//*parm4:addlen                                                    //~v0avI~
//*parm5:dellen                                                    //~v0avI~
//*parm6:reclen to see without last tab                            //~v0bzR~
//*rc   :add length ,0 if addlen<=dellen and no tab data           //~v0avR~
//**************************************************************** //~v0avI~
int filegettabexplen(PULINEH Pplh,int Pcol,char *Padddata,         //~v0bzR~
					int Paddlen,int Pdellen,int Plen)              //~v0bzR~
{                                                                  //~v0avI~
	int len,reslen,cpos,addlen,addskip;                            //~v0avR~
	UCHAR *pcd,*pcdo,*pc,*pco;                                     //~v0avR~
//  int tabsw=0;                                                   //~v0bzR~
    int binsw;                                                     //~v106I~
    PUFILEH pfh;                                                   //~v106I~
//*****************                                                //~v0avI~
    pfh=UGETPFH(Pplh);                                             //~v106I~
  if (UCBITCHK(pfh->UFHflag4,UFHF4BIN))                            //~v106I~
    binsw=1;                                                       //~v106I~
  else                                                             //~v106I~
    binsw=0;                                                       //~v106I~
    addlen=Paddlen-Pdellen;                                        //~v0avR~
//*isrt data                                                       //~v0avI~
    cpos=Pcol;                                                     //~v0avM~
    if (Padddata)	//data specified                               //~v0avI~
    {                                                              //~v0avI~
    	pc=Padddata;                                               //~v0avR~
        reslen=Paddlen;                                            //~v0avR~
    	while(reslen)                                              //~v0avR~
    	{                                                          //~v0avR~
    		pco=pc;                                                //~v0avR~
    		if (!(pc=memchr(pc,TABCHAR,(UINT)reslen)))             //~v0avR~
            {                                                      //~v0avR~
            	cpos+=reslen;                                      //~v0avR~
    			break;                                             //~v0avR~
    		}                                                      //~v0avR~
//          tabsw=1;                                               //~v0bzR~
    		pc++;				//skip tab char                    //~v0avR~
    		len=(int)((ULONG)pc-(ULONG)pco);                       //~v0avR~
    		cpos+=len;                                             //~v0avR~
            reslen-=len;                                           //~v0avR~
//  		addskip=TABSKIPCTR(cpos-1);                            //~v106R~
    		addskip=TABSKIPCTR2(binsw,cpos-1);                     //~v106R~
    		addlen+=addskip;                                       //~v0avR~
            cpos+=addskip;                                         //~v0avR~
    	}//end of string                                           //~v0avR~
    }                                                              //~v0avI~
    else	//for ")" lcmd no data,but all space                   //~v0avI~
    	cpos+=Paddlen;	//has no tab                               //~v0avI~
//  if (!tabsw && Paddlen<=Pdellen)	//no expand occur              //~v0bzR~
//  	return 0;                                                  //~v0bzR~
//*after isrt data                                                 //~v0avR~
	pcd=Pplh->ULHdbcs+Pcol+Pdellen;	//assume pad char rep to space //~v0avM~
//  reslen=Pplh->ULHlen-Pcol-Pdellen;                              //~v0bzR~
    reslen=Plen-Pcol-Pdellen;                                      //~v0bzI~
	while(reslen>0)                                                //~v0avR~
	{                                                              //~v0avI~
		pcdo=pcd;                                                  //~v0avI~
		if (!(pcd=memchr(pcd,TABCHAR,(UINT)reslen)))               //~v0avI~
			break;                                                 //~v0avI~
		pcd++;				//skip tab char                        //~v0avI~
		len=(int)((ULONG)pcd-(ULONG)pcdo);                         //~v0avI~
		cpos+=len;                                                 //~v0avI~
        reslen-=len;                                               //~v0avI~
//  	addskip=TABSKIPCTR(cpos-1);                                //~v106R~
    	addskip=TABSKIPCTR2(binsw,cpos-1);                         //~v106I~
        cpos+=addskip;                                             //~v0avM~
		while(reslen && *pcd==TABPADCHAR)	//drop previous tab advance char//~v0avI~
		{                                                          //~v0avI~
			pcd++;                                                 //~v0avI~
			reslen--;                                              //~v0avI~
            addskip--;                                             //~v0avR~
		}                                                          //~v0avI~
        if (!addskip)	//no more len change                       //~v0bzR~
        	break;                                                 //~v0bzR~
        addlen+=addskip;                                           //~v0avI~
	}//end of string                                               //~v0avI~
	return addlen;                                                 //~v0avI~
}//filegettabexplen                                                //~v0avR~
//**************************************************************** //~v71UI~
//!filegettabexplenofmargined                                      //~v71UI~
//*calculate tab expand length and chk margin overflow of non space/tab char//~v71UI~
//*parm1:plh                                                       //~v71UI~
//*parm2:offset (assumed in margin)                                //~v71UR~
//*parm3:adddata                                                   //~v71UI~
//*parm4:addlen                                                    //~v71UI~
//*parm5:dellen                                                    //~v71UI~
//*parm6:reclen to see without last tab                            //~v71UI~
//*rc   :4:marginoverflow,1:overflow but tab/space only            //~v71UR~
//**************************************************************** //~v71UI~
int filegettabexplenofmargined(int Popt,int Pmargin,PULINEH Pplh,int Pcol,char *Padddata,//~v71UI~
					int Paddlen,int Pdellen,int Plen,int *Ppaddlen)//~v71UI~
{                                                                  //~v71UI~
	int reslen,cpos,addlen,addskip;                                //~v71UR~
	UCHAR *pcd,*pc,*pcm;                                           //+v71UR~
    int binsw,rc=0;                                                //~v71UI~
    PUFILEH pfh;                                                   //~v71UI~
//*****************                                                //~v71UI~
    pfh=UGETPFH(Pplh);                                             //~v71UI~
  if (UCBITCHK(pfh->UFHflag4,UFHF4BIN))                            //~v71UI~
    binsw=1;                                                       //~v71UI~
  else                                                             //~v71UI~
    binsw=0;                                                       //~v71UI~
    addlen=Paddlen-Pdellen;                                        //~v71UI~
//*isrt data                                                       //~v71UI~
    cpos=Pcol;                                                     //~v71UI~
    if (Padddata)	//data specified                               //~v71UI~
    {                                                              //~v71UI~
    	pc=Padddata;                                               //~v71UI~
        reslen=Paddlen;                                            //~v71UI~
    	while(reslen)                                              //~v71UI~
    	{                                                          //~v71UI~
            if (cpos>=Pmargin)                                     //~v71UI~
            {                                                      //~v71UI~
            	rc|=1;                                             //~v71UI~
            	if (*pc!=TABCHAR && *pc!=' ')                      //~v71UI~
                	rc=4;                                          //~v71UI~
            }                                                      //~v71UI~
    		pc++;				//skip tab char                    //~v71UI~
    		cpos++;                                                //~v71UI~
            reslen--;                                              //~v71UI~
            if (*(pc-1)==TABCHAR)                                  //~v71UI~
            {                                                      //~v71UI~
	    		addskip=TABSKIPCTR2(binsw,cpos-1);                 //~v71UI~
    			addlen+=addskip;                                   //~v71UI~
            	cpos+=addskip;                                     //~v71UI~
            }                                                      //~v71UI~
    	}//end of string                                           //~v71UI~
    }                                                              //~v71UI~
    else	//for ")" lcmd no data,but all space                   //~v71UI~
    	cpos+=Paddlen;	//has no tab                               //~v71UI~
//*after isrt data                                                 //~v71UI~
	pc=Pplh->ULHdata+Pcol+Pdellen;	//assume pad char rep to space //~v71UI~
	pcd=Pplh->ULHdbcs+Pcol+Pdellen;	//assume pad char rep to space //~v71UI~
    reslen=Plen-Pcol-Pdellen;                                      //~v71UI~
	if (Pmargin<Plen)	//already margin data exist                //~v71UI~
    	pcm=Pplh->ULHdata+Pmargin; 	//margin top addr              //~v71UI~
    else                                                           //~v71UI~
		pcm=0;                                                     //~v71UI~
	while(reslen>0)                                                //~v71UI~
	{                                                              //~v71UI~
        if (cpos>=Pmargin)                                         //~v71UI~
        {                                                          //~v71UI~
            rc|=1;                                                 //~v71UI~
            if (*pc!=' ')                                          //~v71UI~
                if (!pcm||pc<pcm)	//no chk for original margin data//~v71UI~
                rc=4;                                              //~v71UI~
        }                                                          //~v71UI~
		pc++;				//skip tab char                        //~v71UR~
		pcd++;				//skip tab char                        //~v71UI~
		cpos++;                                                    //~v71UI~
        reslen--;                                                  //~v71UI~
		if (*(pcd-1)==TABCHAR)                                     //~v71UI~
        {                                                          //~v71UI~
    		addskip=TABSKIPCTR2(binsw,cpos-1);                     //~v71UI~
        	cpos+=addskip;                                         //~v71UI~
			while(reslen && *pcd==TABPADCHAR)	//drop previous tab advance char//~v71UI~
			{                                                      //~v71UI~
            	pc++;                                              //~v71UI~
				pcd++;                                             //~v71UI~
				reslen--;                                          //~v71UI~
            	addskip--;                                         //~v71UI~
			}                                                      //~v71UI~
	        addlen+=addskip;                                       //~v71UI~
        }                                                          //~v71UI~
	}//end of string                                               //~v71UI~
    if (Ppaddlen)        //optional                                //~v71UI~
	    *Ppaddlen=addlen;                                          //~v71UR~
    if (rc>=4)                                                     //~v71UI~
    	return 4;                                                  //~v71UI~
	return rc;                                                     //~v71UI~
}//filegettabexplenofmargined                                      //~v71UI~
//****************************************************************
// tabdisplay
//*display tab char,dbcs space if japanese mode                 //~5502R~
//*parm1:sd data                                                //~5102I~
//*parm2:sd dbcs                                                //~5102I~
//*parm3:len                                                    //~5102I~
//*rc   :1 tab/dbcs space  detected,0:not detected              //~5502R~
//****************************************************************
int tabdisplay(UCHAR *Pdata,UCHAR *Pdbcs,int Plen,int Pbinsw)      //~v20UR~
{                                                               //~5502R~
	int len,reslen,rc;                                          //~5502R~
    int asciisw;                                                   //~v43yI~
    int dbcsspace1,dbcsspace2;                                     //~v21iI~
	UCHAR *pc,*pcd;                       //~5102R~
//*****************
//*unprintable char                                                //~v09UI~
    rc=0;                                                          //~v09UI~
	pc=Pdata;                                                      //~v09UI~
	pcd=Pdbcs;                                                     //~v09UI~
	reslen=Plen;                                                   //~v09UI~
    asciisw=(Pbinsw && UCBITCHK(Gopt4,GOPT47BIT));	//if ASCII on  //~v43yR~
	for(;reslen;reslen--,pc++,pcd++)                               //~v09UI~
    {                                                              //~v09UI~
        if (asciisw && *pc>=0x80)                                  //~v43yR~
        {                                                          //~v43yI~
        	*pc=Gunpdispchar[0];	//displayable char             //~v43yI~
			*pcd=DISPLINEATTRID;//display by lineno fld attr       //~v43yI~
            rc=1;                                                  //~v43yI~
        }                                                          //~v43yI~
        else                                                       //~v43yI~
//      if (*pcd==NULLCHARIDDBCS	//null is always special       //~v0a1R~
//      || (Gunpdispchartbl[*pc]   	//unprintable                  //~v0a1R~
#ifdef UNX                                                         //~v21mI~
        if (*pcd==UDBCSCHK_HKDBCSERR)	//invalid dbcs hankata conbination//~v21mI~
        {                                                          //~v21mI~
        	*pc=Gunpdispchar[0];	//displayable char             //~v21mI~
			*pcd=DISPLINEATTRID;//display by lineno fld attr       //~v21mI~
            rc=1;                                                  //~v21mI~
        }                                                          //~v21mI~
        else                                                       //~v21mI~
#endif                                                             //~v21mI~
        if((Gunpdispchartbl[*pc]   	//unprintable                  //~v0a1I~
            && *pcd!=DBCS1STCHAR                                   //~v09UI~
            && *pcd!=DBCS2NDCHAR))	//no DBCS under english mode   //~v09UR~
        {                                                          //~v09UR~
        	*pc=Gunpdispchar[0];	//displayable char             //~v09UR~
			*pcd=DISPLINEATTRID;//display by lineno fld attr       //~v09UR~
            rc=1;                                                  //~v09UR~
        }                                                          //~v09UR~
      }//ascii mode or else                                        //~v43yI~
  if (!Pbinsw)        //text file                                  //~v20UI~
	if (!UCBITCHK(Gopt,GOPTTABDISPLAY))                            //~v09UI~
    	return rc;                                                 //~v09UI~
    pc=Pdata;                                                         //~v06bI~
	pcd=Pdbcs;
	reslen=Plen;
//first tab pad char caused by scroll                                 //~v06bI~
	while(reslen && *pcd==TABPADCHAR)//tab advance char               //~v06bI~
	{                                                                 //~v06bI~
		*pc++=Gfiletabdisp2;                                          //~v06bI~
    	pcd++;                                                     //~v09UR~
		reslen--;                                                     //~v06bI~
	}                                                                 //~v06bI~
//repl tabs start from tab char                                       //~v06bI~
	while(reslen)                                               //~4C23R~
	{
		if (!(pcd=memchr(pcd,TABCHAR,(UINT)reslen)))        //~5102I~
			break;                                          //~5102I~
		len=(int)((ULONG)pcd-(ULONG)Pdbcs);                 //~4C23R~
        reslen=Plen-len;                                     //~4C23I~
		pc=Pdata+len;
		*pc++=Gfiletabdisp1;	//skip tab char                //~4C23R~
    	pcd++;				//skip tab char                        //~v09UR~
        reslen--;                                               //~4C23I~
		while(reslen && *pcd==TABPADCHAR)//tab advance char//~5102I~
		{                                                   //~5102I~
			*pc++=Gfiletabdisp2;                          //~5102I~
    		pcd++;                                                 //~v09UR~
			reslen--;                                       //~5102I~
		}                                                   //~5102I~
	}//end of string
//  rc=reslen!=Plen;                                               //~v09UR~
    rc+=(reslen!=Plen);                                            //~v09UI~
#ifdef LNX                                                         //~v21iI~
//  if (!UCBITCHK(Gunxflag,GUNX_EUC))                              //~v21kR~
    if ((Gunxflag & (GUNX_EUC|GUNX_KON))!=(GUNX_EUC|GUNX_KON))     //~v21kI~
    	return rc;                                                 //~v21iI~
    dbcsspace1=0xa1;   //dbcs space first byte                     //~v21iI~
    dbcsspace2=0xa1;   //dbcs space second byte                    //~v21iI~
#else                                                              //~v21iI~
	if (!UCBITCHK(Gscrstatus,GSCRSDBCS))                        //~5502I~
    	return rc;                                              //~5502I~
    dbcsspace1=0x81;   //dbcs space first byte                     //~v21iI~
    dbcsspace2=0x40;   //dbcs space second byte                    //~v21iI~
#endif                                                             //~v21iI~
//*dbcs space display                                           //~5502I~
	pc=Pdata;                                                   //~5502I~
	reslen=Plen;                                                //~5502I~
	while(reslen)                                               //~5502I~
	{                                                           //~5502I~
//  	if (!(pc=memchr(pc,DBCSSPACE1,(UINT)reslen)))              //~v21iR~
    	if (!(pc=memchr(pc,dbcsspace1,(UINT)reslen)))              //~v21iI~
			break;                                              //~5502I~
		reslen=Plen-(int)((ULONG)pc-(ULONG)Pdata);              //~5502R~
//  	if (--reslen && *(++pc)==DBCSSPACE2)                       //~v21iR~
		if (--reslen && *(++pc)==dbcsspace2)                       //~v21iI~
        {                                                       //~5502I~
			*(pc-1)=Gunpdispchar[3];                               //~v09XR~
			*pc++=Gunpdispchar[3];                                 //~v09XR~
	        reslen--;                                           //~5502I~
            rc=1;                                               //~5502I~
		}                                                       //~5502I~
	}//end of string                                            //~5502I~
	return rc;                                                  //~5502R~
}//tabdisplay
                                                                //~5102I~
//**************************************************************** //~v61xI~
// tabdisplay for xprint                                           //~v61xI~
//*change ctl char to "."                                          //~v61xI~
//*rc                                                              //~v61xI~
//**************************************************************** //~v61xI~
int tabdisplayforxpr(UCHAR *Pdata,UCHAR *Pdbcs,int Plen)           //~v61xI~
{                                                                  //~v61xI~
	int rc=0,asciisw,reslen;                                       //~v61xR~
	UCHAR *pc,*pcd,altch='.';                                      //~v61xI~
//*****************                                                //~v61xI~
//*unprintable char                                                //~v61xI~
	pc=Pdata;                                                      //~v61xI~
	pcd=Pdbcs;                                                     //~v61xI~
    asciisw=UCBITCHK(Gopt4,GOPT47BIT);	//if ASCII on              //~v61xI~
    reslen=Plen;                                                   //~v61xI~
	for(;reslen;reslen--,pc++,pcd++)                               //~v61xI~
    {                                                              //~v61xI~
        if (asciisw && *pc>=0x80)                                  //~v61xI~
        {                                                          //~v61xI~
        	*pc=altch;                                             //~v61xI~
            rc=1;                                                  //~v61xI~
        }                                                          //~v61xI~
        else                                                       //~v61xI~
        if (*pcd==TABCHAR)                                         //~v61xI~
        {                                                          //~v61xI~
        	*pc=altch;	//displayable char                         //~v61xI~
            rc=1;                                                  //~v61xI~
        }                                                          //~v61xI~
#ifdef UNX                                                         //~v61xI~
        if (*pcd==UDBCSCHK_HKDBCSERR)	//invalid dbcs hankata conbination//~v61xI~
        {                                                          //~v61xI~
        	*pc=altch;	//displayable char                         //~v61xI~
            rc=1;                                                  //~v61xI~
        }                                                          //~v61xI~
        else                                                       //~v61xI~
#endif                                                             //~v61xI~
        if(*pc<' ')   	//unprintable                              //~v61xI~
        {                                                          //~v61xI~
        	*pc=altch;                                             //~v61xI~
            rc=1;                                                  //~v61xI~
        }                                                          //~v61xI~
        else                                                       //~v61xI~
        if(Gunpdispchartbl[*pc])  	//unprintable                  //~v61xR~
        {                                                          //~v61xI~
        	*pc=altch;                                             //~v61xI~
            rc=1;                                                  //~v61xI~
        }                                                          //~v61xI~
	}                                                              //~v61xI~
	return rc;                                                     //~v61xI~
}//tabdisplayforxpr                                                //~v61xI~
                                                                   //~v61xI~
//**************************************************************** //~v0avM~
//!filetabclear                                                    //~v0b3R~
//   clear all tab                                                 //~v0b3R~
//*parm1:PULINEH                                                   //~v0b3R~
//*rc   :none                                                      //~v0b3R~
//**************************************************************** //~v0avM~
void filetabclear(PULINEH Pplh)                                    //~v0b3R~
{                                                                  //~v0avM~
	UCHAR *pcd;                                                    //~v0avM~
	UCHAR *pcdw;                                                   //~v0hQI~
	int len;                                                       //~v0b3R~
//********************	                                           //~v0avM~
//	len=Pplh->ULHlen;                                              //~v0b3R~
//	offs=0;                                                        //~v0b3R~
//	if (Pleft)		//left shift,drop top tab efect                //~v0b3R~
//	{                                                              //~v0b3R~
//		for (pc=Pplh->ULHdbcs;len;len--,pc++,offs++)               //~v0b3R~
//			if (*pc==TABPADCHAR)                                   //~v0b3R~
//				*pc=0;				//reset cut tab char efect     //~v0b3R~
//			else                                                   //~v0b3R~
//                break;                                           //~v0b3R~
//	}                                                              //~v0b3R~
//    else	//right shift                                          //~v0b3R~
//    	if (len)		//drop right tab on boundary               //~v0b3R~
//		{                                                          //~v0b3R~
//    		pcd=Pplh->ULHdbcs+len-1;                               //~v0b3R~
//            if ((*pcd==TABCHAR	&&  !TABSKIPCTR(len-1))        //~v0b3R~
//            ||   *pcd==TABPADCHAR)                               //~v0b3R~
//    			for (;len;len--,pcd--)                             //~v0b3R~
//                {                                                //~v0b3R~
//        			if (*pcd==TABCHAR)                             //~v0b3R~
//                    {                                            //~v0b3R~
//        				*pcd=0;				//reset cut tab char efect//~v0b3R~
//                        break;                                   //~v0b3R~
//                    }                                            //~v0b3R~
//                    else                                         //~v0b3R~
//	        			if (*pcd!=TABPADCHAR)                      //~v0b3R~
//    	                    break;                                 //~v0b3R~
//        			*pcd=0;				//reset cut tab char efect //~v0b3R~
//                }                                                //~v0b3R~
//    	}                                                          //~v0b3R~
//	if (filetabexp(1,Pplh,offs,&len)==UALLOC_FAILED)	//re ajust //~v0b3I~
//    	return UALLOC_FAILED;                                      //~v0b3I~
  	len=Pplh->ULHlen;                                              //~v0b3I~
  	pcd=Pplh->ULHdbcs;                                             //~v0b3I~
    while(len)                                                     //~v0b3I~
    {                                                              //~v0b3I~
        pcdw=pcd;           //save start addr                      //~v0hQI~
        pcd=memchr(pcd,TABCHAR,(UINT)len);                         //~v0b3R~
        if (!pcd)                                                  //~v0b3I~
        	break;                                                 //~v0b3I~
		*pcd++=0;                                                  //~v0b3I~
        len-=(int)((ULONG)pcd-(ULONG)pcdw);                        //~v0hQR~
  		for (;len;len--,pcd++)                                     //~v0b3I~
  			if (*pcd==TABPADCHAR)                                  //~v0b3I~
  				*pcd=0;				//reset cut tab char efect     //~v0b3I~
  			else                                                   //~v0b3I~
                  break;                                           //~v0b3I~
    }                                                              //~v0b3I~
	UCBITOFF(Pplh->ULHflag2,ULHF2TABFOUND);	//no tab exist         //~v0b3I~
    return;                                                        //~v0b3I~
}//filetabclear                                                    //~v0b3R~
                                                                   //~v0avM~
//************************************************************     //~v0hJM~
// filetabclearall                                                 //~v0hJM~
//*clear all tab                                                   //~v0hJM~
//*parm1:pcw                                                       //~v0hJM~
//*return:rc                                                       //~v0hJM~
//************************************************************     //~v0hJM~
int filetabclearall(PUCLIENTWE Ppcw)                               //~v0hJM~
{                                                                  //~v0hJM~
	PUFILEC pfc;                                                   //~v0hJM~
	PUFILEH pfh;                                                   //~v0hJM~
	PULINEH plh;                                                   //~v0hJM~
    int rc;                                                        //~v0hJM~
//*****************************                                    //~v0hJM~
	pfc=Ppcw->UCWpfc;                                              //~v0hJM~
	pfh=pfc->UFCpfh;                                               //~v0hJM~
    if (UCBITCHK(pfh->UFHflag4,UFHF4BIN))                          //~v0hJM~
    {                                                              //~v0hJM~
    	uerrmsg("Cannot clear TAB for binary file",                //~v0hJM~
    			"oCi[t@C̓^uNA[o܂");     //~v0hJM~
		return 4;                                                  //~v0hJM~
    }                                                              //~v0hJM~
    UPCTRREQ(pfh);         //write at save                         //~v0hJM~
    rc=0;                                                          //~v0hJM~
	for (plh=UGETQTOP(&pfh->UFHlineque);plh;plh=UGETQNEXT(plh))    //~v0hJM~
	{                                                              //~v0hJM~
		if (plh->ULHtype!=ULHTDATA)	//file data                    //~v0hJM~
        	continue;                                              //~v0hJM~
                                                                   //~v0hJM~
        if (!plh->ULHdbcs)	//not yet expanded                     //~v0hJM~
        	if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v0hJM~
            	return UALLOC_FAILED;                              //~v0hJM~
                                                                   //~v0hJM~
        if (UCBITCHK(plh->ULHflag2,ULHF2TABFOUND))                 //~v0hJM~
        {                                                          //~v0hJM~
			if (rc=undoupdate(Ppcw,plh,UUHTREP),rc)	//prepare undo and update process//~v0hJM~
            	break;                                             //~v0hJM~
        	filetabclear(plh);                                     //~v0hJM~
		}                                                          //~v0hJM~
	}//all line	                                                   //~v0hJM~
    UPCTRREQ(pfh);         //write at save                         //~v0hJM~
    if (!rc)                                                       //~v0hJM~
    	uerrmsg("All tab is replaced by space(tab skip=%d)",       //~v0hJM~
    			"^uNA[(tab skip=%d)",                     //~v0hJM~
           		Gfiletabskip);                                     //~v0hJM~
    return rc;                                                     //~v0hJM~
}//filetabclearall                                                 //~v0hJM~
//**************************************************************** //~v50fI~
//!filetabrestore                                                  //~v50fI~
//*restore tab as record data                                      //~v50fI~
//*parm1:pfh                                                       //~v50fI~
//*parm2:plh                                                       //~v50fI~
//*parm3:out area                                                  //~v50fI~
//*parm4:out area len                                              //~v50fI~
//*parm5:out len                                                   //~v50fI~
//*parm4:len                                                       //~v50fI~
//*rc   :0:tab reduced,1:not yet expanded,2:no tab detected,8:outbuff overflow//~v50fI~
//**************************************************************** //~v50fI~
int filetabrestore(PUFILEH Ppfh,PULINEH Pplh,UCHAR *Poutbuff,int Poutbufflen,int *Ppoutlen)//~v50fR~
{                                                                  //~v50fI~
	int   len,reslen,rc;                                           //~v50jR~
	UCHAR *pc,*pcout,*pcoute,*pcd,*pcdo;                           //~v50fR~
//*****************                                                //~v50fI~
    if (!Pplh->ULHdbcs)	//not yet expanded                         //~v50fI~
    	return FTRRC_NOTYETEXPANDED;		//not yet expanded     //~v50fI~
	pcout=Poutbuff;                                                //~v50fI~
    pcoute=Poutbuff+Poutbufflen;                                   //~v50fI~
	pc=Pplh->ULHdata;                                              //~v50fI~
	pcd=Pplh->ULHdbcs;                                             //~v50fI~
	reslen=Pplh->ULHlen;                                           //~v50fI~
	rc=FTRRC_NOTABDETECTED;                                        //~v50fI~
	while(reslen)                                                  //~v50fI~
	{                                                              //~v50fI~
		pcdo=pcd;                                                  //~v50fI~
		if (pcd=memchr(pcd,TABCHAR,(UINT)reslen),pcd)              //~v50fR~
        {                                                          //~v50fI~
	        rc=FTRRC_TABDETECTED;                                  //~v50fR~
			len=(int)((ULONG)pcd-(ULONG)pcdo);                     //~v50fR~
        }                                                          //~v50fI~
        else                                                       //~v50fI~
        	len=reslen;                                            //~v50fI~
	    if (rc==FTRRC_TABDETECTED)	//once tab detected            //~v50fI~
        {                                                          //~v50fI~
            if (pcout+len+1>pcoute)             //buff overflow    //~v50fR~
            {                                                      //~v50fR~
                rc=FTRRC_BUFFOVERFLOW;                             //~v50fR~
                break;                                             //~v50fR~
            }                                                      //~v50fR~
            memcpy(pcout,pc,(UINT)len);                            //~v50fR~
            pcout+=len;                                            //~v50fR~
        }                                                          //~v50fI~
        if (!pcd)	//no more tab                                  //~v50fI~
        	break;                                                 //~v50fI~
		*pcout++=TABCHAR;                                          //~v50fI~
		pcd++;				//skip tab char                        //~v50fI~
		pc+=len+1;                                                 //~v50fI~
        reslen-=len+1;                                             //~v50fI~
//skip tab pad                                                     //~v50fI~
        while(reslen && *pcd==TABPADCHAR)   //drop previous tab advance char//~v50fI~
        {                                                          //~v50fI~
        	pc++;                                                  //~v50fI~
            pcd++;                                                 //~v50fI~
            reslen--;                                              //~v50fI~
        }                                                          //~v50fI~
	}//end of string                                               //~v50fI~
    *Ppoutlen=(int)((ULONG)pcout-(UINT)Poutbuff);                  //~v50jR~
	return rc;                                                     //~v50fI~
}//filetabrestore                                                  //~v50fI~
//**************************************************************** //~v50jI~
//!filegettabexplensub                                             //~v50jI~
//*calculate tab expand length                                     //~v50jI~
//*parm1:bin file sw                                               //~v50jI~
//*parm2:data containing tab                                       //~v50jI~
//*parm3:data len                                                  //~v50jI~
//*rc   :new len                                                   //~v50jI~
//**************************************************************** //~v50jI~
int filetgettabexplensub(int Pbinsw,char *Pdata,int Plen)          //~v50jI~
{                                                                  //~v50jI~
	int len,reslen,cpos=0,addskip;                                 //~v50jI~
	UCHAR *pc,*pco;                                                //~v50jI~
//*****************                                                //~v50jI~
  	for (reslen=Plen,pc=Pdata;reslen>0;)                           //~v50jI~
	{                                                              //~v50jI~
    	pco=pc;                                                    //~v50jI~
		if (!(pc=memchr(pc,TABCHAR,(UINT)reslen)))                 //~v50jI~
        {                                                          //~v50jI~
        	cpos+=reslen;                                          //~v50jI~
			break;                                                 //~v50jI~
        }                                                          //~v50jI~
		pc++;				//skip tab char                        //~v50jI~
		len=(int)((ULONG)pc-(ULONG)pco);                           //~v50jI~
		cpos+=len;                                                 //~v50jI~
        reslen-=len;                                               //~v50jI~
    	addskip=TABSKIPCTR2(Pbinsw,cpos-1);                        //~v50jI~
        cpos+=addskip;                                             //~v50jI~
	}//end of string                                               //~v50jI~
	return cpos;                                                   //~v50jI~
}//filegettabexplensub                                             //~v50jI~
//*******************************************************          //~v66fI~
//*reset tabexpansion by tabctr change                             //~v66fI~
//*parm  :none                                                     //~v66fI~
//*return:none                                                     //~v66fI~
//*******************************************************          //~v66fI~
int filepfhchktabdbcs(PUFILEH Ppfh)                                //~v66fR~
{                                                                  //~v66fI~
	PULINEH plh;                                                   //~v66fI~
//***************************                                      //~v66fI~
    for (plh=UGETQTOP(&Ppfh->UFHlineque);plh;plh=UGETQNEXT(plh))   //~v66fI~
    {                                                              //~v66fI~
        if (plh->ULHtype!=ULHTDATA) //not file data                //~v66fI~
            continue;                                              //~v66fI~
        if (!plh->ULHdbcs) //not yet expanded                      //~v66fI~
       		if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v66fI~
            	return UALLOC_FAILED;                              //~v66fI~
    }//all plh                                                     //~v66fI~
	return 0;                                                      //~v66fI~
}//filepfhchktabdbcs                                               //~v66fI~
//**************************************************************** //~v0bbI~
// filetabexpanderr                                                //~v0bbI~
//*tab expand failed                                               //~v0bbI~
//*parm:none                                                       //~v0bbI~
//*rc  :UALLOC_FAILED                                              //~v0bbI~
//**************************************************************** //~v0bbI~
int filetabexpanderr(void)                                         //~v0bbI~
{                                                                  //~v0bbI~
//*******************                                              //~v0bbI~
	uerrmsg("Cannot expand tab,Change tab ctr",                    //~v0bbI~
			"^ugo܂,^uĉ");      //~v0bbI~
	return UALLOC_FAILED;                                          //~v0bbI~
}//filetabexpanderr                                                //~v0bbI~
