//*CID://+v72BR~:                             update#=   98;       //+v72BR~
//*************************************************************
//* xefsub.c
//*************************************************************
//v72B:061205 3270:like rsh,use =6 panel as TSO terminal screen "tso "tostid TSO"/Exit//+v72BI~
//v71W:061113 DROP EOF for TSO file                                //~v71WI~
//v717:060926 3270:dirlist support                                 //~v717I~
//v70z:060904 3270 ftp support                                     //~v70zI~
//v690:060418 display file-description support on dir-list panel   //~v690I~
//v66i:051023 (WXE)C & P;if no Clipboard data on Windows CB,get data from ::CB//~v66iI~
//v66f:051021 (BUG)A+F9 abend when A+F7 on same excludeline and pos1>pos2//~v66fI~
//v57m:040526 (BUG)parmission warining issued for new file;should chk parent dir//~v57mI~
//v55X:040318 (!UNX)update permission warning(read only chk)       //~v55XI~
//v55P:040318 (UNX)update permission warning                       //~v55PI~
//v54U:040125 move updatechk sub to xefsub(used by OS/2 DOS)       //~v54RI~
//v54R:040125 find cmd:max record pos search by max pos parm       //~v54RI~
//v54p:040106 (FTP)uftpisremote interface changed                  //~v54pI~
//v542:031223 (WIN,UNX)remote file edit/save                       //~v542I~
//v53Z:031223 (WIN,UNX)ftp support;no vfat alias(always long)      //~v53ZI~
//v50t:030112 (BUG)mac eolid=4 but eollen=1,offset calc miss       //~v50tI~
//v50e:021229 dbcs conv cont line support                          //~v50eI~
//v49c:020629 (BUG)repword dbcs set should continue to eol if right boundary changed//~v49cI~
//v49b:020623 support *= for not only "(i)x all" but also "(i)find","change"//~v49bI~
//v48o:020518 (UNX)mdos disk readonly when for edit end            //~v48oI~
//v48c:020429 (UNX)edit/browse mdos disk support                   //~v48cI~
//v47X:020413 mac file support(eol=0x0d) /Mm                       //~v47XI~
//v453:011208 (BUG)dbcs tbl set to not dbcs when word rep split dbcs//~v453I~
//			   after reple word it may yet dbcs                    //~v453I~
//v44a:011202 (BUG)hex input replace another tab char to space     //~v44aI~
//v40b:010327 LINUX support:ajust after merge                      //~v40bI~
//v21n:010114 LINUX support:wordrep may dsetroy dbcs conbination   //~v21nI~
//v214:001126 LINUX support:no eof processing;ufgets now return eof id as data.//~v214I~
//            no eofchk and eofwrite required under unix.          //~v214I~
//v213:001126 deney v20B:no automaticaly delete EOFID.It should be binary mode.//~v213I~
//v20B:001103 drop EOF when write mode=unix text                   //~v20BI~
//v19L:000925 LINUX support(permission err msg for fopen)          //~v19LI~
//v180:000820 (BUG)dont write eof when binary update               //~v180I~
//v179:000501 (BUG)when n line join is overflow,errmsg "Already one of split line"//~v179I~
//            So,join to split last line.                          //~v179I~
//v178:000430 renum support for lineno hex mode                    //~v178I~
//v13j:991029 (BUG)It should not be end when close err by disk space shortage.//~v13jI~
//            chk also close err(flush err) at save then notify and wait.//~v13jI~
//v0i0:980429 lcmd skip/bandle support                             //~v0i0I~
//v0fo:971106 (GCC:W32)ugetvfatalias new option parm               //~v0foI~
//v0fm:971103 new function to set filename and alias to ufh        //~v0fmI~
//v09Y:970629:file NULL(0x00) support                              //~v09YI~
//            fileofchk by last read 1a for bin mode          fsub //~v09YI~
//v09x:970525:system/hidden update reject under os/2,issue errmsg  //~v09xI~
//v08s:961207:(DOS:BUG)eof(x1a)drop,it can be easyly checked by feof for all(dos,win,os2)//~v08sI~
//v08q:961123:edit partial file(continued from v08l)-err msg by ufileapierr//~v08qI~
//v08r:961201:chk read only attr when reopen at save               //~v08rI~
//v085:961024:W95 VC                                               //~v085I~
//v07s:960825:new ulib.h/ulibdef.h(no need base def by os2.h)      //~v07sI~
//            to speed up compile,drop include(caused by WIN95 modify)//~v07sI~
//v054:951014:freopen faile if once freopen failed even if after closed//~v054I~
//            another open(errno=9:EISOPEN)                     //~v054I~
//            change freopen to fclose + fopen                  //~v054I~
//v047:950924:file output err(disk full)->close err/reopen err  //~v047I~
//*950318 xefsub from xesub
//*950102 tab display by space for screen print
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>                                                //~v66fI~
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>                                              //~5503M~
//*************************************************************
#ifdef DOS
    #include <dos.h>                                               //~v08sI~
#else
	#ifdef W32                                                     //~v08sI~
        #include <dos.h>                                           //~v08sI~
    #else                                                          //~v08sI~
//  #define INCL_BASE                                              //~v07sR~
//  #include <os2.h>                                               //~v07sR~
	#endif                                                         //~v08sI~
#endif
#ifdef UNX                                                         //~v55PI~
    #include <sys/stat.h>                                          //~v55PI~
#endif                                                             //~v55PI~
//*******************************************************
#include <ulib.h>
#include <ualloc.h>                                                //~v50eI~
#include <uerr.h>
#include <uque.h>
#include <ufile.h>                                              //~5318I~
#include <ufile5.h>	//ugetvfatalias                                //~v0fmR~
#include <ufemsg.h>                                                //~v08sI~
#include <utrace.h>                                                //~v08qI~
#include <ustring.h>                                               //~v0fmI~
#include <udbcschk.h>                                              //~v453I~
#include <uftp.h>                                                  //~v542I~
#include <ufile4.h>                                                //~v690I~
#include <u3270.h>                                                 //~v717I~
#ifdef UNX                                                         //~v55PI~
	#include <uunxsub.h>                                           //~v55PI~
#endif                                                             //~v55PI~
                                                                //~5318I~
#include "xe.h"
#include "xescr.h"                                              //~5318R~
#include "xefile.h"                                             //~5318I~
#include "xefile6.h"                                               //~v50eI~
#include "xefsub.h"
#include "xesub.h"                                                 //~v13jI~
#include "xeftp.h"                                                 //~v542I~
#include "xedir.h"                                                 //~v717I~
#include "xetso.h"                                               //~v70zI~
//*******************************************************
int xefsubresetcsrplhsub(PUCLIENTWE Ppcw,PULINEH Pplh);            //~v66fM~
//*******************************************************          //~v66fI~
static PULINEH Splhstop=0;                                         //~v542R~
//*******************************************************
//*file re-open
//* parm1:UFILEH ptr
//* parm2:new open option char string
//*******************************************************
FILE *filereopen(PUFILEH Ppfh,UCHAR *Ppopt)
{
	FILE *fh;
    FILEFINDBUF3 fstat3;                                           //~v08rI~
    int rc;                                                        //~v08rI~
    char *pc;                                                      //~v08rI~
    char *fnm;                                                     //~v48cI~
//****************************
    fnm=FILELOCALCOPYNAME(Ppfh);                                   //~v542I~
#ifdef UNX                                                         //~v48cI~
	if (UCBITCHK(Ppfh->UFHflag5,UFHF5MDOS))//original is mdos disk //~v48cI~
    {                                                              //~v48oI~
    	if (!ufstat(fnm,&fstat3))                                  //~v48oI~
        	if (fstat3.attrFile & FILE_READONLY)                   //~v48oI~
            {                                                      //~v48oI~
				uerrmsg("%s(\"%s\") ReOpen failed(ReadOnly)",      //~v48oI~
			    		"%s(\"%s\") ăI[vG[(ReadOnly)",   //~v48oI~
							Ppfh->UFHfilename,Ppopt);              //~v48oR~
                return 0;                                          //~v48oI~
            }                                                      //~v48oI~
    	fnm=Ppfh->UFHalias;                                        //~v48cI~
    }                                                              //~v48oI~
#endif                                                             //~v48cI~
                                                                //~v047I~
//	if (!(fh=freopen(Ppfh->UFHfilename,Ppopt,Ppfh->UFHhfile)))  //~v054I~
	if (Ppfh->UFHhfile)                                         //~v054I~
    {                                                              //~v542I~
//  	if (!fclose(Ppfh->UFHhfile))                               //~v13jR~
    	if (!fileclose(Ppfh->UFHfilename,Ppfh->UFHhfile))          //~v13jI~
			Ppfh->UFHhfile=0;                                   //~v054I~
		else                                                       //~v13jI~
        	return 0;                                              //~v13jR~
    }                                                              //~v542I~
//  if (!(fh=fopen(Ppfh->UFHfilename,Ppopt)))                      //~v48cI~
    if (!(fh=fopen(fnm,Ppopt)))                                    //~v48cR~
    {                                                              //~v08rI~
    	rc=errno;                                                  //~v08rI~
    	pc="";                                                     //~v09xI~
#ifdef UNX                                                         //~v19LI~
      if (errno==EACCES)                                           //~v19LI~
    	pc=",Permission";                                          //~v19LI~
      else                                                         //~v19LI~
      {                                                            //~v19LI~
#endif //UNX                                                       //~v19LI~
//  	if (!ufstat(Ppfh->UFHfilename,&fstat3))                    //~v48cR~
    	if (!ufstat(fnm,&fstat3))                                  //~v48cI~
        {                                                          //~v09xI~
        	if (fstat3.attrFile & FILE_READONLY)                   //~v09xR~
				pc=",ReadOnly";                                    //~v09xR~
    	    else                                                   //~v09xR~
	        	if (fstat3.attrFile & (FILE_HIDDEN|FILE_SYSTEM))   //~v09xI~
					pc=",System or Hidden";                        //~v09xI~
        }                                                          //~v09xI~
#ifdef UNX                                                         //~v19LI~
      }//EACCES                                                    //~v19LI~
#endif //UNX                                                       //~v19LI~
		uerrmsg("%s(\"%s\") ReOpen failed(errno=%d)%s",            //~v08qR~
			    "%s(\"%s\") ăI[vG[(errno=%d)%s",Ppfh->UFHfilename,Ppopt,rc,pc);//~v08qR~
	}                                                              //~v08rI~
    else                                                        //~v047I~
		Ppfh->UFHhfile=fh;                                      //~v047R~
	return fh;
}
//*******************************************************
//*file seek
//*******************************************************
int fileseek(PUFILEH Ppfh,FPOST Ppos,int Popt)
{
	int rc;
//****************************
	if ((rc=fseek(Ppfh->UFHhfile,Ppos,Popt),rc))	//position
		uerrmsg("%s fseek(opt=%d,pos=%d) failed,rc=%d,errno=%d",//~5502R~
  				"%s fseek (%d  %d ̈ʒu) ̎s,rc=%d,errno=%d",//~5502R~
				Ppfh->UFHfilename,Popt,Ppos,rc,errno);          //~5502R~
	return rc;
}//fileseek
                                                                //~5502I~
//*******************************************************          //~v08qI~
//*file read                                                       //~v08qI~
//*parm1:pfh                                                       //~v08qI~
//*parm2:buffer                                                    //~v08qI~
//*parm3:request len                                               //~v08qI~
//*parm4:output read len                                           //~v08qI~
//*rc   :0:ok,1:eof,4:err                                          //~v08qI~
//*******************************************************          //~v08qI~
int fileread(PUFILEH Ppfh,void *Pbuff,size_t Preqlen,size_t *Ppreadlen)//~v08qR~
{                                                                  //~v08qI~
	int err;                                                       //~v08qI~
//****************************                                     //~v08qI~
  	if ((*Ppreadlen=fread(Pbuff,1,Preqlen,Ppfh->UFHhfile))!=Preqlen)//~v08qI~
	{                                                              //~v08qI~
		err=errno;    	                                           //~v08qI~
        if (feof(Ppfh->UFHhfile))                                  //~v08qI~
        	return 1;                                              //~v08qI~
        ufileapierr("read by fread",Ppfh->UFHfilename,err);        //~v08qI~
		return 4;                                                  //~v08qI~
	}                                                              //~v08qI~
	return 0;                                                      //~v08qI~
}//fileread                                                        //~v08qI~
                                                                   //~v08qI~
//*******************************************************
//*file write
//*parm1:pfh                                                       //~v08qI~
//*parm2:buffer                                                    //~v08qI~
//*parm3:req len                                                   //~v08qI~
//*rc   :0:ok,else:errno                                           //~v08qI~
//*******************************************************
int filewrite(PUFILEH Ppfh,void *Pbuff,size_t Plen)                //~v08qR~
{
//****************************
  	if (Plen!=(int)fwrite(Pbuff,1,(unsigned int)Plen,Ppfh->UFHhfile))//~v085R~
	{
//  	uerrmsg("%s write failed",                                 //~v08qR~
//				"%s o̓G|",                                   //~v08qR~
//  			Ppfh->UFHfilename);                                //~v08qR~
        ufileapierr("write by fwrite",Ppfh->UFHfilename,errno);    //~v08qI~
		return errno;
	}
	return 0;
}//filewrite
                                                                //~5502I~
//*******************************************************       //~5502I~
//*file eof write                                               //~5502I~
//*parm1:Pfh                                                    //~5502I~
//*retn :none                                                   //~5502I~
//*******************************************************       //~5502I~
//void fileeofwrite(PUFILEH Ppfh)                                  //~v13jR~
int  fileeofwrite(PUFILEH Ppfh)                                    //~v13jI~
{                                                               //~5502I~
#ifdef UNX                                                         //~v214I~
    return 0;                                                      //~v214I~
#else  //!UNX                                                      //~v214I~
static UCHAR eof[1]={EOFCHAR};                                  //~5502R~
//****************************                                  //~5502I~
	if (UCBITCHK(Gopt2,GOPT2EOFDROP))	//never write           //~5502I~
//     	return;                                                    //~v13jR~
       	return 0;                                                  //~v13jI~
	if (UCBITCHK(Ppfh->UFHflag4,UFHF4BIN))                         //~v180I~
       	return 0;                                                  //~v180I~
	if (UCBITCHK(Ppfh->UFHflag6,UFHF6WTEXTMAC)) //mac type write   //~v47XR~
       	return 0;                                                  //~v47XI~
//  if (UCBITCHK(Ppfh->UFHflag3,UFHF3WTEXTUNIX))                   //~v213R~
//     	return 0;                                                  //~v213R~
#ifdef FTPSUPP                                                     //~v71WI~
	if (FILEISTSO(Ppfh))                                           //~v71WI~
       	return 0;                                                  //~v71WI~
#endif                                                             //~v71WI~
	if (!UCBITCHK(Gopt2,GOPT2EOFWRITE)	//same as input         //~5502R~
   	&&  !UCBITCHK(Ppfh->UFHflag,UFHFEOFEXIST))//input has no eof//~5502R~
//  		return;	//for new file,set by GOPT2EOFWIFNEW at filechkeof//~v13jR~
    		return 0;	//for new file,set by GOPT2EOFWIFNEW at filechkeof//~v13jI~
  return                                                           //~v13jI~
    filewrite(Ppfh,eof,1);				//write EOF             //~5502R~
//  return;                                                        //~v13jR~
#endif //!UNX                                                      //~v214I~
}//fileeofwrite                                                 //~5502I~
                                                                //~5502I~
//****************************************************************//~5503M~
// fileeofchk                                                   //~5503I~
//* try read eof id ^z(0x1a)                                    //~5503M~
//*parm1:pfj                                                    //~5503M~
//*retrn:rc 0:ok ,4:err                                         //~5503M~
//****************************************************************//~5503M~
int fileeofchk(PUFILEH Ppfh)                                    //~5503I~
{                                                               //~5503M~
#ifdef UNX                                                         //~v214I~
#else  //!UNX                                                      //~v214I~
	UCHAR buff[2];                                              //~5503M~
    size_t len;                                                    //~v08qI~
//****************                                              //~5503M~
	UCBITOFF(Ppfh->UFHflag,UFHFEOFEXIST);	//clear once        //~5503I~
	if (UCBITCHK(Ppfh->UFHflag,UFHFNEW))	//new file          //~5503M~
    {                                                           //~5503M~
		if (UCBITCHK(Gopt2,GOPT2EOFWIFNEW))	//as input,write eif if NEW//~5503M~
			UCBITON(Ppfh->UFHflag,UFHFEOFEXIST);	//write eof //~5503M~
    	return 0;                                               //~5503M~
	}                                                           //~5503M~
    if (!Ppfh->UFHsize)		//size 0,no EOF                     //~5503M~
    	return 0;                                               //~5503M~
                                                                //~5503M~
//*OS/2 *  return 0a if read pos is 0d or 0a                    //~5503I~
//*OS/2 *  read err(len=0) if read pos is 1a and errno=0x1d=29=EPASTEOF//~5503I~
//*DOS  *  return 0a if read pos is 0d                          //~5503I~
//*DOS  *  read err(le=0) if read pos is 0a or 1a and no errno set//~5503I~
    if (fileseek(Ppfh,(FPOST)(Ppfh->UFHsize-1),SEEK_SET))       //~5503M~
    {                                                              //~v08qI~
//      UTRACEP("rc=4,fileseek-1 rc=%d",errno);                    //~v08sR~
    	return 4;                                               //~5503M~
    }                                                              //~v08qI~
    if (len=fread(buff,1,1,Ppfh->UFHhfile),len) //read ok          //~v08qR~
    {                                                              //~v08qI~
//      UTRACED("rc=0,fread-1",buff,(int)len);                     //~v08sR~
        if (UCBITCHK(Ppfh->UFHflag3,UFHF3RBIN))//bin mode open     //~v09YR~
            if (*buff==0x1a)                                       //~v09YI~
				UCBITON(Ppfh->UFHflag,UFHFEOFEXIST);               //~v09YI~
		return 0;		//no EOF                                //~5503I~
    }                                                              //~v08qI~
    else                                                           //~v08qI~
    {                                                              //~v09YI~
        if (UCBITCHK(Ppfh->UFHflag3,UFHF3RBIN))//bin mode open     //~v09YR~
	    	return 4;		//ioerr                                //~v09YI~
        if (!feof(Ppfh->UFHhfile))//last 1a cause eof when text mode//~v08sR~
        {                                                          //~v08sI~
//			UTRACEP("ioe ,fread-1 rc=%d\n",errno);                 //~v08sR~
	    	return 4;		//ioerr                                //~v08sI~
		}                                                          //~v08sI~
	}//read fail                                                   //~v09YI~
//     	UTRACEP("eof ,fread-1 rc=%d\n",errno);                     //~v08sI~
////#ifdef DOS                                                     //~v08sR~
//#if defined(DOS) || defined(W32)                                 //~v08sR~
//*last byte read err by 0a of 0d0a or 1a	                    //~5503I~
//    if (fileseek(Ppfh,(FPOST)(Ppfh->UFHsize-2),SEEK_SET))        //~v08sR~
//    {                                                            //~v08sR~
//        UTRACEP("rc=4,fileseek-2 rc=%d",errno);                  //~v08sR~
//    	return 4;                                                  //~v08sR~
//    }                                                            //~v08sR~
//    if (len=fread(buff,1,1,Ppfh->UFHhfile)) //read ok            //~v08sR~
//    {                                                            //~v08sR~
//        UTRACED("rc==0,fread-2",buff,len);                       //~v08sR~
//        if (*buff=='\n')                                         //~v08sR~
//			return 0;		//last 2 byte is 0d0a                  //~v08sR~
//	}                                                              //~v08sR~
//    else                                                         //~v08sR~
//        if (feof(Ppfh->UFHhfile))                                //~v08sR~
//    	    UTRACEP("eof ,fread rc=%d\n",errno);                   //~v08sR~
//        else                                                     //~v08sR~
//        	UTRACEP("ioe ,fread rc=%d\n",errno);                   //~v08sR~
//		else//read ok	 -->311a case                           //~5503I~
//	else	//read err -->0d0a1a case                           //~5503I~
//#else                                                            //~v08sR~
//    if (errno!=EPASTEOF)                                         //~v08sR~
//	{                                                              //~v08sR~
//		uerrmsg("%s read test for eof failed(rc=%d)",              //~v08sR~
//				"%s I/OG[(EOF`FbN),rc=%d",               //~v08sR~
//				Ppfh->UFHfilename,errno);                          //~v08sR~
//    	return 4;                                                  //~v08sR~
//	}                                                              //~v08sR~
//#endif                                                           //~v08sR~
	UCBITON(Ppfh->UFHflag,UFHFEOFEXIST);                        //~5503I~
#endif //!UNX                                                      //~v214I~
	return 0;                                                   //~5503M~
}//fileeofchk                                                   //~5503I~
                                                                //~5503M~
//**************************************************
//*getdisplayline
//* get next/prev display(not excluded) line
//*parm 1:plh
//*parm 2:count(if >0 forward,if <0 backward)
//*parm 3:output actual step count(option)
//*return:plh or 0
//**************************************************
PULINEH getdisplayline(PULINEH Pplh,int Pstep,int *Ppstep)
{
	int step=0,outstep=0;
	PULINEH plh;
//********************
	plh=Pplh;
	if (Pstep<0)
	{
		while (plh=UGETQPREV(plh),plh)
        {                                                          //~v0i0I~
 			if (!UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))
				if (--step==Pstep)
					break;
            if (plh==Splhstop)                                     //~v0i0I~
                break;                                             //~v0i0I~
        }                                                          //~v0i0I~
		outstep=-step;
	}
	else		//forward
		if (Pstep>0)
		{
			while (plh=UGETQNEXT(plh),plh)
            {                                                      //~v0i0I~
 				if (!UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))
					if (++step==Pstep)
						break;
        	    if (plh==Splhstop)                                 //~v0i0I~
    	            break;                                         //~v0i0I~
	        }                                                      //~v0i0I~
			outstep=step;
		}
	if (Ppstep)
		*Ppstep=outstep;
    return plh;
}//getdisplayline

//**************************************************               //~v0i0I~
//*getdisplayline2                                                 //~v0i0I~
//* get next/prev display(not excluded) line with stopper          //~v0i0I~
//*parm 1:plh                                                      //~v0i0I~
//*parm 2:count(if >0 forward,if <0 backward)                      //~v0i0I~
//*parm 3:plh stopper                                              //~v0i0I~
//*parm 4:output actual step count(option)                         //~v0i0I~
//*return:plh or 0                                                 //~v0i0I~
//**************************************************               //~v0i0I~
PULINEH getdisplayline2(PULINEH Pplh,int Pstep,PULINEH Pplhstop,int *Ppstep)//~v0i0I~
{                                                                  //~v0i0I~
	PULINEH plh;                                                   //~v0i0I~
//********************                                             //~v0i0I~
    if (Pplh==Pplhstop)                                            //~v0i0I~
    {                                                              //~v0i0I~
    	if (Ppstep)                                                //~v0i0I~
        	*Ppstep=1;                                             //~v0i0I~
        return Pplh;                                               //~v0i0I~
	}                                                              //~v0i0I~
	Splhstop=Pplhstop;                                             //~v0i0I~
	plh=getdisplayline(Pplh,Pstep,Ppstep);                         //~v0i0I~
	Splhstop=0;                                                    //~v0i0I~
    return plh;                                                    //~v0i0I~
}//getdisplayline2                                                 //~v0i0I~
                                                                   //~v0i0I~
//**************************************************
//*lineseqchk
//* sequence chk 2 plh lineno+suffix
//*parm 1:plh1
//*parm 2:plh2
//*return:<0:plh1<plh2, 0:plh1=plh2, >0:plh1>plh2
//**************************************************
long lineseqchk(PULINEH Pplh1,PULINEH Pplh2)
{
	long rc;
//********************
	if (rc=(int)(Pplh1->ULHlinenor-Pplh2->ULHlinenor),rc)
		return rc;
	if (rc=(int)(Pplh1->ULHsuffix-Pplh2->ULHsuffix),rc)
		return rc;
    if (Pplh1==Pplh2)                                              //~v66fI~
        return 0;                                                  //~v66fI~
	if(Pplh1->ULHtype==ULHTEXCLUDE)
		return (long)-1;
	if(Pplh2->ULHtype==ULHTEXCLUDE)
		return (long)1;
	return (long)0;
}//lineseqchk

//**************************************************               //~v0fmI~
//*ufilesetfhfilename                                              //~v0fmI~
//* set filename to ufh,and also to shortname fow dpmi/w95         //~v0fmI~
//* for remote file;set local filename and remote flag             //~v542I~
//*parm 1:pfh                                                      //~v0fmI~
//*parm 2:longname                                                 //~v0fmI~
//*return:0                                                        //~v542R~
//**************************************************               //~v0fmI~
//void ufilesetfhfilename(PUFILEH Ppfh,char *Plongname)            //~v542R~
int ufilesetfhfilename(PUFILEH Ppfh,char *Plongname)               //~v542I~
{                                                                  //~v0fmI~
#ifdef FTPSUPP                                                     //~v54pR~
	PUFTPHOST puftph;                                              //~v54pR~
#endif                                                             //~v54pR~
//********************                                             //~v0fmI~
  	ustrncpyz(Ppfh->UFHfilename,Plongname,sizeof(Ppfh->UFHfilename));//~v0fmI~
#ifdef FTPSUPP                                                     //~v542M~
    if (uftpisremote(Plongname,&puftph)) //remote hostname prefix exist//~v54pR~
    {                                                              //~v542M~
        Ppfh->UFHdirsepc=FTP_DIR_SEPC;                             //~v542M~
        UCBITON(Ppfh->UFHflag6,UFHF6REMOTE);                       //~v542M~
//  	xeftpgetwdfname(Plongname,Ppfh->UFHftpwdfnm);              //~v70zR~
    	xeftpgetwdfname(puftph,Plongname,Ppfh->UFHftpwdfnm);       //~v70zI~
        Ppfh->UFHpuftph=puftph;                                    //~v54pR~
        if (UFTPHISTSO(puftph))                                    //~v70zI~
        {                                                          //~v70zI~
    	    UCBITON(Ppfh->UFHflag7,UFHF7TSO);                      //~v70zI~
	        Ppfh->UFHdirsepc=DSN_SEPC;                             //~v717I~
            if (strchr(Plongname,'('))                             //~v70zI~
	    	    UCBITON(Ppfh->UFHflag7,UFHF7PDSMEMBER);            //~v70zI~
            strupr(Ppfh->UFHfilename+puftph->UFTPHhostnmlen+1);    //~v717R~
        }                                                          //~v70zI~
    }                                                              //~v542M~
    else                                                           //~v542I~
    {                                                              //~v542I~
    	*Ppfh->UFHftpwdfnm=0;                                      //~v542I~
#endif                                                             //~v542M~
        UCBITOFF(Ppfh->UFHflag6,UFHF6REMOTE);                      //~v542I~
        Ppfh->UFHdirsepc=DIR_SEPC;                                 //~v542M~
#ifdef FTPSUPP                                                     //~v542I~
    }                                                              //~v542I~
#endif                                                             //~v542I~
#if defined(DPMI) || defined(W32)                                  //~v0fmI~
  #ifdef W32                                                       //~v53ZI~
   if (!FILEISREMOTE(Ppfh))                                        //~v53ZI~
  #endif                                                           //~v53ZI~
    ugetvfatalias(UGVFA_WILDCARD|UGVFA_NEW,	//may wildcard or new file//~v0foR~
		Plongname,Ppfh->UFHshortname,sizeof(Ppfh->UFHshortname));  //~v0foI~
#endif                                                             //~v0fmI~
    if (ufileisntfs(*Ppfh->UFHfilename)==1)                        //~v690I~
        UCBITON(Ppfh->UFHflag7,UFHF7NTFS);                         //~v690I~
    else                                                           //~v690I~
        UCBITOFF(Ppfh->UFHflag7,UFHF7NTFS);                        //~v690I~
	return 0;                                                      //~v542R~
}//ufilesetfhfilename                                              //~v0fmI~
//**************************************************               //~v178I~
//*fsubseteolid                                                    //~v178I~
//* set end-of-line id from pfh                                    //~v178I~
//*parm 1:pfh                                                      //~v178I~
//*parm 2:optional plh when split chk required,if splitted set no eol//~v178R~
//*parm 3:optional output area                                     //~v178I~
//*return:none                                                     //~v178I~
//**************************************************               //~v178I~
int fsubseteolid(PUFILEH Ppfh,PULINEH Pplh,char *Pout)             //~v178R~
{                                                                  //~v178I~
	int eollen=0;                                                  //~v178I~
//********************                                             //~v178I~
    if (!UCBITCHK(Ppfh->UFHflag4,UFHF4BIN)) //text mode            //~v178R~
    {                                                              //~v178I~
      if (!(Pplh && UCBITCHK(Pplh->ULHflag4,ULHF4NOEOL)))//skip write eol at save//~v66iI~
      {                                                            //~v66iI~
    	if (!Pplh || !UCBITCHK(Pplh->ULHflag2,ULHF2SPLIT1))//not splitted rec//~v178I~
        {                                                          //~v178I~
          if (UCBITCHK(Ppfh->UFHflag6,UFHF6WTEXTMAC))   //write mode MAC//~v47XI~
          {                                                        //~v47XI~
                if (Pout)                                          //~v47XI~
                    *Pout++=0x0d;                                  //~v47XI~
                eollen=3;   //+1=4                                 //~v50tI~
          }                                                        //~v47XI~
          else                                                     //~v47XI~
          {                                                        //~v47XI~
            if (UCBITCHK(Ppfh->UFHflag3,UFHF3WTEXTPC))   //write mode PC//~v178R~
            {                                                      //~v178R~
                if (Pout)                                          //~v178R~
                    *Pout++=0x0d;                                  //~v178R~
                eollen++;                                          //~v178R~
            }                                                      //~v178R~
            if (Pout)                                              //~v178R~
                *Pout++=0x0a;                                      //~v178R~
          }                                                        //~v47XI~
            eollen++;                                              //~v178R~
        }                                                          //~v178I~
      }//no eol write                                              //~v66iI~
	}                                                              //~v178I~
    return eollen;                                                 //~v178I~
}//fsubseteolid                                                    //~v178I~
//**************************************************               //~v179I~
//*fsubnextlineoversplit                                           //~v179I~
//* advance line(count 1 for split lines as all,excluded line is also 1 line)//~v179R~
//*parm 1:1:ignore excluded line                                   //~v179I~
//*parm 2:current plh                                              //~v179I~
//*parm 3:advance step(1:next line,0:end of concatenated line)     //~v179R~
//*parm 4:optional stop plh(this is ok but cannot over this)       //~v179R~
//*return:plh,0 when overed stop plh                               //~v179R~
//**************************************************               //~v179I~
PULINEH fsubnextlineoversplit(int Popt,PULINEH Pplh,int Pstep,PULINEH Pplhstop)//~v179R~
{                                                                  //~v179I~
	int ii,stopsw=0;                                               //~v179R~
	PULINEH plh;                                                   //~v179R~
//********************                                             //~v179I~
    for (ii=0,plh=Pplh ; plh ; plh=UGETQNEXT(plh))                 //~v179R~
    {                                                              //~v179I~
    	if (stopsw)                                                //~v179I~
        	return 0;                                              //~v179I~
		if (plh==Pplhstop)                                         //~v179R~
        	stopsw=1;		//reached to last                      //~v179R~
//search end                                                       //~v179I~
		if (!Pstep)		//advance to end of concatinated line      //~v179I~
        {                                                          //~v179I~
            if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT1))//has next     //~v179I~
                continue;                                          //~v179I~
            break;                                                 //~v179I~
        }                                                          //~v179I~
//step down                                                        //~v179I~
        if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT2))//has prev         //~v179R~
        	continue;                                              //~v179I~
        if ((Popt & FSNL_DISPLINE) && UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))//ignore excluded//~v179R~
        	continue;                                              //~v179I~
        if (plh!=Pplh)	//not start line                           //~v179I~
        {                                                          //~v179I~
	        ii++;                                                  //~v179R~
            if (ii==Pstep)                                         //~v179I~
            	break;                                             //~v179I~
		}                                                          //~v179I~
    }                                                              //~v179I~
    return plh;                                                    //~v179R~
}//fsubnextlineoversplit                                           //~v179I~
//*******************************************************          //~v21nM~
//*dbcs tbl output for file client area only                       //~v21nM~
//*parm1:plh                                                       //~v21nM~
//*parm2:replaced data pos                                         //~v21nM~
//*parm3:replaced data dbcs pos                                    //~v21nM~
//*parm4:old data len                                              //~v21nM~
//*parm5:new data len                                              //~v21nM~
//*******************************************************          //~v21nM~
void filerepwordsetdbcstbl(PULINEH Pplh,UCHAR *Ppdata,UCHAR *Ppdbcs,int Polen,int Pnlen)//~v21nM~
{                                                                  //~v21nM~
    int len,pos1,pos2;                                             //~v21nM~
    char *pdbcs0;                                                  //~v21nI~
//***************                                                  //~v21nM~
	len=Pplh->ULHlen;                                              //~v21nM~
	pdbcs0=Pplh->ULHdbcs;                                          //~v21nR~
	pos1=(int)((ULONG)Ppdbcs-(ULONG)pdbcs0);                       //~v40bR~
	pos2=pos1+Pnlen;                                               //~v21nM~
//  setobdbcserr(pdbcs0,len,pos1,pos2);//set outbound dbcs err     //~v49bR~
    setobdbcserr(0,pdbcs0,len,pos1,pos2);//set outbound dbcs err   //~v49bR~
    if (pos1 && *(pdbcs0+pos1-1)==UDBCSCHK_HKDBCSERR)   //prev 2nd byte replaced//~v453I~
    {                                                              //~v453I~
    	Ppdata--;                                                  //~v453R~
		Ppdbcs--;                                                  //~v453R~
		Pnlen++;                                                   //~v453I~
    }                                                              //~v453I~
    if (pos2 <len && *(pdbcs0+pos2)==UDBCSCHK_HKDBCSERR)   //next 1st byte replaced//~v453I~
//  	Pnlen++;                                                   //~v49cR~
    	Pnlen+=(len-pos2);                                         //~v49cI~
//  filesetdbcstbl(Ppdata,Ppdbcs,Pnlen);                           //~v44aR~
    filesetdbcstbl(Ppdata,Ppdbcs,Pnlen,0);//ignore tab,fcmd process later//~v44aR~
    return;                                                        //~v21nM~
}//filerepwordsetdbcstbl                                           //~v21nM~
//*************************************************************    //~v50eI~
//*get max record size split and cont (may before tab expand)      //~v50eR~
//*ret :rc                                                         //~v50eI~
//*************************************************************    //~v50eI~
int fsubgetmaxlen(int Popt,PUFILEH Ppfh,int *Ppmaxlen,int *Ppmaxcont)//~v50eR~
{                                                                  //~v50eI~
	PULINEH plh;                                                   //~v50eI~
    int maxlen=0,maxcont=0,len,contlen=0;                          //~v50tR~
//***********************                                          //~v50eI~
  if (Ppfh->UFHmaxlrecl)	//already calc and not updated after   //~v54RI~
  {	                                                               //~v54RI~
  	maxlen=Ppfh->UFHmaxlinewidth;	//line width                   //~v54RI~
  	maxcont=Ppfh->UFHmaxlrecl;		//contline summed length       //~v54RI~
  }                                                                //~v54RI~
  else	                                                           //~v54RI~
  {                                                                //~v54RI~
	for (plh=UGETQTOP(&Ppfh->UFHlineque);plh;plh=UGETQNEXT(plh))   //~v50eI~
    {                                                              //~v50eI~
        if (plh->ULHtype!=ULHTDATA)                                //~v50eI~
            continue;                                              //~v50eI~
        if (Popt & FSGML_TABEXP)                                   //~v50eI~
	        if (!plh->ULHdbcs)  //not once displayed               //~v50eI~
	            if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v50eI~
                	return UALLOC_FAILED;                          //~v50eI~
        len=plh->ULHlen;                                           //~v50eI~
        if (maxlen<len)                                            //~v50eI~
            maxlen=len;                                            //~v50eI~
        if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT2))	//2nd line     //~v50eR~
        	contlen+=len;                                          //~v50eI~
        else                                                       //~v50eI~
        	contlen=len;                                           //~v50eR~
        if (maxcont<contlen)                                       //~v50eR~
        	maxcont=contlen;                                       //~v50eI~
    }                                                              //~v50eI~
  	Ppfh->UFHmaxlinewidth=(USHORT)maxlen;	//line width           //~v54RR~
  	Ppfh->UFHmaxlrecl=(USHORT)maxcont;		//contline summed length//~v54RR~
  }//calc chk                                                      //~v54RI~
  if (Ppmaxcont)                                                   //~v54RI~
    *Ppmaxcont=maxcont;                                            //~v50eR~
  if (Ppmaxlen)                                                    //~v54RI~
    *Ppmaxlen=maxlen;                                              //~v50eI~
    return 0;                                                      //~v50eI~
}//fsubgetmaxlen                                                   //~v50eI~
//**************************************************************** //~v54RI~
//* file update chk at save                                        //~v54RI~
//* retrn:rc UALLOC_FAILED or 4                                    //~v54RI~
//**************************************************************** //~v54RI~
int xefsubupdatechk(PUCLIENTWE Ppcw,PUFILEH Ppfh)                  //~v54RI~
{                                                                  //~v54RI~
	FILEFINDBUF3 fstat3;                                           //~v54RI~
	char tfnm[_MAX_PATH];                                          //~v54RR~
    int rc;                                                        //~v54RR~
#ifdef FTPSUPP                                                     //~v70zI~
	PUFTPHOST puftph;                                              //~v70zI~
#endif                                                             //~v70zI~
//*****************                                                //~v54RI~
#ifdef FTPSUPP                                                     //~v70zI~
  if (!UCBITCHK(Ppfh->UFHflag6,UFHF6RLOGIN))                       //+v72BI~
  {                                                                //+v72BI~
    puftph=Ppfh->UFHpuftph;                                        //~v70zI~
    if (UFTPHISTSO(puftph))   //host is tso                        //~v70zR~
    	return xetsoupdatechk(Ppcw,Ppfh);                          //~v70zR~
  }                                                                //+v72BI~
#endif                                                             //~v70zI~
	strcpy(tfnm,Ppfh->UFHfilename);                                //~v54RI~
    rc=(int)ufstat(tfnm,&fstat3);                                  //~v54RR~
    if (rc)                                                        //~v54RI~
    {                                                              //~v54RI~
        if (UCBITCHK(Ppfh->UFHflag,UFHFNEW))                       //~v54RI~
            rc=0;//ok if not exist                                 //~v54RI~
    }                                                              //~v54RI~
    else    //found                                                //~v54RI~
    {                                                              //~v54RI~
        if (UCBITCHK(Ppfh->UFHflag,UFHFNEW))                       //~v54RI~
            rc=1;//someone saved                                   //~v54RI~
        else                                                       //~v54RI~
#ifdef FTPSUPP                                                     //~v54RI~
        if (*fstat3.slink)                                         //~v54RI~
            rc=memcmp(&(fstat3.slinkfdate),&(Ppfh->UFHfiledate),sizeof(FDATE))//~v54RI~
              |memcmp(&(fstat3.slinkftime),&(Ppfh->UFHfiletime),sizeof(FTIME));//~v54RI~
        else                                                       //~v54RI~
#endif                                                             //~v54RI~
            rc=memcmp(&(fstat3.fdateLastWrite),&(Ppfh->UFHfiledate),sizeof(FDATE))//~v54RI~
              |memcmp(&(fstat3.ftimeLastWrite),&(Ppfh->UFHfiletime),sizeof(FTIME));//~v54RI~
    }                                                              //~v54RI~
    if (rc)                                                        //~v54RI~
    {                                                              //~v54RI~
        uerrmsg("%s is changed",0,                                 //~v54RI~
                tfnm);                                             //~v54RI~
        return 8;                                                  //~v54RI~
    }                                                              //~v54RI~
    return 0;                                                      //~v54RI~
}//xefsubupdatechk                                                 //~v54RR~
#ifdef UNX                                                         //~v55PI~
//**************************************************************** //~v55PI~
//* file write permission chk                                      //~v55PI~
//* retrn:rc 0:ok,4:permission err,8:new create permission err,1:remote/err is not chked//~v57mR~
//**************************************************************** //~v55PI~
int xefsubwritepermissionchk(PUFILEH Ppfh)                         //~v55PI~
{                                                                  //~v55PI~
	uid_t uid;                                                     //~v55PI~
	gid_t gid;                                                     //~v55PI~
	uid_t fuid;                                                    //~v57mI~
	gid_t fgid;                                                    //~v57mI~
    int mode,rc;                                                   //~v55PI~
    char fpath[_MAX_PATH];                                         //~v57mI~
	FILEFINDBUF3 ffb3;                                             //~v57mI~
    int newsw;                                                     //~v57mI~
//*****************                                                //~v55PI~
    if (FILEISREMOTE(Ppfh))                                        //~v55PI~
        return 1;                                                  //~v55PI~
    ugetugid(&uid,&gid);                                           //~v55PI~
  if (UCBITCHK(Ppfh->UFHflag,UFHFNEW))                             //~v57mR~
  {                                                                //~v57mR~
    	newsw=1;                                                   //~v57mI~
        strcpy(fpath,Ppfh->UFHfilename);                           //~v57mI~
    	rc=ufilegetpathdir(fpath,fpath);                           //~v57mR~
        if (rc>1)                                                  //~v57mI~
        	return 1;	//not chked                                //~v57mI~
        if (rc==1)//root                                           //~v57mI~
        {                                                          //~v57mI~
            mode=ROOT_MODE;                                        //~v57mI~
            fuid=ROOT_UID;                                         //~v57mI~
            fgid=ROOT_GID;                                         //~v57mI~
        }                                                          //~v57mI~
        else                                                       //~v57mI~
        {                                                          //~v57mI~
            ufstat(fpath,&ffb3);                                   //~v57mR~
            if (FILEISSLINK(ffb3.attrFile))                        //~v57mR~
            {                                                      //~v57mR~
                mode=FILE_GETMODE(ffb3.srcattr);                   //~v57mR~
                fuid=ffb3.slinkuid;                                //~v57mR~
                fgid=ffb3.slinkgid;                                //~v57mR~
            }                                                      //~v57mR~
            else                                                   //~v57mR~
            {                                                      //~v57mR~
                mode=FILE_GETMODE(ffb3.attrFile);                  //~v57mR~
                fuid=ffb3.uid;                                     //~v57mR~
                fgid=ffb3.gid;                                     //~v57mR~
            }                                                      //~v57mR~
        }                                                          //~v57mI~
  }                                                                //~v57mR~
  else                                                             //~v57mR~
  {                                                                //~v57mR~
    	newsw=0;                                                   //~v57mI~
    if (FILEISSLINK(Ppfh->UFHattr))                                //~v55PI~
    	mode=FILE_GETMODE(Ppfh->UFHsrcattr);                       //~v55PI~
    else                                                           //~v55PI~
	    mode=FILE_GETMODE(Ppfh->UFHattr);                          //~v55PR~
    fuid=Ppfh->UFHuid;                                             //~v57mI~
    fgid=Ppfh->UFHgid;                                             //~v57mI~
  }                                                                //~v57mR~
    if (!uid)	//root user                                        //~v55PI~
    	return 0;                                                  //~v55PI~
  if (newsw)                                                       //~v57mI~
    rc=8;                                                          //~v57mI~
  else                                                             //~v57mI~
    rc=4;	//no permission                                        //~v55PI~
//  if (uid==Ppfh->UFHuid)	//owner                                //~v57mR~
    if (uid==fuid)	//owner                                        //~v57mI~
    {                                                              //~v55PI~
      if (!newsw || (mode & S_IXUSR))                              //~v57mI~
    	if (mode & S_IWUSR)                                        //~v55PI~
        	rc=0;                                                  //~v55PI~
    }                                                              //~v55PI~
    else                                                           //~v55PI~
//  if (gid==Ppfh->UFHgid)	//owner group                          //~v57mR~
    if (gid==fgid)	//owner group                                  //~v57mI~
    {                                                              //~v55PI~
      if (!newsw || (mode & S_IXGRP))                              //~v57mI~
    	if (mode & S_IWGRP)                                        //~v55PI~
        	rc=0;                                                  //~v55PI~
    }                                                              //~v55PI~
    else                                                           //~v55PI~
    {                                                              //~v55PI~
      if (!newsw || (mode & S_IXOTH))                              //~v57mI~
    	if (mode & S_IWOTH)                                        //~v55PI~
        	rc=0;                                                  //~v55PI~
    }                                                              //~v55PI~
    return rc;                                                     //~v55PI~
}//xefsubwritepermissionchk                                        //~v55PI~
#else                                                              //~v55XI~
//**************************************************************** //~v55XI~
//* file write permission chk                                      //~v55XI~
//* retrn:rc 0:ok,4:permission err,1:remote is not chked           //~v55XI~
//**************************************************************** //~v55XI~
int xefsubwritepermissionchk(PUFILEH Ppfh)                         //~v55XI~
{                                                                  //~v55XI~
//*****************                                                //~v55XI~
    if (FILEISREMOTE(Ppfh))                                        //~v55XI~
        return 1;                                                  //~v55XI~
    if (Ppfh->UFHattr & FILE_READONLY)                             //~v55XI~
    	return 4;                                                  //~v55XI~
    return 0;                                                      //~v55XI~
}//xefsubwritepermissionchk                                        //~v55XI~
#endif                                                             //~v55PI~
//**************************************************************** //~v66fI~
//* reset UFcsrplh for deleted plh                                 //~v66fI~
//* rc:1:reset done, 0:deleted plh is not on the UFCcsrplh,-1:err(plh is dequed)//~v66fI~
//**************************************************************** //~v66fI~
int xefsubresetcsrplh(PUCLIENTWE Ppcw,PULINEH Pplh)                //~v66fI~
{                                                                  //~v66fI~
	PUFILEH pfh;                                                   //~v66fI~
    int rc;                                                        //~v66fI~
//*****************                                                //~v66fI~
	if (Ppcw)                                                      //~v66fI~
		rc=xefsubresetcsrplhsub(Ppcw,Pplh);                        //~v66fI~
    else                                                           //~v66fI~
    {                                                              //~v66fI~
    	pfh=UGETPFH(Pplh);                                         //~v66fR~
        if (!pfh)                                                  //~v66fI~
        	return -1;	//plh dequed                               //~v66fI~
		rc=xefsubresetcsrplhsub(pfh->UFHeditpcw,Pplh);             //~v66fI~
		rc|=xefsubresetcsrplhsub(pfh->UFHbrowsepcw[0],Pplh);       //~v66fI~
		rc|=xefsubresetcsrplhsub(pfh->UFHbrowsepcw[1],Pplh);       //~v66fI~
    }                                                              //~v66fI~
    return rc;                                                     //~v66fI~
}//xefsubresetcsrplh                                               //~v66fI~
//**************************************************************** //~v66fI~
//**************************************************************** //~v66fI~
int xefsubresetcsrplhsub(PUCLIENTWE Ppcw,PULINEH Pplh)             //~v66fI~
{                                                                  //~v66fI~
	PUFILEC pfc;                                                   //~v66fI~
//*****************                                                //~v66fI~
	if (Ppcw)                                                      //~v66fI~
    {                                                              //~v66fI~
        pfc=Ppcw->UCWpfc;                                          //~v66fI~
        if (pfc->UFCcsrplh==Pplh)                                  //~v66fI~
        {                                                          //~v66fI~
            pfc->UFCcsrplh=0;                                      //~v66fI~
            return 1;                                              //~v66fI~
        }                                                          //~v66fI~
    }                                                              //~v66fI~
    return 0;                                                      //~v66fI~
}//xefsubresetcsrplhsub                                            //~v66fI~
