//*CID://+v71dR~:                             update#=  244;       //+v71dR~
//*************************************************************
//*xepan2.c
//*   filename list process
//*************************************************************
//v71d:061006 (BUG)filenamelsit "S" cmd generate subcmdid=0(truncated cmd)err//+v71dI~
//v64v:050708 (LNX)openwith support                                //~v64vI~
//v61v:050306 (BUG)select shpuld follow previous cmd               //~v61vI~
//v61u:050306 (BUG)redraw required for space lcmd on filename list //~v61fI~
//v61r:050302 keep edit or browse id on filename queue             //~v61rI~
//v61p:050301 support filename list delete lcmd('D')               //~v61pI~
//v61k:050301 (BUG of v61c)abend may occur when filenamelist filename length on//~v61kI~
//            xe!save! is contain strz char.                       //~v61kR~
//v61f:050226 space lcmd on filename list;drop parm and set on cmd line//~v61fI~
//v61d:050222 support pgtop/pglast for filename list               //~v61dI~
//v61c:050221 set open parm to filename list to reopen by same option//~v61cI~
//            lcmd "3" means bin browse/edit                       //~v61cR~
//v56f:040404 finenamelist page overrun by pgdn when enq count is just multiple of pagesize//~v56fI~
//v56d:040403 set csr to top of filename list when wakeup          //~v56dI~
//v55V:040321 (WIN)filename list ! lcmd(openwith) support          //~v55VI~
//v55U:040321 (WXE)openwith when dblclick on filenamelist/dirlist if associated//~v55UI~
//v55w:040302 driveid list missed by v557                          //~v55wI~
//v55m:040218 (BUG)filename list;filename select should consider multipage//~v55mI~
//v557:040203 filename list multi-page support                     //~v557I~
//v54v:040114 display and select by cursor the driveid list.       //~v54vI~
//v53v:031005 (BUG)filename list line is not reversed for lower line.//~v53vI~
//v53c:030921 alt+w for C&P copy word                              //~v53cI~
//v51P:030727 (BUG)filename is cut if screen width is narrow when select on filename list scr//~v51PI~
//v50G:030201 add cmd "et"/"bt"/"st" for e/b/s /mt                 //~v50GI~
//v508:021109 (BUG)menu file list stack,filename compare by case insensitive for not unix//~v508I~
//v500:021109 (WXE)maxline is not same as xe                       //~v500I~
//v500:021109 (WXE)xe maxline over flow(UPCline[ii]) abend caused by wxe//~v500I~
//v44p:011205 cobol cmd support                                    //~v44pI~
//            c:cob-seqno,k:cob-space,i:spfcob-seqno,j:spfcob-space,n:spf//~v44pI~
//v44n:011205 Hex suppot(h:by menuopt,H:opposit of menu opt)       //~v44nI~
//v40b:010327 LINUX support:ajust after merge                      //~v40bI~
//v216:001202 file name list;chance to modify e/b cmd for enter key.//~v216I~
//v20y:001028 new function:filename selection on menu 1/2 name list
//*************************************************************
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifdef DOS
#else
#endif
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <uque.h>
#include <ualloc.h>
#include <ufile.h>
#include <ustring.h>                                               //~v61cI~
#include <utrace.h>
#ifndef UNX                                                        //~v54vI~
	#include <udos2.h>                                             //~v54vI~
#endif                                                             //~v54vI~

#include "xe.h"
#include "xescr.h"
#include "xescr2.h"                                                //~v216I~
#include "xecsr.h"
#include "xefunc.h"
#include "xefunc2.h"                                               //~v216I~
#include "xefile.h"
#include "xepan.h"
#include "xepan2.h"
#define XEPAN22_GLOBAL	//define global in the xepan22.h           //~v557I~
#include "xepan22.h"
#include "xesub.h"
#include "xeerr.h"                                                 //~v53cI~
#include "xedlcmd.h"                                               //~v55VI~
#include "xedlcmd6.h"                                              //~v55VI~
//****************************************************************
//*stack cmd
typedef struct _UP300LIST {						//stack cmd
						UQUEE   U3Lqelem;   //fifo q
                        int     U3Lflag;	                       //~v61cI~
#define U3LFCMDMASK      0x00ff                                    //~v61cR~
#define U3LFCMDBINCMD    'b'                                       //~v61cI~
#define U3LFCMDBINLCMD   '3'                                       //~v61cR~
#define U3LFSPACEEMBEDED 0x0100                                    //~v61cI~
#define U3LFPARM         0x0200                                    //~v61cI~
                        int     U3Lnetfnmlen;  //net filename len  //~v61cI~
                        int     U3Lfnmlen;  //cmd string len
						UCHAR   U3Lfnm[1];	//cmd string
					  	} UP300LIST,*PUP300LIST;
#define UP300LISTSZ (sizeof(UP300LIST))
//****************************************************************
#define LCMDID  "_"                                                //~v20yI~
#define LCMDIDCH '_'                                               //~v61cI~
#define LCMDIDDELCH 'D'        //delete entry lcmd                 //~v61pR~
static UQUEH 		Sfnstack;  //filename stack que
static int Supdatelistsw=0;       //list updated                   //~v44nR~
static int Sspacelcmd=0;	       //put cmd by space lcmd         //~v61fI~
//static UCHAR Scmdtbl[]="best12hHnNcCkKiIjJ";                     //~v55VR~
//static UCHAR Scmdtbl[]="best12hHnNcCkKiIjJ!";                    //~v61cR~
//static UCHAR Scmdtbl[]="best123hHnNcCkKiIjJ!(Space)";            //~v61pR~
static UCHAR Scmdtbl[]="best123hHnNcCkKiIjJ!(Space)d";             //~v61pI~
//****************************************************************
//void pan300addentry(UCHAR *Pfnm,int Pfnmlen,int Pinitsw);        //~v55VR~
int pan300lcmderr(UCHAR *Pcmdtbl);
int panbecmdcall(PUCLIENTWE Ppcw,UCHAR Pcmdid);                    //~v44nI~
int panbrowsecmdchk(PUCLIENTWE Ppcw,UCHAR Pcmdid);                 //~v44nI~
//int pan300getfnm(int Pyy,UCHAR *Pout);                           //~v55UR~
int pan300csrreset(PUCLIENTWE Ppcw);                               //~v56dI~
//int pan300getlcmdfromfuncid(int Pfuncid,int Pbrowsesw);          //~v61rR~
int pan300getlcmdfromfuncid(int Pfuncid,int *Ppbrowsesw);          //~v61rI~
int pan300editfpath(PUCLIENTWE Ppcw,UCHAR *Pfpath,int Plcmd,UCHAR *Poutcmdstr);//~v61cI~
int pan300editcmd(PUCLIENTWE Ppcw,PUP300LIST Ppsc,char *Pcmdstr);  //~v61cR~
int pan300getbecmd(PUCLIENTWE Ppcw,PUP300LIST Ppsc,char *Pbecmd);  //~v61uR~
PUP300LIST pan300getpsc(int Pyy);                                  //~v61cR~
int pan300delentry(PUCLIENTWE Ppcw,PUP300LIST Ppsc);               //~v61pI~
//****************************************************************
//* draw filename list
//****************************************************************
int pan300selectline(PUCLIENTWE Ppcw)
{
	int yy,ii,maxline;
    int curpageend;                                                //~v557I~
    PUPANELC ppc;		//pannel buff
    ULONG fld2mask=0x40000000;
//************************************
	yy=Ppcw->UCWrcsry;		//  cursor line
#ifndef UNX                                                        //~v54vI~
//driveid list                                                     //~v54vI~
    if (yy==PANL300DRIVE)                                          //~v54vI~
    	pan300drawdid(Ppcw);                                       //~v54vI~
#endif                                                             //~v54vI~
    maxline=PANL300LISTTOP+UGETQCTR(&Sfnstack);	//enq counter
    curpageend=maxline-Ppcw->UCWtopfnlist;   //current topline entryno//~v557R~
//#ifdef WXE                                                       //~v557R~
////  maxline=min(maxline,Gscrbuffheight-PANL300LISTTOP);//overflow//~v557R~
//    maxline=min(maxline,Gscrbuffheight);//overflow               //~v557R~
//#else                                                            //~v557R~
////  maxline=min(maxline,Gscrheight-PANL300LISTTOP);//overflow    //~v557R~
//    maxline=min(maxline,Gscrheight);//overflow                   //~v557R~
//#endif                                                           //~v557R~
	maxline=Ppcw->UCWheight;//scr height                           //~v557I~
//set reverse on/off
    ppc=Ppcw->UCWppc;
    for (ii=PANL300LISTTOP;ii<maxline;ii++)
    {                                                              //~v557I~
//        if (ppc->UPCline[ii].UPLerrflag & fld2mask)              //~v557R~
//        {                                                        //~v557R~
//            if (ii!=yy)                                          //~v557R~
//                panflderr(Ppcw,ii,PANL300NAME,PANFERESET);  //reset err reverse//~v557R~
//        }                                                        //~v557R~
//        else                                                     //~v557R~
//            if (ii==yy)                                          //~v557R~
//            {                                                    //~v557R~
//                panflderr(Ppcw,yy,PANL300NAME,PANFESET);    //set err reverse on cur csr//~v557R~
//                csronthefld(Ppcw,yy,PANL300LCMD,0);   //move csr to lcmd fld//~v557R~
//            }                                                    //~v557R~
        if (ii==yy && yy<curpageend)                               //~v557I~
        {                                                          //~v557I~
            panflderr(Ppcw,yy,PANL300NAME,PANFESET);    //set err reverse on cur csr//~v557I~
            csronthefld(Ppcw,yy,PANL300LCMD,0);   //move csr to lcmd fld//~v557I~
        }                                                          //~v557I~
        else                                                       //~v557I~
            if (ppc->UPCline[ii].UPLerrflag & fld2mask)            //~v557I~
                panflderr(Ppcw,ii,PANL300NAME,PANFERESET);  //reset err reverse//~v557I~
    }                                                              //~v557I~
	return 0;
}
//****************************************************************
//* setup filename list
//****************************************************************
int pan300updatelist(PUCLIENTWE Ppcw,int Pwakeupsw)
{
    int ii,yy;                                                     //~v20yR~
    int maxline;                                                   //~v500I~
	PUP300LIST psc;			//stack entry
	PUPANELC ppc;                                                  //~v20yI~
	PUFLD    pfld;                                                 //~v20yI~
    int startline,redrawsw,stackctr,endline;                       //~v557R~
#ifndef UNX                                                        //~v54vI~
    char didlist[32];                                              //~v54vR~
    int didno;                                                     //~v54vM~
#ifdef AAA                                                         //~v54vI~
	char didwk[2],*pc;                                             //~v54vI~
#else                                                              //~v54vI~
    char outlist[64],*pco,*pc;                                     //~v54vI~
#endif                                                             //~v54vI~
#endif                                                             //~v54vI~
    char pageno[20];                                               //~v557R~
	char fpathcmd[_MAX_PATH+MAXCOLUMN];                            //~v61cI~
    char lcmdid[2];                                                //~v61cM~
//************************************
    if (Ppcw->UCWheight!=Ppcw->UCWoldheight)                       //~v557I~
    {                                                              //~v557I~
    	Ppcw->UCWoldheight=Ppcw->UCWheight;                        //~v557I~
        redrawsw=1;                                                //~v557I~
    }                                                              //~v557I~
    else                                                           //~v557I~
        redrawsw=Supdatelistsw;                                    //~v557I~
//  if (Supdatelistsw || Pwakeupsw)       //list updated           //~v557R~
    if (redrawsw || Pwakeupsw)       //list updated                //~v557I~
    {
		ppc=Ppcw->UCWppc;			//client panel control         //~v20yI~
		UCBITON(Ppcw->UCWflag,UCWFDRAW);	//full draw
#ifndef UNX                                                        //~v54vI~
        if (Pwakeupsw)                                             //~v54vI~
        {                                                          //~v54vI~
        	memset(didlist,0,sizeof(didlist));                     //~v54vR~
            didno=ugetdriveidlist(-1,didlist);    //get driveid list//~v54vI~
#ifdef AAA                                                         //~v54vI~
            didwk[1]=0;                                            //~v54vR~
            for (ii=0,pc=didlist;ii<26;ii++,pc++)                  //~v54vR~
            {                                                      //~v54vI~
            	didwk[0]=*pc;                                      //~v54vI~
    			setflddata(Ppcw,PANL300DRIVE,PANF300DRIVEIDLIST+ii,didwk);//~v54vR~
            }                                                      //~v54vI~
#else                                                              //~v54vI~
            for (ii=0,pc=didlist,pco=outlist;ii<didno;ii++,pc++)   //~v54vI~
            {                                                      //~v54vI~
            	*pco++=*pc;                                        //~v54vI~
            	*pco++=' ';                                        //~v54vI~
            }                                                      //~v54vI~
            *pco=0;                                                //~v54vI~
//  		setflddata(Ppcw,PANL300DRIVE,0,outlist);               //~v55wR~
    		setflddata(Ppcw,PANL300DRIVE,1,outlist);               //~v55wI~
#endif                                                             //~v54vI~
        }                                                          //~v54vI~
#endif                                                             //~v54vI~
//#ifdef WXE                                                       //~v557R~
//        maxline=Gscrbuffheight-PANL300LISTTOP;//overflow         //~v557R~
//#else                                                            //~v557R~
//        maxline=Gscrheight-PANL300LISTTOP;//overflow             //~v557R~
//#endif                                                           //~v557R~
		maxline=Ppcw->UCWheight-PANL300LISTTOP;                    //~v557I~
		startline=Ppcw->UCWtopfnlist;                              //~v557M~
		stackctr=UGETQCTR(&Sfnstack);                              //~v557I~
        endline=startline+maxline;                                 //~v557I~
        endline=min(endline,stackctr);                             //~v557I~
      if (endline)                                                 //~v61pI~
		sprintf(pageno,"%d - %d of %d",startline+1,endline,stackctr);//~v557R~
      else                                                         //~v61pI~
		sprintf(pageno,"%d - %d of %d",0,endline,stackctr);        //~v61pI~
    	setflddata(Ppcw,PANL300PAGENO,0,pageno);                   //~v557R~
        if (maxline<=0)                                            //~v557I~
        	return 0;                                              //~v557I~
//  	for (ii=0,psc=UGETQTOP(&Sfnstack);psc;ii++,psc=UGETQNEXT(psc))//all entry//~v500R~
//  	for (ii=0,psc=UGETQTOP(&Sfnstack);ii<maxline && psc;ii++,psc=UGETQNEXT(psc))//all entry//~v557R~
    	for (ii=0,psc=UGETQTOP(&Sfnstack);ii<startline && psc;ii++)//all entry//~v557I~
    		psc=UGETQNEXT(psc);		//skip prev page               //~v557I~
//  	for (ii=0;ii<maxline && psc;ii++,psc=UGETQNEXT(psc))//all entry//~v557R~
    	for (ii=0;ii<maxline;ii++)//all entry                      //~v557I~
        {                                                          //~v20yI~
    		yy=PANL300LISTTOP+ii;                                  //~v20yI~
			pfld=ppc->UPCline[yy].UPLpfld;                         //~v20yI~
          if (psc)                                                 //~v557I~
          {                                                        //~v557I~
			UCBITOFF(pfld->UFLentry[PANL300LCMD].UFLflag,UFLEFPROT);//~v20yI~
//  	    setflddata(Ppcw,yy,PANL300LCMD,LCMDID);//clear input   //~v61cR~
//  		setflddata(Ppcw,yy,PANL300NAME,psc->U3Lfnm);           //~v61cR~
			pan300editcmd(Ppcw,psc,fpathcmd);                      //~v61cR~
//  		lcmdid[0]=(char)(psc->U3Lflag & U3LFCMDMASK);          //~v61rR~
			lcmdid[0]=(char)pan300getbecmd(Ppcw,psc,0);            //~v61vR~
            lcmdid[1]=0;                                           //~v61cI~
    	    setflddata(Ppcw,yy,PANL300LCMD,lcmdid);//clear input   //~v61cI~
    		setflddata(Ppcw,yy,PANL300NAME,fpathcmd);              //~v61cI~
    	    psc=UGETQNEXT(psc);//all entry                         //~v557I~
          }                                                        //~v557I~
          else                                                     //~v557I~
          {                                                        //~v557I~
			UCBITON(pfld->UFLentry[PANL300LCMD].UFLflag,UFLEFPROT);//~v557I~
		    setflddata(Ppcw,yy,PANL300LCMD," ");//clear input      //~v557I~
    		setflddata(Ppcw,yy,PANL300NAME," ");                   //~v557I~
          }                                                        //~v557I~
        }                                                          //~v20yI~
    }
	Supdatelistsw=0;       //ppc updated
	pan300selectline(Ppcw);//set reverse
	return 0;
}//pan300updatelist                                                //~v557R~
//**************************************************************** //~v61fI~
//* get display lcmd                                               //~v61fI~
//* parm3:optional browse/edit cmd string                          //~v61uI~
//*ret cmdid                                                       //~v61fI~
//**************************************************************** //~v61fI~
int pan300getbecmd(PUCLIENTWE Ppcw,PUP300LIST Ppsc,char *Pbecmd)   //~v61uR~
{                                                                  //~v61fI~
    int browsesw,lcmd,lcmdupper,lcmdlower;                         //~v61fI~
    int cmdid,subcmdid;                                            //~v61uI~
//************************************                             //~v61fI~
    if (Ppcw->UCWmenuopt==PANMOBROWSE)                             //~v61fI~
    {                                                              //~v61uI~
        browsesw=1;                                                //~v61fI~
        cmdid='b';                                                 //~v61uI~
    }                                                              //~v61uI~
    else                                                           //~v61fI~
    {                                                              //~v61uI~
        browsesw=0;                                                //~v61fI~
        cmdid='e';                                                 //~v61uI~
    }                                                              //~v61uI~
    lcmd=(Ppsc->U3Lflag & U3LFCMDMASK);                            //~v61fR~
    if (!lcmd)                                                     //~v61fI~
    {                                                              //~v61uI~
        lcmd=LCMDIDCH;                                             //~v61fI~
        subcmdid=0;                                                //~v61uI~
    }                                                              //~v61uI~
    else                                                           //~v61fI~
    {                                                              //~v61fI~
        lcmdupper=toupper(lcmd);                                   //~v61fI~
        lcmdlower=tolower(lcmd);                                   //~v61fI~
        if (lcmdlower=='b')//bin                                   //~v61fI~
        {                                                          //~v61uI~
            if (lcmd==lcmdlower)    //browse                       //~v61fI~
            {                                                      //~v61uI~
                lcmd='1';                                          //~v61fI~
                cmdid='b';                                         //~v61uI~
            }                                                      //~v61uI~
            else                    //edit                         //~v61fI~
            {                                                      //~v61uI~
                lcmd='2';                                          //~v61fI~
                cmdid='e';                                         //~v61uI~
            }                                                      //~v61uI~
            subcmdid='b';   //bin                                  //~v61uI~
        }                                                          //~v61uI~
        else                                                       //~v61fI~
        {                                                          //~v61uI~
            if (lcmd==lcmdupper)    //upper,edit cmd               //~v61uR~
            {                                                      //~v61uR~
                if (!browsesw)      //edit                         //~v61uR~
                    lcmd=lcmdlower; //lower mean edit under edit scr//~v61uR~
                cmdid='e';                                         //~v61uI~
            }                                                      //~v61uR~
            else        //lower,browse cmd                         //~v61uR~
            {                                                      //~v61uR~
                if (!browsesw)      //edit                         //~v61uR~
                    lcmd=lcmdupper; //upper mean edit under browse scr//~v61uR~
                cmdid='b';                                         //~v61uI~
            }                                                      //~v61uR~
            subcmdid=lcmdlower;                                    //~v61uI~
        }                                                          //~v61uI~
    }                                                              //~v61fI~
    if (Pbecmd)                                                    //~v61uI~
    {                                                              //~v61uI~
        *Pbecmd=(char)cmdid;                                       //~v61uI~
        *(Pbecmd+1)=(char)subcmdid;                                //~v61uI~
        *(Pbecmd+2)=0;                                             //~v61uI~
    }                                                              //~v61uI~
    return lcmd;                                                   //~v61fI~
}//pan300getbecmd                                                  //~v61uR~
//**************************************************************** //~v61cI~
//* edit cmd string                                                //~v61cR~
//*   enclose by quote is filename has space                       //~v61cI~
//*   append cmd parm if used at original cmd                      //~v61cI~
//*ret cmd string len                                              //~v61cI~
//**************************************************************** //~v61cI~
int pan300editcmd(PUCLIENTWE Ppcw,PUP300LIST Ppsc,char *Pcmdstr)   //~v61cR~
{                                                                  //~v61cI~
	char *pc,*pco;                                                 //~v61cR~
    int len;                                                       //~v61cR~
//************************************                             //~v61cI~
    pc=Ppsc->U3Lfnm;	//filename                                 //~v61cR~
    pco=Pcmdstr;                                                   //~v61cI~
    if (Ppsc->U3Lflag & (U3LFPARM|U3LFSPACEEMBEDED))               //~v61cR~
    {                                                              //~v61cI~
    	len=Ppsc->U3Lnetfnmlen;                                    //~v61cI~
	    if (Ppsc->U3Lflag & U3LFSPACEEMBEDED)                      //~v61cR~
        	*pco++='\"';                                           //~v61cI~
        memcpy(pco,pc,(UINT)len);                                  //~v61cI~
        pco+=len;                                                  //~v61cI~
        pc+=len+1;	//input pos                                    //~v61cI~
	    if (Ppsc->U3Lflag & U3LFSPACEEMBEDED)                      //~v61cR~
        	*pco++='\"';                                           //~v61cI~
	    if (Ppsc->U3Lflag & U3LFPARM)                              //~v61cI~
        {                                                          //~v61cI~
          if (!Sspacelcmd) //spce cmd drop parm                    //~v61fI~
          {                                                        //~v61fI~
            *pco++=' ';                                            //~v61cI~
        	len=(int)strlen(pc);                                   //~v61cI~
        	memcpy(pco,pc,(UINT)len);                              //~v61cI~
            pco+=len;                                              //~v61cI~
          }                                                        //~v61fI~
        }                                                          //~v61cI~
        *pco=0;                                                    //~v61cI~
    }                                                              //~v61cI~
    else                                                           //~v61cI~
    	strcpy(pco,pc);                                            //~v61cR~
    return (int)strlen(Pcmdstr);                                   //~v61cR~
}//pan300editcmd                                                   //~v61cR~
#ifndef UNX                                                        //~v54vI~
//**************************************************************** //~v54vI~
//* draw drivid list                                               //~v54vI~
//**************************************************************** //~v54vI~
int pan300drawdid(PUCLIENTWE Ppcw)                                 //~v54vI~
{                                                                  //~v54vI~
#ifdef AAA                                                         //~v54vI~
    PUPANELC ppc;		//pannel buff                              //~v54vM~
	PUSCRD psd;                                                    //~v54vI~
    UFLDE  *pfle;                                                  //~v54vR~
    int xx,fldno,did,offs,oldfldno,ii;                             //~v54vR~
    char drvid[4];                                                 //~v54vR~
    ULONG errflg,bitmask;                                          //~v54vR~
//************************************                             //~v54vI~
	psd=Ppcw->UCWpsd+PANL300DRIVE;                                 //~v54vM~
	ppc=Ppcw->UCWppc;			//client panel control             //~v54vI~
    errflg=ppc->UPCline[PANL300DRIVE].UPLerrflag;	//prev value   //~v54vI~
    bitmask=(0x80000000>>PANF300DRIVEIDLIST);                      //~v54vR~
    for (ii=0,oldfldno=-1;ii<26;ii++)   //chk prev driveid fldno   //~v54vR~
    {                                                              //~v54vI~
        if (errflg & bitmask)                                      //~v54vR~
        {                                                          //~v54vI~
        	oldfldno=ii;                                           //~v54vI~
            break;                                                 //~v54vI~
        }                                                          //~v54vI~
        bitmask>>=1;                                               //~v54vI~
    }                                                              //~v54vI~
    pfle=(UFLDE*)getuflde(Ppcw,PANL300DRIVE,PANF300DRIVEIDLIST);   //~v54vM~
	UCBITON(psd->USDflag2,USDF2DRAW);                              //~v54vM~
    xx=Ppcw->UCWrcsrx;      //  cursor line                        //~v54vM~
    offs=xx-pfle->UFLstart;                                        //~v54vM~
    did=0;                                                         //~v54vI~
    if (offs>=-1 && offs<26*2) //cs is in driveid list fld         //~v54vR~
    {                                                              //~v54vI~
        fldno=(offs+1)/2;                                          //~v54vI~
        if (offs%2)	//in between fld                               //~v54vI~
        	if(fldno==oldfldno)                                    //~v54vI~
            	fldno--;                                           //~v54vI~
        if (fldno>=0)                                              //~v54vI~
        {                                                          //~v54vI~
	    	getfldinput(Ppcw,PANL300DRIVE,PANF300DRIVEIDLIST+fldno,drvid);//~v54vR~
    		did=*drvid;                                            //~v54vR~
        }                                                          //~v54vI~
    }                                                              //~v54vI~
    ppc->UPCline[PANL300DRIVE].UPLerrflag=0;	//all clear        //~v54vI~
    if (did)	//on drive id fld                                  //~v54vI~
    {                                                              //~v54vI~
		panflderr(Ppcw,PANL300DRIVE,PANF300DRIVEIDLIST+fldno,PANFESET);	//set err reverse on cur csr//~v54vI~
        if (offs%2)                                                //~v54vI~
    		csronthefld(Ppcw,PANL300DRIVE,PANF300DRIVEIDLIST+fldno,0);   //move csr to lcmd fld//~v54vI~
    }                                                              //~v54vI~
#else                                                              //~v54vI~
	PUSCRD psd;                                                    //~v54vI~
    UFLDE  *pfle;                                                  //~v54vI~
    int xx,offs,datalen;                                           //~v54vR~
    char didlist[64],did;                                          //~v54vR~
//************************************                             //~v54vI~
	psd=Ppcw->UCWpsd+PANL300DRIVE;                                 //~v54vI~
    pfle=(UFLDE*)getuflde(Ppcw,PANL300DRIVE,PANF300DRIVEIDLIST);   //~v54vI~
    datalen=getfldinput(Ppcw,PANL300DRIVE,PANF300DRIVEIDLIST,didlist);//~v54vR~
    xx=Ppcw->UCWrcsrx;      //  cursor line                        //~v54vI~
    offs=xx-pfle->UFLstart;                                        //~v54vI~
    if (!(offs>=0 && offs<datalen))                                //~v54vR~
    	return 0;                                                  //~v54vI~
    did=*(didlist+offs);                                           //~v54vI~
    if (did==' ')                                                  //~v54vI~
    	return 0;                                                  //~v54vI~
//  panflderr(Ppcw,PANL300DRIVE,PANF300DRIVEID,PANFESET);	//set err reverse on cur csr//~v54vR~
    didlist[0]=did;                                                //~v54vI~
    didlist[1]=0;                                                  //~v54vI~
    datalen=setflddata(Ppcw,PANL300DRIVE,PANF300DRIVEID,didlist);  //~v54vR~
	UCBITON(psd->USDflag2,USDF2DRAW);                              //~v54vM~
    pan300setcpath(Ppcw,did);                                      //~v54vR~
	psd=Ppcw->UCWpsd+PANL300CURRENT;                               //~v54vI~
	UCBITON(psd->USDflag2,USDF2DRAW);                              //~v54vI~
#endif                                                             //~v54vI~
	return did;                                                    //~v54vR~
}//pan300drawdid                                                   //~v54vI~
#endif                                                             //~v54vI~
//**************************************************
//*pan300stack
//*stack filename
//*parm1:string addr
//*parm2:string len
//*ret  :none
//**************************************************
//void pan300stack(PUCLIENTWE Ppcw,PUFILEH Ppfh)                   //~v61cR~
void pan300stack(PUCLIENTWE Ppcw,PUFILEH Ppfh,PUCLIENTWE Pcmdpcw)  //~v61cR~
{
    FUNCTBL *pft;	//FUNKTBL ptr                                  //~v61cI~
    PUFILEC  pfc;                                                  //~v61cI~
	char *pc;
	char fpathcmd[_MAX_PATH+MAXCOLUMN];                            //~v61cR~
    int opt;                                                       //~v557I~
    int lcmd=0,browsesw=0,len;                                     //~v61cR~
//**************************************************
    switch(Ppfh->UFHtype)
    {
    case UFHTCLIPBOARD:          //clipboard file in work dir
    case UFHTKFI      :          //key func ini file in work dir
    case UFHTSTDOUT   :          //first opened as cmd stdout
    case UFHTTEMPWK   :          //TEMP work for partial edit etc
        return;
    }
    if (Pcmdpcw)                                                   //~v61cM~
    {                                                              //~v61cM~
      	pft=Pcmdpcw->UCWpfunct;                                    //~v61cM~
      	if (pft)   //::cb etc,internaly called function has no pfunct//~v61cM~
      	{                                                          //~v61cM~
          	pfc=Pcmdpcw->UCWpfc;    //                             //~v61cM~
          	if (pfc)                                               //~v61cM~
              	browsesw=UCBITCHK(pfc->UFCflag,UFCFBROWSE)!=0;     //~v61cM~
//        	lcmd=pan300getlcmdfromfuncid(pft->FTfuncid,browsesw);  //~v61rR~
          	lcmd=pan300getlcmdfromfuncid(pft->FTfuncid,&browsesw); //~v61rI~
      	}                                                          //~v61cM~
  	}                                                              //~v61cM~
	pc=Ppfh->UFHfilename;
    if (len=pan300editfpath(Pcmdpcw,pc,lcmd,fpathcmd),len)//rep fnm of cmd string by fpath//~v61cR~
        pc=fpathcmd;    //quataion embedded or otherparm exist     //~v61cI~
    else                                                           //~v61cI~
    	len=(int)strlen(pc);                                       //~v61vR~
//  pan300addentry(pc,(int)strlen(pc),0);	//not init             //~v557R~
	if (FILEISREMOTE(Ppfh))                                        //~v557R~
    	opt=PAN300AEO_REMOTE;                                      //~v557I~
    else                                                           //~v557I~
    	opt=0;                                                     //~v557I~
//  pan300addentry(pc,(int)strlen(pc),opt);	//not init             //~v61cR~
    if (browsesw)                                                  //~v61rI~
        opt|=PAN300AEO_BROWSE;                                     //~v61rI~
    else                                                           //~v61rI~
        opt|=PAN300AEO_EDIT;                                       //~v61rI~
    pan300addentry(pc,len,opt);	//not init                         //~v61cI~
    return;
}//pan300stack
//**************************************************               //~v61cI~
//*pan300editfpath                                                 //~v61cI~
//*rep filename in cmd string by fpath                             //~v61cI~
//*ret  :output string len,0:parm is (not quatation embedded)filename only//~v61cR~
//**************************************************               //~v61cI~
int pan300editfpath(PUCLIENTWE Ppcw,UCHAR *Pfpath,int Plcmd,UCHAR *Poutcmdstr)//~v61cR~
{                                                                  //~v61cI~
    int ii,opdno,len;                                              //~v61cR~
    UCHAR *pc,*pcout;                                              //~v61cR~
//*******************                                              //~v61cI~
	if (Ppcw)           //fileregist                               //~v61cR~
        opdno=Ppcw->UCWopdno;                                      //~v61cR~
    else                //dirregist                                //~v61cR~
        opdno=0;                                                   //~v61cM~
    if (opdno<=1 && !Plcmd)	//no special cmd and no other option   //~v61cR~
    	return 0;                                                  //~v61cI~
    pcout=Poutcmdstr;                                              //~v61cI~
    len=(int)strlen(Pfpath);                                       //~v61cR~
    memcpy(pcout,Pfpath,(UINT)len);                                //~v61cI~
    pcout+=len;                                                    //~v61cI~
    *pcout++=0;		//filename terminater                          //~v61cI~
	if (opdno>1)	//Ppcw!=0(not dir)                             //~v61cR~
    {                                                              //~v61cI~
        pc=Ppcw->UCWopdpot;                                        //~v61cR~
        for (ii=0;ii<opdno;ii++,pc+=len+1)                         //~v61cR~
        {                                                          //~v61cR~
        	len=(int)strlen(pc);                                   //~v61vR~
            if (ii>0)                                              //~v61cR~
            {                                                      //~v61cI~
            	if (ii>1)                                          //~v61cI~
			        *pcout++=' ';                                  //~v61cR~
                memcpy(pcout,pc,(UINT)len);                        //~v61cR~
                pcout+=len;                                        //~v61cI~
            }                                                      //~v61cI~
        }                                                          //~v61cR~
    }                                                              //~v61cI~
    *pcout++=0;                                                    //~v61cI~
    *pcout++=(UCHAR)Plcmd;                                         //~v61cR~
    *pcout=0;                                                      //~v61cI~
    return (int)((ULONG)pcout-(ULONG)Poutcmdstr);		//edit required//~v61vR~
}//pan300editfpath                                                 //~v61cI~
//**************************************************
//*pan300addentry
//*stack filename,keep max entry count
//*parm1:string addr
//*parm2:string len
//*parm3:initialize at ini3(screen height is not yet initialized)
//*ret  :none
//**************************************************
void pan300addentry(UCHAR *Pfnm,int Pfnmlen,int Pinitsw)
{
	PUP300LIST psc;			//stack entry
#ifdef W32                                                         //~v557I~
    int remotesw;                                                  //~v61rR~
#endif                                                             //~v557I~
    int compsw;                                                    //~v61rI~
	int len,lcmd;                                                  //~v61rR~
   	int reslen,len2,flag=0;                                        //~v61kI~
    char *pc;                                                      //~v61cI~
//**************************************************
    if (!Pfnmlen)   //emptry enter
        return;
#ifdef W32                                                         //~v557I~
    remotesw=Pinitsw & PAN300AEO_REMOTE;                           //~v557I~
#endif                                                             //~v557I~
	for (psc=UGETQTOP(&Sfnstack);psc;psc=UGETQNEXT(psc))//chk same string
    {
//#ifdef W32                                                         //~v557 ~//~v61rR~
//        len=min(Pfnmlen,psc->U3Lfnmlen);                         //~v61rR~
//        if (remotesw)                                            //~v61rR~
////          compsw=memcmp(Pfnm,psc->U3Lfnm,(UINT)Pfnmlen);  //same text//~v61rR~
//            compsw=memcmp(Pfnm,psc->U3Lfnm,(UINT)len);  //same text//~v61rR~
//        else                                                     //~v61rR~
//        {                                                        //~v61rR~
////          compsw=memicmp(Pfnm,psc->U3Lfnm,(UINT)Pfnmlen); //same text//~v61rR~
//            len2=psc->U3Lnetfnmlen;                              //~v61rR~
//          if (len2 < len)                                        //~v61rR~
//          {                                                      //~v61rR~
//            compsw=memicmp(Pfnm,psc->U3Lfnm,(UINT)len2) //same text//~v61rR~
//                 ||memcmp(Pfnm+len2,psc->U3Lfnm+len2,(UINT)(len-len2)); //same text//~v61rR~
//          }                                                      //~v61rR~
//          else                                                   //~v61rR~
//            compsw=memicmp(Pfnm,psc->U3Lfnm,(UINT)len); //same text//~v61rR~
//        }                                                        //~v61rR~
//#endif                                                           //~v61rR~
//        if (Pfnmlen==psc->U3Lfnmlen                              //~v61rR~
//#ifdef UNX                                                       //~v61rR~
//        &&  !memcmp(Pfnm,psc->U3Lfnm,(UINT)Pfnmlen))    //same text//~v61rR~
//#else                                                            //~v61rR~
//  #ifdef W32                                                     //~v61rR~
//        &&  !compsw)    //same text                              //~v61rR~
//  #else                                                          //~v61rR~
//        &&  !memicmp(Pfnm,psc->U3Lfnm,(UINT)Pfnmlen))   //same text//~v61rR~
//  #endif                                                         //~v61rR~
//#endif                                                           //~v61rR~
        if (Pfnmlen!=psc->U3Lfnmlen)	//len not same             //~v61rI~
            continue;                                              //~v61rI~
        len=psc->U3Lnetfnmlen;                                     //~v61rI~
        len2=(int)ustrnlen(Pfnm,(UINT)Pfnmlen);                    //~v61vR~
        if (len!=len2)		//filename len not same                //~v61rI~
            continue;                                              //~v61rI~
#ifdef W32                                                         //~v557 ~//~v61rI~
        if (remotesw)                                              //~v61rI~
            compsw=memcmp(Pfnm,psc->U3Lfnm,(UINT)len);  //same text//~v61rI~
        else                                                       //~v61rI~
            compsw=memicmp(Pfnm,psc->U3Lfnm,(UINT)len); //same text//~v61rI~
#else                                                              //~v61rI~
        compsw=memcmp(Pfnm,psc->U3Lfnm,(UINT)len);  //same text    //~v61rI~
#endif                                                             //~v61rI~
        if (compsw)			//filename compare                     //~v61rI~
            continue;                                              //~v61rI~
        if (len==Pfnmlen)   //no parm                              //~v61rI~
			break;
        if (!memicmp(Pfnm+len,psc->U3Lfnm+len,(UINT)(Pfnmlen-len))) //same parm//~v61vR~
			break;                                                 //~v61rI~
    }
	if (psc)	//found
    {                                                              //~v61rI~
		UDEQ(UQUE_ENT,&Sfnstack,psc);	//deq to re-enq
        lcmd=psc->U3Lflag & U3LFCMDMASK;                           //~v61rI~
        if (lcmd)                                                  //~v61rI~
        {                                                          //~v61rI~
	        if (Pinitsw & PAN300AEO_BROWSE)                        //~v61rI~
            	lcmd=tolower(lcmd);                                //~v61rI~
	        if (Pinitsw & PAN300AEO_EDIT)                          //~v61rI~
            	lcmd=toupper(lcmd);                                //~v61rI~
	  		psc->U3Lflag=(psc->U3Lflag & ~U3LFCMDMASK)|lcmd;       //~v61rI~
       		*(psc->U3Lfnm+psc->U3Lfnmlen-1)=(char)lcmd;	//update for write at term//~v61rR~
        }                                                          //~v61rI~
    }                                                              //~v61rI~
	else		//not found
	{
    	psc=UALLOCM((UINT)(UP300LISTSZ+Pfnmlen));                  //~v61cR~
        if (psc)
        {
        	memset(psc,0,UP300LISTSZ);
       		memcpy(psc->U3Lfnm,Pfnm,(UINT)Pfnmlen);
        	*(psc->U3Lfnm+Pfnmlen)=0;//for setflddata strncpy
        	psc->U3Lfnmlen=Pfnmlen;
//      	psc->U3Lnetfnmlen=len=(int)ustrnlen(Pfnm,Pfnmlen);	//without other parm//~v61kR~
        	psc->U3Lnetfnmlen=Pfnmlen;                             //~v61kI~
        	len=(int)ustrnlen(Pfnm,(UINT)Pfnmlen);	//without other parm//~v61vR~
//          if (len<Pfnmlen) //parm or special cmd exist           //~v61kR~
            if (len+3<=Pfnmlen) //fnmstrz+parm+parmstrz+lcmd       //~v61kR~
            {                                                      //~v61cI~
            	pc=Pfnm+len+1;	//parm position                    //~v61cI~
                reslen=Pfnmlen-len-1;                              //~v61kI~
                if (*pc)                                           //~v61cI~
                {                                                  //~v61cI~
//  	        	psc->U3Lflag|=U3LFPARM;                        //~v61kR~
    	        	flag|=U3LFPARM;                                //~v61kI~
//              	pc+=strlen(pc);	//lcmd pos                     //~v61kR~
                }                                                  //~v61cI~
//              pc++;                                              //~v61kR~
//          	psc->U3Lflag|=*pc;                                 //~v61kR~
                len2=(int)ustrnlen(pc,(UINT)reslen);	//lcmd pos //~v61vR~
                if (len2+2==reslen)			//cmd contain          //~v61kR~
                {                                                  //~v61kI~
  		        	psc->U3Lflag=flag|*(pc+len2+1);                //~v61kI~
        			psc->U3Lnetfnmlen=len;                         //~v61kI~
                }                                                  //~v61kI~
            }                                                      //~v61cI~
            if (memchr(Pfnm,' ',(UINT)len))                        //~v61cR~
	        	psc->U3Lflag|=U3LFSPACEEMBEDED;                    //~v61cI~
        }
	}//not found
    if (psc)
		UENQ(UQUE_TOP,&Sfnstack,psc);	//enq to top
//*chk max entry
//  if (!Pinitsw)                                                  //~v557R~
    if (!(Pinitsw & PAN300AEO_INIT))                               //~v557I~
//#ifdef WXE                                                       //~v557R~
//        if (UGETQCTR(&Sfnstack)>Gscrbuffheight-PANL300LISTTOP)//overflow//~v557R~
//#else                                                            //~v557R~
//        if (UGETQCTR(&Sfnstack)>Gscrheight-PANL300LISTTOP)//overflow//~v557R~
//#endif                                                           //~v557R~
        if (UGETQCTR(&Sfnstack)>Gmaxfnmlist)//overflow             //~v557I~
        {
            psc=UDEQ(UQUE_END,&Sfnstack,0); //deq oldest
            ufree(psc);
        }
	Supdatelistsw=1;       //request ppc update
	return;
}//pan300addentry
//**************************************************               //~v61pI~
//*pan300delentry                                                  //~v61pI~
//*ret  :rc                                                        //~v61pI~
//**************************************************               //~v61pI~
int pan300delentry(PUCLIENTWE Ppcw,PUP300LIST Ppsc)                //~v61pI~
{                                                                  //~v61pI~
	int oldtop,offs;                                               //~v61pR~
//**************************************************               //~v61pI~
	if (!Ppsc)                                                     //~v61pI~
    	return 4;                                                  //~v61pI~
    oldtop=Ppcw->UCWtopfnlist;                                     //~v61pR~
    offs=Ppcw->UCWrcsry-PANL300LISTTOP;                            //~v61pM~
	UDEQ(UQUE_ENT,&Sfnstack,Ppsc);	//deq to re-enq                //~v61pM~
    ufree(Ppsc);                                                   //~v61pM~
    if (!offs)	//del top                                          //~v61pI~
        if (oldtop)                                                //~v61pI~
			return func_pgup_pan(Ppcw);                            //~v61pR~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);                               //~v61pI~
	Supdatelistsw=1;       //request ppc update                    //~v61pI~
	return 0;                                                      //~v61pI~
}//pan300delentry                                                  //~v61pI~
//**************************************************
//*pan300freestack
//*free stack input cmd for retrieve
//*parm:none
//*ret  :none
//**************************************************
void pan300freestack(void)
{
	PUP300LIST psc,pscw;			//stack cmd
//**************************************************
	for (psc=UGETQTOP(&Sfnstack);psc;)//all entry
    {
		pscw=UGETQNEXT(psc);	//get next addr before free
		ufree(psc);
		psc=pscw;
	}
	return;
}//pan300freestack
//**************************************************
//*pan300wstack
//*write filename stack on XE!SAVE!
//*parm:FILE*
//*ret  :rc
//**************************************************
int pan300wstack(FILE *Pfh)
{
	PUP300LIST psc;			//stack cmd
    int ii=0;
    long wkint;
//**************************************************
    ii=UGETQCTR(&Sfnstack);
	wkint=(long)ii;
  	if (!fwrite(&wkint,sizeof(wkint),1,Pfh))
    	return 8;	//written count
    for (psc=UGETQEND(&Sfnstack);psc;psc=UGETQPREV(psc))//chk same string
    {
	  	wkint=(long)psc->U3Lfnmlen;
	  	if (!fwrite(&wkint,sizeof(wkint),1,Pfh))
	    	return 8;	//written count
	  	if (!fwrite(psc->U3Lfnm,(UINT)psc->U3Lfnmlen,1,Pfh))
	    	return 8;	//written count
	}
	return 0;
}//pan300wstack
//**************************************************
//*pan300rstack
//*read  stack from XE!SAVE!
//*parm:FILE*
//*ret  :rc
//**************************************************
int pan300rstack(FILE *Pfh)
{
	char *pc;
    long wkint;
    int ii=0;
    int cmdlen;
//**************************************************
  	if (!fread(&wkint,sizeof(wkint),1,Pfh))
    	return 8;	//written count
	ii=(int)wkint;
    for (;ii;ii--)
    {
	  	if (!fread(&wkint,sizeof(wkint),1,Pfh))
            return 8;
		cmdlen=(int)wkint;
    	pc=UALLOCM((UINT)(cmdlen));
	    UALLOCCHK(pc,UALLOC_FAILED);
	  	if (!fread(pc,(UINT)cmdlen,1,Pfh))
        {
            ufree(pc);
            return 8;
        }
		pan300addentry(pc,cmdlen,1);	//initsw
        ufree(pc);
    }
	return 0;
}//pan300rstack
//**********************************************************************
//* enter on filename list
//* parm 1:pcw
//* ret   :rc
//**********************************************************************
int pan300execlist(PUCLIENTWE Ppcw)
{
//  UCHAR beid[4];		//browse/edit id                           //~v216R~
//  UCHAR beid[MAXCOLUMN],*fnm;		//browse/edit cmd edit work    //~v51PR~
//  UCHAR beid[_MAX_PATH+8],*fnm;		//browse/edit cmd edit work//~v61cR~
    UCHAR beid[_MAX_PATH+MAXCOLUMN],*fnm;		//browse/edit cmd edit work//~v61cI~
    int   len,datalen,yy,pos;                                      //~v216I~
	PUP300LIST psc;			//stack cmd                            //~v61cI~
//*****************
	if (Ppcw->UCWrcsry>=PANL300LISTTOP+UGETQCTR(&Sfnstack))	//enq counter//~v20yI~
    	return 0;                                                  //~v20yI~
    if ((pos=((UFLDE*)getuflde(Ppcw,CMDLINENO,0))->UFLstart)>=Ppcw->UCWwidth)//~v216I~
		return 4;	//no display width                             //~v216I~
    yy=Ppcw->UCWrcsry;                                             //~v216I~
    if (!(psc=pan300getpsc(yy+Ppcw->UCWtopfnlist)))                //~v61cI~
    	return 0;                                                  //~v61cI~
//  if (Ppcw->UCWmenuopt==PANMOBROWSE)                             //~v61uR~
//  	beid[0]='b';                                               //~v61uR~
//  else                                                           //~v61uR~
//  	beid[0]='e';                                               //~v61uR~
//  beid[1]=0;                                                     //~v216R~
//  subcmd=tolower(psc->U3Lflag & U3LFCMDMASK);                    //~v61uR~
//  if (subcmd)                                                    //~v61uR~
//  {                                                              //~v61uR~
//    beid[1]=(UCHAR)subcmd;                                       //~v61uR~
//    beid[2]=' ';                                                 //~v61uR~
//    fnm=beid+3;                                                  //~v61uR~
//    len=3;                                                       //~v61uR~
//  }                                                              //~v61uR~
//  else                                                           //~v61uR~
//  {                                                              //~v61uR~
//    beid[1]=' ';                                                 //~v61uR~
////  return pan300felcmd(Ppcw,beid,0);   //full event             //~v61uR~
//    fnm=beid+2;                                                  //~v61uR~
//    len=2;                                                       //~v61uR~
//  }                                                              //~v61uR~
	pan300getbecmd(Ppcw,psc,beid);                                 //~v61uR~
    len=(int)strlen(beid);                                         //~v61uR~
    fnm=beid+len;                                                  //~v61uI~
    *fnm++=' ';                                                    //~v61uI~
    len++;                                                         //~v61uI~
//  *fnm='"';                                                      //~v61cR~
//  getfldinput(Ppcw,yy,PANL300NAME,fnm+1);                        //~v51PR~
//  len=(int)strlen(fnm);                                          //~v51PI~
//  len=pan300getfnm(yy,fnm+1);                                    //~v55mR~
//  len=pan300getfnm(yy+Ppcw->UCWtopfnlist,fnm+1);                 //~v61cR~
//  if (!len)                                                      //~v61cR~
//  	return 0;                                                  //~v61cR~
//  len++;                                                         //~v61cR~
//  *(fnm+len++)='"';                                              //~v61cR~
//  *(fnm+len)=0;                                                  //~v61cR~
//  len+=2;		//'b '                                             //~v61cR~
	len+=pan300editcmd(Ppcw,psc,fnm);                              //~v61cI~
                                                                   //~v216I~
	funcsetlongcmd(Ppcw,0,beid,len,&datalen);	//no execute,le by strlen//~v216I~
                                                                   //~v216I~
    scrclearmsg(Ppcw);                                             //~v216I~
    Ppcw->UCWrcsry=CMDLINENO;                                      //~v216I~
    Ppcw->UCWrcsrx=pos+datalen;                                    //~v216I~
    csrrestore(Ppcw);   //set csr to end of cmd line               //~v216I~
	UCBITON((Ppcw->UCWpsd+CMDLINENO)->USDflag2,USDF2DRAW);         //~v216I~
  	UCBITOFF(Ppcw->UCWflag,UCWFCMDERR);//clear cmd err             //~v216I~
    return 0;                                                      //~v216I~
}//pan300execlist                                                  //~v61cR~
//**********************************************************************//~v557I~
//* paging                                                         //~v557I~
//**********************************************************************//~v557I~
int func_pgup_pan(PUCLIENTWE Ppcw)                                 //~v557I~
{                                                                  //~v557I~
    int pgsz,oldtop,newtop;                                        //~v557I~
//*****************                                                //~v557I~
	if (((PUPANELC)Ppcw->UCWppc)->UPCid!=PANFNAME)                 //~v557I~
		return  errscrtype("PageScroll");                          //~v557I~
    pgsz=Ppcw->UCWheight-PANL300LISTTOP;                           //~v557I~
    oldtop=Ppcw->UCWtopfnlist;                                     //~v557I~
    if (!oldtop)                                                   //~v557I~
    	return 0;                                                  //~v557R~
    newtop=oldtop-pgsz;                                            //~v557I~
    if (newtop<0)	//enq counter                                  //~v557I~
    	newtop=0;                                                  //~v557I~
    Ppcw->UCWtopfnlist=newtop;                                     //~v557I~
    Ppcw->UCWoldheight=-1;  //filename list redraw req             //~v557I~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);                               //~v557I~
    return 0;                                                      //~v557I~
}//func_pgup_pan                                                   //~v557I~
//**********************************************************************//~v557I~
//* paging                                                         //~v557I~
//**********************************************************************//~v557I~
int func_pgdown_pan(PUCLIENTWE Ppcw)                               //~v557I~
{                                                                  //~v557I~
    int pgsz,oldtop,newtop;                                        //~v557I~
//*****************                                                //~v557I~
	if (((PUPANELC)Ppcw->UCWppc)->UPCid!=PANFNAME)                 //~v557I~
	    errscrtype("PageScroll");                                  //~v557I~
    pgsz=Ppcw->UCWheight-PANL300LISTTOP;                           //~v557I~
    oldtop=Ppcw->UCWtopfnlist;                                     //~v557I~
    newtop=oldtop+pgsz;                                            //~v557I~
//  if (newtop>UGETQCTR(&Sfnstack))	//enq counter                  //~v56fR~
    if (newtop>=UGETQCTR(&Sfnstack))	//enq counter              //~v56fI~
    	return 0;                                                  //~v557R~
    Ppcw->UCWtopfnlist=newtop;                                     //~v557I~
    Ppcw->UCWoldheight=-1;  //filename list redraw req             //~v557I~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);                               //~v557I~
    return 0;                                                      //~v557I~
}//func_pgdown_pan                                                 //~v557I~
//**********************************************************************//~v61dI~
//* paging to toppage                                              //~v61dI~
//**********************************************************************//~v61dI~
int func_pgtop_pan(PUCLIENTWE Ppcw)                                //~v61dI~
{                                                                  //~v61dI~
    int oldtop,newtop;                                             //~v61dI~
//*****************                                                //~v61dI~
	if (((PUPANELC)Ppcw->UCWppc)->UPCid!=PANFNAME)                 //~v61dI~
		return  errscrtype("PageScroll");                          //~v61dI~
    oldtop=Ppcw->UCWtopfnlist;                                     //~v61dI~
    if (!oldtop)                                                   //~v61dI~
    	return 0;                                                  //~v61dI~
    newtop=0;                                                      //~v61dI~
    Ppcw->UCWtopfnlist=newtop;                                     //~v61dI~
    Ppcw->UCWoldheight=-1;  //filename list redraw req             //~v61dI~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);                               //~v61dI~
    return 0;                                                      //~v61dI~
}//func_pgtop_pan                                                  //~v61dI~
//**********************************************************************//~v61dI~
//* paging  to endpage                                             //~v61dI~
//**********************************************************************//~v61dI~
int func_pgend_pan(PUCLIENTWE Ppcw)                                //~v61dI~
{                                                                  //~v61dI~
    int pgsz,oldtop,newtop;                                        //~v61dR~
//*****************                                                //~v61dI~
	if (((PUPANELC)Ppcw->UCWppc)->UPCid!=PANFNAME)                 //~v61dI~
	    errscrtype("PageScroll");                                  //~v61dI~
    pgsz=Ppcw->UCWheight-PANL300LISTTOP;                           //~v61dI~
    oldtop=Ppcw->UCWtopfnlist;                                     //~v61dI~
    newtop=UGETQCTR(&Sfnstack)-pgsz;                               //~v61dI~
    if (newtop<=oldtop)	//enq counter                              //~v61dI~
    	return 0;                                                  //~v61dI~
    Ppcw->UCWtopfnlist=newtop;                                     //~v61dI~
    Ppcw->UCWoldheight=-1;  //filename list redraw req             //~v61dI~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);                               //~v61dI~
    return 0;                                                      //~v61dI~
}//func_pgend_pan                                                  //~v61dI~
//**********************************************************************//~v61cI~
//* get psc for the cursor line                                    //~v61cI~
//* parm 1:rows+page top entry no                                  //~v61cI~
//* parm 2:out data                                                //~v61cI~
//* ret   :filename len                                            //~v61cI~
//**********************************************************************//~v61cI~
PUP300LIST pan300getpsc(int Pyy)                                   //~v61cR~
{                                                                  //~v61cI~
    int ii;                                                        //~v61cR~
	PUP300LIST psc;			//stack entry                          //~v61cI~
//*****************                                                //~v61cI~
	psc=UGETQTOP(&Sfnstack);//chk same string                      //~v61cI~
    for (ii=Pyy-PANL300LISTTOP;ii>0 && psc;ii--)                   //~v61cI~
		psc=UGETQNEXT(psc);//chk same string                       //~v61cI~
    return psc;                                                    //~v61cI~
}//pan300getpsc                                                    //~v61cI~
//**********************************************************************//~v51PI~
//* get fineleme on th curser                                      //~v51PI~
//* parm 1:rows+page top entry no                                  //~v55mR~
//* parm 2:out data                                                //~v51PI~
//* ret   :filename len                                            //~v51PI~
//**********************************************************************//~v51PI~
int pan300getfnm(int Pyy,UCHAR *Pout)                              //~v51PI~
{                                                                  //~v51PI~
    int ii,len;                                                    //~v51PI~
	PUP300LIST psc;			//stack entry                          //~v51PM~
//*****************                                                //~v51PI~
	psc=UGETQTOP(&Sfnstack);//chk same string                      //~v51PI~
    for (ii=Pyy-PANL300LISTTOP;ii>0 && psc;ii--)                   //~v51PI~
		psc=UGETQNEXT(psc);//chk same string                       //~v51PI~
    if (!psc)                                                      //~v51PI~
    	return 0;                                                  //~v51PI~
//  len=psc->U3Lfnmlen;                                            //~v61cR~
//  memcpy(Pout,psc->U3Lfnm,(UINT)len);                            //~v61cR~
//  *(Pout+len)=0;  //null term                                    //~v61cR~
    strcpy(Pout,psc->U3Lfnm);                                      //~v61cI~
    len=psc->U3Lnetfnmlen;                                         //~v61cI~
    return len;                                                    //~v51PI~
}//pan300getfnm                                                    //~v51PI~
//**********************************************************************
//* line cmd field event(full/clear)
//* parm 1:pcw
//* parm 2:data
//* parm 3:event id(0:full/1:clear)
//* ret   :rc
//**********************************************************************
int pan300felcmd(PUCLIENTWE Ppcw,UCHAR *Pdata,int Peventid)
{
//  UCHAR fnm[_MAX_PATH+4];                                        //~v61cR~
    UCHAR fnm[_MAX_PATH+MAXCOLUMN];                                //~v61cI~
	PUSCRD psd;                                                    //~v61fI~
	int yy,len,rc;                                                 //~v44nR~
	PUP300LIST psc;			//stack cmd                            //~v61cI~
    int cmdid,subcmdid,subcmdid0,netfnmlen;                        //~v61cR~
    char lcmdid[2];                                                //~v61fR~
    char becmd[4];                                                 //~v61vR~
//*****************
    yy=Ppcw->UCWrcsry;
    if (!(psc=pan300getpsc(yy+Ppcw->UCWtopfnlist)))                //~v61fM~
    	return 0;                                                  //~v61fM~
	if (Peventid)	//field clear event
    {
//  	panflderr(Ppcw,yy,PANL300LCMD,PANFERESET);	//set err reverse on cur csr//~v61fR~
    	setflddata(Ppcw,yy,PANL300LCMD,LCMDID);//clear input       //~v61fR~
//      return 0;                                                  //~v61fR~
        if (Ppcw->UCWkeytype==UCWKTSBCS && Ppcw->UCWkeydata[0]==' ')//space cmd//~v61fR~
        {                                                          //~v61fI~
            Sspacelcmd=1;                                          //~v61fR~
            rc=pan300execlist(Ppcw);                               //~v61fR~
            Sspacelcmd=0;                                          //~v61fR~
			psd=Ppcw->UCWpsd+yy;                                   //~v61fI~
			lcmdid[0]=(char)pan300getbecmd(Ppcw,psc,0);            //~v61vR~
            lcmdid[1]=0;                                           //~v61fI~
		    setflddata(Ppcw,yy,PANL300LCMD,lcmdid);//clear input   //~v61fI~
			UCBITON(psd->USDflag2,USDF2DRAW);	//redraw           //~v61fI~
        }                                                          //~v61fI~
        else                                                       //~v61fI~
        	rc=0;                                                  //~v61fI~
        return rc;                                                 //~v61fI~
	}
    csronthefld(Ppcw,yy,PANL300LCMD,0);   //for when next wakeup
//  *fnm='"';                                                      //~v61cR~
//  getfldinput(Ppcw,yy,PANL300NAME,fnm+1);                        //~v51PR~
//  len=(int)strlen(fnm);                                          //~v51PR~
//  len=pan300getfnm(yy+Ppcw->UCWtopfnlist,fnm+1);                 //~v61cR~
//  if (!len)                                                      //~v61cR~
//  	return 0;                                                  //~v61cR~
//  len++;                                                         //~v61cR~
//  *(fnm+len++)='"';                                              //~v61cR~
//  *(fnm+len)=0;                                                  //~v61cR~
    subcmdid0=subcmdid=psc->U3Lflag & U3LFCMDMASK;                 //~v61cR~
    if (!subcmdid)                                                 //~v61cI~
    	subcmdid=' ';                                              //~v61cI~
//  Ppcw->UCWparm=fnm;                                             //~v61cR~
    rc=0;                                                          //~v61cR~
    switch(toupper(*Pdata))
    {
    case 'B':
//  	rc=func_browse_file2(Ppcw,0);	//filename only            //~v61cR~
        cmdid='b';                                                 //~v61cI~
    	break;
    case 'E':
//  	rc=func_edit_file2(Ppcw,0);	//parm is file name only       //~v61cR~
        cmdid='e';                                                 //~v61cI~
    	break;
    case U3LFCMDBINLCMD://'0'                                      //~v61cI~
//  	strcpy(fnm+len," /Mb");	//binary option                    //~v61cR~
//  	rc=panbecmdcall(Ppcw,*Pdata);                              //~v61cR~
		subcmdid='b';		//binary                               //~v61cI~
    	if (Ppcw->UCWmenuopt==PANMOBROWSE)                         //~v61cI~
    	    cmdid='b';                                             //~v61cI~
        else                                                       //~v61cI~
    	    cmdid='e';                                             //~v61cI~
    	break;                                                     //~v61cI~
    case '1':
//  	strcpy(fnm+len," /Mb");	//binary option                    //~v61cR~
//  	rc=func_browse_file2(Ppcw,1);	//filename only            //~v61cR~
		subcmdid='b';		//binary                               //~v61cI~
        cmdid='b';			//browse                               //~v61cI~
    	break;
    case '2':
//  	strcpy(fnm+len," /Mb");	//binary option                    //~v61cR~
//  	rc=func_edit_file2(Ppcw,1);	//filename with option /Mb     //~v61cR~
		subcmdid='b';		//binary                               //~v61cI~
        cmdid='e';			//edit                                 //~v61cI~
    	break;
    case 'C':                                                      //~v44pI~
    case 'L':                                                      //~v44pI~
//  	strcpy(fnm+len," /Mc");	//cobol with seqno                 //~v61cR~
//  	rc=panbecmdcall(Ppcw,*Pdata);                              //~v61cR~
		subcmdid='c';		//cobol                                //~v61cI~
        cmdid=panbrowsecmdchk(Ppcw,*Pdata)?'b':'e';                //~v61cI~
    	break;                                                     //~v44pI~
    case 'H':                                                      //~v44nI~
//  	strcpy(fnm+len," /Mh");	//hex display option               //~v61cR~
//  	rc=panbecmdcall(Ppcw,*Pdata);                              //~v61cR~
		subcmdid='h';		//cobol                                //~v61cI~
        cmdid=panbrowsecmdchk(Ppcw,*Pdata)?'b':'e';                //~v61cI~
    	break;                                                     //~v44nI~
    case 'I':                                                      //~v44pI~
//  	strcpy(fnm+len," /Mcn");	//spf cobol with seqno         //~v61cR~
//  	rc=panbecmdcall(Ppcw,*Pdata);                              //~v61cR~
		subcmdid='i';		//cobolnum                             //~v61cI~
        cmdid=panbrowsecmdchk(Ppcw,*Pdata)?'b':'e';                //~v61cI~
    	break;                                                     //~v44pI~
    case 'J':                                                      //~v44pI~
//  	strcpy(fnm+len," /Mkn");	//spf cobol with space         //~v61cR~
//  	rc=panbecmdcall(Ppcw,*Pdata);                              //~v61cR~
		subcmdid='j';		//cobol2 num                           //~v61cI~
        cmdid=panbrowsecmdchk(Ppcw,*Pdata)?'b':'e';                //~v61cI~
    	break;                                                     //~v44pI~
    case 'K':                                                      //~v44pI~
//  	strcpy(fnm+len," /Mk");	    //cobol with space             //~v61cR~
//  	rc=panbecmdcall(Ppcw,*Pdata);                              //~v61cR~
		subcmdid='k';		//cobolw                               //~v61cI~
        cmdid=panbrowsecmdchk(Ppcw,*Pdata)?'b':'e';                //~v61cI~
    	break;                                                     //~v44pI~
    case 'N':                                                      //~v44pI~
//  	strcpy(fnm+len," /Mn");	    //spf                          //~v61cR~
//  	rc=panbecmdcall(Ppcw,*Pdata);                              //~v61cR~
		subcmdid='n';		//cobolw                               //~v61cI~
        cmdid=panbrowsecmdchk(Ppcw,*Pdata)?'b':'e';                //~v61cI~
    	break;                                                     //~v44pI~
    case 'S':                                                      //~v216I~
//        if (Ppcw->UCWmenuopt==PANMOBROWSE)                       //~v61vR~
////          rc=func_browse_file2(Ppcw,0);   //filename only      //~v61vR~
//            cmdid='b';      //browse                             //~v61vR~
//        else                                                     //~v61vR~
////          rc=func_edit_file2(Ppcw,0); //parm is file name only //~v61vR~
//            cmdid='e';      //edit                               //~v61vR~
		pan300getbecmd(Ppcw,psc,becmd);                            //~v61vR~
		cmdid=*becmd;                                              //~v61vR~
		subcmdid=*(becmd+1);                                       //~v61vR~
        if (!subcmdid)                                             //+v71dI~
            subcmdid=' ';                                          //+v71dI~
    	break;                                                     //~v61vR~
    case 'T':                                                      //~v50GI~
//  	strcpy(fnm+len," /Mt");	//binary option                    //~v61cR~
		subcmdid='t';		//text                                 //~v61cI~
    	if (Ppcw->UCWmenuopt==PANMOBROWSE)                         //~v50GI~
//  		rc=func_browse_file2(Ppcw,1);	//1:opd exist          //~v61cR~
        	cmdid='b';		//browse                               //~v61cI~
        else                                                       //~v50GI~
//  		rc=func_edit_file2(Ppcw,1);	//1:opd exist              //~v61cR~
        	cmdid='e';		//edit                                 //~v61cI~
    	break;                                                     //~v50GI~
//#ifdef W32                                                       //~v64vR~
#if defined(W32) || defined(LNX)                                   //~v64vI~
    case '!':                                                      //~v55VI~
//  	*(fnm+len-1)=0;		//drop quote                           //~v61cR~
//  	rc=dlcmdopenwithsub(Ppcw,fnm+1);	//binary option        //~v61cR~
    	rc=dlcmdopenwithsub(Ppcw,psc->U3Lfnm);//filename only      //~v61cI~
    	break;                                                     //~v55VI~
#endif                                                             //~v55VI~
    case LCMDIDDELCH:     //delete entry                           //~v61pR~
    	return pan300delentry(Ppcw,psc);//psc is freed             //~v61pR~
    default:
        panflderr(Ppcw,yy,PANL300LCMD,PANFESET);    //set err reverse on cur csr
        return pan300lcmderr(Scmdtbl);
    }
    if (*Pdata!='!')	//edit/browse cmd                          //~v61cI~
    {                                                              //~v61cI~
    	fnm[0]=(UCHAR)cmdid;                                              //~v61cI~
    	fnm[1]=(UCHAR)subcmdid;                                           //~v61cI~
    	fnm[2]=' ';                                                //~v61cI~
		len=pan300editcmd(Ppcw,psc,fnm+3);	//set filename and other parm//~v61cI~
		if (subcmdid && subcmdid!=subcmdid0)	//subcmd changed   //~v61cR~
        {                                                          //~v61cI~
        	netfnmlen=psc->U3Lnetfnmlen;                           //~v61cR~
		    if (psc->U3Lflag & U3LFSPACEEMBEDED)                   //~v61cI~
        		netfnmlen+=2;                   //with quatation   //~v61cI~
            *(fnm+netfnmlen+3)=0;		//drop other parm          //~v61cR~
            len=netfnmlen;                                         //~v61cI~
        }                                                          //~v61cI~
		funcsetlongcmd(Ppcw,1,fnm,len+3,0);	//1:execute,0:no output cmdlen//~v61cI~
    }                                                              //~v61cI~
    setflddata(Ppcw,yy,PANL300LCMD,LCMDID);//clear input           //~v20yR~
//  Ppcw->UCWparm=0;        //worked                               //~v61cR~
    if (!rc)                                                       //~v61cR~
    	pan300csrreset(Ppcw);                                      //~v61cR~
    return rc;					//ignore,next tab
}//pan300felcmd
//**********************************************************************//~v61cI~
//* get lcmd verb from becmdopt saved in stack cmd string          //~v61cI~
//* ret   :lcmd verb                                               //~v61cI~
//**********************************************************************//~v61cI~
//int pan300getlcmdfromfuncid(int Pfuncid,int Pbrowsesw)           //~v61rR~
int pan300getlcmdfromfuncid(int Pfuncid,int *Ppbrowsesw)           //~v61rI~
{                                                                  //~v61cI~
    char lcmd=0;                                                   //~v61cI~
    int browsesw;                                                  //~v61rI~
//*****************                                                //~v61cI~
	browsesw=*Ppbrowsesw;                                          //~v61rI~
    switch(Pfuncid)                                                //~v61cI~
    {                                                              //~v61cI~
    case FUNCID_BROWSETEXT:                                        //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='t';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITTEXT:                                          //~v61rM~
    	browsesw=0;                                                //~v61rI~
        lcmd='T';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTTEXT:                                        //~v61cI~
       if (browsesw)                                               //~v61rR~
        lcmd='t';                                                  //~v61cR~
       else                                                        //~v61rI~
        lcmd='T';                                                  //~v61rI~
        break;                                                     //~v61cI~
    case FUNCID_BROWSEBIN:                                         //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='b';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITBIN:                                           //~v61rM~
    	browsesw=0;                                                //~v61rI~
        lcmd='B';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTBIN:                                         //~v61cI~
       if (browsesw)                                               //~v61rR~
        lcmd='b';                                                  //~v61rR~
       else                                                        //~v61rI~
        lcmd='B';                                                  //~v61rI~
        break;                                                     //~v61cI~
    case FUNCID_BROWSEHEX:                                         //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='h';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITHEX:                                           //~v61cI~
    	browsesw=0;                                                //~v61rI~
        lcmd='H';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTHEX:                                         //~v61cI~
        if (browsesw)                                              //~v61rR~
            lcmd='h';                                              //~v61cR~
        else                                                       //~v61rI~
            lcmd='H';                                              //~v61rI~
        break;                                                     //~v61cI~
    case FUNCID_BROWSESPF:                                         //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='n';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITSPF:                                           //~v61rM~
    	browsesw=0;                                                //~v61rI~
        lcmd='N';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTSPF:                                         //~v61cI~
        if (browsesw)                                              //~v61rR~
            lcmd='n';                                              //~v61cR~
        else                                                       //~v61rI~
            lcmd='N';                                              //~v61rI~
        break;                                                     //~v61cI~
    case FUNCID_BROWSESPFCOB:                                      //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='c';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITSPFCOB:                                        //~v61rM~
    	browsesw=0;                                                //~v61rI~
        lcmd='C';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTSPFCOB:                                      //~v61cI~
        if (browsesw)                                              //~v61rR~
            lcmd='c';                                              //~v61cR~
        else                                                       //~v61rI~
            lcmd='C';                                              //~v61rI~
        break;                                                     //~v61cI~
    case FUNCID_BROWSESPFCOBNUM:                                   //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='i';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITSPFCOBNUM:                                     //~v61rM~
    	browsesw=0;                                                //~v61rI~
        lcmd='I';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTSPFCOBNUM:                                   //~v61cI~
        if (browsesw)                                              //~v61rR~
            lcmd='i';                                              //~v61cI~
        else                                                       //~v61rI~
            lcmd='I';                                              //~v61rI~
        break;                                                     //~v61cI~
    case FUNCID_BROWSESPFCOB2:                                     //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='k';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITSPFCOB2:                                       //~v61rM~
    	browsesw=0;                                                //~v61rI~
        lcmd='K';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTSPFCOB2:                                     //~v61cI~
        if (browsesw)                                              //~v61rR~
            lcmd='k';                                              //~v61cR~
        else                                                       //~v61rI~
            lcmd='K';                                              //~v61rI~
        break;                                                     //~v61cI~
    case FUNCID_BROWSESPFCOB2NUM:                                  //~v61cI~
    	browsesw=1;                                                //~v61rI~
        lcmd='j';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_EDITSPFCOB2NUM:                                    //~v61rM~
    	browsesw=0;                                                //~v61rI~
        lcmd='J';                                                  //~v61rI~
        break;                                                     //~v61rI~
    case FUNCID_SELECTSPFCOB2NUM:                                  //~v61cI~
        if (browsesw)                                              //~v61rR~
            lcmd='j';                                              //~v61cR~
        else                                                       //~v61rI~
            lcmd='J';                                              //~v61rI~
        break;                                                     //~v61cI~
    }                                                              //~v61cI~
    *Ppbrowsesw=browsesw;                                          //~v61rR~
    return lcmd;                                                   //~v61cI~
}//pan300getlcmdfromfuncid                                         //~v61cI~
//**************************************************************** //~v56dI~
// pan300csrreset                                                  //~v56dI~
//*set curso to topline of 1st page                                //~v56dI~
//*parm 1:pcw                                                      //~v56dI~
//*rc    :1:browse,0:edit                                          //~v56dI~
//**************************************************************** //~v56dI~
int pan300csrreset(PUCLIENTWE Ppcw)                                //~v56dI~
{                                                                  //~v56dI~
//************************                                         //~v56dI~
    Ppcw->UCWtopfnlist=0;   //top page                             //~v56dI~
    csronthefld(Ppcw,PANL300LISTTOP,PANL300LCMD,0);                //~v56dI~
    return 0;                                                      //~v56dI~
}//pan300csrreset                                                  //~v56dI~
//**************************************************************** //~v44nI~
// panbecmdcall                                                    //~v44nI~
//*call browse/editcmd by lower/upper case                         //~v44nI~
//*parm 1:pcw                                                      //~v44nI~
//*parm 2:cmd code                                                 //~v44nI~
//*rc    :1:browse,0:edit                                          //~v44nI~
//**************************************************************** //~v44nI~
int panbecmdcall(PUCLIENTWE Ppcw,UCHAR Pcmdid)                     //~v44nI~
{                                                                  //~v44nI~
	int browsesw,rc;                                               //~v44nI~
//************************                                         //~v44nI~
    browsesw=panbrowsecmdchk(Ppcw,Pcmdid);                         //~v44nR~
    if (browsesw)                                                  //~v44nI~
        rc=func_browse_file2(Ppcw,1);   //with option              //~v44nI~
    else                                                           //~v44nI~
        rc=func_edit_file2(Ppcw,1); //with option parm             //~v44nI~
    return rc;                                                     //~v44nI~
}//panbecmdcall                                                    //~v44nI~
//**************************************************************** //~v44nI~
// panbrowsecmdchk                                                 //~v44nI~
//*determin browse or edit by menu opt and cmd upper/lower case    //~v44nI~
//*parm 1:pcw                                                      //~v44nI~
//*parm 2:cmd code                                                 //~v44nI~
//*rc    :1:browse,0:edit                                          //~v44nI~
//**************************************************************** //~v44nI~
int panbrowsecmdchk(PUCLIENTWE Ppcw,UCHAR Pcmdid)                  //~v44nI~
{                                                                  //~v44nI~
	int browsesw;                                                  //~v44nI~
//**********************                                           //~v44nI~
	if (toupper(Pcmdid)==(int)Pcmdid)	//upper :opposit           //~v44nR~
        if (Ppcw->UCWmenuopt==PANMOBROWSE)                         //~v44nI~
            browsesw=0;                                            //~v44nI~
        else                                                       //~v44nI~
            browsesw=1;                                            //~v44nI~
    else    //lower   :allow menu opt                              //~v44nI~
        if (Ppcw->UCWmenuopt==PANMOBROWSE)                         //~v44nR~
            browsesw=1;                                            //~v44nI~
        else                                                       //~v44nI~
            browsesw=0;                                            //~v44nI~
    return browsesw;                                               //~v44nI~
}//panbrowsecmdchk                                                 //~v44nI~
//**************************************************************** //~v53cI~
//* draw filename list                                             //~v53cI~
//**************************************************************** //~v53cI~
int pan300getword(PUCLIENTWE Ppcw,char *Pword,int Plen)            //~v53cI~
{                                                                  //~v53cI~
	int yy,len;                                                    //~v53cR~
    UCHAR fnmwk[_MAX_PATH];                                        //~v53cI~
//************************************                             //~v53cI~
	yy=Ppcw->UCWrcsry;		//  cursor line                        //~v53cI~
//othe line                                                        //~v53cI~
    switch(yy)                                                     //~v53cI~
    {                                                              //~v53cI~
    case PANL300FILENAME:  //filename  lineno                      //~v53cI~
    case PANL300DIR:        //directory lineno                     //~v53cI~
    case PANL300CURRENT:  //current dir lineno                     //~v53cI~
#ifndef UNX                                                        //~v53cI~
	case PANL300DRIVE:		//driveid   lineno                     //~v53cI~
#endif                                                             //~v53cI~
		len=getfldinput(Ppcw,yy,0,fnmwk);//directory name          //~v53cI~
    	break;                                                     //~v53cI~
    default:                                                       //~v53cI~
	    if (yy>=PANL300LISTTOP)                                    //~v53cI~
            len=pan300getfnm(yy+Ppcw->UCWtopfnlist,fnmwk);         //~v55mR~
        else                                                       //~v53cI~
        {                                                          //~v53cI~
	        errcsrpos();                                           //~v53cR~
            return 0;                                              //~v53cI~
        }                                                          //~v53cI~
    }//switch                                                      //~v53cI~
    if (len)                                                       //~v53cI~
        if (len>Plen)                                              //~v53cI~
        {                                                          //~v53cI~
            errtoolong();                                          //~v53cI~
            len=0;                                                 //~v53cI~
        }                                                          //~v53cI~
        else                                                       //~v53cI~
            memcpy(Pword,fnmwk,(UINT)len);                         //~v53cI~
    else                                                           //~v53cI~
    	uerrmsg("Line has no data",0);                             //~v53cR~
    return len;                                                    //~v53cI~
}//pan300getword                                                   //~v53cI~
//****************************************************************
// dlcverberr
//*err msg for verb err
//*parm  :none
//*rc    :4
//****************************************************************
int pan300lcmderr(UCHAR *Pcmdtbl)
{
//*********************
	uerrmsg("Invalid,Use one of \"%s\"",
			"R}h(\"%s\")",
            Pcmdtbl);
	return 4;
}//pan300lcmderr
