//*CID://+v636R~:                             update#=   18;       //+v636R~
//*********************************************************************
//*xesub.h
//* common routine hdr
//*********************************************************************
//v636:050428 new workdir filename naming ::#((pid).xxx) for grep work filename//+v636I~
//v49b:020623 support *= for not only "(i)x all" but also "(i)find","change"//~v49bI~
//v48c:020429 (UNX)edit/browse mdos disk support                   //~v45cI~
//v45x:011219 integrate "num cutoff" cmd to "split" cmd            //~v45xI~
//v44a:011202 (BUG)hex input replace another tab char to space     //~v44aI~
//v40w:010618 display unprintable for dbcs split by line width parm//~v40wI~
//v40u:010617 wild-card support for path name if dir contain only one member.//~v40uI~
//            (replace v143)                                       //~v40uI~
//v21n:010114 LINUX support:wordrep may dsetroy dbcs conbination   //~v21nI~
//v09Y:970629:file NULL(0x00) support                              //~v09YI~
//            set dbcstbl(new function for file area only)   sub   //~v09YI~
//v05O:960120:copy/move cmd *\(same as source)/ **\(parent of source) support//~v05OR~
//*v039:950728:bug,setflddata need set dbcstbl also             //~v039I~
//*v020:950616:dir support(fldprotchk return pfld)              //~v020I~
//*********************************************************************//~v020I~
#ifdef XESUB_GBL                                                   //~v40uI~
    int Gsubgblopt;                                                //~v40uI~
#else                                                              //~v40uI~
    extern int Gsubgblopt;                                         //~v40uI~
#endif                                                             //~v40uI~
#define XESUB_GBLOPT_WILDPATH    0x01	//expand wild card path if it has only a member//~v40uI~
#define XESUB_GBLOPT_WILDMEMB    0x02	//expand wild card last filename if it has only a member//~v40uI~
#define XESUB_PIDFILEID  '#'     //::# is translated to ::pid.     //+v636I~
//*********************************************************************//~v020I~
//* FUNCTION *******************************
//*******************************************************       //~v020I~
int filefind(UCHAR *Ppfile,UCHAR *Pfullpath,FILEFINDBUF3 *Ppfstat3,//~5513R~
			 int Pmsgopt);                                      //~5513I~
#define FFMSG   	0                                           //~5625R~
#define FFNONFMSG   1                                           //~5625R~
#define FFNODIRMSG  2                                           //~5625R~
//*******************************************************       //~5625I~
int filedirchk(UCHAR *Pfilename);                               //~5625I~
//*******************************************************
FILE *fileopen(UCHAR *Ppfile,UCHAR *Ppopt);

#ifdef UNX                                                         //~v48cI~
//*******************************************************          //~v48cR~
FILE *fileopen_mdostemp(UCHAR *Ppfile,UCHAR *Ppopt,int Pnewsw,UCHAR *Pmdostempfnm);//~v48cR~
#endif                                                             //~v48cI~
                                                                   //~v48cR~
//*******************************************************
int fileclose(UCHAR *Pfile,FILE* Pfh);                          //~v039I~

#ifdef UNX                                                         //~v48cI~
//*******************************************************          //~v48cI~
int fileclose_mdos(UCHAR *Pmdosfile,UCHAR *Ptempfile);             //~v48cI~
#endif                                                             //~v48cI~
                                                                   //~v48cI~
//*******************************************************       //~5318M~
char *filefullpath(char *Pfullpath,char *Pfilename,size_t Plen);//~5318M~
//*******************************************************       //~v05OI~
char *filefullpath2(char *Pfullpath,char *Ptarget,size_t Plen,char *Psource);//~v05OR~
#define SAMEDIR  	'*'                                         //~v05OM~
//*******************************************************
//*dbcs tbl output
//*******************************************************
void setdbcstbl(UCHAR *Ppdata,UCHAR *Ppdbcs,int Plen);
//*******************************************************          //~v09YI~
//*dbcs tbl output for file client area only                       //~v09YI~
//*******************************************************          //~v09YI~
int filesetdbcstbl(UCHAR *Ppdata,UCHAR *Ppdbcs,int Plen,int Popt); //~v44aR~
#define FSDT_TABSAVE       1	//preserve previous tab id         //~v44aI~
//*******************************************************       //~5224I~
int getcmdstr(UCHAR *Pcin,UCHAR *Pcout);                        //~5224I~
//*******************************************************
//*get next commnad parse
//*******************************************************
void getnextcmd(UCHAR *Pcin,UCHAR *Pcout);
//*******************************************************       //~v039I~
int getfldpos(PUCLIENTWE Ppcw,int Prow,int Pfldno,UCHAR **Pout,UCHAR **Pdbcs);//~v039I~
//*******************************************************
int getfldinput(PUCLIENTWE Ppcw,int Prow,int Pfldno,UCHAR *Pout);
//*******************************************************
int setflddata(PUCLIENTWE Ppcw,int Prow,int Pfldno,UCHAR *Pdata);
//**************************************************            //~4C23I~
int fldprotchk(PUCLIENTWE Ppcw,int Popt,PVOID Pppfld);          //~v020I~
#define FPC_DBCSCHK	   	0                                       //~5423I~
#define FPC_NODBCSCHK   1                                       //~5423I~
//*******************************************************       //~v020M~
PVOID getuflde(PUCLIENTWE Ppcw,int Prow,int Pfldno);            //~v020R~
//**************************************************            //~5103I~
int setdbcssplit(UCHAR *Pdata,UCHAR *Pdbcs,int Plen,UCHAR Prepchar);//~5103I~
//**************************************************               //~v40wI~
int setdbcssplit2(UCHAR *Pdata,UCHAR *Pdbcs,int Plen,UCHAR Prepchar);//~v40wI~
//**************************************************            //~5503I~
void setobtabdbcs(UCHAR *Pdata,UCHAR *Pdbcs,int Pdatalen,int Ppos,//~5503I~
					int Prangelen);                             //~5503I~
//**************************************************            //~5225I~
int wordtblisrch(UCHAR *Pword,UCHAR *Pwordtbl);                 //~5225I~
//**************************************************            //~v039I~
int getpathlen(UCHAR *Pfilename,UCHAR *Plevel,int Pdirsw);      //~v039I~
//**************************************************               //~v09YI~
int subgetfilelc(int Popt,UCHAR *Ppfnm,ULONG *Pplinecnt);          //~v09YR~
#define GETLC_FPATHINP   0x01		//parm fname is already fullpath//~v09YI~
//**************************************************               //~v21nI~
//void setobdbcserr(UCHAR *Pdbcs,int Plen,int Ppos1,int Ppos2);    //~v49bR~
void setobdbcserr(UCHAR *Pdata,UCHAR *Pdbcs,int Plen,int Ppos1,int Ppos2);//~v49bR~
//**************************************************               //~v45xI~
int btabclear(UCHAR *Pdata,UCHAR *Pdbcs,int Pdatalen,int Ppos,int Popt);//~v45xI~
