    switch (reqcode)                                               //~v5jaI~
    {                                                              //~v5jaI~
	case CRITSEC_INIT:                                             //~v5jaI~
    	if (Popc & CRITSEC_PRIVATE)                                //~v5jaI~
        	key=IPC_PRIVATE;                                       //~v5jaI~
        else                                                       //~v5jaI~
        	key=(key_t)(*((ULONG*)Ppsem));                         //~v5jaI~
        flag=IPC_CREATE|IPC_EXCL|0666;                             //~v5jaI~
		handle=semget(key,1,flag);                                 //~v5jaI~
        if (!handle)                                               //~v5jaI~
        	return uerrapi0t(0,"semget",errno);                    //~v5jaI~
        semctlparm.val=1;			//value of SETVAL operation    //~v5jaI~
        rc=semctl(handle,0,SETVAL,semctlparm);	//0:offset 0 of sem array//~v5jaI~
        if (rc==-1)                                                //~v5jaI~
        	return uerrapi0t(0,"semctl SETVAL",errno);             //~v5jaI~
        *((int*)Ppsem)=handle;                                     //~v5jaI~
        break;                                                     //~v5jaI~
	case CRITSEC_ENTER:                                            //~v5jaI~
    	handle=(int)Ppsem;                                         //~v5jaI~
        sem.sem_num=0;      //sem count 0 means 1                  //~v5jaI~
        sem.sem_op=-1;     //wait                                  //~v5jaI~
        sem.sem_flg=SEM_UNDO;      //free when process exit        //~v5jaI~
		rc=semop(handle,&sem,1); 	//1 count of array of sem      //~v5jaI~
        if (rc==-1)                                                //~v5jaI~
        	return uerrapi0t(0,"semop WAIT",errno);                //~v5jaI~
        break;                                                     //~v5jaI~
	case CRITSEC_LEAVE:                                            //~v5jaI~
    	handle=(int)Ppsem;                                         //~v5jaI~
        sem.sem_num=0;      //sem count 0 means 1                  //~v5jaI~
        sem.sem_op=1;     //post                                   //~v5jaI~
        sem.sem_flg=SEM_UNDO;      //free when process exit        //~v5jaI~
		rc=semop(handle,&sem,1); 	//1 count of array of sem      //~v5jaI~
        if (rc==-1)                                                //~v5jaI~
        	return uerrapi0t(0,"semop POST",errno);                //~v5jaI~
        break;                                                     //~v5jaI~
	case CRITSEC_DELETE:                                           //~v5jaI~
    	handle=(int)Ppsem;                                         //~v5jaI~
        rc=semctl(handle,0,IPC_RMID);                              //~v5jaI~
        if (rc==-1)                                                //~v5jaI~
        	return uerrapi0t(0,"semctl IPC_RMID",errno);           //~v5jaI~
        break;                                                     //~v5jaI~
    }                                                              //~v5jaI~
