//*CID://+v5dxR~:                             update#=   35;       //+v5dxR~
//*******************************************************
//v5dx:040815 BC cmd:support dw/up                                 //+v5dxI~
//v5dr:040627 BC cmd:accept minus value                            //~v5drI~
//v5dj:040612 support dword underpoint "+"(add)/"-" operation      //~v5djI~
//v5ag:040106 prevday support for calc nextday                     //~v5agI~
//v59s:031221 calc next day                                        //~v59sI~
//v50k:010407 host time support                                    //~v50kM~
//v50g:010402 calc:long decimal support                            //~v50gI~
//v50f:010402 TOD conversion                                       //~v50fI~
//v50e:010402 double word calc support                             //~v50eI~
//*******************************************************
typedef struct _UCALC_TIME                                         //~v50eI~
        {int year,month,day,hour,min,sec,milsec;} UCALC_TIME,*PUCALC_TIME;//~v50eI~
//*******************************************************          //~v50eI~
#define DWORD_LSHIFT(high,low)         \
          (high=(LONG)(((ULONG)high<<1)+((low & HIGHBIT)!=0)),\
           low=(LONG)((ULONG)low<<1))                              //~v5drI~
//        (high=(high<<1)+((low & HIGHBIT)!=0),low<<=1)            //~v5drI~
#define DWORD_RSHIFT(high,low)         \
        (low=(LONG)(((ULONG)low>>1)|((high & 1)?HIGHBIT:0)),\
        high=(LONG)(((ULONG)high)>>1))                             //~v5drI~
//      (low=(low>>1)|((high & 1)?HIGHBIT:0),high>>=1)             //~v5drI~
#define DWORD_COMP(high1,low1,high2,low2)         \
        (((long)(high1)>(long)(high2))?1:(((long)(high1)<(long)high2)?-1:\
        (((unsigned long)(low1)>(unsigned long)(low2))?1:(((unsigned long)(low1)<(unsigned long)(low2))?-1:0))))//~v5drR~
//      ((high1>high2)?1:((high1<high2)?-1:((low1>low2)?1:((low1<low2)?-1:0))))//~v5drI~
#define DWORD_SUB(high1,low1,high2,low2)         \
        (high1-=(LONG)(high2+((ULONG)(low1)<(ULONG)(low2))),\
		low1-=(LONG)low2)                                          //~v5drI~
//      (high1-=high2+(low1<low2),low1-=low2)                      //~v5drI~
#define DWORD_ADD(high1,low1,high2,low2)         \
        (high1+=(LONG)(high2+((ULONG)(low1)>(ULONG)(low1+low2))),\
        low1+=(LONG)low2)             /*//~v50eI~*/\
//      (high1+=high2+(low1>(low1+low2)),low1+=low2)               //~v5drI~
#define DWORD_MINUS(high,low)         \
        (high=(LONG)(-high-(low!=0)),\
		low=-(LONG)low)                                            //~v5drI~
//***************************************************************  //~v50eI~
int bc_getxdw(char *Pdata,long *Pvalue);                           //~v50eM~
//***************************************************************  //~v50eI~
//int bc_getld(char *Pdata,long *Pvalue);                          //~v5djR~
int bc_getld(int Popt,char *Pdata,long *Pvalue);                   //~v5djI~
#define GETLD_DWUP		0x01 //accept Dword underpoint             //~v5djI~
//***************************************************************  //~v50gI~
int bc_dwbinop(int Popt,int Pope,long *Popd1,long *Popd2);         //~v50eI~
//***************************************************************  //~v50eI~
int bc_edittod(UCHAR *Pout,long *Pvalue);                          //~v50fI~
//***************************************************************  //~v50fI~
int bc_dweditnum(int Pfunctype,int Pconvtype,long *Pvalue,UCHAR *Pout);//~v50eI~
//***************************************************************  //~v50eI~
//int ucalc_dwmult(ULONG *Ppopd1,ULONG Popd2);                     //~v5drR~
int ucalc_dwmult(LONG *Ppopd1,LONG Popd2);                         //~v5drI~
//***************************************************************  //~v50eI~
//int ucalc_dwdiv(ULONG *Ppopd1,ULONG Popd2);                      //~v5drR~
int ucalc_dwdiv(LONG *Ppopd1,LONG Popd2);                          //~v5drI~
//***************************************************************  //~v50eI~
int ucalc_ltime(int Ptmtype,ULONG *Ptime,PUCALC_TIME Ppuct);       //~v50eI~
#define LTIME_PC      1                                            //~v50eI~
#define LTIME_UNIX    2                                            //~v50eI~
#define LTIME_HOST    3                                            //~v50eI~
//***************************************************************  //~v50gI~
//int ucalc_ld2dw(char *Pdecs,ULONG *Pdword);                      //~v5drR~
int ucalc_ld2dw(char *Pdecs,LONG *Pdword);                         //~v5drI~
//***************************************************************  //~v50gI~
int ucalc_dw2ld(ULONG Pdwh,ULONG Pdwl,char *Pnumstr);              //~v50gI~
//***************************************************************  //~v50gI~
int ucalc_nsadd(char *Pnumstr1,char *Pnumstr2);                    //~v50gI~
//*******************************************************          //~v50kM~
int ucalc_ltime(int Ptmtype,ULONG *Ptime,PUCALC_TIME Ppuct);       //~v50kM~
//*******************************************************          //~v50kI~
int ucalc_getdate(int Pdays,int *Pdate);                           //~v50kI~
//*******************************************************          //~v59sR~
int ucalc_nextday(int Pdiff,int *Ppyear,int *Ppmonth,int *Ppday);  //~v5agR~
//*******************************************************          //~v5djI~
void ucalc_dwupinit(long *Pdwup);                                  //~v5djI~
//*******************************************************          //~v5djI~
//void ucalc_dwupset(long *Pdwup,long *Plv);                       //~v5drR~
void ucalc_dwupset(int Popt,long *Pdwup,long *Plv);                //~v5drI~
//*******************************************************          //~v5drI~
int bc_dword2word(int Popt,long *Pnumfmt,long *Poutnumfmt);        //~v5drM~
//*******************************************************          //+v5dxI~
int ucalcerrdwordovf(void);                                        //+v5dxI~
