//CID://+v5igR~:                             update#=   38;        //~v5igR~
//*************************************************************
//*uedit2.c
//*  uasciidump,ueditfattr,uxdumpline,ugetdtparm(date/time parm)   //~v5czR~
//*************************************************************
//v5ig:060620 add convert macro;char to hex char                   //~v5igI~
//v5i5:060505 (XDA)print ucs code                                  //~v5i5I~
//v5cz:040522 date/time edit func for locate cmd                   //~v5czI~
//v59e:031103 ftp support(4 byte udirlist attr for ! UNX)          //~v59eI~
//v56s:020712 (UNX)allow to udirlist select non-reguler file       //~v56sI~
//v50R:010917 UNX:chng attr fmt to ugtdl(S=u+g,L=d+l),d is option, //~v50RR~
//v50Q:010915 UNX:edit file attr for other than xe(rwxd/lugt fmt)  //~v50QR~
//v50G:010618 LNX:disket support(using mtools)                     //~v50GI~
//v50E:010616 return symbolic link attr/name for dir list          //~v50EI~
//v378:000930 LINUX support(file attr by 777st fmt)                //~v378I~
//v333 000904:LINUX support(file attr size 1-->4)                  //~v327I~
//v327 000820:LINUX support                                        //~v327I~
//v256:990626 seg:off display for dump of DOS                      //~v256I~
//v226:990307 dumpxline addr invalid when not on boundary          //~v226I~
//v222:990213 no delm option for dump                              //~v222I~
//v217:990108 disas:change v216;for current buff addr use same value//~v217I~
//v216:990108 disas:base 0 id(-1)                                  //~v216I~
//v207:981220 add uxdumpline                                       //~v207I~
//v195:980920 display attr/size on xdd list                        //~v195I~
//v163:980301 add uasciidump                                       //~v163I~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifdef UNX                                                         //~v327I~
	#include <sys/stat.h>                                          //~v378R~
#else                                                              //~v327I~
#include <io.h>                                                    //~v195I~
#endif                                                             //~v327I~
#include <errno.h>                                                 //~v226I~
//*******************************************************
#ifdef DOS
#else
    #ifdef W32
    #else
	#endif
#endif
//*******************************************************
#include <ulib.h>
#include <ufile.h>                                                 //~v195I~
#include <uedit.h>                                                 //~v5czI~
#include <uedit2.h>
#include <udbcschk.h>                                              //~v163I~
#include <uerr.h>                                                  //~v195I~
#include <uque.h>                                                  //~v59eI~
#include <uftp.h>                                                  //~v59eI~
#include <ucvucs.h>                                                //~v5i5I~
//*******************************************************
#ifdef UNX                                                         //~v59eI~
void ueditfattr_mdos(UCHAR Pattr,UCHAR *Pout,int Popt);            //~v50GI~
#else                                                              //~v59eI~
void ueditfattrunix(ULONG Pattr,UCHAR *Pout,int Popt);             //~v59eI~
#endif                                                             //~v59eI~
char ueditfattrspf(ULONG Pmode);                                   //~v56sI~
int ueditgetftnum(char *Pdata,int *Ppi1,int *Ppi2,int *Ppi3);      //~v5czI~
//*******************************************************
//*uedit
//* dummy for LIB
//******************************************************
void uedit2(void)
{
	return;
}//uedit

//*******************************************************
//*uasciidump
//* numeric patern edit
//* parm1 :opt 1:dbcs chk,2:allow kana
//* parm2 :outbuff
//* parm3 :inpdata
//* parm4 :inpdata len
//* return:0:ok,1:last dbcs split                                  //~v163R~
//******************************************************
int uasciidump(int Popt,UCHAR *Pout,UCHAR *Pinp,int Pinplen)       //~v163R~
{
	UCHAR *pco,*pci,*pcie,ch;                                      //~v163R~
    int dbcschk,kanachk,dbcssw;
//******************
    dbcschk=((Popt&UAD_DBCS) && udbcschkcp());                     //~v163R~
    kanachk=(Popt&UAD_KANA);
    dbcssw=0;
    pco=Pout;
    pci=Pinp;
    pcie=pci+Pinplen;
    while (pci<pcie)           /* 1 line setup*/                   //~v163R~
    {
        ch=*pci++;                                                 //~v163R~
		if (dbcssw)
        {                                                          //~v163I~
            if (ch<' ')	//previous is not valid                    //~v163I~
            {                                                      //~v163I~
            	ch='.';                                            //~v163R~
                *(pco-1)='.';                                      //~v163I~
            }                                                      //~v163I~
			dbcssw=0;
        }                                                          //~v163I~
        else
        {
            if (dbcschk)
            	dbcssw=udbcschk(ch);                               //~v163R~
			if (!dbcssw)
            {                                                      //~v59eI~
				if (ch<' ')
                    ch='.';
                else
					if (ch>=0x7f)
                    {                                              //~v59eI~
						if (kanachk)
                        {
                        	if (ch<0xa1 || ch>0xdf)	//katakana
                            	ch='.';
						}
                        else
                            ch='.';
                    }//7f                                          //~v59eI~
            }//dbcssw                                              //~v59eI~
        }//dbcschk faile
		*pco++=ch;
	}//for loop
    if (dbcssw)
    {                                                              //~v163I~
		if (!(Popt & UAD_LLASTDBCS))//not leave last dbcs          //~v163I~
   			*(pco-1)='.';                                          //~v163R~
        return 1;                                                  //~v163I~
	}                                                              //~v163I~
	return 0;                                                      //~v163R~
}//uasciidump
                                                                   //~v163I~
//*******************************************************          //~v5i5I~
//*uucsdump                                                        //~v5i5I~
//* du,p as source is ucs(conv to sjis)                            //~v5i5I~
//* parm1 :opt 1:dbcs chk                                          //~v5i5I~
//* parm2 :outbuff                                                 //~v5i5I~
//* parm3 :inpdata                                                 //~v5i5I~
//* parm4 :len to be printed  //max 32 byte                        //~v5i5I~
//* parm4 :inpdata total len                                       //~v5i5I~
//* return:0:ok,1:last dbcs split                                  //~v5i5I~
//******************************************************           //~v5i5I~
int uucsdump(int Popt,UCHAR *Pout,UCHAR *Pinp,int Pprintlen,int Pinplen)//~v5i5I~
{                                                                  //~v5i5I~
	UCHAR *pco,*pc,errch='.';                                      //~v5i5R~
    int dbcschk,ii,jj,sjis,len,ucsctr,ucsctr1,padsw,maxoutlen=0,outlen;//~v5i5R~
    ULONG ucs,opt;                                                 //~v5i5R~
//******************                                               //~v5i5I~
    dbcschk=((Popt&UUD_DBCS) && udbcschkcp());                     //~v5i5R~
    opt=UCVUCS_LE;                                                 //~v5i5I~
    len=Pprintlen;                                                 //~v5i5I~
    pc=Pinp;                                                       //~v5i5I~
    for (jj=0;jj<3;jj++)	//conv from top, from 2nd, back to top because more ucs detected//~v5i5I~
    {                                                              //~v5i5I~
    	pco=Pout;                                                  //~v5i5I~
        ucsctr=0;                                                  //~v5i5I~
        padsw=0;                                                   //~v5i5I~
	    if (len & 0x01)	//odd number                               //~v5i5I~
    		if (Pinplen>Pprintlen)                                 //~v5i5I~
            {                                                      //~v5i5I~
        		len++;                                             //~v5i5I~
                padsw=1;                                           //~v5i5I~
            }                                                      //~v5i5I~
        for (ii=len;ii>1;ii-=2,pc+=2)                              //~v5i5R~
        {                                                          //~v5i5I~
            ucs=(ULONG)(*pc+(*(pc+1)<<8));   //little endian       //~v5i5R~
            sjis=uccvucs2sjis(opt,ucs);                            //~v5i5I~
            if (sjis==UCVERRUCS)    //err                          //~v5i5I~
            {                                                      //~v5i5I~
                *pco++=errch;                                      //~v5i5I~
            }                                                      //~v5i5I~
            else                                                   //~v5i5I~
            if (dbcschk && (sjis & 0xff00))  //dbcs                //~v5i5I~
            {                                                      //~v5i5I~
                *pco++=(UCHAR)(sjis>>8);                           //~v5i5R~
                *pco++=(UCHAR)(sjis & 0xff);                       //~v5i5I~
                ucsctr++;                                          //~v5i5I~
            }                                                      //~v5i5I~
            else                                                   //~v5i5I~
            {                                                      //~v5i5I~
                if (sjis>=' ' && sjis<0x7f)                        //~v5i5I~
                {                                                  //~v5i5I~
	                ucsctr++;                                      //~v5i5I~
                    *pco++=(UCHAR)sjis;                            //~v5i5I~
                }                                                  //~v5i5I~
                else                                               //~v5i5I~
                    *pco++=errch;                                  //~v5i5I~
            }                                                      //~v5i5I~
        }                                                          //~v5i5I~
        if (ii && !padsw)                                          //~v5i5I~
        	*pco++=errch;                                          //~v5i5I~
		outlen=(int)((ULONG)pco-(ULONG)Pout);                      //~v5i5R~
        if (maxoutlen<outlen)                                      //~v5i5I~
        	maxoutlen=outlen;                                      //~v5i5I~
        if (Popt & UUD_NORETRY)	// 	0x02		//try from top byte only//~v5i5I~
        	break;                                                 //~v5i5I~
        if (!jj)	//1st loop                                     //~v5i5I~
        {                                                          //~v5i5I~
	        ucsctr1=ucsctr;		//save of 1st loop                 //~v5i5I~
    	    pc=Pinp+1;                                             //~v5i5I~
        	len=Pprintlen-1;                                       //~v5i5I~
        }                                                          //~v5i5I~
        else                                                       //~v5i5I~
        if (jj==1)	//2nd loop                                     //~v5i5I~
        {                                                          //~v5i5I~
	    	if (ucsctr>=ucsctr1)	//2nd loop detected more ucs code than 1st loop//~v5i5I~
        		break;                                             //~v5i5I~
    		len=Pprintlen;                                         //~v5i5I~
    		pc=Pinp;                                               //~v5i5I~
        }                                                          //~v5i5I~
    }                                                              //~v5i5I~
    if (maxoutlen>outlen)                                          //~v5i5I~
    	memset(Pout+outlen,' ',(UINT)(maxoutlen-outlen));	//clear longer retry//~v5i5I~
	return outlen;                                                 //~v5i5R~
}//uucsdump                                                        //~v5i5I~
//*******************************************************          //~v163I~
//*ub2x                                                            //~v163I~
//* binary to hex degit                                            //~v163I~
//* parm1 :option    0:upper case,1:lower case output              //~v163I~
//* parm2 :outbuff                                                 //~v163I~
//* parm3 :source                                                  //~v163I~
//* parm4 :len                                                     //~v163I~
//* return:0                                                       //~v163I~
//******************************************************           //~v163I~
int ub2x(int Popt,UCHAR *Pout,void *Pinp,int Plen)                 //~v163R~
{                                                                  //~v163I~
static UCHAR Sucase[17]="0123456789ABCDEF";                        //~v59eR~
static UCHAR Slcase[17]="0123456789abcdef";                        //~v59eR~
	UCHAR *pce,*pc;                                                //~v163R~
    int ch,chh,chl,lsw;                                            //~v163R~
//******************                                               //~v163I~
	lsw=Popt & UBX_LOWER;                                          //~v163I~
    for (pc=Pinp,pce=pc+Plen;pc<pce;pc++)                          //~v163R~
    {                                                              //~v163I~
    	ch=(int)*pc;                                               //~v163R~
        chh=(int)((UINT)ch>>4);                                           //~v59eR~
        chl=ch & 0x0f;                                             //~v163I~
        if (lsw)                                                   //~v163R~
        {                                                          //~v163I~
        	*Pout++=Slcase[chh];                                   //~v163M~
        	*Pout++=Slcase[chl];                                   //~v163M~
        }                                                          //~v163M~
        else                                                       //~v163M~
        {                                                          //~v163M~
        	*Pout++=Sucase[chh];                                   //~v163M~
        	*Pout++=Sucase[chl];                                   //~v163M~
        }                                                          //~v163M~
    }                                                              //~v163I~
	return 0;                                                      //~v163I~
}//uasciidump                                                      //~v163I~
                                                                   //~v195I~
#ifdef FTPSUPP   //UNX or W32                                      //~v59eI~
#ifdef UNX                                                         //~v378M~
                                                                   //~v378M~
//*******************************************************          //~v378I~
//*file attr conv to char                                          //~v378I~
//* parm1: attribute                                               //~v378I~
//* parm2: output area(4 to max 6 byte)                            //~v378I~
//*        s:setuid,S:setuid+setgid,G:setgid,t:stickey             //~v378I~
//* parm3: option;x01:set last 0,x'02' set directory               //~v378I~
//* return:none                                                    //~v378I~
//*******************************************************          //~v378I~
void ueditfattr(ULONG Pattr,UCHAR *Pout,int Popt)                  //~v378M~
#else                                                              //~v59eI~
void ueditfattrunix(ULONG Pattr,UCHAR *Pout,int Popt)              //~v59eI~
#endif                                                             //~v59eI~
{                                                                  //~v378M~
    int mode;                                                      //~v378M~
#ifdef UNX                                                         //~v59eI~
    UCHAR attr;                                                    //~v50GI~
#endif                                                             //~v59eI~
    char filetype;                                                 //~v56sI~
//************************                                         //~v378M~
#ifdef UNX                                                         //~v59eI~
	if (Popt & UEFA_MDOS)                                          //~v50GI~
    {                                                              //~v50GI~
    	attr=(UCHAR)FILE_GETATTR(Pattr);                           //~v50GI~
		ueditfattr_mdos(attr,Pout,Popt);                           //~v50GI~
        return;                                                    //~v50GI~
    }                                                              //~v50GI~
#endif                                                             //~v59eI~
    mode=FILE_GETMODE(Pattr);                                      //~v378M~
    Pout[0]=(UCHAR)('0'+((UINT)(mode & S_IRWXU)>>6));	//user     //~v59eR~
    Pout[1]=(UCHAR)('0'+((UINT)(mode & S_IRWXG)>>3));	//group    //~v59eR~
    Pout[2]=(UCHAR)('0'+((UINT)(mode & S_IRWXO))   );		//other//~v59eR~
	filetype=ueditfattrspf(mode);                                  //~v56sI~
  if (Popt & UEFA_UFMT) //@dsgt fmt                                //~v50QI~
  {                                                                //~v50QI~
//  if (S_ISLNK(mode))  //slink                                    //~v56sR~
    if (filetype=='l')  //slink                                    //~v56sI~
        Pout[3]='l';                                               //~v56sR~
    else                                                           //~v56sR~
//      if (S_ISDIR(mode))  //dir                                  //~v56sI~
	    if (filetype=='d')  //slink                                //~v56sI~
            Pout[3]='d';                                           //~v56sR~
        else                                                       //~v56sR~
            Pout[3]='-';                                           //~v56sR~
    if (mode & S_ISUID)     //setuid                               //~v50QR~
        Pout[4]='u';                                               //~v50QR~
    else                                                           //~v50QI~
        Pout[4]='-';                                               //~v50QR~
    if (mode & S_ISGID)     //setgid                               //~v50QR~
        Pout[5]='g';                                               //~v50QR~
    else                                                           //~v50QI~
        Pout[5]='-';                                               //~v50QR~
    if (mode & S_ISVTX)     //stickey                              //~v50QI~
        Pout[6]='t';                                               //~v50QI~
    else                                                           //~v50QI~
      if (filetype!='d' && filetype!='l')   //not dir and not slink//~v56sI~
        Pout[6]=filetype;                                          //~v56sI~
      else                                                         //~v56sI~
        Pout[6]='-';                                               //~v50QI~
    if (Popt & UEFA_SZ)                                            //~v50QI~
        Pout[7]=0;                                                 //~v50QI~
  }                                                                //~v50QI~
  else                                                             //~v50QI~
  {                                                                //~v50QI~
    if (mode & S_ISUID)     //setuid                               //~v378R~
        if (mode & S_ISGID)                                        //~v378R~
            Pout[3]='S';                                           //~v378R~
        else                                                       //~v378R~
//          Pout[3]='s';    //"S" for s+x                          //~v50RR~
            Pout[3]='u';    //setuid                               //~v50RR~
    else                                                           //~v378R~
        if (mode & S_ISGID)                                        //~v378I~
//          Pout[3]='G';                                           //~v50RR~
            Pout[3]='g';    //setgid                               //~v50RR~
        else                                                       //~v378I~
            Pout[3]='-';    //"S" for s+x                          //~v378I~
    if (mode & S_ISVTX)//setgid;stickey is no mean for normal file //~v378R~
        Pout[4]='t';                                               //~v378R~
    else                                                           //~v378R~
      if (filetype!='d' && filetype!='l')   //not dir and not slink//~v56sI~
        Pout[4]=filetype;                                          //~v56sI~
      else                                                         //~v56sI~
        Pout[4]='-';                                               //~v378R~
//*                                                                //~v378R~
	if (Popt & UEFA_DIR)	//chk dir attr                         //~v378M~
    {                                                              //~v378M~
//      if (S_ISLNK(mode))  //slink                                //~v56sR~
        if (filetype=='l')  //slink                                //~v56sI~
    		if (Pattr & FILE_DIRECTORY)  //dir                     //~v50EI~
//          	Pout[5]='D';        //symbolink and directory      //~v50RR~
            	Pout[5]='L';        //symbolink and directory      //~v50RI~
        	else                                                   //~v50EI~
//          	Pout[5]='s';        //symbolic link                //~v50RR~
            	Pout[5]='l';        //symbolic link                //~v50RR~
        else                                                       //~v50EI~
//  	if (S_ISDIR(mode))  //dir                                  //~v56sR~
    	if (filetype=='d')  //dir                                  //~v56sI~
            Pout[5]='d';                                           //~v378M~
        else                                                       //~v378M~
            Pout[5]='-';                                           //~v378M~
		if (Popt & UEFA_SZ)                                        //~v378M~
            Pout[6]=0;                                             //~v378M~
	}                                                              //~v378M~
    else                                                           //~v378M~
    {                                                              //~v378M~
		if (Popt & UEFA_SZ)                                        //~v378M~
            Pout[5]=0;                                             //~v378M~
	}                                                              //~v378M~
  }//xe fmt                                                        //~v50QI~
	return;                                                        //~v378M~
}//ueditfattr                                                      //~v378M~
//*******************************************************          //~v56sI~
//*file attr conv to char for special file                         //~v56sI~
//* parm1: attribute                                               //~v56sI~
//* return:char id                                                 //~v56sI~
//*******************************************************          //~v56sI~
char ueditfattrspf(ULONG Pmode)                                    //~v56sI~
{                                                                  //~v56sI~
	char filetype;                                                 //~v56sI~
//*************                                                    //~v56sI~
    if (S_ISLNK(Pmode))  //slink                                   //~v56sI~
        filetype='l';                                              //~v56sI~
    else                                                           //~v56sI~
    if (S_ISDIR(Pmode))  //dir                                     //~v56sI~
        filetype='d';                                              //~v56sI~
    else                                                           //~v56sI~
    if (S_ISCHR(Pmode))  //char device                             //~v56sI~
        filetype='c';                                              //~v56sI~
    else                                                           //~v56sI~
    if (S_ISBLK(Pmode))  //blk  device                             //~v56sI~
        filetype='b';                                              //~v56sI~
    else                                                           //~v56sI~
    if (S_ISFIFO(Pmode))  //pipe  device                           //~v56sI~
        filetype='p';                                              //~v56sI~
    else                                                           //~v56sI~
    if (S_ISSOCK(Pmode))  //socket device                          //~v56sI~
        filetype='s';                                              //~v56sI~
    else                                                           //~v56sI~
        filetype='-';                                              //~v56sI~
    return filetype;                                               //~v56sI~
}//ueditfattrspf                                                   //~v56sI~
#endif  //FTPSUPP                                                  //~v59eI~
//*******************************************************          //~v195I~
//*file attr conv to char                                          //~v195I~
//* parm1: attribute                                               //~v195I~
//* parm2: output area(4 or 6 byte)                                //~v195I~
//* parm3: option;x01:set last 0,x'02' set directory               //~v195R~
//* return:none                                                    //~v195I~
//*******************************************************          //~v195I~
#ifdef UNX                                                         //~v59eI~
void ueditfattr_mdos(UCHAR Pattr,UCHAR *Pout,int Popt)             //~v50GM~
#else   //!UNX                                                     //~v50GI~
//void ueditfattr(UCHAR Pattr,UCHAR *Pout,int Popt)                //~v59eR~
void ueditfattr(ULONG Pattr,UCHAR *Pout,int Popt)                  //~v59eI~
#endif                                                             //~v50GI~
{                                                                  //~v195I~
//************************                                         //~v195I~
#ifdef UNX                                                         //~v59eI~
#else                                                              //~v59eI~
  #ifdef FTPSUPP                                                   //~v59eI~
	if (Pattr & FILE_REMOTE)	//ftp file                         //~v59eI~
    {                                                              //~v59eI~
		ueditfattrunix(Pattr,Pout,Popt);                           //~v59eR~
        return;                                                    //~v59eI~
    }                                                              //~v59eI~
  #endif                                                           //~v59eI~
#endif                                                             //~v59eI~
 	if (UCBITCHK(Pattr,FILE_ARCHIVED))                             //~v195I~
       	Pout[0]='A';                                               //~v195I~
    else                                                           //~v195I~
       	Pout[0]='-';                                               //~v195I~
    if (UCBITCHK(Pattr,FILE_SYSTEM))                               //~v195I~
       	Pout[1]='S';                                               //~v195I~
    else                                                           //~v195I~
       	Pout[1]='-';                                               //~v195I~
    if (UCBITCHK(Pattr,FILE_HIDDEN))                               //~v195I~
       	Pout[2]='H';                                               //~v195I~
    else                                                           //~v195I~
       	Pout[2]='-';                                               //~v195I~
    if (UCBITCHK(Pattr,FILE_READONLY))                             //~v195I~
       	Pout[3]='R';                                               //~v195I~
    else                                                           //~v195I~
       	Pout[3]='-';                                               //~v195I~
	if (Popt & UEFA_DIR)	//chk dir attr                         //~v195I~
    {                                                              //~v195I~
        if (UCBITCHK(Pattr,FILE_DIRECTORY))                        //~v195R~
            Pout[4]='D';                                           //~v195I~
        else                                                       //~v195I~
            Pout[4]='-';                                           //~v195I~
		if (Popt & UEFA_SZ)                                        //~v195I~
            Pout[5]=0;                                             //~v195I~
	}                                                              //~v195I~
    else                                                           //~v195I~
    {                                                              //~v195I~
		if (Popt & UEFA_SZ)                                        //~v195I~
            Pout[4]=0;                                             //~v195I~
	}                                                              //~v195I~
	return;                                                        //~v195I~
}//ueditfattr                                                      //~v195I~
//#endif //!UNX                                                    //~v50GR~
//********************************************************************//~v195I~
//* hex line edit and print	                                       //~v207R~
//*   input:                                                       //~v195I~
//*     p1 : XDUMPLINEPRM                                          //~v195I~
//*   output:                                                      //~v195I~
//*     buff or file                                               //~v195I~
//********************************************************************//~v195I~
int uxdumpline(PXDUMPLINEPRM Ppxdlp)                               //~v195I~
{                                                                  //~v195I~
#define LINEWIDTH  256                                             //~v195I~
#define LINENOSZ   8                                               //~v195I~
#define LINENOSZ2  (8+10)                                          //~v256I~
                                                                   //~v195I~
void xdlputs(UCHAR *Pdata,FILE* Pfh,UCHAR **Pppout);               //~v207R~
                                                                   //~v195I~
static  XDUMPLINEPRM  Sxdlp;                                       //~v207I~
static  UCHAR Sdumpline[LINEWIDTH];                                //~v207R~
static  UCHAR Ssameline[LINEWIDTH];                                //~v207R~
static  UCHAR Ssamechksv[32];                                      //~v195I~
static	ULONG Ssamestart;                                          //~v195I~
static	int   Sboundary,Sdumpwidth,Shexpos,Scharpos,Slowersw,Sdbcssw;//~v207R~
static	int   Sucspos;                                             //~v5i5I~
static	int   Slinenosz;                                           //~v256I~
static  UCHAR Ssameedit[]="%08lx to %08lx is same as above\n";     //~v207R~
static  UCHAR Soffsedit[]="%08lx";                                 //~v207I~
static  UCHAR Sdosedit[]=" %04x:%04x";                             //~v256I~
        UCHAR xdumpwk[LINEWIDTH],*pxdumpwk;      //dump print line v6.7a//~v195R~
		ULONG offset,reslen;                                       //~v207R~
        ULONG vaddr;                                               //~v216I~
	    UCHAR *pchexd,*inpdata,*outdata;                           //~v195R~
		int ii,opt,line1sw;                                        //~v207R~
		int wlen,linewidth,ilen;                                   //~v207R~
        USHORT dosseg,dossegr;                                     //~v256R~
//******************                                               //~v195I~
	opt=Ppxdlp->XDLPopt;                                           //~v195I~
//  if (vaddr==(ULONG)-1)                                          //~v217R~
//      vaddr=0;                                                   //~v217R~
//init process                                                     //~v195I~
	if (!(opt & XDLP_2ND))				//printdump sub first sw   //~v195I~
	{                                                              //~v195I~
		if (UCBITCHK(Ppxdlp->XDLPopt,XDLP_DOSSEG))                 //~v256I~
        	Slinenosz=LINENOSZ2;	//with seg:off                 //~v256I~
        else                                                       //~v256I~
        	Slinenosz=LINENOSZ;                                    //~v256I~
		Ppxdlp->XDLPopt=(UCHAR)(Ppxdlp->XDLPopt|XDLP_2ND); 			//printdump sub first sw//~v207R~
        memcpy(&Sxdlp,Ppxdlp,sizeof(Sxdlp));                       //~v207I~
        memset(Sdumpline,' ',sizeof(Sdumpline));                   //~v195R~
        memset(Ssameline,' ',sizeof(Ssameline));                   //~v195R~
        Ssamestart=0;                                              //~v207I~
	    vaddr=(ULONG)Sxdlp.XDLPvirtual;                            //~v217I~
        if (opt & XDLP_32)              //printdump sub first sw   //~v195I~
        {                                                          //~v195I~
            Sdumpwidth=32;                                         //~v195I~
//          Sboundary=(int)((ULONG)(Sxdlp.XDLPvirtual) & 0x1f);    //~v216R~
            Sboundary=(int)(vaddr & 0x1f);                         //~v216I~
//  		Shexpos=LINENOSZ+1+Sxdlp.XDLPhexpos;                   //~v256R~
    		Shexpos=Slinenosz+1+Sxdlp.XDLPhexpos;                  //~v256I~
			Scharpos=Shexpos+4*9-1+4+4*9-1+Sxdlp.XDLPcharpos+1;    //~v207R~
        }                                                          //~v195I~
        else                                                       //~v195I~
        {                                                          //~v195I~
            Sdumpwidth=16;                                         //~v195I~
//          Sboundary=(int)((ULONG)(Sxdlp.XDLPvirtual) & 0x0f);    //~v216R~
            Sboundary=(int)(vaddr & 0x0f);                         //~v216I~
//			Shexpos=LINENOSZ+1+Sxdlp.XDLPhexpos-1;                 //~v256R~
  			Shexpos=Slinenosz+1+Sxdlp.XDLPhexpos-1;                //~v256I~
			Scharpos=Shexpos+16*3+Sxdlp.XDLPcharpos+1;             //~v207R~
        }                                                          //~v195I~
        if (!Sxdlp.XDLPdelm2)                                      //~v222R~
            Scharpos--;                                            //~v222I~
//  	*(Sdumpline+LINENOSZ)=Sxdlp.XDLPdelm1;                     //~v256R~
    	*(Sdumpline+Slinenosz)=Sxdlp.XDLPdelm1;                    //~v256I~
	if (Sxdlp.XDLPdelm2)                                           //~v222I~
		*(Sdumpline+Scharpos-1)=Sxdlp.XDLPdelm2;                   //~v207R~
        linewidth=Scharpos+Sdumpwidth;                             //~v207R~
	if (Sxdlp.XDLPdelm2)                                           //~v222I~
		*(Sdumpline+linewidth++)=Sxdlp.XDLPdelm2;                  //~v207R~
	if ((Sxdlp.XDLPopt & XDLP_UCS))		//ucs conversion print req //~v5i5I~
    {                                                              //~v5i5I~
    	Sucspos=linewidth+XDLP_UCSSPACE;                           //~v5i5I~
    	linewidth+=XDLP_UCSSPACE+(Sdumpwidth+2);                   //~v5i5R~
    }                                                              //~v5i5I~
		*(Sdumpline+linewidth++)='\n';                             //~v207R~
		*(Sdumpline+linewidth)=0;                                  //~v207R~
        line1sw=1;                                                 //~v195I~
		if (Sxdlp.XDLPopt & XDLP_UPPER)				//printdump sub first sw//~v207I~
        {                                                          //~v207I~
        	Ssameedit[4]='X';                                      //~v207I~
        	Ssameedit[13]='X';                                     //~v207I~
        	Soffsedit[4]='X';                                      //~v207I~
        	Sdosedit[4]='X';                                       //~v256R~
        	Sdosedit[9]='X';                                       //~v256R~
            Slowersw=UBX_LOWER*0;                                  //~v207R~
        }                                                          //~v207I~
        else                                                       //~v207I~
        {                                                          //~v207I~
        	Ssameedit[4]='x';                                      //~v207I~
        	Ssameedit[13]='x';                                     //~v207I~
        	Soffsedit[4]='x';                                      //~v207I~
        	Sdosedit[4]='x';                                       //~v256R~
        	Sdosedit[9]='x';                                       //~v256R~
            Slowersw=UBX_LOWER;                                    //~v207I~
		}	                                                       //~v207I~
		if (Sxdlp.XDLPopt & XDLP_DBCS)				//printdump sub first sw//~v207I~
    		Sdbcssw=1;                                             //~v207I~
    	else                                                       //~v207I~
    		Sdbcssw=0;                                             //~v207I~
	}                                                              //~v195I~
    else	                                                       //~v195I~
        line1sw=0;                                                 //~v195I~
                                                                   //~v195I~
//*                                                                //~v195I~
	reslen=Ppxdlp->XDLPlen;                                        //~v195I~
//  offset=(ULONG)Ppxdlp->XDLPvirtual;                             //~v216R~
    offset=(ULONG)Sxdlp.XDLPvirtual;                               //~v217R~
    offset-=Sboundary;                                             //~v195R~
//printf("offset=%08lx,vaddr=%08lx,bound=%08lx\n",offset,vaddr,Sboundary);//~v217R~
	inpdata=Ppxdlp->XDLPinpbuff;                                   //~v195I~
	outdata=Ppxdlp->XDLPoutbuff;                                   //~v195R~
    dosseg=Ppxdlp->XDLPdosseg;                                     //~v256I~
    dossegr=Ppxdlp->XDLPdossegr;                                   //~v256I~
//                                                                 //~v195I~
	while (reslen)                                                 //~v195I~
    {                                                              //~v195I~
	    wlen=(int)min(reslen,(UINT)(Sdumpwidth-Sboundary));        //~v207R~
		for (;;)		//break by same chk                        //~v195I~
        {                                                          //~v195I~
//samechk                                                          //~v195I~
            if (wlen==Sdumpwidth                                   //~v195I~
            &&  !line1sw                                           //~v195R~
            &&  !memcmp(Ssamechksv,inpdata,(UINT)Sdumpwidth))      //~v195R~
            {                                                      //~v195I~
                if (!Ssamestart)                                   //~v195I~
                    Ssamestart=offset;                             //~v195I~
                break;      //next input width                     //~v195I~
            }                                                      //~v195I~
            else                                                   //~v195I~
            {                                                      //~v195I~
             	if (Ssamestart)                                    //~v195I~
                {                                                  //~v195I~
//  				sprintf(Ssameline+LINENOSZ+1,Ssameedit,        //~v256R~
    				sprintf(Ssameline+Slinenosz+1,Ssameedit,       //~v256I~
								Ssamestart,offset-1);              //~v207R~
                    xdlputs(Ssameline,Sxdlp.XDLPfh,&outdata);      //~v207R~
				}                                                  //~v195I~
                if (wlen==Sdumpwidth)                              //~v195I~
                	memcpy(Ssamechksv,inpdata,(UINT)Sdumpwidth);   //~v207R~
				Ssamestart=0;                                      //~v195I~
			}                                                      //~v195I~
//addr                                                             //~v195I~
            sprintf(xdumpwk,Soffsedit,offset);                     //~v207R~
            memcpy(Sdumpline,xdumpwk,8);                           //~v207I~
            if (Slinenosz!=LINENOSZ)	//DOS                      //~v256I~
            {                                                      //~v256I~
	            sprintf(xdumpwk,Sdosedit,(UINT)(dosseg+dossegr),offset-(((ULONG)dosseg)<<4));//~v256R~
   		        memcpy(Sdumpline+LINENOSZ,xdumpwk,10);             //~v256R~
            }                                                      //~v256I~
//char dump                                                        //~v195I~
            memset(Sdumpline+Scharpos,' ',(UINT)Sdumpwidth);       //~v207R~
            uasciidump(Sdbcssw,Sdumpline+Scharpos+Sboundary,inpdata,wlen);//~v207R~
			if ((Sxdlp.XDLPopt & XDLP_UCS))		//ucs conversion print req//~v5i5I~
            {                                                      //~v5i5I~
	            memset(Sdumpline+Sucspos,' ',(UINT)(Sdumpwidth+2));//~v5i5I~
	            uucsdump(Sdbcssw,Sdumpline+Sucspos,inpdata,wlen,(int)reslen);//~v5i5R~
            }                                                      //~v5i5I~
//hexdump                                                          //~v195I~
            ub2x(Slowersw,xdumpwk,inpdata,wlen);                   //~v207R~
            pxdumpwk=xdumpwk;                                      //~v195R~
            pchexd=Sdumpline+Shexpos;                              //~v207R~
            ilen=wlen;			//input len                        //~v207I~
            if (Sdumpwidth==16)                                    //~v195I~
                for (ii=0;ii<Sdumpwidth;ii++)           /* 1 line setup*///~v207R~
                {                                                  //~v195I~
                    if (ii==8)                                     //~v195I~
                        *pchexd++='-';                             //~v207R~
                    else                                           //~v207I~
                    	pchexd++;                                  //~v207R~
                    if (ii>=Sboundary && ilen) //for boundary v7.25a//~v207R~
                    {                                              //~v207I~
                        *pchexd++=*pxdumpwk++;                     //~v207R~
                        *pchexd++=*pxdumpwk++;                     //~v207I~
                        --ilen;                                    //~v207R~
					}                                              //~v207I~
                    else                                           //~v207I~
                    {                                              //~v207I~
                    	*pchexd++=' ';                             //~v207R~
                    	*pchexd++=' ';                             //~v207R~
					}                                              //~v207I~
                }                                                  //~v195I~
            else//32byte mode                                      //~v195I~
                for (ii=0;ii<Sdumpwidth;ii++)           /* 1 line setup*///~v207R~
                {                                                  //~v195I~
                	if (ii)                                        //~v207I~
                    {                                              //~v207I~
                    	if (!(ii & 3))                             //~v207R~
                        	pchexd++;                              //~v207R~
                    	if (!(ii & 15))                            //~v207R~
                        	pchexd++;                              //~v207R~
					}                                              //~v207I~
                    if (ii>=Sboundary && ilen) //for boundary v7.25a//~v207R~
                    {                                              //~v207I~
                        *pchexd++=*pxdumpwk++;                     //~v207R~
                        *pchexd++=*pxdumpwk++;                     //~v207I~
                        --ilen;                                    //~v207R~
					}                                              //~v207I~
                    else                                           //~v207I~
                    {                                              //~v207I~
                    	*pchexd++=' ';                             //~v207R~
                    	*pchexd++=' ';                             //~v207R~
					}                                              //~v207I~
                }                                                  //~v195I~
            xdlputs(Sdumpline,Sxdlp.XDLPfh,&outdata);              //~v207R~
            break;                                                 //~v207I~
        }//same chk break                                          //~v195I~
        inpdata+=wlen;                                             //~v195I~
//        offset+=wlen;                                            //~v226R~
          offset+=(wlen+Sboundary);                                //~v226I~
        reslen-=wlen;                                              //~v195I~
        Sboundary=0;                                               //~v195R~
        line1sw=0;                                                 //~v207I~
	}                                                              //~v195I~
    if (Ssamestart                                                 //~v207R~
	&&  !(opt & XDLP_NOTLAST))                                     //~v207I~
    {                                                              //~v207I~
//      sprintf(Ssameline+LINENOSZ+1,Ssameedit,                    //~v256R~
        sprintf(Ssameline+Slinenosz+1,Ssameedit,                   //~v256I~
                    Ssamestart,offset-1);                          //~v207I~
        xdlputs(Ssameline,Sxdlp.XDLPfh,&outdata);                  //~v207I~
    }                                                              //~v207I~
    return 0;                                                      //~v195I~
}//uxdumpline                                                      //~v195I~
                                                                   //~v195I~
//********************************************************************//~v195I~
//*lineput                                                         //~v195I~
//*   input:                                                       //~v195I~
//*     p1 : data                                                  //~v195I~
//*     p2 : fh                                                    //~v195I~
//*   output:                                                      //~v195I~
//*     print output                                               //~v195I~
//********************************************************************//~v195I~
void xdlputs(UCHAR *Pdata,FILE* Pfh,UCHAR **Pppout)                //~v207R~
{                                                                  //~v195I~
    int rc;                                                        //~v207I~
//****************                                                 //~v195I~
	if (!Pfh)  			//no fileout                               //~v207I~
    {                                                              //~v207I~
     	strcpy(*Pppout,Pdata);                                     //~v207I~
        *Pppout+=(strlen(Pdata)+1);                                //~v207R~
        return;                                                    //~v207I~
	}                                                              //~v207I~
	rc=fputs(Pdata,Pfh);                                           //~v207R~
#ifdef DOS                                                         //~v207I~
  #ifdef DPMI					//DPMI version                     //~v207I~
    if (rc==-1)                                                    //~v207I~
  #else                       //not DPMI                           //~v207I~
    if (rc)                                                        //~v207I~
  #endif                      //DPMI or not                        //~v207I~
#else                                                              //~v207I~
    if (rc==-1)                                                    //~v207I~
#endif                                                             //~v207I~
	{                                                              //~v195I~
		uerrexit("HexDump output failed,rc=%d\n",0,                //~v195I~
				errno);                                            //~v195I~
	}                                                              //~v195I~
    return;	                                                       //~v195I~
}//xdlputs                                                         //~v195I~
//********************************************************************//~v5czI~
//*ugetdtparm                                                      //~v5czI~
//*   parse date/time parameter                                    //~v5czI~
//********************************************************************//~v5czI~
int ugetdtparm(UCHAR *Pdata,void /*FDATE*/ *Ppfdate,void /*FTIME*/ *Ppftime)//~v5czR~
{                                                                  //~v5czI~
    int len,rc;                                                    //~v5czI~
#define DT_MAX 20                                                  //~v5czI~
    char *pc,strdt[DT_MAX],strtm[DT_MAX];                          //~v5czI~
//*************************                                        //~v5czI~
    len=(int)strlen(Pdata);                                        //~v5czI~
    if (len>=DT_MAX)                                               //~v5czI~
    	return 4;                                                  //~v5czI~
    strcpy(strdt,Pdata);                                           //~v5czI~
	pc=strchr(strdt,'-');                                          //~v5czI~
    if (pc)                                                        //~v5czI~
    {                                                              //~v5czI~
    	*pc=0;                                                     //~v5czI~
    	strcpy(strtm,pc+1);                                        //~v5czI~
        rc=ugetdateparm(strdt,Ppfdate);                            //~v5czI~
        rc+=ugettimeparm(strtm,Ppftime);                           //~v5czI~
    }                                                              //~v5czI~
    else                                                           //~v5czI~
    {                                                              //~v5czI~
        rc=ugetdateparm(strdt,Ppfdate);                            //~v5czI~
        memset(Ppftime,0,sizeof(FTIME));                           //~v5czI~
    }                                                              //~v5czI~
    return rc;                                                     //~v5czI~
}//ugetdtparm                                                      //~v5czI~
//********************************************************************//~v5czI~
//*ugetdtparm                                                      //~v5czI~
//*   parse date/time parameter                                    //~v5czI~
//********************************************************************//~v5czI~
int ugetdateparm(UCHAR *Pdata,void /*FDATE*/ *Ppfdate)             //~v5czR~
{                                                                  //~v5czI~
    int ii,jj,kk;                                                  //~v5czI~
//*************************                                        //~v5czI~
    if (ueditgetftnum(Pdata,&ii,&jj,&kk))                          //~v5czR~
    	return 4;                                                  //~v5czI~
    if (ueditsetfdate(ii,jj,kk,Ppfdate))                           //~v5czR~
        return 4;                                                  //~v5czR~
    return 0;                                                      //~v5czR~
}//ugetdateparm                                                    //~v5czR~
//********************************************************************//~v5czI~
//*ugetdtparm                                                      //~v5czI~
//*   parse date/time parameter                                    //~v5czI~
//********************************************************************//~v5czI~
int ugettimeparm(UCHAR *Pdata,void /*FDATE*/ *Ppftime)             //~v5czR~
{                                                                  //~v5czI~
    int ii,jj,kk;                                                  //~v5czI~
//*************************                                        //~v5czI~
    if (ueditgetftnum(Pdata,&ii,&jj,&kk))                          //~v5czI~
        return 4;                                                  //~v5czI~
    if (ueditsetftime(ii,jj,kk,Ppftime))                           //~v5czI~
        return 4;                                                  //~v5czI~
    return 0;                                                      //~v5czI~
}//ugettimeparm                                                    //~v5czI~
//**********************************************************************//~v5czI~
//* get 3 int value                                                //~v5czI~
//*parm1:parm string                                               //~v5czI~
//*parm2:out int area1                                             //~v5czI~
//*parm3:out int area1                                             //~v5czI~
//*parm4:out int area1                                             //~v5czI~
//*return:rc;                                                      //~v5czI~
//**********************************************************************//~v5czI~
int ueditgetftnum(char *Pdata,int *Ppi1,int *Ppi2,int *Ppi3)       //~v5czI~
{                                                                  //~v5czI~
    int len,i1,i2,i3;                                              //~v5czI~
//****************                                                 //~v5czI~
    len=(int)strlen(Pdata);                                        //~v5czI~
    switch(len)                                                    //~v5czI~
    {                                                              //~v5czI~
    case 1:           //"0"                                        //~v5czI~
    	if (*Pdata!='0')                                           //~v5czI~
        	return 4;                                              //~v5czI~
        i1=i2=i3=0;                                                //~v5czI~
    	break;                                                     //~v5czI~
    case 4:           //"hhmm"                                     //~v5czI~
		if (unumlen(Pdata  ,0,4)!=4)                               //~v5czI~
	    	return 4;                                              //~v5czI~
		i1=uatoin(Pdata,  2);                                      //~v5czI~
		i2=uatoin(Pdata+2,2);                                      //~v5czI~
		i3=0;                                                      //~v5czI~
    	break;                                                     //~v5czI~
    case 5:           //"hh:mm"                                    //~v5czI~
		if (unumlen(Pdata  ,0,2)!=2                                //~v5czI~
		||  *(Pdata+2)!=':'                                        //~v5czI~
    	||  unumlen(Pdata+3,0,2)!=2)                               //~v5czI~
    		return 4;                                              //~v5czI~
		i1=uatoin(Pdata,  2);                                      //~v5czI~
		i2=uatoin(Pdata+3,2);                                      //~v5czI~
		i3=0;                                                      //~v5czI~
    	break;                                                     //~v5czI~
    case 6:           //"yymmdd"                                   //~v5czI~
		if (unumlen(Pdata  ,0,6)!=6)                               //~v5czI~
	    	return 4;                                              //~v5czI~
		i1=uatoin(Pdata,  2);                                      //~v5czI~
		i2=uatoin(Pdata+2,2);                                      //~v5czI~
		i3=uatoin(Pdata+4,2);                                      //~v5czI~
    	break;                                                     //~v5czI~
    case 8:           //"yy:mm:dd"                                 //~v5czI~
		if (unumlen(Pdata  ,0,2)!=2                                //~v5czI~
    	||  unumlen(Pdata+3,0,2)!=2                                //~v5czI~
    	||  unumlen(Pdata+6,0,2)!=2)                               //~v5czI~
    		return 4;                                              //~v5czI~
		i1=uatoin(Pdata,  2);                                      //~v5czI~
		i2=uatoin(Pdata+3,2);                                      //~v5czI~
		i3=uatoin(Pdata+6,2);                                      //~v5czI~
    	break;                                                     //~v5czI~
	default:                                                       //~v5czI~
    	return 4;                                                  //~v5czI~
	}                                                              //~v5czI~
	*Ppi1=i1;                                                      //~v5czI~
	*Ppi2=i2;                                                      //~v5czI~
	*Ppi3=i3;                                                      //~v5czI~
    return 0;                                                      //~v5czI~
}//getftnum                                                        //~v5czI~
//**********************************************************************//~v5czI~
//* generate FDATE                                                 //~v5czI~
//*parm1:output ULONG(FDATE/FTIME) addr                            //~v5czI~
//*parm2:yy                                                        //~v5czI~
//*parm3:mm                                                        //~v5czI~
//*parm4:dd                                                        //~v5czI~
//*return:rc;                                                      //~v5czI~
//**********************************************************************//~v5czI~
int ueditsetfdate(int Pyy,int Pmm,int Pdd,void /*FDATE*/ *Ppfdate) //~v5czR~
{                                                                  //~v5czI~
    FDATE fdt,*pfdt;                                               //~v5czR~
    int rc=0;                                                      //~v5czI~
//**************                                                   //~v5czI~
    if (Pyy<80)                                                    //~v5czI~
        fdt.year =2000-1980+Pyy;                                   //~v5czI~
    else                                                           //~v5czI~
        fdt.year =Pyy-80;                                          //~v5czI~
    if (Pmm>=1 && Pmm<=12)                                         //~v5czI~
    	fdt.month=Pmm;                                             //~v5czI~
    else                                                           //~v5czI~
    	rc=4;                                                      //~v5czI~
    if (Pdd>=1 && Pdd<=31)                                         //~v5czI~
    	fdt.day  =Pdd;                                             //~v5czI~
    else                                                           //~v5czI~
    	rc=4;                                                      //~v5czI~
    pfdt=(FDATE*)(ULONG)Ppfdate;                                   //~v5czI~
    *pfdt=fdt;                                                     //~v5czI~
    return rc;                                                     //~v5czI~
}//ueditsetfdate                                                   //~v5czI~
//**********************************************************************//~v5czI~
//* generate FTIME                                                 //~v5czI~
//*parm1:output ULONG(FDATE/FTIME) addr                            //~v5czI~
//*parm2:yy                                                        //~v5czI~
//*parm3:mm                                                        //~v5czI~
//*parm4:dd                                                        //~v5czI~
//*return:rc;                                                      //~v5czI~
//**********************************************************************//~v5czI~
int ueditsetftime(int Phh,int Pmm,int Pss,void /*FTIME*/ *Ppftime) //~v5czR~
{                                                                  //~v5czI~
    FTIME ftm,*pftm;                                               //~v5czR~
    int rc=0;                                                      //~v5czI~
//**************                                                   //~v5czI~
    if (Phh>=0 && Phh<=23)                                         //~v5czI~
        ftm.hours  =Phh;                                           //~v5czI~
    else                                                           //~v5czI~
    	rc=4;                                                      //~v5czI~
    if (Pmm>=0 && Pmm<=59)                                         //~v5czI~
        ftm.minutes=Pmm;                                           //~v5czI~
    else                                                           //~v5czI~
    	rc=4;                                                      //~v5czI~
    if (Pss>=0 && Pss<=59)                                         //~v5czI~
        ftm.twosecs=Pss/2;                                         //~v5czI~
    else                                                           //~v5czI~
    	rc=4;                                                      //~v5czI~
    pftm=(FTIME*)(ULONG)Ppftime;                                   //~v5czR~
    *pftm=ftm;                                                     //~v5czI~
    return rc;                                                     //~v5czI~
}//ueditsetftime                                                   //~v5czI~
