//*CID://+v5jdR~:                             update#=   20;       //~v5jdR~
//******************************************************
//*uerr.h
//******************************************************
//v5jd:061002 3270 support:rename/delete                           //~v5jdI~
//v5j3:060912 add uerrapi1tx etc(display error description)        //~v5j3I~
//v5iy:060908 (WIN)add ugetlasterrmsg                              //~v5iyI~
//v5ix:060908 add uconfirmmsg from xfs                             //~v5ixI~
//v5iw:060907 uerrmsg timestamp display option                     //~v5iwI~
//v5i8:060601 (LNX:FC5)errmsg by utf8(accordingly for gxe "g_locale_to_utf8" do no conversion,//~v5i8I~
//             for xe utf8 msg processed by gnome-terminal)        //~v5i8I~
//v5c2:040322 (WXE)uerr is accessed from WXE                       //~v5c2I~
//v5bz:040314 set force_english option to gbl for wxe help msg     //~v5bzI~
//v570:020824 wxe support                                          //~v570I~
//v55a:020427 (UNX:BUG)mdoscmd clear errmsg by ugeterrmsg;save and restore//~v55aI~
//v50u:010421 EUC japanese errmsg under kon                        //~v50uI~
//v324 000813:LINUX support(CRLF)                                  //~v324I~
//v293:991031 no beep option support                               //~v293I~
//v200:981025 uerrmsgcat:strcat to previous errmsg if prev is short enough//~v200I~
//v191:980831 bell option for uerrexit(uerrexit_optinit)           //~v191R~
//v182:980607 uerrmsg2:msg if no prev msg pending                  //~v182I~
//            ugeterrmsg2:msg get but not clear                    //~v182I~
//v062:970210:external err msg out control                         //~v062I~
//v060:970201:function:uerrhelpmsg:for help,wait key enter to continue//~v060I~
//           :function:uerrscrheight:get max row                   //~v060I~
//           :function:uerrmsgedit:uerrmsg but no output to any    //~v060I~
//           :control dbcs flag by external symbol for test use    //~v060I~
//v040:961027:uerrapi0,uerrapi0x(errmsg with no parm)              //~v040I~
//v022:960727:WIN32(CONSOLE api)                                   //~v022I~
//******************************************************           //~v022I~
#define MAX_UERRMSGLL  4096                                        //~v5j3I~
                                                                   //~v5j3I~
#define GBL_UERR_BG			0x01		//*back ground exec        //~v060R~
#define GBL_UERR_DBCSSET  	0x02		//*determined              //~v060I~
#define GBL_UERR_DBCSMODE   0x04		//*DBCS mode               //~v060I~
#define GBL_UERR_NOMSGOUT   0x08		//*uerrmsg:edit only,no output to any//~v062R~
#define GBL_UERR_NOMSGOUTSV 0x80		//*uerrmsg:edit only,no output to any//~v062I~
#define GBL_UERR_SJIS2EUC   0x40        //sjis to euc conversion required//~v50uI~
#define GBL_UERR_FORCEENG   0x20        //force english option     //~v5bzI~
#define GBL_UERR_SJIS2UTF8  0x10        //sjis 2 utf8 conversion   //~v5i8I~
#ifdef GBL_UERR                                                    //~v060I~
    unsigned char Guerropt;                                        //~v060I~
#else                                                              //~v060I~
    extern unsigned char Guerropt;                                 //~v060I~
#endif                                                             //~v060I~
#define UERRSETSNOMSG() ( Guerropt=(char)((Guerropt&~GBL_UERR_NOMSGOUTSV) \
           |((Guerropt&GBL_UERR_NOMSGOUT)<<4)|GBL_UERR_NOMSGOUT) ) //~v062I~
#define UERRBACKNOMSG() ( Guerropt=(char)((Guerropt&~GBL_UERR_NOMSGOUT) \
           |((Guerropt&GBL_UERR_NOMSGOUTSV)>>4)) )                 //~v062R~
//******************************************************           //~v060I~
typedef void (UEXITFUNC)(char *,void *);    //edit msg and exit parm of uerrexit_init//~v062R~
#ifdef __cplusplus                                                 //~v5c2I~
	extern "C" {                                                   //~v5c2I~
#endif                                                             //~v5c2I~
//*******************************************************          //~v293I~
int ubell_init(int Popt);                                          //~v293R~
//*******************************************************          //~v297I~
void ubell_init2(int *Pkbdinpctr);                                 //~v297I~
//*******************************************************
void ubell(void);
//******************************************************
//   uerrexit(English msg,Japanese msg,... )
void uerrexit(char *     ,char *      ,... );
//   uerrexit_init(title ,output handle,exit function,exit func parm);
void uerrexit_init(char *Ptitle,FILE *Poutput,char *Pmapfile,UEXITFUNC *Pexitfunc,void *Pexitparm);
//******************************************************           //~v191I~
void uerrexit_optinit(int Popt);                                   //~v191R~
#define UERREXIT_BELL     	0x01                                   //~v191R~
//******************************************************
//    uerrmsg(English msg,Japanese msg,... )
char *uerrmsg(char *     ,char *      ,... );
//******************************************************           //~v182I~
char *uerrmsg2(char *Pemsg ,char *Pjmsg,... );                     //~v182I~
//******************************************************           //~v570I~
char *uerrmsgedit(char *Ptitle,char *Pemsg ,char *Pjmsg,unsigned long *Pparg);//~v570I~
//******************************************************           //~v060I~
char *uerrsprintf(char *Pemsg ,char *Pjmsg,... );                  //~v060I~
//******************************************************           //~v060I~
char *uerrhelpmsg(FILE *Poutf,FILE *Pqueryf,char *Pemsg ,char *Pjmsg,... );//~v060I~
//**********************************************************************//~v060I~
int uerrscrheight(void);                                           //~v060I~
//******************************************************        //~5B11I~
void uerrmsg_init(char *Ptitle,FILE *Poutput,int Popt);         //~5B11R~
#define  UERR_OPTION    		0xff00                          //~5B11R~
#define  UERR_ATTR		    	0x00ff                          //~5B11I~
#define  UERR_FORCE_ENGLISH  	0x0100                          //~5B11I~
#define  UERR_TIMESTAMP      	0x0200                             //~v5iwI~
//******************************************************           //~v55aI~
char *useterrmsg(char *Perrmsg);                                   //~v55aI~
//******************************************************
char *ugeterrmsg(void);
//******************************************************           //~v182I~
char *ugeterrmsg2(void);                                           //~v182I~
//******************************************************           //~v200I~
char *uerrmsgcat(char *Pemsg ,char *Pjmsg,... );                   //~v200R~
//******************************************************           //~v5ixI~
char uconfirmmsg(char *Pmsge,char *Pmsgj,char *Preply);            //~v5ixR~
//******************************************************           //~v5iyM~
char *uerrornomsg(int Perrorno);                                   //~v5iyI~
//******************************************************           //~v5iyI~
#ifdef W32                                                         //~v5iyI~
	char *ugetlasterror(int *Pprc);                                //~v5iyR~
#endif                                                             //~v5iyI~
//**************************************************************** //~v5j3I~
char *ugeterrdescription(int Pgetlasterrsw,int *Pprc);             //~v5j3R~
//****************************************************************//~5A10I~
int uerrapi1(char  *Papiname,char  *Pparm1,int Papirc);         //~5A10R~
//**************************************************************** //~v022R~
void uerrapi1x(char  *Papiname,char  *Pparm1,int Papirc);          //~v022R~
//**************************************************************** //~v040I~
int uerrapi0(char  *Papiname,int Papirc);                          //~v040I~
//**************************************************************** //~v040I~
void uerrapi0x(char  *Papiname,int Papirc);                        //~v040I~
//**************************************************************** //~v5j3I~
int uerrapi1t(int Pgetlasterrsw,char  *Papiname,char  *Pparm1,int Papirc);//~v5j3R~
//**************************************************************** //~v5j3I~
void uerrapi1tx(int Pgetlasterrsw,char  *Papiname,char  *Pparm1,int Papirc);//~v5j3I~
//**************************************************************** //~v5j3I~
int uerrapi0t(int Pgetlasterrsw,char  *Papiname,int Papirc);       //~v5j3I~
//**************************************************************** //~v5j3I~
void uerrapi0tx(int Pgetlasterrsw,char  *Papiname,int Papirc);     //~v5j3I~
//**************************************************************** //~v5jdI~
int uerrnotsupported(char *Pcmd,char *Pcond,int Prc);              //+v5jdR~
//**************************************************************** //~v5j3I~
#ifdef __cplusplus                                                 //~v5c2I~
	}                                                              //~v5c2I~
#endif                                                             //~v5c2I~
