//*CID://+v5b0R~:                             update#=    9;       //~v5b0R~
//******************************************************        //~5B11I~
//*ufile4.h                                                        //~v050R~
//******************************************************        //~5B11I~
//v5i0:060419 add ufileisntfs                                      //+v5b0I~
//v5b0:040115 (LNX:BUG)mkstmp is for file only,mkdtmp is required for temp dir//~v5b0I~
//v578:021207 udirlist performance tuning(stat call on the current dir)//~v578I~
//v56A:020809 (BUG)S-link loop chk;for the case slinked to looped path(over update#0)//~v56AR~
//v56t:020712 (UNX)udirwalk slink skip option                      //~v56tI~
//v56m:020711 udirwalk;option to skip dir by rc=-5 from user func  //~v56mI~
//v528:020217 option to apply mask 1st level only for xds          //~v528I~
//v424:010101 TLinux:f_fsid is not type name but fld name          //~v424I~
//v348:000926 LINUX support(ugetdiskfree now returns file system id additionaly)//~v348I~
//v327 000820:LINUX support                                        //~v327I~
//v202:981101 udirwalk:end of list call support for uds(dir size calc)//~v202I~
//v120:971116 (BUG:GCC)when env var LFN changed N to Y,it is needed to force//~v120I~
//                     call _get_volume_info at _use_lfn.          //~v120I~
//                     new option to ufileisvfat                   //~v120I~
//v101:971009 long filename                                        //~v101I~
//            ufile4.c/h:add ufileishpfs(return file system id)    //~v101I~
//                       ufilevfat for DOS/W95                     //~v101I~
//v083:970508 add ugetdiskfree                                     //~v083I~
//v063:970210:udirwalk function add                                //~v063I~
//v050:961201:add utempnam                                         //~v050I~
//**************************************************************** //~v083I~
typedef  struct _UDISKINFO {                                       //~v083R~
        unsigned total_clusters;                                   //~v083R~
        unsigned avail_clusters;                                   //~v083I~
        unsigned sectors_per_cluster;                              //~v083I~
        unsigned bytes_per_sector;                                 //~v083I~
#ifdef UNX                                                         //~v348I~
//      f_fsid   filesystemid;                                     //~v424R~
        fsid_t   filesystemid;                                     //~v424I~
#endif                                                             //~v348I~
        } UDISKINFO;                                               //~v083R~
//**************************************************************** //~v050I~
char *utempnam(char *Pdir,char *Pprefix,char *Ptempfile);          //~v050I~
//**************************************************************** //~v5b0I~
char *utempnamd(char *Pdir,char *Pprefix,char *Ptempfile);         //~v5b0I~
//**************************************************************** //~v050I~
long  ufgetpos(FILE *Pfh);                                         //~v050R~
//**********************************************************************//~v063I~
int  udirwalk(int Popt,char *Pstartdir,char *Pdirmask,char *Pfilemask,//~v063I~
                int Pattrmask,int Pstopdepth,                      //~v063I~
               int (*Pfunc)(char *Pdir,char *Pfullpath,UDIRLIST *Pudirlist,//~v063I~
                            int Pdepth,void *Pdata,int *Papplrc),  //~v063I~
               void *Pfuncdata,int *Prc);                          //~v063I~
//*                                                                //~v063I~
#define UDIRWALK_FILECALL       0x0100                             //~v063I~
#define UDIRWALK_DIRCALL        0x0200                             //~v063I~
#define UDIRWALK_NOMSG          0x0400  //no err msg               //~v063I~
#define UDIRWALK_EMPTYCALL      0x0800  //call if empty even if file call only//~v063I~
#define UDIRWALK_SORT_REV       0x1000  //reverse sort sw          //~v063I~
#define UDIRWALK_CD             0x2000  //change dir               //~v063I~
#define UDIRWALK_EOLCALL        0x4000  //end of list entry req    //~v202I~
#define UDIRWALK_TOPMASK        0x8000  //apply mask to top level only//~v528I~
#ifdef UNX                                                         //~v56tI~
#define UDIRWALK_SKIPSLINK    0x010000  //skip slink               //~v56tI~
#define UDIRWALK_TEMPCD       0x020000  //cd for udirlist performance up//~v578I~
#endif                                                             //~v56tI~
                                                                   //~v56tI~
#define UDIRWALK_SORT_MASK      0x00ff  //sort order mask          //~v063I~
#define UDIRWALK_SORT_NAME         'N'  //name seq                 //~v063I~
#define UDIRWALK_SORT_EXT          'E'  //extention                //~v063I~
#define UDIRWALK_SORT_DATE         'D'  //time stamp               //~v063I~
#define UDIRWALK_RC_EMPTY   1   //no matching file                 //~v063I~
#define UDIRWALK_RC_NAME    4   //dir name err                     //~v063I~
#define UDIRWALK_RC_NOTF    8   //not found                        //~v063I~
#define UDIRWALK_RC_NOTDIR 12   //not dir                          //~v063I~
                                                                   //~v56mI~
#define UDIRWALK_URC_SKIPDIR  -2 //user requested skip this dir    //~v56mI~
//*                                                                //~v063I~
//*******************************************************          //~v083I~
#ifdef UNX                                                         //~v327I~
int ufileslinkchk(char *Pdir,char *Pmember,char *Pslink);          //~v56AR~
unsigned int ugetdiskfree(char *Pfname,UDISKINFO *Pudiskinfo);     //~v327I~
#else                                                              //~v327I~
unsigned int ugetdiskfree(char Pdletter,UDISKINFO *Pudiskinfo);    //~v083R~
#endif                                                             //~v327I~
                                                                   //~v101I~
#ifdef OS2                                                         //~v101I~
//*******************************************************          //~v101I~
int ufileishpfs(char Pdletter);                                    //~v101R~
#else                                                              //~v101I~
//*******************************************************          //~v101I~
int ufileisvfat(int Popt);                                         //~v120R~
#define ISVFAT_ERRMSG   0x01    //errmsg if not vfat               //~v120I~
#define ISVFAT_FORCE    0x02    //force get_volume_info to _use_lfn//~v120I~
#endif                                                             //~v101I~
                                                                   //+v5b0I~
int ufileisntfs(int Pdriveletter);                                 //+v5b0I~
