//*CID://+v5jtR~:                             update#=   52;       //~v5jtR~
//*************************************************************
//*ufile5.c                                                        //~v205R~
//*  ufgets,ufgetsinit udoseditname ufileeditname                  //~v340R~
//*************************************************************
//v5jt:061113 (3270)new filecomapre option;binary null append allows//~v5jtI~
//v5js:061111 (3270)new filecomapre option;text mode and ignore trailing space//~v5jsI~
//v5jd:061002 3270 support:rename/delete                           //~v5jdI~
//v5j8:060915 add ufile6.c ufilecomp for 3270 update chk           //~v5j8I~
//v5fk:050226 (BUG)unumlen abend by overrun end of string          //~v5fkI~
//v5cr:040509 (FTP:BUG)no consideration for wildcard rename edit   //~v5crI~
//v577:021202 binfilechk:set weight 30 for null char               //~v577R~
//v56y:020807 (BUG)add ufilewildcomp func;wildcomp DBCS support    //~v56yI~
//v56x:020805 (BUG)editfilename DBCS support                       //~v56xI~
//v55h:020429 (UNX:BUG)wildcard conversion err for mdos disk       //~v55hI~
//v552:020413 mac eol(0x0d) support                                //~v552I~
//v50U:010930 udoseditnameopt used for xdc even if not unix        //~v50UI~
//v50b:010324 LINUX:ajust after merge                              //~v50bI~
//v39h:001125 LINUX support:EOFID is one of data                   //~v39hI~
//v388:001009 LINUX support(option of unox like wildcard process   //~v388I~
//            (no special meaning of "." as seperator))            //~v388I~
//v340:000923 (BUG) udoseditname "a" and "*.*" -->"a."; "a" is good//~v327I~
//            ufile5.c                                             //~v327I~
//v327 000820:LINUX support                                        //~v327I~
//v296:991112 add to bin file determination chk logic              //~v296I~
//            (chk up to 1024 byte;if no LF it is bin;dbcs chk;rate change 50->30)//~v296I~
//v290:991024 (BUG)doseditname x.c by aa* result to aac.it should be aa.c//~v290I~
//v279:990813 ufileeditname:udoseditname interface by fullpath parm//~v279I~
//v272:990718 add udoseditname:conv filename by wild card patern   //~v272I~
//v240:990509 >=0xfd is also one of binary data to chk binary file //~v240I~
//v237:990502 record split width support for optbin case           //~v237I~
//v205:981213 add option to ufgets;ignore crlf,chk bin by first block//~v205I~
//v114:971104 option for ugetvfatalias                             //~v114I~
//v110:971103 (GCC)for wild card,chk max len                       //~v110I~
//v105:971026 (GCC)lfn support                                     //~v105I~
//           -use int21 ah=60/7160 for ugetvfatshortname           //~v105I~
//v103:971017 W95 and GCC;ugetalias                                //~v103I~
//v095:970712 maint current pos for ufgets                         //~v095I~
//v090:970629 add ufgets function(pc/unix both support,0x1a chk support)
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>

//*******************************************************
#ifdef DOS
    #ifdef DPMI
                #include <dos.h>                                           //~v105I~
    #endif
#else
        #ifdef W32
			#include <io.h>                                        //~v5j8I~
        #include <windows.h>         //GetShortPathName            //~v103I~
        #else
        #endif
#endif

//*******************************************************
#include <ulib.h>
#include <uque.h>                                                  //~v5crI~
#include <ufile.h>
#include <ufile4.h>       //ufileisvfat                            //~v105I~
#include <ufile5.h>
#include <ufemsg.h>                                                //~v103I~
#include <ualloc.h>
#include <uerr.h>
#include <utrace.h>
#include <ustring.h>                                               //~v110I~
#include <udbcschk.h>                                              //~v114I~
#ifdef DPMI                                                        //~v105I~
        #include <udpmisub.h>       //ufileisvfat                      //~v105I~
#endif                                                             //~v105I~
#ifdef FTPSUPP                                                     //~v5crI~
        #include <uftp.h>                                          //~v5crI~
        #include <u3270.h>                                         //~v5jdI~
#endif                                                             //~v5crI~
//**********************************************************************
#define IOBSZ           4096
#define LFID            0x0a
#define CRID            0x0d
#define EOFID           0x1a
                                                                   //~v205I~
//#define DEFBINRATE      50    //default binary chk rate          //~v296R~
#define DEFBINRATE      30    //default binary chk rate            //~v296I~
#define NULLWEIGHT      30    //default weight of null char        //~v577I~
//**********************************************************************
static UINT Sreadreslen;                //residual len to be move to caller buff
static int  Ssubeofsw;                  //sub eofsw
static int  Seofsw;                             //main eofsw
static UINT Siobreslen;                 //iobuff res data len
static int  Slastbytesw;        //pass to next call sw
static UINT Scurpos;            //returned total length(contain eol)//~v095I~

static int   Smode;               //PC/UNIX type
static int   Sbinrate;            //binary file determination rate //~v205I~
static int   Soptbinwidth;        //when determind binary,use as record width//~v237I~
static int   Sbinsw;             //binary more                     //~v205I~
static UINT  Siobsz=0;              //fread buff size              //~v56yR~
static UCHAR *Siob=0;             //fread buff size                //~v56yR~
static UCHAR *Siobpos;          //fread buff size
static UCHAR *Sreadpos;         //next move data pos on a read line
#ifdef DPMI                                                        //~v105I~
static int   Sdoserr;           //rc of udpmiintdos                //~v105I~
#endif                                                             //~v105I~
                                                                   //~v388I~
//#ifdef UNX                                                       //~v50UR~
//static int   Sdenopt;           //udoseditname option            //~v56xR~
//#endif //UNX                                                     //~v50UR~
//*******************************************************
int ufgetssub(FILE *Pfh,unsigned char **Pdatapos,unsigned int *Pdatalen,int *Peolid);
int ufilefnameconv(char *Plongname,char *Pshortname,int Plen,int Popt);//~v114I~
UCHAR *ufilewildcompsub(int Popt,int Pcomplen,                     //~v56yI~
					UCHAR *Pin,UCHAR *Ppat,UCHAR *Pdbcsi,UCHAR *Pdbcsp);//~v56yM~
int ufilecomptextmode(int Popt,char *Pfnm1,char *Pfnm2,char *Pbuff);//~v5jsI~
//*******************************************************
//*dummy for lib(same name as file)                                             *
//*******************************************************
void ufile5(void)
{
        return;
}

//*******************************************************
//*ufgetsinit
//*   init ufgets
//*parm 1:mode 1:PC file(0d0a)=default,2:unix file(0a),3:both is eol
//*            x10:binary,x20:optionary binary,x80:term req        //~v205R~
//*parm 2:fread buff size(if 0 use default)
//*parm 3:binary file determination rate at first block            //~v205I~
//*parm 4:binary file record width used when binary for opt-bin case//~v237I~
//*ret   :0:ok,0x1001:malloc failed
//*******************************************************
int ufgetsinit(int Pmode,unsigned int Pbuffsz,int Pbinrate,int Poptbinwidth)//~v237R~
{
//*****************
    if (Pmode & UFGETS_TERM)                                       //~v090R~
    {                                                              //~v090I~
        if (Siob)                                                  //~v090I~
        {                                                          //~v090I~
                ufree(Siob);                                           //~v090I~
            Siob=0;                                                //~v090I~
        }                                                          //~v090I~
        return 0;                                                  //~v090I~
    }                                                              //~v090I~
        Smode=Pmode;                                                   //~v090M~
        Sbinrate=0;                                                //~v205I~
        Soptbinwidth=0;                                            //~v237I~
        if (Smode & UFGETS_OPTBIN)                                 //~v205I~
        {                                                          //~v205I~
            Sbinrate=Pbinrate;                                     //~v205R~
            if (!Sbinrate)                                         //~v205I~
                Sbinrate=DEFBINRATE;                               //~v205I~
            Soptbinwidth=Poptbinwidth;                             //~v237I~
        }                                                          //~v205I~
        if (Smode & UFGETS_BIN)                                    //~v205I~
            Sbinsw=1;                                              //~v205I~
        else                                                       //~v205I~
            Sbinsw=0;                                              //~v205I~
  if (!(Smode & UFGETS_MAC))            //not mac eol specified,use default as mix//~v552I~
    if (!(Smode & (UFGETS_PC|UFGETS_UNIX)))
        Smode|=(UFGETS_PC | UFGETS_UNIX);                          //~v090R~
    if (!Pbuffsz)
        Pbuffsz=IOBSZ;
    if (Pbuffsz!=Siobsz)                                           //~v090R~
    {                                                              //~v090I~
        if (Siob)
        {
                ufree(Siob);
            Siob=0;
        }
        Siobsz=Pbuffsz;                                            //~v090R~
        Siob=UALLOCM(Siobsz);                                      //~v090R~
        UALLOCCHK(Siob,UALLOC_FAILED);                             //~v090R~
    }                                                              //~v090I~
//*
        Seofsw=0;
        Ssubeofsw=0;
        Siobreslen=0;
        Slastbytesw=0;
        Sreadreslen=0;
        Scurpos=0;              //current pos                          //~v095I~
    return 0;
}//ufgetsinit

//*******************************************************          //~v095I~
//*ufgetscurpos                                                    //~v095I~
//*   get current position(returned total length)                  //~v095I~
//*ret   :total length                                             //~v095I~
//*******************************************************          //~v095I~
unsigned int ufgetscurpos(void)                                    //~v095I~
{                                                                  //~v095I~
        return Scurpos;                                                //~v095I~
}//ufgetscurpos                                                    //~v095I~
                                                                   //~v095I~
//*******************************************************
//*ufgets
//*     read a line binary mode and drop eol/eof sign
//*parm 1:buff
//*parm 2:buffsz(UINT)
//*parm 3:fh(must be opened by "rb")
//*parm 4:&read len(UINT)
//*parm 5:optional &eol tyep                                       //~v090R~
//          0:no eol data,1:0x0a,2:0d0a,4:0d(Mac) when rc==0       //~v552R~
//*         0                            when rc==more/err         //~v095R~
//*         0:no 0x1a,1:0x1a             when rc==eof              //~v090R~
//*ret   :-1:io err,1:eof ,4:more data ,                           //~v205R~
//*        2:for OPTBIN only;determind to binary by optbin req     //~v205I~
//*******************************************************
int ufgets(char *Pbuff,unsigned int Pbuffsz,FILE *Pfh,
           unsigned int *Preadlen,int *Peolid)
{
static int Seolid;                                                 //~v090R~
static int Ssubrc=0;                                               //~v56yR~
    char *buffpos;
    int  rc,eolid;                                                 //~v090R~
    UINT buffreslen,copylen;
//*******************
        buffpos=Pbuff;
    buffreslen=Pbuffsz;
    for (;;)
    {
        if (Sreadreslen)                                           //~v090R~
                rc=Ssubrc;                              //restore previos sub rc       //~v090I~
        else                                                       //~v090I~
        {
            if (Seofsw)
                rc=UFGETS_EOF;
            else
            {
                rc=Ssubrc=ufgetssub(Pfh,&Sreadpos,&Sreadreslen,&Seolid);//~v090R~
                if (rc==UFGETS_ERR)
                        break;
                if (rc==UFGETS_EOF)
                        Seofsw=1;
                if (Sbinsw==2)  //binary of optbin case;RCBIN      //~v237I~
                    if (Soptbinwidth)   //opt bin width specified  //~v237I~
                        buffreslen=Pbuffsz=(UINT)Soptbinwidth;  //shorted read size//~v237R~
            }
        }
        copylen=min(Sreadreslen,buffreslen);
        memcpy(buffpos,Sreadpos,copylen);
        Sreadpos+=copylen;
        Sreadreslen-=copylen;
        buffpos+=copylen;
        buffreslen-=copylen;
        if (!buffreslen && Sreadreslen)
        {
                rc=UFGETS_MORE;
            break;
        }
        if (!rc || rc==UFGETS_EOF)                      //a line moved
                break;
    }
    *Preadlen=Pbuffsz-buffreslen;
        eolid=Seolid;                                                  //~v090R~
  if (rc==UFGETS_MORE)                                             //~v095I~
  {                                                                //~v205I~
    eolid=0;                                                       //~v095I~
    if (Sbinsw)     //ufgets always return more if bin mode        //~v205I~
    {                                                              //~v205I~
        if (Sbinsw==2)                                             //~v205M~
        {                                                          //~v205M~
            Sbinsw=1;       //only 1st time                        //~v205M~
            rc=UFGETS_RCBIN;//notify determind binary              //~v205I~
        }                                                          //~v205M~
        else                                                       //~v205I~
            rc=0;           //split record                         //~v205I~
    }                                                              //~v205I~
  }                                                                //~v205I~
  else                                                             //~v095I~
    if (rc==UFGETS_EOF)
        if (*Preadlen)
        {
            if (Sbinsw==2)                                         //~v205I~
            {                                                      //~v205I~
                Sbinsw=1;       //only 1st time                    //~v205I~
                rc=UFGETS_RCBIN;//notify determind binary          //~v205I~
            }                                                      //~v205I~
            else                                                   //~v205I~
                rc=0;
            eolid=0;                                               //~v090R~
        }
    if (Peolid)                                                    //~v090I~
            *Peolid=eolid;                                             //~v090I~
    Scurpos+=(*Preadlen+eolid); //last position                    //~v095I~
    return rc;
}//ufgets

//*******************************************************
//*ufgetssub
//*  read binary mode and process 0d,0d0a,1a
//*parm 1:fh(must be opened by "rb")
//*parm 2:&read data ptr on io buff
//*parm 3:&read len(UINT)
//*parm 4:&eol tyep(0:no eol data,1:0x0a,2:0d0a 4:0d when rc==0    //~v552R~
//*                 0                            when rc==more/err //~v095R~
//*                 0:no 0x1a,1:0x1a             when rc==eof
//*ret   :-1:io err,1:eof 4:more data,                             //~v205R~
//*                 for bin mode always return more                //~v205I~
//*******************************************************
int ufgetssub(FILE *Pfh,unsigned char **Pdatapos,unsigned int *Pdatalen,int *Peolid)//~v090R~
{
static UCHAR Slastbyte=0;                                          //~v56yR~
        UINT readlen,datalen;
    int rc;
    char *pc;
//*******************
        *Peolid=0;                              //for more/err case                    //~v095I~
    if (!Siobreslen)        //no data on fread buff
    {
        *Siob=Slastbyte;
        if (Ssubeofsw)
            readlen=0;
        else
        {
            readlen=fread(Siob+Slastbytesw,1,(UINT)(Siobsz-Slastbytesw),Pfh);
            if (readlen!=Siobsz-Slastbytesw)    //err or eof
            {
                if (ferror(Pfh))
                        return UFGETS_ERR;
                Ssubeofsw=1;
            }
            if (Sbinrate)   //OPTBIN first time                    //~v205R~
            {                                                      //~v205I~
                if (ufgetsbinchk(Siob,readlen,Sbinrate))//bynary   //~v205R~
                    Sbinsw=2;   //bin mode by chk                  //~v205R~
                Sbinrate=0;     //1st time only                    //~v205I~
            }//bin chk required                                    //~v205I~
        }
        Siobreslen=(UINT)(readlen+Slastbytesw);
        Siobpos=Siob;
        Slastbytesw=0;
    }
//*
  if (Sbinsw)       //bynary mode                                  //~v205R~
  {                                                                //~v205I~
    rc=UFGETS_MORE;              //req re-call                     //~v205I~
    Slastbyte=0;                    //except 0d or 1a              //~v205I~
    datalen=Siobreslen;                                            //~v205I~
    Siobreslen=0;                           //next is fread        //~v205I~
    *Pdatapos=Siobpos;                      //path all data        //~v205I~
    if (Ssubeofsw)                                  //eof reached  //~v205I~
        rc=UFGETS_EOF;          //ufgets return eof only when readlen=0//~v205I~
  }                                                                //~v205I~
  else                                                             //~v205I~
  {                                                                //~v205I~
//*text mode                                                       //~v205R~
   if (Smode & UFGETS_MAC) //cr only                               //~v552I~
   {                                                               //~v552I~
    	pc=memchr(Siobpos,CRID,Siobreslen);                        //~v552I~
        *Pdatapos=Siobpos;                      //path all data    //~v552I~
    	if (!pc)                    //no cr                        //~v552I~
    	{                                                          //~v552I~
        	rc=UFGETS_MORE;              //req re-call             //~v552I~
            datalen=Siobreslen;                                    //~v552I~
            Siobreslen=0;                           //next is fread//~v552I~
        	if (Ssubeofsw)                                  //eof reached//~v552I~
            	rc=UFGETS_EOF;                                     //~v552I~
    	}//cr not found                                            //~v552I~
    	else    //cr found                                         //~v552I~
    	{                                                          //~v552I~
        	rc=0;                                                  //~v552I~
        	*Peolid=4;   		//cr:mac type                      //~v552I~
        	datalen=(ULONG)pc-(ULONG)Siobpos;                      //~v552I~
            Siobreslen-=(datalen+1);                               //~v552I~
        	Siobpos=pc+1;                                          //~v552I~
    	}//cr found                                                //~v552I~
   }//mac eol process                                              //~v552I~
   else                                                            //~v552I~
   {//nor mac(!0d)                                                 //~v552I~
    pc=memchr(Siobpos,LFID,Siobreslen);
        *Pdatapos=Siobpos;                      //path all data
    if (!pc)                    //no lf
    {
        rc=UFGETS_MORE;              //req re-call
        if (Siobreslen)
            Slastbyte=*(Siobpos+Siobreslen-1);      //to chk last byte
        else
            Slastbyte=0;                    //except 0d or 1a
                datalen=Siobreslen;
                Siobreslen=0;                           //next is fread
        if (Ssubeofsw)                                  //eof reached
        {
            rc=UFGETS_EOF;
#ifdef UNX            //no EOFID process,return 0x1a as data       //~v39hI~
#else  //!UNX                                                      //~v39hI~
            if (Slastbyte==EOFID)
            {
                        datalen--;                      //chk last byte at next call
                *Peolid=1;
            }
//          else                                                   //~v095R~
//              *Peolid=0;                              //no  crlf                 //~v095R~
#endif //!UNX                                                      //~v39hI~
        }
        else                    //not eof
            if (Slastbyte==CRID || Slastbyte==EOFID)
            {
                        datalen--;                      //chk last byte at next call
                        Slastbytesw=1;
            }
    }//lf not found
    else    //lf found
    {
        rc=0;
        *Peolid=1;
        datalen=(ULONG)pc-(ULONG)Siobpos;
                Siobreslen-=(datalen+1);
        Siobpos=pc+1;
        if (datalen && *(pc-1)==CRID)   //cr+lf
        {
            if (Smode & UFGETS_PC)
            {
                datalen--;
                *Peolid=2;
            }
        }
        else                                                            //lf only
            if (!(Smode & UFGETS_UNIX)) //cf+lf only
            {
                datalen++;
                rc=UFGETS_MORE;
                        *Peolid=0;              //no eol                           //~v095I~
            }
    }
   }//not mac(!0d)                                                 //~v552I~
  }                                                                //~v205I~
        *Pdatalen=datalen;
    return rc;
}//ufgetssub
                                                                   //~v205I~
//*******************************************************          //~v205I~
//*chk binary file                                                 //~v205R~
//* bin if 50 char <x20 except x0d,x0a exist in the range specified len//~v205I~
//* (len max is 100 char)                                          //~v205I~
//*parm1 :io area                                                  //~v205I~
//*parm2 :io area len                                              //~v205I~
//*parm3 :rate                                                     //~v205I~
//*return:1:bin,0:txt                                              //~v205I~
//*******************************************************          //~v205I~
int ufgetsbinchk(UCHAR *Pbuff,UINT Plen,int Prate)                 //~v205I~
{                                                                  //~v205I~
    int  ctlctr;                                                   //~v205R~
    int  nullctr=0;                                                //~v577I~
    UINT len,ch;                                                   //~v205I~
    UCHAR *pc,*pce;                                                //~v205R~
//***************************                                      //~v205I~
//  len=min(100,Plen);                                             //~v296R~
    len=min(1024,Plen);                                            //~v296I~
    if (!memchr(Pbuff,'\n',len))                                   //~v296R~
        if (Plen>=1024) //Plen>=1024                               //~v296I~
            return 1;                                              //~v296R~
    ctlctr=0;                                                      //~v205I~
    for (pc=Pbuff,pce=Pbuff+len;pc<pce;pc++)                       //~v205R~
    {                                                              //~v205I~
        ch=(UINT)*pc;                                              //~v205R~
//      if ((ch<0x20 && ch!=0x0d && ch!=0x0a)                      //~v296R~
//      ||   ch>=0xfd)                                             //~v296I~
        if (udbcschk((UCHAR)ch))    //dbcs 1st byte                //~v296R~
        {                                                          //~v296I~
            if (pc+1<pce && *(pc+1)>=0x40 && *(pc+1)<=0xfc)        //~v296I~
            {                                                      //~v296I~
                pc++;                                              //~v296I~
                continue;                                          //~v296I~
            }                                                      //~v296I~
        }                                                          //~v296I~
        else                                                       //~v296I~
            if ((ch>=0x20 && ch<0xff)                              //~v296I~
            ||   ch==0x06         //keisen yokobo                  //~v296I~
            ||   ch==0x0d || ch=='\n' || ch=='\t')                 //~v296I~
                continue;                                          //~v296I~
            ctlctr++;                                              //~v205I~
        if (!ch)                                                   //~v577I~
            nullctr++;                                             //~v577I~
//          if (ctlctr>Prate)                                      //~v296R~
//              return 1;                                          //~v296R~
    }                                                              //~v205I~
    ctlctr+=nullctr*NULLWEIGHT;                                    //~v577R~
    if (ctlctr*100>Prate*(int)len)                                 //~v296R~
        return 1;                                                  //~v296I~
    return 0;                                                      //~v205R~
}//ufgetbinchk                                                     //~v205I~
                                                                   //~v205I~
#if defined(W32) || defined(DPMI)                                  //~v103I~
//*******************************************************          //~v103I~
//*ugetvfatalias                                                   //~v103R~
//*  get shprt path name                                           //~v103I~
//*parm 1:option                                                   //~v114I~
//*parm 2:input long name                                          //~v114I~
//*parm 3:output short name                                        //~v114I~
//*parm 4:output bufflen(contain last null)                        //~v114I~
//*ret   :short name strlen                                        //~v103R~
//*******************************************************          //~v103I~
int ugetvfatalias(int Popt,unsigned char *Plongname,unsigned char *Pshortname,int Plen)//~v114R~
{                                                                  //~v103I~
        UINT len;                                                      //~v103I~
    int rc;                                                        //~v103I~
    int pathlen;                                                   //~v103R~
    char fatname[MAXFILENAMEZ_FAT];                                //~v114I~
    char *fnm;                                                     //~v114I~
//*******************                                              //~v103I~
    if (!ufileisvfat(0))                                           //~v110I~
    {                                                              //~v110I~
        ustrncpyz(Pshortname,Plongname,(UINT)Plen);                //~v110R~
        return strlen(Pshortname);                                 //~v110R~
    }                                                              //~v110I~
        pathlen=-1;             //pass filename to api as is           //~v114I~
  if (Popt & UGVFA_WILDCARD)                                       //~v114I~
        if (WILDCARD(Plongname))                                       //~v103I~
    {                                                              //~v103I~
        pathlen=PATHLEN(Plongname);                                //~v103R~
        if (pathlen>=0)                                            //~v103I~
                pathlen--;                                             //~v103I~
    }                                                              //~v103I~
//  else                                                           //~v114R~
//      pathlen=-1;                                                //~v114R~
        if (pathlen>0)                                                 //~v103I~
    {                                                              //~v114I~
        fnm=Plongname+pathlen;                                     //~v114I~
        *fnm=0;                                                    //~v114I~
    }                                                              //~v114I~
//      len=GetShortPathName(Plongname,Pshortname,(UINT)Plen);         //~v105R~
        len=ugetshortpathname(Plongname,Pshortname,(UINT)Plen);        //~v105R~
        if (pathlen>0)                                                 //~v103I~
        *fnm='\\';                                                 //~v114R~
    if (!len || len>=(UINT)Plen)//err or buff shortage             //~v103R~
    {                                                              //~v103I~
#ifdef DPMI                                                        //~v105I~
        rc=Sdoserr;                                                //~v105I~
        if (rc==ENOENT)                                            //~v105I~
#else                                                              //~v105I~
        rc=GetLastError();                                         //~v103R~
        if (rc==ERROR_PATH_NOT_FOUND                               //~v114R~
        ||  rc==ERROR_FILE_NOT_FOUND)                              //~v114R~
#endif                                                             //~v105M~
        {                                                          //~v114I~
                if (pathlen<0 && (Popt & UGVFA_NEW))    //not wild card,allow new file//~v114I~
            {                                                      //~v114I~
                        pathlen=PATHLEN(Plongname);                        //~v114I~
                        if (pathlen>=0)                                    //~v114I~
                                pathlen--;                                     //~v114I~
                                if (pathlen>0)                                     //~v114I~
                {                                                  //~v114I~
                                fnm=Plongname+pathlen;                         //~v114R~
                                *fnm=0;                                        //~v114I~
                                        len=ugetvfatalias(Popt&~UGVFA_NEW,Plongname,Pshortname,Plen);//~v114I~
                                *fnm='\\';                                     //~v114R~
                }                                                  //~v114I~
            }                                                      //~v114I~
          if (!len && (Popt & UGVFA_MSG))       //path faile and msg opt//~v114R~
            ufilenotfound(Plongname,rc);                           //~v103I~
        }                                                          //~v114I~
        else                                                       //~v103I~
#ifdef DPMI                                                        //~v105I~
                ufileapierr("udpmiintdos(get short path name)",Plongname,Sdoserr);//~v105I~
#else                                                              //~v105I~
            ufileapierr("GetShortPathName",Plongname,rc);          //~v103I~
#endif                                                             //~v105I~
        }                                                                  //~v103I~
        if (pathlen>0)                                                 //~v103I~
    {                                                              //~v103I~
        ufilegenshortfname(fnm+1,fatname);                             //~v114R~
        *(Pshortname+len)='\\';                                    //~v114R~
        ustrncpyz(Pshortname+len+1,fatname,Plen-len-1);            //~v114I~
        len=strlen(Pshortname);                                    //~v110R~
        }                                                              //~v103I~
    return (int)len;                                               //~v103R~
}//ugetvfatalias                                                   //~v103R~
                                                                   //~v105I~
//*******************************************************          //~v114I~
//*ufilegenshortfname                                              //~v114I~
//*  conversion lfn to fat name                                    //~v114I~
//*parm 1:input long filename                                      //~v114I~
//*parm 2:output fatname                                           //~v114I~
//*ret   :sufixpos                                                 //~v114R~
//*******************************************************          //~v114I~
int ufilegenshortfname(char *Plongname,char *Pshortname)           //~v114R~
{                                                                  //~v114I~
        char *pc,*pc2,*pc3;                                            //~v114R~
    int len,convsw=0,pos;                                          //~v114R~
//*******************                                              //~v114I~
    pc=strchr(Plongname,'.');                                      //~v114I~
    if (pc)                                                        //~v114I~
    {                                                              //~v114I~
        len=(int)((ULONG)pc-(ULONG)Plongname);                     //~v114I~
        pc++;                                                      //~v114I~
        if (strlen(pc)>3)                                          //~v114I~
            convsw=1;                                              //~v114I~
        else                                                       //~v114I~
            if (strchr(pc,'.'))                                    //~v114I~
                convsw=1;                                          //~v114I~
    }                                                              //~v114I~
    else                                                           //~v114I~
        len=(int)strlen(Plongname);                                //~v114I~
    if (len>8)                                                     //~v114I~
        convsw=1;                                                  //~v114I~
    if (!convsw)                                                   //~v114I~
        if (strchr(Plongname,' '))                                 //~v114R~
            convsw=1;                                              //~v114R~
        if (!convsw)                                                   //~v114I~
    {                                                              //~v114I~
                ufilefnameconv(Plongname,Pshortname,MAXFILENAMEZ_FAT-1,0);//base max is 6,stop at '.'//~v114I~
        return 0;               //no change                                //~v114R~
    }                                                              //~v114I~
//shorten   to   xxxxxx~1.yyy                                      //~v114I~
        pos=ufilefnameconv(Plongname,Pshortname,6,1);//base max is 6,stop at '.'//~v114R~
    pc2=Pshortname+pos;                                            //~v114I~
    *pc2++='~';                                                    //~v114R~
    *pc2++='1';                                                    //~v114R~
    *pc2=0;                                                        //~v114R~
        if (pc) //extention                                            //~v114R~
    {                                                              //~v114I~
        *pc2++='.';                                                //~v114M~
        pc3=strrchr(pc,'.');    //last period                      //~v114R~
                if (pc3)                                                       //~v114I~
                pc=pc3+1;                                              //~v114I~
                ufilefnameconv(pc,pc2,3,0);//ext max is 3                  //~v114R~
    }                                                              //~v114I~
    return pos+1;       //sufix pos                                    //~v114R~
}//ufilegenshortfname                                              //~v114I~
//*******************************************************          //~v114I~
//*ufilefnameconv                                                  //~v114I~
//*  shorten file base name/ext name(drop space,drop boundary dbcs)//~v114I~
//*parm 1:input long filename                                      //~v114I~
//*parm 2:output fatname                                           //~v114I~
//*parm 3:maxlen                                                   //~v114I~
//*parm 4:opton 1:stop before '.'                                  //~v114I~
//*ret   :outlen                                                   //~v114I~
//*******************************************************          //~v114I~
int ufilefnameconv(char *Plongname,char *Pshortname,int Plen,int Popt)//~v114R~
{                                                                  //~v114I~
        char *pcs,*pcl,*pcend;                                         //~v114I~
//*******************                                              //~v114I~
    pcs=Pshortname;                                                //~v114R~
        pcl=Plongname;                                                 //~v114I~
        pcend=Pshortname+Plen;                                         //~v114I~
    for (;*pcl && pcs<pcend;)                                      //~v114I~
    {                                                              //~v114I~
        if (Popt)                                                  //~v114I~
                if (*pcl=='.')                                         //~v114R~
                break;                                             //~v114R~
        if (*pcl==' ')                                             //~v114R~
                pcl++;                                                 //~v114I~
                else                                                       //~v114I~
        {                                                          //~v114I~
            if (udbcschk(*pcl))                                    //~v114I~
            {                                                      //~v114I~
                    *pcs++=*pcl++;                                     //~v114I~
                    *pcs++=*pcl++;                                     //~v114I~
                        }                                                      //~v114I~
            else                                                   //~v114I~
                if (*pcl>='a' && *pcl<='z')                        //~v114R~
                {                                                  //~v114I~
                        *pcs++=(UCHAR)toupper(*pcl);                   //~v114R~
                    pcl++;                                         //~v114I~
                }                                                  //~v114I~
                else                                               //~v114I~
                        *pcs++=*pcl++;                                 //~v114R~
        }                                                          //~v114I~
    }                                                              //~v114I~
    if (pcs>pcend)      //last is dbcs                                 //~v114I~
        pcs-=2;                                                    //~v114I~
        *pcs=0;                                                        //~v114I~
        return (int)((ULONG)pcs-(ULONG)Pshortname);                    //~v114I~
}//ufilefnameconv                                                  //~v114I~
//*******************************************************          //~v105I~
//*ugetshortpathname W32 and DPMI                                  //~v105I~
//*  get shprt path name                                           //~v105I~
//*parm 1:input long name                                          //~v105I~
//*parm 2:output short name                                        //~v105I~
//*parm 3:output bufflen(contain last null)                        //~v105I~
//*ret   :short name strlen                                        //~v105I~
//*******************************************************          //~v105I~
int ugetshortpathname(unsigned char *Plongname,unsigned char *Pshortname,int Plen)//~v105I~
{                                                                  //~v105I~
#ifdef DPMI                                                        //~v105I~
        union REGS   reg;                                              //~v105I~
    char wk[_MAX_PATH];                                            //~v105R~
//***************                                                  //~v105I~
    memset(&reg,0,sizeof(reg));                                    //~v105I~
        if (ufileisvfat(0))                                            //~v105I~
    {                                                              //~v105I~
                reg.h.ah=0x71;                                  //lfn func                 //~v105I~
                reg.h.al=0x60;                                  //get curr dir             //~v105I~
                reg.x.cx=1;                                             //short pathname get       //~v105I~
        }                                                              //~v105I~
    else                                                           //~v105I~
                reg.h.ah=0x60;                                  //get curr dir             //~v105I~
                                                                   //~v105I~
    reg.d.esi=(int)Plongname; //input dir name ptr                 //~v105I~
    reg.d.edi=(int)wk; //output dir name ptr                       //~v105I~
    udpmiintdos(&reg,&reg);     //get cur dir                      //~v105I~
    Sdoserr=0;                                                     //~v105I~
        if (reg.x.cflag)                                               //~v105I~
    {                                                              //~v105I~
        Sdoserr=errno;                                             //~v105I~
        return 0;                                                  //~v105I~
        }                                                              //~v105I~
    strncpy(Pshortname,wk,Plen-1);                                 //~v105I~
    *(Pshortname+Plen-1)=0;                                        //~v105I~
    return (int)strlen(wk);                                        //~v105I~
#else                                                              //~v105I~
        return GetShortPathName(Plongname,Pshortname,(UINT)Plen);      //~v105I~
#endif                                                             //~v105I~
}//ugetshortpathname                                               //~v105I~
#endif                                                             //~v103I~
                                                                   //~v272I~
//#ifdef UNX                                                       //~v50UR~
////*******************************************************        //~v56xR~
////*udoseditnameopt                                               //~v56xR~
////*   set option for udoseditname                                //~v56xR~
////*******************************************************        //~v56xR~
//void udoseditnameopt(int Popt)                                   //~v56xR~
//{                                                                //~v56xR~
//    Sdenopt=Popt;                                                //~v56xR~
//    return;                                                      //~v56xR~
//}                                                                //~v56xR~
////udoseditnameopt                                                //~v56xR~
//#endif                                                           //~v50UR~
                                                                   //~v50bI~
//*******************************************************          //~v272M~
//*udoseditname                                                    //~v272M~
//*   covert filename by patern(no path support)                   //~v272R~
//*parm 1:source filename                                          //~v272M~
//*parm 2:patern string                                            //~v272M~
//*parm 3:sout area addr                                           //~v272M~
//*ret   :always 0                                                 //~v272R~
//*******************************************************          //~v272M~
int udoseditname(int Popt,UCHAR *Pin,UCHAR *Ppat,UCHAR *Pout)      //~v56xR~
{                                                                  //~v272M~
    UCHAR  chp,*pci,*pco,*pcp,*pcie,wk[_MAX_PATH];                 //~v272R~
    UCHAR  dbcsi[_MAX_PATH],dbcsp[_MAX_PATH],*pdbcsi,*pdbcsp;      //~v56xI~
    int    leni,lenp;                                              //~v56xI~
    int    msw;                                                    //~v56xI~
//*****************                                                //~v272M~
    pcie=Pin+strlen(Pin);                                          //~v272M~
    pcp=Ppat; pci=Pin; pco=wk;                                     //~v272R~
    leni=(int)((ULONG)pcie-(ULONG)Pin);                            //~v56xI~
    lenp=(int)strlen(Ppat);                                        //~v56xI~
    usetdbcstbl(USDT_CODE_DEFAULT,Pin,dbcsi,leni);                 //~v56xR~
    usetdbcstbl(USDT_CODE_DEFAULT,Ppat,dbcsp,lenp);                //~v56xR~
    chp=*pcp;             //for compiler warning                   //~v327I~
    while(pci<pcie)                                                //~v272M~
    {                                                              //~v272M~
        chp=*pcp++;             //patern                           //~v272M~
        switch(chp)                                                //~v272M~
        {                                                          //~v272M~
        case '*':                                                  //~v272M~
            chp=*pcp;       //next of '*'                          //~v272M~
            while (chp=='*')    //ignore double '*'                //~v272M~
                chp=*++pcp;                                        //~v272M~
            pdbcsp=dbcsp+((ULONG)pcp-(ULONG)Ppat);                 //~v56xI~
            pdbcsi=dbcsi+((ULONG)pci-(ULONG)Pin);                  //~v56xI~
            while (pci<pcie)                                       //~v272M~
            {                                                      //~v272M~
//              if (toupper(chp)==toupper(*pci))                   //~v56xR~
//                  break;                                         //~v56xI~
                msw=0;                      //match sw             //~v56xI~
                if (*pdbcsi==*pdbcsp)   //same dbcs type           //~v56xI~
                {                                                  //~v5crI~
                    if (chp==*pci)                                 //~v56xI~
                    {                                              //~v56xI~
                        if (*pdbcsi==UDBCSCHK_DBCS1ST)             //~v56xI~
                        {                                          //~v56xI~
							if (*(pci+1)==*(pcp+1))                //~v56xI~
                                msw=1;                             //~v56xI~
                        }                                          //~v56xI~
                        else      //sbcs or 2nd byte               //~v56xI~
                        	msw=1;                                 //~v56xI~
                    }                                              //~v56xI~
                    else        //char unmatch                     //~v56xI~
                    	if (!*pdbcsi)	//sbcs                     //~v56xR~
              				if (!(Popt & DEN_CASE)) 	//case insensitive//~v56xR~
                				if (toupper(chp)==toupper(*pci))   //~v56xI~
                                	msw=1;                         //~v56xI~
                }//dbcs type                                       //~v5crI~
                if (msw)                                           //~v56xI~
                    break;                                         //~v56xI~
                *pco++=*pci++;                                     //~v272M~
            }                                                      //~v272M~
            break;                                                 //~v272M~
        case '?':                                                  //~v272M~
            if (*pci=='.')        //nop when '.'                   //~v290R~
                break;                                             //~v290I~
            *pco++=*pci++;  //copy from patern                     //~v272M~
            break;                                                 //~v272M~
        case '.':                                                  //~v272M~
//#ifdef UNX                                                       //~v50UR~
//        if (Sdenopt & DEN_UNIX)                                  //~v56xR~
          if (Popt & DEN_UNIX)                                     //~v56xI~
          {                      //same as default                 //~v388I~
            *pco++=chp; //copy from patern                         //~v388I~
	        pci++;      //pass input char                          //~v388I~
            break;                                                 //~v388I~
          }                                                        //~v388I~
//#endif //UNX                                                     //~v50UR~
            while(pci<pcie) //all base                             //~v272M~
                if (*pci++=='.')                                   //~v272M~
                    break;                                         //~v272M~
            *pco++='.';                                            //~v272M~
            break;                                                 //~v272M~
        case  0:                                                   //~v290I~
            break;                                                 //~v290I~
        default:                                                   //~v272M~
            *pco++=chp; //copy from patern                         //~v272M~
//#ifdef UNX                                                       //~v50UR~
//        if (Sdenopt & DEN_UNIX)                                  //~v56xR~
          if (Popt & DEN_UNIX)                                     //~v56xI~
	            pci++;      //pass input char                      //~v388I~
          else                                                     //~v388I~
//#endif //UNX                                                     //~v50UR~
          if (*pci!='.')                                           //~v290I~
            pci++;      //pass input char                          //~v272M~
        }                                                          //~v272M~
        if (!chp)                                                  //~v290I~
            break;                                                 //~v290I~
    }//while input exist                                           //~v272M~
//copy residual of patern                                          //~v272M~
//  do                                                             //~v290R~
    while(chp)                                                     //~v290I~
    {                                                              //~v272M~
        chp=*pcp++;                                                //~v272M~
        if (!chp)                                                  //~v290I~
            break;                                                 //~v290I~
        if (chp!='*' && chp!='?')                                  //~v272M~
        {                                                          //~v340R~
//#ifdef UNX                                                       //~v50UR~
//        if (!(Sdenopt & DEN_UNIX))                               //~v56xR~
          if (!(Popt & DEN_UNIX))                                  //~v56xI~
//#endif //UNX                                                     //~v50UR~
            if (chp=='.')                                          //~v340R~
        		if (strlen(pcp)==strspn(pcp,"*?."))	//no other char than */?/.//~v340R~
                    break;                                         //~v340R~
            *pco++=chp;                                            //~v272M~
        }                                                          //~v340R~
                                                                   //~v272M~
//  }while(chp);                                                   //~v290R~
    }                                                              //~v290I~
    *pco=0;                                                        //~v272I~
    strcpy(Pout,wk);                                               //~v272I~
    return 0;                                                      //~v272M~
}//udoseditname                                                    //~v272M~
                                                                   //~v279I~
//*******************************************************          //~v279I~
//*ufileeditname                                                   //~v279I~
//*   covert last filename by patern(source may contain path)      //~v279I~
//*parm 1:option  for udoseditname                                 //~v56xR~
//*parm 2:source pathname                                          //~v56xI~
//*parm 3:patern pathname(only last is wild card)                  //~v56xR~
//*parm 4:out area addr                                            //~v56xR~
//*       if patern is fullpath format output is of patern path,   //~v279I~
//        else patern path is concatinate to source path           //~v279I~
//*ret   :always 0                                                 //~v279I~
//*******************************************************          //~v279I~
int ufileeditname(int Popt,UCHAR *Psource,UCHAR *Ppatern,UCHAR *Ptarget)//~v56xR~
{                                                                  //~v279I~
    int pathlens,pathlenp,pathlent;                                //~v279I~
    int fpathsw=0;                                                 //~v5crI~
    UCHAR wk[_MAX_PATH];                                           //~v279I~
#ifdef FTPSUPP                                                     //~v5crI~
    PUFTPHOST puftph;                                              //~v5crI~
#endif                                                             //~v5crI~
//*****************                                                //~v279I~
#ifdef FTPSUPP                                                     //~v5jdI~
  	if (uftpisremote(Ppatern,&puftph))		//ftp filename         //~v5jdI~
  	{                                                              //~v5jdI~
    	if (UFTPHISTSO(puftph))                                    //~v5jdI~
        	return u3270editname(puftph,U3EN_WILDSOURCE,Ppatern,Psource,Ptarget);//~v5jdI~
  	}                                                              //~v5jdI~
  	if (uftpisremote(Psource,&puftph))		//ftp filename         //~v5jdI~
  	{                                                              //~v5jdI~
    	if (UFTPHISTSO(puftph))                                    //~v5jdI~
        	return u3270editname(puftph,U3EN_WILDSOURCE|U3EN_SRCLOCAL,Ppatern,Psource,Ptarget);//~v5jdR~
  	}                                                              //~v5jdI~
#endif                                                             //~v5jdI~
    if ((pathlens=PATHLEN(Psource))<0)                             //~v279R~
        pathlens=0;     //no path                                  //~v279I~
                                                                   //~v279I~
    if ((pathlenp=PATHLEN(Ppatern))<0)                             //~v279R~
        pathlenp=0;                                                //~v279I~
                                                                   //~v279I~
#ifdef FTPSUPP                                                     //~v5crI~
  if (uftpisremote(Ppatern,&puftph))		//ftp filename         //~v5crI~
  {                                                                //~v5crI~
    	if (Ppatern[puftph->UFTPHhostnmlen+1]==FTP_DIR_SEPC)       //~v5crI~
        	fpathsw=1;                                             //~v5crI~
  }                                                                //~v5crI~
  else//local                                                      //~v5crI~
  {                                                                //~v5crI~
#endif                                                             //~v5crI~
#ifdef UNX                                                         //~v327I~
//  if (Ppatern[0]==DIR_SEPC)    //fullpath                        //~v55hR~
    if (Ppatern[0]==DIR_SEPC     //fullpath                        //~v55hI~
    ||    (MDOSDISKOK(Ppatern)                                     //~v55hI~
        && Ppatern[2]==DIR_SEPC))                                  //~v55hI~
        fpathsw=1;                                                 //~v5crI~
#else                                                              //~v327I~
    if (Ppatern[1]==':' && Ppatern[2]=='\\')    //fullpath         //~v279I~
        fpathsw=1;                                                 //~v5crI~
#endif                                                             //~v327I~
#ifdef FTPSUPP                                                     //~v5crI~
  }//local                                                         //~v5crI~
#endif                                                             //~v5crI~
	if (fpathsw)                                                   //~v5crI~
    {                                                              //~v279I~
        memcpy(wk,Ppatern,(UINT)pathlenp);   //repl by patern      //~v279R~
        pathlent=pathlenp;                                         //~v279I~
    }                                                              //~v279I~
    else                                                           //~v279I~
    {                                                              //~v279I~
        memcpy(wk,Psource,(UINT)pathlens);                         //~v279R~
        memcpy(wk+pathlens,Ppatern,(UINT)pathlenp);   //add to source//~v279R~
        pathlent=pathlens+pathlenp;                                //~v279I~
    }                                                              //~v279I~
//  udoseditname(Psource+pathlens,Ppatern+pathlenp,wk+pathlent);   //~v56xR~
    udoseditname(Popt,Psource+pathlens,Ppatern+pathlenp,wk+pathlent);//~v56xR~
    strcpy(Ptarget,wk);                                            //~v279I~
    return 0;                                                      //~v279I~
}//ufileeditname                                                   //~v279I~
//*******************************************************          //~v56yI~
//*ufilewildcomp                                                   //~v56yI~
//*   wildcard matching                                            //~v56yI~
//*parm 1:option   dos type "." usage,case sense,"*" is for 0-byte //~v56yI~
//*parm 2:source filename                                          //~v56yI~
//*parm 3:patern string                                            //~v56yI~
//*ret   :0:match,4:unmatch                                        //~v56yI~
//*******************************************************          //~v56yI~
int ufilewildcomp(int Popt,UCHAR *Pin,UCHAR *Ppat,UCHAR *Pdbcsp)   //~v56yI~
{                                                                  //~v56yI~
#define UNMATCH 4                                                  //~v56yI~
    UCHAR  *pci,*pcp,*pcp0,*pcie,*pcpe,*pc;                        //~v56yR~
    UCHAR  dbcsp[_MAX_PATH],dbcsi[_MAX_PATH],*pdbcsp;              //~v56yI~
    int ii,leni,lenp,complen,topsw;                                //~v56yI~
//*****************                                                //~v56yI~
//printf("entry opt=%x,in=%s,pat=%s\n",Popt,Pin,Ppat);             //~v56yR~
    leni=(int)strlen(Pin);                                         //~v56yI~
    lenp=(int)strlen(Ppat);                                        //~v56yI~
    if (pdbcsp=Pdbcsp,!pdbcsp)                                     //~v56yI~
    {                                                              //~v56yI~
    	pdbcsp=dbcsp;                                              //~v56yI~
        usetdbcstbl(USDT_CODE_DEFAULT,Ppat,dbcsp,lenp);            //~v56xR~
    }                                                              //~v56yI~
    usetdbcstbl(USDT_CODE_DEFAULT,Pin,dbcsi,leni);                 //~v56xR~
    pcie=Pin+leni;                                                 //~v56yI~
    pcpe=Ppat+lenp;                                                //~v56yI~
    pcp=Ppat;                                                      //~v56yI~
    pci=Pin;                                                       //~v56yI~
    while(pcp<pcpe)                                                //~v56yI~
    {                                                              //~v56yI~
    	for (pcp0=pcp;*pcp=='*';pcp++)                             //~v56yI~
        	if (!(Popt & UFWC_0BYTE))                              //~v56yI~
            	pci++;                                             //~v56yI~
        if (pci>pcie)                                              //~v56yI~
            return UNMATCH;                                        //~v56yI~
        if (pcp>=pcpe)                                             //~v56yI~
        {                                                          //~v56yI~
            pci=pcie;                                              //~v56yI~
        	break;		//match                                    //~v56yI~
        }                                                          //~v56yI~
        if (pcp==pcp0)	//no preceding '*'                         //~v56yI~
        	topsw=1;	//chk head string only                     //~v56yI~
        else                                                       //~v56yI~
        	topsw=0;	//                                         //~v56yI~
        if (pc=strchr(pcp,'*'),pc)	//followed by more '*'         //~v56yI~
        	complen=(int)((ULONG)pc-(ULONG)pcp);                   //~v56yI~
        else                                                       //~v56yI~
        	complen=(int)strlen(pcp);                              //~v56yI~
        if (pci+complen>pcie)                                      //~v56yI~
            return UNMATCH;                                        //~v56yI~
        for (ii=(int)((ULONG)pcie-(ULONG)pci)-complen;ii>=0;ii--,pci++) //~v56yI~
        {                                                          //~v56yI~
        	pc=ufilewildcompsub(Popt,complen,pci,pcp,              //~v56yI~
							dbcsi+((ULONG)pci-(ULONG)Pin),         //~v56yI~
							pdbcsp+((ULONG)pcp-(ULONG)Ppat));//match//~v56yI~
//printf("sub ret %p=%s,complen=%d,topsw=%d,in=%s,pat=%s\n",pc,pc,complen,topsw,pci,pcp);//~v56yR~
        	if (pc)	//matched,next chk source string               //~v56yI~
            	break;                                             //~v56yI~
            if (topsw)       //match should be head                //~v56yI~
            	return UNMATCH;                                    //~v56yI~
        }                                                          //~v56yI~
        if (!pc)                                                   //~v56yI~
            return UNMATCH;                                        //~v56yI~
        pci=pc;                                                    //~v56yI~
        pcp+=complen;                                              //~v56yI~
    }                                                              //~v56yI~
    if (pci<pcie)   //remain input                                 //~v56yI~
        return UNMATCH;                                            //~v56yI~
    return 0;                                                      //~v56yI~
}//ufilewildcomp                                                   //~v56yI~
//*******************************************************          //~v56yI~
//*ufilewildcompsub                                                //~v56yI~
//*   wildcard matching                                            //~v56yI~
//*parm 1:option                                                   //~v56yI~
//*parm 2:compare position sw; 1:top,2:last;0:in the full string   //~v56yI~
//*parm 3:compare patern string length                             //~v56yI~
//*parm 4:source filename                                          //~v56yI~
//*parm 5:patern string                                            //~v56yI~
//*parm 6:dbcs tbl of source filename                              //~v56yI~
//*parm 7:dbcs tbl of patern string                                //~v56yI~
//*ret   :next of source string                                    //~v56yI~
//*******************************************************          //~v56yI~
UCHAR *ufilewildcompsub(int Popt,int Pcomplen,                     //~v56yI~
					UCHAR *Pin,UCHAR *Ppat,UCHAR *Pdbcsi,UCHAR *Pdbcsp)//~v56yI~
{                                                                  //~v56yI~
    UCHAR  *pci,*pcp,*pcdi,*pcdp;                                  //~v56yI~
    int ii;                                                        //~v56yR~
//*****************                                                //~v56yI~
	for (ii=0,pci=Pin,pcp=Ppat,pcdi=Pdbcsi,pcdp=Pdbcsp;            //~v56yI~
//  			*pci && ii<Pcomplen;                               //~v5fkR~
    			ii<Pcomplen && *pci;                               //~v5fkI~
					ii++,pcp++,pcdp++,pci++,pcdi++)                //~v56yI~
    {                                                              //~v56yI~
    	switch(*pcp)                                               //~v56yI~
        {                                                          //~v56yI~
        case '?':                                                  //~v56yI~
            if (Popt & UFWC_DOS)                                   //~v56yI~
  		      	if (*pci=='.')                                     //~v56yI~
                	return 0;                                      //~v56yI~
        	break;                                                 //~v56yI~
        default:                                                   //~v56yI~
//printf("pcdi=%p=%c ;pcdp=%p=%c\n",pcdi,*pcdi,pcdp,*pcdp);        //~v56yR~
        	if (*pcdi!=*pcdp)	//dbcs type unmatch                //~v56yI~
                return 0;                                          //~v56yI~
            if (*pci!=*pcp)                                        //~v56yI~
            {                                                      //~v5crI~
            	if (Popt & UFWC_CASE)                              //~v56yI~
	                return 0;                                      //~v56yI~
                else                                               //~v56yI~
            	if (*pcdi)		//dbcs char                        //~v56yI~
	                return 0;                                      //~v56yI~
                else			//sbcs                             //~v56yI~
            	if (toupper(*pci)!=toupper(*pcp))                  //~v56yI~
	                return 0;                                      //~v56yI~
            }//!=                                                  //~v5crI~
        }//sw                                                      //~v56yI~
    }                                                              //~v56yI~
    if (ii<Pcomplen)                                               //~v56yI~
    	return 0;	//remain patern string                         //~v56yI~
    if (!*pcp && *pci)	//remain source string                     //~v56yI~
    	return 0;                                                  //~v56yI~
	return pci;                                                    //~v56yI~
}//ufilewildcompsub                                                //~v56yI~
//*********************************************************************//~v5j8I~
#define COMP_BUFFSZ  	32760   //32k                              //~v5j8I~
//*********************************************************************//~v5j8I~
//* binary compare 2 local file                                    //~v5j8I~
//* return 0:fully equall                                          //~v5j8I~
//*        1:file1 not exist or dir                                //~v5j8I~
//*        2:file2 not exist or dir                                //~v5j8I~
//*        3:both not exist or dir                                 //~v5j8I~
//*        4:size unmatch                                          //~v5j8I~
//*        5:contents unmatch(size is same)                        //~v5j8I~
//*        6:null appended                                         //~v5jtI~
//*        8:other err                                             //~v5j8I~
//*        UALLOC_FAILED                                           //~v5j8I~
//*********************************************************************//~v5j8I~
int ufilecomp(int Popt,char *Pfnm1,char *Pfnm2)                    //~v5j8R~
{                                                                  //~v5j8I~
	FILE *fh1,*fh2;                                                //~v5j8I~
    UINT readlen1,readlen2;                                        //~v5j8I~
    int rc;                                                        //~v5j8I~
    FILEFINDBUF3 fstat31,fstat32;                                  //~v5j8I~
    char *buff1,*buff2;                                            //~v5j8R~
    int eof1=0,eof2=0,nullappend=0;                                //+v5jtR~
    UINT complen,applen;                                           //+v5jtI~
    char *papp;                                                    //~v5jtI~
//*****************************                                    //~v5j8I~
	rc=0;                                                          //~v5j8I~
    if (ufstat(Pfnm1,&fstat31)||(fstat31.attrFile & FILE_DIRECTORY))//~v5j8I~
    	rc|=1;                                                     //~v5j8I~
    if (ufstat(Pfnm2,&fstat32)||(fstat32.attrFile & FILE_DIRECTORY))//~v5j8R~
    	rc|=2;                                                     //~v5j8I~
    if (rc)                                                        //~v5j8I~
    	return rc;                                                 //~v5j8I~
    if (!(buff1=umalloc(COMP_BUFFSZ*2)))                           //~v5j8I~
        return UALLOC_FAILED;                                      //~v5j8I~
    if (Popt & UFCO_TEXT)	//text mode                            //~v5jsI~
    {                                                              //~v5jsI~
		rc=ufilecomptextmode(Popt,Pfnm1,Pfnm2,buff1);              //~v5jsR~
    	ufree(buff1);                                              //~v5jsI~
        return rc;                                                 //~v5jsI~
    }                                                              //~v5jsI~
    buff2=buff1+COMP_BUFFSZ;                                       //~v5j8I~
	if (fstat31.cbFile!=fstat32.cbFile)                            //~v5j8I~
    {                                                              //~v5jsI~
//  	return 4;	//size unmatch                                 //~v5jsR~
      if (!(Popt & UFCO_NULLAPP)) //allow binary mode compare null append for RECFM=Fx//~v5jtR~
      {                                                            //~v5jtI~
    	ufree(buff1);                                              //~v5jsI~
        return UFCRC_SIZE;// 4    //bin compare size unmatch       //~v5jsR~
      }                                                            //~v5jtI~
    }                                                              //~v5jsI~
	if (!(fh1=fopen(Pfnm1,"rb")))                                  //~v5j8I~
    	uerrapi1("fopen",Pfnm1,errno);                             //~v5j8I~
	if (!(fh2=fopen(Pfnm2,"rb")))                                  //~v5j8I~
    	uerrapi1("fopen",Pfnm2,errno);                             //~v5j8I~
    if (fh1 && fh2)                                                //~v5j8I~
    {                                                              //~v5j8I~
//compare                                                          //~v5j8I~
        for (;;)                                                   //~v5j8I~
        {                                                          //~v5j8I~
          if (eof1)                                                //~v5jtI~
          	readlen1=0;                                            //~v5jtI~
          else                                                     //~v5jtI~
          {                                                        //~v5jtI~
		    readlen1=fread(buff1,1,COMP_BUFFSZ,fh1);	//read 1 block//~v5j8I~
            if (!readlen1)                                         //~v5jtI~
            	eof1=1;                                            //~v5jtI~
          }                                                        //~v5jtI~
          if (eof2)                                                //~v5jtI~
          	readlen2=0;                                            //~v5jtI~
          else                                                     //~v5jtI~
          {                                                        //~v5jtI~
		    readlen2=fread(buff2,1,COMP_BUFFSZ,fh2);	//read 1 block//~v5j8I~
            if (!readlen2)                                         //~v5jtI~
            	eof2=1;                                            //~v5jtI~
          }                                                        //~v5jtI~
            if (readlen1!=readlen2)                                //~v5j8I~
            {                                                      //~v5jtI~
		      if (!(Popt & UFCO_NULLAPP)) //allow binary mode compare null append for RECFM=Fx//~v5jtI~
            	break;                                             //~v5j8I~
            	if (readlen1<readlen2)                             //~v5jtI~
                {                                                  //~v5jtI~
                	papp=buff2+readlen1;                           //~v5jtI~
                    applen=readlen2-readlen1;                      //~v5jtI~
                    complen=readlen1;                              //~v5jtI~
                }                                                  //~v5jtI~
                else         //readlen1>readlen2                   //~v5jtI~
                {                                                  //~v5jtI~
                	papp=buff1+readlen2;                           //~v5jtI~
                    applen=readlen1-readlen2;                      //~v5jtI~
                    complen=readlen2;                              //~v5jtI~
                }                                                  //~v5jtI~
                if (complen)                                       //~v5jtI~
		            if (memcmp(buff1,buff2,complen))               //~v5jtI~
                    	break;                                     //~v5jtI~
                if (applen)                                        //~v5jtI~
                {                                                  //~v5jtI~
                	if ((UINT)applen!=umemspnc(papp,0,(UINT)applen))	//not all null//~v5jtR~
                    	break;                                     //~v5jtI~
                    else                                           //~v5jtI~
                    	nullappend=1;//null append detected        //~v5jtI~
                }                                                  //~v5jtI~
                continue;                                          //~v5jtI~
            }                                                      //~v5jtI~
            if (!readlen1)                                         //~v5j8I~
            	break;                                             //~v5j8I~
            if (memcmp(buff1,buff2,readlen1))                      //~v5j8R~
                break;                                             //~v5j8I~
        }                                                          //~v5j8I~
        if (readlen1)                                              //~v5j8I~
        	rc=5;		//unmatch                                  //~v5j8I~
        if (nullappend)                                            //~v5jtI~
        	rc=UFCRC_NULLAPP;                                      //~v5jtI~
    }                                                              //~v5j8I~
    else                                                           //~v5jsI~
    	rc=8;                                                      //~v5jsI~
    ufree(buff1);                                                  //~v5j8I~
    if (fh1)                                                       //~v5j8I~
	    fclose(fh1);                                               //~v5j8I~
    if (fh2)                                                       //~v5j8I~
	    fclose(fh2);                                               //~v5j8I~
    return rc;                                                     //~v5j8I~
}//ufilecomp                                                       //~v5j8I~
//*********************************************************************//~v5jsI~
//* text modecompare 2 local file                                  //~v5jsI~
//*        5:contents unmatch(size is same)                        //~v5jsI~
//*        8:other err                                             //~v5jsI~
//*********************************************************************//~v5jsI~
int ufilecomptextmode(int Popt,char *Pfnm1,char *Pfnm2,char *Pbuff)//~v5jsI~
{                                                                  //~v5jsI~
	FILE *fh1,*fh2;                                                //~v5jsI~
    UINT len1,len2,lenc,lenr;                                      //~v5jsR~
    int rc;                                                        //~v5jsI~
    char *buff1,*buff2,*pc1,*pc2,*pc;                              //~v5jsR~
//*****************************                                    //~v5jsI~
	rc=0;                                                          //~v5jsI~
    buff1=Pbuff;                                                   //~v5jsI~
    buff2=buff1+COMP_BUFFSZ;                                       //~v5jsI~
	if (!(fh1=fopen(Pfnm1,"r")))                                   //~v5jsI~
    	uerrapi1("fopen",Pfnm1,errno);                             //~v5jsI~
	if (!(fh2=fopen(Pfnm2,"r")))                                   //~v5jsI~
    	uerrapi1("fopen",Pfnm2,errno);                             //~v5jsI~
    if (fh1 && fh2)                                                //~v5jsI~
    {                                                              //~v5jsI~
//compare                                                          //~v5jsI~
        for (;;)                                                   //~v5jsI~
        {                                                          //~v5jsI~
		    pc1=fgets(buff1,COMP_BUFFSZ,fh1);	//read 1 block     //~v5jsI~
		    pc2=fgets(buff2,COMP_BUFFSZ,fh2);	//read 1 block     //~v5jsI~
            if (!pc1 && !pc2)    //both eof                        //~v5jsI~
            	break;                                             //~v5jsI~
            if (!pc1 || !pc2)    //one is eof                      //~v5jsI~
            	break;                                             //~v5jsI~
            if (!(Popt & UFCO_TSPACE))	//no trailing space chk    //~v5jsI~
            {                                                      //~v5jsI~
            	if (strcmp(pc1,pc2)) //unmatch                     //~v5jsI~
                {                                                  //~v5jsI~
//                  printf("txt unmatch %s!=%s",pc1,pc2);          //~v5jsR~
                	break;                                         //~v5jsI~
                }                                                  //~v5jsI~
                continue;                                          //~v5jsI~
            }                                                      //~v5jsI~
            len1=strlen(pc1);                                      //~v5jsI~
            len2=strlen(pc2);                                      //~v5jsI~
            if (len1>len2)                                         //~v5jsI~
            {                                                      //~v5jsI~
                lenc=len2;         //comaprelen                    //~v5jsR~
                if (*(pc2+lenc-1)=='\n')                           //~v5jsI~
                	lenc--;                                        //~v5jsI~
                lenr=len1-lenc;    //spacechk len                  //~v5jsR~
            	pc=pc1+lenc;                                       //~v5jsR~
            }                                                      //~v5jsI~
            else                                                   //~v5jsI~
            if (len1<len2)                                         //~v5jsI~
            {                                                      //~v5jsI~
                lenc=len1;                                         //~v5jsR~
                if (*(pc1+lenc-1)=='\n')                           //~v5jsI~
                	lenc--;                                        //~v5jsI~
                lenr=len2-lenc;                                    //~v5jsR~
            	pc=pc2+lenc;                                       //~v5jsR~
            }                                                      //~v5jsI~
            else  //same len                                       //~v5jsI~
            {                                                      //~v5jsI~
                lenc=len1;                                         //~v5jsI~
                lenr=0;                                            //~v5jsI~
            }                                                      //~v5jsI~
            if (memcmp(pc1,pc2,(UINT)lenc)) //unmatch              //~v5jsI~
            {                                                      //~v5jsI~
//              printf("txt unmatch len=%d %s!=%s",lenc,pc1,pc2);  //~v5jsR~
            	break;                                             //~v5jsI~
            }                                                      //~v5jsI~
            if (!lenr)		//match same len                       //~v5jsI~
                continue;                                          //~v5jsI~
            if (strspn(pc," \n")!=lenr)	//residual is not all space//~v5jsI~
            {                                                      //~v5jsI~
//              printf("txt trailer unmatch lenc=%d lenr=%d,%s!=%s,trailer=%s",lenc,lenr,pc1,pc2,pc);//~v5jsR~
            	break;                                             //~v5jsI~
            }                                                      //~v5jsI~
        }                                                          //~v5jsI~
        if (pc1 || pc2)   //not both eof                           //~v5jsI~
        	rc=5;		//unmatch                                  //~v5jsI~
    }                                                              //~v5jsI~
    else                                                           //~v5jsI~
    	rc=8;                                                      //~v5jsI~
    if (fh1)                                                       //~v5jsI~
	    fclose(fh1);                                               //~v5jsI~
    if (fh2)                                                       //~v5jsI~
	    fclose(fh2);                                               //~v5jsI~
    return rc;                                                     //~v5jsI~
}//ufilecomp                                                       //~v5jsI~
