//*CID://+v5j4R~:                             update#=  259;       //~v5j4R~
//******************************************************
//*uftp.h                                                          //~v5adR~
//******************************************************
//v5j4:060914 ftp:3270 support (xehost TSO=portno operand)         //~v5j4I~
//v5ex:041107 tempname support at remote                           //~v5exI~
//v5dz:040823 ftp:specify large windowsize(windows default is 4096)//~v5dzI~
//v5df:040609 (AIX:BUG)AIX responce is by JST for ls,GMT for modtime//~v5dfI~
//                     LNX responce is both by GMT;                //~v5dfI~
//                     ajust ls time by xehosts,mdtime result by ftime tz//~v5dfI~
//v5d7:040529 (FTP)delete process duplicated                       //~v5d7I~
//v5c9:040331 (FTP:BUG)macro should not contain ";" for use under the condition of if-then-else//~v5c9I~
//v5bv:040222 (FTP)use resident ftp client pgm because mdos prompt appear each time under WXE//~v5bvI~
//v5bo:040211 (FTP)password cryptograph                            //~v5boI~
//v5b1:040115 (FTP)tempdir del option for test                     //~v5b1I~
//v5ak:040108 (WIN-FTP:BUG)dir dele fail by wind dirsepc           //~v5akI~
//v5aj:040108 (FTP)allow file for udosfindfirst like as win        //~v5ajI~
//v5af:040106 pass PUFTPHOST as parm not but nodename to chk TZ,SJIS option etc//~v5aeI~
//v5ae:040105 solaris time stamp fmt is mmdd yyyyN            //~v5aeI~
//v5ad:040105 support TZ=hhmm and DBCS=EUC/SJIS                    //~v5adI~
//v5ab:040104 integrate ROOTDIR2--->ROOTDIR3                       //~v5abI~
//v59d:030816 ftp support
//******************************************************
#ifdef FTPSUPP                                                     //~v59dI~
                                                                   //~v59dI~
#ifdef GBLDEF_FTP                                                  //~v59dI~
	int Gftpopt;                                                   //~v59dI~
#else                                                              //~v59dI~
	extern int Gftpopt;                                            //~v59dI~
#endif                                                             //~v59dI~
#define GFTPO_AVAIL     0x01    //ftp initialized                  //~v59dI~
//******************************************************           //~v59dI~
typedef int (FTPCMD_CALLBACK)(FILE *,void *Ppvoid);	//uftpcmd callback func//~v59dR~
                                                                   //~v59dI~
#define FTP_WINDOWSZ  65536 	//default ftp windowsize           //~v5dzR~
#define FTP_REMOTEID  ':'		//remote fine name seperater       //~v59dM~
#define FTP_ROOTUSER    "root"                                     //~v59dI~
#define FTP_HDIRMASK    0xffffff00 	//hdir chk mask for FTP        //~v59dI~
#define FTP_HDIRIDXMASK 0x000000ff 	//hdir table index mask for FTP//~v59dI~
#define FTP_HDIRID      0xff11ee00 	//hdir id  for FTP             //~v59dI~
                                                                   //~v59dI~
#define FTP_CHMODMASK   07777                                      //~v59dI~
#ifndef UNX
  #ifndef S_IFMT    //windows sys/stat.h has definition            //~v59dI~
    #define S_IFMT 	0170000		/*   mask               0xf000*/   //~v59dR~
  #endif                                                           //~v59dI~
  #ifndef S_IFREG   //windows sys/stat.h has definition            //~v59dI~
    #define S_IFREG	0100000		/*   reguler            0x8000*/   //~v59dR~
  #endif                                                           //~v59dI~
  #ifndef S_IFDIR   //windows sys/stat.h has definition            //~v59dI~
    #define S_IFDIR	0040000		/*   directory          0x4000*/   //~v59dR~
  #endif                                                           //~v59dI~
    #define S_IFBLK 	0060000		/*   block special      0x6000*///~v59dR~
  #ifndef S_IFCHR   //windows sys/stat.h has definition            //~v59dI~
    #define S_IFCHR 	0020000		/*   character special  0x2000*///~v59dR~
  #endif                                                           //~v59dI~
	#define S_IFLNK 	0120000		/* symbolic link        0xa000*///~v59dR~
    #define S_IFIFO 	0010000		/*   fifo               0x1000*///~v59dR~
	#define S_IFSOCK 	0140000		/* socket               0xc000*///~v59dR~

    #define  __S_ISTYPE(mode,mask)  ((mode & S_IFMT) == (mask))    //~v59dR~
	#define  S_ISDIR(mode)	__S_ISTYPE((mode),S_IFDIR)             //~v59dR~
	#define  S_ISBLK(mode)	__S_ISTYPE((mode),S_IFBLK)             //~v59dR~
	#define  S_ISCHR(mode)	__S_ISTYPE((mode),S_IFCHR)             //~v59dR~
	#define  S_ISLNK(mode)	__S_ISTYPE((mode),S_IFLNK)             //~v59dR~
	#define  S_ISFIFO(mode)	__S_ISTYPE((mode),S_IFIFO)             //~v59dR~
	#define  S_ISSOCK(mode) __S_ISTYPE((mode),S_IFSOCK)            //~v59dR~

	#define S_IRWXU 	0000700		/* 0x01c0 owner mask             */
	#define S_IRUSR 	0000400		/* 0x0100 read permission: owner */
	#define S_IWUSR		0000200		/* 0x0080 write permission: owner */
	#define S_IXUSR		0000100		/* 0x0040 execute/search permission: owner */
	#define S_IRWXG 	0000070		/* 0x0038 group mask             */
	#define S_IRGRP 	0000040		/* 0x0020 read permission: owner */
	#define S_IWGRP		0000020		/* 0x0010 write permission: owner */
	#define S_IXGRP		0000010		/* 0x0008 execute/search permission: owner */
	#define S_IRWXO 	0000007		/* 0x0007 other mask             */
	#define S_IROTH 	0000004		/* 0x0004 read permission: owner */
	#define S_IWOTH		0000002		/* 0x0002 write permission: owner */
	#define S_IXOTH		0000001		/* 0x0001 execute/search permission: owner */
	#define S_ISUID     0004000		/* 0x0800 set user id on execution */
	#define S_ISGID     0002000		/* 0x0400 set group id on execution */
	#define S_ISVTX     0001000		/* 0x0200 sticky */

    #define ELOOP 40        //symbolic link loop                   //~v5akI~
                                                                   //~v5akI~
#endif //not UNX                                                   //~v59dR~

#define FTP_DIR_SEPC     '/'                                       //~v59dI~
#define FTP_DIR_SEPS     "/"                                       //~v59dI~
#define FTP_DIR_ALLMEMB  "*"                                       //~v5akI~
#define FTP_ROOTDIR(fname) (*(fname)=='/' && *((fname)+1)==0) //root id//~v59dR~
#define FTP_PATHLEN(fname) (uftppathlen(fname))                    //~v59dR~
#define FTP_HOSTNAMELEN 8   //node id name max length
#define FTP_USERNAMELEN 16  //ftp user name max length
#define FTP_PSWDNAMELEN 16  //ftp pswd max length
#define FTP_IPADNAMELEN 15  //ftp pswd max length
#define FTP_MAXPATH    512                                         //~v59dI~
#define FTP_ROOTDIRPOS   0                                         //~v59dI~
#define FTP_GETHOSTN(pathname,hostnmlen,hostnm) \
    				memcpy(hostnm,pathname,hostnmlen), /*;*/   \
    				*(hostnm+hostnmlen)=0;                         //~v59dI~
#define FTP_SETPATHN(hostnmlen,hostnm,fname,pathname) \
    				memcpy(pathname,hostnm,hostnmlen), /*;*/  \
    				*(pathname+hostnmlen)=FTP_REMOTEID, /*;*/  \
    				strcpy(pathname+hostnmlen+1,fname);            //~v59dR~
                                                                   //~v59dI~
typedef struct _UFTPHOST{   //ftp node table
					  UQUEE    UFTPHqe;
                      ULONG    UFTPHflag;                          //~v59dR~
#define UFTPHFROOT    0x0001   //root user                         //~v59dI~
#define UFTPHFSJIS    0x0002   //sjis                              //~v5adI~
#define UFTPHFEUC     0x0004   //eus                               //~v5adI~
#define UFTPHFAJUST   0x0008   //tz specified                      //~v5afR~
#define UFTPHFTSO     0x0010   //host is mainframe TSO             //~v5j4I~
#define UFTPHISTSO(puftph)  (puftph && (puftph->UFTPHflag & UFTPHFTSO))//+v5j4R~
                      int      UFTPHport;     //port of 3270emulator//~v5j4R~
                      int      UFTPHtz;       //time zone by minute//~v5adI~
                      int      UFTPHhostnmlen;//UFTPhost len       //~v5aeI~
                      UCHAR    UFTPHhost[FTP_HOSTNAMELEN+1];
                      UCHAR    UFTPHuser[FTP_USERNAMELEN+1];
                      UCHAR    UFTPHpswd[FTP_PSWDNAMELEN+1];
                      UCHAR    UFTPHipad[FTP_IPADNAMELEN+1];
                      UCHAR    UFTPHcwd[FTP_MAXPATH];	//current dir//~v59dR~
                      UCHAR    UFTPHhome[FTP_MAXPATH];	//homedir  //~v59dR~
                    } UFTPHOST, *PUFTPHOST;
#define UFTPHOSTSZ (sizeof(UFTPHOST))
                                                                   //~v59dI~
#define FTPWILDLEN   64                                            //~v59dI~
typedef struct _UFTPDIRH{   //ftp readdir handle                   //~v59dR~
                      PUFTPHOST   UFTPDHpuftph;    //nodetbl       //~v5aeI~
                      PUDIRLIST   UFTPDHpudl;      //pudl top      //~v59dI~
                      int         UFTPDHnpos;      //next readdir pos//~v59dI~
                      ULONG       UFTPDHattr;                      //~v59dI~
                      char        UFTPDHwild[FTP_MAXPATH];         //~v59dI~
                    } UFTPDIRH, *PUFTPDIRH;                        //~v59dI~
#define UFTPDIRHSZ (sizeof(UFTPDIRH))                              //~v59dI~
//*******************************************************
#define FTPRC_OPENERR         101
#define FTPRC_LOGONERR        102
#define FTPRC_PARSEERR        103
#define FTPRC_FULLPATHERR     104
#define FTPRC_NOTDEFNODE      105
#define FTPRC_INTERNALERR     106
#define FTPRC_NOMOREFILE      128                                  //~v5d7I~
#define FTPRC_NOTSUPPORTED    ENOSYS //109                         //~v59dR~
//*********************************************************************************//~v59dR~
//110 Restart marker reply. RESTR}ĥ߂̃}[J[ԓł //~v59dI~
//120 Service ready in nnn minutes. T[rX͒~Ă邪Annnɏł//~v59dI~
//125 Data connection already open; transfer starting. f[^RlNV͂łɊmĂB̃RlNVœ]Jn//~v59dI~
//150 File status okay; about to open data connection. t@CXe[^X͐łBf[^RlNVm//~v59dI~
//200 Command okay. R}h͐Ɏ󂯓ꂽ                 //~v59dI~
//202 Command not implemented, superfluous at this site. R}h͎ĂȂBSITER}hOSR}hK؂łȂꍇȂ//~v59dI~
//211 System status, or system help reply. STATR}hɑ΂郌X|X//~v59dI~
//212 Directory status. STATR}hɂfBNg   //~v59dI~
//213 File status. STATR}hɂt@C            //~v59dI~
//214 Help message. HELPR}hɑ΂郌X|X                 //~v59dI~
//215 NAME system type. SYSTR}hɑ΂郌X|X             //~v59dI~
//220 Service ready for new user. VK[U[ɏBOCɕ\ꍇz肵Ă//~v59dI~
//221 Service closing control connection. Rg[RlNVؒfBQUITR}h̃X|X//~v59dI~
//225 Data connection open; no transfer in progress. f[^RlNVmBf[^̓]͍sĂȂ//~v59dI~
//226 Closing data connection. vꂽNGXg͐Bf[^RlNVN[Y//~v59dI~
//227 Entering Passive Mode (h1,h2,h3,h4,p1,p2). PASVR}hւ̃X|XBh1`h4IPAhXAp1`p2̓|[gԍ//~v59dI~
//230 User logged in, proceed. [U[OC̐              //~v59dI~
//250 Requested file action okay, completed. vꂽR}hɂ鑀͐I//~v59dI~
//257 "PATHNAME" created. t@CfBNg쐬Ƃ̂RFCł̈ӖAMKDR}ȟʈȊOɂAۂɂPWDR}ȟʂɂp//~v59dI~
//331 User name okay, need password. pX[h̓͂߂      //~v59dI~
//332 Need account for login. ACCTR}hŉۋw肷Kv//~v59dI~
//350 Requested file action pending further information ̉炩̏߂Ă//~v59dI~
//421 Service not available, closing control connection. T[rX񋟂łȂBRg[RlNVIBT[õVbg_EȂ//~v59dI~
//425 Can't open data connection. f[^RlNVI[vłȂ//~v59dI~
//426 Connection closed; transfer aborted. 炩̌ɂARlNVN[YAf[^]~//~v59dI~
//450 Requested file action not taken. vꂽNGXg̓ANZXt@CVXe̗RŎsłȂ//~v59dI~
//451 Requested action aborted. Local error in processing. [JG[̂ߏ𒆎~//~v59dI~
//452 Requested action not taken. fBXNeʂ̖ŎsłȂ //~v59dI~
//500 Syntax error, command unrecognized. R}h̕@G[     //~v59dI~
//501 Syntax error in parameters or arguments. p[^̕@G[//~v59dI~
//502 Command not implemented. R}h͖ł              //~v59dI~
//503 Bad sequence of commands. R}hp鏇ԂԈĂ //~v59dI~
//504 Command not implemented for that parameter. p[^//~v59dI~
//530 Not logged in. [U[̓OCłȂ                //~v59dI~
//532 Need account for storing files. t@CMɂ́AACCTR}hŉۋmFȂĂ͂ȂȂ//~v59dI~
//550 Requested action not taken. vꂽNGXg̓ANZXt@CVXe̗RŎsłȂ//~v59dI~
//551 Requested action aborted. Page type unknown. y[W\̃^Cv̖ŎsłȂ//~v59dI~
//552 Requested file action aborted. fBXNeʂ̖ŎsłȂ//~v59dI~
//553 Requested action not taken. t@CԈĂ邽ߎsłȂ//~v59dI~
                                                                   //~v59dI~
#define FTPRESPID_XCOMP "226 "                                     //~v59dI~
//*******************************************************
//int uftpinit(int Popt,char *Plogfnm,char *Phostsfnm);            //~v5bvR~
int uftpinit(int Popt,char *Plogfnm,char *Phostsfnm,char *Pclientpgm);//~v5bvI~
#define  UFTPO_NOP     0x01     //no ftp support                   //~v59dR~
#define  UFTPO_LOG     0x02                                        //~v59dI~
#define  UFTPO_APPEND  0x04     //append mode                      //~v59dR~
#define  UFTPO_KEEPWD  0x08     //keep work dir for test           //~v5b1I~
//*******************************************************          //~v59dI~
int uftpterm(void);                                                //~v59dR~
//*******************************************************          //~v59dI~
unsigned uftpdirlist(PUFTPHOST Ppuftph,char *Pfpath,ULONG Pattr,PUDIRLIST *Pppudl,int *Ppentno);//~v5aeR~
//*******************************************************          //~v59dI~
unsigned int uftpfstatudl(PUFTPHOST Ppuftph,int Popt,char *Pfpnm,PUDIRLIST Ppudl);//~v5aeR~
#define FTPSUD_SLINK     0x01                                      //~v59dI~
//*******************************************************          //~v59dI~
int uftppathlen(char *Pfilename);
//*******************************************************          //~v59dI~
PUFTPHOST uftpnodesrch(char *Pnode);
//*******************************************************          //~v59dI~
int uftpnodeadd(PUFTPHOST Ppuftph);                                //~v5afI~
//*******************************************************          //~v59dI~
int uftpnodedel(char *Pnode);
//*******************************************************          //~v59dI~
void uftpnodeclear(void);                                          //~v59dI~
//*******************************************************          //~v59dI~
UQUEH *uftpgethostqhaddr(void);                                    //~v59dI~
//*******************************************************          //~v59dI~
int uftpcmd(PUFTPHOST Ppuftph,int Popt,char *Pcmd,char ***Pstdo,int *Pstdoctr,FTPCMD_CALLBACK *Pfunc,void *Ppvoid);//~v5aeR~
#define FTPCMD_BINARY  0x01                                        //~v59dM~
//*******************************************************          //~v59dM~
int uftpcmdrespchk(char **Pstdo,int Pstdoctr);                     //~v59dM~
//*******************************************************          //~v59dI~
int uftpnextstdo(char ***Ppstdo,int *Ppstdoctr);                   //~v59dM~
//*******************************************************          //~v59dI~
int uftpsrchfname(PUFTPHOST Ppuftph,char **Pstdo,int Pstdoctr,char *Pfname,PUDIRLIST Ppudl);//~v5afR~
//*******************************************************          //~v59dI~
int uftpgetdl(PUFTPHOST Ppuftph,char **Pstdo,int Pstdoctr,PUDIRLIST *Pppudl,int *Pentno);//~v5afR~
//*******************************************************          //~v59dI~
int uftpgetdl1(PUFTPHOST Ppuftph,char *Prec,PUDIRLIST Ppudl);      //~v5afR~
//*******************************************************          //~v59dI~
int uftpcmdsrchrespid(char ***Ppstdo,int *Ppstdoctr,char *Pokrespid);//~v59dR~
#define UFCSRRC_EOL          -1     //not found                    //~v59dR~
//*******************************************************          //~v59dI~
void uftpudl2ffb3(PUDIRLIST Ppudl,FILEFINDBUF3 *Ppffb3);           //~v59dR~
//*******************************************************          //~v59dI~
int uftpopendir(PUFTPHOST Ppuftph,char *Pfpath,ULONG Pattr,ULONG *Phdir,int *Pentno);//~v5aeR~
//*******************************************************          //~v59dI~
int uftpreaddir(int Phdir,PUDIRLIST *Pppudl);                      //~v59dR~
//*******************************************************          //~v59dI~
int uftpclosehdir(int Phdir);                                      //~v59dI~
//*******************************************************          //~v59dI~
int uftpdirlistslink(PUFTPHOST Ppuftph,char *Pfpnm,PUDIRLIST Ppudl,int Pentno);//~v5aeR~
//*******************************************************          //~v59dI~
int uftplog(int Popt,char *Pline);                                 //~v59dM~
#define FTPLOG_REQ 	0x01                                           //~v59dI~
#define FTPLOG_RESP	0x02                                           //~v59dI~
#define FTPLOG_ADDLF   0x04                                        //~v59dI~
#define FTPLOG_PSWD    0x08    //del password on log               //~v59dI~
//*******************************************************          //~v59dI~
int uftpsrchfnameslink(PUFTPHOST Ppuftph,char ***Pstdo,int *Ppstdoctr,char *Pfname,PUDIRLIST Ppudl);//~v5afR~
//*******************************************************          //~v59dI~
int uftpgethostsdata(char *Pdata,int Plen,PUFTPHOST Ppufh);        //~v59dI~
//*******************************************************          //~v59dI~
int uftpipachk(char *Pipa,ULONG *Ppxipa);                          //~v59dI~
//*******************************************************          //~v59dI~
int uftphoststbinit(char *Phostsfnm);                              //~v59dI~
//*******************************************************          //~v59dI~
int uftpsimplerespchk(char *Pcmd,char *Prespid,char *Pfname,char ***Ppstdo,int *Ppstdoctr,int Prc);//~v59dI~
//*******************************************************          //~v59dI~
int uftpisexist(PUFTPHOST Ppuftph,char *Pfpath);                   //~v5aeR~
//******************************************************           //~v59dM~
int uftpisremote(char *Pfpath,PUFTPHOST *Pppuftph);                //~v5aeI~
//******************************************************           //~v59dI~
//int uftpajustjst(PUFTPHOST Ppuftph,FDATE *Ppfdate,FTIME *Ppftime);//~v5dfR~
int uftpajustjst(int Popt,PUFTPHOST Ppuftph,FDATE *Ppfdate,FTIME *Ppftime);//~v5dfI~
#define UFAJO_GMT  0x01                                            //~v5dfI~
//******************************************************           //~v5abI~
int uftpisrootdir(char *Pfpath);                                   //~v5abI~
//******************************************************           //~v5ajI~
int uftpattrselect(ULONG Pfattr,ULONG Pfattrsrc,ULONG Ppattr);     //~v5ajM~
//******************************************************           //~v5b1I~
int uftpmktempwd(char *Ptempfnm);                                  //~v5b1R~
//******************************************************           //~v5b1I~
int uftpdeltempwd(char *Ptempfnm);                                 //~v5b1I~
//******************************************************           //~v5boI~
int uftphostscrypt(int Popt,char *Pipswd,char *Popswd);            //~v5boI~
//******************************************************           //~v5exI~
char *uftptempnam(char *Phost,char *Pprefix,char *Ptempfile);      //~v5exI~
#endif //FTPSUPP                                                   //~v59dI~
