//*CID://+v590R~:                             update#=    5;       //~v590R~
//*********************************************************************
//ulibdef.h                                                        //~v321R~
//  include from ulib.h when the case except <os2.h> is included.  //~v053I~
//*********************************************************************
//v590:030913 define MAX_INTVAL                                    //~v590R~
//v547:020330 (WIN)keep ctime(creatio time)/atime(last access time) for xff cmd//~v547I~
//v321 000729:UNIX support                                         //~v321I~
//v053:970107:gcc version(control by DPMI)                         //~v053I~
//            -missing macro min,max,_MAX_PATH                     //~v053I~
//            -short int is not int but short int                  //~v053I~
//v038:961024:define HANDLE for the case <windows.h> not included  //~v038I~
//v023:960825:copy from os2.h to shorten compile time              //~v023I~
//v022:960727:WIN32(CONSOLE api)                                   //~v022I~
//*********************************************************************//~v189I~
#ifdef DOS                                                         //~v022R~
  #ifdef DPMI					//DPMI version                     //~v053I~
	#define SHORT    short           /* s   */                     //~v053I~
	typedef unsigned short USHORT;   /* us  */                     //~v053I~
	typedef USHORT  *PUSHORT;                                      //~v053I~
    #define MAX_INT_VAL  0x7fffffff                                //+v590R~
  #else                       //not DPMI                           //~v053I~
	#define SHORT    int             /* s   */                     //~v022R~
	typedef unsigned int   USHORT;   /* us  */                     //~v022R~
	typedef USHORT  *PUSHORT;                                      //~v022R~
    #define MAX_INT_VAL  0x7fff                                    //+v590R~
  #endif                      //DPMI or not                        //~v053I~
  #define VOID     void                                            //~v053I~
#else		//w95 or os2 without os2.h                             //~v022R~
    #define MAX_INT_VAL  0x7fffffff                                //+v590R~
    #ifndef _INC_WINDOWS   //os2 without os2.h,w95 without windows.h//~v022R~
        #define VOID     void                                      //~v053I~
		#define SHORT    short           /* s   */                 //~v022R~
		typedef SHORT   *PSHORT;                                   //~v022R~
		typedef unsigned short  USHORT;  /* us  */                 //~v022R~
		typedef USHORT  *PUSHORT;                                  //~v022R~
		typedef void    *HANDLE;                                   //~v038I~
//* to avoid include windows.h                                     //~v547I~
		typedef struct _FILETIME{                                  //~v547I~
                					unsigned int dwLowDateTime;    //~v547R~
                					unsigned int dwHighDateTime;   //~v547R~
                				} FILETIME;                        //~v547I~
	#endif                                                         //~v022R~
#endif                                                             //~v022M~
//when os2,without os2.h                                           //~v022R~
	#define APIRET      ULONG                                      //~v022R~
	#define APIRET16 	USHORT                                     //~v021I~//~v022R~
	typedef unsigned long    LHANDLE;                              //~v023I~
#ifndef _INC_WINDOWS   //dos,os2 without os2.h,w95 without windows.h//~v022R~
	typedef unsigned char  UCHAR;   /* uch */                      //~v022R~
	typedef UCHAR *PUCHAR;                                         //~v022R~
	typedef char CHAR;            /* ch  */                        //~v022R~
	typedef CHAR *PCHAR;                                           //~v022R~
	typedef char BYTE;     /* b   */                               //~v022R~
	typedef BYTE *PBYTE;                                           //~v022R~
	typedef char *PSZ;                                             //~v022R~
	typedef char *PCH;                                             //~v022R~
	typedef unsigned long  ULONG;   /* ul  */                      //~v022R~
	typedef ULONG *PULONG;                                         //~v022R~
	typedef long   LONG;           /* l   */                       //~v022R~
	typedef LONG *PLONG;                                           //~v022R~
	typedef unsigned int   UINT;                                   //~v022R~
	typedef int            INT;                                    //~v022R~
	typedef VOID   *PVOID;                                         //~v022R~
	typedef PVOID  *PPVOID;                                        //~v022R~
#endif                                                             //~v022R~
//*copy from os2.h for shorten compile time                        //~v023I~
#ifdef UNX                                                         //~v321R~
	#include <ulibunx.h>                                           //~v321R~
#else                                                              //~v321R~
#ifdef DOS                                                         //~v023I~
    #ifdef DPMI					//DPMI version                     //~v053I~
        #define max(a,b) (((a)>(b)) ? (a):(b))                     //~v053I~
        #define min(a,b) (((a)<(b)) ? (a):(b))                     //~v053I~
        #define _MAX_PATH 260        /*same as MSC6*/              //~v053R~
    #else                       //not DPMI                         //~v053I~
    #endif                      //DPMI or not                      //~v053I~
#else                                                              //~v023I~
    #ifdef W32                                                     //~v023I~
    #else                       //os2                              //~v023I~
		#include <ulibos2.h>                                       //~v023R~
	#endif                                                         //~v023I~
#endif                                                             //~v023I~
#endif                                                             //~v321R~
