//*CID://+v5g6R~:                             update#=   12;       //+v5g6R~
//*********************************************************************//~v131I~
//* define --common to DOS/OS2/WIN95/UNX/LNX                       //~v321R~
//*********************************************************************//~v131I~
//v5g6:050613 (XXE)xxe support                                     //+v5g6I~
//v5c3:040325 (WIN)#define WINCON                                  //~v5c3I~
//v59u:031223 ftp support:DIR_ALL_MEMB is common to WIN and UNX(="*")//~v59uI~
//v59d:030816 ftp support                                          //~v59dI~
//v59b:031027 OSTYPE='A' for aix                                   //~v59bI~
//v57g:021229 ucs conv support except native dos                   //~v57gI~
//v421:010101 TLinux:libc5 stdlib.h include errno.h,but libc2 is not.//~v421I~
//v40m:001128 AIX support:Big endian                               //~v40mI~
//v344:000925 LINUX support(command flag parm prefix is "-" not "/")//~v344I~
//v321 000729:UNIX support                                         //~v321R~
//v208:981223 uimage.h                                             //~v208I~
//v189:980802 UGETVALUE macro                                      //~v189I~
//v131:971220 OSTYPE macro to ulibdef.h                            //~v131I~
//*********************************************************************//~v131I~
#define ENTNOOF(tbl) (sizeof(tbl)/sizeof(tbl[0]))                  //~v321I~
#define ENTNOOF2(tbl) (sizeof(tbl)/sizeof(tbl[0][0]))              //~v321I~
#ifdef UNX                                                         //~v321R~
    #ifdef XXE                                                     //+v5g6I~
        #define W32XXE                                             //+v5g6I~
        #define WXEXXE                                             //+v5g6I~
    #endif                                                         //+v5g6I~
	#ifdef LNX           //linux                                   //~v321I~
    	#define	OSTYPE 'L'                                         //~v321I~
        #ifdef LNXLC2                                              //~v421I~
            #include <errno.h>     //alternatve libc5 stdlib.h     //~v421I~
        #endif                                                     //~v421I~
    #else                //unix                                    //~v321I~
//  	#define	OSTYPE 'U'                                         //~v59bR~
    	#define	OSTYPE 'A'                                         //~v59bI~
        #define BIGENDIAN          //for AIX                       //~v40mI~
    #endif                                                         //~v321I~
    #define FTPSUPP         //ftp support=yes for win and unx      //~v59dI~
    #define DIR_SEPC  '/'                                          //~v321R~
    #define DIR_SEPS  "/"                                          //~v321I~
    #define DIR_ALLMEMB "*"                                        //~v321I~
    #define CMDFLAG_PREFIX  '-'                                    //~v344I~
    #define CMDFLAG_PREFIX2 '/'                                    //~v344I~
//check command flag for parm ***************************          //~v344I~
//  '-':flag,'/' flag when not 1st parm of except '-'              //~v344I~
    #define CMDFLAGCHK(topbyte,secondsw) /* top byte and parm seqno except flag*/\
       ( ((topbyte)==CMDFLAG_PREFIX) ? 1 :   /* flag if '-' */\
            ( ((topbyte)!=CMDFLAG_PREFIX2) ? 0 : /* parm if not '-' and '/'*/\
                 ( (secondsw) ? 1 : 0 ) ) )/*1st "/" is parm*/     //~v344R~
#else                                                              //~v321R~
    #define DIR_SEPC '\\'                                          //~v321R~
    #define DIR_SEPS "\\"                                          //~v321I~
  #ifdef W32                                                       //~v59uI~
    #define DIR_ALLMEMB "*"                                        //~v59uI~
  #else                                                            //~v59uI~
    #define DIR_ALLMEMB "*.*"                                      //~v321I~
  #endif                                                           //~v59uI~
    #define CMDFLAG_PREFIX  '/'                                    //~v344M~
    #define CMDFLAG_PREFIX2 '-'                                    //~v344M~
//check command flag for parm ***************************          //~v344I~
//  '-':flag,'/' flag when not 1st parm of except '-'              //~v344I~
    #define CMDFLAGCHK(topbyte,secondsw) /* top byte and parm seqno except flag*/\
       ( ((topbyte)==CMDFLAG_PREFIX) ? 1 :   /* flag if '/' */\
            ( ((topbyte)!=CMDFLAG_PREFIX2) ? 0 : 1 ) ) /* parm if not '-' and '/'*///~v5bhR~
#ifdef DOS                                                         //~v131I~
	#ifdef DPMI                                                    //~v131I~
        #define DOSGCC      //id of gcc dos                        //~v57gI~
    	#define	OSTYPE 'G'                                         //~v131I~
	#else                                                          //~v131I~
        #define DOSDOS      //id of native dos                     //~v57gI~
    	#define	OSTYPE 'D'                                         //~v131I~
	#endif        	                                               //~v131I~
#else                                                              //~v131I~
	#ifdef W32                                                     //~v131I~
        #define W32XXE                                             //+v5g6I~
    	#define	OSTYPE 'W'                                         //~v131I~
    	#define FTPSUPP         //ftp support=yes for win and unx  //~v59dI~
        #ifndef WXE                                                //~v5c3I~
        	#define WINCON		//windows console version          //~v5c3I~
        #else                                                      //+v5g6I~
	        #define WXEXXE                                         //+v5g6I~
        #endif                                                     //~v5c3I~
	#else                                                          //~v131I~
    	#define	OSTYPE '2'                                         //~v131I~
	#endif                                                         //~v131I~
#endif                                                             //~v131I~
#endif                                                             //~v321R~
//*********************************************************************//~v189I~
#define UGETPV(type,ptr) ( *(type*)( (unsigned long)(ptr) ) )      //~v189R~
//*********************************************************************//~v208I~
#ifndef _WINNT_                                                    //~v208I~
//*****                                                            //~v208I~
//*for uimage.h  copy from windef.h                                //~v208I~
//*****                                                            //~v208I~
    typedef unsigned short         WCHAR;                          //~v208I~
                                                                   //~v208I~
    #ifdef DOS                                                     //~v208I~
		#ifdef DPMI                                                //~v208I~
			typedef unsigned long       DWORD,*PDWORD;             //~v208R~
			typedef unsigned short      WORD,PWORD;                //~v208R~
        #else                                                      //~v208I~
			typedef unsigned long       DWORD,*PDWORD;             //~v208I~
			typedef unsigned int        WORD,PWORD;                //~v208I~
        #endif                                                     //~v208I~
    #else                                                          //~v208I~
		typedef unsigned int        DWORD,*PDWORD;                 //~v208I~
		typedef unsigned short      WORD,PWORD;                    //~v208I~
    #endif                                                         //~v208I~
//*****                                                            //~v208I~
#endif                                                             //~v208I~
