//*CID://+v5jpR~:                              update#=  321;      //+v5jpR~
//************************************************************* //~5825I~
//*uproc3.c                                                        //~v5gbR~
//* ushellexec,uprocconnect                                        //~v5jaR~
//*************************************************************    //~v022I~
//v5jq:061103 (3270) pipe read err msg(remains more data)          //~v5jpI~
//v5jn:061024 (BUG:FC5)gnome_vfs\mine_get_default_application_type is deprecated.//~v5jnI~
//            rh9:gnome_vfs_mime_get_default_application return null if type is not application//~v5jnI~
//            fc5:return type is 0 but application is returned to schecyule cmd//~v5jnI~
//v5jm:061022 (XXE:3270:BUG)r-btn-down issue assertion fail localfullpath[0]=='/ etc//~v5jmI~
//v5ja:060921 (LNX)3270 support                                    //~v5jaI~
//v5j5:060914 named pipe server                                    //~v5j5I~
//v5gc:050709 (LNX)child shell create function for spawn terminalsim screen//~v5gcI~
//v5gb:050709 move ushellexex to uproc3.c to avoid gnome link for xsub utility//~v5gbI~
//v5ga:050708 (UNX:BUG)space enclosing is not required for LNX,spawn cmd fail. See v082//~v5g9R~
//v5g9:050708 (LNX)openwith support                                //~v5g9M~
//v5es:041031 (BUG)stderr ptr should be safe to be cleared         //~v5csI~
//v5cw:040516 (WXE)it should be notified to cmd server of cd drive id change//~v5cwI~
//v5cs:040509 (WIN:BUG)_tempnam  returns prefix itself if prefix length >=8//~v5csI~
//                     and loop when the only one name exist       //~v5csI~
//v5cc:040414 (WXE)confirm xesyscmd.exe is alive before write to pipe//~v5ccI~
//v5by:040229 shellexecute(open with application by ext association) support//~v5byI~
//************************************************************* //~5825I~
#include <time.h>                                               //~5825I~
#include <stdio.h>                                              //~5825I~
#include <stdlib.h>                                             //~5825I~
#include <stddef.h>	//offsetof                                     //~v5jaI~
#include <string.h>                                             //~5825I~
#include <stdarg.h>                                             //~5A10I~
#include <errno.h>                                              //~5A10I~
#include <fcntl.h>                                                 //~v59jI~
#ifdef UNX                                                         //~v327I~
  #ifdef LNX                                                       //~v59jI~
	#include <sys/wait.h>                                          //~v59jI~
	#include <term.h>                                              //~v5g9I~
                                                                   //~v5g9R~
//	#include <libgnomevfs/gnome-vfs.h>                             //~v5g9I~
    #include <libgnomevfs/gnome-vfs-init.h>                        //~v5g9R~
	#include <libgnomevfs/gnome-vfs-utils.h>                       //~v5g9R~
//	#include <libgnomevfs/gnome-vfs-mime-info.h>                   //~v5g9I~
	#include <libgnomevfs/gnome-vfs-mime-handlers.h>               //~v5g9I~
	#include <libgnomevfs/gnome-vfs-mime.h>                        //~v5g9I~
  #endif                                                           //~v59jI~
	#include <sys/stat.h>                                          //~v327I~
	#include <unistd.h>                                            //~v428I~
#else                                                              //~v327I~
	#include <process.h>                                           //~v50HI~
#ifdef DOS                                                      //~5825I~
#else                                                           //~5825I~
    #ifdef W32                                                     //~v022I~
        #include <windows.h>                                       //~v316I~
        #include <dos.h>                                           //~v065I~
        #include <io.h>                                            //~v59jI~
    #else                                                          //~v022I~
    #endif                                                         //~v022I~
#endif                                                          //~5825I~
#endif   //!UNX                                                    //~v327I~
                                                                   //~v022I~
#include <ulib.h>                                               //~5825I~
#include <ualloc.h>                                                //~v5jaR~
#include <uque.h>                                                  //~v5jmI~
#include <uerr.h>                                                  //~v5jaI~
#include <uproc.h>                                              //~5A10I~
#include <uparse.h>                                                //~v5gcI~
#include <ufile.h>                                                 //~v064I~
#ifdef UNX                                                         //~v327I~
	#include <ufile2l.h>                                           //~v327I~
	#ifdef LNX                                                     //~v5g9I~
		#include <ukbdl.h>                                         //~v5g9I~
	#endif                                                         //~v5g9I~
#endif                                                             //~v327I~
#include <uftp.h>                                                  //~v5jmI~
#include <utrace.h>                                                //~v5j5I~
#include <u3270.h>                                                 //~v5jpI~
//*********************************************                    //~v064R~
#ifdef LNX                                                         //~v5gcI~
	int ulnxlgettermpgmopt(int Ptermsimid,char *Ptermsimname,char *Poptprefix);//~v5gcI~
#endif                                                             //~v5gcI~
#ifdef W32                                                         //~v5gcI~
char *ushellexecerrmsg(ULONG Perrid);                              //~v5gcI~
#endif                                                             //~v5gcI~
int uprocpiperecevmsg(ULONG Phpipe,char *Precvmsg,int Precvbuffsz,int *Ppreadlen,char **Ppdata,int *Ppdatalen);//~v5jaI~
int uprocpiperead(ULONG Phpipe,char *Pbuff,int Preqlen,int *Ppreadlen);//~v5jaR~
int uprocpipeiodata(ULONG Phpipe,char *Pbuff,int Pbufflen,int Preqlen,int *Ppreadlen);//~v5jaI~
//*********************************************                    //~v064R~
#ifdef W32                                                         //~v5byI~
//**************************************************************** //~v5byI~
//*start application by ext association                            //~v5byI~
//*rc:ret code                                                     //~v5byI~
//**************************************************************** //~v5byI~
int ushellexec(char *Pfname)                                       //~v5byI~
{                                                                  //~v5byI~
    int showcmd,rc;                                                //~v5byI~
    HINSTANCE hi;                                                  //~v5byI~
    ULONG ulrc;                                                    //~v5byI~
    char *pseerrmsg;                                               //~v5byI~
//********************************                                 //~v5byI~
    showcmd=SW_SHOW;                                               //~v5byI~
    hi=ShellExecute(HWND_DESKTOP,"open",Pfname,                    //~v5byR~
				NULL, //parm                                       //~v5byI~
				NULL, //default dir                                //~v5byI~
                showcmd);                                          //~v5byI~
    ulrc=(ULONG)hi;                                                //~v5byI~
    if (ulrc<=32)                                                  //~v5byI~
    {                                                              //~v5byI~
        pseerrmsg=ushellexecerrmsg(ulrc);                          //~v5byI~
    	uerrmsg("ShellExecute failed for \"%s\",rc=%ld(%s)",0,     //~v5byI~
					Pfname,ulrc,pseerrmsg);                        //~v5byI~
        rc=4;                                                      //~v5byI~
    }                                                              //~v5byI~
    else                                                           //~v5byI~
    	rc=0;                                                      //~v5byI~
    return rc;                                                     //~v5byI~
}//ushellexec                                                      //~v5byI~
//**************************************************************** //~v5byI~
//*start application by ext association                            //~v5byI~
//*rc:ret code                                                     //~v5byI~
//**************************************************************** //~v5byI~
char *ushellexecerrmsg(ULONG Perrid)                               //~v5byI~
{                                                                  //~v5byI~
	char *perrmsg;                                                 //~v5byI~
//********************************                                 //~v5byI~
	switch(Perrid)                                                 //~v5byI~
    {                                                              //~v5byI~
    case SE_ERR_FNF:           //2       // file not found         //~v5byI~
        perrmsg="file not found";                                  //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_PNF:           //3       // path not found         //~v5byI~
        perrmsg="path not found";                                  //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_ACCESSDENIED:  //5       // access denied          //~v5byI~
        perrmsg="access denied";                                   //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_OOM:          // 8       // out of memory          //~v5byI~
        perrmsg="out of memory";                                   //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_DLLNOTFOUND:    //       32                        //~v5byI~
        perrmsg="dll not found";                                   //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_SHARE:          //       26                        //~v5byI~
        perrmsg="sharing vioration";                               //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_ASSOCINCOMPLETE:  //     27                        //~v5byI~
        perrmsg="incomplete association";                          //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_DDETIMEOUT:         //   28                        //~v5byI~
        perrmsg="DDE timeout";                                     //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_DDEFAIL:            //   29                        //~v5byI~
        perrmsg="DDE failed";                                      //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_DDEBUSY:            //   30                        //~v5byI~
        perrmsg="DDE busy";                                        //~v5byI~
        break;                                                     //~v5byI~
    case SE_ERR_NOASSOC:            //   31                        //~v5byI~
        perrmsg="no association";                                  //~v5byI~
        break;                                                     //~v5byI~
    default:                                                       //~v5byI~
        perrmsg="unknown err";                                     //~v5byI~
    }                                                              //~v5byI~
    return perrmsg;                                                //~v5byI~
}//ushellexecerrmsg                                                //~v5byI~
#endif                                                             //~v5byI~
#ifdef LNX                                                         //~v5g9M~
//**************************************************************** //~v5g9I~
//* initialize for gnome vfs                                       //~v5g9I~
//**************************************************************** //~v5g9I~
int uproc_gvfsinit(void)                                           //~v5g9I~
{                                                                  //~v5g9I~
	static int Sinitsw=0;                                          //~v5g9R~
//******************                                               //~v5g9I~
	if (Sinitsw)                                                   //~v5g9I~
    	return 0;                                                  //~v5g9I~
	if (!gnome_vfs_init())                                         //~v5g9I~
    {                                                              //~v5g9I~
		uerrmsg("gnome_vfs_init failed",0);                        //~v5g9I~
		return -1;                                                 //~v5g9I~
	}                                                              //~v5g9I~
    Sinitsw=1;                                                     //~v5g9I~
    return 0;                                                      //~v5g9I~
}//uproc_gvfsinit                                                  //~v5g9I~
int ushellexecsub(char *Pfpath,char *Pcmd,int Ptermuse);           //~v5g9I~
//**************************************************************** //~v5g9M~
//* ulnxopenwidth                                                  //~v5g9M~
//* send file to associated application                            //~v5g9M~
//* rc:1 requre terminal for chkonly option                        //~v5g9M~
//**************************************************************** //~v5g9M~
int ushellexec(int Popt,char *Pfnm)                                //~v5g9I~
{                                                                  //~v5g9M~
int ushellexecsub(char *Pfpath,char *Pcmd,int Ptermuse);           //~v5g9I~
    GnomeVFSMimeActionType actiontype;                             //~v5g9M~
    GnomeVFSMimeApplication *papp;                                 //~v5g9M~
	char *pmimetype,*puri,*pparmname,*pdircmd=0,*pcmd,*pname;      //~v5gbR~
    char fpath[_MAX_PATH];                                         //~v5g9M~
    int rc=0,termsw,simid,termid,actiontypeerr=0,reqterm;          //~v5gbR~
#define MIME_DIR  "x-directory/"                                   //~v5gbI~
#define MIME_DIR_CMD  "nautilus"                                   //~v5gbI~
//*********************                                            //~v5g9M~
	termid=ukbdl_gettermid();                                      //~v5g9R~
    if ((termid & TERM_IDMASK)==TERM_TTYLCONS)                     //~v5g9R~
    {                                                              //~v5g9I~
		if (!(Popt & USHEXE_NOMSG))                                //~v5g9I~
	    	uerrmsg("Open With Application is not avail on console screen",0);//~v5g9R~
    	return -1;		//no mime type defined                     //~v5g9I~
    }                                                              //~v5g9I~
	simid=termid&TERM_SIMID;                                       //~v5g9I~
    if (uproc_gvfsinit())                                          //~v5g9I~
    	return -1;                                                 //~v5g9I~
	if(!ufullpath(fpath,Pfnm,sizeof(fpath)))                       //~v5g9R~
    	return -1;                                                 //~v5g9M~
	if (uftpisremote(fpath,0))  //gnome_vfs assersion fail for "hostid:/" format//~v5jmI~
    	return -1;                                                 //~v5jmI~
    if (ufstat(fpath,0))                                           //~v5gcI~
    {                                                              //~v5gcI~
		uerrmsg("%s not found",0,                                  //~v5gcI~
        		fpath);                                            //~v5gcI~
        return -1;                                                 //~v5gcI~
    }                                                              //~v5gcI~
    puri=gnome_vfs_get_uri_from_local_path(fpath);	// file:///root/... fmt//~v5g9M~
    if (!puri)                                                     //~v5jmI~
    {                                                              //~v5jmI~
		uerrmsg("uri format err(%s)",0,                            //~v5jmI~
        		fpath);                                            //~v5jmI~
    	return -1;                                                 //~v5jmI~
    }                                                              //~v5jmI~
    pmimetype=gnome_vfs_get_mime_type(puri);                       //~v5g9R~
//printf("mimetype=%s from uristr=%s \n",pmimetype,puri);          //~v5g9R~
    if (!pmimetype)                                                //~v5g9R~
    {                                                              //~v5g9I~
		if (!(Popt & USHEXE_NOMSG))                                //~v5g9I~
	    	uerrmsg("MIME type not defined for %s",0,              //~v5g9R~
        				puri);                                     //~v5g9I~
    	return -1;		//no mime type defined                     //~v5g9M~
    }                                                              //~v5g9I~
    papp=gnome_vfs_mime_get_default_application(pmimetype);        //~v5jnI~
  if (!papp)	//no application defined                           //~v5jnI~
  {                                                                //~v5jnI~
    actiontype=gnome_vfs_mime_get_default_action_type(pmimetype);  //~v5g9M~
//printf("mimetype:%s actiontype=%d (0:non,1:app,2:comp)\n",pmimetype,actiontype);//~v5g9R~
    if (actiontype==GNOME_VFS_MIME_ACTION_TYPE_COMPONENT)          //~v5gbI~
    {                                                              //~v5gbI~
		if (strlen(pmimetype)>sizeof(MIME_DIR) && !memcmp(pmimetype,MIME_DIR,sizeof(MIME_DIR)-1))//~v5gbR~
        	pdircmd=MIME_DIR_CMD;                                  //~v5gbI~
        else                                                       //~v5gbI~
        	actiontypeerr=1;                                       //~v5gbI~
    }                                                              //~v5gbI~
    else                                                           //~v5gbI~
//  	if (actiontype!=GNOME_VFS_MIME_ACTION_TYPE_APPLICATION)    //~v5jnR~
        	actiontypeerr=1;                                       //~v5gbI~
    if (actiontypeerr)                                             //~v5gbI~
    {                                                              //~v5g9I~
		if (!(Popt & USHEXE_NOMSG))                                //~v5g9I~
	    	uerrmsg("default action is not defined for MIME type:%s",0,//~v5gbR~
        				pmimetype);                                //~v5g9I~
    	return -1;		//no application binded                    //~v5g9M~
    }                                                              //~v5g9I~
  }//application not defined                                       //~v5jnI~
    if (pdircmd)                                                   //~v5gbI~
    {                                                              //~v5gbI~
    	papp=0;                                                    //~v5gbI~
        pparmname=fpath;                                           //~v5gbI~
        reqterm=0;                                                 //~v5gbI~
        pname=pcmd=pdircmd;                                        //~v5gbI~
    }                                                              //~v5gbI~
    else                                                           //~v5gbI~
    {                                                              //~v5gbI~
//      papp=gnome_vfs_mime_get_default_application(pmimetype);    //~v5jnR~
//printf("mimetype:%s papp=%p\n",pmimetype,papp);                  //~v5g9R~
//printf("id=%s,name=%s,command=%s,can_open_multiple_files=%d,expects_uris=%d,requires_terminal=%d\n",//~v5g9R~
//papp->id,papp->name,papp->command,papp->can_open_multiple_files,papp->expects_uris,papp->requires_terminal);//~v5g9R~
        if (papp->expects_uris==GNOME_VFS_MIME_APPLICATION_ARGUMENT_TYPE_URIS) ////~v5gbR~
            pparmname=puri;                                        //~v5gbR~
        else                                                       //~v5gbR~
        if (papp->expects_uris==GNOME_VFS_MIME_APPLICATION_ARGUMENT_TYPE_PATHS) ////~v5gbR~
            pparmname=fpath;                                       //~v5gbR~
        else                                                       //~v5gbR~
        {                                                          //~v5gbR~
            if (!(Popt & USHEXE_NOMSG))                            //~v5gbR~
                uerrmsg("parameter type for default application(%s) for MIME type:%s is not local-pathname nor uri",0,//~v5gbR~
                            papp->name,pmimetype);                 //~v5gbR~
            return -1;      //no application binded                //~v5gbR~
        }                                                          //~v5gbR~
		pcmd=papp->command;                                        //~v5gbI~
		pname=papp->name;                                          //~v5gbI~
		reqterm=(papp->requires_terminal!=0);                      //~v5gbI~
    }                                                              //~v5gbI~
    if (Popt & USHEXE_CHKONLY)                                     //~v5g9R~
		rc=reqterm;		//terminal requred as rc                   //~v5gbR~
    else                                                           //~v5g9M~
    {                                                              //~v5g9I~
        termsw=reqterm || (Popt & USHEXE_FORCETERM);               //~v5gbR~
        if (termsw)                                                //~v5g9R~
        {                                                          //~v5g9I~
	        if (!simid)                                            //~v5g9I~
    	    	simid=TERM_OTHERSIM;                               //~v5g9R~
        }                                                          //~v5g9I~
        else                                                       //~v5g9I~
        	simid=0;	//no term required                         //~v5g9I~
		rc=ushellexecsub(pparmname,pcmd,simid);                    //~v5gbR~
        if (rc>0)	//pid                                          //~v5g9R~
			if (!(Popt & USHEXE_NOMSG))                            //~v5g9I~
		    	uerrmsg("sent \"%s\" to %s(pid=%d)",0,             //~v5gbR~
        				Pfnm,pname,rc);                            //~v5gbR~
    }                                                              //~v5g9I~
    if (papp)                                                      //~v5gbI~
		gnome_vfs_mime_application_free(papp);                     //~v5gbR~
//printf("use term");                                              //~v5g9R~
    return rc;                                                     //~v5g9M~
}//ushellexec                                                      //~v5g9I~
//**************************************************************** //~v5g9M~
//* ulnxlaunchapp                                                  //~v5g9M~
//*(gnome_vfs_mine_application_launch is supported from gnome_vfs v2.4;rh9 is v2.0)//~v5jnI~
//* apwan assciated appl                                           //~v5g9M~
//* rc:                                                            //~v5g9M~
//**************************************************************** //~v5g9M~
int ushellexecsub(char *Pfpath,char *Pcmd,int Ptermsimid)          //~v5g9R~
{                                                                  //~v5g9M~
    int parmctr=0,rc;                                              //~v5g9R~
    int ii,wordno;                                                 //~v5jnR~
    char *parmv[20],ppopt[8],psim[32],*pcmd;                       //~v5jnR~
    char cmdinterm[_MAX_PATH+_MAX_PATH];                           //~v5g9R~
    UCHAR **cmdparsev=0;                                           //~v5jnR~
//*********************                                            //~v5g9M~
	if (Ptermsimid)                                                //~v5g9R~
    {                                                              //~v5g9M~
		ulnxlgettermpgmopt(Ptermsimid,psim,ppopt);                 //~v5gcR~
        pcmd=psim;                                                 //~v5g9M~
		parmv[parmctr++]=pcmd;                                     //~v5g9M~
		parmv[parmctr++]=ppopt;                                    //~v5g9R~
		parmv[parmctr++]="/bin/sh";                                //~v5g9M~
		parmv[parmctr++]="-c";                                     //~v5g9M~
        sprintf(cmdinterm,"%s '%s'",Pcmd,Pfpath);                  //~v5g9R~
		parmv[parmctr++]=cmdinterm;                                //~v5g9M~
    }                                                              //~v5g9M~
    else                                                           //~v5g9M~
    {                                                              //~v5g9M~
//  	pcmd=Pcmd;                                                 //~v5jnR~
//  	parmv[parmctr++]=pcmd;                                     //~v5jnR~
    	if (uparsev(Pcmd,&cmdparsev,&wordno,0,0))//nocrlf,no delmtb//~v5jnI~
    	{                                                          //~v5jnI~
    		uerrmsg("associated cmd(%s) parse failed",0,           //~v5jnI~
        				Pcmd);                                     //~v5jnI~
    		return -1;//err pid                                    //~v5jnI~
    	}                                                          //~v5jnI~
    	pcmd=cmdparsev[0];                                         //~v5jnI~
    	for (ii=0;ii<wordno;ii++)                                  //~v5jnI~
    		parmv[parmctr++]=cmdparsev[ii];                        //~v5jnI~
		parmv[parmctr++]=Pfpath;                                   //~v5g9M~
	}                                                              //~v5g9M~
//  for (ii=0;ii<parmctr;ii++)                                     //~v5g9R~
//	    printf("spawn parm ii=%d=%s\n",ii,parmv[ii]);              //~v5g9R~
	parmv[parmctr++]=0;	//last                                     //~v5g9M~
    rc=uspawnvp(P_NOWAIT,pcmd,parmv);                              //~v5g9R~
//printf("uspawn async pid=%d\n",pid);                             //~v5g9R~
    if (cmdparsev)                                                 //~v5jnI~
        ufree(cmdparsev);                                          //~v5jnI~
    return rc;  //return pid                                       //~v5g9R~
}//ushellexecsub                                                   //~v5g9I~
//**************************************************************** //~v5gcI~
//* ulnxlgettermpgmopt                                             //~v5gcI~
//* get terminal simulater name and subcmd prefix                  //~v5gcI~
//* rc:                                                            //~v5gcI~
//**************************************************************** //~v5gcI~
int ulnxlgettermpgmopt(int Ptermsimid,char *Ptermsimname,char *Poptprefix)//~v5gcI~
{                                                                  //~v5gcI~
    char *ppopt,*psim;                                             //~v5gcI~
//*****************                                                //~v5gcI~
    ppopt="-e";                                                    //~v5gcI~
    switch(Ptermsimid)                                             //~v5gcI~
    {                                                              //~v5gcI~
    case TERM_GTERMSIM:                                            //~v5gcI~
        psim="gnome-terminal";                                     //~v5gcI~
        ppopt="-x";                                                //~v5gcI~
        break;                                                     //~v5gcI~
    case TERM_DTTERMSIM:                                           //~v5gcI~
        psim="dtterm";                                             //~v5gcI~
        break;                                                     //~v5gcI~
    case TERM_NXTERMSIM:                                           //~v5gcI~
        psim="nxterm";                                             //~v5gcI~
        break;                                                     //~v5gcI~
    case TERM_COLORXSIM:                                           //~v5gcI~
        psim="color-xterm";                                        //~v5gcI~
        break;                                                     //~v5gcI~
    case TERM_RXVTSIM:                                             //~v5gcI~
        psim="rxvt";                                               //~v5gcI~
        break;                                                     //~v5gcI~
    case TERM_XTERMSIM:                                            //~v5gcI~
        psim="xterm";                                              //~v5gcI~
        break;                                                     //~v5gcI~
    default:                                                       //~v5gcI~
        psim="gnome-terminal";                                     //~v5gcI~
        ppopt="-x";                                                //~v5gcI~
    }                                                              //~v5gcI~
    strcpy(Ptermsimname,psim);                                     //~v5gcI~
    if (Poptprefix)                                                //~v5gcI~
	    strcpy(Poptprefix,ppopt);                                  //~v5gcI~
    return 0;                                                      //~v5gcI~
}//ulnxlgettermpgmopt                                              //~v5gcI~
//**************************************************************** //~v5gcI~
//* ulnxlaunchapp                                                  //~v5gcI~
//* apwan assciated appl                                           //~v5gcI~
//* rc:                                                            //~v5gcI~
//**************************************************************** //~v5gcI~
int usystemlnxterm(char *Poptions)                                 //~v5gcI~
{                                                                  //~v5gcI~
    int rc=0,termid,simid,argc;                                    //~v5gcI~
    char  psim[32],**argv;                                         //~v5gcR~
//*********************                                            //~v5gcI~
	termid=ukbdl_gettermid();                                      //~v5gcI~
    if ((termid & TERM_IDMASK)==TERM_TTYLCONS)                     //~v5gcI~
    {                                                              //~v5gcI~
	    uerrmsg("start terminal is not avail on console screen",0);//~v5gcR~
    	return -1;                                                 //~v5gcR~
    }                                                              //~v5gcI~
	simid=termid&TERM_SIMID;                                       //~v5gcI~
	ulnxlgettermpgmopt(simid,psim,0);	//0:no option prefix required//~v5gcI~
    uparsev(Poptions,(UCHAR ***)(&argv),&argc,0,0);                //~v5gcR~
    argv[0]=psim;                                                  //~v5gcI~
    rc=uspawnvp(P_NOWAIT,psim,argv);                               //~v5gcI~
    uerrmsg("started %s,pid=%d",0,                                 //~v5gcI~
            psim,rc);                                              //~v5gcI~
    return rc;  //return pid                                       //~v5gcI~
}//ushellexecsub                                                   //~v5gcI~
#endif                                                             //~v5g9M~
#if defined(W32) || defined(UNX)                                   //~v5jaI~
//************************************************************     //~v5jaI~
//*sleep                                                           //~v5jaI~
//************************************************************     //~v5jaI~
void usleepms(int Pmilisec)                                        //~v5jaI~
{                                                                  //~v5jaI~
#ifdef W32                                                         //~v5jaI~
	Sleep(Pmilisec);                                               //~v5jaI~
#else                                                              //~v5jaI~
	usleep(Pmilisec*1000); 	//by microsec                          //~v5jaI~
#endif                                                             //~v5jaI~
}//usleepms                                                        //~v5jaI~
#endif                                                             //~v5jaI~
                                                                   //~v5jaI~
#ifdef W32                                                         //~v5j5I~
//************************************************************     //~v5j5I~
//*connect to server with namedpipe                                //~v5j5I~
//*re rc                                                           //~v5j5I~
//************************************************************     //~v5j5I~
int uprocconnect(int Popt,char *Pservercmd,char *Ppipename,ULONG *Pphandle)//~v5j5R~
{                                                                  //~v5j5I~
	int startserver(int Popt,char *Pservercmd);                    //~v5j5R~
	int retry,errcd,rc;                                            //~v5j5I~
    HANDLE hpipe;                                                  //~v5j5I~
    ULONG mode;                                                    //~v5j5I~
//**************************************                           //~v5j5I~
   	for (retry=0;;retry++)                                         //~v5j5I~
   	{                                                              //~v5j5I~
      	hpipe=CreateFile(                                          //~v5j5I~
         					Ppipename,   // pipe name              //~v5j5I~
         					GENERIC_READ |  // read and write access//~v5j5I~
         					GENERIC_WRITE,                         //~v5j5I~
         					0,              // no sharing          //~v5j5I~
         					NULL,           // default security attributes//~v5j5I~
         					OPEN_EXISTING,  // opens existing pipe //~v5j5I~
         					0,              // default attributes  //~v5j5I~
         					NULL);          // no template file    //~v5j5I~
                                                                   //~v5j5I~
      	if (hpipe!=INVALID_HANDLE_VALUE)   	// Break if the pipe handle is valid.//~v5j5I~
         	break;                                                 //~v5j5I~
      	errcd=GetLastError();                                      //~v5j5I~
        if (errcd==ERROR_FILE_NOT_FOUND)	//server not exist     //~v5j5I~
        {                                                          //~v5j5I~
        	if (retry)                                             //~v5j5I~
            {                                                      //~v5j5I~
            	uerrmsg("Server dose not start",0);                //~v5j5I~
				return 4;                                          //~v5j5I~
            }                                                      //~v5j5I~
        	if (startserver(Popt,Pservercmd))                      //~v5j5I~
            	return 4;                                          //~v5j5I~
            usleepms(1000);                                        //~v5jaR~
            continue;                                              //~v5j5I~
        }                                                          //~v5j5I~
      	if (errcd==ERROR_PIPE_BUSY)      // Exit if an error other than ERROR_PIPE_BUSY occurs.//~v5j5I~
        {                                                          //~v5j5I~
            uerrmsg("Server busy try later",0);                    //~v5j5R~
    	    return 4;                                              //~v5j5I~
        }                                                          //~v5j5I~
        uerrapi1t(1,"CreateFile",Ppipename,-1);                    //~v5j5R~
        return 4;                                                  //~v5j5I~
   	}                                                              //~v5j5I~
   	mode=PIPE_READMODE_MESSAGE;                                    //~v5j5I~
   	rc=SetNamedPipeHandleState(                                    //~v5j5I~
      							hpipe,    // pipe handle           //~v5j5I~
      							&mode,  // new pipe mode           //~v5j5I~
      							NULL,     // don't set maximum bytes//~v5j5I~
      							NULL);    // don't set maximum time//~v5j5I~
   	if (!rc)                                                       //~v5j5I~
        return uerrapi0t(1,"SetnamedPipehandleState",-1);          //~v5j5I~
    *Pphandle=(ULONG)hpipe;                                        //~v5j5R~
    return 0;                                                      //~v5j5I~
}//uprocconnect                                                    //~v5j5I~
//************************************************************     //~v5j5I~
//*connect to server with namedpipe                                //~v5j5I~
//*re rc                                                           //~v5j5I~
//************************************************************     //~v5j5I~
//int uprocdisconnect(ULONG Phpipe)                                //~v5jaR~
int uprocdisconnect(ULONG *Pphpipe,char *Ppopename)                //~v5jaR~
{                                                                  //~v5j5I~
//  CloseHandle((HANDLE)Phpipe);                                   //~v5jaR~
    CloseHandle((HANDLE)*Pphpipe);                                 //~v5jaI~
    return 0;                                                      //~v5j5I~
}//uprocdisconnect                                                 //~v5j5I~
//************************************************************     //~v5j5I~
//*msg send/receive(WIN)                                           //~v5jaR~
//************************************************************     //~v5j5I~
//int uprocpipeio(ULONG Phpipe,char *Psendmsg,char *Precvmsg,int Precvbuffsz,int *Ppreadlen)//~v5jaR~
int uprocpipeio(ULONG *Pphpipe,char *Ppipename,char *Psendmsg,char *Precvmsg,int Precvbuffsz,int *Ppreadlen,char **Ppdata,int *Ppdatalen)//~v5jaR~
{                                                                  //~v5j5I~
	int rc,writelen,len,totlen=0;                                  //~v5jaR~
    HANDLE hpipe;                                                  //~v5jaI~
//*****************************                                    //~v5j5I~
	hpipe=(HANDLE)*Pphpipe;                                        //~v5jaR~
    len=strlen(Psendmsg);                                          //~v5j5I~
   	rc=WriteFile(                                                  //~v5j5I~
//    			(HANDLE)Phpipe,                  // pipe handle    //~v5jaR~
      			hpipe,                  // pipe handle             //~v5jaI~
      			Psendmsg,	             // message                //~v5j5I~
      			len,		 			// message length          //~v5j5R~
      			&writelen,             // bytes written            //~v5j5I~
      			NULL);                  // not overlapped          //~v5j5I~
   	if (!rc)                                                       //~v5j5I~
    	return uerrapi0t(1,"WriteFile",-1);                        //~v5j5I~
   	FlushFileBuffers((HANDLE)hpipe);                               //~v5jaR~
	rc=uprocpiperecevmsg((ULONG)hpipe,Precvmsg,Precvbuffsz,Ppreadlen,Ppdata,Ppdatalen);//~v5jaR~
   	return rc;                                                     //~v5j5I~
}//uprocpipeio                                                     //~v5jaR~
//************************************************************     //~v5jaI~
//* read pipe                                                      //~v5jaI~
//*return -1:eor,>0 err                                            //~v5jaI~
//************************************************************     //~v5jaI~
int uprocpiperead(ULONG Phpipe,char *Pbuff,int Preqlen,int *Ppreadlen)//~v5jaR~
{                                                                  //~v5jaI~
	int rc,readlen,ercd=0;                                         //~v5jaR~
//*****************************                                    //~v5jaI~
    rc=ReadFile(                                                   //~v5jaI~
                (HANDLE)Phpipe,    // pipe handle                  //~v5jaR~
                Pbuff,    // buffer to receive reply               //~v5jaI~
                Preqlen,  // size of buffer                        //~v5jaI~
                &readlen,  // number of bytes read                 //~v5jaI~
                NULL);    // not overlapped                        //~v5jaI~
UTRACED("piperead",Pbuff,readlen);                                 //~v5jaR~
    if (!rc)	//not success                                      //~v5jaR~
    {                                                              //~v5jaI~
        ercd=GetLastError();                                       //~v5jaI~
        if (ercd==ERROR_MORE_DATA||ercd==ERROR_PIPE_NOT_CONNECTED) //~v5jaR~
            rc=0;                                                  //~v5jaI~
        else                                                       //~v5jaI~
            return uerrapi0t(1,"ReadFile",-1);                     //~v5jaI~
    }                                                              //~v5jaI~
UTRACEP("piperead rc=%d,lasterr=%d\n",rc,ercd);                    //~v5jaI~
    *Ppreadlen=readlen;                                            //~v5jaI~
    if (!readlen)                                                  //~v5jaI~
    	return -1;                                                 //~v5jaR~
    return 0;                                                      //~v5jaR~
}//uprocpiperead                                                   //~v5jaI~
//************************************************************     //~v5j5I~
//*msg send/receive                                                //~v5j5I~
//************************************************************     //~v5j5I~
int startserver(int Popt,char *Pservercmd)                         //~v5j5R~
{                                                                  //~v5j5I~
    SECURITY_ATTRIBUTES sec={sizeof(SECURITY_ATTRIBUTES),          //~v5j5I~
    							NULL,                              //~v5j5I~
                                TRUE};	//inherit                  //~v5j5I~
//**********************************                               //~v5j5I~
#ifdef AAA                                                         //~v5j5I~
	ugetcwd(curdir);                                               //~v5j5I~
  	sprintf(cmd,"%s.exe -L%s",XE3270SERVER,XE3270_DEFAULT_LOGFILE);//~v5j5I~
    GetStartupInfo(&sinf);                                         //~v5j5I~
    if (!CreateProcess(NULL,                                       //~v5j5I~
                  cmd,                                             //~v5j5I~
                  NULL,     //inherit gotten pid=No                //~v5j5I~
                  NULL,     //inherit gotten threadid=No           //~v5j5I~
                  FALSE,     //inherit	handle=No                  //~v5j5I~
//                DETACHED_PROCESS,                                //~v5j5I~
                  CREATE_NEW_CONSOLE,                              //~v5j5I~
                  NULL,     //env is same                          //~v5j5I~
                  curdir, //cdir                                   //~v5j5I~
                  &sinf,                                           //~v5j5I~
                  &pinfo)) //output                                //~v5j5I~
		return uerrapi1t(1,"CreatePipe",cmd,-1);                   //~v5j5I~
    	uerrmsg("started server(%s) pid=%d",0,                     //~v5j5I~
    		cmd,pinfo.dwProcessId);                                //~v5j5I~
#else                                                              //~v5j5I~
    system(Pservercmd);                                            //~v5j5I~
//  uerrmsg("started server(%s)",0,                                //~v5jaR~
//  		Pservercmd);                                           //~v5jaR~
#endif                                                             //~v5j5I~
    return 0;                                                      //~v5j5I~
}//startserver                                                     //~v5j5I~
#endif                                                             //~v5j5I~
#ifdef LNX                                                         //~v5jaI~
//************************************************************     //~v5jaI~
//*connect to server with namedpipe                                //~v5jaI~
//*return 1 fd(write to server)                                    //~v5jaR~
//*re rc                                                           //~v5jaI~
//************************************************************     //~v5jaI~
int uprocconnect(int Popt,char *Pservercmd,char *Ppipename,ULONG *Pphandle)//~v5jaI~
{                                                                  //~v5jaI~
	int startserver(int Popt,char *Pservercmd);                    //~v5jaI~
	int retry,rc,fdw;                                              //~v5jaR~
    char readpipename[_MAX_PATH];                                  //~v5jaI~
    char dupchkpipename[_MAX_PATH];                                //~v5jaI~
//**************************************                           //~v5jaI~
    sprintf(dupchkpipename,SERVERPIPELOCK,Ppipename);              //~v5jaR~
   	for (retry=0;;retry++)                                         //~v5jaI~
   	{                                                              //~v5jaI~
        fdw=open(dupchkpipename,O_WRONLY|O_NONBLOCK);    //not blocked but fail if no reader exist//~v5jaR~
        if (fdw>0)  //reader exist                                 //~v5jaR~
            break;                                                 //~v5jaR~
        if (retry)                                                 //~v5jaI~
        {                                                          //~v5jaI~
			if (access(dupchkpipename,F_OK)!=-1)  //F_OK:existance chk//~v5jaR~
            	uerrmsg("Server start failed,pipe(%s) should be cleared.",0,//~v5jaI~
    	    			dupchkpipename);                           //~v5jaR~
            else                                                   //~v5jaI~
	            uerrmsg("Server dose not start.chk pgm path for \"%s\".",0,//~v5jaR~
		        			Pservercmd);                           //~v5jaR~
            return 4;                                              //~v5jaI~
        }                                                          //~v5jaI~
        if (startserver(Popt,Pservercmd))                          //~v5jaI~
            return 4;                                              //~v5jaI~
        usleepms(1000);                                            //~v5jaI~
        continue;                                                  //~v5jaI~
    }                                                              //~v5jaI~
    close(fdw);	//dupchk only                                      //~v5jaI~
//BLOCK mode open(BLOCK mode required for atomic write)            //~v5jaI~
    fdw=open(Ppipename,O_WRONLY);	//block mode(wait server open by read mode)//~v5jaI~
    if (fdw<0)                                                     //~v5jaI~
    	return uerrapi1t(0,"open(SendPipe)",Ppipename,errno);      //~v5jaR~
    sprintf(readpipename,CLIENTPIPENAME,Ppipename,getpid());       //~v5jaM~
    unlink(readpipename);  //for duplicated call                   //~v5jaM~
    rc=mkfifo(readpipename,0777);                                  //~v5jaM~
    if (rc==-1)                                                    //~v5jaM~
        return uerrapi1t(0,"mkfifo(ClientReadPipe)",readpipename,errno);//~v5jaR~
    *Pphandle=fdw;                                                 //~v5jaI~
    return 0;                                                      //~v5jaI~
}//uprocconnect                                                    //~v5jaI~
//************************************************************     //~v5jaI~
//*connect to server with namedpipe                                //~v5jaI~
//*re rc                                                           //~v5jaI~
//************************************************************     //~v5jaI~
int uprocdisconnect(ULONG *Phpipe,char *Ppipename)                 //~v5jaI~
{                                                                  //~v5jaI~
    char readpipename[_MAX_PATH];                                  //~v5jaI~
//**************************************                           //~v5jaI~
UTRACEP("pipe disconnect\n");                                      //~v5jpI~
	close((int)(*Phpipe));                                         //~v5jaI~
	close((int)(*(Phpipe+1)));                                     //~v5jaR~
    sprintf(readpipename,CLIENTPIPENAME,Ppipename,getpid());       //~v5jaI~
    unlink(readpipename);                                          //~v5jaR~
    return 0;                                                      //~v5jaI~
}//uprocdisconnect                                                 //~v5jaI~
//************************************************************     //~v5jaI~
//*msg send/receive (LNX)                                          //~v5jaR~
//*return 1 fd(read from server)                                   //~v5jaI~
//************************************************************     //~v5jaI~
int uprocpipeio(ULONG *Phpipe,char *Ppipename,char *Psendmsg,      //~v5jaR~
				char *Precvmsg,int Precvbuffsz,int *Ppreadlen,char **Ppdata,int *Ppdatalen)//~v5jaR~
{                                                                  //~v5jaI~
	int writelen,len,fdr,fdw,rc;                                   //~v5jaR~
    PIPEMSG pipemsg;                                               //~v5jaI~
    char readpipename[_MAX_PATH];                                  //~v5jaR~
//*****************************                                    //~v5jaI~
    len=strlen(Psendmsg);                                          //~v5jaI~
UTRACED("send",Psendmsg,len);                                      //~v5jaI~
    if (len>MAX_PIPEMSG)                                           //~v5jaI~
    	len=MAX_PIPEMSG;                                           //~v5jaI~
    pipemsg.pid=getpid();                                          //~v5jaI~
    memcpy(pipemsg.msg,Psendmsg,len);                              //~v5jaI~
    len+=sizeof(pipemsg.pid);                                      //~v5jaI~
    fdw=(int)(*Phpipe);                                            //~v5jaI~
   	writelen=write(fdw,&pipemsg,len);                              //~v5jaI~
    if (writelen!=len)                                             //~v5jaI~
    	return uerrapi0t(1,"write pipe",errno);                    //~v5jaI~
//open response pipe(after write msg because open by block mode)   //~v5jaI~
    sprintf(readpipename,CLIENTPIPENAME,Ppipename,getpid());       //~v5jaI~
	fdr=open(readpipename,O_RDONLY);	//wait server write open   //~v5jaI~
	if (fdr<0)	//reader exist                                     //~v5jaM~
        return uerrapi1t(0,"open pipe(read)",readpipename,errno);  //~v5jaM~
    *(Phpipe+1)=fdr;                                               //~v5jaI~
	rc=uprocpiperecevmsg((ULONG)fdr,Precvmsg,Precvbuffsz,Ppreadlen,Ppdata,Ppdatalen);//~v5jaI~
   	return rc;                                                     //~v5jaR~
}//uprocpipeio                                                     //~v5jaI~
//************************************************************     //~v5jaI~
//*msg send/receive                                                //~v5jaI~
//************************************************************     //~v5jaI~
int startserver(int Popt,char *Pservercmd)                         //~v5jaI~
{                                                                  //~v5jaI~
//**********************************                               //~v5jaI~
    system(Pservercmd);                                            //~v5jaI~
//  uerrmsg("started server(%s)",0,                                //~v5jaR~
//  		Pservercmd);                                           //~v5jaR~
    return 0;                                                      //~v5jaI~
}//startserver                                                     //~v5jaI~
//************************************************************     //~v5jaI~
//*pipe read                                                       //~v5jaI~
//*return -1:eor,>0 err                                            //~v5jaI~
//************************************************************     //~v5jaI~
int uprocpiperead(ULONG Phpipe,char *Pbuff,int Preqlen,int *Ppreadlen)//~v5jaI~
{                                                                  //~v5jaI~
	int fdr,readlen;                                               //~v5jaI~
//*************************                                        //~v5jaI~
	fdr=(int)Phpipe;                                               //~v5jaI~
    readlen=read(fdr,Pbuff,Preqlen);                               //~v5jaI~
UTRACEP("pipe read req=%d,read=%d\n",Preqlen,readlen);             //~v5jaR~
UTRACED("pipe read",Pbuff,max(readlen,0));                         //~v5jaR~
    if (readlen<0)                                                 //~v5jaI~
    	return uerrapi0t(0,"read(pipe from server)",-1);           //~v5jaR~
    *Ppreadlen=readlen;                                            //~v5jaI~
    if (!readlen)                                                  //~v5jaI~
    	return -1;                                                 //~v5jaI~
    return 0;                                                      //~v5jaI~
}//uprocpiperead                                                   //~v5jaI~
#endif                                                             //~v5jaI~
//************************************************************     //~v5jaI~
//*msg send/receive                                                //~v5jaI~
//*return -1:eof reached before all data read,>0 err               //~v5jaI~
//************************************************************     //~v5jaI~
int uprocpiperecevmsg(ULONG Phpipe,char *Precvmsg,int Precvbuffsz,int *Ppreadlen,char **Ppdata,int *Ppdatalen)//~v5jaR~
{                                                                  //~v5jaI~
	int readlen,hdrlen,msglen,datalen,rc;                          //~v5jaR~
    char *pdata;                                                   //~v5jaR~
    PPIPERESPMSG prespmsghdr;                                      //~v5jaR~
//*****************************                                    //~v5jaI~
//*read hdr                                                        //~v5jaI~
    hdrlen=PIPERESPMSGHDRSZ;                                       //~v5jaI~
    rc=uprocpiperead(Phpipe,Precvmsg,hdrlen,&readlen);             //~v5jaI~
    if (rc)                                                        //~v5jaI~
    	return rc;                                                 //~v5jaI~
    prespmsghdr=(PPIPERESPMSG)(ULONG)Precvmsg;                     //~v5jaI~
    msglen=prespmsghdr->msglen;                                    //~v5jaR~
    datalen=prespmsghdr->datalen;                                  //~v5jaR~
    rc=uprocpipeiodata(Phpipe,Precvmsg+hdrlen,Precvbuffsz-hdrlen-1,msglen,&readlen);//~v5jaR~
    if (rc)                                                        //~v5jaI~
    	return rc;                                                 //~v5jaI~
    *(Precvmsg+hdrlen+readlen)=0;                                  //~v5jaI~
    *Ppreadlen=readlen;                                            //~v5jaI~
    if (datalen && Ppdata)                                         //~v5jaI~
    {                                                              //~v5jaI~
	    pdata=umalloc(datalen);                                    //~v5jaR~
    	rc=uprocpipeiodata(Phpipe,pdata,0,datalen,&readlen);       //~v5jaR~
    	if (!rc)                                                   //~v5jaR~
    	{                                                          //~v5jaR~
            *Ppdata=pdata;                                         //~v5jaI~
            *Ppdatalen=readlen;                                    //~v5jaR~
        }                                                          //~v5jaI~
        else                                                       //~v5jaI~
        {                                                          //~v5jpI~
            ufree(pdata);                                          //~v5jaI~
            if (rc>0)                                              //~v5jpI~
                return rc;                                         //~v5jpI~
        }                                                          //~v5jpI~
    }                                                              //~v5jaI~
   	return 0;                                                      //~v5jaI~
}//uprocpiperecevmsg                                               //~v5jaI~
//************************************************************     //~v5jaM~
//*msg and data read                                               //~v5jaI~
//*return -1:eof before full data get ,>0 err                      //~v5jaM~
//************************************************************     //~v5jaM~
int uprocpipeiodata(ULONG Phpipe,char *Pbuff,int Pbufflen,int Preqlen,int *Ppreadlen)//~v5jaI~
{                                                                  //~v5jaM~
	int reslen,rc=0,readlen,reqlen,len;                            //~v5jaR~
    char *pc;                                                      //~v5jaM~
    char buff[4096];                                               //~v5jaM~
//*****************************                                    //~v5jaM~
	if (Pbufflen)      //buffsz limit                              //~v5jaM~
		reqlen=min(Pbufflen,Preqlen);                              //~v5jaM~
    else                                                           //~v5jaM~
    	reqlen=Preqlen;                                            //~v5jaM~
	for (pc=Pbuff,reslen=reqlen;reslen>0;reslen-=readlen,pc+=readlen)//~v5jaM~
    {                                                              //~v5jaM~
    	rc=uprocpiperead(Phpipe,pc,reslen,&readlen);               //~v5jaI~
        if (rc>0)                                                  //~v5jaI~
        	return rc;                                             //~v5jaI~
        if (rc<0)	//eof                                          //~v5jaI~
        	break;                                                 //~v5jaM~
	}                                                              //~v5jaM~
    if (reslen && rc<0)     //eof reached before all data read     //~v5jpI~
    {                                                              //~v5jpI~
        uerrmsg("pipe read failed(reached EOF remaining more len=%d data)",0,//~v5jpR~
                    reslen);                                       //~v5jpI~
		return U3CR_RC_OTHER;                                      //~v5jpI~
    }                                                              //~v5jpI~
    if (reqlen<Preqlen) //buff short                               //~v5jaM~
    {                                                              //~v5jaM~
        if (rc<0)    //eof                                         //~v5jaI~
        	return -1;                                             //~v5jaM~
        for (reslen=Preqlen-reqlen;reslen>0;reslen-=readlen)       //~v5jaM~
        {                                                          //~v5jaM~
            len=min(sizeof(buff),reslen);                          //~v5jaM~
	    	rc=uprocpiperead(Phpipe,buff,len,&readlen);            //~v5jaI~
       		if (rc>0)                                              //~v5jaI~
        		return rc;                                         //~v5jaI~
            if (rc<0)                                              //~v5jaI~
                break;                                             //~v5jaM~
        }                                                          //~v5jaM~
//      if (reslen)     //eof reached                              //~v5jpR~
//      	return -1;                                             //~v5jpR~
    }                                                              //~v5jaM~
    *Ppreadlen=reqlen;                                             //~v5jaM~
   	return 0;                                                      //~v5jaM~
}//uprocpipeiodata                                                 //~v5jaM~
