//*CID://+v72rR~:                             update#=  140;       //~v72rR~
//*************************************************************
//*xedlcmd2.c
//* each dir line cmd process                                   //~5731R~
//* browse(b)/browse binary(2)/edit(e)/expand(-)/reduce(+)/exclude(x)/display(y)///~v10kR~
//* cur dir(.)/expandall(>)/free(f)/view(v)/view edit(w)        //~v04lR~
//* toggle size display byte count<-->line count                   //~v10rI~
//*************************************************************
//v72r:061129 3270:initialy lineno display for TSO SPF             //~v72rI~
//v72a:061120 support line count display by spf info               //~v72aI~
//v71t:061022 display err msg when refresh cmd on dirlist for the case TSO err etc//~v71tI~
//v71j:061017 3270:undel lcmd support                              //~v71jI~
//v71a:061005 3270:dirlist:display filesize if once downloaded from localfile//~v71aI~
//v717:060926 3270:dirlist support                                 //~v717I~
//v690:060418 display file-description support on dir-list panel   //~v690I~
//v61e:050223 use cmd verb not /M parm for filename list(no parm is better)//~v61eI~
//v60r:050130 (BUG)2nd time refresh dose not refresh subdir        //~v60rI~
//            because 1st refresh change expandid:"-" to dirid:"+".//~v60rI~
//v59W:041211 (BUG)dirlist lineno is displayed as 0 after sort     //~v59WI~
//v59N:041121 (BUG)of v58t;prev sort option remains in rename fld when sort twice//~v59MI~
//v59M:041121 sort on dir list parameter change sor [[{/|-}o]{n|s|t}[-]]//~v59MI~
//v59c:041107 % lcmd:remote support(use rsh)                       //~v59cI~
//v58t:040926 (BUG)sort cmd ignore filemask previously specified   //~v58tI~
//v57j:040522 sort cmd for dirlist                                 //~v57jI~
//v57f:040521 dirlist sort;dlcmd "-" with /ox option:x:Size,t:Time,n:Name//~v57fI~
//v57c:040517 (BUG)refresh dose not update curr dir                //~v57cI~
//v57b:040517 (BUG)refresh fail when cur dir is deleted            //~v57bI~
//v57a:040517 (BUG)refresh fail when same filename is deleted(rename fld not eq filename)//~v57aI~
//v568:040402 (WXE:BUG)ignore association for dir(force open by xe)//~v568I~
//v55U:040321 (WXE)openwith when dblclick on filenamelist/dirlist if associated//~v55UI~
//v54r:040108 (FTP)dlcmd "." set cur dir support                   //~v54rI~
//v54m:040105 (FTP)update dir list file time when once browsed     //~v54mI~
//v540:031223 (WIN,UNX)set dir sepc on ufh                         //~v540I~
//v53Z:031223 (WIN,UNX)ftp support;no vfat alias(always long)      //~v53ZI~
//v50G:030201 add cmd "et"/"bt"/"st" for e/b/s /mt                 //~v50GI~
//v485:020427 (BUG)refresh dirlist err when expandied subdir is deleted//~v485I~
//v47Q:020330 leave "s" as old fashion and use "o" for edit/browse wit patm//~v47QI~
//v47P:020330 dlcmd "s" support option specification               //~v47PI~
//v47a:020223 (BUG)S+f1(refresh) issue err file not found          //~v47aI~
//             when dirname is expanded by S+f11(long filename display)//~v47aI~
//v44t:011206 dlcmd "I":/Mcn,"J":/Mkn                              //~v44gI~
//v44g:011204 new dlcmd 'K':/Mk(cob with no num),'N':/Mn(spf),'L':/Mc//~v44fI~
//v44f:011204 new dlcmd 'H'/'h'(h:follow edit/browse open mode,'H':reverse)//~v44fI~
//v20Q:001111 (BUG)dir list reflesh ignore filename mask           //~v20QI~
//v19V:000928 LINUX support("*" mean all member,"*.*" require intermediate ".";//~v19VI~
//            under windows those are same effect)                 //~v19VI~
//            udirlist use ufileeditname(of windows logic),so no bad effect but correct//~v19VI~
//v19a:000903 LINUX support(dir path seperator)                    //~v19aI~
//v196:000902 LINUX support(drop drive func;uchdrive/ugetdrive)    //~v196I~
//v184:001210 (BUG)clear mask when dirlist expand reduced(+)       //~v184I~
//v152:000311 dir-list REFresh cmd                                 //~v152I~
//v10v:990326 chng browse binary mode:"2" -->"1",and add "2" as edit binary mode//~v10vI~
//v10t:990404 csr restore after view split end                     //~v10tI~
//v10s:990404 move csr to split scr for view/vieedit               //~v10sI~
//v10r:990327 display lineno on dir list,accum size/line cnt to dir line//~v10rI~
//v10p:990326 new dlcmd "2";browse binary mode                     //~v10pI~
//v10k:990322 (BUG)after select cmd for new file on dirlist,end with no update//~v10kI~
//            or cancel update file cause deletion of parent dir plh.//~v10kI~
//            So locate cmd faile and move csr to last entry.      //~v10kI~
//v0g1:971207 print parm by short filename option(opt plfn on/off) //~v0g1I~
//v0fr:971109 dir list sort by fully for longname                  //~v0frI~
//v0fp:971108 split dlcmd2-->dlcmd5.c                              //~v0fpI~
//v0fn:971103 (GCC:W32)dirlist merge by shortname                  //~v0fnI~
//v0fm:971103 new function to set filename and alias to ufh        //~v0fmI~
//v0fk:971103 set alias also when re-expand filename change        //~v0fkI~
//v0ff:971019 (w95/GCC)dir sort seq is by alias                    //~v0ffI~
//v0fd:971018 (w95/GCC)udhname is long or short,but only one of them is needed.//~v0fdI~
//v09A:970531:(BUG)abend when dir line deleted which is on top of screen//~v09AI~
//            of splitted                                          //~v09AI~
//v09z:970425:dir upctr tell to parent dir list                    //~v09zI~
//            so enq when also browse(it may be dir)               //~v09zI~
//v09w:970524:Select cmd support on dir list                       //~v09vI~
//            update pdh line timstamp/size(search function)       //~v09vI~
//v09v:970524:(BUG)-dlcmdresetdata:filefind rc chk bug             //~v09vI~
//                  line data will not be updated                  //~v09vI~
//                 -dlcmdfree:dont deq now,it need until dlcmddeqpfc//~v09vI~
//                 (dlcmdddeqpfc call dlcmdresetdata if qued)      //~v09vI~
//v09h:970517:(BUG)dirgetflddata need size=strlen + 1,expand mask invalid//~v09hI~
//v09b:970510:disk free space display                              //~v09bI~
//            -req update free space info at edit from dirlist(dlcmd2.c)//~v09bI~
//v091:970104:(BUG) of v085 loop(next plh no setup by continue)    //~v091I~
//v08l:961123:edit/browse line range parameter                     //~v08lI~
//v085:961024:W95 VC                                               //~v085I~
//            free destroy free area(need UGETQNEXT before ufree)  //~v085I~
//v082:961001:(BUG)expand type change to dir even if expanded before re-expand//~v082I~
//            so keep type around re-expand.                       //~v082I~
//            (additional to v07m,for also path dir)               //~v082I~
//v07s:960825:new ulib.h/ulibdef.h(no need base def by os2.h)      //~v07sI~
//            to speed up compile,drop include(caused by WIN95 modify)//~v07sI~
//v07m:960714:(BUG)expand type change to dir even if expanded before re-expand//~v07mI~
//            so keep type around re-expand.                       //~v07mI~
//v05U:960203:(BUG)need full draw when entry deleted            //~v05UI~
//v05P:960120:(BUG)-(expand) dose'nt update tyep,caused "it is dir" msg//~v05PI~
//            for type is file on list (but actualy dir)        //~v05PI~
//v05L:960113:err not dir msg for dlcmd                         //~v05LI~
//v05K:960107:path id(:) for also edit/bowse dir                //~v05KI~
//v05H:960106:update time stamp when expand("-"/">") file       //~v05HI~
//v05G:960105:update time stamp of dir list when edit saved(add to v04j)//~v05GI~
//            change interface of dlcgetfullname(plc-->pdh parm)//~v05GI~
//v05F:960105:rename save field realloc each time(undeleted file may//~v05FI~
//            re-moved to long path name)                       //~v05FI~
//v05z:951224:(BUG)del and re-create and expand dir list,remain D flag//~v05zI~
//v05r:951126:dlcmd cursor                                      //~v05rI~
//v05q:951126:MOVE flag on memver of dir                        //~v05qI~
//v05o:951125:dlcmd dir delete woth confirmation support        //~v05oI~
//v04l:951008:free view/edit screen when delete                 //~v04lI~
//v04j:951007:update id for edit(W or E) saved file on dir list //~v04jR~
//v04d:950930:malloc/calloc rc chk for dos                      //~v04dI~
//v04b:950924:expand all dlcmd(>)                               //~v04bI~
//v04a:950924:process dir lcmd from last to be able to del empty dir//~v048I~
//            no need to reverse for browse/edit                //~v048I~
//v048:950924:dir renum from current line(performance)          //~v048I~
//v046:950923:view dir lcmd                                     //~v046I~
//v043:950917:cur dir lcmd(.)                                   //~5917I~
//v030:950903:save mask data for "-" and " "(cancel expand)     //~5903R~
//v03y:950903:pfh path name length for dir entry matching       //~5903I~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifdef DOS
#else
    #ifdef W32                                                     //~v71aI~
		#include <io.h>                                            //~v71aI~
    #endif                                                         //~v71aI~
//  #define INCL_BASE                                              //~v07sR~
//  #include <os2.h>                                               //~v07sR~
#endif
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <ualloc.h>
#include <uque.h>
#include <ustring.h>
#include <ufile.h>
#include <uparse.h>                                                //~v10pI~
#include <uftp.h>                                                  //~v717I~
#include <u3270.h>                                                 //~v71aI~

#include "xe.h"
#include "xescr.h"
#include "xefile.h"
#include "xefile2.h"                                            //~5812I~
#include "xefsub.h"     //ufilesetfhfilename                       //~v0fnI~
#include "xepan.h"
#include "xedir.h"
#include "xedir2.h"                                             //~5731I~
#include "xedlcmd.h"                                            //~v05oM~
#include "xedlcmd2.h"                                           //~v05oM~
#include "xedlcmd3.h"                                           //~v05oI~
#include "xedlcmd5.h"                                              //~v0fpI~
#include "xefunc.h"
#include "xefunct.h"                                               //~v61eI~
#include "xedcmd.h"                                             //~5917M~
#include "xecsr.h"                                              //~v046I~
#include "xeerr.h"                                              //~5731I~
#include "xesub.h"                                              //~5903I~
#include "xetso.h"                                                 //~v717I~
//*******************************************************
static int Sexpandallsw;                                           //~v19VR~
static int Sexpandallerr;                                          //~v19VR~
static int Srefreshsw=0;                                           //~v485I~
#if defined(W32) || defined(DPMI)                                  //~v0g1I~
    static char Saliassw;                                          //~v0g1I~
#endif                                                             //~v0g1I~
//*******************************************************       //~v04bI~
int dlcmdotherbecmd(PUCLIENTWE Ppcw,PUDLCMD Pplc,char *Pmode);     //~v44fI~
int dlcmdotherbecmdfuncid(PUCLIENTWE Ppcw,PUDLCMD Pplc,int Pfuncidb,int Pfuncide);//~v61eR~
                                                                   //~v184I~
int dlcmdexpand1(PUCLIENTWE Ppcw,PULINEH Pplh,
                        UCHAR *Pdirname,UCHAR *Pfilemask);
int dlcmdsetszorlcsub(PUCLIENTWE Ppcw,PULINEH Pplh,int Popt,LONG Pdirlineno);//~v10rR~
//int dlcmdbinbe(PUCLIENTWE Ppcw,PUDLCMD Pplc,int Pbeopt);         //~v44fR~
int dlcmdbinbe(PUCLIENTWE Ppcw,PUDLCMD Pplc,int Pbeopt,char *Pmode);//~v44fI~
int dlcmdbinbefuncid(PUCLIENTWE Ppcw,PUDLCMD Pplc,int funcid);     //~v61eR~
int dlcmdrefreshsub(PUCLIENTWE Ppcw,PULINEH Pplh,PUDIRLH Ppdh);    //~v152R~
int dlcmdgetexpopt(char *Pparm,int *Ppsortopt);                    //~v57fR~
//**************************************************************** //~v47PI~
// dlcmdselect                                                     //~v47PI~
// process select dlcmd                                            //~v47PI~
//*rc   :0                                                         //~v47PI~
//**************************************************************** //~v47PI~
int dlcmdselect(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)    //~v47PI~
{                                                                  //~v47QI~
    int   editsw;                                                  //~v47QI~
//*******************                                              //~v47QI~
    editsw=UCBITCHK(Pplc->UDLCflag,UDLCEDIT)!=0;  //edit or browse //~v47QI~
	return dlcmdbinbe(Ppcw,Pplc,editsw,"");	// /Mx                 //~v47QI~
}//dlcmdselect                                                     //~v47QI~
//**************************************************************** //~v50GI~
// dlcmdselecttext                                                 //~v50GI~
// process select dlcmd                                            //~v50GI~
//*rc   :0                                                         //~v50GI~
//**************************************************************** //~v50GI~
int dlcmdselecttext(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)//~v50GI~
{                                                                  //~v50GI~
    int   editsw;                                                  //~v50GI~
//*******************                                              //~v50GI~
    editsw=UCBITCHK(Pplc->UDLCflag,UDLCEDIT)!=0;  //edit or browse //~v50GI~
//  return dlcmdbinbe(Ppcw,Pplc,editsw," /Mt");	// /Mx             //~v61eR~
    if (editsw)                                                    //~v61eI~
    	return dlcmdbinbefuncid(Ppcw,Pplc,FUNCID_EDITTEXT);	// /Mx //~v61eR~
    else                                                           //~v61eI~
    	return dlcmdbinbefuncid(Ppcw,Pplc,FUNCID_BROWSETEXT);	// /Mx//~v61eR~
}//dlcmdselecttext                                                 //~v50GI~
//**************************************************************** //~v47QI~
// dlcmdopenm                                                      //~v47QI~
// process open dlcmd                                              //~v47QI~
//*rc   :0                                                         //~v47QI~
//**************************************************************** //~v47QI~
int dlcmdopen(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)      //~v47QI~
{                                                                  //~v47PI~
    PULINEH plh;                                                   //~v47PI~
    PUDIRLH pdh;                                                   //~v47PI~
    int  rc;                                                       //~v47QR~
    UCHAR  modeparm[80];                                           //~v47PI~
//*******************                                              //~v47PI~
//  editsw=UCBITCHK(Pplc->UDLCflag,UDLCEDIT)!=0;  //edit or browse //~v47QR~
    plh=Pplc->UDLCplh;                                             //~v47PI~
    pdh=UGETPDH(plh);                                              //~v47PI~
    if (pdh->UDHtype==UDHTFILE)                                    //~v47PI~
    {                                                              //~v47PI~
        *modeparm=' ';                                             //~v47PI~
    	if (dirgetflddata(Ppcw,plh,PANL310RENAME,modeparm+1)<0)  //fld len//~v47PR~
        	return 4;   //internal logic err                       //~v47PI~
    }                                                              //~v47PI~
    else                                                           //~v47PI~
    	*modeparm=0;                                               //~v47PI~
//  rc=dlcmdbinbe(Ppcw,Pplc,editsw,modeparm);	// /Mx             //~v47QR~
	rc=dlcmdotherbecmd(Ppcw,Pplc,modeparm);	// /Mx                 //~v47QI~
    if (rc)                                                        //~v47PI~
    {                                                              //~v47PI~
		dirsetflderr(Ppcw,plh,PANL310RENAME);//reverse err fld     //~v47PI~
    	return rc;                                                 //~v47PI~
    }                                                              //~v47PI~
	UCBITOFF(pdh->UDHflag,UDHFLCMDIN2|UDHFDDSETUP);//set pro at ddsetup//~v47PR~
    filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr                 //~v47PI~
	return rc;                                                     //~v47PI~
}//dlcmdopen                                                       //~v47QR~
//****************************************************************
// dlcmdbrowse
// process browse dlcmd
//*rc   :0
//****************************************************************
int dlcmdbrowse(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)
{
    UCHAR  fullpathname[_MAX_PATH];
    int rc;
//*******************
    if (dlcgetfullname(UGETPDH(Pplc->UDLCplh),fullpathname))    //~v05GR~
        return 4;                                               //~5721I~
    Ppcw->UCWparm=fullpathname;
    rc=func_browse_file2(Ppcw,0);   //filename only                //~v08lR~
    Ppcw->UCWparm=0;        //worked
//  if (!rc)                                                    //~v048R~
//      dlcfifo(Ppcw);                                          //~v048R~
    if (rc)                                                        //~v09zI~
        return rc;                                                 //~v09zI~
    rc=dlcmdeditenq(Ppcw,Pplc); //once deq from previous dir list  //~v09zI~
    return rc;                                                  //~5721R~
}//dlcmdbrowse

//**************************************************************** //~v10pR~
// dlcmdbrowse by bin mode                                         //~v10vR~
//**************************************************************** //~v10pR~
int dlcmdbrowse2(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)   //~v10pR~
{                                                                  //~v10vI~
//  return dlcmdbinbe(Ppcw,Pplc,0);                                //~v44fR~
//  return dlcmdbinbe(Ppcw,Pplc,0," /Mb");      //browsw parm      //~v61eR~
    return dlcmdbinbefuncid(Ppcw,Pplc,FUNCID_BROWSEBIN);      //browsw parm//~v61eR~
}//dlcmdbrowse2                                                    //~v10vI~
//**************************************************************** //~v10vI~
// dlcmdedit by bin mode                                           //~v10vI~
//**************************************************************** //~v10vI~
int dlcmdedit2(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)     //~v10vI~
{                                                                  //~v10vI~
//  return dlcmdbinbe(Ppcw,Pplc,1);                                //~v44fR~
//  return dlcmdbinbe(Ppcw,Pplc,1," /Mb");		//edit parm        //~v61eR~
    return dlcmdbinbefuncid(Ppcw,Pplc,FUNCID_EDITBIN);		//edit parm//~v61eR~
}//dlcmdedit2                                                      //~v10vI~
//**************************************************************** //~v10vI~
// dlcmdbinbe                                                      //~v10vI~
// process browse/edit bynaly mode for dlcmd                       //~v10vI~
//parm1:pcw                                                        //~v10vI~
//parm2:plc                                                        //~v10vI~
//parm3:0:browse,1:edit                                            //~v10vI~
//parm4:parm string on /M                                          //~v44fI~
//*rc   :0                                                         //~v10vI~
//**************************************************************** //~v10vI~
int dlcmdbinbe(PUCLIENTWE Ppcw,PUDLCMD Pplc,int Pbeopt,char *Pmode)//~v44fR~
{                                                                  //~v10pR~
    UCHAR  fullpathname[_MAX_PATH];                                //~v10pR~
    UCHAR  fnameq[_MAX_PATH+16];                                   //~v10pI~
    PUDIRLH pdh;                                                   //~v10vI~
    int rc;                                                        //~v10pI~
    UINT len;                                                      //~v10pI~
//*******************                                              //~v10pI~
    pdh=UGETPDH(Pplc->UDLCplh);                                    //~v10vI~
    if (dlcgetfullname(pdh,fullpathname))                          //~v10vR~
        return 4;                                                  //~v10pI~
  if (Pplc->UDLCcmd!='S')   //not select cmd                       //~v47QR~
    if (pdh->UDHtype!=UDHTFILE)                                    //~v10vI~
        return errdir(fullpathname);                               //~v10vR~
    len=strlen(fullpathname);                                      //~v10pR~
    if (uparsein(fullpathname,fnameq,sizeof(fnameq),0,'\"'))//enclosed if space embedding//~v10pI~
        len=strlen(fnameq);         //dir name                     //~v10pR~
//  strcpy(fnameq+len," /Mb");  //binary option                    //~v44fR~
    strcpy(fnameq+len,Pmode);   // /M parm                         //~v44fI~
    Ppcw->UCWparm=fnameq;                                          //~v10pR~
  if (Pbeopt)                                                      //~v10vI~
    rc=func_edit_file2(Ppcw,1); //filename with option /Mb         //~v10vI~
  else                                                             //~v10vI~
    rc=func_browse_file2(Ppcw,1);   //filename with option /Mb     //~v10pR~
    Ppcw->UCWparm=0;        //worked                               //~v10pI~
    if (rc)                                                        //~v10pI~
        return rc;                                                 //~v10pI~
    rc=dlcmdeditenq(Ppcw,Pplc); //once deq from previous dir list  //~v10pI~
    return rc;                                                     //~v10pI~
}//dlcmdbbinbe                                                     //~v10vR~
//**************************************************************** //~v61eI~
// dlcmdbinbefunid                                                 //~v61eR~
// process browse/edit binaly mode for dlcmd                       //~v61eI~
//parm1:pcw                                                        //~v61eI~
//parm2:plc                                                        //~v61eI~
//parm3:browse/edit func addr                                      //~v61eI~
//*rc   :0                                                         //~v61eI~
//**************************************************************** //~v61eI~
int dlcmdbinbefuncid(PUCLIENTWE Ppcw,PUDLCMD Pplc,int Pfuncid)     //~v61eR~
{                                                                  //~v61eI~
    UCHAR  fullpathname[_MAX_PATH];                                //~v61eI~
    PUDIRLH pdh;                                                   //~v61eI~
    int rc,opdnosv;                                                //~v61eR~
    FUNCTBL *pft,*pftsv;                                           //~v61eI~
    char *potsv,*parmsv;                                           //~v61eI~
    FTFUNC *pfunc;                                                 //~v61eI~
//*******************                                              //~v61eI~
    pdh=UGETPDH(Pplc->UDLCplh);                                    //~v61eI~
    if (dlcgetfullname(pdh,fullpathname))                          //~v61eI~
        return 4;                                                  //~v61eI~
  	if (Pplc->UDLCcmd!='S')   //not select cmd                     //~v61eI~
    	if (pdh->UDHtype!=UDHTFILE)                                //~v61eI~
        	return errdir(fullpathname);                           //~v61eI~
    pft=functblsrch(Pfuncid);                                      //~v61eI~
    if (!pft)                                                      //~v61eI~
    	return 8;                                                  //~v61eI~
    pftsv=Ppcw->UCWpfunct;                                         //~v61eR~
    parmsv=Ppcw->UCWparm;                                          //~v61eI~
    potsv=Ppcw->UCWopdpot;                                         //~v61eI~
    opdnosv=Ppcw->UCWopdno;                                        //~v61eI~
                                                                   //~v61eI~
    Ppcw->UCWpfunct=pft;                                           //~v61eR~
    Ppcw->UCWparm=fullpathname;                                    //~v61eR~
	Ppcw->UCWopdpot=fullpathname;  //same as before parse out      //~v61eR~
	Ppcw->UCWopdno=1;        //no other parm                       //~v61eI~
                                                                   //~v61eI~
    pfunc=pft->FTfunc[UCWTDIR];                                    //~v61eI~
    rc=pfunc(Ppcw);                                                //~v61eR~
                                                                   //~v61eI~
    Ppcw->UCWpfunct=pftsv;                                         //~v61eR~
    Ppcw->UCWparm=parmsv;                                          //~v61eI~
    Ppcw->UCWopdpot=potsv;                                         //~v61eI~
    Ppcw->UCWopdno=opdnosv;                                        //~v61eI~
    if (rc)                                                        //~v61eI~
        return rc;                                                 //~v61eI~
    rc=dlcmdeditenq(Ppcw,Pplc); //once deq from previous dir list  //~v61eI~
    return rc;                                                     //~v61eI~
}//dlcmdbbinbefuncid                                               //~v61eR~
//****************************************************************
// dlcmdedit
// process browse dlcmd
//*rc   :0
//****************************************************************
int dlcmdedit(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)
{
    UCHAR  fullpathname[_MAX_PATH];
    int rc;
//*******************
    if (dlcgetfullname(UGETPDH(Pplc->UDLCplh),fullpathname))    //~v05GR~
        return 4;                                               //~5721I~
    Ppcw->UCWparm=fullpathname;
    rc=func_edit_file2(Ppcw,0); //parm is file name only           //~v08lR~
    Ppcw->UCWparm=0;        //worked
    if (rc)                                                     //~v04jI~
        return rc;                                              //~v04jI~
//  if (!rc)                                                    //~v048R~
//      dlcfifo(Ppcw);                                          //~v048R~
    return dlcmdeditenq(Ppcw,Pplc); //once deq from previous dir list//~v04jR~
}//dlcmdedit                                                    //~v04jR~

//****************************************************************//~5723I~
// dlcfifo                                                      //~5723I~
// change order to FIFO                                         //~5723I~
//*parm  :dir list pcw                                          //~5723R~
//*ret   :none                                                  //~5723I~
//****************************************************************//~5723I~
//void dlcfifo(PUCLIENTWE Ppcw)                                 //~v048R~
//{                                                             //~v048R~
//    PUCLIENTWE pcw;                                           //~v048R~
//  PUFILEH pfh;                                                //~v048R~
//*******************                                           //~5723I~
//  pcw=scrgetcw(0);    //current top pcw                       //~v048R~
//  pfh=((PUFILEC)(Ppcw->UCWpfc))->UFCpfh;  //dir pfh           //~v048R~
//  if (UCBITCHK(pfh->UFHflag,UFHFUPCTRREQ))//first time after exec_file//~v048R~
//      UCBITON(pcw->UCWflag,UCWFWAKEUP+UCWFDRAW);//re-init     //~v048R~
//  else                                                        //~v048R~
//  {                                                           //~v048R~
//      pcw=scrdeqcw(Ppcw->UCWsplitid,0,0);//no free,deq top    //~v048R~
//      screnqcw(Ppcw->UCWsplitid,pcw,UQUE_BEF,Ppcw);//after dir//~v048R~
//  }                                                           //~v048R~
//}//dlcfifo                                                    //~v048R~
                                                                //~v04jI~
//****************************************************************//~v046I~
// dlcmdviewb                                                   //~v046I~
// process view browse(v) dlcmd                                 //~v046I~
//*rc   :0                                                      //~v046I~
//****************************************************************//~v046I~
int dlcmdviewb(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)  //~v046I~
{                                                               //~v046I~
    UCHAR  fullpathname[_MAX_PATH];                             //~v046I~
    int rc;                                                     //~v046I~
    int splitsw;                                                   //~v10tI~
    PUCLIENTWE pcw2;                                            //~v046I~
//*******************                                           //~v046I~
//  if (dlcmdviewscrswap1(Ppcw,Pplc,fullpathname,&pcw2))           //~v10tR~
    if ((splitsw=dlcmdviewscrswap1(Ppcw,Pplc,fullpathname,&pcw2))>=4)//~v10tI~
        return 4;                                               //~v046I~
    pcw2->UCWparm=fullpathname;                                 //~v046I~
    rc=func_browse_file2(pcw2,0);   //filename only                //~v08lR~
    pcw2->UCWparm=0;        //worked                            //~v046R~
    if (rc)                                                     //~v046I~
        return rc;                                              //~v046I~
    dlcsaveviewpcw();   //save viewb pcw to swap at last           //~v10sM~
    if (splitsw)                                                   //~v10tI~
    {                                                              //~v10tI~
        scrpopup(pcw2,0);   //pop menu to top                      //~v10tR~
        panpopup(pcw2);     //free top                             //~v10tI~
    }                                                              //~v10tI~
    if (dlcmdviewscrswap2(Ppcw,Pplc))                           //~v046R~
        return 4;                                               //~v046I~
    return 0;                                                   //~v046I~
}//dlcmdviewb                                                   //~v046I~
                                                                //~v046I~
//****************************************************************//~v046I~
// dlcmdviewe                                                   //~v046I~
// process view browse(v) dlcmd                                 //~v046I~
//*rc   :0                                                      //~v046I~
//****************************************************************//~v046I~
int dlcmdviewe(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)  //~v046I~
{                                                               //~v046I~
    UCHAR  fullpathname[_MAX_PATH];                             //~v046I~
    int rc;                                                     //~v046I~
    int splitsw;                                                   //~v10tI~
    PUCLIENTWE pcw2;                                            //~v046I~
//*******************                                           //~v046I~
//  if (dlcmdviewscrswap1(Ppcw,Pplc,fullpathname,&pcw2))           //~v10tR~
    if ((splitsw=dlcmdviewscrswap1(Ppcw,Pplc,fullpathname,&pcw2))>=4)//~v10tI~
        return 4;                                               //~v046I~
    pcw2->UCWparm=fullpathname;                                 //~v046I~
    rc=func_edit_file2(pcw2,0); //parm is filename only            //~v08lR~
    pcw2->UCWparm=0;        //worked                            //~v046R~
    if (rc)                                                     //~v046I~
        return rc;                                              //~v046I~
    dlcsaveviewpcw();   //save viewb pcw to swap at last           //~v10sM~
    if (splitsw)                                                   //~v10tI~
    {                                                              //~v10tI~
        scrpopup(pcw2,0);   //pop menu to top                      //~v10tI~
        panpopup(pcw2);     //free top                             //~v10tI~
    }                                                              //~v10tI~
    if (dlcmdviewscrswap2(Ppcw,Pplc))                           //~v046R~
        return 4;                                               //~v046I~
    return 0;                                                   //~v046I~
}//dlcmdviewe                                                   //~v046I~
//**************************************************************** //~v44fR~
// dlcmdhex                                                        //~v44fR~
// hex display                                                     //~v44fR~
//*rc   :0                                                         //~v44fR~
//**************************************************************** //~v44fR~
int dlcmdhex(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)       //~v44fR~
{                                                                  //~v44fR~
//	return dlcmdotherbecmd(Ppcw,Pplc," /Mh");	//browse/edit cmd parm//~v61eR~
  	return dlcmdotherbecmdfuncid(Ppcw,Pplc,FUNCID_BROWSEHEX,FUNCID_EDITHEX);	//browse/edit cmd parm//~v61eR~
}//dlcmdhex                                                        //~v44fR~
//**************************************************************** //~v44gR~
// dlcmdcobnum                                                     //~v44gR~
// cobol with col1-6:seqno                                         //~v44gR~
//*rc   :0                                                         //~v44gR~
//**************************************************************** //~v44gR~
int dlcmdcobnum(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)    //~v44gR~
{                                                                  //~v44gR~
//  return dlcmdotherbecmd(Ppcw,Pplc," /Mc");	//browse/edit cmd parm//~v61eR~
    return dlcmdotherbecmdfuncid(Ppcw,Pplc,FUNCID_BROWSESPFCOB,FUNCID_EDITSPFCOB);	//browse/edit cmd parm//~v61eR~
}//dlcmdcobnum                                                     //~v44gR~
//**************************************************************** //~v44gR~
// dlcmdcobnum                                                     //~v44gR~
// cobol with col1-6:space                                         //~v44gR~
//*rc   :0                                                         //~v44gR~
//**************************************************************** //~v44gR~
int dlcmdcobspace(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)  //~v44gR~
{                                                                  //~v44gR~
//	return dlcmdotherbecmd(Ppcw,Pplc," /Mk");	//browse/edit cmd parm//~v61eR~
  	return dlcmdotherbecmdfuncid(Ppcw,Pplc,FUNCID_BROWSESPFCOB2,FUNCID_EDITSPFCOB2);	//browse/edit cmd parm//~v61eR~
}//dlcmdcobspace                                                   //~v44gR~
//**************************************************************** //~v44tI~
// dlcmdspfcobnum                                                  //~v44tI~
// cobol with col1-6:seqno                                         //~v44tI~
//*rc   :0                                                         //~v44tI~
//**************************************************************** //~v44tI~
int dlcmdspfcobnum(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy) //~v44tI~
{                                                                  //~v44tI~
//  return dlcmdotherbecmd(Ppcw,Pplc," /Mcn");	//browse/edit cmd parm//~v61eR~
    return dlcmdotherbecmdfuncid(Ppcw,Pplc,FUNCID_BROWSESPFCOBNUM,FUNCID_EDITSPFCOBNUM);	//browse/edit cmd parm//~v61eR~
}//dlcmdspfcobnum                                                  //~v44tI~
//**************************************************************** //~v44tI~
// dlcmdspfcobnum                                                  //~v44tI~
// cobol with col1-6:space                                         //~v44tI~
//*rc   :0                                                         //~v44tI~
//**************************************************************** //~v44tI~
int dlcmdspfcobspace(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)//~v44tI~
{                                                                  //~v44tI~
//	return dlcmdotherbecmd(Ppcw,Pplc," /Mkn");	//browse/edit cmd parm//~v61eR~
	return dlcmdotherbecmdfuncid(Ppcw,Pplc,FUNCID_BROWSESPFCOB2NUM,FUNCID_EDITSPFCOB2NUM);	//browse/edit cmd parm//~v61eR~
}//dlcmdspfcobspace                                                //~v44tI~
//**************************************************************** //~v44gR~
// dlcmdspf                                                        //~v44gR~
// spf                                                             //~v44gR~
//*rc   :0                                                         //~v44gR~
//**************************************************************** //~v44gR~
int dlcmdspf(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)       //~v44gR~
{                                                                  //~v44gR~
//	return dlcmdotherbecmd(Ppcw,Pplc," /Mn");	//browse/edit cmd parm//~v61eR~
  	return dlcmdotherbecmdfuncid(Ppcw,Pplc,FUNCID_BROWSESPF,FUNCID_EDITSPF);	//browse/edit cmd parm//~v61eR~
}//dlcmdspf                                                        //~v44gR~
//**************************************************************** //~v44fR~
// for cmd browse/edit is by upper case                            //~v44fR~
//*rc   :0                                                         //~v44fR~
//**************************************************************** //~v44fR~
int dlcmdotherbecmd(PUCLIENTWE Ppcw,PUDLCMD Pplc,char *Pmode)      //~v44fR~
{                                                                  //~v44fR~
    int  editsw;                                                   //~v44fR~
//*******************                                              //~v44fR~
//dtermin browse or edit                                           //~v44fR~
    if (UCBITCHK(Pplc->UDLCflag,UDLCEDIT))  //dir list is edit mode//~v44fR~
		if (UCBITCHK(Pplc->UDLCflag,UDLCUPPER))	//upper case cmd   //~v44fR~
        	editsw=0;				//reverse mode                 //~v44fR~
        else                                                       //~v44fR~
        	editsw=1;                                              //~v44fR~
    else      								//browse dirlist       //~v44fR~
		if (UCBITCHK(Pplc->UDLCflag,UDLCUPPER))	//upper case cmd   //~v44fR~
        	editsw=1;             //reverse mode                   //~v44fR~
        else                                                       //~v44fR~
        	editsw=0;                                              //~v44fR~
	return dlcmdbinbe(Ppcw,Pplc,editsw,Pmode);	// /Mx             //~v44fI~
}//dlcmdotherbecmd                                                 //~v44fR~
//**************************************************************** //~v61eI~
// for case sensitive cmd browse/edit by func addr parm            //~v61eI~
//*rc   :0                                                         //~v61eI~
//**************************************************************** //~v61eI~
int dlcmdotherbecmdfuncid(PUCLIENTWE Ppcw,PUDLCMD Pplc,int Pfuncidb,int Pfuncide)//~v61eR~
{                                                                  //~v61eI~
    int  editsw;                                                   //~v61eI~
    int funcid;                                                    //~v61eI~
//*******************                                              //~v61eI~
//dtermin browse or edit                                           //~v61eI~
    if (UCBITCHK(Pplc->UDLCflag,UDLCEDIT))  //dir list is edit mode//~v61eI~
		if (UCBITCHK(Pplc->UDLCflag,UDLCUPPER))	//upper case cmd   //~v61eI~
        	editsw=0;				//reverse mode                 //~v61eI~
        else                                                       //~v61eI~
        	editsw=1;                                              //~v61eI~
    else      								//browse dirlist       //~v61eI~
		if (UCBITCHK(Pplc->UDLCflag,UDLCUPPER))	//upper case cmd   //~v61eI~
        	editsw=1;             //reverse mode                   //~v61eI~
        else                                                       //~v61eI~
        	editsw=0;                                              //~v61eI~
    if (editsw)                                                    //~v61eI~
    	funcid=Pfuncide;                                           //~v61eI~
    else                                                           //~v61eI~
    	funcid=Pfuncidb;                                           //~v61eI~
	return dlcmdbinbefuncid(Ppcw,Pplc,funcid);	//call browse func //~v61eR~
}//dlcmdotherbecmdfuncid                                           //~v61eR~
//****************************************************************//~v046I~
// dlcmddeqpfc                                                  //~v046I~
//*deq pfc from pdh and re-draw plh                             //~v046I~
//*parm1:pfc                                                       //~v09wR~
//*return:none                                                  //~v046I~
//****************************************************************//~v046I~
void dlcmddeqpfc(PUFILEC Ppfc)                                     //~v09wR~
{                                                               //~v046I~
    PUQUEH  pqh;                                                //~v046I~
    PUDIRLH pdh;                                                //~v046I~
    PULINEH plh;                                                //~v046I~
//  PULINEH plhprev;                                               //~v10kR~
    PUFILEH pfh;                                                   //~v09bI~
    PUCLIENTWE pcw;                                                //~v09bI~
//*******************                                           //~v046I~
    if (pqh=UGETQHDR(Ppfc),pqh)         //qhdr addr on pdh      //~v046R~
    {                                                           //~v046I~
        UDEQ(UQUE_ENT,pqh,Ppfc);        //deq from view lcmd pdh//~v046R~
        pdh=(PUDIRLH)(PVOID)((ULONG)pqh-offsetof(UDIRLH,UDHviewqh));//~v046I~
        plh=UGETDIRPLH(pdh);                                    //~v046I~
        pfh=UGETPFH(plh);                                          //~v54mI~
        UCBITON(plh->ULHflag,ULHFDRAW); //to clear viewed sign  //~v046I~
        if (UCBITCHK(Ppfc->UFCflag,UFCFENDSAVE))    //saved at end//~v04jI~
        {                                                       //~v05GI~
            dlcmdresetdata(pdh);                                //~v05GI~
            dlcmdupctr(plh);                                    //~v04jI~
//          pfh=UGETPFH(plh);                                      //~v54mR~
            pcw=pfh->UFHbrowsepcw[0];                              //~v09bR~
            if (pcw)                                               //~v09bI~
                dlcfsiupdate(pcw); //update free space info        //~v09bI~
            pcw=pfh->UFHbrowsepcw[1];                              //~v09bR~
            if (pcw)                                               //~v09bI~
                dlcfsiupdate(pcw); //update free space info        //~v09bI~
        }                                                       //~v05GI~
#ifdef FTPSUPP                                                     //~v54mI~
        else                                                       //~v54mI~
            if (FILEISREMOTE(pfh))                                 //~v54mI~
              if (FILEISTSO(pfh)==0)                               //~v71aI~
        	    dirresetftpfiletime(pdh,pfh);                      //~v54mI~
#endif                                                             //~v54mI~
//no need to delete(not isrted if new at start)                    //~v10kI~
//        else                                                     //~v10kR~
//            if (UCBITCHK(Ppfc->UFCflag,UFCFCANNEWF))    //saved at end//~v10kR~
//            {                                                    //~v10kR~
//                plhprev=UGETQPREV(plh);                          //~v10kR~
//                dlcdelentry(plh,plhprev); //update free space info//~v10kR~
//                dirrenum(plhprev);  //lineno renumber after this line//~v10kR~
//            }                                                    //~v10kR~
    }                                                           //~v046I~
    return;                                                        //~v09wI~
}//dlcmddeqpfc                                                  //~v046I~
                                                                //~v046I~
//****************************************************************//~v05GI~
// dlcmdresetdata                                               //~v05GR~
//*reset information for updated file                           //~v05GI~
//*parm :pdh                                                    //~v05GI~
//*return:rc                                                    //~v05GI~
//****************************************************************//~v05GI~
int dlcmdresetdata(PUDIRLH Ppdh)                                //~v05GI~
{                                                               //~v05GI~
    FILEFINDBUF3  fstat3;                                       //~v05GI~
    int rc;                                                     //~v05PI~
    UCHAR  fullpathname[_MAX_PATH];                             //~v05GI~
    ULONG oldsz;                                                   //~v10rI~
    int   swexpanded;                                              //~v60rI~
#ifdef FTPSUPP                                                     //~v71aI~
    PUFILEH pfh;                                                   //~v71aI~
    PULINEH plh;                                                   //~v71aI~
#endif                                                             //~v71aI~
//**********                                                    //~v05GI~
#ifdef FTPSUPP                                                     //~v71aI~
	plh=UGETDIRPLH(Ppdh);                                          //~v71aI~
	pfh=UGETPFH(plh);                                              //~v71aI~
    if (FILEISTSO(pfh))                                            //~v71aI~
    {                                                              //~v71jI~
		UCBITOFF(Ppdh->UDHflag,UDHFDDSETUP);	//request line make//~v71jI~
    	return 0;  //size/timestamp is already set at save         //~v71aI~
    }                                                              //~v71jI~
#endif                                                             //~v71aI~
    if (dlcgetfullname(Ppdh,fullpathname))                      //~v05GI~
        return 4;                                               //~v05GI~
    rc=filefind(fullpathname,0,&fstat3,FFNODIRMSG);             //~v05PR~
//  if (!rc && rc!=16)  //not file nor dir                         //~v09vR~
    if (rc && rc!=16)   //not file nor dir                         //~v09vI~
        return 4;                                               //~v05GI~
    if (UCBITCHK(Ppdh->UDHupdatetype,UDHUTNOTEXIST))               //~v10rI~
        oldsz=0;                                                   //~v10rI~
    else                                                           //~v10rI~
        oldsz=Ppdh->UDHsize;                                       //~v10rR~
    swexpanded=(Ppdh->UDHtype==UDHTDIREXP); //dirserdatasub2 may change UDHtype//~v60rI~
    dirsetdatasub2(Ppdh,&fstat3);                               //~v05GR~
    if (Ppdh->UDHtype==UDHTDIR)	//yet dir                          //~v60rI~
	    if (swexpanded)                                            //~v60rI~
			Ppdh->UDHtype=UDHTDIREXP; 		//recover              //~v60rI~
    dlcmdresetparentsz(Ppdh,DLCPSZ_SZ,Ppdh->UDHsize-oldsz,0);//update parent sz//~v10rR~
    return rc;  //normal file or dir                            //~v05PR~
}//dlcmdresetdata                                               //~v05GI~
                                                                //~v05GI~
//****************************************************************//~v05oI~
// dlcmdfree                                                    //~v05oI~
// clear view screen                                            //~v05oI~
//*rc   :rc                                                     //~v05oI~
//****************************************************************//~v05oI~
int dlcmdfree(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)   //~v05oI~
{                                                               //~v05oI~
    PULINEH plh;                                                //~v05oI~
    PUDIRLH pdh;                                                //~v05oM~
    PUFILEC pfc;                                                //~v05oM~
//*******************                                           //~v05oI~
    plh=Pplc->UDLCplh;                                          //~v05oI~
    pdh=UGETPDH(plh);                                           //~v05oI~
//  if (!(pfc=UDEQ(UQUE_TOP,&pdh->UDHviewqh,0)))    //enqued pfc   //~v09vR~
    if (!(pfc=UGETQTOP(&pdh->UDHviewqh)))   //top pfc              //~v09vI~
    {                                                           //~v05oM~
        uerrmsg("It is not viewed",                             //~v05oM~
                "View Ă܂");                         //~v05oM~
        return 4;                                               //~v05oM~
    }                                                           //~v05oM~
    return dlcmdfreesub(Ppcw,pfc);                              //~v05oI~
}//dlcmdfree                                                    //~v05oI~
                                                                //~v05oI~
//****************************************************************//~v046I~
// dlcmdfreesub                                                 //~v05oR~
// clear view screen                                            //~v046I~
//parm1:pcw                                                     //~v05oI~
//parm2:pfc                                                     //~v05oI~
//*rc   :rc                                                     //~v046I~
//****************************************************************//~v046I~
int dlcmdfreesub(PUCLIENTWE Ppcw,PUFILEC Ppfc)                  //~v05oR~
{                                                               //~v046I~
    PUCLIENTWE pcw;                                             //~v046I~
    int rc;                                                     //~v04lI~
//*******************                                           //~v046I~
    pcw=Ppfc->UFCpcw;                                           //~v05oR~
    Gscrcurclient=pcw->UCWsplitid;  //enq to top of that split  //~v046I~
    scrpopup(pcw,0);    //popup to top                          //~v046R~
    if (pcw->UCWtype==UCWTFILE)                                 //~v04lI~
        rc=func_end_file(pcw);                                  //~v04lR~
    else                                                        //~v04lI~
        rc=func_end_dir(pcw);                                   //~v04lI~
    if (rc)                                                     //~v04lI~
        return rc;                                              //~v04lR~
    csrrestore(Ppcw);   //restore previous cursor pos           //~v046I~
    return 0;                                                   //~v046I~
}//dlcmdfreesub                                                 //~v05oR~
                                                                //~v046I~
//****************************************************************//~5917I~
// dlcmdcd                                                      //~5917I~
// set current dir                                              //~5917I~
//*ret   :rc                                                    //~5917I~
//****************************************************************//~5917I~
int dlcmdcd(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)     //~5917I~
{                                                               //~5917I~
    PULINEH plh;                                                //~5917I~
    PUDIRLH pdh;                                                //~5917I~
#ifdef FTPSUPP                                                     //~v54rI~
    PUFILEH pfh;                                                   //~v54rR~
#endif                                                             //~v54rI~
    int pathlen;                                                //~5917I~
    UCHAR   dirname[_MAX_PATH]; //fullpath name                 //~5917R~
//****************************                                  //~5917I~
    plh=Pplc->UDLCplh;                                          //~5917I~
#ifdef FTPSUPP                                                     //~v54rI~
    pfh=UGETPFH(plh);                                              //~v54rI~
#endif                                                             //~v54rI~
    pdh=UGETPDH(plh);                                           //~5917I~
    if (dlcgetfullname(pdh,dirname))                            //~v05GR~
        return 4;                                               //~5917I~
    if (pdh->UDHtype==UDHTFILE)                                 //~5917M~
    {                                                           //~5917I~
#ifdef FTPSUPP                                                     //~v71aI~
      if (FILEISTSO(pfh))                                          //~v71aI~
    	u3270parentdsn(U3PL_PARENTORDROPMEMBER,dirname,dirname);//0:parent path//~v71aI~
      else                                                         //~v71aI~
      {                                                            //~v71aI~
#endif                                                             //~v71aI~
        pathlen=PATHLEN(dirname);                               //~5917I~
        *(dirname+pathlen)=0;                                   //~5917I~
        if (!ROOTDIR(dirname))                                  //~5917I~
           *(dirname+pathlen-1)=0;                              //~5917I~
#ifdef FTPSUPP                                                     //~v71aI~
      }                                                            //~v71aI~
#endif                                                             //~v71aI~
    }                                                           //~5917I~
    Ppcw->UCWopdpot=            //single parm                      //~v091I~
    Ppcw->UCWparm=dirname;                                      //~5917I~
#ifdef FTPSUPP                                                     //~v54rI~
  if (!FILEISREMOTE(pfh))                                          //~v54rI~
#endif                                                             //~v54rI~
#ifndef UNX                                                        //~v196I~
    if (dcmd_drive(Ppcw))   //use only drive letter on UCWparm  //~5917R~
        return 4;                                               //~5917I~
#endif //! UNX                                                     //~v196I~
    filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr              //~v05rI~
    return dcmd_cd(Ppcw);                                       //~5917I~
}//dlcmdcd                                                      //~5917I~
                                                                //~5917I~
//****************************************************************//~v04bI~
// dlcmdexpandall                                               //~v04bI~
// process expandall(>) dlcmd                                   //~v04bI~
//*ret   :rc                                                    //~v04bI~
//****************************************************************//~v04bI~
int dlcmdexpandall(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)//~v04bI~
{                                                               //~v04bI~
    int rc;                                                     //~v04bI~
#ifdef FTPSUPP                                                     //~v71aI~
    PUFILEC pfc;                                                   //~v71aI~
    PUFILEH pfh;                                                   //~v71aI~
#endif                                                             //~v71aI~
//****************************                                  //~v04bI~
#ifdef FTPSUPP                                                     //~v71aI~
    pfc=Ppcw->UCWpfc;                                              //~v71aI~
    pfh=pfc->UFCpfh;                                               //~v71aI~
    if (FILEISTSO(pfh))                                            //~v71aI~
        return errnotsupported(">(ExpandAll)","TSO PDS");          //~v71aR~
#endif                                                             //~v71aI~
    Sexpandallsw=1;                                             //~v04bI~
    Sexpandallerr=0;                                            //~v04bI~
    rc=dlcmdexpand(Ppcw,Pplc,Pplcdummy);                        //~v04bI~
    Sexpandallsw=0;                                             //~v04bI~
    if (!rc)                                                    //~v04bI~
        if (Sexpandallerr)                                      //~v04bR~
            ubell();                                            //~v04bI~
    return rc;                                                  //~v04bI~
}//dlcmdexpandall                                               //~v04bI~
//**************************************************************** //~v152I~
// refresh cmd                                                     //~v152I~
//*ret   :rc                                                       //~v152I~
//**************************************************************** //~v152I~
int func_dlcmdrefresh(PUCLIENTWE Ppcw)                             //~v152I~
{                                                                  //~v152I~
    PUFILEC pfc;                                                   //~v152I~
    PUFILEH pfh;                                                   //~v152I~
    PULINEH plh,plh0;                                              //~v152I~
    PUDIRLH pdh;                                                   //~v152I~
    int rc=0;                                                      //~v152I~
    int level,levelmax,levelf;                                     //~v152R~
//****************************                                     //~v152I~
    pfc=Ppcw->UCWpfc;                                              //~v152I~
    pfh=pfc->UFCpfh;                                               //~v152I~
    plh0=UGETQTOP(&pfh->UFHlineque);                               //~v152I~
    levelf=pfh->UFHlevel;                                          //~v152I~
//get lowest level                                                 //~v152I~
    for (plh=plh0,levelmax=levelf;plh;plh=UGETQNEXT(plh))          //~v152R~
    {                                                              //~v152I~
        if (plh->ULHtype!=ULHTDATA) //file data                    //~v152I~
            continue;                                              //~v152I~
        pdh=UGETPDH(plh);                                          //~v152I~
        UCBITON(pdh->UDHflag2,UDHF2REFRESH);//description may re-read//~v690R~
        level=(int)pdh->UDHlevel;                                  //~v152R~
        if (pdh->UDHtype==UDHTDIREXP                               //~v152R~
        &&  level>levelmax      //srch lowest                      //~v152I~
        &&  !UCBITCHK(pdh->UDHflag,UDHFEXCLUDED))//not excluded    //~v152I~
            levelmax=(int)pdh->UDHlevel;                           //~v152R~
    }                                                              //~v152I~
//expand from lowest                                               //~v152I~
    for (level=levelmax;level>=levelf;level--)                     //~v152R~
    {                                                              //~v152I~
        for (plh=plh0;plh;plh=UGETQNEXT(plh))                      //~v152R~
        {                                                          //~v152I~
            if (plh->ULHtype!=ULHTDATA) //file data                //~v152I~
                continue;                                          //~v152I~
            pdh=UGETPDH(plh);                                      //~v152I~
            if (UCBITCHK(pdh->UDHflag,UDHFEXCLUDED))//excluded     //~v152I~
                continue;                                          //~v152I~
            if ((int)pdh->UDHlevel!=level)                         //~v152R~
                continue;                                          //~v152I~
            if (level==levelf                                      //~v152R~
            ||  pdh->UDHtype==UDHTDIREXP)                          //~v152I~
                if (rc=dlcmdrefreshsub(Ppcw,plh,pdh),rc)           //~v152R~
                {                                                  //~v485I~
//                  break;                                         //~v485R~
					rc=0;		//ignore deleted                   //~v485I~
                    continue;                                      //~v485I~
                }                                                  //~v485I~
        }                                                          //~v152I~
        if (rc)                                                    //~v152I~
            break;                                                 //~v152I~
    }                                                              //~v152I~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);    //full redraw              //~v152I~
    dirrenum(plh0); //lineno renumber from next of this line       //~v152I~
    return rc;                                                     //~v152I~
}//func_dlcmdrefresh                                               //~v152I~
//****************************************************************//~v04bI~
// dlcmdexpand                                                  //~v04bI~
// process expand dlcmd                                         //~v04bI~
//*ret   :rc                                                    //~v04bI~
//****************************************************************//~v04bI~
int dlcmdexpand(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy) //~v04bI~
{                                                               //~v04bI~
    PULINEH plh;                                                //~v04bI~
    PUFILEH pfh;                                                //~v04bI~
    PUDIRLH pdh;                                                //~v04bI~
    UCHAR   dirname[_MAX_PATH]; //for udirlist                  //~v04bI~
//  UCHAR   filemask[PANL310MASKLEN]; //getflddata                 //~v09hR~
//  UCHAR   filemask[PANL310MASKLEN+1]; //getflddata               //~v57fR~
    UCHAR   filemask[_MAX_PATH]; //getflddata                      //~v57fI~
    int parentsw;                                               //~v05KI~
    ULONG  oldsz;                                                  //~v10rI~
     LONG  oldlc;                                                  //~v10rI~
//****************************                                  //~v04bI~
    plh=Pplc->UDLCplh;                                          //~v04bI~
    pfh=UGETPFH(plh);                                           //~v04bI~
    pdh=UGETPDH(plh);                                           //~v04bI~
    if (pdh->UDHtype==UDHTFILE)                                 //~v04bI~
    {                                                           //~v05HI~
        dirsetflddata(Ppcw,plh,PANL310RENAME,"");               //~v05HI~
        return  dlcmdresetdata(pdh);                            //~v05HI~
    }                                                           //~v05HI~
    if (dlcgetfullname(pdh,dirname))                            //~v05GR~
        return 4;                                               //~v04bI~
    if (dirgetflddata(Ppcw,plh,PANL310RENAME,filemask)<0)  //fld len//~v47aR~
        return 4;   //internal logic err                           //~v47aR~
    oldsz=pdh->UDHsize; //save for parent size update              //~v10rI~
    oldlc=plh->ULHlinenow;//save for parent linecnt update         //~v10rI~
    if (Sexpandallsw)                                           //~v04bI~
        dlcmdlvlclear(Ppcw,pdh,1,0);//force clear under the level//~v05oR~
    else                                                        //~v04bI~
    {                                                              //~v57fI~
        if (UCBITCHK(pdh->UDHflag,UDHFEXCLUDED))//excluded      //~v04bR~
            if (dlcmdunexclude(Ppcw,Pplc,Pplcdummy))            //~v04bR~
                return 4;                                       //~v04bR~
    }                                                              //~v57fI~
    parentsw=(pdh->UDHtype==UDHTPARENT);                        //~v05KI~
    if (dlcmdexpand1(Ppcw,plh,dirname,filemask))                //~v04bI~
        return 4;                                               //~v04bI~
    if (parentsw)                   //expand set direxpand id   //~v05KI~
        pdh->UDHtype=UDHTPARENT;    //recov parent id           //~v05KI~
    if (pdh->UDHlevel<=pfh->UFHlevel)   //path up               //~v04bI~
        dlcchngfh(Ppcw,pfh,pdh,dirname);//change pfh filename   //~v04bR~
    dlcmdsetszorlc(Ppcw,plh,UCBITCHK(pdh->UDHflag2,UDHF2DISPLC)!=0);//1:lc,0:sz//~v10rI~
    dlcmdresetparentsz(pdh,DLCPSZ_SZ|DLCPSZ_LC,                    //~v10rR~
                        pdh->UDHsize-oldsz,plh->ULHlinenow-oldlc);//update parent sz//~v10rI~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);    //full redraw           //~v04bI~
    filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr              //~v04bI~
    dirrenum(plh);  //lineno renumber from next of this line    //~v04bI~
    return 0;                                                   //~v04bI~
}//dlcmdexpand                                                  //~v04bI~
//**************************************************************** //~v57jR~
// dlcmdexpandbysort                                               //~v57jR~
// process dirlist sort cmd                                        //~v57jR~
//*ret   :rc                                                       //~v57jR~
//**************************************************************** //~v57jR~
int dlcmdexpandbysort(PUCLIENTWE Ppcw,char *Psortopt)              //~v57jR~
{                                                                  //~v57jR~
    PUFILEC pfc;                                                   //~v57jR~
    PUFILEH pfh;                                                   //~v57jR~
    PULINEH plh,plhp;                                              //~v57jR~
    PUDIRLH pdh,pdhp;                                              //~v57jR~
    UCHAR   dirname[_MAX_PATH]; //for udirlist                     //~v57jR~
    UCHAR   filemask[_MAX_PATH+8]; //for udirlist                  //~v58tI~
    char *pc;                                                      //~v59MI~
//****************************                                     //~v57jR~
  	pfc=Ppcw->UCWpfc;                                              //~v57jR~
  	pfh=pfc->UFCpfh;                                               //~v57jR~
#ifdef FTPSUPP                                                     //~v71aI~
    if (FILEISTSO(pfh))                                            //~v71aI~
        return errnotsupported("SORt","TSO PDS");                  //~v71aI~
#endif                                                             //~v71aI~
	for (plh=UGETQTOP(&pfh->UFHlineque);plh;plh=UGETQNEXT(plh))    //~v57jR~
	{                                                              //~v57jR~
		if (plh->ULHtype!=ULHTDATA)	//file data                    //~v57jR~
            continue;                                              //~v57jR~
    	pdh=UGETPDH(plh);                                          //~v57jR~
        if (pdh->UDHtype==UDHTPARENT)                              //~v57jR~
        {                                                          //~v57jR~
        	plhp=plh;	//parent plh for size/time search          //~v57jR~
            pdhp=pdh;                                              //~v57jR~
        }                                                          //~v57jR~
        else                                                       //~v57jR~
        	break;                                                 //~v57jR~
    }                                                              //~v57jR~
    if (dlcgetfullname(pdhp,dirname))                              //~v57jR~
        return 4;                                                  //~v57jR~
    if (UCBITCHK(pdhp->UDHflag,UDHFEXCLUDED))//excluded            //~v57jR~
    {                                                              //~v57jR~
    	uerrmsg("path excluded",0);                                //~v57jR~
        return 4;                                                  //~v57jR~
    }                                                              //~v57jR~
    if (UCBITCHK(pdhp->UDHflag2,UDHF2MASKNAME)                     //~v58tI~
    &&  !UCBITCHK(pdhp->UDHupdatetype,UDHUTNOTEXIST)               //~v58tI~
    &&  pdhp->UDHrenamesv && *pdhp->UDHrenamesv)                   //~v58tR~
    {                                                              //~v59MI~
      if (pdhp->UDHsortopt)   //previous sort option               //~v59NR~
      {                                                            //~v59NR~
          pc=strrchr(pdhp->UDHrenamesv,' ');                       //~v59NR~
          if (pc && *(pc+1)=='/' && *(pc+2)=='o')                  //~v59NR~
          {                                                        //~v59NR~
              *pc=0;                                               //~v59NR~
              sprintf(filemask,"%s %s",pdhp->UDHrenamesv,Psortopt);//~v59NR~
          }                                                        //~v59NR~
          else                                                     //~v59NR~
              sprintf(filemask,"%s",Psortopt);                     //~v59NR~
      }                                                            //~v59NR~
      else                                                         //~v59NR~
        sprintf(filemask,"%s %s",pdhp->UDHrenamesv,Psortopt);      //~v58tR~
    }                                                              //~v59NR~
    else                                                           //~v58tI~
    	strcpy(filemask,Psortopt);                                 //~v58tI~
//  if (dlcmdexpand1(Ppcw,plhp,dirname,Psortopt))                  //~v58tR~
    if (dlcmdexpand1(Ppcw,plhp,dirname,filemask))                  //~v58tI~
        return 4;                                                  //~v57jR~
    pdhp->UDHtype=UDHTPARENT;    //recov parent id                 //~v57jR~
	dirrenum(plhp);                                                //~v59WI~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);    //full redraw              //~v57jR~
    return 0;                                                      //~v57jR~
}//dlcmdexpandbysort                                               //~v57jR~
//**************************************************************** //~v152I~
// dlcmdrefreshsub                                                 //~v152R~
// expand by refresh cmd                                           //~v152R~
//*ret   :rc                                                       //~v152I~
//**************************************************************** //~v152I~
int dlcmdrefreshsub(PUCLIENTWE Ppcw,PULINEH Pplh,PUDIRLH Ppdh)     //~v152R~
{                                                                  //~v152I~
    UCHAR   dirname[_MAX_PATH]; //for udirlist                     //~v152I~
//  UCHAR   filemask[PANL310MASKLEN+1]; //getflddata               //~v47aR~
    UCHAR   filemask[_MAX_PATH]; //for udirlist                    //~v47aI~
    int parentsw;                                                  //~v152I~
    ULONG  oldsz;                                                  //~v152I~
     LONG  oldlc;                                                  //~v152I~
//****************************                                     //~v152I~
    if (dlcgetfullname(Ppdh,dirname))                              //~v152I~
        return 4;                                                  //~v152I~
    oldsz=Ppdh->UDHsize; //save for parent size update             //~v152I~
    oldlc=Pplh->ULHlinenow;//save for parent linecnt update        //~v152I~
    parentsw=(Ppdh->UDHtype==UDHTPARENT);                          //~v152R~
//  if (dlcmdexpand1(Ppcw,Pplh,dirname,""))                        //~v20QR~
//  if (dirgetflddata(Ppcw,Pplh,PANL310RENAME,filemask)<0)  //fld len//~v47aR~
//      return 4;   //internal logic err                           //~v47aR~
    if (UCBITCHK(Ppdh->UDHflag2,UDHF2MASKNAME)                     //~v47aR~
    &&  !UCBITCHK(Ppdh->UDHupdatetype,UDHUTNOTEXIST)               //~v57aI~
    &&  Ppdh->UDHrenamesv && *Ppdh->UDHrenamesv)                   //~v47aR~
        strcpy(filemask,Ppdh->UDHrenamesv);                        //~v47aR~
    else                                                           //~v47aI~
    	*filemask=0;                                               //~v47aI~
    Srefreshsw=1;                                                  //~v485I~
    if (dlcmdexpand1(Ppcw,Pplh,dirname,filemask))                  //~v20QI~
    {                                                              //~v485I~
    	Srefreshsw=0;                                              //~v485I~
    	if (parentsw)                   //expand set direxpand id  //~v57bI~
        	Ppdh->UDHtype=UDHTPARENT;   //recov parent id          //~v57bI~
        return 4;                                                  //~v152I~
    }                                                              //~v485I~
    Srefreshsw=0;                                                  //~v485I~
    dlcmdresetdata(Ppdh);			//set new data(it may be mkdir'ed after del)//~v57cM~
    UCBITOFF(Ppdh->UDHupdatetype,UDHUTNOTEXIST);    //clear del/move/rename//~v57cM~
    if (parentsw)                   //expand set direxpand id      //~v152I~
        Ppdh->UDHtype=UDHTPARENT;   //recov parent id              //~v152R~
    dlcmdsetszorlc(Ppcw,Pplh,UCBITCHK(Ppdh->UDHflag2,UDHF2DISPLC)!=0);//1:lc,0:sz//~v152I~
    dlcmdresetparentsz(Ppdh,DLCPSZ_SZ|DLCPSZ_LC,                   //~v152I~
                        Ppdh->UDHsize-oldsz,Pplh->ULHlinenow-oldlc);//update parent sz//~v152I~
    return 0;                                                      //~v152I~
}//dlcmdrefreshsub                                                 //~v152R~
//****************************************************************//~v04bI~
// dlcmdexpand1                                                 //~v04bI~
// process expand 1 directory                                   //~v04bI~
//*parm1:pcw                                                    //~v04bI~
//*parm2:plh                                                    //~v04bI~
//*parm3:dir name                                               //~v04bI~
//*parm4:file selection mask                                    //~v04bI~
//*ret   :rc                                                    //~v04bI~
//****************************************************************//~v04bI~
int dlcmdexpand1(PUCLIENTWE Ppcw,PULINEH Pplh,                  //~v04bI~
                        UCHAR *Pdirname,UCHAR *Pfilemask)       //~v04bI~
{                                                               //~v04bI~
    PUDIRLIST pudirlist;                                        //~v04bI~
    PUDIRLH pdh;                                                //~v04bI~
    PUFILEH pfh;                                                   //~v0frI~
    PULINEH plhn,plhw,plh;                                      //~v04bR~
    int     filectr,len,len2,pathlen;                           //~v04bR~
    int refresherrsw=0;                                            //~v57bI~
    int opt;                                                       //~v57fI~
    UCHAR   filemask[_MAX_PATH]; //for udirlist                    //~v57fI~
    int sortopt;                                                   //~v57fI~
#ifdef FTPSUPP                                                     //~v71aI~
    int membopt;                                                   //~v71aI~
#endif                                                             //~v71aI~
//****************************                                  //~v04bI~
    pdh=UGETPDH(Pplh);                                          //~v04bI~
    pfh=UGETPFH(Pplh);                                             //~v0frI~
    strcpy(filemask,Pfilemask);                                    //~v57fI~
    if (dlcmdgetexpopt(filemask,&sortopt))                         //~v57fM~
        return 4;   //internal logic err                           //~v57fM~
//  if (sortopt!=pdh->UDHsortopt)                                  //~v57jR~
    if (sortopt!=pdh->UDHsortopt||sortopt)//changed or not by name //~v57jR~
    {                                                              //~v57fI~
        dlcmdlvlclear(Ppcw,pdh,1,0);//force clear under the level  //~v57fI~
        pdh->UDHsortopt=(UCHAR)sortopt;                            //~v57jR~
    }                                                              //~v57fI~
#ifdef FTPSUPP                                                     //~v71aI~
  if (FILEISTSO(pfh))                                              //~v71aI~
  {                                                                //~v71aI~
    if (*filemask)  //mask specified                               //~v71aI~
    {                                                              //~v71aI~
    	if (pdh->UDHattr & FILE_DIRECTORY)                         //~v71aI~
        	membopt=1;                                             //~v71aI~
        else                                                       //~v71aI~
        	membopt=0;                                             //~v71aI~
  		if (u3270concatfilename(membopt,Pdirname,filemask,Pdirname)<0)//~v71aR~
    		return 4;                                              //~v71aR~
    }                                                              //~v71aI~
  }                                                                //~v71aI~
  else                                                             //~v71aI~
  {                                                                //~v71aI~
#endif                                                             //~v71aI~
    len=(int)strlen(Pdirname);                                  //~v04bI~
//  len2=(int)strlen(Pfilemask);                                   //~v57fR~
    len2=(int)strlen(filemask);                                    //~v57fI~
    if (len2)   //mask input len                                //~v04bI~
    {                                                           //~v04bI~
        if ((len+len2+1)>=_MAX_PATH)                            //~v04bI~
            return errtoolong();                                //~v04bI~
        if (pdh->UDHlevel)                                      //~v04bI~
//          *(Pdirname+len++)='\\';                                //~v19aR~
//          *(Pdirname+len++)=DIR_SEPC;                            //~v540R~
            *(Pdirname+len++)=pfh->UFHdirsepc;                     //~v540I~
//      strcpy(Pdirname+len,Pfilemask);                            //~v57fR~
        strcpy(Pdirname+len,filemask);                             //~v57fI~
        len+=len2;                                              //~v04bI~
    }                                                           //~v04bI~
    else                                                        //~v04bI~
    {                                                           //~v04bI~
        if ((len+4+1)>=_MAX_PATH)                               //~v04bI~
            return errtoolong();                                //~v04bI~
        if (pdh->UDHlevel)                                      //~v04bI~
        {                                                          //~v540I~
//          strcpy(Pdirname+len,"\\*.*");                          //~v19aR~
//          strcpy(Pdirname+len,DIR_SEPS "*.*");                   //~v19VR~
//          strcpy(Pdirname+len,DIR_SEPS DIR_ALLMEMB);             //~v540R~
            *(Pdirname+len)=pfh->UFHdirsepc;                       //~v540I~
            strcpy(Pdirname+len+1,DIR_ALLMEMB);                    //~v540I~
        }                                                          //~v540I~
        else    //root                                          //~v04bI~
//          strcpy(Pdirname+len,"*.*");                            //~v19VR~
            strcpy(Pdirname+len,DIR_ALLMEMB);                      //~v19VI~
    }                                                           //~v04bI~
#ifdef FTPSUPP                                                     //~v71aI~
  }                                                                //~v71aI~
#endif                                                             //~v71aI~
    dirsetflddata(Ppcw,Pplh,PANL310RENAME,Pfilemask);  //drop pre space//~v04bM~
//  filectr=dirgetlist(pfh,Pdirname,0,&pudirlist);//name seq       //~v57fR~
	opt=pdh->UDHsortopt<<8;                                        //~v57fI~
    filectr=dirgetlist(pfh,Pdirname,(UINT)opt,&pudirlist);//name seq//~v57jR~
    if (filectr<0)  //err                                       //~v04bI~
    {                                                           //~v04bI~
//    if (Srefreshsw)                                              //~v71tR~
      if (Srefreshsw                                               //~v71tI~
      &&  UCBITCHK(pdh->UDHupdatetype,UDHUTNOTEXIST))              //~v71tR~
      {                                                            //~v485I~
		ugeterrmsg();           //clear notfound msg               //~v485I~
//    	return 1;	//no errmsg                                    //~v57bR~
        pudirlist=0;                                               //~v57bI~
        filectr=0;  //parm to lvlmerge(avoid abend)                //~v57bI~
        refresherrsw=1;                                            //~v57bI~
      }                                                            //~v485I~
      else                                                         //~v57bI~
      {                                                            //~v57bI~
        dirsetflderr(Ppcw,Pplh,PANL310RENAME);//reverse err fld //~v04bI~
        return 4;                                               //~v04bI~
      }                                                            //~v57bI~
    }                                                           //~v04bR~
    pdh->UDHtype=UDHTDIREXP;                                    //~v04bM~
    UCBITOFF(Pplh->ULHflag,ULHFHLDIRTYPE);//highlight of parent unexp//~v05KR~
    UCBITOFF(pdh->UDHflag,UDHFLCMDIN2|UDHFMASK|UDHFDDSETUP);    //~v04bM~
    UCBITON(pdh->UDHflag2,UDHF2MASKNAME);                          //~v47aI~
    if (dirsavename(Pplh,Pfilemask))                            //~v05FR~
        return 4;                                               //~v05FI~
//enq file data                                                 //~v04bI~
    plhn=UGETQNEXT(Pplh);   //stopper for expand all            //~v04bI~
    dlclvlmerge(Ppcw,pdh,pudirlist,filectr);                    //~v04bI~
    pathlen=PATHLEN(Pdirname);                                  //~v04bI~
    if (Sexpandallsw)   //expand all cmd                        //~v04bI~
    {                                                           //~v04bI~
        plhw=plhn;  //compile warning                           //~v04bR~
        for (plh=UGETQNEXT(Pplh);plh!=plhn;plh=plhw)    //all entry//~v04bR~
        {                                                       //~v04bI~
            pdh=UGETPDH(plh);                                   //~v04bI~
            plhw=UGETQNEXT(plh);    //next before insert        //~v04bI~
            if (pdh->UDHtype==UDHTFILE)                         //~v04bI~
                continue;                                       //~v04bI~
            strcpy(Pdirname+pathlen,pdh->UDHname);              //~v04bR~
            if (dlcmdexpand1(Ppcw,plh,Pdirname,Pfilemask))//ignore err//~v04bR~
            {                                                   //~v04bI~
//avoid input   UCBITON(pdh->UDHflag,UDHFLCMDIN2|UDHFMASK); //rename cmd input//~v04bR~
                Sexpandallerr=1;                                //~v04bR~
            }                                                   //~v04bI~
            if (*Pfilemask)                                        //~v47aI~
                UCBITON(pdh->UDHflag,UDHFMASK); //rename cmd input //~v47aI~
        }                                                       //~v04bI~
    }                                                           //~v04bI~
  if (pudirlist)                                                   //~v57bI~
    ufree(pudirlist);                                           //~v04bI~
#ifdef FTPSUPP                                                     //~v71aI~
  if (FILEISTSO(pfh))                                              //~v71aI~
    u3270parentdsn(0,Pdirname,Pdirname);//0:parent path            //~v71aI~
  else                                                             //~v71aI~
  {                                                                //~v71aI~
#endif                                                             //~v71aI~
    *(Pdirname+pathlen)=0;   //file name on pfh       //~v04bR~
    if (!ROOTDIR(Pdirname))                                     //~v04bI~
        *(Pdirname+pathlen-1)=0;   //file name on pfh          //~v04bI~
#ifdef FTPSUPP                                                     //~v71aI~
  }                                                                //~v71aI~
#endif                                                             //~v71aI~
    if (refresherrsw)                                              //~v57bI~
    	return 1;                                                  //~v57bI~
    return 0;                                                   //~v04bR~
}//dlcmdexpand1                                                 //~v04bI~
                                                                //~v04bI~
//**************************************************************** //~v57fM~
// dlcmdgetexpopt                                                  //~v57fM~
// get expand sort option                                          //~v57fM~
//*ret   :rc                                                       //~v57fM~
//**************************************************************** //~v57fM~
int dlcmdgetexpopt(char *Pparm,int *Ppsortopt)                     //~v57fM~
{                                                                  //~v57fM~
    char    *posparm,*pflagparm[1],*psortopt;                      //~v57jR~
    char   pot[MAXCOLUMN],*ppot,*pc;                               //~v57jR~
    int sortopt,opdno,reversesw=0;                                 //~v57fM~
    PUPODELMTBL pdelmt;                                            //~v57fM~
//****************************                                     //~v57fM~
	*Ppsortopt=UDHSONAME;                                          //~v57fM~
    if (!*Pparm)                                                   //~v57fM~
    	return 0;                                                  //~v57fM~
    ppot=pot;                                                      //~v57fM~
    if (uparsecmd(UPCMD_DROPQ,Pparm,&opdno,&ppot,0,&pdelmt))       //~v57fM~
        return 4;                                                  //~v57fM~
	if (uparsegetopt(UPGO_NOCASE|UPGO_ERRMSG|UPGO_FLAGUNIX|UPGO_FLAGDOS|UPGO_NOSPLIT,//~v57fM~
						pot,&opdno,"o",&posparm,pflagparm)) //drop /o option value//~v57fM~
    	return 4;                                                  //~v57fM~
    psortopt=pflagparm[0];                                         //~v57fM~
    if (!psortopt)	//no /o option                                 //~v57fM~
    {                                                              //~v57fM~
        if (pdelmt->upoquate=='\''                                 //~v57fM~
        ||  pdelmt->upoquate=='\"')                                //~v57fM~
    		strcpy(Pparm,ppot);	//drop quate                       //~v57fM~
    	return 0;                                                  //~v57fM~
    }                                                              //~v57fM~
    if (Sexpandallsw)                                              //~v57fM~
    {                                                              //~v57fM~
    	uerrmsg("sort option(%s) is supported only for \"-\" cmd", //~v57fM~
        		"\x83\\[gIvV(%s)\"-\"R}hŎgpł܂B",//~v57jR~
                psortopt);                                         //~v57fM~
        return 4;                                                  //~v57fM~
    }                                                              //~v57fM~
    sortopt=*psortopt;                                             //~v57fM~
    pc=psortopt;                                                   //~v57jR~
//  if (sortopt=='-')   //reverse                                  //~v59MR~
//  {                                                              //~v59MR~
//      reversesw=1;                                               //~v59MR~
//      sortopt=*(psortopt+1);                                     //~v59MR~
//      pc++;                                                      //~v59MR~
//  }                                                              //~v59MR~
    switch(toupper(sortopt))                                       //~v57fM~
    {                                                              //~v57fM~
    case 'N':                                                      //~v57fM~
    	sortopt=UDHSONAME;                                         //~v57fM~
    	break;                                                     //~v57fM~
    case 'T':                                                      //~v57fM~
    	sortopt=UDHSOTIME;                                         //~v57fM~
    	break;                                                     //~v57fM~
    case 'S':                                                      //~v57fM~
    	sortopt=UDHSOSIZE;                                         //~v57fM~
    	break;                                                     //~v57fM~
    default:                                                       //~v57fM~
        if (sortopt)                                               //~v57fM~
    	    uerrmsg("invalid sort option(%c)",                     //~v57fM~
	                "\x83\\[gIvVG[(%c)",              //~v57jR~
	                    sortopt);                                  //~v57fM~
        else                                                       //~v57fM~
    	    uerrmsg("invalid sort option(null)",                   //~v57fM~
	                "\x83\\[gIvVG[(null)",            //~v57jR~
	                    sortopt);                                  //~v57fM~
        return 4;                                                  //~v57fM~
    }                                                              //~v57fM~
    pc++;                                                          //~v57jR~
    if (*pc=='-')   	// "/os-" patern                           //~v57jR~
    	reversesw=1;                                               //~v57jR~
    if (reversesw)                                                 //~v57fM~
        if (sortopt)                                               //~v57fM~
        	sortopt=sortopt|UDHSOREVERSE;                          //~v57fM~
    *Ppsortopt=sortopt;                                            //~v57fM~
    strcpy(Pparm,posparm);                                         //~v57fM~
    return 0;                                                      //~v57fM~
}//dlcmdgetexpopt                                                  //~v57fM~
//****************************************************************//~5806I~
// dlcmdunexpand                                                //~5806I~
// unexpand(drop all child)                                     //~5813R~
//*ret   :rc                                                    //~5806I~
//****************************************************************//~5806I~
int dlcmdunexpand(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)//~5806I~
{                                                               //~5806I~
    PULINEH plh;                                                //~5806R~
    PUDIRLH pdh;                                                //~5806R~
//****************************                                  //~5806I~
    plh=Pplc->UDLCplh;                                          //~5806I~
    pdh=UGETPDH(plh);                                           //~5806I~
    switch(pdh->UDHtype)                                        //~5806I~
    {                                                           //~5806I~
    case UDHTDIREXP:                                            //~5812I~
    case UDHTPARENT:                                            //~5813I~
        break;                                                  //~5806I~
    case UDHTDIR:                                               //~v05LI~
        return 4;                                               //~v05LM~
    default:        //file/dir                                  //~5813R~
        return errnotdir();                                     //~v05LI~
    }                                                           //~5806I~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);    //full redraw           //~5807I~
    dirsavename(plh,"");    //clear rename fld                     //~v184I~
    UCBITOFF(pdh->UDHflag,UDHFDDSETUP); //re-setup                 //~v184I~
    filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr              //~5812I~
    if (pdh->UDHtype==UDHTPARENT)   //not path                  //~v05KR~
        UCBITON(plh->ULHflag,ULHFHLDIRTYPE);//highlight         //~v05KI~
    else                                                        //~v05KI~
        pdh->UDHtype=UDHTDIR;                                   //~v05KR~
    dlcmdlvlclear(Ppcw,pdh,1,0);    //force clear under the level//~v05oR~
    dirrenum(plh);  //lineno renumber after this line           //~v048R~
    return 0;                                                   //~5806I~
}//dlcmdunexpand                                                //~5806I~
                                                                //~5806I~
//****************************************************************//~5813I~
// dlcmdpath                                                    //~5813I~
// drop all brother                                             //~5813I~
//*ret   :rc                                                    //~5813I~
//****************************************************************//~5813I~
int dlcmdpath(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)   //~5813I~
{                                                               //~5813I~
    PULINEH plh;                                                //~5813I~
    PUFILEH pfh;                                                   //~v540I~
    PUDIRLH pdh;                                                //~5813I~
    int     len,len2;                                           //~5819I~
    UCHAR   dirname[_MAX_PATH];                                 //~5819I~
//  UCHAR   filemask[PANL310MASKLEN]; //getflddata                 //~v09hR~
//  UCHAR   filemask[PANL310MASKLEN+1]; //getflddata               //~v57fR~
    UCHAR   filemask[_MAX_PATH]; //getflddata                      //~v57fI~
//****************************                                  //~5813I~
    plh=Pplc->UDLCplh;                                          //~5813I~
    pfh=UGETPFH(plh);                                              //~v540I~
    pdh=UGETPDH(plh);                                           //~5813I~
    switch(pdh->UDHtype)                                        //~5813I~
    {                                                           //~5813I~
    case UDHTDIREXP:                                            //~5813I~
    case UDHTDIR:                                               //~5813I~
    case UDHTPARENT:                                            //~v05KI~
        if (!pdh->UDHlevel)//root                               //~5813I~
            return 4;                                           //~5813I~
//      if (UGETPDH(plhw)->UDHtype==UDHTPARENT)                 //~v05KR~
//      {                                                       //~v05KR~
//          uerrmsg("Already on the path",                      //~v05KR~
//                  "ɌoHɂ܂");                    //~v05KR~
//          return 4;                                           //~v05KR~
//      }//for the case intermediate path is expanded(-)        //~v05KR~
        break;                                                  //~5813I~
    default:        //file/path                                 //~5813I~
        return errnotdir();                                     //~v05LR~
    }                                                           //~5813I~
    if (dlcgetfullname(pdh,dirname))                            //~v05GR~
        return 4;                                               //~5819I~
    if ((len2=dirgetflddata(Ppcw,plh,PANL310RENAME,filemask))<0)  //ufhfilename//~5826R~
        return 4;   //internal logic err                        //~5819I~
    if (len2)   //mask input len                                //~5819I~
    {                                                           //~5819I~
        len=(int)strlen(dirname);                               //~5819I~
        if ((len+len2+1)>=_MAX_PATH)                            //~5819I~
            return errtoolong();                                //~5819I~
//      *(dirname+len++)='\\';                                     //~v19aR~
//      *(dirname+len++)=DIR_SEPC;                                 //~v540R~
        *(dirname+len++)=pfh->UFHdirsepc;                          //~v540I~
        strcpy(dirname+len,filemask);                           //~5819I~
    }                                                           //~5819I~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);    //full redraw           //~5813I~
    filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr              //~5813I~
    dlcchngfh(Ppcw,UGETPFH(plh),pdh,dirname);                   //~5819I~
    pdh->UDHtype=UDHTPARENT;    //set on also the line          //~v05KI~
    do                                                          //~5813I~
    {                                                           //~5813I~
        dlcmdlvlclear(Ppcw,pdh,0,0);    //clear brother only    //~v05oR~
        pdh=pdh->UDHdirptr;                                     //~5813I~
        pdh->UDHtype=UDHTPARENT;                                //~5813I~
        plh=UGETDIRPLH(pdh);        //re-draw dir id            //~5813I~
    } while(pdh->UDHlevel);                                     //~5813I~
    dirrenum(plh);  //lineno renumber from changed path         //~v048R~
    return 0;                                                   //~5813I~
}//dlcmdpath                                                    //~5813I~
                                                                //~5813I~
//****************************************************************//~5806I~
// dlcmdexclude                                                 //~5806I~
// process exclude dlcmd(un-display)                            //~5806I~
//*ret    :rc                                                   //~5806I~
//****************************************************************//~5806I~
int dlcmdexclude(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)//~5806I~
{                                                               //~5806I~
    PULINEH plh,plht,plh0;                                      //~5806I~
    PUDIRLH pdh;                                                //~5806I~
    PUFILEC pfc;                                                //~5806I~
    int level;                                                  //~5806R~
//****************************                                  //~5806I~
    pfc=Ppcw->UCWpfc;                                           //~5806I~
    plht=pfc->UFCcurtop;                                        //~5806I~
    plh0=Pplc->UDLCplh;                                         //~5806I~
    pdh=UGETPDH(plh0);                                          //~5806I~
    switch(pdh->UDHtype)                                        //~5806I~
    {                                                           //~5806I~
    case UDHTDIREXP:                                            //~5812I~
    case UDHTPARENT:                                            //~v05KI~
        if (UCBITCHK(pdh->UDHflag,UDHFEXCLUDED))                //~5806I~
            return 4;                                           //~5806I~
        break;                                                  //~5806I~
    case UDHTDIR:                                               //~v05LI~
        return 4;                                               //~v05LI~
    default:        //file/parent                               //~5806I~
        return errnotdir();                                     //~v05LI~
    }                                                           //~5806I~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);    //full redraw           //~5807I~
    UCBITON(pdh->UDHflag,UDHFEXCLUDED);                         //~5819R~
    UCBITON(plh0->ULHflag,ULHFHLDIRTYPE);//highlight            //~5819I~
    filesetcsr(Ppcw,plh0,PANL310LINENO,0);//set csr             //~5812R~
    level=pdh->UDHlevel;        //my dir level                  //~5807R~
    for (plh=plh0;plh=UGETQNEXT(plh),plh;)                      //~5807R~
    {                                                           //~5806I~
        if ((int)UGETPDH(plh)->UDHlevel<=level) //higher or same//~5815R~
            break;                                              //~5806I~
        UCBITON(plh->ULHflag2,ULHF2EXCLUDED);   //out of display//~5806R~
        if (plh==plht)                                          //~5806I~
            pfc->UFCcurtop=plh0;                                //~5806I~
    }                                                           //~5806I~
    return 0;                                                   //~5806I~
}//dlcmdexclude                                                 //~5806I~
                                                                //~5806I~
//****************************************************************//~5806I~
// dlcmdunexclude                                               //~5806I~
// process unexclude dlcmd(re-display)                          //~5806I~
//*ret    :rc                                                   //~5806I~
//****************************************************************//~5806I~
int dlcmdunexclude(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)//~5806I~
{                                                               //~5806I~
    PULINEH plh;                                                //~5806R~
    PUDIRLH pdh;                                                //~5806R~
//****************************                                  //~5806I~
    plh=Pplc->UDLCplh;                                          //~5806I~
    pdh=UGETPDH(plh);                                           //~5806I~
    switch(pdh->UDHtype)                                        //~5806I~
    {                                                           //~5806I~
    case UDHTDIREXP:                                            //~5812I~
    case UDHTDIR:                                               //~5806I~
    case UDHTPARENT:                                            //~v05KI~
        if (!UCBITCHK(pdh->UDHflag,UDHFEXCLUDED))               //~5806I~
            return 4;                                           //~5806I~
        break;                                                  //~5806I~
    default:        //file                                      //~v05LR~
        return errnotdir();                                     //~v05LI~
    }                                                           //~5806I~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);    //full redraw           //~5807I~
    UCBITOFF(pdh->UDHflag,UDHFEXCLUDED);                        //~5806I~
    UCBITOFF(plh->ULHflag,ULHFHLDIRTYPE);//highlight            //~5819I~
    filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr              //~5812I~
    dlcunexsub(pdh);    //recursive                             //~5806I~
    return 0;                                                   //~5806I~
}//dlcmdunexclude                                               //~v05LR~
//**************************************************************** //~v10rI~
// display filesiez or line count                                  //~v10rR~
//*parm1:pcw                                                       //~v10rI~
//*parm2:plh                                                       //~v10rI~
//*parm3:opt 1:linecount,0:size                                    //~v10rI~
//*ret   :rc                                                       //~v10rI~
//**************************************************************** //~v10rI~
int dlcmdsetszorlc(PUCLIENTWE Ppcw,PULINEH Pplh,int Popt)          //~v10rR~
{                                                                  //~v10rI~
    PULINEH plh;                                                   //~v10rR~
    PUDIRLH pdh,pdh0;                                              //~v10rR~
//#ifdef FTPSUPP                                                   //~v71tI~,//~v72aR~
//    PUFILEH pfh;                                                 //~v71jI~,//~v72aR~
//#endif                                                           //~v71tI~,//~v72aR~
    LONG    dirlc;                                                 //~v10rR~
    ULONG   dirsz;                                                 //~v10rI~
    int     levelc;                                                //~v10rI~
//****************************                                     //~v10rI~
    pdh0=pdh=UGETPDH(Pplh);                                        //~v10rR~
    plh=Pplh;                                                      //~v10rI~
//#ifdef FTPSUPP                                                   //+v71tM~,//~v72aR~
//    pfh=UGETPFH(Pplh);                                           //~v71jI~,//~v72aR~
//    if (FILEISTSO(pfh))                                          //~v71jI~,//~v72aR~
//        return 0;                                                //~v71jI~,//~v72aR~
//#endif                                                           //~v71jI~,//~v72aR~
    if (pdh->UDHtype==UDHTFILE)                                    //~v10rI~
    {                                                              //~v10rI~
        if (dlcmdsetszorlcsub(Ppcw,plh,Popt,0))                    //~v10rR~
            return 4;                                              //~v10rI~
        return 0;                                                  //~v10rI~
    }                                                              //~v10rI~
//dir                                                              //~v10rI~
    levelc=pdh->UDHlevel+1;     //child level                      //~v10rI~
    for (dirlc=0,dirsz=0;;)                                        //~v10rR~
    {                                                              //~v10rI~
        if (!(plh=UGETQNEXT(plh)))                                 //~v10rR~
            break;                                                 //~v10rI~
        pdh=UGETPDH(plh);                                          //~v10rI~
        if ((int)pdh->UDHlevel<levelc)  //same as parent           //~v10rR~
            break;                                                 //~v10rI~
        if ((int)pdh->UDHlevel>levelc)  //child of brother         //~v10rR~
            continue;                                              //~v10rI~
        if (UCBITCHK(pdh->UDHupdatetype,UDHUTNOTEXIST))            //~v10rI~
            continue;                                              //~v10rI~
        if (pdh->UDHtype==UDHTFILE)                                //~v10rI~
        {                                                          //~v10rI~
            if (dlcmdsetszorlcsub(Ppcw,plh,Popt,0))                //~v10rR~
                return 4;                                          //~v10rI~
            dirlc+=plh->ULHlinenow;                                //~v10rI~
            dirsz+=pdh->UDHsize;                                   //~v10rI~
            continue;                                              //~v10rI~
        }                                                          //~v10rI~
        if (dlcmdsetszorlc(Ppcw,plh,Popt))  //recursive            //~v10rR~
            return 4;                                              //~v10rI~
        dirlc+=plh->ULHlinenow;                                    //~v10rI~
        dirsz+=pdh->UDHsize;                                       //~v10rI~
    }                                                              //~v10rI~
    pdh0->UDHsize=dirsz;        //dir total of displayed line      //~v10rR~
    if (dlcmdsetszorlcsub(Ppcw,Pplh,Popt,dirlc))                   //~v10rR~
        return 4;                                                  //~v10rI~
    return 0;                                                      //~v10rI~
}//dlcmdsetszorlc                                                  //~v10rR~
//**************************************************************** //~v10rI~
// toggle file size display option                                 //~v10rI~
//*parm1:pcw                                                       //~v10rI~
//*parm2:plh                                                       //~v10rI~
//*parm3:opt 1:linecount,0:size                                    //~v10rI~
//*parm4:input dir level total lineno                              //~v10rI~
//*ret   :rc                                                       //~v10rI~
//**************************************************************** //~v10rI~
int dlcmdsetszorlcsub(PUCLIENTWE Ppcw,PULINEH Pplh,int Popt,LONG Pdirlineno)//~v10rR~
{                                                                  //~v10rI~
    PUDIRLH pdh;                                                   //~v10rI~
    UCHAR   fpathnm[_MAX_PATH];                                    //~v10rI~
    int prevst,getlcsw;                                            //~v10rI~
//****************************                                     //~v10rI~
    if (UCBITCHK(Pplh->ULHflag2,ULHF2EXCLUDED))                    //~v10rR~
        return 0;                                                  //~v10rI~
    pdh=UGETPDH(Pplh);                                             //~v10rI~
    prevst=UCBITCHK(pdh->UDHflag2,UDHF2DISPLC);                    //~v10rI~
    getlcsw=0;                                                     //~v10rI~
    if (Popt)   //disp by lc                                       //~v10rI~
    {                                                              //~v10rI~
        if (!prevst)    //curr size mode                           //~v10rI~
        {                                                          //~v10rI~
            UCBITOFF(pdh->UDHflag,UDHFDDSETUP); //rewrite          //~v10rI~
            UCBITON(pdh->UDHflag2,UDHF2DISPLC);                    //~v10rI~
            UCBITON(Pplh->ULHflag,ULHFDRAW); //redraw              //~v10rI~
        }                                                          //~v10rI~
        if (pdh->UDHtype!=UDHTFILE ||                              //~v10rI~
            !UCBITCHK(pdh->UDHflag2,UDHF2LCGOTTEN)) //not yet lc gotten or update required//~v10rI~
        {                                                          //~v10rI~
            getlcsw=1;                                             //~v10rI~
            UCBITOFF(pdh->UDHflag,UDHFDDSETUP); //rewrite          //~v10rI~
            UCBITON(Pplh->ULHflag,ULHFDRAW); //redraw              //~v10rI~
        }                                                          //~v10rI~
                                                                   //~v10rI~
    }                                                              //~v10rI~
    else    //disp by size                                         //~v10rI~
    {                                                              //~v10rI~
        if (prevst) //curr lc mode                                 //~v10rI~
        {                                                          //~v10rI~
            UCBITOFF(pdh->UDHflag,UDHFDDSETUP); //rewrite          //~v10rI~
            UCBITOFF(pdh->UDHflag2,UDHF2DISPLC);                   //~v10rI~
            UCBITON(Pplh->ULHflag,ULHFDRAW); //redraw              //~v10rI~
        }                                                          //~v10rI~
    }//by size                                                     //~v10rI~
    if (!getlcsw)                                                  //~v10rI~
        return 0;                                                  //~v10rI~
//line ctr update                                                  //~v10rI~
    if (pdh->UDHtype!=UDHTFILE)                                    //~v10rI~
        Pplh->ULHlinenow=Pdirlineno;                               //~v10rR~
    else                                                           //~v10rI~
    {                                                              //~v10rI~
#ifdef FTPSUPP                                                     //~v72aI~
	  if (pdh->UDHattr & FILE_TSO)	//tso file                     //~v72aI~
      {                                                            //~v72aI~
//      if (pdh->UDHattr & FILE_SPF)	//spf info exist           //~v72rR~
//      	Pplh->ULHlinenow=pdh->UDHslinksize;                    //~v72rR~
//      else                                                       //~v72rR~
//      if (!(pdh->UDHattr & FILE_SPF))	//spf info exist           //+v72rR~
//      {                                                          //+v72rR~
//      	Pplh->ULHlinenow=0;                                    //~v72rR~
//      	uerrmsg("No SPF information exist",0);                 //+v72rR~
//      }                                                          //+v72rR~
        return 0;	//no set LCGOTTEN                              //~v72rI~
      }                                                            //~v72aI~
      else                                                         //~v72aI~
      {                                                            //~v72aI~
#endif                                                             //~v72aI~
        if (dlcgetfullname(pdh,fpathnm))                           //~v10rR~
            return 4;                                              //~v10rR~
        if (subgetfilelc(GETLC_FPATHINP,fpathnm,(ULONG*)(void*)(&Pplh->ULHlinenow)))//~v10rR~
            return 4;                                              //~v10rR~
#ifdef FTPSUPP                                                     //~v72aI~
      }                                                            //~v72aI~
#endif                                                             //~v72aI~
    }                                                              //~v10rI~
    UCBITON(pdh->UDHflag2,UDHF2LCGOTTEN);                          //~v10rI~
    return 0;                                                      //~v10rI~
}//dlcmdsetszorlcsub                                               //~v10rR~
//**************************************************************** //~v10rI~
// update size on parent                                           //~v10rI~
//*parm1:pdh of dir/file                                           //~v10rR~
//*parm2:update opt;2:lc,1:size,3:both                             //~v10rR~
//*parm3:size to be added                                          //~v10rR~
//*parm4:linecnt to be added                                       //~v10rR~
//*rc   :1:updated,0:no parent updated                             //~v10rI~
//**************************************************************** //~v10rI~
int dlcmdresetparentsz(PUDIRLH Ppdh,int Popt,ULONG Paddsz,LONG Paddlc)//~v10rR~
{                                                                  //~v10rI~
    PULINEH plh;                                                   //~v10rR~
    PUFILEH pfh;                                                   //~v10rI~
    PUDIRLH pdh;                                                   //~v10rI~
    LONG    addlc;                                                 //~v10rI~
    int rc,chngsw;                                                 //~v10rR~
    UCHAR   fhlvl;                                                 //~v10rI~
//****************************                                     //~v10rI~
    plh=UGETDIRPLH(Ppdh);    //cur level                           //~v10rI~
    pfh=UGETPFH(plh);                                              //~v10rI~
//#ifdef FTPSUPP                                                     //~v71jR~,//~v72rR~
//    if (FILEISTSO(pfh))                                            //~v71jI~,//~v72rR~
//        return 0;                                                  //~v71jI~,//~v72rR~
//#endif                                                             //~v71jI~,//~v72rR~
    fhlvl=pfh->UFHlevel;                                           //~v10rI~
    if (UCBITCHK(Ppdh->UDHflag2,UDHF2LCGOTTEN))                    //~v10rI~
        addlc=Paddlc;                                              //~v10rI~
    else                                                           //~v10rI~
        addlc=0;                                                   //~v10rI~
    rc=0;                                                          //~v10rI~
    for (pdh=Ppdh;;)                                               //~v10rI~
    {                                                              //~v10rI~
        if (!(pdh=pdh->UDHdirptr))  //parent                       //~v10rI~
            break;                                                 //~v10rI~
        if (pdh->UDHlevel<fhlvl)    //parent of cur file dir       //~v10rI~
            break;                                                 //~v10rI~
        plh=UGETDIRPLH(pdh);    //cur level                        //~v10rR~
        chngsw=0;                                                  //~v10rI~
        if (Popt & DLCPSZ_SZ)                                      //~v10rI~
        {                                                          //~v10rI~
            pdh->UDHsize+=Paddsz;                                  //~v10rI~
            chngsw=1;                                              //~v10rI~
        }                                                          //~v10rI~
        if (Popt & DLCPSZ_LC)                                      //~v10rI~
            if (UCBITCHK(pdh->UDHflag2,UDHF2LCGOTTEN))             //~v10rR~
            {                                                      //~v10rI~
                plh->ULHlinenow+=addlc;                            //~v10rR~
                chngsw=1;                                          //~v10rI~
            }                                                      //~v10rI~
        if (chngsw)                                                //~v10rI~
        {                                                          //~v10rI~
            rc=1;                                                  //~v10rI~
            UCBITOFF(pdh->UDHflag,UDHFDDSETUP); //request line make//~v10rR~
            UCBITON(plh->ULHflag,ULHFDRAW);                        //~v10rR~
        }                                                          //~v10rI~
    }                                                              //~v10rI~
    return rc;                                                     //~v10rI~
}//dlcmdresetparentsz                                              //~v10rI~
//****************************************************************//~5806I~
// dlcmdlvlclear                                                //~v05oR~
// clear entry on the dir level                                 //~5806I~
//*parm1:pcw                                                    //~5806I~
//*parm2:pdh of dir                                             //~5806I~
//*parm3:option 1:clear the all child                           //~5819R~
//*             2:clear the all child and itself                //~v05oR~
//*             0:all brother                                   //~5819R~
//*parm4:action 0:del entry                                     //~v05oI~
//*             1:flag deleted                                  //~v05oI~
//*             2:drop view                                     //~v05qI~
//*             3:flag moved                                    //~v05qI~
//*rc   :none                                                   //~5806I~
//****************************************************************//~5806I~
void dlcmdlvlclear(PUCLIENTWE Ppcw,PUDIRLH Ppdh,int Popt,int Paction)//~v05oR~
{                                                               //~5806I~
    PULINEH plh,plh0;                                           //~5813R~
    PULINEH plhn;                                                  //~v085I~
    PUDIRLH pdh,pdh0;                                           //~v05oR~
    int level,childsw;                                          //~5813R~
//****************************                                  //~5806I~
    if (!Popt)                                                  //~5819R~
    {                                                           //~5813I~
        childsw=0;              //direct child id               //~5813I~
        pdh=Ppdh->UDHdirptr;    //parent                        //~5813I~
    }                                                           //~5813I~
    else                                                        //~5813I~
        pdh=Ppdh;                                               //~5813I~
    level=pdh->UDHlevel+1;      //clear 1 level under the line of dir//~5813R~
    pdh0=pdh;                   //start pdh                     //~v05oI~
    plh0=UGETDIRPLH(pdh);       //start plh                     //~5813R~
//  for (plh=plh0;plh=UGETQNEXT(plh),plh;)                         //~v085R~
//  for (plh=UGETQNEXT(plh0);plh;)                                 //~v091R~
    for (plhn=UGETQNEXT(plh0);plh=plhn,plh;)                       //~v091R~
    {                                                           //~5806I~
        plhn=UGETQNEXT(plh);    //over plh ufree                   //~v085I~
        pdh=UGETPDH(plh);                                       //~5806I~
        if ((int)pdh->UDHlevel<level)   //higher                //~5815R~
            break;                  //loop out                  //~5813R~
        if ((int)pdh->UDHlevel>level)   //lower(child)          //~5815R~
        {                                                       //~5819I~
            if (!Popt && childsw)   //req brother clear and my child//~5819R~
                    continue;       //dont del                  //~5813I~
        }                                                       //~5819I~
        else                        //same level                //~5813I~
        {                                                       //~5819I~
            if (!Popt)              //req brother               //~5819R~
            {                                                   //~5813I~
                if (pdh==Ppdh)      //myself                    //~5813I~
                {                                               //~5813I~
                    childsw=1;      //dont del my child         //~5813I~
                    continue;       //dont del myself           //~5813I~
                }                                               //~5813I~
                childsw=0;          //del child                 //~5815I~
            }                                                   //~5819I~
        }                                                       //~5819I~
        switch(Paction)                                         //~v05oR~
        {                                                       //~v05oI~
        case 0:                                                 //~v05oI~
            dlcdelentry(plh,plh0);                                 //~v09AR~
            break;                                              //~v05oI~
        case 1:                                                 //~v05oI~
            dlcmddelflag(Ppcw,plh,pdh); //set del flag          //~v05oM~
            break;                                              //~v05oI~
        case 2:                                                 //~v05oI~
            dlcmddelview(Ppcw,pdh); //drop view                 //~v05oI~
            break;                                              //~v05oI~
        case 3:                                                 //~v05qM~
            dlcmdmoveflag(Ppcw,plh,pdh,UDHUTMOVEOCHILD);    //moved child flag on//~v05LR~
            break;                                              //~v05qI~
        }                                                       //~v05oI~
//      plh=plhn;   //next line                                    //~v091R~
    }                                                           //~5806I~
    if (Popt==2)    //del dir                                   //~5819I~
        switch(Paction)                                         //~v05oI~
        {                                                       //~v05oI~
        case 0:                                                 //~v05oI~
            dlcdelentry(plh0,UGETQPREV(plh0));                     //~v09AR~
            break;                                              //~v05oI~
        case 1:                                                 //~v05oI~
            dlcmddelflag(Ppcw,plh0,pdh0);   //set del flag      //~v05oM~
            break;                                              //~v05oI~
        case 2:                                                 //~v05oI~
            dlcmddelview(Ppcw,pdh0);    //drop view             //~v05oI~
            break;                                              //~v05oI~
        case 3:                                                 //~v05qM~
            dlcmdmoveflag(Ppcw,plh0,pdh0,0);//not move child    //~v05LR~
            break;                                              //~v05qI~
        }                                                       //~v05oI~
    return;                                                     //~5806I~
}//dlcmdlvlclear                                                //~v05oR~
                                                                //~5819I~
//*************************************************************    //~v55UI~
//*for lineselect by mouse                                         //~v55UI~
//*parm2:optional fpath output                                     //~v568I~
//*parm3:optional pdh output                                       //~v568I~
//*************************************************************    //~v55UI~
//int dlcgetdirlistfname(PUCLIENTWE Ppcw,char *Pfpath)             //~v568R~
int dlcgetdirlistfname(PUCLIENTWE Ppcw,char *Pfpath,PUDIRLH *Pppdh)//~v568R~
{                                                                  //~v55UI~
    PUSCRD  psd;                                                   //~v55UI~
    PULINEH    plh;                                                //~v55UI~
    PUDIRLH    pdh;                                                //~v568I~
//***********************                                          //~v55UI~
    if (Ppcw->UCWtype!=UCWTDIR)                                    //~v55UI~
        return 4;                                                  //~v55UI~
    if (!CSRONFILELINE(Ppcw))                                      //~v55UI~
        return 4;                                                  //~v55UI~
    psd=Ppcw->UCWpsd;                                              //~v55UI~
    psd+=Ppcw->UCWrcsry;                                           //~v55UI~
    plh=psd->USDbuffc;                                             //~v55UI~
    if (!plh)                                                      //~v55UI~
        return 4;                                                  //~v55UI~
    if (plh->ULHtype==ULHTHDR)                                     //~v55UI~
        return 4;                                                  //~v55UI~
    pdh=UGETPDH(plh);                                              //~v568I~
    if (Pppdh)                                                     //~v568I~
        *Pppdh=pdh;                                                //~v568I~
    if (Pfpath)                                                    //~v55UI~
    {                                                              //~v568I~
//      if (dlcgetfullname(UGETPDH(plh),Pfpath))                   //~v568R~
        if (dlcgetfullname(pdh,Pfpath))                            //~v568R~
            return 4;                                              //~v55UI~
    }                                                              //~v568I~
    return 0;                                                      //~v55UI~
}//dlcgetdirlistfname                                              //~v55UI~
//****************************************************************//~5813M~
// dlcgetfullname                                               //~5813M~
// get fullpath filename of dir member                          //~5813M~
//*parm1 :pdh                                                   //~v05GR~
//*parm2 :output file name                                      //~5813M~
//*ret   :rc                                                    //~5813M~
//****************************************************************//~5813M~
int dlcgetfullname(PUDIRLH Ppdh,UCHAR *Pfname)                  //~v05GR~
{                                                               //~5813M~
    PUDIRLH pdh;                                                //~5813M~
    UCHAR *pc;                                                  //~5813M~
    UCHAR *name;                                                   //~v0g1I~
    UINT   ulen,utlen,utleno,delmlen;                           //~5813M~
    PUFILEH pfh;                                                   //~v53ZI~
    PULINEH plh;                                                   //~v53ZI~
//*******************                                           //~5813M~
    plh=UGETDIRPLH(Ppdh);                                          //~v53ZI~
    pfh=UGETPFH(plh);                                              //~v53ZI~
#ifdef FTPSUPP                                                     //~v717M~
    if (FILEISTSO(pfh))                                            //~v717M~
    	return xetsodlcgetfullname(pfh,Ppdh,Pfname);               //~v717M~
#endif                                                             //~v717M~
    *(pc=Pfname)=0;                                             //~5813M~
    utlen=1;                                                    //~5813M~
    for (pdh=Ppdh;pdh;pdh=pdh->UDHdirptr)   //hierarchy         //~v05GR~
    {                                                           //~5813M~
        delmlen=(UINT)(pdh->UDHlevel && utlen!=1);              //~5813M~
        utleno=utlen;                   //save old len          //~5813M~
//      ulen=strlen(pdh->UDHname);                                 //~v0g1R~
#if defined(W32) || defined(DPMI)                                  //~v0g1I~
#ifdef W32                                                         //~v53ZI~
      if (FILEISREMOTE(pfh))                                       //~v53ZR~
        name=pdh->UDHname;      //use long filename                //~v53ZI~
      else                                                         //~v53ZI~
#endif                                                             //~v53ZI~
        if (Saliassw)                                              //~v0g1I~
            name=pdh->UDHalias;                                    //~v0g1R~
        else                                                       //~v0g1I~
#endif                                                             //~v0g1I~
            name=pdh->UDHname;                                     //~v0g1R~
        ulen=strlen(name);                                         //~v0g1I~
        if (utlen+=ulen+delmlen,utlen>=_MAX_PATH)               //~5813M~
            return errtoolong();                                //~5813M~
        memmove(pc+ulen+delmlen,pc,utleno);                     //~5813M~
//      memcpy(pc,pdh->UDHname,ulen);   //insert parent dir name   //~v0g1R~
        memcpy(pc,name,ulen);   //insert parent dir name           //~v0g1I~
        if (!pdh->UDHlevel) //root                              //~5813M~
            break;                                              //~5813M~
        if (utleno!=1)  //not first time                        //~5813M~
//          *(pc+ulen)='\\';                                       //~v19aR~
//          *(pc+ulen)=DIR_SEPC;                                   //~v540R~
            *(pc+ulen)=pfh->UFHdirsepc;                            //~v540I~
    }                                                           //~5813M~
    return 0;                                                   //~5813M~
}//dlcgetfullname                                               //~5813M~
//**************************************************************** //~v59cI~
// dlcgetfullnameenclose                                           //~v59cI~
// get fullpath filename of dir member and enclose by dquote if space containing//~v59cI~
//*parm1 :pdh                                                      //~v59cI~
//*parm2 :output file name                                         //~v59cI~
//*ret   :rc                                                       //~v59cI~
//**************************************************************** //~v59cI~
int dlcgetfullnameenclose(PUDIRLH Ppdh,UCHAR *Pfname)              //~v59cI~
{                                                                  //~v59cI~
	char fnmwk[_MAX_PATH+2];                                       //~v59cI~
    int rc,len;                                                    //~v59cI~
//*******************                                              //~v59cI~
	rc=dlcgetfullname(Ppdh,Pfname);                                //~v59cI~
    if (rc)                                                        //~v59cI~
    	return rc;                                                 //~v59cI~
    if (!strchr(Pfname,' '))                                       //~v59cI~
    	return 0;                                                  //~v59cI~
    len=(int)strlen(Pfname);                                       //~v59NR~
    *fnmwk='"';                                                    //~v59cI~
    memcpy(fnmwk+1,Pfname,(UINT)len);                              //~v59cI~
    *(fnmwk+1+len)='"';                                            //~v59cI~
    memcpy(Pfname,fnmwk,(UINT)(len+2));                            //~v59cI~
    *(Pfname+len+2)=0;                                             //~v59cI~
    return 0;                                                      //~v59cI~
}//dlcgetfullname                                                  //~v59cI~
                                                                //~5813M~
#if defined(W32) || defined(DPMI)                                  //~v0g1I~
//**************************************************************** //~v0g1I~
// dlcgetfullnamealias                                             //~v0g1I~
// get fullpath filename of dir member by alias                    //~v0g1I~
//*parm1 :pdh                                                      //~v0g1I~
//*parm2 :output file name                                         //~v0g1I~
//*ret   :rc                                                       //~v0g1I~
//**************************************************************** //~v0g1I~
int dlcgetfullnamealias(PUDIRLH Ppdh,UCHAR *Pfname)                //~v0g1I~
{                                                                  //~v0g1I~
    int rc;                                                        //~v0g1I~
//*******************                                              //~v0g1I~
    Saliassw=1;                                                    //~v0g1I~
    rc=dlcgetfullname(Ppdh,Pfname);                                //~v0g1I~
    Saliassw=0;                                                    //~v0g1I~
    return rc;                                                     //~v0g1I~
}//dlcgetfullnamealias                                             //~v0g1I~
#endif                                                             //~v0g1I~
