//*CID://+v71NR~:                             update#=  169;       //~v71NR~
//*************************************************************
//*xedlcmd6.c                                                      //~v51WR~
//* %:apply command                                                //~v51WR~
//* !:openwdith cmd                                                //~v56eI~
//* #:submit/rsh                                                   //~v59eI~
//*************************************************************
//v71N:061107 (3270)support "#"/% dlcmd for TSO file               //~v71NI~
//v71r:061022 association not supported for remote file;chk also for WXE/XXE mouse operation//~v71rI~
//v662:050863 &(spawn) linecmd support(async version of #)         //~v662I~
//v64v:050708 (LNX)openwith support                                //~v64vI~
//v63b:050429 change dlcmd "%" temp file(cfso/cf) to use pid for contension inter user//~v63bI~
//v59e:041107 add "#" lcmd:submit for localfile/rsh for remotefile //~v59eI~
//v59c:041107 % lcmd:remote support(use rsh)                       //~v59cI~
//v58K:041011 (BUG)"%" cmd parse delm tbl to call func_submit()    //~v58KI~
//v58h:040905 (BUG)rename fld by %cmd prevent long filename display//~v58hI~
//v588:040823 % dlcmd:enclose filename if blank embedding when no % used as parm//~v588I~
//v583:040822 keep csr on the line for dlcmd ! and %               //~v583I~
//v57F:040612 (BUG)don't enclose filename  by quote because cmd fail when % is concatinated like as "%\*"//~v57FI~
//v56e:040404 xp open dir by explorler,so allow dir for openwith   //~v56eI~
//v55V:040321 (WIN)filename list ! lcmd(openwith) support          //~v55VI~
//v55v:040229 (W32)v55u for W32 console xe(dlcmd "!":openwith)     //~v55vI~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifdef DOS
#else
//  #define INCL_BASE                                              //~v07sR~
//  #include <os2.h>                                               //~v07sR~
#endif
#ifdef W32                                                         //~v56eI~
	#include <io.h>                                                //~v56eI~
#endif                                                             //~v56eI~
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <ualloc.h>
#include <uque.h>
#include <ustring.h>
#include <ufile.h>
#include <ufile2.h>                                                //~v71NI~
#include <ufile3.h>                                                //~v71NI~
#include <uparse.h>                                                //~v10pI~
#include <ufemsg.h>                                                //~v51WI~
#include <udos.h>                                                  //~v51WI~
#include <uftp.h>                                                  //~v59cI~
#ifdef UNX                                                         //~v51WI~
	#include <ufile2l.h>                                           //~v51WI~
#endif                                                             //~v51WI~
#include <uproc.h>                                                 //~v64vI~
#ifdef W32                                                         //~v55vI~
	#include <uwinsub.h>                                           //~v56eI~
#endif                                                             //~v55vI~

#include "xe.h"
#include "xescr.h"                                                 //~v51WI~
#include "xefile.h"
#include "xefile2.h"                                               //~v583I~
#include "xepan.h"
#include "xepan22.h"                                               //~v55VM~
#include "xedir.h"
#include "xedir2.h"                                                //~v51WI~
#include "xedlcmd.h"                                            //~v05oM~
#include "xedlcmd2.h"                                              //~v51WI~
#include "xedlcmd3.h"                                              //~v71NI~
#include "xedlcmd6.h"                                              //~v51WR~
#include "xefunc.h"                                                //~v51WI~
#include "xesub.h"                                                 //~v51WI~
#include "xeerr.h"                                                 //~v51WI~
#include "xedcmd2.h"                                               //~v662I~
#include "xedcmd3.h"                                               //~v59cI~
#include "xedcmd4.h"                                               //~v63bI~
#include "xeftp.h"                                                 //~v71NI~
//*******************************************************
#define CMDFNM	"cf"                                               //~v51WR~
#define SOFNM	"cfso"                                             //~v51WR~
//*******************************************************          //~v51WI~
//#ifdef UNX                                                       //~v63bR~
//        static UCHAR Scmdfnm[]=WORKDIRPATHID CMDFNM;             //~v63bR~
//#else                                                            //~v63bR~
//    #ifdef OS2                                                   //~v63bR~
//        static UCHAR Scmdfnm[]=WORKDIRPATHID CMDFNM ".cmd";      //~v63bR~
//    #else                                                        //~v63bR~
//        static UCHAR Scmdfnm[]=WORKDIRPATHID CMDFNM ".bat";      //~v63bR~
//    #endif                                                       //~v63bR~
//#endif                                                           //~v63bR~
    static UCHAR Scmdfnm[]=DCMDSUBMITCMDFNM;                       //~v63bI~
//do not set inter-space after ">" befause parse required          //~v51WR~
//static UCHAR Sredirectparm[]=">" WORKDIRPATHID SOFNM;            //~v63bR~
static UCHAR Sredirectparm[]=">" DCMDDLCMDCFSO;                    //~v63bR~
static UCHAR Scmdfullpath[_MAX_PATH]="";                           //~v55VR~
#ifdef FTPSUPP                                                     //~v71NI~
	static UCHAR Sappcmdtmpdir[_MAX_PATH]="";                      //~v71NR~
	static PUDLCMD Splcac1;                                        //~v71NI~
#endif                                                             //~v71NI~
static PUDLCMD Splcac;                                             //~v51WI~
//*******************************************************       //~v04bI~
int dlcmdappcmdedit(char *Ppatern,char *Pfnm,char *Poutstr);       //~v51WI~
int dlcmdgetcmdstr(PUCLIENTWE Ppcw,PUDLCMD Pplc,char *Pcmdstr);    //~v51WI~
int dlcmdsubrshcmdedit(char *Pfnm,char *Pparm,char *Poutstr);      //~v59eR~
#ifdef FTPSUPP                                                     //+v71NI~
int dlcmdgetcmdstrtso(PUCLIENTWE Ppcw,PUFILEH Ppfh,PUDLCMD Pplc,char *Pcmdstr);//~v71NI~
int dlcmdaclisttso(PUCLIENTWE Ppcw,PUFILEH Ppfh,PUDLCMD Pplc,int Precno);//~v71NI~
#endif                                                             //+v71NI~
//**************************************************************** //~v51WI~
//!dlcmdaclist                                                     //~v51WI~
// setup xprint indirect file list                                 //~v51WI~
//*parm1:pcw                                                       //~v51WI~
//*parm2:plc                                                       //~v51WI~
//*parm3:record seq no(1 start,0 for eof)                          //~v51WI~
//*ret  :0:ok,4 io err                                             //~v51WI~
//**************************************************************** //~v51WI~
int dlcmdaclist(PUCLIENTWE Ppcw,PUDLCMD Pplc,int Precno)           //~v51WI~
{                                                                  //~v51WI~
    UCHAR  cmdstr[_MAX_PATH+MAXCOLUMN];                            //~v51WI~
#ifdef W32                                                         //~v51WI~
    UCHAR  *pc;                                                    //~v51WI~
#endif                                                             //~v51WI~
    int rc;                                                        //~v51WI~
	static FILE *Sfh=0;                                            //~v51WR~
#ifdef FTPSUPP                                                     //~v71NI~
    PUFILEH pfh;                                                   //~v71NI~
#endif                                                             //~v71NI~
//*******************                                              //~v51WI~
#ifdef FTPSUPP                                                     //~v71NI~
	pfh=UGETPFHFROMPCW(Ppcw);                                      //~v71NI~
    if (FILEISTSO(pfh))                                            //~v71NI~
		return dlcmdaclisttso(Ppcw,pfh,Pplc,Precno);               //~v71NI~
#endif                                                             //~v71NI~
	if (!*Scmdfullpath)                                            //~v51WR~
    {                                                              //~v51WI~
#ifdef W32                                                         //~v51WI~
      	if (udosiswinnt())                                         //~v51WI~
        {	                                                       //~v51WI~
        	if (pc=strchr(Scmdfnm,'.'),pc)                         //~v51WI~
	        	strcpy(pc+1,"cmd");                                //~v51WI~
        }                                                          //~v51WI~
#endif                                                             //~v51WI~
		if (!filefullpath(Scmdfullpath,Scmdfnm,_MAX_PATH))         //~v51WI~
        	return 4;   //full path err                            //~v51WI~
    }                                                              //~v51WI~
	if (!Precno)	//last call                                    //~v51WI~
    {                                                              //~v51WI~
    	if (Sfh)                                                   //~v51WI~
        {                                                          //~v51WI~
		    fileclose(Scmdfullpath,Sfh);                           //~v51WI~
#ifdef UNX                                                         //~v51WI~
	        if (uattrxon(Scmdfullpath))    //user x bit on         //~v51WI~
    	        return 4;                                          //~v51WI~
#endif //UNX                                                       //~v51WI~
        }                                                          //~v51WI~
		Sfh=0;                                                     //~v51WI~
        Splcac=Pplc;	//xprint kick(last '%' lcmd plc)           //~v51WR~
        return 0;                                                  //~v51WI~
	}                                                              //~v51WI~
	if (Precno==1)	//first call                                   //~v51WI~
    {                                                              //~v63bI~
    	if (!(Sfh=fileopen(Scmdfullpath,"w")))                     //~v51WI~
        	return 4;   //open err                                 //~v51WI~
    	Gdcmdtempf|=GDCMDTEMPF_SUB; //del at term                  //~v63bI~
    }                                                              //~v63bI~
	if (dlcmdgetcmdstr(Ppcw,Pplc,cmdstr))                          //~v51WR~
    	return 4;                                                  //~v51WI~
	strcat(cmdstr,"\n");                                           //~v51WI~
  	rc=fputs(cmdstr,Sfh);                                          //~v51WI~
#ifdef DOS                                                         //~v51WI~
    #ifdef DPMI					//DPMI version                     //~v51WI~
    if (rc==-1)                                                    //~v51WI~
    #else                       //not DPMI                         //~v51WI~
    if (rc)                                                        //~v51WI~
    #endif                      //DPMI or not                      //~v51WI~
#else                                                              //~v51WI~
    if (rc==-1)                                                    //~v51WI~
#endif                                                             //~v51WI~
    {                                                              //~v51WI~
    	ufileapierr("fputs",Scmdfullpath,rc);                      //~v51WR~
        return 4;                                                  //~v51WI~
	}                                                              //~v51WI~
    return 0;                                                      //~v51WI~
}//dlcmdaclist                                                     //~v51WI~
#ifdef FTPSUPP                                                     //+v71NI~
//**************************************************************** //~v71NI~
//!dlcmdaclisttso                                                  //~v71NI~
// setup %/# cmd indirect file list for remote is TSO case         //~v71NI~
//*parm1:pcw                                                       //~v71NI~
//*parm2:plc                                                       //~v71NI~
//*parm3:record seq no(1 start,0 for eof)                          //~v71NI~
//*ret  :0:ok,4 io err                                             //~v71NI~
//**************************************************************** //~v71NI~
int dlcmdaclisttso(PUCLIENTWE Ppcw,PUFILEH Ppfh,PUDLCMD Pplc,int Precno)//~v71NI~
{                                                                  //~v71NI~
    UCHAR  cmdstr[_MAX_PATH+MAXCOLUMN];                            //~v71NI~
    UCHAR  fullpathname[_MAX_PATH];                                //~v71NI~
    int rc;                                                        //~v71NI~
	static FILE *Sfh=0;                                            //~v71NI~
    PULINEH plh;                                                   //~v71NI~
    PUDIRLH pdh;                                                   //~v71NI~
//*******************                                              //~v71NI~
	if (!Precno)	//last call                                    //~v71NI~
    {                                                              //~v71NI~
    	if (Sfh)                                                   //~v71NI~
		    fileclose(Scmdfullpath,Sfh);                           //~v71NI~
		Sfh=0;                                                     //~v71NI~
        Splcac=Pplc;	//xprint kick(last '%' lcmd plc)           //~v71NI~
        return 0;                                                  //~v71NI~
	}                                                              //~v71NI~
	if (Precno==1)	//first call                                   //~v71NI~
    {                                                              //~v71NI~
    	if (Pplc->UDLCcmd==DLCMD_APPCMD)                           //~v71NI~
        {                                                          //~v71NI~
        	if (!*Sappcmdtmpdir)                                   //~v71NR~
	  			if (rc=dlcxpgettmpdir(Sappcmdtmpdir),rc)           //~v71NR~
  					return rc;                                     //~v71NI~
			if (!filefullpath(Scmdfullpath,Scmdfnm,_MAX_PATH))     //~v71NR~
        		return 4;   //full path err                        //~v71NI~
	    	if (!(Sfh=fileopen(Scmdfullpath,"w")))                 //~v71NR~
    	    	return 4;   //open err                             //~v71NI~
    		Gdcmdtempf|=GDCMDTEMPF_SUB; //del at term              //~v71NI~
        }                                                          //~v71NI~
    	if (Pplc->UDLCcmd==DLCMD_SUBRSH)                           //~v71NI~
        {                                                          //~v71NI~
    		plh=Pplc->UDLCplh;                                     //~v71NI~
    		pdh=UGETPDH(plh);                                      //~v71NI~
    		dlcgetfullname(pdh,fullpathname);                      //~v71NI~
			xeftpgetwdfname(Ppfh->UFHpuftph,fullpathname,Scmdfullpath);//~v71NR~
            uremovenomsg(Scmdfullpath);                            //~v71NR~
        }                                                          //~v71NI~
        Splcac1=Pplc;	//1st to chk same cmd                      //~v71NR~
    }                                                              //~v71NI~
    else	//not 1st                                              //~v71NI~
    if (Pplc->UDLCcmd!=Splcac1->UDLCcmd)                           //~v71NR~
    {                                                              //~v71NM~
    	uerrmsg("mixed command is not supported for TSO file(%c and %c)",0,//~v71NR~
    			Pplc->UDLCcmd,Splcac1->UDLCcmd);                   //~v71NR~
        return 4;                                                  //~v71NM~
    }                                                              //~v71NM~
	if (dlcmdgetcmdstrtso(Ppcw,Ppfh,Pplc,cmdstr))                  //~v71NR~
    	return 4;                                                  //~v71NI~
    if (Pplc->UDLCcmd==DLCMD_APPCMD)                               //~v71NI~
    {                                                              //~v71NI~
        strcat(cmdstr,"\n");                                       //~v71NI~
        rc=fputs(cmdstr,Sfh);                                      //~v71NI~
        if (rc==-1)                                                //~v71NI~
        {                                                          //~v71NI~
            ufileapierr("fputs",Scmdfullpath,rc);                  //~v71NR~
            return 4;                                              //~v71NI~
        }                                                          //~v71NI~
    }                                                              //~v71NI~
    return 0;                                                      //~v71NI~
}//dlcmdaclisttso                                                  //~v71NI~
#endif                                                             //+v71NI~
//**************************************************************** //~v47PI~
// dlcmdgetcmdstr                                                  //~v58hR~
// retrieve cmd string for #,%,& lcmd                              //~v662R~
//*rc   :0                                                         //~v47PI~
//**************************************************************** //~v47PI~
int dlcmdgetcmdstr(PUCLIENTWE Ppcw,PUDLCMD Pplc,char *Pcmdstr)     //~v51WR~
{                                                                  //~v47QI~
    PULINEH plh;                                                   //~v47PI~
#ifdef FTPSUPP                                                     //~v59cI~
    PUFILEH pfh;                                                   //~v59cI~
#endif                                                             //~v59cI~
    PUDIRLH pdh;                                                   //~v47PI~
    UCHAR  parmcmd[MAXCOLUMN];                                     //~v51WR~
    UCHAR  fullpathname[_MAX_PATH];                                //~v51WI~
    int rc;                                                        //~v51WI~
//*******************                                              //~v47PI~
    plh=Pplc->UDLCplh;                                             //~v51WM~
    pdh=UGETPDH(plh);                                              //~v51WM~
    if (dlcgetfullname(pdh,fullpathname))                          //~v51WI~
        return 4;                                                  //~v51WI~
#ifdef FTPSUPP                                                     //~v59cI~
    pfh=UGETPFH(plh);                                              //~v59cI~
  	if (FILEISREMOTE(pfh))                                         //~v59cI~
    	strcpy(fullpathname,fullpathname+((PUFTPHOST)(pfh->UFHpuftph))->UFTPHhostnmlen+1);//cut hostid//~v59cR~
#endif                                                             //~v59cI~
    if (dirgetflddata(Ppcw,plh,PANL310RENAME,parmcmd)<=0)  //fld len//~v51WM~
//      strcpy(Pcmdstr,fullpathname);	//no parm,exec the file    //~v59eR~
		dlcmdsubrshcmdedit(fullpathname,0,Pcmdstr);	//replace % to filename//~v59eR~
    else                                                           //~v51WI~
      if (Pplc->UDLCcmd==DLCMD_SPAWN)	//"&" cmd                  //~v662I~
		dlcmdsubrshcmdedit(fullpathname,parmcmd,Pcmdstr);   //replace % to filename//~v662I~
      else                                                         //~v662I~
      if (Pplc->UDLCcmd==DLCMD_SUBRSH)	//"#" cmd                  //~v59eR~
		dlcmdsubrshcmdedit(fullpathname,parmcmd,Pcmdstr);   //replace % to filename//~v59eR~
      else                                                         //~v59eI~
      {                                                            //~v59eI~
		if (dlcmdappcmdedit(parmcmd,fullpathname,Pcmdstr))	//replace % to filename//~v51WR~
        	return 4;   //internal logic err                       //~v51WR~
      }                                                            //~v59eI~
#ifdef UNX                                                         //~v51WI~
    rc=strcmp(Scmdfullpath,fullpathname);                          //~v51WR~
#else                                                              //~v51WI~
    rc=stricmp(Scmdfullpath,fullpathname);                         //~v51WR~
#endif                                                             //~v51WI~
	if (!rc)	//same as temp cmd file                            //~v51WI~
    {                                                              //~v51WI~
    	uerrmsg("%s is same as work cmd file",0,                   //~v51WI~
        		Scmdfullpath);                                     //~v51WR~
        return 4;                                                  //~v51WI~
    }                                                              //~v51WI~
  	UCBITON(pdh->UDHflag,UDHFAPPCMDSTR); //rename fld is by % lcmd //~v58hI~
	UCBITOFF(pdh->UDHflag,UDHFLCMDIN2|UDHFDDSETUP);//protect rename fld//~v58hI~
    if (dirsavename(plh,parmcmd))                                  //~v58hR~
        return 4;                                                  //~v58hI~
	return 0;                                                      //~v51WR~
}//dlcmdgetcmdstr                                                  //~v51WR~
#ifdef FTPSUPP                                                     //+v71NI~
//**************************************************************** //~v71NI~
// dlcmdgetcmdstrto                                                //~v71NI~
// retrieve cmd string for #,% lcmd  for TSO file                  //~v71NI~
//*rc   :0                                                         //~v71NI~
//**************************************************************** //~v71NI~
int dlcmdgetcmdstrtso(PUCLIENTWE Ppcw,PUFILEH Ppfh,PUDLCMD Pplc,char *Pcmdstr)//~v71NI~
{                                                                  //~v71NI~
    PULINEH plh;                                                   //~v71NI~
    PUDIRLH pdh;                                                   //~v71NI~
    UCHAR  parmcmd[MAXCOLUMN];                                     //~v71NI~
    UCHAR  fullpathname[_MAX_PATH];                                //~v71NI~
    UCHAR  localfnm[_MAX_PATH];                                    //~v71NI~
    int rc;                                                        //~v71NI~
//*******************                                              //~v71NI~
    plh=Pplc->UDLCplh;                                             //~v71NI~
    pdh=UGETPDH(plh);                                              //~v71NI~
    if (!(pdh->UDHattr & FILE_PDSMEMB))                            //~v71NI~
    {                                                              //~v71NM~
    	uerrmsg("command %c is supported only for PDS member",0,   //~v71NR~
	        	Pplc->UDLCcmd);                                    //~v71NM~
    	return 4;                                                  //~v71NM~
    }                                                              //~v71NM~
    if (dlcgetfullname(pdh,fullpathname))                          //~v71NI~
        return 4;                                                  //~v71NI~
    if (Pplc->UDLCcmd==DLCMD_SPAWN)	//"&" cmd                      //~v71NI~
    {                                                              //~v71NI~
      	uerrmsg("%c cmd is not supported for TSO file",0,          //~v71NI~
        	Pplc->UDLCcmd);                                        //~v71NI~
		return 4;                                                  //~v71NI~
    }                                                              //~v71NI~
    if (Pplc->UDLCcmd==DLCMD_SUBRSH)	//"#" cmd                  //~v71NI~
        rc=uxcopy(fullpathname,Scmdfullpath,DCPY_APPEND,FILE_NORMAL); //append to now downloaded//~v71NR~
    else                              //%                          //~v71NI~
    {                                                              //~v71NI~
	    dirgetflddata(Ppcw,plh,PANL310RENAME,parmcmd);             //~v71NI~
  		sprintf(localfnm,"%s%c%s",Sappcmdtmpdir,DIR_SEPC,pdh->UDHname);//~v71NR~
	  	if (xeftpgetremotecopy(0,fullpathname,Ppfh->UFHpuftph,localfnm))//copy into parmdir//~v71NR~
    		return 4;                                              //~v71NI~
		if (dlcmdappcmdedit(parmcmd,localfnm,Pcmdstr))	//replace % to filename//~v71NR~
        	return 4;   //internal logic err                       //~v71NI~
        UCBITON(pdh->UDHflag,UDHFAPPCMDSTR); //rename fld is by % lcmd//~v71NR~
        UCBITOFF(pdh->UDHflag,UDHFLCMDIN2|UDHFDDSETUP);//protect rename fld//~v71NR~
        if (dirsavename(plh,parmcmd))                              //~v71NR~
            return 4;                                              //~v71NR~
    }                                                              //~v71NM~
	return 0;                                                      //~v71NI~
}//dlcmdgetcmdstrtso                                               //~v71NI~
#endif                                                             //+v71NI~
//**************************************************************** //~v51WI~
//* edit cmd string edit for % dlcmd                               //~v51WI~
//* parm1 :pcw                                                     //~v51WI~
//* retrn :-1:err, 1:execute, 0:cmd set on line only               //~v51WI~
//**************************************************************** //~v51WI~
int dlcmdappcmdedit(char *Ppatern,char *Pfnm,char *Poutstr)        //~v51WI~
{                                                                  //~v51WI~
    int repsw,fnmlen,len;                                          //~v51WR~
    int spaceembeddingsw;                                          //~v588I~
    char  *pci,*pcio,*pco;                                         //~v51WR~
//********************                                             //~v51WI~
                                                                   //~v51WI~
	fnmlen=(int)strlen(Pfnm);                                      //~v51WI~
    pco=Poutstr;                                                   //~v51WI~
//    if (*Ppatern=='>')  //redirect parm only,exec the file       //~v57FR~
//    {                                                            //~v57FR~
//        *pco++='\"';                                             //~v57FR~
//        memcpy(pco,Pfnm,fnmlen);                                 //~v57FR~
//        pco+=fnmlen;                                             //~v57FR~
//        *pco++='\"';                                             //~v57FR~
//        strcpy(pco,Ppatern);                                     //~v57FR~
//        return 0;                                                //~v57FR~
//    }                                                            //~v57FR~
    for (pci=Ppatern,repsw=0,pco=Poutstr;;)                        //~v51WR~
    {                                                              //~v51WI~
    	pcio=pci;                                                  //~v51WI~
    	pci=strchr(pci,'%');                                       //~v51WR~
        if (!pci)                                                  //~v51WI~
        {                                                          //~v51WI~
           strcpy(pco,pcio);                                       //~v51WR~
           pco+=strlen(pcio);                                      //~v51WI~
        	break;                                                 //~v51WI~
        }                                                          //~v51WI~
        len=(int)((ULONG)pci-(ULONG)pcio);                         //~v58hR~
        memcpy(pco,pcio,(UINT)len);                                //~v51WI~
        pco+=len;                                                  //~v51WI~
        if (pci!=Ppatern && *(pci-1)=='\\')	// \% is for char '%' as cmd parm//~v51WR~
        {	                                                       //~v51WI~
        	*(pco-1)='%';                                          //~v51WR~
            pci++;                                                 //~v51WI~
            continue;                                              //~v51WI~
        }                                                          //~v51WI~
        repsw=1;                                                   //~v51WI~
//      *pco++='\"';                                               //~v57FR~
        memcpy(pco,Pfnm,(UINT)fnmlen);                             //~v58hR~
        pco+=fnmlen;                                               //~v51WI~
//      *pco++='\"';                                               //~v57FR~
        pci++;                                                     //~v51WI~
    }                                                              //~v51WI~
    if (!repsw)                                                    //~v51WI~
    {                                                              //~v51WI~
        spaceembeddingsw=memchr(Pfnm,' ',(UINT)fnmlen)!=0;         //~v588R~
    	*pco++=' ';                                                //~v51WI~
//      *pco++='\"';                                               //~v57FR~
		if (spaceembeddingsw)                                      //~v588R~
			*pco++='\"';                                           //~v588I~
        memcpy(pco,Pfnm,(UINT)fnmlen);                             //~v58hR~
        pco+=fnmlen;                                               //~v51WI~
//      *pco++='\"';                                               //~v57FR~
		if (spaceembeddingsw)                                      //~v588R~
			*pco++='\"';                                           //~v588I~
    }                                                              //~v51WI~
    *pco++=0;	//null term                                        //~v51WI~
    return 0;                                                      //~v51WI~
}//dlcmdappcmdedit                                                 //~v51WI~
//**************************************************************** //~v59eI~
//* edit cmd string edit for # dlcmd                               //~v59eI~
//* parm1 :pcw                                                     //~v59eI~
//* retrn :0;                                                      //~v59eR~
//**************************************************************** //~v59eI~
int dlcmdsubrshcmdedit(char *Pfnm,char *Pparm,char *Poutstr)       //~v59eR~
{                                                                  //~v59eI~
    int fnmlen,spaceembeddingsw;                                   //~v59eR~
    char  *pco;                                                    //~v59eR~
//********************                                             //~v59eI~
	fnmlen=(int)strlen(Pfnm);                                      //~v59eI~
    pco=Poutstr;                                                   //~v59eI~
    spaceembeddingsw=memchr(Pfnm,' ',(UINT)fnmlen)!=0;             //~v59eI~
	if (spaceembeddingsw)                                          //~v59eI~
		*pco++='\"';                                               //~v59eI~
    memcpy(pco,Pfnm,(UINT)fnmlen);                                 //~v59eI~
    pco+=fnmlen;                                                   //~v59eI~
	if (spaceembeddingsw)                                          //~v59eI~
		*pco++='\"';                                               //~v59eI~
    *pco++=' ';                                                    //~v59eR~
    if (Pparm)                                                     //~v59eI~
	    strcpy(pco,Pparm);                                         //~v59eR~
    else                                                           //~v59eI~
	    *pco++=0;                                                  //~v59eI~
    return 0;                                                      //~v59eI~
}//dlcmdsubrshcmdedit                                              //~v59eI~
//**************************************************************** //~v51WI~
// dlcmdappcmd                                                     //~v51WI~
// submit cmd work file                                            //~v51WI~
//*ret  :rc                                                        //~v51WI~
//**************************************************************** //~v51WI~
int dlcmdappcmd(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)    //~v51WI~
{                                                                  //~v51WI~
    PULINEH plh;                                                   //~v583I~
#ifdef FTPSUPP                                                     //~v59cI~
    PUFILEH pfh;                                                   //~v59cI~
#endif                                                             //~v59cI~
	UCHAR wkpot[MAXCOLUMN+1];                                      //~v71NM~
	UCHAR wkpodt[MAXCOLUMN+1];                                     //~v71NM~
	UCHAR *wkppot;                                                 //~v71NM~
	int wordno;                                                    //~v71NM~
    PUPODELMTBL podt;                                              //~v71NM~
    UCHAR  cmdstr[_MAX_PATH+MAXCOLUMN+32];                         //~v51WI~
//  UCHAR  cmdstrpo[_MAX_PATH+MAXCOLUMN+32];                       //~v71NR~
//  UPODELMTBL delmt[2];                                           //~v71NR~
    int rc;                                                        //~v51WI~
//*******************                                              //~v51WI~
    if (Pplc!=Splcac)   //not last print entry                     //~v51WR~
        return 0;                                                  //~v51WI~
    plh=Pplc->UDLCplh;                                             //~v583I~
    Gdcmdtempf|=GDCMDTEMPF_DLCMDCF; //del at term                  //~v63bR~
#ifdef FTPSUPP                                                     //~v59cM~
    pfh=UGETPFH(plh);                                              //~v59cR~
//if (FILEISREMOTE(pfh))                                           //~v71NR~
  if (FILEISREMOTE(pfh)                                            //~v71NI~
  &&  !FILEISTSO(pfh))                                             //~v71NI~
    rc=dcmdrshlocalfile(Ppcw,pfh,Scmdfullpath,Sredirectparm+1,0);	//stde is &1//~v59cI~
  else                                                             //~v59cM~
  {                                                                //~v59cM~
   if (FILEISTSO(pfh)                                              //~v71NI~
   && Pplc->UDLCcmd==DLCMD_SUBRSH)                                 //~v71NI~
   {                                                               //~v71NI~
   	sprintf(cmdstr,"%s %s %s 2>&1",TSOSUBCMD,Scmdfullpath,Sredirectparm);//~v71NR~
    Ppcw->UCWparm=cmdstr;                                          //~v71NI~
	podt=(PUPODELMTBL)(ULONG)wkpodt;                               //~v71NR~
	wkppot=wkpot;                                                  //~v71NI~
    uparse2(cmdstr,&podt,&wkppot,&wordno,                          //~v71NI~
    		UPARSE2USEAREAPARM|UPARSE2SETCONTDLM2,0);              //~v71NI~
    Ppcw->UCWopdno=wordno;	//cmd operand number                   //~v71NR~
    Ppcw->UCWopdpot=wkppot;                                        //~v71NR~
    Ppcw->UCWopddelmt=podt;                                        //~v71NR~
    rc=func_submit(Ppcw);                                          //~v71NI~
   }                                                               //~v71NI~
   else                                                            //~v71NI~
   {                                                               //~v71NI~
#endif                                                             //~v59cM~
//    Ppcw->UCWopdno=2;       //cmd operand number                 //~v71NR~
//    strcpy(cmdstr,Scmdfullpath);                                 //~v71NR~
//    strcat(cmdstr," "); //ajust for delmtbl                      //~v71NR~
//    strcat(cmdstr,Sredirectparm);                                //~v71NR~
//    Ppcw->UCWparm=cmdstr;                                        //~v71NR~
//    strcpy(cmdstrpo,Scmdfullpath);                               //~v71NR~
//    strcpy(cmdstrpo+strlen(Scmdfullpath)+1,Sredirectparm);//parse out fmt//~v71NR~
//    Ppcw->UCWopdpot=cmdstrpo;                                    //~v71NR~
//    memset(&delmt,0,sizeof(delmt));                              //~v71NR~
//    delmt[0].upodelmoffs=(USHORT)strlen(Scmdfullpath);           //~v71NR~
//    delmt[1].upodelmoffs=(USHORT)(delmt[0].upodelmoffs+1+strlen(Sredirectparm));//~v71NR~
//    Ppcw->UCWopddelmt=&delmt;                                    //~v71NR~
   	sprintf(cmdstr,"%s %s 2>&1",Scmdfullpath,Sredirectparm);       //~v71NI~
    Ppcw->UCWparm=cmdstr;                                          //~v71NI~
	podt=(PUPODELMTBL)(ULONG)wkpodt;                               //~v71NI~
	wkppot=wkpot;                                                  //~v71NI~
    uparse2(cmdstr,&podt,&wkppot,&wordno,                          //~v71NI~
    		UPARSE2USEAREAPARM|UPARSE2SETCONTDLM2,0);              //~v71NI~
    Ppcw->UCWopdno=wordno;	//cmd operand number                   //~v71NI~
    Ppcw->UCWopdpot=wkppot;                                        //~v71NI~
    Ppcw->UCWopddelmt=podt;                                        //~v71NI~
    rc=func_submit(Ppcw);                                          //~v51WR~
#ifdef FTPSUPP                                                     //~v59cI~
	dlcxpdelremotetemp();	//delete tempdir downloaded contaims file//~v71NI~
   }//!TSO sub                                                     //~v71NI~
  }//local submit                                                  //~v59cI~
#endif                                                             //~v59cI~
  	filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr                 //~v583I~
    uerrmsg("done,see cmdfile=%s,stdout=%s",0,                     //~v51WR~
		    Scmdfnm,Sredirectparm+1);                              //~v51WR~
    return rc;                                                     //~v51WI~
}//dlcmdappcmd                                                     //~v51WI~
//**************************************************************** //~v59eI~
// dlcmdappcmd                                                     //~v59eI~
// submit cmd work file                                            //~v59eI~
//*ret  :rc                                                        //~v59eI~
//**************************************************************** //~v59eI~
int dlcmdsubrshcmd(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy) //~v59eI~
{                                                                  //~v59eI~
	int rc;                                                        //~v59eI~
//*******************                                              //~v59eI~
	rc=dlcmdappcmd(Ppcw,Pplc,Pplcdummy);                           //~v59eI~
    return rc;                                                     //~v59eI~
}//dlcmdsubrshcmd                                                  //~v59eI~
#ifndef DOS                                                        //~v662I~
//**************************************************************** //~v662I~
// dlcmdappcmd                                                     //~v662I~
// submit cmd work file                                            //~v662I~
//*ret  :rc                                                        //~v662I~
//**************************************************************** //~v662I~
int dlcmdspawn(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)     //~v662I~
{                                                                  //~v662I~
	int rc;                                                        //~v662I~
    UCHAR  cmdstr[_MAX_PATH+MAXCOLUMN];                            //~v662I~
    PULINEH plh;                                                   //~v662I~
#ifdef FTPSUPP                                                     //~v662I~
    PUFILEH pfh;                                                   //~v662I~
#endif                                                             //~v662I~
#ifndef UNX                                                        //~v662I~
    PUDIRLH pdh;                                                   //~v662I~
#endif                                                             //~v662I~
//*******************                                              //~v662I~
    plh=Pplc->UDLCplh;                                             //~v662M~
#ifndef UNX                                                        //~v662I~
    pdh=UGETPDH(plh);                                              //~v662I~
    if (dlcgetfullname(pdh,cmdstr))                                //~v662I~
        return 4;                                                  //~v662I~
    rc=uextchk(cmdstr);                                            //~v662I~
    if (!rc||rc==9)		//ext err or no extention                  //~v662I~
    {                                                              //~v662I~
    	uerrmsg("filename extension error",0);                     //~v662I~
        return 4;                                                  //~v662I~
    }                                                              //~v662I~
#endif                                                             //~v662I~
	if (dlcmdgetcmdstr(Ppcw,Pplc,cmdstr))                          //~v662I~
    	return 4;                                                  //~v662I~
#ifdef FTPSUPP                                                     //~v662I~
    pfh=UGETPFH(plh);                                              //~v662I~
  	if (FILEISREMOTE(pfh))                                         //~v662I~
    {                                                              //~v662I~
    	uerrmsg("remote file not yet supported",0);                //~v662I~
        rc=4;                                                      //~v662I~
    }                                                              //~v662I~
  	else                                                           //~v662I~
  	{                                                              //~v662I~
#endif                                                             //~v662I~
        Ppcw->UCWparm=cmdstr;                                      //~v662I~
        rc=dcmd_spawn(Ppcw);                                       //~v662I~
#ifdef FTPSUPP                                                     //~v662I~
  	}//local submit                                                //~v662I~
#endif                                                             //~v662I~
  	filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr                 //~v662I~
    return rc;                                                     //~v662I~
}//dlcmdspawn                                                      //~v662I~
#endif                                                             //~v662I~
//#ifdef W32                                                       //~v64vR~
#if defined(W32) || defined(LNX)                                   //~v64vI~
//**************************************************************** //~v55vI~
// dlcmdopenwith                                                   //~v55vI~
// submit cmd work file                                            //~v55vI~
//*ret  :rc                                                        //~v55vI~
//**************************************************************** //~v55vI~
int dlcmdopenwith(PUCLIENTWE Ppcw,PUDLCMD Pplc,PUDLCMD Pplcdummy)  //~v55vI~
{                                                                  //~v55vI~
    char fpath[_MAX_PATH];                                         //~v55vI~
    PULINEH plh;                                                   //~v55vI~
    PUDIRLH pdh;                                                   //~v55vI~
    int rc;                                                        //~v55vI~
//***********************                                          //~v55vI~
    plh=Pplc->UDLCplh;                                             //~v55vI~
    pdh=UGETPDH(plh);                                              //~v55vI~
    if (dlcgetfullname(pdh,fpath))                                 //~v55vI~
        return 4;                                                  //~v55vI~
//  rc=ushellexec(fpath); 	//0:no return HINSTANCE                //~v55VR~
    rc=dlcmdopenwithsub(Ppcw,fpath); 	//0:no return HINSTANCE    //~v55VI~
  	filesetcsr(Ppcw,plh,PANL310LINENO,0);//set csr                 //~v583I~
    return rc;                                                     //~v55vI~
}//dlcmdopenwith                                                   //~v55vI~
//**************************************************************** //~v55VI~
// dlcmdopenwithsub                                                //~v55VI~
// subbmit associated app and register file to filename list       //~v55VI~
//*ret  :rc                                                        //~v55VI~
//**************************************************************** //~v55VI~
int dlcmdopenwithsub(PUCLIENTWE Ppcw,char *Pfnm)                   //~v55VI~
{                                                                  //~v55VI~
    int rc;                                                        //~v55VI~
//***********************                                          //~v55VI~
#ifdef FTPSUPP                                                     //~v64vI~
    if (uftpisremote(Pfnm,0))                                      //~v64vI~
    {                                                              //~v64vI~
        uerrmsg("remote file is not supported",0);                 //~v64vI~
        return 4;                                                  //~v64vI~
    }                                                              //~v64vI~
#endif                                                             //~v64vI~
	pan300addentry(Pfnm,strlen(Pfnm),0);                           //~v55VI~
  #ifdef LNX                                                       //~v64vI~
    rc=(ushellexec(0,Pfnm)==-1);                                   //~v64vI~
  #else                                                            //~v64vI~
	rc=ushellexec(Pfnm); 	//0:no return HINSTANCE                //~v55VI~
  #endif                                                           //~v64vI~
    return rc;                                                     //~v55VI~
}//dlcmdopenwithsub                                                //~v55VI~
#endif                                                             //~v55vI~
//#ifdef WXE                                                       //~v64vR~
#if defined(WXE) || defined(LNX)                                   //~v64vR~
//*************************************************************    //~v56eM~
//*association chk for filenamelist                                //~v56eM~
//*************************************************************    //~v56eM~
int dlcmdassocchk_fnamelist(PUCLIENTWE Ppcw)                       //~v56eM~
{                                                                  //~v56eM~
#ifndef LNX                                                        //~v64vR~
	FILEFINDBUF3 ffb3;                                             //~v56eM~
    UCHAR *pc;                                                     //~v64vI~
#endif                                                             //~v64vI~
	int assocsw=0;                                                 //~v56eM~
    UCHAR fpath[_MAX_PATH];                                        //~v64vR~
//**************************************                           //~v56eM~
    if (pan300getfnm(Ppcw->UCWrcsry+Ppcw->UCWtopfnlist,fpath))	//get stacked name over scr width//~v56eM~
    {                                                              //~v56eM~
	  if (!uftpisremote(fpath,0))                                  //~v71rI~
      {                                                            //~v71rI~
#ifdef LNX                                                         //~v64vR~
        assocsw=(ushellexec(USHEXE_CHKONLY|USHEXE_NOMSG,fpath)>=0);//~v64vR~
#else                                                              //~v64vI~
	  if (!ufstat(fpath,&ffb3))                                    //~v56eR~
		if (ffb3.attrFile & FILE_DIRECTORY)                        //~v56eI~
        	assocsw=1;	//use explorer under win XP                //~v56eM~
        else                                                       //~v56eM~
        {                                                          //~v56eM~
    		pc=umemrchr(fpath,'.',strlen(fpath));	//search extension//~v56eM~
        	if (pc)                                                //~v56eM~
        		assocsw=uwinreg_chkassociation(pc);                //~v56eM~
        }                                                          //~v56eM~
#endif                                                             //~v64vI~
      }//not remote                                                //~v71rI~
    }                                                              //~v56eM~
    return assocsw;                                                //~v56eM~
}//dlcmdassocchk_fnamelist                                         //~v56eM~
//*************************************************************    //~v56eM~
//*association chk for dirlist filename                            //~v56eM~
//*************************************************************    //~v56eM~
int  dlcmdassocchk_dirlist(PUCLIENTWE Ppcw)                        //~v56eM~
{                                                                  //~v56eM~
	PUDIRLH pdh;                                                   //~v56eM~
#ifndef LNX                                                        //~v64vR~
    UCHAR *pc;                                                     //~v64vI~
#endif                                                             //~v64vI~
	int assocsw=0;                                                 //~v56eM~
    UCHAR fpath[_MAX_PATH];                                        //~v64vR~
//**********************************                               //~v56eM~
    if (!dlcgetdirlistfname(Ppcw,fpath,&pdh))                      //~v56eM~
    {                                                              //~v56eM~
	  if (!uftpisremote(fpath,0))                                  //~v71rI~
      {                                                            //~v71rI~
#ifdef LNX                                                         //~v64vR~
        assocsw=(ushellexec(USHEXE_CHKONLY|USHEXE_NOMSG,fpath)>=0);//~v64vR~
#else                                                              //~v64vI~
    	if (pdh->UDHattr & FILE_DIRECTORY)//not dirname            //~v56eM~
        	assocsw=1;	//use explorer under win XP                //~v56eM~
        else                                                       //~v56eM~
	    {                                                          //~v56eM~
    		pc=umemrchr(fpath,'.',strlen(fpath));	//search extension//~v56eM~
        	if (pc)                                                //~v56eM~
        		assocsw=uwinreg_chkassociation(pc);                //~v56eM~
    	}                                                          //~v56eM~
#endif                                                             //~v64vI~
      }//not remote                                                //~v71rI~
    }                                                              //~v56eM~
    return assocsw;                                                //~v56eM~
}//dlcmdassocchk_dirlist                                           //~v56eM~
#endif                                                             //~v56eI~
