//*CID://+v652R~:                             update#=  374;       //~v652R~
//*************************************************************
//*xefcmd4.c*
//**file cmd:Rotate  ROT { R | L | X | Y | RX | LX | RJ | LJ } [NX] [TAIL] [n-m] [.lab1 .lab2]//~v511R~
//** NX: x,y,rj,lj only                                            //~v511R~
//*************************************************************
//v652:050712 (BUG)assoc cmd;chk dcmdfullpath fail(may fail for remote file)//~v652I~
//v64v:050708 (LNX)openwith support(! lcmd & ASS cmd)              //~v64vI~
//v564:040328 (WIN)ASSociate command same as ! lcmd                //~v564I~
//v54G:040121 (BUG)abend when curtop xline is deleted.rotate cmd also abend by same reason//~v54GI~
//v52h:030830 DOS linkerr                                          //~v52hR~
//v52d:030821 (BUG)rotate rj generate invalid line.                //~v52dI~
//v511:030302 new rotate cmd
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifdef DOS
#else
#endif
//*******************************************************
#include <ulib.h>
#include <uque.h>
#include <uerr.h>
#include <uparse.h>
#include <ufile.h>
#include <ualloc.h>
#include <uedit.h>
#include <ustring.h>

#include "xe.h"
#include "xescr.h"
#include "xefile.h"
#include "xefile6.h"
#include "xefcmd.h"
#include "xefcmd22.h"
#include "xefcmd3.h"
#include "xefcmd6.h"
#include "xelcmd.h"
#include "xelcmd2.h"                                               //~v54GI~
#include "xeerr.h"
#include "xeundo.h"
#include "xesub.h"
#include "xefsub.h"
#include "xefunc.h"
#include "xepan.h"                                                 //~v564I~
#include "xedir.h"                                                 //~v564I~
#include "xedcmd.h"                                                //~v564R~
#include "xedlcmd.h"                                               //~v564I~
#include "xedlcmd6.h"                                              //~v564I~
//*******************************************************
//****************************************************************
#define ROTOPT_RTYPE    0x00ff        //rtype mask                 //~v511R~
#define ROTOPT_RJUST    0x0100        //dbcs found                 //~v511I~
#define ROTOPT_DBCS     0x0200        //dbcs found                 //~v511R~
#define ROTOPT_TAILCUT  0x0400        //tail cut option            //~v511R~
#define ROTOPT_AJRANGE  0x0800        //ajust range parm           //~v511I~
#define ROTOPT_NX       0x1000        //for not excluded only      //~v511R~
#define ROTOPT_REV      0x2000        //for LX                     //~v511R~

#define MAXLABEL      2
//**************************************************************** //~v511I~
                                                                   //~v511I~
#ifdef DOSDOS                                                      //~v511I~
#else                                                              //~v511I~
static UCHAR *Swordtbl="R\0L\0X\0Y\0LX\0RX\0RJ\0LJ\0RSV1\0TAIL\0NX\0";//~v511R~
static UCHAR *Srottype;                                            //~v511I~
static long  Sjpos1,Sjpos2;                                        //~v511I~
#endif                                                             //~v511I~
                                                                   //~v511I~
//****************************************************************
int fcmdrotateopdchk(PUCLIENTWE Ppcw,UCHAR Pplabt[][ULHLINENOSZ+1],int *Pplabctr,int *Popt);
int fcmdrotatemain(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt);
int fcmdrotaterl(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt,
					UCHAR *Ppwk,int Plinectr,int Pcharctr);
int fcmdrotatey(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt,UCHAR *Ppwk,int Pmaxlen);//~v511R~
int fcmdrotatex(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt,int Plinectr);//~v511R~
int fcmdajr(int Popt,PULINEH Pplh,char *Ppwk,int Pmaxlen,int *Pplen);//~v511I~
//****************************************************************
// sort on optional label range
//*rc   :0
//****************************************************************
int func_rotate(PUCLIENTWE Ppcw)
{
#ifdef DOSDOS
    return errnotsupported("ROTate","DOS version");
#else
	UCHAR labt[MAXLABEL][ULHLINENOSZ+1];//label opd from/to
    PUFILEH pfh;
    PULINEH plhs,plhe;
    PUFILEC pfc;
    int rc,labctr,opt;
//*********************************
	if (!Ppcw->UCWparm)		//operand
    {
        uerrmsg("ROT { R | L | X | Y | RX | LX | RJ | LJ } [NX] [TAIL] [n-m] [.lab1 .lab2]",0);//~v511R~
        return 0;
    }
	pfc=Ppcw->UCWpfc;
    if (UCBITCHK(pfc->UFCflag,UFCFBROWSE))
		return errbrowsemode();
	pfh=pfc->UFCpfh;
    if (pfh->UFHtype==UFHTKFI)	//menu opt file
    	return 4;
	memset(labt,0,sizeof(labt));		//for null term
	if (fcmdrotateopdchk(Ppcw,labt,&labctr,&opt))
    	return 4;
	if (rc=fcmdgetabrange(Ppcw,pfh,labt,labctr,&plhs,&plhe,1),rc) //1:plh2 is next plh
    	return rc;	//may 1:no bell
	rc=fcmdrotatemain(Ppcw,pfh,plhs,plhe,opt);
    return rc;
#endif
}//func_rotate                                                     //~v511R~
#ifdef DOSDOS
#else
//****************************************************************
//!fcmdrotateopdchk
//  SORT n-m[/[r][c][i] ... (max5) [.lab1 .lab2]
//* parm1 :pcw
//* parm2 :label output
//* parm3 :key range output
//* parm4 :label ctr
//* parm5 :key ctr
//* return:rc
//****************************************************************
int fcmdrotateopdchk(PUCLIENTWE Ppcw,UCHAR Pplabt[][ULHLINENOSZ+1],int *Pplabctr,int *Ppopt)
{
    char *pc,*plabt;
    int labctr=0,ropt=0,rtype=0,opdno,ii,opid,rc;                  //~v511R~
//*********************************
    opdno=Ppcw->UCWopdno;           //funccmd created already
    pc=Ppcw->UCWopdpot;
    plabt=&Pplabt[0][0];
	for (ii=0;ii<opdno;ii++,pc=pc+strlen(pc)+1)   //next opd addr
    {
        if (*pc==ULCCMDLABEL)  //lebel specified
        {
            if (labctr==MAXLABEL)
                return fcmdlabelerr("Too many");
            strncpy(plabt,pc,ULHLINENOSZ);
            plabt+=ULHLINENOSZ+1;
            labctr++;
            continue;
		}
        if (*pc>='0' && *pc<='9')                                  //~v511I~
        {                                                          //~v511I~
			rc=ugetnumrange(pc,&Sjpos1,&Sjpos2);                   //~v511R~
			if (rc!=1 || Sjpos1>=Sjpos2)                           //~v511R~
    	    	return errinvalid(pc);                             //~v511I~
            Sjpos1--;                                              //~v511I~
			ropt|=ROTOPT_AJRANGE;                                  //~v511I~
            continue;                                              //~v511I~
        }                                                          //~v511I~
 		switch(opid=wordtblisrch(pc,Swordtbl),opid)
        {
        case 0:	//err
        	return errinvalid(pc);
        case 1: //R
        case 2: //L
        case 3: //X                                                //~v511R~
        case 4: //Y                                                //~v511R~
            Srottype=pc;                                           //~v511I~
            rtype=opid;
            break;
        case 5: //LX                                               //~v511I~
            Srottype=pc;                                           //~v511I~
            rtype=2;    //left                                     //~v511I~
            ropt|=ROTOPT_REV;                                      //~v511I~
            break;                                                 //~v511I~
        case 6: //RX                                               //~v511I~
            Srottype=pc;                                           //~v511I~
            rtype=1;    //left                                     //~v511I~
            ropt|=ROTOPT_REV;                                      //~v511I~
            break;                                                 //~v511I~
        case 7: //RJ                                               //~v511R~
            Srottype=pc;                                           //~v511I~
            ropt|=ROTOPT_RJUST;                                    //~v511I~
            rtype=5;                                               //~v511I~
            break;
        case 8: //LJ                                               //~v511R~
            Srottype=pc;                                           //~v511I~
            ropt&=~ROTOPT_RJUST;                                   //~v511I~
            rtype=5;                                               //~v511I~
            break;
        case 9: //????                                             //~v511R~
        	return errinvalid(pc);                                 //~v511I~
        case 10: //TAILCUT                                         //~v511R~
            ropt|=ROTOPT_TAILCUT;                                  //~v511I~
            break;                                                 //~v511I~
        case 11: //NX                                              //~v511R~
            ropt|=ROTOPT_NX;  //not excluded only                  //~v511R~
            break;                                                 //~v511I~
        }
	}//opdno loop
    if (labctr && (labctr!=MAXLABEL))
        return fcmdlabelerr("label count=0 or 2");
    if (!rtype)
    {
        uerrmsg("No rotation type option",
                "]^CvwȂ");
		return 4;
    }
    if (ropt & ROTOPT_NX)  //not excluded only                     //~v511I~
    	if (rtype<=2)                                              //~v511I~
        	return errconflict("NX",0);                            //~v511I~
    if (ropt & ROTOPT_AJRANGE)  //not excluded only                //~v511I~
    	if (rtype!=5)                                              //~v511I~
        	return errconflict("colomn-range",0);                  //~v511I~
	*Ppopt=rtype|ropt;
	*Pplabctr=labctr;
    return 0;
}//fcmdrotateopdchk
#endif                                                             //~v52hR~
//****************************************************************
//!fcmdgetabrange
//* get line range from label
//*parm1 :pcw
//*parm2 :pfh
//*parm3 :labt
//*parm4 :labtctr(!=0)
//*parm5 :output strat plh
//*parm6 :output end plh
//*parm7 :opt for fcmdgetlabelrange
//*rc   :0:ok,1:lab not found 2nd time,4:notfound 1st time or label err
//****************************************************************
int fcmdgetabrange(PUCLIENTWE Ppcw,PUFILEH Ppfh,UCHAR Pplabt[][ULHLINENOSZ+1],
						int Plabctr,PULINEH *Ppplhs,PULINEH *Ppplhe,int Popt)
{
    PULINEH plht[MAXLABEL],plh1,plh2;
    int rc;
//***************
    rc=fcmdgetlabelrange(Ppfh,Plabctr,Pplabt,plht,Popt);//not drop cmd
	if (!Plabctr)
    {
        plh1=UGETQTOP(&Ppfh->UFHlineque);//search from first
        plh2=UGETQEND(&Ppfh->UFHlineque);//search from first
    }
    else
    {
            plh1=plht[0];
            plh2=plht[1];
    }
    *Ppplhs=plh1;
    *Ppplhe=plh2;
	if (rc==2)		//2 for no bell by fcmdgetlabelrange
    	rc=1;
    return rc;       //has label
}//fcmdgetabrange
#ifdef DOSDOS                                                      //~v52hR~
#else                                                              //~v52hR~
//****************************************************************
// rotate line
//*parm1 :pcw
//*parm2 :pfh
//*parm3 :start plh
//*parm4 :end   plh
//*parm5 :option
//*return:rc
//****************************************************************
int fcmdrotatemain(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt)
{
	PULINEH plh;                                                   //~v511R~
    int linectr=0,maxchar,dbcssw=0,sbcssw=0,maxlen;                //~v511R~
    int rc,rtype,opt,len,ii,nxsw,djwklen;                          //~v511R~
    UCHAR *pwk,*pdbcs;                                             //~v511R~
//*********************************
	rtype=Popt & ROTOPT_RTYPE;
	nxsw=(Popt & ROTOPT_NX);                                       //~v511I~
//count line
	plh=Pplhs;
    for (maxlen=0,plh=Pplhs;plh && plh!=Pplhe;plh=UGETQNEXT(plh))  //~v511R~
	{
        if (plh->ULHtype!=ULHTDATA)
        	continue;
		if (nxsw                                                   //~v511I~
		&&  UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))                 //~v511I~
        	continue;                                              //~v511I~
        if (!plh->ULHdbcs)  //not once displayed
            if ((rc=filechktabdbcs(plh))==UALLOC_FAILED)//expand data len
                return UALLOC_FAILED;
        if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT1|ULHF2SPLIT2))
        {
            uerrmsg("Cannot rotate file with split line",
                    "ŝt@C͉]ł܂");
            return 4;
        }
        len=plh->ULHlen;
        if (rtype<=2)	//rot r/l
        {
            pdbcs=plh->ULHdbcs;                                    //~v511I~
            for (ii=0,maxchar=0;ii<len;ii++,pdbcs++,maxchar++)     //~v511R~
                if (*pdbcs==DBCS1STCHAR)
                {
                    dbcssw=1;
                    ii++;
                    pdbcs++;                                       //~v511I~
                }
                else                                               //~v511I~
                if (*pdbcs!=DBCS2NDCHAR)                           //~v511I~
                    sbcssw=1;                                      //~v511I~
        }
        else
        	maxchar=len;
        if (maxlen<maxchar)
            maxlen=maxchar;
        linectr++;
	}//
    opt=Popt;
    if (rtype<=2)	//R or L
    {
    	if (dbcssw)
        {
            opt|=ROTOPT_DBCS;
			len=(linectr+linectr)*maxlen;                          //~v511I~
        }
        else                                                       //~v511I~
			len=linectr*maxlen;                                    //~v511R~
    }
    else
    	len=maxlen;
    len<<=1;            //pdbcs
    djwklen=maxlen*sizeof(int);                                    //~v511R~
	pwk=umalloc((UINT)(len+djwklen));                              //~v511R~
    UALLOCCHK(pwk,UALLOC_FAILED);
//  len>>=1;                                                       //~v54GR~
    len=(int)((UINT)len>>1);                                       //~v54GI~

    if (rtype<=2)	//R or L
    {
        memset(pwk,0,(UINT)djwklen);     //data                    //~v511R~
    	memset(pwk+djwklen,' ',(UINT)len);     //data              //~v511R~
    	memset(pwk+djwklen+len,0,(UINT)len);   //dbcs              //~v511R~
    }
    UPCTRREQ(Ppfh);         //write at save                        //~v511M~
    switch(rtype)
    {
   	case 1:	//R
   	case 2:	//L
    	if (linectr>MAXLINEDATA)                                   //~v511I~
        {                                                          //~v511I~
        	uerrmsg("Too many line(max=%d)",                       //~v511I~
            		"]͍ő %d s܂",                        //~v511I~
                    MAXLINEDATA);                                  //~v511I~
            break;                                                 //~v511I~
        }                                                          //~v511I~
		rc=fcmdrotaterl(Ppcw,Ppfh,Pplhs,Pplhe,opt,pwk,linectr,maxlen);
        if (!rc)                                                   //~v511I~
        	if (dbcssw && sbcssw)                                  //~v511I~
            	uerrmsg("SBCS and DBCS mixed",                     //~v511I~
                		"SBCS  DBCS ");                    //~v511I~
        break;
    case 3:
		rc=fcmdrotatex(Ppcw,Ppfh,Pplhs,Pplhe,opt,linectr);         //~v511R~
        break;
    case 4:
		rc=fcmdrotatey(Ppcw,Ppfh,Pplhs,Pplhe,opt,pwk,maxlen);      //~v511R~
        break;
    case 5:                                                        //~v511I~
    case 6:                                                        //~v511I~
		rc=fcmdrotatey(Ppcw,Ppfh,Pplhs,Pplhe,opt,pwk,maxlen);      //~v511I~
        break;                                                     //~v511I~
    }
    UPCTRREQ(Ppfh);         //write at save
    ufree(pwk);
    if (!rc)                                                       //~v511I~
    	uerrmsg("ROT %s Completed",                                //~v511R~
                "ROT %s ",                                     //~v511R~
				Srottype);                                         //~v511R~
	return rc;
}//fcmdrotatemain
//****************************************************************
// rotate right/left
//*parm1 :pcw
//*parm2 :pfh
//*parm3 :start plh
//*parm4 :end   plh
//*parm5 :option
//*parm6 :work
//*parm7 :rotate range line ctr
//*parm8 :rotate range width(char ctr)                             //~v511R~
//*return:rc
//****************************************************************
int fcmdrotaterl(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt,
					UCHAR *Ppwk,int Plinectr,int Pmaxcol)          //~v511R~
{
	PULINEH plh;
    UCHAR   *pwk,*pdata,*pdbcs,*pc;
    int ii,rc=0,rtype,dbcssw,linectr,dbcsoffs,len,isrtctr,offs,tailcutsw;//~v511R~
    int outwidth,revsw,charctr,*pdjwk0,*pdjwk,outrow,lineoffs,bottomupsw;//~v511R~
    int maxwidth,djoffs;                                           //~v511R~
//*********************************
	rtype=Popt & ROTOPT_RTYPE;
	dbcssw=(Popt & ROTOPT_DBCS)!=0;
	tailcutsw=(Popt & ROTOPT_TAILCUT);                             //~v511I~
	revsw=(Popt & ROTOPT_REV);                                     //~v511I~
    if (rtype==1)       //rotate right                             //~v511I~
        if (revsw)      //RX                                       //~v511I~
            bottomupsw=1;                                          //~v511I~
        else                                                       //~v511I~
            bottomupsw=0;                                          //~v511I~
    else                                                           //~v511I~
        if (revsw)      //LX                                       //~v511I~
            bottomupsw=0;                                          //~v511I~
        else                                                       //~v511I~
            bottomupsw=1;                                          //~v511I~
    pwk=Ppwk;                       //data
    pdjwk0=(int*)(void*)pwk;                                       //~v511R~
    pwk+=Pmaxcol*sizeof(int);                                      //~v511R~
    outwidth=(Plinectr<<dbcssw);                                   //~v511I~
    dbcsoffs=outwidth*Pmaxcol;	//dbcs                             //~v511R~
    for (linectr=0,plh=Pplhs;plh && plh!=Pplhe;plh=UGETQNEXT(plh)) //~v511R~
    {                                                              //~v511R~
        if (plh->ULHtype!=ULHTDATA)                                //~v511R~
            continue;                                              //~v511R~
        pdata=plh->ULHdata;                                        //~v511R~
        pdbcs=plh->ULHdbcs;                                        //~v511R~
        len=plh->ULHlen;                                           //~v511R~
        for (ii=0,charctr=0;charctr<Pmaxcol;ii++,pdata++,pdbcs++)  //~v511R~
        {                                                          //~v511R~
            if (bottomupsw)                                        //~v511R~
                outrow=Pmaxcol-charctr-1;                          //~v511R~
            else                                                   //~v511R~
                outrow=charctr;                                    //~v511R~
            lineoffs=outrow*outwidth;                              //~v511R~
            pdjwk=pdjwk0+outrow;                                   //~v511R~
            offs=*pdjwk;                                           //~v511I~
            if (rtype==1)       //rj                               //~v511R~
            	offs=outwidth-offs;                                //~v511R~
	   		pc=pwk+lineoffs+offs;                                  //~v511I~
            if (ii<len)                                            //~v511R~
                if (dbcssw && *pdbcs==DBCS1STCHAR)                 //~v511I~
                {                                                  //~v511R~
                    if (rtype==1)       //rj                       //~v511R~
                        pc-=2;                                     //~v511R~
                    *pc=*pdata++;                                  //~v511R~
                    pdbcs++;                                       //~v511R~
                    *((pc++)+dbcsoffs)=DBCS1STCHAR;                //~v511R~
                    *pc=*pdata;                                    //~v511R~
                    *(pc+dbcsoffs)=DBCS2NDCHAR;                    //~v511R~
                    ii++;                                          //~v511R~
                    *pdjwk+=2;                                     //~v511R~
                }                                                  //~v511R~
                else                    //sbcs                     //~v511R~
                {                                                  //~v511R~
                    if (rtype==1)       //rj                       //~v511R~
                        pc--;                                      //~v511R~
                    *pc=*pdata;                                    //~v511R~
                    *pdjwk+=1;                                     //~v511R~
                }                                                  //~v511R~
            else	//short line                                   //~v511I~
                *pdjwk+=1;                                         //~v511I~
            charctr++;                                             //~v511R~
        }//a line data                                             //~v511R~
        linectr++;                                                 //~v511R~
    }//all line                                                    //~v511R~
//update file
	djoffs=0;                                                      //~v511I~
    for (ii=0,maxwidth=0,pdjwk=pdjwk0;ii<Pmaxcol;ii++,pdjwk++)     //~v511R~
        if (maxwidth<*pdjwk)                                       //~v511R~
            maxwidth=*pdjwk;                                       //~v511R~
    if (rtype==1)   //rotate right                                 //~v511R~
        djoffs=outwidth-maxwidth;                                  //~v511R~
    UCBITON(Ppcw->UCWflag,UCWFDRAW);	//after curtop changed chk //~v511I~
    for (linectr=0,plh=Pplhs;plh && plh!=Pplhe;plh=UGETQNEXT(plh))
	{
        if (plh->ULHtype!=ULHTDATA)
        	continue;
        pdata=pwk+linectr*outwidth+djoffs;                         //~v511R~
        pdbcs=pdata+dbcsoffs;
        len=maxwidth;                                              //~v511I~
        if (linectr<Pmaxcol)	//rep range of tall box            //~v511R~
        {
        	if (tailcutsw)                                         //~v511I~
	        	len-=(int)umemrspnc(pdata,' ',(UINT)len);          //~v52dR~
        	rc=fcmdlineupdate(Ppcw,plh,pdata,pdbcs,len);
            if (rc)
            	break;
        }
        else
        {                                                          //~v54GI~
			lcmddelresetcurtop(Ppcw,plh);	//maint pfccurtop      //~v54GI~
			if (rc=undoupdate(Ppcw,plh,UUHTDEL),rc)//deq and prep for undo
            	break;	//UALLOC_FAILED
        }                                                          //~v54GI~
        linectr++;
	}//all plh
    if (rc)//expand data len
    	return rc;
    plh=UGETQPREV(Pplhe);//before eof line                         //~v511R~
    if (isrtctr=Pmaxcol-Plinectr,isrtctr>0)	//isrt required(wide box)//~v511R~
    {
        pdata=pwk+Plinectr*outwidth;                               //~v511R~
    	for (ii=0;ii<isrtctr;ii++,pdata+=outwidth)                 //~v511R~
        {
        	pc=pdata+djoffs;                                       //~v511I~
	        len=maxwidth;                                          //~v511I~
    		if (tailcutsw)                                         //~v511I~
        		len-=(int)umemrspnc(pc,' ',(UINT)len);             //~v52dR~
			rc=fcmdisrtlinedbcs(Ppcw,plh,pc,pc+dbcsoffs,len);      //~v511R~
            if (rc)                                                //~v511I~
            	break;                                             //~v511I~
            plh=UGETQNEXT(plh);     //isrted line
        }
    }
	return rc;                                                     //~v511R~
}//fcmdrotaterl
//****************************************************************
// rotate horizontal
//*parm1 :pcw
//*parm2 :pfh
//*parm3 :start plh
//*parm4 :end   plh
//*parm5 :option
//*parm6 :work
//*parm7 :maxlen
//*return:rc
//****************************************************************
int fcmdrotatey(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt,UCHAR *Ppwk,int Pmaxlen)//~v511R~
{
	PULINEH plh;
    UCHAR   *pwk,*pdata,*pdbcs,*pc;
    int ii,rc=0,rjust,dbcsoffs,len,rpos,tailcutsw,nxsw,justsw,shiftlen;//~v511R~
    int ajrsw;                                                     //~v511I~
//*********************************
	justsw=((Popt & ROTOPT_RTYPE)==5);                             //~v511I~
	rjust=(Popt & ROTOPT_RJUST);                                   //~v511R~
	tailcutsw=(Popt & ROTOPT_TAILCUT);                             //~v511I~
	nxsw=(Popt & ROTOPT_NX);                                       //~v511I~
	ajrsw=(Popt & ROTOPT_AJRANGE);                                 //~v511R~
    dbcsoffs=Pmaxlen;
    pwk=Ppwk;                       //data
//update file
    for (plh=Pplhs;plh && plh!=Pplhe;plh=UGETQNEXT(plh))
	{
        if (plh->ULHtype!=ULHTDATA)
        	continue;
        if (nxsw)                                                  //~v511R~
			if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))             //~v511I~
            	continue;                                          //~v511I~
        if (ajrsw)                                                 //~v511I~
            fcmdajr(Popt,plh,pwk,Pmaxlen,&len);                    //~v511I~
        else                                                       //~v511I~
        {                                                          //~v511I~
            pdata=plh->ULHdata;                                    //~v511R~
            pdbcs=plh->ULHdbcs;                                    //~v511R~
            len=plh->ULHlen;                                       //~v511R~
            memset(pwk+Pmaxlen,0,(UINT)Pmaxlen);                   //~v511R~
            if (justsw)         //rj or lj                         //~v511R~
            {                                                      //~v511R~
                if (rjust)       //ajust right                     //~v511R~
                {                                                  //~v511R~
                    rpos=(int)umemrspnc(pdata,' ',(UINT)len);      //~v52dR~
                    shiftlen=len-rpos;                             //~v511R~
                    rpos+=(Pmaxlen-len);    //ajust to maxlen record//~v52dI~
                    memset(pwk,' ',(UINT)rpos);                    //~v511R~
                    memcpy(pwk+rpos,pdata,(UINT)shiftlen);         //~v511R~
                    pc=pwk+dbcsoffs+rpos;                          //~v511R~
                    len=Pmaxlen;                                   //~v511R~
                    if (tailcutsw && shiftlen==0)                  //~v511R~
                        len=0;                                     //~v511R~
                    else                                           //~v511R~
                        len=Pmaxlen;                               //~v511R~
                }                                                  //~v511R~
                else                                               //~v511R~
                {                                                  //~v511R~
                    rpos=(int)umemspnc(pdata,' ',(UINT)len);       //~v52dR~
                    shiftlen=len-rpos;                             //~v511R~
                    memcpy(pwk,pdata+rpos,(UINT)shiftlen);         //~v511R~
                    memset(pwk+shiftlen,' ',(UINT)(Pmaxlen-shiftlen));//~v511R~
                    pdbcs+=rpos;                                   //~v511R~
                    pc=pwk+dbcsoffs;                               //~v511R~
                    rpos=shiftlen;                                 //~v511R~
                    if (tailcutsw)                                 //~v511R~
                        len=rpos-(int)umemrspnc(pwk,' ',(UINT)rpos);//~v52dR~
                }                                                  //~v511R~
                for (ii=0;ii<shiftlen;ii++,pdbcs++,pc++)           //~v511R~
                {                                                  //~v511R~
                    if (*pdbcs==DBCS1STCHAR)                       //~v511R~
                    {                                              //~v511R~
                        pdbcs++;                                   //~v511R~
                        *pc++=DBCS1STCHAR;                         //~v511R~
                        *pc=DBCS2NDCHAR;                           //~v511R~
                        ii++;                                      //~v511R~
                    }                                              //~v511R~
                }                                                  //~v511R~
            }                                                      //~v511R~
            else    //rotate                                       //~v511R~
            {                                                      //~v511R~
                rpos=len;                                          //~v511R~
                pc=pwk+(rpos-1);                                   //~v511R~
                for (ii=0;ii<len;ii++,pdata++,pdbcs++,pc--)        //~v511R~
                {                                                  //~v511R~
                    if (*pdbcs==DBCS1STCHAR)                       //~v511R~
                    {                                              //~v511R~
                        *(pc-1)=*pdata++;       //1st byte         //~v511R~
                        pdbcs++;                                   //~v511R~
                        *(pc-1+dbcsoffs)=DBCS1STCHAR;              //~v511R~
                        *pc=*pdata;                                //~v511R~
                        *((pc--)+dbcsoffs)=DBCS2NDCHAR;            //~v511R~
                        ii++;                                      //~v511R~
                    }                                              //~v511R~
                    else                    //sbcs                 //~v511R~
                        *pc=*pdata;                                //~v511R~
                }                                                  //~v511R~
                if (tailcutsw)                                     //~v511R~
                    len=rpos-(int)umemrspnc(pwk,' ',(UINT)rpos);   //~v52dR~
                else                                               //~v511R~
                    len=rpos;                                      //~v511R~
            }//rotate                                              //~v511R~
        }                                                          //~v511I~
        rc=fcmdlineupdate(Ppcw,plh,pwk,pwk+dbcsoffs,len);
        if (rc)
            break;
	}//all plh
    return rc;
}//fcmdrotatey                                                     //~v511R~
//**************************************************************** //~v511I~
// range taype shift r/l                                           //~v511I~
//*parm1 :opt                                                      //~v511I~
//*parm2 :plh                                                      //~v511I~
//*parm3 :work                                                     //~v511I~
//*parm4 :worklen                                                  //~v511I~
//*parm5 :output line length                                       //~v511I~
//*return:rc                                                       //~v511I~
//**************************************************************** //~v511I~
int fcmdajr(int Popt,PULINEH Pplh,char *Ppwk,int Pmaxlen,int *Pplen)//~v511I~
{                                                                  //~v511I~
    UCHAR   *pwk,*pdata,*pdbcs,*pc;                                //~v511I~
    int ii,rjust,len,rpos,tailcutsw,shiftlen,outlen,inppos,outpos,cutlen,width;//~v511R~
    int dbcssw1;                                                   //~v511I~
//*********************************                                //~v511I~
	rjust=(Popt & ROTOPT_RJUST);                                   //~v511I~
	tailcutsw=(Popt & ROTOPT_TAILCUT);                             //~v511I~
    pwk=Ppwk;                       //data                         //~v511I~
    pdata=Pplh->ULHdata;                                           //~v511R~
    pdbcs=Pplh->ULHdbcs;                                           //~v511R~
    len=Pplh->ULHlen;                                              //~v511R~
    memcpy(pwk,pdata,(UINT)len);                                   //~v511R~
    memcpy(pwk+Pmaxlen,pdbcs,(UINT)len);                           //~v511I~
    for (ii=0,pc=pwk+Pmaxlen;ii<len;ii++,pdbcs++,pc++)             //~v511I~
    	if (*pdbcs==DBCS1STCHAR)                                   //~v511I~
        	*pc=DBCS1STCHAR;                                       //~v511I~
        else                                                       //~v511I~
    	if (*pdbcs==DBCS2NDCHAR)                                   //~v511I~
        	*pc=DBCS2NDCHAR;                                       //~v511I~
    pdbcs=Pplh->ULHdbcs;                                           //~v511I~
    memset(pwk+len,' ',(UINT)(Pmaxlen-len));                       //~v511I~
    memset(pwk+Pmaxlen+len,0,(UINT)(Pmaxlen-len));                 //~v511I~
    outlen=len; //no change                                        //~v511I~
    width=Sjpos2-Sjpos1;                                           //~v511I~
    if (len<=Sjpos1)	//no data in the range                     //~v511I~
    {                                                              //~v511I~
    	if (!tailcutsw)                                            //~v511I~
        	outlen=Sjpos2;                                         //~v511I~
    }                                                              //~v511I~
    else                                                           //~v511I~
    {                                                              //~v511I~
	    if (len<Sjpos2)	//short data                               //~v511I~
    		shiftlen=len-Sjpos1;                                   //~v511I~
        else                                                       //~v511I~
        	shiftlen=width;                                        //~v511R~
        if (rjust)       //ajust right                             //~v511I~
        {                                                          //~v511I~
        	cutlen=(int)umemrspnc(pdata+Sjpos1,' ',(UINT)shiftlen);//~v52dR~
        	shiftlen-=cutlen;                                      //~v511I~
            inppos=Sjpos1;                                         //~v511I~
            outpos=Sjpos2-shiftlen;	//out pos                      //~v511I~
	        memset(pwk+Sjpos1,' ',(UINT)(width-shiftlen));         //~v511I~
	        memcpy(pwk+outpos,pdata+inppos,(UINT)shiftlen);        //~v511I~
        }                                                          //~v511I~
        else	//ljust                                            //~v511I~
        {                                                          //~v511I~
        	cutlen=(int)umemspnc(pdata+Sjpos1,' ',(UINT)shiftlen); //~v52dR~
        	shiftlen-=cutlen;                                      //~v511I~
            inppos=Sjpos1+cutlen;                                  //~v511I~
            outpos=Sjpos1;                                         //~v511I~
	        memcpy(pwk+outpos,pdata+inppos,(UINT)shiftlen);        //~v511I~
	        memset(pwk+outpos+shiftlen,' ',(UINT)(width-shiftlen));//~v511I~
        }                                                          //~v511I~
    	if (tailcutsw)                                             //~v511I~
        	shiftlen-=(int)umemrspnc(pdata+inppos,' ',(UINT)shiftlen);//~v52dR~
        rpos=outpos+shiftlen;                                      //~v511I~
        pdbcs+=inppos;                                             //~v511I~
        pc=pwk+Pmaxlen+outpos;                                     //~v511I~
        dbcssw1=0;                                                 //~v511I~
        for (ii=0;ii<shiftlen;ii++,pdbcs++,pc++)                   //~v511I~
        {                                                          //~v511I~
            if (*pdbcs==DBCS1STCHAR)                               //~v511R~
            {                                                      //~v511I~
            	if (ii==shiftlen-1	//last dbcs split              //~v511I~
                &&  outpos+shiftlen!=Sjpos2)                       //~v511I~
                {                                                  //~v511I~
                    *(pwk+outpos+ii)=' ';                          //~v511I~
                    *(pwk+Sjpos2)=' ';                             //~v511M~
                    *(pwk+Pmaxlen+Sjpos2)=0;                       //~v511I~
                }                                                  //~v511I~
                else                                               //~v511I~
                {                                                  //~v511I~
            		dbcssw1=1;                                     //~v511I~
                	*pc=DBCS1STCHAR;                               //~v511R~
                }                                                  //~v511I~
            }                                                      //~v511I~
            else                                                   //~v511I~
            if (*pdbcs==DBCS2NDCHAR)                               //~v511I~
            {                                                      //~v511I~
            	if (!dbcssw1	//after 1st byte                   //~v511I~
                &&  inppos!=outpos)                                //~v511I~
                {                                                  //~v511I~
                    *(pwk+outpos)=' ';                             //~v511I~
                    *(pwk+Sjpos1-1)=' ';                           //~v511I~
                    *(pwk+Pmaxlen+Sjpos1-1)=0;                     //~v511R~
                }                                                  //~v511I~
                else                                               //~v511I~
	                *pc=DBCS2NDCHAR;                               //~v511I~
            }                                                      //~v511I~
        }                                                          //~v511I~
	    if (len<Sjpos2)	//short data                               //~v511I~
        {                                                          //~v511I~
	    	if (tailcutsw)                                         //~v511I~
        		outlen=rpos;                                       //~v511I~
            else                                                   //~v511I~
            	outlen=Sjpos2;                                     //~v511I~
        }                                                          //~v511I~
    }                                                              //~v511I~
    *Pplen=outlen;                                                 //~v511I~
    return 0;                                                      //~v511I~
}//fcmdajr                                                         //~v511I~
//****************************************************************
// rotate virtical
//*parm1 :pcw
//*parm2 :pfh
//*parm3 :start plh
//*parm4 :end   plh
//*parm5 :option
//*parm6 :linectr
//*return:rc
//****************************************************************
int fcmdrotatex(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplhs,PULINEH Pplhe,int Popt,int Plinectr)//~v511R~
{
	PULINEH plh,plhback,plhnext=0,plhbackprev;                     //~v511R~
    UCHAR   *pdata,*pdbcs;
    int rc,swapctr=0,maxswap,len,bufflen,nxsw,tailcutsw;           //~v511R~
//*********************************
	tailcutsw=(Popt & ROTOPT_TAILCUT);                             //~v511I~
	nxsw=(Popt & ROTOPT_NX);                                       //~v511I~
    maxswap=(int)((UINT)Plinectr>>1);                              //+v652R~
    plhbackprev=UGETQPREV(Pplhe);                                  //~v511R~
//update file
    for (plh=Pplhs,swapctr=0;swapctr<maxswap && plh;plh=plhnext)   //~v511R~
	{
	    plhnext=UGETQNEXT(plh);                                    //~v511I~
        if (plh->ULHtype!=ULHTDATA)
        	continue;
        if (nxsw)                                                  //~v511R~
			if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))             //~v511I~
            	continue;                                          //~v511I~
        for (plhback=plhbackprev;plhback;plhback=UGETQPREV(plhback))//~v511R~
        	if (plhback->ULHtype==ULHTDATA)                        //~v511R~
		        if (!nxsw                                          //~v511R~
				||  !UCBITCHK(plhback->ULHflag2,ULHF2EXCLUDED))    //~v511R~
            		break;                                         //~v511R~
		plhbackprev=UGETQPREV(plhback);                            //~v511I~
        if ((rc=undoupdate(Ppcw,plh,UUHTREP))==UALLOC_FAILED)   //prepare undo and update process
            break;
        if ((rc=undoupdate(Ppcw,plhback,UUHTREP))==UALLOC_FAILED)   //prepare undo and update process
            break;
//swap
        pdata  =plh->ULHdata;
        pdbcs  =plh->ULHdbcs;
        bufflen=plh->ULHbufflen;
        len    =plh->ULHlen;
        plh->ULHdata   =plhback->ULHdata;
        plh->ULHdbcs   =plhback->ULHdbcs;
        plh->ULHbufflen=plhback->ULHbufflen;
        plh->ULHlen    =plhback->ULHlen;
        if (tailcutsw)                                             //~v511I~
        	plh->ULHlen-=(int)umemrspnc(plh->ULHdata,' ',(UINT)(plh->ULHlen));//~v52dR~
        plhback->ULHdata   =pdata;
        plhback->ULHdbcs   =pdbcs;
        plhback->ULHbufflen=bufflen;
        if (tailcutsw)                                             //~v511I~
        	len-=(int)umemrspnc(pdata,' ',(UINT)len);              //~v52dR~
        plhback->ULHlen    =len;
        swapctr++;
	}//half of all plh                                             //~v511R~
    return rc;
}//fcmdrotatex                                                     //~v511R~
//****************************************************************
// line update with data/dbcs
//*parm1 :pcw
//*parm2 :plh
//*parm3 :data
//*parm4 :dbcs
//*parm5 :len
//*return:rc
//****************************************************************
int fcmdlineupdate(PUCLIENTWE Ppcw,PULINEH Pplh,UCHAR *Ppdata,UCHAR *Ppdbcs,int Plen)
{
//******************************
	if (Pplh->ULHbufflen<Plen)
    	if (fileexpandbuff(Pplh,Plen)==UALLOC_FAILED)      //expand buff
    	    return UALLOC_FAILED;
    if (Pplh->ULHlen==Plen)                                        //~v511I~
    {                                                              //~v511I~
    	if (!memcmp(Pplh->ULHdata,Ppdata,(UINT)Plen)               //~v511I~
    	&&  !memcmp(Pplh->ULHdbcs,Ppdbcs,(UINT)Plen))              //~v511I~
        	return 0;                                              //~v511I~
    }                                                              //~v511I~
    if (undoupdate(Ppcw,Pplh,UUHTREP)==UALLOC_FAILED)    //prepare undo and update process
    	return UALLOC_FAILED;
    memcpy(Pplh->ULHdata,Ppdata,(UINT)Plen);
    memcpy(Pplh->ULHdbcs,Ppdbcs,(UINT)Plen);
    Pplh->ULHlen=Plen;
    return 0;
}//fcmdlineupdate
#endif //not DOSDOS
//#ifdef W32                                                       //~v64vR~
#if defined(W32)||defined(LNX)                                     //~v64vI~
//**************************************************************** //~v564I~
// sort on optional label range                                    //~v564I~
//*rc   :0                                                         //~v564I~
//**************************************************************** //~v564I~
int func_openwith(PUCLIENTWE Ppcw)                                 //~v564I~
{                                                                  //~v564I~
	char *pc;                                                      //~v564I~
	char *pc2;                                                     //~v652I~
    int rc;                                                        //~v564I~
    char fpath[_MAX_PATH];                                         //~v564I~
//*********************************                                //~v564I~
	if (!(pc=Ppcw->UCWparm))		//operand                      //~v564I~
    {                                                              //~v564I~
        uerrmsg("ASS filename",0);                                 //~v564R~
        return 0;                                                  //~v564I~
    }                                                              //~v564I~
    pc2=                                                           //~v652I~
    dcmdfullpath(Ppcw,fpath,pc);                                   //~v564I~
    if (!pc2)                                                      //~v652I~
    {                                                              //~v652I~
    	uerrmsg("%s is invalid(remote is not supported)",0,        //~v652I~
				pc);                                               //~v652I~
    	return 4;                                                  //~v652I~
    }                                                              //~v652I~
    rc=dlcmdopenwithsub(Ppcw,fpath);                               //~v564R~
    if (!rc)                                                       //~v564I~
    	uerrmsg("Associate command accepted for %s",0,             //~v564R~
				pc);                                               //~v564I~
    return rc;                                                     //~v564I~
}//func_openwith                                                   //~v564I~
#endif                                                             //~v564I~
