//CID://+v72nR~:                                      Update#=  345//~v72nR~
//*************************************************************
//*xefile12.c*                                                     //~v0baR~
//**save,renum                                                     //~v0duR~
//*************************************************************
//v72n:061127 3270:spf cmd to update spf info                      //~v72nI~
//v71Z:061114 v71Y miss set version number in the following case   //~v71ZI~
//            for SPF err file opened by en,update then "renum force" because SPFNUMOK set by renum at undo.//~v71ZI~
//v71Y:061113 keep spf version number over renum force;(currently reset all renumed if spferr at loadtime)//~v71YI~
//v71R:061111 3270:check after save by reloading and keep result in workdir if save fail//~v71RI~
//v71M:061106 (3270:BUG)msg "file updated from at downloaded tim" is issuend because ind$FILE cut traling space.//~v71MI~
//v71h:061014 (BUG)ABEND when save by pcd==0;to be checked not upundoctr but upctr//~v71hI~
//v719:061004 dirlist DSN list support                             //~v719I~
//v716:060926 3270:"listds" cmd to chk file exist/dsorg            //~v716I~
//v710:060916 (BUG)tmp file remains in xeftpwd by save cmd with remotefile operand.//~v710I~
//v70k:060803 for safety tab chk at save if ULHdbcs gotten(tab may rep to space)//~v70kI~
//v70c:060731 (WXEXXE:BUG)cb is not written by the reason of file updated from read time by the other process. and alloc area not freed at termination.//~v70cI~
//v656:050726 (XXE)xxe support;WXP cmd                             //~v656I~
//v630:050426 grep support  as dos cmd(for edit screen flag line and search by rfind for *L)//~v630I~
//v62n:050321 (BUG)ftpsave rc is ignored                           //~v62nI~
//v625:050309 vhex mode support for wxp **/***(line split no consideration)//~v625I~
//v624:050309 vhex mode support for xpr **/***(line split consideration)//~v624I~
//v623:050309 (BUG)xpr *** lineno size should be refrect current size for gauge line//~v623I~
//v61x:050308 xprint for binfile(rep to "." from crlf etc ctlchar) //~v61xI~
//v61w:050308 xprint on vhex mode                                  //~v61wI~
//v61g:050226 diffrrent errmsg for cobnum fld err                  //~v61gI~
//v60u:050201 xpr cmd;add -tabon option to write tab display char(default istaboff)//~v60uI~
//v60f:050123 (UNX:BUG)rc clear missing after copy success after rename fail by filesystem diffresnnt//~v60fR~
//v57P:040620 cre/rep/app change deault to ALL when with labal range parm//~v57PI~
//v57N:040619 (FTP:BUG)partial edit fail(rename fail because file system diffence)//~v57NI~
//v57M:040619 (FTP:BUG)partial edit cut 2nd part                   //~v57MI~
//v57K:040619 (FTP:BUG)append cmd dose not append but copy only    //~v57KI~
//v576:040513 (FTP:BUG)if u edit same filename except case,        //~v576I~
//            another file name is  save back to remote.so use tempdir//~v576I~
//v574:040509 (FTP:BUG)remote new file save fail by not found      //~v574I~
//v54Y:040201 "cre/rep/sav/app" support xall nxall .a .b           //~v54YI~
//v54U:040125 move updatechk sub to xefsub(used by OS/2 DOS)       //~v54UI~
//v54p:040106 (FTP)uftpisremote interface changed                  //~v54pI~
//v54d:040103 split xefile.c to xefile.c xefile14.c                //~v54dI~
//v546:040101 (FTP:BUG)partial file edit fail                      //~v546I~
//v543:031230 timestamp update chk before save                     //~v543I~
//v53U:031109 (WIN,UNX)ftp support                                 //~v53UI~
//v53g:030923 (BUG)for xprint **;lineno shift like as screen       //~v53gI~
//v53e:030923 (BUG)for xprint **;lineno may changed lineno to hex offset//~v53eI~
//            after once displayed(plhlineno is set previous fmt)  //~v53eI~
//v53d:030923 option seti/setr without renum                       //~v53dI~
//v50t:030112 (BUG)mac eolid=4 but eollen=1,offset calc miss       //~v50tI~
//v506:021019 add "set" option for renum cmd;set num fld on specified colomn//~v506I~
//v48c:020429 (UNX)edit/browse mdos disk support                   //~v48cI~
//v47Y:020415 skip eol chnge write after save cmd with eol option  //~v47YI~
//v47X:020413 mac file support(eol=0x0d) /Mm                       //~v47XI~
//v47T:020406 eol-id change option for cre/rep/app/sav/end cmd     //~v47TI~
//v47L:020330 do save of not updated file if eol-id chnge specified//~v47LI~
//v47A:020321 renum and num clear for cobk                         //~v47AI~
//v47v:020316 COBK w/o N is not spf(allow any char in col.1-6;any lrecl)//~v45vI~
//            for cobk,set cid pos default=col73 if cid is not defined(other than //,;;,||)//~v45vI~
//            COBK with N is spf but col1-6 is ant value           //~v45vI~
//v45x:011219 integrate "num cutoff" cmd to "split" cmd            //~v45uI~
//            (move filecutoff to fcmd4)                           //~v45uI~
//v45u:011216 num cutoff cmd to split continued line               //~v45uI~
//v44i:011204 (BUG of v42x)remain "cob2" on errmsg                 //~v44iI~
//v445:011201 binary file support for xprint **/***                //~v445I~
//v436:011018 (BUG)copy data cut when contain tab and not once displayed//~v436I~
//v430:011010 (BUG)invalid lrecl not reset when cob has no num(col1,col73)//~v430I~
//v42v:011009 option to allow cob num fld is all space             //~v42vI~
//v42u:011009 clear the num fld;spf=col73,cob=col1,cobn=col1+col73 //~v42uI~
//v42t:011009 keep COB status over num clear                       //~v42uR~
//v42s:011009 NOAUTONUM status should not be changed by num clear cmd.//~v42sR~
//v42r:011009 (BUG)num clear ignored at save                       //~v42rI~
//v42i:011002 set spfnum at save for suffix overflow line to avoid line update flag(*u search)//~v42iI~
//v425:010922 (BUG)col 72 cleared by renum twice for cob w/o num.  //~v425I~
//v422:010918 (BUG)spf long record written after topline cid err at save is corrected//~v422I~
//            This is by v413                                      //~v422I~
//            For topline deleted case,keep previous margin/spfpos value//~v422I~
//v420:010918 cob fld num clear option;num clear cob               //~v420I~
//v416:010728 accept clear for without col72 num fld case          //~v416I~
//v413:010728 (BUG)when cid topline is erased for spf file,filegetcid call//~v413I~
//            at filesave destroy spflen;write max length record   //~v413I~
//v412:010728 (BUG)col-72 renumed for cob witout n option          //~v412I~
//v40W:010722 set spfnum(cob) after isrt topline cid(cob)          //~v40WI~
//v40U:010722 cobol support:allow col-72-80 is all space for cobol input//~v40UI~
//v40T:010722 (BUG)cob num fld is not renumed when fld erased but num is same as prev//~v40TI~
//v40S:010722 (BUG)offset change cause renum(bug of logic by xlineno display)//~v40SI~
//v40F:010709 COB support:num clear(clear col72-80)                //~v40FI~
//v40E:010709 COB support:renum                                    //~v40ER~
//v40o:010603 print lcmd when **/***(scr print)                    //~v40oI~
//v40k:010526 screen current print("***")                          //~v40kR~
//v40h:010526 xprint **;like as print screen                       //~v40hI~
//v20P:001111 allow topline upctr init value when no line at load time//~v20PI~
//v20v:001022 option to tab clear when file output                 //~v20vI~
//v17g:000507 (BUG)fclose abend when pf4 after partile file update.//~v17gI~
//v178:000430 renum support for lineno hex mode                    //~v178I~
//v13j:991029 (BUG)It should not be end when close err by disk space shortage.//~v13jI~
//            chk also close err(flush err) at save then notify and wait.//~v13jI~
//v11t:990813 rename target wild card support                      //~v11tI~
//v10Y:990606 support input range by hex offset value(/NXxxx-Xxxx) for edit/browsw cmd//~v10YI~
//            (lineno is couted from 1 even if offset!=0)          //~v10YI~
//v10A:990411 (BUG)splitupctr clear miss.following aplit is trated as all updated//~v10AI~
//v10z:990411 (BUG)pos of cid for split last line is too far.      //~v10zI~
//            it should consider prev split continued line length. //~v10zI~
//            (But probrem remain in the case cid is spritted or on prev line,//~v10zI~
//            new cid dose not replace but added.)                 //~v10zI~
//v108:981213 binary mode extit(no crlf process)                   //~v108I~
//v104:981212 no csr move when renum                               //~v104I~
//v103:981212 (BUG)for binaly file edit,last 0d0a is added         //~v103I~
//            0d0a is added at end of file eveif input has no 0d0a //~v103I~
//            skip add only when thatline is at end of file,if moved to other//~v103I~
//            position,\d0a is added.                              //~v103I~
//v102:981212 (BUG)for binaly file edit,redunt byte write occur.   //~v102I~
//            For the case tab containing line is over 999,last char is doubly written//~v102I~
//v0im:980625 pfk cmd support(optk1 and optk2)                     //~v0imI~
//v0if:980620 pfk cmd support(fmt chk and update c.b)              //~v0ifI~
//v0ib:980530 v0i9 cotinued for other than file copy               //~v0ibI~
//v0ia:980530 add APPend cmd                                       //~v0iaI~
//v@@@:980227 test trap for tab clear-->del                        //~v@@@R~
//v0fq:971109 new file by select cmd has alias but it is temporary name//~v0fqI~
//            it may duplicated alias name.                        //~v0fqI~
//            dont created new pdh if new,isrt at end file if new file.//~v0fqI~
//v0fm:971103 new function to set filename and alias to ufh        //~v0fmI~
//v0eL:970927 (BUG)renum for spf need boundar dbcs/tab             //~v0eLI~
//v0e8:970915 (BUG)need expand before valid spf line chk           //~v0e7I~
//v0e7:970915 (BUG)need chk also valid spfnum for renum.           //~v0e7I~
//v0du:970909 for performance,use flag once chked spfnumok         //~v0duI~
//            set on when chked,reset when line update or insert.  //~v0duI~
//v0cz:970818 null cid //+NONE~R                                   //~v0czI~
//v0cw:970818 drop tab(change to space) at write for spf file      //~v0cwI~
//v0ct:970814 RENUM(NUM reset) Force option for spf file           //~v0ctI~
//v0cq:970814 display version number at time of load,+1 at save.   //~v0cqI~
//v0co:970813 undo set ver even if pfh set only case               //~v0coI~
//v0cn:970813 RENUM undo support(move filerenum from xefile to xefile12)//~v0cnI~
//v0cm:970812 NUM VER subcmd(reset spf version)                    //~v0cmI~
//            use ULF2CIDCLEAR for also version update only        //~v0cmI~
//v0cl:970811 spf NUM field support                                //~v0clI~
//v0ba:970726 split xefile,xefile12(save)                          //~v0baI~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifdef DOS
    #ifdef DPMI					//DPMI version                     //~v095I~
        #include <errno.h>                                         //~v095I~
    #else                       //not DPMI                         //~v095I~
    #endif                      //DPMI or not                      //~v095I~
#else
//  #define INCL_BASE                                              //~v07sR~
//  #include <os2.h>                                               //~v07sR~
#endif
//*******************************************************
#include <ulib.h>
#include <ualloc.h>
#include <uerr.h>
#include <uque.h>
#include <ufile.h>                                              //~5318I~
#include <ufile2.h>
#include <ufile3.h>                                                //~v57NI~
#include <uparse.h>                                                //~v0b2R~
#include <uedit.h>                                                 //~v0clI~
#include <ustring.h>                                               //~v40FI~
#include <uftp.h>                                                  //~v54pI~
                                                                //~5318I~
#include "xe.h"
#include "xescr.h"
#include "xescr2.h"                                                //~v53UI~
#include "xefile.h"
#include "xefile12.h"                                              //~v0clI~
#include "xefile14.h"                                              //~v54dI~
#include "xefile2.h"                                               //~v40hI~
#include "xefile22.h"                                              //~v445I~
#include "xefile4.h"                                            //~4C23R~
#include "xefile5.h"                                               //~v08qI~
#include "xefile6.h"                                               //~v0e7I~
#include "xefile7.h"    //filefksave                               //~v0ifI~
#include "xedir.h"    //filefksave                                 //~v716I~
#include "xefcmd.h"                                                //~v0iaI~
#include "xefsub.h"                                             //~5318I~
#include "xesub.h"                                              //~5318I~
#include "xeundo.h"                                                //~v0clI~
#include "xeopt.h"                                                 //~v506I~
#ifdef FTPSUPP                                                     //~v53UI~
	#include "xeftp.h"                                             //~v53UR~
	#include "xetso.h"                                             //~v716I~
#endif                                                             //~v53UI~
//*******************************************************
void filespfseqerr(void);                                          //~v0clR~
void filespfvermaxerr(int Pver,int Plimit);                        //~v0clR~
int filenotspferr(void);                                           //~v0clI~
int filespfvererr(void);                                           //~v0clI~
int filespfver(int Pver);                                          //~v0clI~
int filespfneedforce(void);                                        //~v0ctI~
void filespfnumerr(void);                                          //~v0ctI~
void filespferrnotspace(void);                                     //~v42vI~
void filespflenerr(int Plen);                                      //~v0ctI~
int filecloseerr(PUFILEH Ppfh);                                    //~v13jI~
int filepartialouterr(void);                                       //~v13jI~
void filespfcobnumerr(void);                                       //~v61gI~
//**************************************************************** //~v0ibI~
//****************************************************************
// filesave
//*write file                                                   //~v020R~
//*parm1:option end(1) or save(0) or append cmd(3)                 //~v0iaR~
//*      0x10 :bandle used for rep/cre                             //~v0ibI~
//*parm2:file hdr                                               //~5128I~
//*parm3:plh write start                                        //~5128I~
//*parm4:plh write end(or PUCLIENTWE when screen page print)       //~v40kR~
//*parm5:output filename(fullpath)                              //~5128R~
//*rc   :0-ok 4:file load err
//****************************************************************
//int filesave(int Pendsw,PUFILEH Ppfh,PULINEH Pplh1,PULINEH Pplh2,UCHAR *Poutfile)//~v445R~
int filesave(PUCLIENTWE Ppcw,int Pendsw,PUFILEH Ppfh,PULINEH Pplh1,PULINEH Pplh2,UCHAR *Poutfile)//~v445I~
{
	UFILEH  ufhout;                                                //~v08qR~
	PUFILEC pfc;                                                   //~v61wI~
//  PUCLIENTWE scrpcw;	//for prt screen case only                 //~v445R~
	int     rc,len,wlen,cidexplen;                              //~5130R~
	UCHAR   *pcf,*pct,*pcw,*pcd;                                //~5102R~
	LONG    lineno=0;
	LONG    sline,eline;                                           //~v08qI~
	PULINEH plh;
	PUFILEH pfh;                                                //~5128I~
	UCHAR   *cid;
	FILEFINDBUF3 fstat3;     				//output from DosFindxxxx//~v020I~
    int partialsw,procctr;                                         //~v08qR~
    int writebinsw,wpcsw;                                          //~v0abR~
    int wmacsw;                                                    //~v47XI~
    int splitupctr=0,splitupctrlast,swfollow;                      //~v0b9I~
    int spfsw;                                                     //~v0cwI~
    int spflen;                                                    //~v0czI~
    int appendsw;                                                  //~v0iaI~
    int bandlesw;                                                  //~v0ibI~
    int prtscrsw,prtpagesw,maxline,wrtline=0;                      //~v40kR~
    int prttabsw;                                                  //~v60uI~
    int noeolsw;		//skip eol write                           //~v103I~
    int binfsw,hexbinsw;         //binfilesw                       //~v445R~
    int splittotlen=0;  //len up to previous                       //~v10AR~
    int xrangeswe=0;                                               //~v10YI~
    FILE *fhreopen;                                                //~v13jI~
    int droptabsw;                                                 //~v20vI~
//  int linenosz;                                                  //~v625R~
    int linenoszw;	//write len                                    //~v53gI~
    int saveopt=0;                                                 //~v47TI~
    int newsavesw;                                                 //~v546R~
    int ffmsgopt;                                                  //~v574I~
    int  xallsw,nxallsw;                                           //~v54YI~
    char *eolchngid=0;                                             //~v47LR~
//  char wklineno[ULHLINENOSZ+1];                                  //~v624R~
    char wklineno[ULHLINENOSZ+2];                                  //~v624I~
    char *pelocalfnm;                                              //~v546I~
    char *poutfnm;                                                 //~v574I~
    int rc2;                                                       //~v716I~
#ifdef FTPSUPP                                                     //~v57KI~
    int  appendremotesw;                                           //~v57KI~
#endif                                                             //~v57KI~
    int vhexmodesw;                                                //~v61wR~
    int vhexlineidsw;                                              //~v625I~
//#ifdef WXE                                                       //~v656R~
#ifdef WXEXXE                                                      //~v656I~
    int wxpcmdsw;                                                  //~v625R~
#endif                                                             //~v625R~
    int setfstatsw;                                                //~v719I~
//****************************
	pfc=Ppcw->UCWpfc;                                              //~v61wI~
    bandlesw=(Pendsw & FSENDSW_BANDLE); //chk bandle used          //~v0ibI~
    Pendsw &= ~FSENDSW_BANDLE;          //chked no more use        //~v0ibI~
    prtscrsw=(Pendsw & FSENDSW_PRTSCR); //chk print screen req     //~v40hI~
    Pendsw &= ~FSENDSW_PRTSCR;          //chked no more use        //~v40hI~
    prtpagesw=(Pendsw & FSENDSW_PRTPAGE); //chk print screen req   //~v40kI~
    Pendsw &= ~FSENDSW_PRTPAGE;          //chked no more use       //~v40kI~
    prttabsw=(Pendsw & FSENDSW_PRTTAB); //chk print tab display char req//~v60uI~
    Pendsw &= ~FSENDSW_PRTTAB;          //chked no more use        //~v60uI~
//  vhexmodesw=UCBITCHK(pfc->UFCflag2,UFCF2VHEX);                  //~v624R~
    vhexmodesw=UCBITCHK(pfc->UFCflag2,UFCF2VHEX)!=0;	//1 or 0   //~v624I~
    vhexlineidsw=vhexmodesw;                                       //~v625I~
//#ifdef WXE                                                       //~v656R~
#ifdef WXEXXE                                                      //~v656I~
    wxpcmdsw=(Pendsw & FSENDSW_WXP); //chk print tab display char req//~v625M~
    Pendsw &= ~FSENDSW_WXP;          //chked no more use           //~v625M~
    if (wxpcmdsw)                                                  //~v625I~
    	vhexlineidsw=0;				//no set lineid at top of line //~v625I~
#endif                                                             //~v625M~
    if (prtpagesw)                                                 //~v40kI~
    {                                                              //~v40kI~
//  	scrpcw=(PUCLIENTWE)(ULONG)Pplh2;                           //~v445R~
//      maxline=scrpcw->UCWheight-scrpcw->UCWfilehdrlineno;        //~v445R~
        maxline=Ppcw->UCWheight-Ppcw->UCWfilehdrlineno;            //~v445I~
//      Pplh2=0;                                                   //~v445R~
    	xallsw=0;                                                  //~v54YI~
    	nxallsw=0;                                                 //~v54YI~
    }                                                              //~v40kI~
    else                                                           //~v47TI~
    {                                                              //~v54YI~
//  	filesaveoptionchk(Ppcw,Ppfh,&saveopt,0);                   //~v54YR~
    	filesaveoptionchk(Ppcw,Ppfh,&saveopt,0,0,0);               //~v54YI~
    	xallsw=(saveopt & FSOC_XALL); //write excluded all line    //~v54YI~
    	nxallsw=(saveopt & FSOC_NXALL); //write excluded all line  //~v54YI~
    }                                                              //~v54YI~
                                                                   //~v08qI~
    if (Pplh1)  //repl or create                                   //~v08qI~
        partialsw=sline=eline=0;  //do not partial file copy       //~v08qR~
    else                                                           //~v08qI~
    {                                                              //~v08qI~
        sline=Ppfh->UFHsline;                                      //~v08qR~
    	eline=Ppfh->UFHeline;                                      //~v08qR~
        partialsw=(sline || eline);                                //~v08qR~
        if (UCBITCHK(Ppfh->UFHflag4,UFHF4XRANGE))   //it may be xrange parm//~v10YR~
        {                                                          //~v10YI~
        	partialsw=1;                                           //~v10YI~
            xrangeswe=Ppfh->UFHelinepos;	//write after end offset//~v10YI~
        }                                                          //~v10YI~
    }                                                              //~v08qI~
	if (Poutfile)		//save to same file                     //~5128I~
	{                                                           //~5128I~
		memcpy(&ufhout,Ppfh,UFILEHSZ);                             //~v08qR~
//  	strcpy(ufhout.UFHfilename,Poutfile);                       //~v0fmR~
        ufilesetfhfilename(&ufhout,Poutfile);                      //~v0fmI~
		pfh=&ufhout;                                               //~v08qR~
	    pfh->UFHpathlen=(UCHAR)getpathlen(pfh->UFHfilename,    //get path len//~v03yR~
								&pfh->UFHlevel,		//dir level //~v03yI~
                              	0);//dir sw                     //~v03yI~
	}                                                           //~5128I~
	else				//save to same file                     //~5128I~
	{                                                           //~5128I~
		pfh=Ppfh;                                               //~5128I~
		if (pfh->UFHupctr==pfh->UFHupctrsave)	//same as saved //~5128R~
		{                                                       //~5128R~
//        if (saveopt & (FSOC_EOL_PC|FSOC_EOL_UNIX))               //~v47XR~
          if (saveopt & (FSOC_EOL_PC|FSOC_EOL_UNIX|FSOC_EOL_MAC))  //~v47XI~
          {                                                        //~v47TI~
          	if (saveopt & FSOC_EOL_MAC)                            //~v47XI~
            	eolchngid="Mac file";                              //~v47XI~
            else                                                   //~v47XI~
          	if (saveopt & FSOC_EOL_PC)                             //~v47TI~
            	eolchngid="PC file";                               //~v47TI~
            else                                                   //~v47TI~
            	eolchngid="Unix file";                             //~v47TI~
            UCBITOFF(pfh->UFHflag6,UFHF6EOLCHNG);//skip eol chng write at save//~v47YI~
          }                                                        //~v47TI~
          else                                                     //~v47LI~
          if (!pfh->UFHupctr && UCBITCHK(pfh->UFHflag6,UFHF6EOLCHNG))////~v47LR~
          {                                                        //~v47LI~
            if (UCBITCHK(pfh->UFHflag6,UFHF6WTEXTMAC))             //~v47XI~
            	eolchngid="Mac file";                              //~v47XI~
            else                                                   //~v47XI~
            if (UCBITCHK(pfh->UFHflag3,UFHF3WTEXTPC))              //~v47LR~
            	eolchngid="PC file";                               //~v47LR~
            else                                                   //~v47LI~
            	eolchngid="Unix file";                             //~v47LR~
          }                                                        //~v47LI~
          else                                                     //~v47TI~
		  {					//not (noupdate and eol chnge req by edit parm)//~v47LI~
			uerrmsg("%s is not Updated",                        //~5128R~
					"%s ͖XV",                              //~5128R~
					pfh->UFHfilename);                          //~5128R~
			return 0;                                           //~5128R~
          }                                                        //~v47LI~
   		 }                                                      //~5128R~
       if (!UCBITCHK(pfh->UFHflag8,UFHF8NOUPDCHK))//force save (::cb at term)//~v70cR~
       {                                                           //~v70cI~
         if (!scrconfirmchk(GSCRCONFSAVE))   //not yet confirmed   //~v543R~
//          if (xeftpsave(XEFTPSO_UPDATECHKONLY,Ppcw,pfh))//updated//~v54UR~
//          if (xefsubupdatechk(Ppcw,pfh))//updated                //~v716R~
            if (rc2=xefsubupdatechk(Ppcw,pfh),rc2)//updated        //~v716I~
            {                                                      //~v543R~
              UCBITON(pfh->UFHflag,UFHFWRITEERR); //dont delete at closefree to manual chk later//~v71RR~
              if (rc2>0)	//not tso err                          //~v716I~
                uerrmsg("File is updated after load,Use same key to force save,or Esc to cancel",//~v543R~
                        "t@CǂݍݎύXĂ܂Bs鎞͍ē,EscŎ");//~v543R~
                return 8;                                          //~v543R~
            }                                                      //~v543R~
        }                                                          //~v70cI~
    	if (partialsw)                                             //~v08qM~
        {                                                          //~v08qM~
			memcpy(&ufhout,Ppfh,UFILEHSZ);                         //~v08qM~
        	filetempname(&ufhout);                                 //~v08qM~
            UCBITOFF(ufhout.UFHflag6,UFHF6REMOTE);//for filetempname,but should be off for filereopen//~v57MI~
			pfh=&ufhout;	//write to temp file                   //~v08qI~
		}                                                          //~v08qM~
		if (pfh->UFHtype==UFHTKFI)	//ke func ini file             //~v0ifR~
        {                                                          //~v0imR~
        	if (rc=filefksave(pfh),rc)                             //~v0ifR~
            	return rc;                                         //~v0ifI~
    		UCBITON(pfh->UFHflag,UFHFUPCTRREQ);	//next time updatectr up//~v0imR~
    		pfh->UFHupctrsave=pfh->UFHupctr;		//upctr when saved//~v0imR~
            return 0;                                              //~v0imR~
        }                                                          //~v0imR~
#ifdef FTPSUPP                                                     //~v53UI~
        else                                                       //~v53UI~
		if (pfh->UFHtype==UFHTHOSTS)	//ftp hosts file           //~v53UI~
        {                                                          //~v53UI~
        	if (rc=xeftphostsget(Ppcw,pfh),rc)                     //~v53UR~
            	return rc;                                         //~v53UI~
        }                                                          //~v53UI~
#endif                                                             //~v53UI~
	}                                                           //~5128I~
	UCBITON(pfh->UFHflag,UFHFUPCTRREQ);	//next time updatectr up//~5128R~
                                                                   //~v0avI~
	if (!Poutfile)		//save to same file                        //~v20PI~
    	UCBITON(pfh->UFHflag5,UFHF5TLUCTR);	//request id to filetoplineuctr//~v20PR~
//  spfsw=UCBITCHK(pfh->UFHflag2,UFHF2SPFNUMOK);                   //~v422R~
//  spflen=pfh->UFHlrecl;                                          //~v422R~
    if (filegetcid(pfh,2,0,&cid))//chk hdr line if sline==0,if err //~v0avM~
    {                                                              //~v20PI~
	    UCBITOFF(pfh->UFHflag5,UFHF5TLUCTR);	//request id to filetoplineuctr//~v20PI~
    	return 4;				//topline cid header err           //~v0avM~
    }                                                              //~v20PI~
    UCBITOFF(pfh->UFHflag5,UFHF5TLUCTR);	//request id to filetoplineuctr//~v20PI~
                                                                   //~v0avI~
    writebinsw=(UCBITCHK(pfh->UFHflag3,UFHF3WBIN)!=0)*FILE_OPEN_BIN;//~v0abI~
    wpcsw=(UCBITCHK(pfh->UFHflag3,UFHF3WBIN|UFHF3WTEXTPC)          //~v47TR~
    		==(UFHF3WBIN|UFHF3WTEXTPC));//write pc eol by bin mode //~v47TR~
    wmacsw=UCBITCHK(pfh->UFHflag3,UFHF3WBIN)                       //~v47XI~
           &&UCBITCHK(pfh->UFHflag6,UFHF6WTEXTMAC);	//mac eol write//~v47XR~
    if (saveopt & FSOC_EOL_PC)                                     //~v47TI~
    {                                                              //~v47XI~
    	wmacsw=0;                                                  //~v47XI~
        wpcsw=1;                                                   //~v47TI~
    }                                                              //~v47XI~
    if (saveopt & FSOC_EOL_MAC)                                    //~v47XI~
    {                                                              //~v47XI~
        wmacsw=1;                                                  //~v47XI~
        wpcsw=0;                                                   //~v47XI~
    }                                                              //~v47XI~
    if (saveopt & FSOC_EOL_UNIX)                                   //~v47TI~
    {                                                              //~v47XI~
    	wmacsw=0;                                                  //~v47XI~
        wpcsw=0;                                                   //~v47TI~
    }                                                              //~v47XI~
    spfsw=UCBITCHK(pfh->UFHflag2,UFHF2SPFNUMOK);                   //~v422R~
    spflen=pfh->UFHlrecl;                                          //~v422R~
  if (partialsw)                                                   //~v08qI~
  {                                                                //~v13jI~
  	rc=filepartialcopy(0,Ppfh,pfh);                                //~v08qI~
  			//open Ppfh="rb",pfh="wb",copy then reopen pfh="w+"    //~v08qI~
    if (rc)                                                        //~v13jI~
    	filepartialouterr();                                       //~v13jI~
  }                                                                //~v13jI~
  else                                                             //~v08qI~
	if (Poutfile || UCBITCHK(pfh->UFHflag,UFHFNEW))                //~v08qR~
    {                                                              //~v0iaI~
//  	rc=filefindopen(pfh->UFHfilename,&fstat3,-1,&pfh->UFHhfile,FFMSG);//"w" open//~v0abR~
//  	rc=filefindopen(pfh->UFHfilename,&fstat3,writebinsw+FILE_OPEN_OUT,&pfh->UFHhfile,FFMSG);//"w" open//~v0iaR~
        appendsw=FILE_OPEN_APPEND*(Pendsw==FCMDFOAPP);             //~v0iaI~
    	ffmsgopt=FFNONFMSG;	//no notfound msgrequired              //~v574R~
        poutfnm=pfh->UFHfilename;                                  //~v574I~
#ifdef  FTPSUPP                                                    //~v574I~
        appendremotesw=appendsw;                                   //~v57KI~
	    if (FILEISREMOTE(pfh))//remote output by rep/cre/save      //~v574I~
        {                                                          //~v57KI~
        	poutfnm=pfh->UFHftpwdfnm;	//output open temp file    //~v574I~
            appendsw=0; //write to local temp                      //~v57KI~
        }                                                          //~v57KI~
#endif                                                             //~v574I~
#ifdef UNX                                                         //~v48cI~
//  	rc=filefindopen(pfh->UFHfilename,&fstat3,appendsw+writebinsw+FILE_OPEN_OUT,&pfh->UFHhfile,FFMSG,pfh->UFHalias);//"w" open//~v574R~
//  	rc=filefindopen(poutfnm,&fstat3,appendsw+writebinsw+FILE_OPEN_OUT,&pfh->UFHhfile,ffmsgopt,pfh->UFHalias);//"w" open//~v576R~
    	rc=filefindopen(poutfnm,&fstat3,appendsw+writebinsw+FILE_OPEN_OUT,&pfh->UFHhfile,ffmsgopt,pfh->UFHalias,0);//"w" open//~v576I~
#else                                                              //~v48cI~
//  	rc=filefindopen(pfh->UFHfilename,&fstat3,appendsw+writebinsw+FILE_OPEN_OUT,&pfh->UFHhfile,FFMSG);//"w" open//~v574R~
  #ifdef  FTPSUPP                                                  //~v576I~
    	rc=filefindopen(poutfnm,&fstat3,appendsw+writebinsw+FILE_OPEN_OUT,&pfh->UFHhfile,ffmsgopt,0);//"w" open,local file open for remote//~v576I~
  #else                                                            //~v576I~
    	rc=filefindopen(poutfnm,&fstat3,appendsw+writebinsw+FILE_OPEN_OUT,&pfh->UFHhfile,ffmsgopt);//"w" open//~v574I~
  #endif                                                           //~v576I~
#endif                                                             //~v48cI~
    }                                                              //~v0iaI~
	else
      if (writebinsw)                                              //~v0abI~
		rc=!filereopen(pfh,"wb");		//once close,reopen bin mode write//~v0abI~
      else                                                         //~v0abI~
		rc=!filereopen(pfh,"w");		//once close            //~5128R~
	if (rc)					//once close 
	{
  		UCBITON(pfh->UFHflag,UFHFWRITEERR);	//flag err          //~5128R~
		return 4;
	}
                                                                   //~v08qI~
  	UCBITOFF(pfh->UFHflag,UFHFWRITEERR);	//reset flag err    //~v03yI~
	if (sline)	//first  half copy to temp or other file           //~v08qI~
    	lineno=sline-1;	//for ULHlinenow                           //~v08qI~
//  if (pfh->UFHsline) //first line not loaded                     //~v09rR~
//  	cid=filegetcid(pfh,1);	//do not chk first line            //~v09rR~
//  else                                                           //~v09rR~
//  cid=filegetcid(pfh,0);	//get changeid when close,chk first line//~v09rR~
//  cid=filegetcid(pfh,2,0);	//chk hdr line if sline==0         //~v0avR~
	if (!(plh=Pplh1))	//full write                            //~5128I~
		plh=UGETQTOP(&pfh->UFHlineque);		//top entry         //~5128R~
    binfsw=                                                        //~v445I~
    noeolsw=UCBITCHK(pfh->UFHflag4,UFHF4BIN);	//bynary mode      //~v108I~
    hexbinsw=UCBITCHK(pfh->UFHflag5,UFHF5HEX);	//bynary mode with hex display//~v445R~
                                                                   //~v20vI~
	droptabsw=UCBITCHK(pfh->UFHflag5,UFHF5DROPTAB);//no tab clear at save//~v20vI~
//* save for print screen *****************************            //~v40kR~
    if (prtscrsw)	//screen print                                 //~v40hI~
    {                                                              //~v40hI~
//  	linenosz=ULHLINENOSZ;                                      //~v625R~
    	linenoszw=Ppcw->UCWlinenosz;                               //~v53gI~
        if (prtpagesw)                                             //~v445I~
        {                                                          //~v445I~
			if (Ppcw->UCWfilehdrlineno>FILEHDRLINENO)	//gauge required//~v445I~
            {                                                      //~v445I~
//          	if (vhexmodesw)                                    //~v625R~
            	if (vhexlineidsw)                                  //~v625I~
                	*Gfilebuff='*';	//id of not data line          //~v624I~
                len=80;                                            //~v445I~
//              len=filecolsprint(Ppcw,Gfilebuff,linenosz,len);    //~v623R~
//              len=filecolsprint(Ppcw,Gfilebuff,linenoszw,len);   //~v624R~
//              len=filecolsprint(Ppcw,Gfilebuff+vhexmodesw,linenoszw,len);//~v625R~
                len=filecolsprint(Ppcw,Gfilebuff+vhexlineidsw,linenoszw,len);//~v625I~
//          	if (rc=filewrite(pfh,Gfilebuff,(size_t)len),rc)    //~v624R~
//          	if (rc=filewrite(pfh,Gfilebuff,(size_t)(len+vhexmodesw)),rc)//~v625R~
            	if (rc=filewrite(pfh,Gfilebuff,(size_t)(len+vhexlineidsw)),rc)//~v625I~
            		return rc;                                     //~v445I~
            }                                                      //~v445I~
        }                                                          //~v445I~
        for (;plh;plh=UGETQNEXT(plh))                              //~v40kR~
        {                                                          //~v40hI~
        	if (prtpagesw)                                         //~v40kI~
            	if (wrtline>=maxline)                              //~v40kI~
                	break;                                         //~v40kI~
            if (plh->ULHtype==ULHTDATA) //file data                //~v40hI~
            {                                                      //~v40hI~
                if (!plh->ULHdbcs) //not displayed                 //~v40hI~
                    if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v40hI~
                        return UALLOC_FAILED;                      //~v40hI~
    	        len=plh->ULHlen;                                   //~v40hI~
                len=min(len,GFILEBUFFSZ*2);                        //~v445I~
                memcpy(Gfilebuff,plh->ULHdata,(UINT)len);          //~v445R~
              if (binfsw)	//binfile printscr                     //~v61xI~
                tabdisplayforxpr(Gfilebuff,plh->ULHdbcs,len);//rep ctl-char to "."//~v61xI~
              else                                                 //~v61xI~
              if (prttabsw)     //write tab display char           //~v60uI~
                tabdisplay(Gfilebuff,plh->ULHdbcs,len,binfsw);     //~v445I~
		        pcf=Gfilebuff;                                     //~v445I~
            }                                                      //~v40hI~
            else                                                   //~v40hI~
            {                                                      //~v445I~
    	        len=80;                                            //~v40hI~
		        pcf=plh->ULHdata;                                  //~v445I~
            }                                                      //~v445I~
            if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))             //~v40kI~
            	continue;                                          //~v40kI~
//          if (*plh->ULHlineno)                                   //~v53eR~
//          {                                                      //~v53eR~
//          	memcpy(wklineno,plh->ULHlineno,(UINT)linenosz);    //~v53eR~
//  			if (UCBITCHK(plh->ULHflag,ULHFLINECMD))//line cmd input//~v53gR~
//              {                                                  //~v53gR~
//  				memset(wklineno,' ',(UINT)(linenosz-1));       //~v53gR~
//  				memcpy(wklineno,plh->ULHlinecmd,strlen(plh->ULHlinecmd));//~v53gR~
//              }                                                  //~v53gR~
//          }                                                      //~v53eR~
//          else                                                   //~v53gR~
//  	    if (plh->ULHtype!=ULHTDATA)	//file data                //~v53gR~
//          	memcpy(wklineno,plh->ULHlineno,(UINT)linenosz);    //~v53gR~
//          else                                                   //~v53gR~
//          	fileinitialeditlineno(pfh,plh,wklineno);           //~v53eR~
//          	fileeditlineno(Ppcw,pfh,plh,wklineno);             //~v53gR~
//          	fileeditlineno(Ppcw,pfh,plh,wklineno,linenoszw,FELN_SHIFT|FELN_SETCMD);//~v624R~
//          if (vhexmodesw)                                        //~v625R~
            if (vhexlineidsw)                                      //~v625I~
            {                                                      //~v624I~
	            if (plh->ULHtype==ULHTDATA) //file data            //~v624I~
    	            *wklineno='0';	//id of data line              //~v624I~
                else                                               //~v624I~
    	            *wklineno='*';	//id of not data line          //~v624I~
            }                                                      //~v624I~
//          fileeditlineno(Ppcw,pfh,plh,wklineno+vhexmodesw,linenoszw,FELN_SHIFT|FELN_SETCMD);//~v625R~
            fileeditlineno(Ppcw,pfh,plh,wklineno+vhexlineidsw,linenoszw,FELN_SHIFT|FELN_SETCMD);//~v625I~
//          if (rc=filewrite(pfh,wklineno,(size_t)linenosz),rc)    //~v53gR~
//          if (rc=filewrite(pfh,wklineno,(size_t)linenoszw),rc)   //~v624R~
//          if (rc=filewrite(pfh,wklineno,(size_t)(linenoszw+vhexmodesw)),rc)//~v625R~
            if (rc=filewrite(pfh,wklineno,(size_t)(linenoszw+vhexlineidsw)),rc)//~v625I~
            	return rc;                                         //~v40hI~
//          pcf=plh->ULHdata;                                      //~v445R~
            if (hexbinsw && pcf==Gfilebuff)                        //~v445I~
				len=filehexprint(Ppcw,plh);                        //~v445R~
            if (rc=filewrite(pfh,pcf,(size_t)len),rc)              //~v40hI~
            	return rc;                                         //~v40hR~
            if (rc=filewrite(pfh,"\n",1),rc)                       //~v40hR~
                return rc;                                         //~v40hI~
            wrtline++;                                             //~v40kI~
            if (vhexmodesw                                         //~v61wR~
            &&  plh->ULHtype==ULHTDATA) //file data                //~v61wI~
            {                                                      //~v61wI~
//  			filevhexprint(Ppcw,pfh,plh,wklineno,linenoszw);    //~v624R~
//  			filevhexprint(Ppcw,pfh,plh,wklineno,linenoszw+vhexmodesw);//~v625R~
    			filevhexprint(Ppcw,pfh,plh,wklineno,linenoszw+vhexlineidsw);//~v625I~
	            wrtline+=2;                                        //~v61wI~
            }                                                      //~v61wI~
            if (Pplh2 && plh==Pplh2)    //partial write            //~v40hI~
                break;                                             //~v40hI~
		}//while plh                                               //~v40hI~
	}//prt scr                                                     //~v40hI~
	else                                                           //~v40hI~
//normal save ***************                                      //~v40hI~
	while(plh)								//all line
	{
		if (plh->ULHtype==ULHTDATA)	//file data
		{
		    if (xallsw) 	//write x line                         //~v54YR~
              if (nxallsw)                                         //~v57PI~
                	bandlesw=0;	//write                            //~v57PI~
              else                                                 //~v57PI~
				if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))         //~v54YI~
                	bandlesw=0;	//write                            //~v54YI~
                else                                               //~v54YI~
                	bandlesw=1;	//skip write                       //~v54YI~
            else                                                   //~v54YI~
            	if (nxallsw)                                       //~v54YR~
                {                                                  //~v54YI~
					if (UCBITCHK(plh->ULHflag2,ULHF2EXCLUDED))     //~v54YI~
    	            	bandlesw=1;	//skip write                   //~v54YI~
        	        else                                           //~v54YI~
            	    	bandlesw=0;	//write                        //~v54YI~
                }//nxallsw                                         //~v54YI~
          if (!bandlesw || UCBITCHK(plh->ULHflag4,ULHF4SELECTED))  //~v0ibI~
          {//not bandle used or selected at bandle use             //~v0ibI~
			++lineno;                                           //~5128R~
//  		if (!Poutfile)		//save to same file; update for grep//~v630R~
				plh->ULHlinenow=lineno;                         //~5128I~
//expand tab for not displayed line to drop tab                    //~v20vI~
//          if (droptabsw && !plh->ULHdbcs)	//not displayed        //~v436R~
            if (!plh->ULHdbcs)	//not displayed                    //~v436I~
              if (droptabsw || plh->ULHupctr) 	//updtaed          //~v436I~
        		if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v20vI~
            		return UALLOC_FAILED;                          //~v20vI~
		  	len=plh->ULHlen;
			pcf=plh->ULHdata;                                   //~5130I~
			pcd=plh->ULHdbcs;	//dbcs/tab tbl                  //~5130I~
			if (cid)                                            //~5130R~
			{                                                   //~5130I~
                if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT1|ULHF2SPLIT2))//~v0b9I~
                {                                                  //~v0b9I~
                    if (splitupctr<plh->ULHupctr)                  //~v0b9R~
	                    splitupctr=plh->ULHupctr;                  //~v0b9I~
	                if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT1))//continued//~v0b9I~
                    {                                              //~v10zI~
	                    swfollow=1;		//bypass setcid            //~v0b9I~
                        splittotlen+=len;   //len up to prev line  //~v10zI~
                    }                                              //~v10zI~
	                else                                           //~v0b9I~
                    {                                              //~v0b9I~
	                    swfollow=2;		//restore upctr            //~v0b9I~
	                    splitupctrlast=plh->ULHupctr;              //~v0b9I~
	                    plh->ULHupctr=splitupctr;	//newest;      //~v0b9I~
                    }                                              //~v0b9I~
                }                                                  //~v0b9I~
                else                                               //~v0b9I~
                {                                                  //~v0b9I~
                	splitupctr=0;                                  //~v0b9I~
                    swfollow=0;			//call setcid              //~v0b9I~
                    splittotlen=0;  	//call setcid              //~v10zI~
                }                                                  //~v0b9I~
              if (swfollow!=1)			//not continued line       //~v0b9I~
//  			if (filesetcid(pfh,plh,Gfilebuff,Gfilebuff2,len,cid,&cidexplen)) //chng cid//~v014R~
//  			if (rc=filesetcid(pfh,plh,Gfilebuff,Gfilebuff2,cid,&cidexplen),rc) //chng cid//~v10zR~
    			if (rc=filesetcid(pfh,plh,Gfilebuff,Gfilebuff2,cid,&cidexplen,splittotlen),rc) //chng cid//~v10zI~
				{                                               //~5130I~
                	if (rc==UALLOC_FAILED)	//storage shortage  //~v04dI~
                    	return UALLOC_FAILED;	                //~v04dI~
					len+=cidexplen;                             //~5130I~
					pcf=Gfilebuff;	                            //~5130R~
					pcd=Gfilebuff2;		//dbcs tbl              //~5130R~
				}//sata copyed                                  //~5130I~
              if (swfollow==2)			//cont last line           //~v0b9I~
              {                                                    //~v10zI~
	            plh->ULHupctr=splitupctrlast;//restore             //~v0b9I~
                splitupctr=0;	                                   //~v10AI~
                splittotlen=0;                                     //~v10zI~
			  }	                                                   //~v10zI~
			}                                                   //~5130I~
//set updated line lineno of spf file                              //~v0czI~
			if ((spfsw//spf file                                   //~v42iR~
            &&  plh->ULHupctr   //updated                          //~v0czI~
            &&  !UCBITCHK(plh->ULHflag,ULHFCIDCLEAR) //update is cid clear only//~v0czR~
            &&  !UCBITCHK(plh->ULHflag4,ULHF4REPRENUM) //update is not renum only//~v71ZI~
            &&  !UCBITCHK(plh->ULHflag3,ULHF3SETSPFVER)) //update is ver set only//~v42iR~
			||UCBITCHK(plh->ULHflag4,ULHF4SETSPFVER2))//suffixoverflow//~v42iR~
            {                                                      //~v0czI~
                wlen=plh->ULHlen;   //save over filesetspfnum      //~v0czI~
                plh->ULHlen=len;    //may expanded                 //~v0czI~
                if (pcf!=Gfilebuff) //no cid added                 //~v0czI~
                {	                                               //~v0czI~
                	memcpy(Gfilebuff,pcf,(UINT)wlen);              //~v0czR~
					pcf=Gfilebuff;                                 //~v0czI~
					pcd=0;		//dbcs tbl                         //~v0czI~
                }                                                  //~v0czI~
//              filesetspfnum(pfh,plh,pcf,0,0);//no dbcs set,ver from pfh//~v71YR~
                filesetspfnum(pfh,plh,pcf,0,SETSPFNUM_ATSAVE);//no dbcs set,ver from pfh//~v71YI~
                len=spflen;                                        //~v0czI~
                plh->ULHlen=wlen;   //restore over filesetspfnum   //~v0czI~
            }                                                      //~v0czR~
                                                                   //~v0czI~
		  if (!noeolsw)			//text mode                        //~v108R~
            if (UCBITCHK(plh->ULHflag4,ULHF4NOEOL))//has no eol    //~v103I~
				if (UGETQNEXT(plh)==UGETQEND(&pfh->UFHlineque))	//last data line//~v103I~
                	noeolsw=1;		//skip write eol               //~v103I~
//drop tab                                                         //~v20vI~
                                                                   //~v103I~
			do			//while(len)
			{
				pcw=pct=Gfilebuff;			//	write area
//  			if (UCBITCHK(plh->ULHflag2,ULHF2TABFOUND)//tab detected//~v70kR~
    			if ((UCBITCHK(plh->ULHflag2,ULHF2TABFOUND)//tab detected//~v70kI~
//  			     ||plh->ULHupundoctr!=0)              //once updated//~v71hR~
    			     ||(plh->ULHupctr!=0 && pcd))     //once updated,pcd chk is for safety//~v71hR~
				&&  !droptabsw	//no tab clear at save             //~v20vR~
				&&  !spfsw)//tab detected                          //~v0cwI~
//*change tab char for display to normal tab
//  				for(wlen=0;len;len--,pcf++,pcd++)              //~v102R~
    				for(wlen=0;len && wlen<MAXLINEDATA ;len--,pcf++,pcd++)//~v102I~
					{
						if (*pcd==TABCHAR)                      //~5102R~
						{
							*pct++=TABCHAR;
							wlen++;
						}
						else
							if (*pcd!=TABPADCHAR)               //~5102R~
							{
								*pct++=*pcf;
								wlen++;
							}
//  					if (wlen==MAXLINEDATA)                     //~v102R~
//  						break;                                 //~v102R~
					}
				else	//no tab
				{
					len-=(wlen=min(len,MAXLINEDATA));
					memcpy(pct,pcf,(UINT)wlen);
                    pcf+=wlen;  //next write data start         //~5107I~
				}
				if (!len)
                if (!UCBITCHK(plh->ULHflag2,ULHF2SPLIT1))//not splitted rec//~v0aeI~
                if (!noeolsw)	//no skip eol write                //~v103I~
                {                                                  //~v0abI~
#ifdef FTPSUPP                                                     //~v71MI~
                  if (FILEISTSO(pfh))                              //~v71MI~
                  {                                                //~v71MI~
                    for (;wlen>0 && *(pcw+wlen-1)==' ';)           //~v71MR~
                    	wlen--;                                    //~v71MI~
                  }                                                //~v71MI~
#endif                                                             //~v71MI~
                  if (wmacsw)                                      //~v47XI~
					*(pcw+wlen++)=0x0d;                            //~v47XI~
                  else                                             //~v47XI~
                  {                                                //~v47XI~
                  	if (wpcsw)                                     //~v0abI~
						*(pcw+wlen++)=0x0d;                        //~v0abR~
					*(pcw+wlen++)='\n';
                  }                                                //~v47XI~
                }                                                  //~v0abI~

	  		  	if (rc=filewrite(pfh,pcw,(size_t)wlen),rc)         //~v08qR~
  				{
//  				uerrmsg("%s write err",                        //~v08qR~
//duplicated				"%s o̓G[",                       //~v08qR~
//msg by filewrite  		pfh->UFHfilename);                     //~v08qR~
					if (!partialsw && !Poutfile)                   //~v08qI~
	    				uerrmsg("%s write err(file incomplete),Save to other drive!",//~v13jR~
    		           			"%s o̓G[(t@CsS),̃hCu֕ۑv!",//~v13jR~
            	            	pfh->UFHfilename);                 //~v08qI~
  					UCBITON(pfh->UFHflag,UFHFWRITEERR);	//flag err//~5128R~
  					return rc;
  				}
			}while(len);
          }//not bandle used or selected at bandle use             //~v0ibI~
		}//ULHDATA                                                 //~v0ibR~
		if (Pplh2 && plh==Pplh2)	//partial write             //~5128I~
			break;                                              //~5128I~
		plh=UGETQNEXT(plh);
	}	
//  if (eline)	//write last half to temp or other file            //~v10YR~
    if (eline || xrangeswe)	//write last half to temp or other file//~v10YI~
    	if (filepartialcopy(1,Ppfh,pfh))//reopen pfh with "wb+" then copy//~v08qR~
        {                                                          //~v08qI~
  			UCBITON(pfh->UFHflag,UFHFWRITEERR);	//flag err         //~v08qI~
//			return 4;                                              //~v13jR~
    		return filepartialouterr();                            //~v13jI~
		}                                                          //~v08qI~
//  fileeofwrite(pfh);				//write EOF                    //~v13jR~
  if (!(saveopt & FSOC_EOL_MAC))                                   //~v47XI~
    if (fileeofwrite(pfh))				//write EOF                //~v13jI~
    	return filecloseerr(pfh);                                  //~v13jI~
	if (Poutfile)		//other same file                       //~5128R~
    {                                                              //~v13jI~
      rc=                                                          //~v13jI~
		fileclose(pfh->UFHfilename,pfh->UFHhfile);              //~5128I~
	  	if (rc)                                                    //~v13jI~
	    	return filecloseerr(pfh);                              //~v13jI~
        else                                                       //~v13jI~
			pfh->UFHhfile=0;                                       //~v13jI~
#ifdef UNX                                                         //~v48cI~
		if (UCBITCHK(pfh->UFHflag5,UFHF5MDOS))//original is mdos disk//~v48cI~
        	rc=fileclose_mdos(pfh->UFHfilename,pfh->UFHalias);     //~v48cI~
#endif                                                             //~v48cI~
#ifdef FTPSUPP                                                     //~v543R~
		if (!rc)                                                   //~v543R~
	    	if (FILEISREMOTE(pfh))//remote output by rep/cre/save  //~v543R~
            {                                                      //~v57KI~
//      	    rc=xeftpsave(0,Ppcw,pfh);//0:no rep chk            //~v57KR~
            	if (appendremotesw)                                //~v57KI~
                	appendremotesw=XEFTPSO_APPEND;                 //~v57KI~
                appendremotesw|=XEFTPSO_DELTEMP;   //delete temp local file//~v710I~
                appendremotesw|=XEFTPSO_OUTFILE;   //not write to itself//~v72nI~
            	if (Pplh1||xallsw||nxallsw)          //rep/cre     //+v72nR~
                	appendremotesw|=XEFTPSO_OUTPARTIAL;            //~v72nR~
        		rc=xeftpsave(appendremotesw,Ppcw,pfh);             //~v57KI~
            }                                                      //~v57KI~
#endif                                                             //~v543R~
	}                                                              //~v13jI~
    else                                                        //~5128I~
//!Poutfile                                                        //~v62nI~
	{                                                           //~5128I~
        rc=0;   //init                                             //~v62nI~
    	if (partialsw)                                             //~v08qI~
        {                                                          //~v08qI~
		    pelocalfnm=FILELOCALCOPYNAME(Ppfh);                    //~v546I~
          rc=                                                      //~v13jI~
			fileclose(pfh->UFHfilename,pfh->UFHhfile);//temp file  //~v08qR~
          	if (rc)                                                //~v13jI~
    			return filepartialouterr();                        //~v13jI~
//  		fileclose(Ppfh->UFHfilename,Ppfh->UFHhfile);//source file//~v546R~
    		fileclose(pelocalfnm,Ppfh->UFHhfile);//source file     //~v546I~
			Ppfh->UFHhfile=0;                                      //~v08qR~
#ifdef UNX                                                         //~v48cM~
		  if (UCBITCHK(Ppfh->UFHflag5,UFHF5MDOS))//original is mdos disk//~v48cI~
          {                                                        //~v48cI~
        	rc=fileclose_mdos(Ppfh->UFHfilename,pfh->UFHfilename);//mdos<=partial temp//~v48cI~
			uxdelete(Ppfh->UFHalias,FILE_NORMAL,UXDELNOMSG,        //~v48cI~
						&procctr,&procctr,&procctr);//mdos temp    //~v48cI~
          }                                                        //~v48cI~
          else                                                     //~v48cI~
          {                                                        //~v48cI~
#endif                                                             //~v48cM~
//  		rc=uxdelete(Ppfh->UFHfilename,FILE_NORMAL,UXDELNOMSG,  //~v546R~
    		rc=uxdelete(pelocalfnm,FILE_NORMAL,UXDELNOMSG,         //~v546I~
						&procctr,&procctr,&procctr);//source file  //~v08qR~
			if (rc)	//source delete faile                          //~v08qR~
				uxdelete(pfh->UFHfilename,FILE_NORMAL,UXDELNOMSG,  //~v08qI~
							&procctr,&procctr,&procctr);//del temp //~v08qI~
            else                                                   //~v08qI~
            {                                                      //~v57NI~
//  			rc=urename(pfh->UFHfilename,Ppfh->UFHfilename,0);  //~v546R~
    			rc=urename(pfh->UFHfilename,pelocalfnm,0);         //~v546I~
                if (rc)//rename mey fail if filesystem differed    //~v57NI~
                {                                                  //~v60fR~
                  rc=                                              //~v60fR~
                    uxcopy(pfh->UFHfilename,pelocalfnm,0,0);       //~v57NI~
                    if (!rc)                                       //~v60fR~
						ugeterrmsg();   //clear filesystem unmatch errmsg by urename//~v60fR~
                }                                                  //~v60fR~
            }                                                      //~v57NI~
#ifdef UNX                                                         //~v48cI~
          }//not mdos disk partial                                 //~v48cI~
#endif                                                             //~v48cI~
        	pfh=Ppfh;//reopen source later                         //~v08qI~
            if (rc)                                                //~v08qI~
            {                                                      //~v08qI~
	  			UCBITON(pfh->UFHflag,UFHFWRITEERR);	//flag err     //~v08qI~
				return 4;                                          //~v08qI~
			}                                                      //~v08qI~
		}                                                          //~v08qI~
//  	pfh->UFHupctrsave=pfh->UFHupctr;		//upctr when saved //~v13jR~
	newsavesw=0;                                                   //~v53UI~
	if (UCBITCHK(pfh->UFHflag,UFHFNEW))			//new now          //~v0fqI~
    {                                                              //~v0fqI~
//  	UCBITOFF(pfh->UFHflag,UFHFNEW);		//not new now          //~v62nR~
	  if (!FILEISREMOTE(pfh))//win/gcc;setup alias for new file    //~v574I~
    	ufilesetfhfilename(pfh,pfh->UFHfilename);                  //~v0fqI~
        newsavesw=1;                                               //~v53UI~
	}                                                              //~v0fqI~
		if (!Pendsw)                                            //~5128I~
        {                                                          //~v13jI~
		  if (UCBITCHK(pfh->UFHflag3,UFHF3RBIN))                   //~v0abI~
           fhreopen=                                               //~v13jR~
			filereopen(pfh,"rb");//once close and reopen           //~v0abI~
          else                                                     //~v0abI~
           fhreopen=                                               //~v13jR~
			filereopen(pfh,"r");					//once close and reopen//~5128R~
          if (!fhreopen)                                           //~v13jR~
	    	return filecloseerr(pfh);                              //~v13jI~
		}                                                          //~v13jI~
        else                                                       //~v13jI~
		  if (pfh->UFHhfile)  //if partial,already closed          //~v17gI~
          {                                                        //~v53UI~
			if (fileclose(pfh->UFHfilename,pfh->UFHhfile))         //~v13jI~
		    	return filecloseerr(pfh);                          //~v13jI~
          	else                                                   //~v13jI~
				pfh->UFHhfile=0;                                   //~v13jI~
          }//hfile                                                 //~v53UI~
//  	pfh->UFHupctrsave=pfh->UFHupctr;		//upctr when saved //~v62nR~
#ifdef UNX                                                         //~v48cI~
//      rc=0;                                                      //~v62nR~
		if (UCBITCHK(pfh->UFHflag5,UFHF5MDOS))//original is mdos disk//~v48cR~
          if (!partialsw)                                          //~v48cI~
        	rc=fileclose_mdos(pfh->UFHfilename,pfh->UFHalias);     //~v48cI~
      if (!rc)                                                     //~v48cI~
      {                                                            //~v53UI~
#endif                                                             //~v48cI~
#ifdef FTPSUPP                                                     //~v543R~
		if (FILEISREMOTE(Ppfh))                                    //~v543R~
        	rc=xeftpsave(0,Ppcw,Ppfh);                             //~v57KR~
        if (!rc)//ftpsave rc                                       //~v54UI~
        {                                                          //~v54UI~
#endif                                                             //~v543R~
//      if (newsavesw || !Pendsw)   //new saved by save cmd        //~v719R~
    	setfstatsw=(newsavesw || !Pendsw);  //new saved by save cmd//~v719I~
#ifdef FTPSUPP                                                     //~v719I~
    	if (UCBITCHK(Ppfh->UFHflag7,UFHF7TSO))	//tso bin mode is explicitly by cmd operand to save same mode//~v719I~
            setfstatsw=1;   //setlocal fstat to update dirlist     //~v719I~
#endif                                                             //~v719I~
        if (setfstatsw)                                            //~v719I~
        {                                                          //~v543R~
#ifdef FTPSUPP                                                     //~v716I~
    	 if (UCBITCHK(Ppfh->UFHflag7,UFHF7TSO)	//spf info exist,it was updated tspspfupdate//~v72nI~
         &&  (Ppfh->UFHattr & FILE_SPF))                           //~v72nI~
         {                                                         //~v72nI~
			xetsodlcmdsetlocal(pfc,0,Ppfh);	//pdh=0,get by pfc if enqued tp dirlist//~v72nI~
         }                                                         //~v72nI~
         else                                                      //~v72nI~
         {                                                         //~v72nI~
    	  if (UCBITCHK(Ppfh->UFHflag7,UFHF7TSO))	//tso bin mode is explicitly by cmd operand to save same mode//~v716I~
          {                                                        //~v719I~
            memset(&fstat3,0,sizeof(fstat3));                      //~v719I~
//          fstat3.attrFile=Ppfh->UFHattr;  //xetsolocalfstat do reverse operation//~v72nR~
            rc=(int)xetsolocalfstat(Ppfh,&fstat3);                 //~v716I~
          }                                                        //~v719I~
          else                                                     //~v716I~
#endif                                                             //~v716I~
            rc=(int)ufstat(Ppfh->UFHfilename,&fstat3);             //~v54UR~
            if (!rc)                                               //~v543R~
            {                                                      //~v719I~
                filesetfstat(Ppfh,&fstat3);                        //~v543R~
#ifdef FTPSUPP                                                     //~v719I~
    	  		if (UCBITCHK(Ppfh->UFHflag7,UFHF7TSO))	//tso bin mode is explicitly by cmd operand to save same mode//~v719I~
					xetsodlcmdsetlocal(pfc,0,Ppfh);	//pdh=0,get by pfc if enqued tp dirlist//~v719I~
#endif                                                             //~v719I~
            }                                                      //~v719I~
#ifdef FTPSUPP                                                     //~v72nI~
    	 }//TSO & SPF                                              //~v72nI~
#endif                                                             //~v72nI~
        }                                                          //~v543R~
//      if (!rc)                                                   //~v54UR~
//      {                                                          //~v54UR~
		if (!UCBITCHK(Gprocstatus,GPROCSTERM))//not CB at termination//~5228I~
        {                                                          //~v53UI~
          if (eolchngid)                                           //~v47LR~
			uerrmsg("%s is not updated,but save by %s EOL id",     //~v47TR~
					"%s XVt@C %s sIDŕۑ",         //~v47TR~
					pfh->UFHfilename,eolchngid);                   //~v47LR~
          else                                                     //~v47LI~
          {                                                        //~v53UI~
#ifdef FTPSUPP                                                     //~v53UI~
			if (pfh->UFHtype==UFHTHOSTS)	//ftp hosts file       //~v53UI~
            	uerrmsg("FTP hosts data updated",                  //~v53UI~
						"zXge[uXV܂");           //~v53UI~
            else                                                   //~v53UI~
#endif                                                             //~v53UI~
			uerrmsg("%s was Saved",                             //~5228R~
					"%s ͕ۊǂ܂",                      //~5228R~
					pfh->UFHfilename);                          //~5228R~
          }                                                        //~v53UI~
        }//gprocsterm                                              //~v53UI~
        pfh->UFHupctrsave=pfh->UFHupctr;        //upctr when saved //~v62nI~
    	UCBITOFF(pfh->UFHflag,UFHFNEW);		//not new now          //~v62nI~
#ifdef FTPSUPP                                                     //~v53UI~
        }//xeftpsave !rc                                           //~v543R~
#endif                                                             //~v53UI~
#ifdef UNX                                                         //~v53UI~
	  }//mdos !rc                                                  //~v53UI~
#endif                                                             //~v53UI~
//!Poutfile                                                        //~v62nI~
	}                                                           //~5128I~
//  if (spfsw)                                                     //~v@@@R~
//  	if (UCBITCHK(Gopt3,GOPT3TESTEXIT|GOPT3TESTABEND))//abend by double Esc//~v@@@R~
//  	    uerrexit("tab will clear at save",0);                  //~v@@@R~
//  return 0;                                                      //~v62nR~
    return rc;                                                     //~v62nI~
}//filesave
                                                                   //~v0clI~
//**************************************************************** //~v074I~
// filerenum                                                       //~v074I~
//*renumber line number and free undo stack                        //~v074I~
//*parm1 :pcw                                                      //~v074I~
//*parm2 :pfh                                                      //~v074I~
//*parm3 :option 0:normal,1:force option                           //~v0ctI~
//*parm4 :num fld and delm char(0+col1+col2+delmchar)              //~v506I~
//*return:rc                                                       //~v0cnR~
//**************************************************************** //~v074I~
int filerenum(PUCLIENTWE Ppcw,UFILEH *Ppfh,int Popt,ULONG Pnumfld) //~v506R~
{                                                                  //~v074I~
	LONG  lineno=0;                                                //~v074I~
	PUQUEH qh;                                                     //~v074I~
	PULINEH plh;                                                   //~v074I~
	PULINEH plh1st=0;                                              //~v0cnR~
    int suffix=0;                                                  //~v0aiI~
    int spfsw,newlen,datasw;                                       //~v0cnR~
    int spferrsw;                                                  //~v0ctI~
    int lenerrsw;                                                  //~v0cnR~
    int clearsw,xlinenosw,cobsw;                                   //~v40TR~
    int rc;                                                        //~v0cnI~
    int cobclearsw;                                                //~v420I~
    int donectr=0;                                                 //~v412I~
    int nonumsw;                                                   //~v42uI~
    int spfpos;                                                    //~v413I~
    int cobkrenumsw=0,cobkclearsw=0;                               //~v47AR~
    int setrinorenumsw=0;		//seti/setr without renum          //~v53dI~
    int numfldcol,numfldlen,numdelmfldlen,len,numfldcole,delmch,setrisw=0,maxfldsz;//~v506R~
    UCHAR renumonlysw=0,svreason;  //to avoid version-no up by renum//~v71ZR~
    char *pdata,*pdbcs,*pc;                                        //~v506R~
    ULONG offs;                                                    //~v178R~
    char wkedit2[8];                                               //~v40TR~
    char wkedit3[16];                                              //~v506R~
//*********************************                                //~v074I~
	qh=&(Ppfh->UFHlineque);                                        //~v074I~
	plh=(PULINEH)UGETQTOP(qh);                                     //~v074I~
    UPCTRREQ(Ppfh);         //write at save                        //~v0cnI~
    if (Popt & RENUMOPT_COBK)                                      //~v47AI~
    {                                                              //~v47AI~
        if (!UCBITCHK(Ppfh->UFHflag5,UFHF5COB2))                   //~v47AI~
        {                                                          //~v47AI~
        	uerrmsg("K option is valid only for COBK file",        //~v47AI~
        	        "K IvV COBK t@Cɂ̂ݗL");     //~v47AR~
            return 4;                                              //~v47AI~
        }                                                          //~v47AI~
		if (Popt & RENUMOPT_CLEAR)                                 //~v47AI~
 			cobkclearsw=SETSPFNUM_COB;		//clear cob fld        //~v47AI~
        else                                                       //~v47AI~
 			cobkrenumsw=SETSPFNUM_COBKRENUM;                       //~v47AR~
    }                                                              //~v47AI~
    if (Popt & (RENUMOPT_SETR|RENUMOPT_SETI))                      //~v506I~
    {                                                              //~v506I~
        if (UCBITCHK(Ppfh->UFHflag2,UFHF2SPFNUMOK|UFHF2SPFNUMERR)) //~v506I~
        {                                                          //~v506M~
        	uerrmsg("This file is line-numbered file.",            //~v506M~
        	        "̃t@C͍sԍL̃t@CłB"); //~v506M~
            return 4;                                              //~v506M~
        }                                                          //~v506M~
    	if (Popt & RENUMOPT_SETR)                                  //~v506I~
        	setrisw='R';		//SETR id	                       //~v506I~
        else                                                       //~v506I~
        	setrisw='I';		//SETI id                          //~v506I~
        numfldcol=(int)(Pnumfld>>16)-1;        	//num fld start col//~v50tR~
        numfldlen=(int)((Pnumfld>>8)&255)-numfldcol;      //end col//~v50tR~
        delmch=(int)(Pnumfld&255);         //delm char             //~v50tR~
        numdelmfldlen=numfldlen+(delmch!=0);                       //~v506I~
        numfldcole=numfldcol+numdelmfldlen;	//next col pos         //~v506I~
        setrinorenumsw=!(Popt & RENUMOPT_RENUM);                   //~v53dI~
    }                                                              //~v506I~
//  clearsw=((Popt & RENUMOPT_CLEAR) ? SETSPFNUM_CLEAR : 0);       //~v42uR~
//  cobclearsw=((Popt & RENUMOPT_COB) ? SETSPFNUM_COB : 0);        //~v42uR~
	nonumsw=UCBITCHK(Ppfh->UFHflag5,UFHF5NOAUTONUM);  //no use col72-80//~v42uR~
    clearsw=   (((Popt & RENUMOPT_CLEAR) && !nonumsw)              //~v42uR~
 				? SETSPFNUM_CLEAR : 0);//col72 clear option        //~v42uI~
    cobclearsw=(((Popt & RENUMOPT_CLEAR) && UCBITCHK(Ppfh->UFHflag5,UFHF5COB)//~v45vR~
                  && !UCBITCHK(Ppfh->UFHflag5,UFHF5COB2))          //~v45vI~
 				? SETSPFNUM_COB : 0);                              //~v42uI~
    spferrsw=UCBITCHK(Ppfh->UFHflag2,UFHF2SPFNUMERR);              //~v0ctI~
    if (spferrsw)	//err at load                                  //~v0ctI~
//  	if (!Popt)	//force option                                 //~v40FR~
    	if (!(Popt & RENUMOPT_FORCE))	//force option             //~v40FI~
        	return filespfneedforce();                             //~v0ctI~
    spfsw=UCBITCHK(Ppfh->UFHflag2,UFHF2SPFNUMOK);                  //~v0cnR~
    spfsw|=spferrsw;                                               //~v0ctR~
    cobsw=UCBITCHK(Ppfh->UFHflag5,UFHF5COB);  //cobol spf file     //~v45vI~
//  if (spfsw)                                                     //~v47AR~
//  	newlen=Ppfh->UFHlrecl;                                     //~v47AR~
//  else                                                           //~v47AR~
    if (!spfsw)                                                    //~v47AI~
//  	if (clearsw)                                               //~v45vR~
        if (Popt & RENUMOPT_CLEAR)                                 //~v45vI~
        {	                                                       //~v40FM~
          if (cobsw)                                               //~v45vI~
          {                                                        //~v47AI~
           if (!cobkclearsw)                                       //~v47AI~
           {                                                       //~v47AI~
            uerrmsg("No num fld defined COBOL file.Use K option to clear COB-SEQNO fld",//~v47AR~
                    "sԍCOBOLt@CłBKIvVōsԍNA[B");//~v47AR~
            return 4;                                              //~v47AI~
           }                                                       //~v47AI~
          }                                                        //~v47AI~
          else                                                     //~v45vI~
          {                                                        //~v47AI~
        	uerrmsg("CLEAR option is valid for file with line number.",//~v40FM~
            		"CLEAR IvV͍sԍtt@Cɂ̂ݗL");//~v40FM~
            return 4;                                              //~v40FM~
          }                                                        //~v47AI~
        }                                                          //~v40FM~
    offs=(ULONG)Ppfh->UFHslinepos;	//start offset                 //~v178I~
  	xlinenosw=UCBITCHK(Ppfh->UFHflag4,UFHF4XLINENO);               //~v40TR~
    if (setrisw)                                                   //~v506I~
    {                                                              //~v506I~
        if (xlinenosw)                                             //~v506I~
	    	if (UCBITCHK(Goptopt,GOPT_HEX_UPPER))	//if alias on  //~v506I~
    		    sprintf(wkedit2,"%%0%dlX%c",numfldlen,delmch);     //~v506R~
            else                                                   //~v506I~
    		    sprintf(wkedit2,"%%0%dlx%c",numfldlen,delmch);     //~v506R~
        else                                                       //~v506I~
    	    sprintf(wkedit2,"%%0%dld%c",numfldlen,delmch);         //~v506R~
        maxfldsz=8;                                                //~v506I~
        if (numfldlen<1||numfldlen>maxfldsz)                       //~v506R~
        {                                                          //~v506M~
        	uerrmsg("Number field size(%d) err(1-%d).",            //~v506R~
        	        "sԍtB[hTCY(%d) G[B(1-%d)",   //~v506R~
					numfldlen,maxfldsz);                           //~v506R~
            return 4;                                              //~v506M~
        }                                                          //~v506M~
        if (delmch=='%')                                           //~v506I~
            strcat(wkedit2,"%");                                   //~v506R~
    }                                                              //~v506I~
//  cobsw=UCBITCHK(Ppfh->UFHflag5,UFHF5COB);  //cobol spf file     //~v45vR~
//  if (cobclearsw && !cobsw)                                      //~v42vR~
//  {                                                              //~v42vR~
//      uerrmsg("CLEAR C option is valid for COBOL file.",         //~v42vR~
//              "CLEAR C IvVCOBOLt@Cɂ̂ݗL");    //~v42vR~
//      return 4;                                                  //~v42vR~
//  }                                                              //~v42vR~
//  if (cobsw)                                                     //~v45vR~
//    if (!(Popt & RENUMOPT_CLEAR))		//renum cmd                //~v45vR~
//    if (!(Popt & RENUMOPT_CLEAR)		//renum cmd                //~v45vR~
//    ||   (!clearsw && !cobclearsw))                              //~v45vR~
//  	if (nonumsw && UCBITCHK(Ppfh->UFHflag5,UFHF5COB2))  //cob has no num fld//~v45vR~
//  	{                                                          //~v45vR~
//      	uerrmsg("No num fld defined COBOL file.",              //~v45vR~
//              	"sԍ`ĂȂCOBOLt@CłB");//~v45vR~
//      	return 4;                                              //~v45vR~
//  	}                                                          //~v45vR~
	spfpos=Ppfh->UFHspfpos;                                        //~v413I~
	while(plh)                                                     //~v074I~
	{                                                              //~v074I~
    	if (setrinorenumsw)		//seti/setr without renum          //~v53dI~
        {                                                          //~v53dI~
            lineno=plh->ULHlinenor; //use current value            //~v53dI~
            suffix=plh->ULHsuffix;                                 //~v53dI~
            offs=plh->ULHoffs;                                     //~v53dI~
        }                                                          //~v53dI~
		if (spfsw)                                                 //~v47AI~
			newlen=Ppfh->UFHlrecl;                                 //~v47AI~
        else                                                       //~v47AI~
			newlen=max(plh->ULHlen,SPFCOBNUMFLDLEN);               //~v47AR~
        if (plh->ULHtype==ULHTDATA)                                //~v074I~
        {                                                          //~v0cnI~
//          if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT2))               //~v0cnR~
//            suffix++;                                            //~v0cnR~
//          else                                                   //~v0cnR~
//          {                                                      //~v0cnR~
//            ++lineno;                                            //~v0cnR~
//            suffix=0;                                            //~v0cnR~
//          }                                                      //~v0cnR~
          datasw=1;                                                //~v0cnI~
//        if (spfsw && !clearsw)                                   //~v42uR~
          if (spfsw && !clearsw && !cobclearsw)                    //~v42uI~
//            lenerrsw=(newlen!=plh->ULHlen);                      //~v0e7R~
              lenerrsw=!fileisvalidspfline(Ppfh,plh,0);            //~v0e7I~
		  else	                                                   //~v0cnI~
	          lenerrsw=0;                                          //~v0cnI~
		}                                                          //~v0cnI~
        else                                                       //~v0cnI~
          lenerrsw=                                                //~v0cnR~
          datasw=0;                                                //~v0cnR~
      if (datasw)  //data line                                     //~v40FR~
      {//datasw                                                    //~v543I~
      	if (clearsw) //clear req                                   //~v40FI~
        {                                                          //~v40FI~
//          if (plh->ULHlen<spfpos+SPFNUMFLDLEN                    //~v430R~
            if (plh->ULHlen!=spfpos+SPFNUMFLDLEN                   //~v430I~
    	    ||  umemspnc(plh->ULHdata+spfpos,' ',SPFNUMFLDLEN)!=SPFNUMFLDLEN)//~v413R~
        	   lenerrsw=1;                                         //~v40FR~
            else                                                   //~v420I~
//          	if (cobclearsw)                                    //~v47AR~
            	if (cobclearsw||cobkclearsw)                       //~v47AI~
                	if (plh->ULHlen<SPFCOBNUMFLDLEN                //~v420I~
		    	    ||  umemspnc(plh->ULHdata,' ',SPFCOBNUMFLDLEN)!=SPFCOBNUMFLDLEN)//~v420I~
						lenerrsw=1;                                //~v420I~
        }                                                          //~v40FI~
        else                                                       //~v42uI~
        if (cobclearsw)                                            //~v42uI~
        {                                                          //~v42uI~
//          if (plh->ULHlen<SPFCOBNUMFLDLEN                        //~v430R~
            if (plh->ULHlen!=STDSPFLRECL                           //~v430I~
		    ||  umemspnc(plh->ULHdata,' ',SPFCOBNUMFLDLEN)!=SPFCOBNUMFLDLEN)//~v42uI~
				lenerrsw=1;                                        //~v42uI~
                                                                   //~v42uI~
		}                                                          //~v42uI~
        else                                                       //~v40FI~
        if (cobkclearsw)	//cobo seqno of cobk file              //~v47AI~
        {                                                          //~v47AI~
        	if (plh->ULHlen<SPFCOBNUMFLDLEN                        //~v47AI~
		    ||  umemspnc(plh->ULHdata,' ',SPFCOBNUMFLDLEN)!=SPFCOBNUMFLDLEN)//~v47AI~
				lenerrsw=1;                                        //~v47AI~
		}                                                          //~v47AI~
        else                                                       //~v47AI~
//      	if (spfsw)                                             //~v47AR~
        	if (spfsw||cobkrenumsw)                                //~v47AI~
        	{                                                      //~v413I~
				sprintf(wkedit2,"%04ld%02d",plh->ULHlinenor%10000,plh->ULHsuffix%100);//~v413I~
              if (spfsw)                                           //~v47AI~
				if (!UCBITCHK(Ppfh->UFHflag5,UFHF5NOAUTONUM))	//prev is clear//~v413R~
                {                                                  //~v71ZI~
//  		        if (plh->ULHlen<spfpos+SPFNUMFLDLEN            //~v71ZR~
//                  ||  memcmp(plh->ULHdata+spfpos,wkedit2,SPFNUMVERPOS))//~v71ZR~
    		        if (plh->ULHlen<spfpos+SPFNUMFLDLEN)           //~v71ZI~
						lenerrsw=1;                                //~v413I~
                    else                                           //~v71ZI~
                    if (memcmp(plh->ULHdata+spfpos,wkedit2,SPFNUMVERPOS))//~v71ZI~
                    {                                              //~v71ZI~
						lenerrsw=1;                                //~v71ZI~
	  					if (UCBITCHK(plh->ULHflag3,ULHF3SPFNUMOK))//already valid spf//~v71ZR~
							renumonlysw=1;	                       //~v71ZI~
                    }                                              //~v71ZI~
                }                                                  //~v71ZI~
            	if (cobsw)                                         //~v47AR~
                      if (plh->ULHlen<SPFCOBNUMFLDLEN              //~v413R~
                      ||  memcmp(plh->ULHdata,wkedit2,SPFCOBNUMFLDLEN))//do REPRENUM//~v413R~
                      {                                            //~v71ZI~
						lenerrsw=1;                                //~v413I~
						renumonlysw=0; //cob num fld updated-->spf version-no up//~v71ZI~
                      }                                            //~v71ZI~
    		}//spfsw                                               //~v413I~
            else                                                   //~v506I~
            if (setrisw)        //SETR/SETI id                     //~v506I~
            {                                                      //~v506I~
                if (!plh->ULHdbcs)  //not once displayed           //~v506I~
                    if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v506I~
                        return UALLOC_FAILED;                      //~v506I~
		        if (xlinenosw)                                     //~v506I~
        	        len=sprintf(wkedit3,wkedit2,offs);             //~v506R~
                else                                               //~v506I~
        	        len=sprintf(wkedit3,wkedit2,lineno);           //~v506R~
                if (len>numdelmfldlen)	//overflow                 //~v506I~
                	strcpy(wkedit3,wkedit3+len-numdelmfldlen);     //~v506R~
				len=plh->ULHlen;                                   //~v506R~
                if (setrisw=='I')	//insert                       //~v506R~
                {                                                  //~v506I~
                    lenerrsw=1;		//undoprep                     //~v506I~
                    if (numfldcol<len)	//into record              //~v506I~
                    	newlen=len+numdelmfldlen;	//inserted len //~v506I~
                    else                                           //~v506I~
                    	newlen=numfldcole;	//after space padding  //~v506I~
                }                                                  //~v506I~
                else                                               //~v506I~
                {                                                  //~v506I~
                    if (numfldcole>len)	//over record              //~v506R~
                    {                                              //~v506I~
                        lenerrsw=1;     //num changed              //~v506I~
                        newlen=numfldcole;                         //~v506I~
                    }                                              //~v506I~
                    else			//	on the record              //~v506R~
                    {                                              //~v506I~
                        newlen=len;		//len not change           //~v506I~
                    	if (memcmp(plh->ULHdata+numfldcol,wkedit3,(UINT)numdelmfldlen))//~v506R~
		                	lenerrsw=1;     //num changed          //~v506R~
                    }                                              //~v506I~
                }                                                  //~v506I~
            }//seti/setr                                           //~v506R~
      }//datasw                                                    //~v543I~
//    if (lineno!=plh->ULHlinenor || suffix!=plh->ULHsuffix        //~v47AR~
      if ( (!(Popt & RENUMOPT_CLEAR) && (lineno!=plh->ULHlinenor || suffix!=plh->ULHsuffix))//~v47AR~
//    ||  offs  !=plh->ULHoffs                                     //~v40SR~
      ||  (xlinenosw && offs  !=plh->ULHoffs)                      //~v40SI~
      ||  lenerrsw)                                                //~v0cnR~
      {                                                            //~v0cnI~
      	if (!plh1st)                                               //~v0cnI~
        	plh1st=plh;		//1st changed                          //~v0cnI~
//      if (spfsw && datasw)                                       //~v47AR~
        if (datasw                                                 //~v47AI~
        &&  (spfsw||cobkclearsw||cobkrenumsw))                     //~v47AR~
        {                                                          //~v0cnI~
			if (newlen>plh->ULHbufflen)                            //~v0cnR~
            {                                                      //~v0cnI~
				if (fileexpandbuff(plh,newlen)==UALLOC_FAILED)     //~v0cnR~
                    return UALLOC_FAILED;                          //~v0cnR~
			}                                                      //~v0cnI~
    		if (lenerrsw)                                          //~v40SR~
//            if (clearsw|cobclearsw)                              //~v47AR~
              if (clearsw|cobclearsw|cobkclearsw)                  //~v47AI~
    	  		rc=undoupdate(Ppcw,plh,UUHTREPRENUMCLR);//no num set at save//~v42rI~
              else                                                 //~v42rI~
              {                                                    //~v71ZI~
                svreason=Ppcw->UCWreason;                          //~v71ZI~
                Ppcw->UCWreason=renumonlysw;   //parm to undo update//~v71ZI~
    	  		rc=undoupdate(Ppcw,plh,UUHTREPRENUM);//recl change //~v0ctR~
                Ppcw->UCWreason=svreason;                          //~v71ZI~
              }                                                    //~v71ZI~
    		else            //lineno,suffix chnged                 //~v40SR~
    			rc=undoupdate(Ppcw,plh,UUHTRENUM);//also upctr up for save//~v40SR~
            if (rc)                                                //~v0cnR~
                return rc;                                         //~v0cnI~
            donectr++;                                             //~v412I~
                                                                   //~v53dI~
          if (!setrinorenumsw)        //not SETR/SETI id           //~v53dI~
          {                                                        //~v53dI~
            plh->ULHlinenor=lineno;                                //~v0cnI~
            plh->ULHsuffix=suffix;                                 //~v0cnI~
            plh->ULHoffs=offs;		//update offset                //~v53dI~
          }                                                        //~v53dI~
//          filesetspfnum(Ppfh,plh,plh->ULHdata,plh->ULHdbcs,1);   //~v40FR~
            filesetspfnum(Ppfh,plh,plh->ULHdata,plh->ULHdbcs,      //~v40FR~
//  						SETSPFNUM_PLHVER+clearsw+SETSPFNUM_FORCE);//~v420R~
//  						SETSPFNUM_PLHVER+clearsw+cobclearsw+SETSPFNUM_FORCE);//~v47AR~
    						SETSPFNUM_PLHVER+clearsw+cobclearsw+cobkclearsw+cobkrenumsw+SETSPFNUM_FORCE);//~v47AR~
            plh->ULHlen=newlen;                                    //~v0cnR~
		}                                                          //~v0cnI~
        else                                                       //~v0cnI~
//      if (datasw && setrisw && lenerrsw && !suffix)	//SETI/SETR//~v53dR~
        if (datasw && setrisw && lenerrsw && !UCBITCHK(plh->ULHflag2,ULHF2SPLIT2))//~v53dR~
        {                                                          //~v506I~
			if (newlen>plh->ULHbufflen)                            //~v506I~
            {                                                      //~v506I~
				if (fileexpandbuff(plh,newlen)==UALLOC_FAILED)     //~v506I~
                    return UALLOC_FAILED;                          //~v506I~
			}                                                      //~v506I~
    	  	rc=undoupdate(Ppcw,plh,UUHTREPRENUM);//recl change     //~v506I~
            if (rc)                                                //~v506I~
                return rc;                                         //~v506I~
            donectr++;                                             //~v506I~
          if (!setrinorenumsw)        //not SETR/SETI id           //~v53dI~
          {                                                        //~v53dI~
            plh->ULHlinenor=lineno;                                //~v506I~
            plh->ULHsuffix=suffix;                                 //~v506I~
            plh->ULHoffs=offs;		//update offset                //~v506I~
          }                                                        //~v53dI~
            len=plh->ULHlen;                                       //~v506I~
            pdata=plh->ULHdata;                                    //~v506R~
            pdbcs=plh->ULHdbcs;                                    //~v506I~
            if (setrisw=='I')   //insert                           //~v506I~
            {                                                      //~v506I~
                if (numfldcol<len)  //into record                  //~v506I~
                {                                                  //~v506I~
                	pc=pdata+numfldcol;                            //~v506I~
                    memmove(pc+numdelmfldlen,pc,(UINT)(len-numfldcol));//~v506R~
                    memcpy(pc,wkedit3,(UINT)numdelmfldlen);        //~v50tR~
                	pc=pdbcs+numfldcol;                            //~v506I~
                    memmove(pc+numdelmfldlen,pc,(UINT)(len-numfldcol));//~v506R~
                    setobtabdbcs(pdata,pdbcs,len,numfldcol,numdelmfldlen);//~v506M~
                    memset(pc,0,(UINT)numdelmfldlen);              //~v50tR~
                }                                                  //~v506I~
                else                                               //~v506I~
                {                                                  //~v506I~
                	memset(pdata+len,' ',(UINT)(numfldcol-len));   //~v506I~
                	memcpy(pdata+numfldcol,wkedit3,(UINT)numdelmfldlen);//~v506R~
                	memset(pdbcs+len,0,(UINT)(numfldcole-len));    //~v506M~
                }                                                  //~v506I~
            }                                                      //~v506I~
            else	//repl                                         //~v506R~
            {                                                      //~v506I~
                if (numfldcol>len) //over record                   //~v506I~
                {                                                  //~v506I~
                	memset(pdata+len,' ',(UINT)(numfldcol-len));   //~v506I~
                	memcpy(pdata+numfldcol,wkedit3,(UINT)numdelmfldlen);//~v506R~
                	memset(pdbcs+len,0,(UINT)(numfldcole-len));    //~v506I~
                }                                                  //~v506I~
                else          //      on the record                //~v506R~
                {                                                  //~v506I~
                	memcpy(pdata+numfldcol,wkedit3,(UINT)numdelmfldlen);//~v506R~
                    setobtabdbcs(pdata,pdbcs,len,numfldcol,numdelmfldlen);//~v506M~
                	memset(pdbcs+numfldcol,0,(UINT)numdelmfldlen); //~v506I~
                }                                                  //~v506I~
            }                                                      //~v506I~
            plh->ULHlen=newlen;                                    //~v506I~
            filechktabdbcs(plh);                                   //~v506I~
		}                                                          //~v506I~
        else                                                       //~v506I~
        {                                                          //~v0cnI~
      		rc=undoprep(Ppcw,plh,UUHTRENUM);                       //~v0cnR~
            if (rc)                                                //~v0cnI~
                return rc;                                         //~v0cnI~
          if (!setrinorenumsw)        //not SETR/SETI id           //~v53dI~
          {                                                        //~v53dI~
            plh->ULHlinenor=lineno;                                //~v0cnI~
            plh->ULHsuffix=suffix;                                 //~v0cnI~
            plh->ULHoffs=offs;		//update offset                //~v178I~
          }                                                        //~v53dI~
        }                                                          //~v0cnI~
//      plh->ULHlinenor=lineno;                                    //~v0cnR~
//      plh->ULHsuffix=0;                                          //~v0aiR~
//      plh->ULHsuffix=suffix;                                     //~v0cnR~
      }//changed                                                   //~v0cnI~
//set next line count                                              //~v0cnI~
      if (!setrinorenumsw)        //not SETR/SETI id               //~v53dI~
      {                                                            //~v53dI~
        if (plh->ULHtype!=ULHTEXCLUDE)	//data or hdr              //~v0cnI~
        {                                                          //~v0cnI~
        	if (plh->ULHtype==ULHTDATA)                            //~v178I~
                offs+=plh->ULHlen+plh->ULHeolid;	//next line offset//~v50tR~
          	if (UCBITCHK(plh->ULHflag2,ULHF2SPLIT1))               //~v0cnI~
          		suffix++;                                          //~v0cnI~
          	else                                                   //~v0cnI~
          	{                                                      //~v0cnI~
        		++lineno;                                          //~v0cnI~
          		suffix=0;                                          //~v0cnI~
		  	}                                                      //~v0cnI~
		}                                                          //~v0cnI~
      }//setri no renum                                            //~v53dI~
		plh=UGETQNEXT(plh);                                        //~v074I~
	}                                                              //~v074I~
//  undofreeuuh(Ppfh);			//free all undo data               //~v0cnR~
    if (spferrsw)                                                  //~v0ctI~
    {                                                              //~v0ctI~
		UCBITOFF(Ppfh->UFHflag2,UFHF2SPFNUMERR);                   //~v0ctI~
		UCBITON(Ppfh->UFHflag2,UFHF2SPFNUMOK);                     //~v0ctI~
		UCBITON(Ppcw->UCWflag,UCWFDRAW);//even if 0 line updated(plh1st=0)//~v412I~
	}                                                              //~v0ctI~
//if (cobsw)    //NOAUTONUM is effective only for cob              //~v42tR~
//{                                                                //~v42tR~
// if (cobclearsw)                                                 //~v42tR~
//      UCBITOFF(Ppfh->UFHflag5,UFHF5COB);	//no more cob          //~v42tR~
// else                                                            //~v42tR~
//  if (clearsw)                                                   //~v42sR~
//      UCBITON(Ppfh->UFHflag5,UFHF5NOAUTONUM);                    //~v42sR~
//  else                                                           //~v425R~
//      UCBITOFF(Ppfh->UFHflag5,UFHF5NOAUTONUM);	//do renum     //~v425R~
//}                                                                //~v42tR~
    UPCTRREQ(Ppfh);         //write at save                        //~v0cnI~
    if (plh1st)                                                    //~v0cnI~
    {                                                              //~v0ctI~
//  	undocsrmove(Ppcw,plh1st);                                  //~v104R~
		UCBITON(Ppcw->UCWflag,UCWFDRAW);                           //~v0ctI~
    }                                                              //~v0ctI~
    if (nonumsw)                                                   //~v42uI~
    {                                                              //~v45vI~
      if (spfsw)    //not ek renum                                 //~v45vI~
    	uerrmsg("%d line(s) updated (COB num only)",               //~v42uI~
    			"%d sXV(COB̂)",                           //~v42uI~
            		donectr);                                      //~v42uI~
    }                                                              //~v45vI~
    else                                                           //~v42uI~
    uerrmsg("%d line(s) updated",                                  //~v412I~
    		"%d sXV",                                          //~v412R~
            	donectr);                                          //~v412I~
	return 0;                                                      //~v0cnR~
}//filerenum                                                       //~v074I~
//**************************************************************** //~v0clI~
//!filespfchk                                                      //~v0clI~
//* spf file lrecl/numeric chk for all line(even if partial edit)  //~v0clI~
//*parm1:plh                                                       //~v0clI~
//*parm2:spf num fld offset                                        //~v0clI~
//*parm3:output max version field                                  //~v0clI~
//*retrn:UALLOC_FAILED                                             //~v0clI~
//**************************************************************** //~v0clI~
int filespfchk(PULINEH Pplh,int Pspfpos,int *Pmaxver)              //~v0clR~
{                                                                  //~v0clI~
	char *pc;                                                      //~v0clI~
    int spfver;                                                    //~v0clI~
    int cobsw,nonumsw;                                             //~v40UI~
    int nocobnumsw;                                                //~v42vI~
    PUFILEH pfh;                                                   //~v40UI~
//***************                                                  //~v0clI~
    pfh=UGETPFH(Pplh);                                             //~v40UI~
    cobsw=UCBITCHK(pfh->UFHflag5,UFHF5COB);  //cobol spf file      //~v40UI~
	nonumsw=UCBITCHK(pfh->UFHflag5,UFHF5NOAUTONUM);  //no use col72-80//~v413R~
	nocobnumsw=UCBITCHK(pfh->UFHflag5,UFHF5COB2);  //cob num fld is all space//~v42vR~
    if (!Pplh->ULHdbcs)  //not once displayed                      //~v0e7I~
        if (filechktabdbcs(Pplh)==UALLOC_FAILED)//expand data len  //~v0e7I~
            return UALLOC_FAILED;                                  //~v0e7I~
	if (Pplh->ULHlen!=Pspfpos+SPFNUMFLDLEN)                        //~v0clI~
    {                                                              //~v0clI~
		UCBITON(Pplh->ULHflag3,ULHF3SPFNUMERR);                    //~v0duR~
        filesetlineerr(Pplh);                                      //~v0clI~
        return SPFERRLEN;                                          //~v0clI~
    }                                                              //~v0clI~
    pc=Pplh->ULHdata+Pspfpos;                                      //~v0clI~
  if (!nonumsw)		//not cobol num fld only                       //~v40UI~
    if (unumlen(pc,0,SPFNUMFLDLEN)!=SPFNUMFLDLEN)                  //~v0clI~
    {                                                              //~v0clI~
		UCBITON(Pplh->ULHflag3,ULHF3SPFNUMERR);                    //~v0duI~
        filesetlineerr(Pplh);                                      //~v0clR~
        return SPFERRNUM;                                          //~v0clI~
    }                                                              //~v0clI~
  	if (cobsw)		//to be chk cobol num fld(col 1-6)             //~v40UI~
//    if (nocobnumsw)	//col1-6 should be all space               //~v47vR~
//    {                                                            //~v47vR~
//  	if (umemspnc(Pplh->ULHdata,' ',SPFCOBNUMFLDLEN)!=SPFCOBNUMFLDLEN)//~v47vR~
//  	{                                                          //~v47vR~
//  		UCBITON(Pplh->ULHflag3,ULHF3SPFNUMERR);                //~v47vR~
//      	filesetlineerr(Pplh);                                  //~v47vR~
//      	return SPFERRNOTSPC;                                   //~v47vR~
//  	}                                                          //~v47vR~
//    }                                                            //~v47vR~
//    else                                                         //~v47vR~
      if (!nocobnumsw)	//col1-6 should be all space               //~v47vI~
    	if (unumlen(Pplh->ULHdata,0,SPFCOBNUMFLDLEN)!=SPFCOBNUMFLDLEN)//~v40UR~
    	{                                                          //~v40UI~
			UCBITON(Pplh->ULHflag3,ULHF3SPFNUMERR);                //~v40UI~
        	filesetlineerr(Pplh);                                  //~v40UI~
//      	return SPFERRNUM;                                      //~v61gR~
        	return SPFERRCOBNUM;                                   //~v61gI~
    	}                                                          //~v40UI~
    UCBITON(Pplh->ULHflag3,ULHF3SPFNUMOK);                         //~v0duI~
  if (nonumsw)		//cobol num fld only                           //~v412I~
    spfver=0;                                                      //~v412I~
  else                                                             //~v412I~
    spfver=uatoin(pc+SPFNUMVERPOS,SPFNUMVERLEN);                   //~v0clI~
    Pplh->ULHspfver=(UCHAR)spfver;                                 //~v0clR~
    if (spfver>*Pmaxver)                                           //~v0clI~
        *Pmaxver=spfver;//for all even if partial file             //~v0clI~
	return 0;                                                      //~v0clI~
}//filespfchk                                                      //~v0clI~
                                                                   //~v0czI~
//**************************************************************** //~v0czI~
//!fileisvalidspfline                                              //~v0czI~
//* spf file lrecl/numeric chk for all line(even if partial edit)  //~v0czI~
//*parm1:pfh                                                       //~v0czI~
//*parm2:plh                                                       //~v0czI~
//*parm3:option 1:set flag3,0:bypass set flag3                     //~v0duI~
//*retrn:1:valid spfline,0:invalid spfline                         //~v0czI~
//**************************************************************** //~v0czI~
int fileisvalidspfline(PUFILEH Ppfh,PULINEH Pplh,int Popt)         //~v0duR~
{                                                                  //~v0czI~
    int rc;                                                        //~v0duI~
    int cobsw,nonumsw;                                             //~v40UI~
    int nocobnumsw;                                                //~v42vI~
    UCHAR *pc;                                                     //~v40UI~
    UCHAR flag;                                                    //~v0duI~
//***************                                                  //~v0czI~
    flag=Pplh->ULHflag3;                                           //~v0duI~
    if (UCBITCHK(flag,ULHF3SPFNUMOK))                              //~v0duI~
        return 1;                           //already chked ok     //~v0duI~
    if (UCBITCHK(flag,ULHF3SPFNUMERR))                             //~v0duI~
        return 0;                           //already chked err    //~v0duI~
    if (!Pplh->ULHdbcs)  //not once displayed                      //~v0e7I~
        if (filechktabdbcs(Pplh)==UALLOC_FAILED)//expand data len  //~v0e7I~
            return 0;                                              //~v0e7I~
//  rc=    (Pplh->ULHlen==Ppfh->UFHlrecl                           //~v40UR~
//         && unumlen(Pplh->ULHdata+Ppfh->UFHspfpos,0,SPFNUMFLDLEN)==SPFNUMFLDLEN);//~v40UR~
    rc=Pplh->ULHlen==Ppfh->UFHlrecl;                               //~v40UI~
    if (rc)                                                        //~v40UI~
    {                                                              //~v40UI~
    	cobsw=UCBITCHK(Ppfh->UFHflag5,UFHF5COB);  //cobol spf file //~v40UR~
		nonumsw=UCBITCHK(Ppfh->UFHflag5,UFHF5NOAUTONUM);  //no use col72-80//~v412R~
		nocobnumsw=UCBITCHK(Ppfh->UFHflag5,UFHF5COB2);  //cob num fld is all space//~v42vI~
		pc=Pplh->ULHdata+Ppfh->UFHspfpos;                          //~v40UI~
		if (!nonumsw)		//not cobol num fld only               //~v40UI~
			rc=unumlen(pc,0,SPFNUMFLDLEN)==SPFNUMFLDLEN;           //~v40UR~
        if (rc)                                                    //~v40UI~
  			if (cobsw)		//to be chk cobol num fld(col 1-6)     //~v40UI~
            {                                                      //~v53UI~
              if (nocobnumsw)                                      //~v42vI~
//  	        rc=umemspnc(Pplh->ULHdata,' ',SPFCOBNUMFLDLEN)==SPFCOBNUMFLDLEN;//~v47vR~
    	        rc=0;           //any string allowed               //~v47vI~
              else                                                 //~v42vI~
    			rc=unumlen(Pplh->ULHdata,0,SPFCOBNUMFLDLEN)==SPFCOBNUMFLDLEN;//~v40UR~
            }//cobsw                                               //~v53UI~
    }                                                              //~v40UI~
  	if (Popt)	                                                   //~v0duI~
    {                                                              //~v53UI~
    	if (rc)                                                    //~v0duR~
        {                                                          //~v0duI~
			UCBITON(flag,ULHF3SPFNUMOK);                           //~v0duR~
			UCBITOFF(flag,ULHF3SPFNUMERR);                         //~v0duI~
        }                                                          //~v0duI~
		else                                                       //~v0duR~
        {                                                          //~v0duI~
			UCBITON(flag,ULHF3SPFNUMERR);                          //~v0duR~
			UCBITOFF(flag,ULHF3SPFNUMOK);                          //~v0duI~
        }                                                          //~v0duI~
    }//Popt                                                        //~v53UI~
	return rc;                                                     //~v0duI~
}//fileisvalidspfline                                              //~v0czI~
//**************************************************************** //~v0clI~
//!filespfloadnum                                                  //~v0clI~
//  get spf numver(num chk alrady end)                             //~v0clR~
//*parm1:pfh                                                       //~v0clI~
//*parm2:max version                                               //~v0clI~
//*parm3:errsw                                                     //~v0ctI~
//*rc   :none                                                      //~v0clI~
//**************************************************************** //~v0clI~
void filespfloadnum(PUFILEH Ppfh,int Pmaxver,int Perrsw)           //~v0ctR~
{                                                                  //~v0clI~
	PULINEH plh,plhlast;                                           //~v0clI~
    char *pc;                                                      //~v0clI~
    int spfpos,spfseqerr=0;                                        //~v0clI~
    int lnoprev=0,lno;                                             //~v0clR~
    int snoprev=0,sno;                                             //~v0clR~
    int nonumsw;                                                   //~v412I~
    int nocobnumsw;                                                //~v42vI~
    long temp[2];                                                  //~v0clI~
//********************                                             //~v0clI~
    spfpos=Ppfh->UFHspfpos;                                        //~v0clI~
	nonumsw=UCBITCHK(Ppfh->UFHflag5,UFHF5NOAUTONUM);  //no use col72-80//~v412I~
	nocobnumsw=UCBITCHK(Ppfh->UFHflag5,UFHF5COB2);  //num fld is all space//~v42vI~
    if (Pmaxver>=SPFNUMMAXVER)                                     //~v0ctM~
    {                                                              //~v0ctM~
    	filespfvermaxerr(Pmaxver,SPFNUMMAXVER);                    //~v0ctM~
        Pmaxver=SPFNUMMAXVER;                                      //~v0ctM~
	}                                                              //~v0ctM~
    Ppfh->UFHspfver=(UCHAR)Pmaxver; //set even if err              //~v0ctM~
    if (Perrsw & SPFERRLEN)                                        //~v0ctM~
    {                                                              //~v0ctM~
     	filespflenerr(spfpos+SPFNUMFLDLEN);                        //~v0ctM~
        return;                                                    //~v0ctM~
	}                                                              //~v0ctM~
    if (Perrsw & SPFERRCOBNUM)                                     //~v61gI~
    {                                                              //~v61gI~
        filespfcobnumerr();                                        //~v61gI~
        return;                                                    //~v61gI~
	}                                                              //~v61gI~
    if (Perrsw & SPFERRNUM)                                        //~v0ctM~
    {                                                              //~v0ctM~
        filespfnumerr();                                           //~v0ctM~
        return;                                                    //~v0ctM~
	}                                                              //~v0ctM~
    if (Perrsw & SPFERRNOTSPC)                                     //~v42vR~
    {                                                              //~v42vI~
        filespferrnotspace();                                      //~v42vI~
        return;                                                    //~v42vI~
	}                                                              //~v42vI~
  if (!(nonumsw && nocobnumsw))		//spf but no seqno prepared    //~v42vI~
  {                                                                //~v42vI~
	for (plh=UGETQTOP(&Ppfh->UFHlineque);plh;plh=UGETQNEXT(plh))   //~v0clI~
	{                                                              //~v0clI~
		if (plh->ULHtype!=ULHTDATA)	//not file data                //~v0clI~
        	continue;                                              //~v0clI~
      if (nonumsw)                                                 //~v412I~
      {                                                            //~v412I~
		pc=plh->ULHdata;	//spf fld                              //~v412I~
        lno=uatoin(pc,SPFNUMLNOLEN);                               //~v412I~
        sno=uatoin(pc+SPFNUMSNOPOS,SPFNUMSNOLEN);                  //~v412I~
      }                                                            //~v412I~
      else                                                         //~v412I~
      {                                                            //~v412I~
		pc=plh->ULHdata+spfpos;	//spf fld                          //~v0clR~
        lno=uatoin(pc,SPFNUMLNOLEN);                               //~v0clI~
        sno=uatoin(pc+SPFNUMSNOPOS,SPFNUMSNOLEN);                  //~v0clR~
      }                                                            //~v412I~
        if (lno<lnoprev                                            //~v0clR~
        ||  (lno==lnoprev && sno<=snoprev))                        //~v0clR~
        {                                                          //~v0clI~
        	filesetlineerr(plh);                                   //~v0clR~
            spfseqerr=1;                                           //~v0clI~
        }                                                          //~v0clI~
        lnoprev=lno;                                               //~v0clR~
        snoprev=sno;                                               //~v0clR~
        temp[0]=(long)lno;                                         //~v0clR~
        temp[1]=(long)sno;                                         //~v0clR~
        memcpy(plh->ULHlineno,temp,ULHLINENOSZ);                   //~v0clR~
	}//all plh                                                     //~v0clI~
//                                                                 //~v0clI~
	for (plh=UGETQTOP(&Ppfh->UFHlineque);plh;plhlast=plh,plh=UGETQNEXT(plh))//~v0clI~
	{                                                              //~v0clI~
		if (plh->ULHtype!=ULHTDATA)	//not file data                //~v0clI~
        	continue;                                              //~v0clI~
	    if (!spfseqerr)                                            //~v0clI~
        {                                                          //~v0clI~
            memcpy(temp,plh->ULHlineno,sizeof(temp));              //~v0clR~
            plh->ULHlinenor=temp[0];                               //~v0clR~
            plh->ULHsuffix=(int)temp[1];                           //~v0clR~
        }                                                          //~v0clI~
        memset(plh->ULHlineno,0,ULHLINENOSZ);                      //~v0clI~
	}//all plh                                                     //~v0clI~
    plhlast->ULHlinenor=temp[0]+1;                                 //~v0clI~
  }//spf but no lineno on line                                     //~v42vI~
    if (spfseqerr)                                                 //~v0clM~
    {                                                              //~v0clI~
    	filespfseqerr();                                           //~v0clM~
        return;                                                    //~v0clI~
    }                                                              //~v0clI~
//  else                                                           //~v0cqR~
//      Pmaxver++;                                                 //~v0cqR~
    UCBITON(Ppfh->UFHflag2,UFHF2SPFNUMOK);	//write num a save     //~v0clR~
    UCBITOFF(Ppfh->UFHflag2,UFHF2SPFNUMERR);//write num a save     //~v0ctI~
	return;                                                        //~v0clI~
}//filespfloadnum                                                  //~v0clI~
                                                                   //~v0clI~
//************************************************************     //~v0clI~
// filesetspfnum                                                   //~v0clI~
//*spf num filed setup                                             //~v0clI~
//*parm1:pfh                                                       //~v0clI~
//*parm2:plh                                                       //~v0clI~
//*parm3:data                                                      //~v0clI~
//*parm4:dbcs                                                      //~v0clI~
//*parm5:opt 0:ver from pfh,1:ver from plh                         //~v0cnI~
//*return:addlen                                                   //~v0clI~
//************************************************************     //~v0clI~
int  filesetspfnum(PUFILEH Ppfh,PULINEH Pplh,char * Pdata,char *Pdbcs,int Popt)//~v0cnR~
{                                                                  //~v0clI~
    int spfexplen,spfpos,lrecl,addlen;                             //~v0clI~
    int lineno,ovf;                                                //~v0clI~
    int ver;                                                       //~v0cqI~
//  int plhversw=0;                                                //+v71YR~,//~v71ZR~
    char wkedit[16];                                               //~v0clR~
    char wkedit2[8];                                               //~v40TI~
//*****************                                                //~v0clI~
    spfpos=Ppfh->UFHspfpos;                                        //~v0clI~
    lrecl=Pplh->ULHlen;                                            //~v0clI~
    spfexplen=(spfpos+SPFNUMFLDLEN)-lrecl;                         //~v0clI~
    if (spfexplen>0)                                               //~v0clI~
        addlen=spfexplen;                                          //~v0clI~
	else                                                           //~v0clI~
    	addlen=0;                                                  //~v0clR~
                                                                   //~v0clI~
//  spfexplen-=SPFNUMFLDLEN;                                       //~v40FR~
//  if (spfexplen>0)                                               //~v40FR~
    if (addlen>0)       //clear also num fld for the case no col72-80 set//~v40FI~
    {                                                              //~v0clI~
//      memset(Pdata+lrecl,' ',(UINT)spfexplen);                   //~v40FR~
        memset(Pdata+lrecl,' ',(UINT)addlen);                      //~v40FI~
        if (Pdbcs)                                                 //~v0clI~
//     		 memset(Pdbcs+lrecl,0,(UINT)spfexplen);                //~v40FR~
       		 memset(Pdbcs+lrecl,0,(UINT)addlen);                   //~v40FI~
    }                                                              //~v0clI~
    lineno=(int)Pplh->ULHlinenor*10000+Pplh->ULHsuffix*100;        //~v0cnR~
//  if (Popt & SETSPFNUM_ATSAVE)//no dbcs set,ver from pfh         //+v71YM~,//~v71ZR~
//  	if (UCBITCHK(Pplh->ULHflag3,ULHF3SPFNUMOK)//num ok         //+v71YM~,//~v71ZR~
//      &&  memcmp(Pplh->ULHdata+spfpos+SPFNUMVERPOS,"00",SPFNUMVERLEN))//already ver set//+v71YM~,//~v71ZR~
//      	plhversw=1;                                            //+v71YI~,//~v71ZR~
                                                                   //~v0cqI~
//  if (Popt)                                                      //~v40FR~
    if (Popt & SETSPFNUM_PLHVER)                                   //~v40FI~
    	ver=Pplh->ULHspfver;                                       //~v0cqR~
	else                                                           //~v0cnI~
//  if (plhversw)                                                  //+v71YI~,//~v71ZR~
//  	ver=Pplh->ULHspfver;                                       //+v71YI~,//~v71ZR~
//  else                                                           //+v71YI~,//~v71ZR~
    	ver=Ppfh->UFHspfver+1;                                     //~v0cqR~
    if (ver>SPFNUMMAXVER)                                          //~v0cqI~
        ver=SPFNUMMAXVER;                                          //~v0cqR~
    lineno+=ver;                                                   //~v0cqR~
                                                                   //~v0cqI~
    sprintf(wkedit,"%08d",lineno);                                 //~v0clR~
 if (Popt & SETSPFNUM_CLEAR)                                       //~v416R~
 {                                                                 //~v42uI~
 	if (Popt & SETSPFNUM_COB)                                      //~v420I~
    	memset(Pdata,' ',SPFCOBNUMFLDLEN);                         //~v420I~
//  else                                                           //~v42uR~
    	memset(Pdata+spfpos,' ',SPFNUMFLDLEN);                     //~v416I~
 }                                                                 //~v42uI~
 else                                                              //~v42uI~
 if (Popt & SETSPFNUM_COB)                                         //~v42uI~
    memset(Pdata,' ',SPFCOBNUMFLDLEN);                             //~v42uI~
 else                                                              //~v416R~
 {                                                                 //~v416R~
                                                                   //~v42rI~
  if (Popt & SETSPFNUM_FORCE    //num cmd(renum or clear)          //~v42rI~
  ||  !UCBITCHK(Ppfh->UFHflag5,UFHF5NUMCLEARED)) //not once cleared//~v42rI~
  {                                                                //~v42rI~
  if (!UCBITCHK(Ppfh->UFHflag5,UFHF5NOAUTONUM)	//already clear req//~v40FR~
//||  (Popt & SETSPFNUM_FORCE))                                    //~v412R~
     )                                                             //~v412I~
  {                                                                //~v40FM~
    ovf=(int)strlen(wkedit)-SPFNUMFLDLEN;                          //~v0clR~
//   if (Popt & SETSPFNUM_CLEAR)                                   //~v416R~
//    memset(Pdata+spfpos,' ',SPFNUMFLDLEN);                       //~v416R~
//   else                                                          //~v416R~
    memcpy(Pdata+spfpos,wkedit+ovf,SPFNUMFLDLEN);                  //~v0clR~
    if (Pdbcs)                                                     //~v0clI~
    {                                                              //~v0eLI~
        setobtabdbcs(Pdata,Pdbcs,spfpos+SPFNUMFLDLEN,spfpos,SPFNUMFLDLEN);//outbound tab clear//~v0eLM~
    	memset(Pdbcs+spfpos,0,SPFNUMFLDLEN);                       //~v0clR~
    }                                                              //~v0eLI~
  }//auto renum                                                    //~v40FM~
    if (UCBITCHK(Ppfh->UFHflag5,UFHF5COB)   //cobol spf file       //~v42vR~
//  &&  !UCBITCHK(Ppfh->UFHflag5,UFHF5COB2))  //no space cobnum    //~v47AR~
    &&  (!UCBITCHK(Ppfh->UFHflag5,UFHF5COB2)                       //~v47AI~
        ||(Popt & SETSPFNUM_COBKRENUM)))                           //~v47AI~
    {                                                              //~v40EI~
    	sprintf(wkedit2,"%04ld%02d",Pplh->ULHlinenor%10000,Pplh->ULHsuffix%100);//~v40WR~
        memcpy(Pdata,wkedit2,SPFCOBNUMFLDLEN);                     //~v40TR~
        if (Pdbcs)                                                 //~v40EI~
        {                                                          //~v40EI~
            setobtabdbcs(Pdata,Pdbcs,spfpos+SPFNUMFLDLEN,0,SPFCOBNUMFLDLEN);//outbound tab clear//~v40EI~
            memset(Pdbcs,0,SPFCOBNUMFLDLEN);                       //~v40EI~
        }                                                          //~v40EI~
    }                                                              //~v40EI~
  }//num cmd or not once cleared                                   //~v42rI~
 }//not clear option                                               //~v416I~
    return addlen;                                                 //~v0clI~
}//filesetspfnum                                                   //~v0clI~
                                                                   //~v0clI~
//************************************************************     //~v0cnI~
// filesetspfnumedit                                               //~v0cnI~
//  called from ando and cidtopc isrt                              //~v40WI~
//*spf num filed setup(asumption:lrecl is right)                   //~v0cnI~
//*parm1:pfh                                                       //~v0cnI~
//*parm2:plh                                                       //~v0cnI~
//*parm3:opt  0:ver from pfh,1:ver from plh                        //~v0cnI~
//*return:none                                                     //~v0cnI~
//************************************************************     //~v0cnI~
void filespfnumedit(PUFILEH Ppfh,PULINEH Pplh,int Popt)            //~v0cnI~
{                                                                  //~v0cnI~
    int spfpos;                                                    //~v40WR~
    int ver;                                                       //~v0cqI~
    int cobsw=0;                                                   //~v40WI~
    char wkedit[16];                                               //~v0cnI~
//*****************                                                //~v0cnI~
	if (Popt & SPFNUMEDIT_COB)                                     //~v40WI~
    {                                                              //~v40WI~
		Popt &=~SPFNUMEDIT_COB;                                    //~v40WI~
        cobsw=1;                                                   //~v40WI~
    }                                                              //~v40WI~
  if (Popt & SPFNUMEDIT_CIDTOP)                                    //~v40WI~
  {                                                                //~v40WI~
	Popt &=~SPFNUMEDIT_CIDTOP;                                     //~v40WI~
  	spfpos=STDSPFLRECL-SPFNUMFLDLEN;                               //~v40WI~
  }                                                                //~v40WI~
  else                                                             //~v40WI~
    spfpos=Ppfh->UFHspfpos;                                        //~v0cnI~
//  lineno=(int)Pplh->ULHlinenor*10000+Pplh->ULHsuffix*100;        //~v40WR~
                                                                   //~v0cqI~
    if (Popt)                                                      //~v0cqI~
    	ver=Pplh->ULHspfver;                                       //~v0cqI~
	else                                                           //~v0cqI~
    	ver=Ppfh->UFHspfver+1;                                     //~v0cqI~
    if (ver>SPFNUMMAXVER)                                          //~v0cqI~
        ver=SPFNUMMAXVER;                                          //~v0cqR~
//  lineno+=ver;                                                   //~v40WR~
                                                                   //~v0cqI~
//  sprintf(wkedit,"%08d",lineno);                                 //~v40WR~
//  ovf=(int)strlen(wkedit)-SPFNUMFLDLEN;                          //~v40WR~
//  memcpy(Pplh->ULHdata+spfpos,wkedit+ovf,SPFNUMFLDLEN);          //~v40WR~
    sprintf(wkedit,"%04ld%02d%02d",Pplh->ULHlinenor%10000,Pplh->ULHsuffix%100,ver%100);//~v40WR~
    memcpy(Pplh->ULHdata+spfpos,wkedit,SPFNUMFLDLEN);              //~v40WI~
    if (cobsw)                                                     //~v40WI~
	    memcpy(Pplh->ULHdata,wkedit,SPFCOBNUMFLDLEN);              //~v40WR~
    return;                                                        //~v0cnI~
}//filespfnumedit                                                  //~v0cnI~
                                                                   //~v0cnI~
//**************************************************************** //~v0cmR~
// fileresetver                                                    //~v0cmR~
//*renumber line number and free undo stack                        //~v0cmR~
//*parm1 :pcw                                                      //~v0cmR~
//*parm2 :pfh                                                      //~v0cmR~
//*parm3 :operand version no                                       //~v0cmR~
//*return:rc                                                       //~v0cmR~
//**************************************************************** //~v0cmR~
int fileresetver(PUCLIENTWE Ppcw,UFILEH *Ppfh,int Pver)            //~v0cmR~
{                                                                  //~v0cmR~
	PUQUEH qh;                                                     //~v0cmR~
	PULINEH plh;                                                   //~v0cmR~
	PULINEH plhlastdata=0;                                         //~v0coI~
	PULINEH plh1st=0;                                              //~v0coI~
    int ver,maxver,downno;                                         //~v0cmR~
    int upno;                                                      //~v0cmR~
//*********************************                                //~v0cmR~
    if (!UCBITCHK(Ppfh->UFHflag2,UFHF2SPFNUMOK|UFHF2SPFNUMERR))    //~v0ctR~
    	return filenotspferr();                                    //~v0cmR~
	maxver=Ppfh->UFHspfver;                                        //~v0cmR~
	if (Pver==-1)                                                  //~v0cmR~
    	return filespfver(maxver);                                 //~v0cmR~
    if (!UCBITCHK(Ppfh->UFHflag2,UFHF2SPFNUMOK))                   //~v0ctR~
    	return filenotspferr();                                    //~v0ctI~
	if (Pver>SPFNUMMAXVER)                                         //~v0cqR~
    	return filespfvererr();                                    //~v0cmR~
    UPCTRREQ(Ppfh);         //write at save                        //~v0coM~
                                                                   //~v0coI~
	qh=&(Ppfh->UFHlineque);                                        //~v0cmR~
	plh=(PULINEH)UGETQTOP(qh);                                     //~v0cmR~
    upno=0;                                                        //~v0cmR~
    downno=maxver-Pver;	//down level                               //~v0cmR~
	while(plh)                                                     //~v0cmR~
	{                                                              //~v0cmR~
        if (plh->ULHtype==ULHTDATA)                                //~v0cmR~
        {                                                          //~v0cmR~
            plhlastdata=plh;                                       //~v0coI~
            if (downno<=0)	//version up                           //~v0coI~
            	break;      //no need to line change,pfh change only//~v0coI~
          	ver=(int)plh->ULHspfver;                               //~v0cmR~
            if (ver)                                               //~v0cmR~
            {                                                      //~v0cmR~
                if (Pver)                                          //~v0cmR~
                {                                                  //~v0cmR~
            		ver-=downno;                                   //~v0cmR~
                	if (ver<=0)                                    //~v0cmR~
	                	ver=1;                                     //~v0cmR~
				}                                                  //~v0cmR~
				else                                               //~v0cmR~
	               	ver=0;                                         //~v0cmR~
				upno++;                                            //~v0cmR~
                if (!plh1st)	                                   //~v0coI~
                	plh1st=plh;                                    //~v0coI~
      			if (undoupdate(Ppcw,plh,UUHTSPFVER)==UALLOC_FAILED)//~v0cmR~
    	        	return UALLOC_FAILED;                          //~v0cmR~
                plh->ULHspfver=(UCHAR)ver;                         //~v0cmR~
                filesetvernum(Ppfh,plh);                           //~v0cmR~
            }	                                                   //~v0cmR~
		}                                                          //~v0cmR~
		plh=UGETQNEXT(plh);                                        //~v0cmR~
	}                                                              //~v0cmR~
	if (!plhlastdata)	//no data line                             //~v0coI~
    {                                                              //~v0coI~
	    uerrmsg("No data line",                                    //~v0coI~
    	        "f[^s܂");                           //~v0coI~
    	return 4;                                                  //~v0coI~
	}                                                              //~v0coI~
    uerrmsg("Version changed(%d-->%d),%d line changed",            //~v0cnR~
            "o[WԍύX(%d-->%d),%ds̕ύX",              //~v0cnR~
            maxver,Pver,upno);                                     //~v0cnR~
	if (undoprep(Ppcw,plhlastdata,UUHTSPFVERMAX)==UALLOC_FAILED)   //~v0coI~
    	return UALLOC_FAILED;                                      //~v0coI~
    Ppfh->UFHspfver=(UCHAR)Pver;                                   //~v0cmI~
    UPCTRREQ(Ppfh);         //write at save                        //~v0cmR~
    if (plh1st)                                                    //~v0coI~
    	undocsrmove(Ppcw,plh1st);                                  //~v0coI~
    return 0;                                                      //~v0cmR~
}//fileresetver                                                    //~v0cmR~
                                                                   //~v0cmR~
//**************************************************************** //~v0cmR~
// filesetvernum                                                   //~v0cmR~
//*set version on lineno fld                                       //~v0cmR~
//*parm1:pfh                                                       //~v0cmR~
//*parm2:plh                                                       //~v0cmR~
//*int  :0 set,4:short record bypassed                             //~v0cmR~
//**************************************************************** //~v0cmR~
int filesetvernum(PUFILEH Ppfh,PULINEH Pplh)                       //~v0cmR~
{                                                                  //~v0cmR~
    int pos;                                                       //~v0cmR~
    char editwk[16];                                               //~v0cmR~
//************************                                         //~v0cmR~
	pos=Ppfh->UFHlrecl;                                            //~v0cmR~
    if (pos>Pplh->ULHlen)                                          //~v0cmR~
    	return 4;                                                  //~v0cmR~
    sprintf(editwk,"%02d",(int)Pplh->ULHspfver);                   //~v0cmR~
	memcpy(Pplh->ULHdata+pos-SPFNUMVERLEN,editwk,SPFNUMVERLEN);    //~v0cmR~
	return 0;                                                      //~v0cmR~
}//filesetvernum                                                   //~v0cmR~
                                                                   //~v0cmR~
//**************************************************************** //~v0clI~
//!filelineerr                                                     //~v0clI~
//   reverse err line                                              //~v0clI~
//*parm1:plh                                                       //~v0clI~
//*rc   :none                                                      //~v0clI~
//**************************************************************** //~v0clI~
void filesetlineerr(PULINEH Pplh)                                  //~v0clI~
{                                                                  //~v0clI~
//********************                                             //~v0clI~
    UCBITON(Pplh->ULHflag,ULHFDRAW); //reverse                     //~v0clI~
    UCBITON(Pplh->ULHflag3,ULHF3ERRLINE);    //reverse             //~v0clI~
	return;                                                        //~v0clI~
}//filesetlineerr                                                  //~v0clI~
                                                                   //~v0clI~
//**************************************************************** //~v0clI~
// filespfnumerr                                                   //~v0clI~
//*spf lineno numeric err                                          //~v0clI~
//*parm:none                                                       //~v0clI~
//*rc  :none;                                                      //~v0clI~
//**************************************************************** //~v0clI~
void filespfnumerr(void)                                           //~v0clR~
{                                                                  //~v0clI~
//*******************                                              //~v0clI~
    uerrmsg("Line-No field numeric err of Numbered-Line-File",     //~v0clR~
            "sԍtt@C̍sԍlG[");             //~v0clR~
    ubell();                                                       //~v0clI~
    return;                                                        //~v0clI~
}//filespfnumerr                                                   //~v0clI~
//**************************************************************** //~v61gI~
// filespfcobnumerr                                                //~v61gI~
//*rc  :none;                                                      //~v61gI~
//**************************************************************** //~v61gI~
void filespfcobnumerr(void)                                        //~v61gI~
{                                                                  //~v61gI~
//*******************                                              //~v61gI~
    uerrmsg("COBOL Line-No field numeric err",                     //~v61gI~
            "COBOLsԍlG[");                            //~v61gI~
    ubell();                                                       //~v61gI~
    return;                                                        //~v61gI~
}//filespfcobnumerr                                                //~v61gI~
                                                                   //~v0clI~
//**************************************************************** //~v42vI~
// filespferrnotspace                                              //~v42vI~
//*spf lineno numeric err                                          //~v42vI~
//*parm:none                                                       //~v42vI~
//*rc  :none;                                                      //~v42vI~
//**************************************************************** //~v42vI~
void filespferrnotspace(void)                                      //~v42vI~
{                                                                  //~v42vI~
//*******************                                              //~v42vI~
    uerrmsg("COBOL lineno(coil1-6) is not space;option=(..,cobk,..)",//~v44iR~
            "COBOL sԍXy[XłȂ;option=(..,cobk,..)");   //~v44iR~
    ubell();                                                       //~v42vI~
    return;                                                        //~v42vI~
}//filespferrnotspace                                              //~v42vI~
                                                                   //~v42vI~
//**************************************************************** //~v0clI~
// filespflenerr                                                   //~v0clI~
//*spf lineno length err                                           //~v0clI~
//*parm:none                                                       //~v0clI~
//*rc  :none;                                                      //~v0clI~
//**************************************************************** //~v0clI~
void filespflenerr(int Plen)                                       //~v0clR~
{                                                                  //~v0clI~
//*******************                                              //~v0clI~
    uerrmsg("Line length err(!=%d) of Numbered-Line-File",         //~v0clR~
            "sԍtt@C̍sG[(!=%d)",                //~v0clI~
            Plen);                                                 //~v0clI~
    ubell();                                                       //~v0clI~
    return;                                                        //~v0clI~
}//filespflenerr                                                   //~v0clI~
                                                                   //~v0clI~
//**************************************************************** //~v0clI~
// filespfseqerr                                                   //~v0clI~
//*spf lineno sequence err                                         //~v0clI~
//*parm:none                                                       //~v0clI~
//*rc  :none;                                                      //~v0clI~
//**************************************************************** //~v0clI~
void filespfseqerr(void)                                           //~v0clR~
{                                                                  //~v0clI~
//*******************                                              //~v0clI~
    uerrmsg("Line-No sequence err of Numbered-Line-File",          //~v0clR~
            "sԍtt@C̍sԍG[");               //~v0clR~
    ubell();                                                       //~v0clI~
    return;                                                        //~v0clI~
}//filespfseqerr                                                   //~v0clI~
                                                                   //~v0clI~
//**************************************************************** //~v0clI~
// filespfvermaxerr                                                //~v0clI~
//*spf version max over                                            //~v0clI~
//*parm1:cur version no                                            //~v0clI~
//*parm2:limit                                                     //~v0clI~
//*rc  :none;                                                      //~v0clI~
//**************************************************************** //~v0clI~
void filespfvermaxerr(int Pver,int Plimit)                         //~v0clR~
{                                                                  //~v0clI~
//*******************                                              //~v0clI~
    uerrmsg("Vesion-No on Line-No(%d) column reached to limit(%d)",//~v0clR~
            "sԍ̃o[Wԍ(%d)l(%d)ɒBĂ܂",//~v0clR~
            Pver,Plimit);                                          //~v0clI~
    ubell();                                                       //~v0clI~
    return;                                                        //~v0clI~
}//filespfseqerr                                                   //~v0clI~
                                                                   //~v0clI~
//**************************************************************** //~v0clI~
// filespfpfeerr                                                   //~v0clI~
//*partial edit not allowed for spf file                           //~v0clI~
//*parm:none                                                       //~v0clI~
//*rc  :none;                                                      //~v0clI~
//**************************************************************** //~v0clI~
void filespfpfeerr(void)                                           //~v0clI~
{                                                                  //~v0clI~
//*******************                                              //~v0clI~
    uerrmsg("Partial edit not allowed for Numbered-Line-File",     //~v0clI~
            "sԍtt@C͕ҏWo܂");             //~v0clI~
    return;                                                        //~v0clI~
}//filespfpfeerr                                                   //~v0clI~
                                                                   //~v0clI~
//**************************************************************** //~v0clI~
// filenotspferr                                                   //~v0clI~
//*not spf file                                                    //~v0clI~
//*parm:none                                                       //~v0clI~
//*rc  :4                                                          //~v0clI~
//**************************************************************** //~v0clI~
int filenotspferr(void)                                            //~v0clI~
{                                                                  //~v0clI~
//*******************                                              //~v0clI~
    uerrmsg("This is not valid Numbered-Line-File",                //~v0ctR~
            "͐sԍtt@Cł͂܂");       //~v0ctR~
    return 4;                                                      //~v0clI~
}//filespfpfeerr                                                   //~v0clI~
                                                                   //~v0clI~
//**************************************************************** //~v0clI~
// filespfvererr                                                   //~v0clI~
//*not spf file                                                    //~v0clI~
//*parm:none                                                       //~v0clI~
//*rc  :4                                                          //~v0clI~
//**************************************************************** //~v0clI~
int filespfvererr(void)                                            //~v0cqR~
{                                                                  //~v0clI~
//*******************                                              //~v0clI~
    uerrmsg("Max version is %d",                                   //~v0cqR~
            "o[Wԍ͍ő %d",                             //~v0cqR~
			SPFNUMMAXVER);                                         //~v0cqR~
    return 4;                                                      //~v0clI~
}//filespfpfeerr                                                   //~v0clI~
                                                                   //~v0clI~
//**************************************************************** //~v0clM~
// postfix err                                                     //~v0clM~
//*parm :version                                                   //~v0clM~
//*rc   :4                                                         //~v0clM~
//**************************************************************** //~v0clM~
int filespfver(int Pver)                                           //~v0clI~
{                                                                  //~v0clM~
	uerrmsg("Current Version is %d",                               //~v0clM~
			"o[W %d",                                   //~v0clM~
			Pver);                                                 //~v0clM~
	return 0;                                                      //~v0clM~
}//filespfver                                                      //~v0clI~
                                                                   //~v0ctI~
//**************************************************************** //~v0ctI~
// postfix err                                                     //~v0ctI~
//*parm :version                                                   //~v0ctI~
//*rc   :4                                                         //~v0ctI~
//**************************************************************** //~v0ctI~
int filespfneedforce(void)                                         //~v0ctI~
{                                                                  //~v0ctI~
    uerrmsg("Numbered-Line-File has err lines,Use Force option",   //~v0ctI~
            "G[ŝsԍtt@C,ForceIvVKvł");//~v0ctI~
	return 4;                                                      //~v0ctI~
}//filespfver                                                      //~v0ctI~
//**************************************************************** //~v13jI~
//*parm :close err                                                 //~v13jI~
//*rc   :4                                                         //~v13jI~
//**************************************************************** //~v13jI~
int filecloseerr(PUFILEH Ppfh)                                     //~v13jI~
{                                                                  //~v13jI~
  	UCBITON(Ppfh->UFHflag,UFHFWRITEERR);	//flag err             //~v13jI~
    uerrmsg("%s Close failed(disk space shortage?),Save to other drive!",//~v13jR~
            "%s N[Ys(fBXNXy[Xs?),̃hCu֕ۑv!",//~v13jR~
            Ppfh->UFHfilename);                                    //~v13jR~
	return 4;                                                      //~v13jI~
}//filecloseerr                                                    //~v13jI~
//**************************************************************** //~v13jI~
//*parm :close err                                                 //~v13jI~
//*rc   :4                                                         //~v13jI~
//**************************************************************** //~v13jI~
int filepartialouterr(void)                                        //~v13jI~
{                                                                  //~v13jI~
    uerrmsg("Output to temp file for partial edit failed.(no space?).Save to other drive!",//~v13jI~
            "ҏŴ߂̈ꎞt@C̏o̓G[(Xy[Xs?),̃hCu֕ۑv!");//~v13jI~
	return 4;                                                      //~v13jI~
}//filepartialouterr                                               //~v13jI~
