//*CID://+v70jR~:                             update#=  210;       //~v70jR~
//*************************************************************
//*xefile2.c  *                                                 //~v04dR~
//* hex mode                                                       //~v440R~
//*************************************************************
//v70j:060802*(BUG)hex edit csr positioning err when ulhlen<fhwidth//~v70jI~
//v70h:060802*(BUG)/mh input 2nd byte is not 0 padding when added on end of file//~v70hI~
//v65b:050727 (BUG)vhex mode;skip tab(currently input avail but ignored)//~v65bI~
//v61w:050308 xprint on vhex mode                                  //~v61wI~
//v60v:050201 virtual hex display option(/Mx,HEX on/off,prev HEX is XIN)//~v60vI~
//v59v:041114 (BUG)hex disp mode:display char part column when csr is on hex part//~v59vR~
//v59u:041114 (BUG)hexinput:del cur pos if csr is on later half of byte//~v59vR~
//v59t:041114 hexinput:allow input at end of line                  //~v59vR~
//v53c:030921 alt+w for C&P copy word                              //~v53cI~
//v455:011208 (BUG)tab reple change hi-4bit+0(because tab is x20 on data fld)//~v455I~
//v44m:011204 option of upper/lower hex code display               //~v44mI~
//v446:011201 default cols data for hex edit                       //~v446I~
//v445:011201 binary file support for xprint **/***                //~v445I~
//v444:011201 del on hex part                                      //~v444I~
//v443:011201 colr on data csr corresponding on csr on hex part    //~v443I~
//v442:011201 skip csr over hex intermidiate space                 //~v442I~
//v441:011130 edit   hex                                           //~v441I~
//v440:011125 browse hex                                           //~v440I~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifdef DOS
#else
#endif
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <uque.h>
#include <ufile.h>                                              //~5318R~
#include <ualloc.h>                                             //~5318I~
#include <uedit2.h>                                                //~v440I~
                                                                //~5318I~
#include "xe.h"
#include "xescr.h"
#include "xefunc.h"
#include "xefile.h"
#include "xefile22.h"                                              //~v440I~
#include "xechar.h"                                                //~v440I~
#include "xeopt.h"                                                 //~v44mI~
#include "xeerr.h"                                                 //~v53cI~
#include "xefsub.h"                                                //~v61wI~
//*******************************************************
static int Shpose;                                                 //~v446R~
//*******************************************************          //~v445I~
int filegethexpos(int Phpos,int Phpose,int Pdataoffs);             //~v440I~
//int filegetdatapos(int Phpos,int Phpose,int Poffs,int *Ppdpos,int Popt);//~v59uR~
//**************************************************************** //~v445I~
// filehexprint                                                    //~v445I~
//*set hex data for xprint **                                      //~v445I~
//*parm1:pcw                                                       //~v445I~
//*parm2:plh                                                       //~v445I~
//*rc   :total print line len                                      //~v445I~
//**************************************************************** //~v445I~
int filehexprint(PUCLIENTWE Ppcw,PULINEH Pplh)                     //~v445I~
{                                                                  //~v445I~
	int plhlen,hexcsr=0,datacsr=0,rlen;                            //~v445R~
    UCHAR *pc;                                                     //~v445I~
//*************************                                        //~v445I~
	plhlen=Pplh->ULHlen;                                           //~v445I~
    pc=Gfilebuff+plhlen;                                           //~v445I~
	rlen=GFILEBUFFSZ*2-plhlen;                                     //~v445I~
    *pc++=' ';          //for eolid                                //~v445I~
    rlen--;                                                        //~v445I~
    if (rlen)                                                      //~v445I~
		filehexdisplay(Ppcw,pc,rlen,plhlen,Pplh,&hexcsr,&datacsr); //~v445R~
    else                                                           //~v445I~
    	Shpose=plhlen;                                             //~v445I~
    return Shpose;		//print lenght                             //~v445I~
}//filehexprint                                                    //~v445I~
//**************************************************************** //~v440I~
// filehexdisplay                                                  //~v440I~
//*set hex data for hex display mode                               //~v440I~
//*parm1:pcw                                                       //~v440I~
//*parm2:data addr on psd                                          //~v440I~
//*parm3:screen line residual len                                  //~v445R~
//*parm4:screen line data set len                                  //~v445R~
//*parm5:plh                                                       //~v445R~
//*parm6:input csr offs,output hex data pos correspondig to csr pos//~v445R~
//*parm7:output -1 or data pos correspondig to csr pos on hex part //~v445R~
//*rc   :none                                                      //~v440I~
//**************************************************************** //~v440I~
UCHAR *filehexdisplay(PUCLIENTWE Ppcw,UCHAR *Ppdata,int Preslen,   //~v440R~
		int Pdatalen,PULINEH Pplh,int *Phexcsr,int *Pdatacsr)      //~v443R~
{                                                                  //~v440I~
	PUFILEC pfc;                                                   //~v440I~
	PUFILEH pfh;                                                   //~v440I~
	UCHAR *phex,*phexe,*pdata,*pdata0,*pdbcs,*pdbcs0,*tabpos;      //~v440R~
    int   roffs,loffs,coffs,len,dpos,dpose,hpos,hpose,poss,pose;   //~v440R~
    int   ii,jj,oddsw,oddsw2,skiplen,csrx,hcsrx,hlen,rlen,dposc;   //~v443R~
    int   ulopt;                                                   //~v44mI~
    UCHAR hexdata[MAXCOLUMN*2]; //conv only display width          //~v440R~
    UCHAR srcdata[MAXCOLUMN]; //conv only display width            //~v440I~
//*****************                                                //~v440I~
	pfc=Ppcw->UCWpfc;                                              //~v440I~
	pfh=pfc->UFCpfh;                                               //~v440I~
    loffs=pfc->UFCleft;             //left most column             //~v440R~
    coffs=loffs+Pdatalen+1;			//for EOL id                   //~v440R~
    roffs=coffs+Preslen;	//right most pos                       //~v440I~
	csrx=*Phexcsr;			//offset in filearea                   //~v440R~
    *Phexcsr=-1;			//once clear output                    //~v440M~
    *Pdatacsr=-1;			//once clear output                    //~v443I~
                                                                   //~v440I~
    filegethposrange(pfh,Pplh->ULHlen,&hpos,&hpose);//get hex area range//~v446R~
    Shpose=hpose;			//return to filehexprint               //~v445I~
    skiplen=hpos-coffs;		//len between last printed and top hex pos//~v440I~
    pdata0=Ppdata;                                                 //~v440I~
    if (skiplen>0)                                                 //~v440R~
    {                                                              //~v440I~
        memset(pdata0,' ',(UINT)skiplen);                          //~v455R~
    	pdata0+=skiplen;                                           //~v440I~
        coffs+=skiplen;                                            //~v440I~
    }                                                              //~v440I~
//chk wether hex pard is on screen                                 //~v440I~
	poss=max(coffs,hpos);                                          //~v440R~
    oddsw=filegetdatapos(hpos,hpose,poss,&dpos,0);//left most data pos//~v440R~
    if (dpos<0)	//window is right of hex area                      //~v440I~
    	return 0;                                                  //~v440I~
	pose=min(roffs,hpose);                                         //~v440R~
    oddsw2=filegetdatapos(hpos,hpose,pose,&dpose,0);//right most data pos//~v440I~
    if (dpose<0)	//window is left of hex area                   //~v440I~
    	return 0;                                                  //~v440I~
    if (csrx>=0)        //csr line                                 //~v443R~
    {                                                              //~v440I~
		csrx+=loffs;		//offset in ULHdata                    //~v440I~
        hcsrx=filegethexpos(hpos,hpose,csrx);                      //~v440R~
        if (hcsrx>=0)                                              //~v440R~
            *Phexcsr=hcsrx-loffs;   //cols in file area            //~v440R~
    	if (filegetdatapos(hpos,hpose,csrx,&dposc,1)>=0//right most data pos//~v443I~
        &&  dposc>=0)                                              //~v443R~
            *Pdatacsr=dposc-loffs;   //cols in file area           //~v443I~
    }                                                              //~v440I~
//conv data                                                        //~v440I~
    len=dpose-dpos+oddsw2;                                         //~v440R~
    len=min(len,MAXCOLUMN); //conv only screen width               //~v441R~
//restore tabchar                                                  //~v440I~
    memcpy(srcdata,Pplh->ULHdata+dpos,(UINT)len);                  //~v455R~
    pdbcs=pdbcs0=Pplh->ULHdbcs+dpos;                               //~v440I~
    for (rlen=len;rlen;)                                           //~v440I~
    {                                                              //~v440I~
    	tabpos=memchr(pdbcs,TABCHAR,(UINT)rlen);                   //~v455R~
        if (!tabpos)                                               //~v440I~
        	break;                                                 //~v440I~
        rlen=(int)((ULONG)tabpos-(ULONG)pdbcs0);                   //~v455R~
        *(srcdata+rlen)=TABCHAR;                                   //~v440R~
        rlen=len-rlen-1;                                           //~v440R~
        pdbcs=tabpos+1;                                            //~v440I~
        if (!rlen)                                                 //~v440I~
        	break;                                                 //~v440I~
    }                                                              //~v440I~
    if (UCBITCHK(Goptopt,GOPT_HEX_UPPER))                          //~v44mI~
        ulopt=UBX_UPPER;                                           //~v44mI~
    else                                                           //~v44mI~
        ulopt=UBX_LOWER;                                           //~v44mI~
	ub2x(ulopt,hexdata,srcdata,len);                               //~v44mR~
    phex=hexdata+oddsw;                                            //~v440R~
    phexe=hexdata+len+len;                                         //~v441I~
    hlen=pose-poss;                                                //~v440I~
    for (ii=coffs-hpos,jj=0,pdata=pdata0;jj<hlen;ii++,jj++,pdata++)//~v440R~
    	if (ii%9!=8 && phex<phexe)                                 //~v445R~
          	*pdata=*phex++;                                        //~v445R~
        else                                                       //~v445I~
        	*pdata=' ';                                            //~v445R~
    return pdata0;                                                 //~v440R~
}//filehexdisplay                                                  //~v440I~
//**************************************************************** //~v441R~
// filecharhexinput                                                //~v441R~
//*set hex data to plhdata                                         //~v441R~
//*parm1:pcw                                                       //~v441R~
//*parm2:pfh                                                       //~v441R~
//*parm3:plh                                                       //~v441R~
//*parm4:input:current,output:next;cusor step count                //~v441R~
//*parm5:data offset                                               //~v441I~
//*parm6:operation code                                            //~v441R~
//*rc   :0:continue normal process,1:hex input accepted,           //~v441R~
//       4:protected,8:input data err(not hex digit)               //~v441R~
//**************************************************************** //~v441R~
int filecharhexinput(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,    //~v441R~
					int Pcsrpos,int *Ppdoffs,int Popcode)          //~v441R~
{                                                                  //~v441R~
    int   dpos,hpos,hpose,chi,cho;                                 //~v441R~
    int   oddsw,keyindatalen;                                      //~v442R~
    UCHAR *keyindata;                                              //~v441R~
    int shortsw;                                                   //~v70jI~
//*****************                                                //~v441R~
//csr pos chk                                                      //~v441R~
	keyindata=Ppcw->UCWkeydata;                                    //~v441R~
	keyindatalen=Ppcw->UCWkeytype;                                 //~v441R~
    shortsw=Pplh->ULHlen<Ppfh->UFHwidth;//if short no csr advance by data part char insert//~v70jI~
    filegethposrange(Ppfh,Pplh->ULHlen,&hpos,&hpose);//get hex area range//~v446R~
    if (Pcsrpos<hpos)                                              //~v441R~
    	return 0;	//continue to accept normal input              //~v441R~
    oddsw=filegetdatapos(hpos,hpose,Pcsrpos,&dpos,1);//left most data pos//~v441R~
    if (oddsw<0)	//csr on intermediate space                    //~v441R~
    	return 4;   //protected                                    //~v441R~
    if (dpos<0)		//csr outof range                              //~v444I~
    {                                                              //~v59cI~
  	  if (Popcode!=CHAROPDEL		//rep 2nd half                 //~v59cI~
      &&  Pcsrpos==hpose+1  	//may be after boundary space      //~v59cI~
      &&  filegetdatapos(hpos,hpose,Pcsrpos-1,&dpos,1)<0)//eol is boundary//~v59cI~
      	oddsw=0;                                                   //~v59cI~
      else                                                         //~v59cI~
    	return 4;   //protected                                    //~v444I~
    }                                                              //~v59cI~
    if (oddsw && Popcode==CHAROPINS)		//rep 2nd half         //~v441I~
		return FCHI_ODDINS;                                        //~v441R~
    *Ppdoffs=dpos;                                                 //~v444M~
  if (Popcode!=CHAROPDEL)		//rep 2nd half                     //~v444M~
  {                                                                //~v444M~
//hex code chk                                                     //~v441R~
	if (keyindatalen!=1)                                           //~v441R~
    	return 8;					//invalid data                 //~v441R~
    chi=toupper(*keyindata);                                       //~v441R~
    if (chi>='0' && chi<='9')                                      //~v441R~
		chi=chi-'0';                                               //~v441R~
	else                                                           //~v441R~
	if (chi>='A' && chi<='F')                                      //~v441R~
		chi=chi-'A'+10;                                            //~v441R~
    else	                                                       //~v441R~
    	return 8;					//invalid data                 //~v441R~
//get data                                                         //~v441R~
  if (dpos>=Pplh->ULHlen)                                          //~v70hR~
    cho=0;                                                         //~v70hI~
  else                                                             //~v70hI~
	cho=*(Pplh->ULHdata+dpos);                                     //~v441R~
                                                                   //+v70jI~
    if (oddsw)		//csr on later half byte                       //~v441R~
    {                                                              //~v441I~
		if (cho==' ' && (*(Pplh->ULHdbcs+dpos)==TABCHAR))          //~v455I~
        	cho=TABCHAR;                                           //~v455I~
    	cho=(cho & 0xf0)|chi;                                      //~v441R~
        if ((dpos%4)==3)	//                                     //~v441I~
        	Ppcw->UCWreason=UCWREASON_HEXSTEP;	//csr step over intermediate space//~v442R~
    }                                                              //~v441I~
    else                                                           //~v441R~
    	if (Popcode==CHAROPREP)		//rep 2nd half                 //~v441R~
        {                                                          //~v455I~
		    if (cho==' ' && (*(Pplh->ULHdbcs+dpos)==TABCHAR))      //~v455R~
        		cho=TABCHAR;                                       //~v455I~
	    	cho=(cho & 0x0f)|(chi<<4);                             //~v441R~
			if (dpos>=Pplh->ULHlen)	//insert at eol                //~v70jI~
            	if (!shortsw)                                      //~v70jI~
		        	Ppcw->UCWreason=UCWREASON_HEXSTEP;	//csr step more 1 column//~v70jI~
        }                                                          //~v455I~
        else                                                       //~v441R~
        {                                                          //~v442I~
	    	cho=(chi<<4);                                          //~v441R~
         if (!shortsw)                                             //~v70jI~
        	Ppcw->UCWreason=UCWREASON_HEXSTEP;	//csr step to odd byte//~v442I~
        }                                                          //~v442I~
    *Ppcw->UCWkeydata=(UCHAR)cho;                                //1 byte data//~v441R~
  }                                                                //~v444I~
    return FCHI_HEX;                                               //~v442R~
}//filecharhexinput                                                //~v441R~
//**************************************************************** //~v440I~
// filegethposrange                                                //~v440R~
//*get hex area range                                              //~v440R~
//*parm1:pfh                                                       //~v440I~
//*parm2:data length                                               //~v446R~
//*parm3:top offset of hex part                                    //~v446I~
//*parm4:end offset of hex part                                    //~v446I~
//*rc   :len between end of data and top of hex area               //~v440R~
//**************************************************************** //~v440I~
int filegethposrange(PUFILEH Ppfh,int Pdatalen,int *Pptop,int *Ppend)//~v446R~
{                                                                  //~v440I~
    int  ulhlen,width,hpos,wordno,resbyte,hlen;                    //~v440R~
//*****************                                                //~v440I~
    ulhlen=Pdatalen;                                               //~v446R~
    width=Ppfh->UFHwidth;                                          //~v440I~
    if (ulhlen<width)                                              //~v440I~
    	hpos=width;                                                //~v440I~
    else                                                           //~v440I~
    	hpos=ulhlen;                                               //~v440I~
    hpos+=HEXMARGIN;                                               //~v440R~
    *Pptop=hpos;                                                   //~v440I~
    wordno=(int)((UINT)ulhlen>>2);                                 //~v455R~
    resbyte=ulhlen%4;                                              //~v440I~
    hlen=wordno*9+(resbyte<<1)-(resbyte==0);                       //~v440I~
    *Ppend=hpos+hlen;                                              //~v440I~
    return 0;                                                      //~v440R~
}//filegethposrange                                                //~v440R~
//**************************************************************** //~v440I~
// filegethexpos                                                   //~v440R~
//*get hex area column for data pos                                //~v440R~
//*parm1:hex part start offset                                     //~v440R~
//*parm2:hex part end   offset                                     //~v440I~
//*parm3:input offset in ULHdata                                   //~v440R~
//*rc   :return pos in hex part                                    //~v440I~
//**************************************************************** //~v440I~
int filegethexpos(int Phpos,int Phpose,int Pdataoffs)              //~v440I~
{                                                                  //~v440I~
    int  hpos,wordno,resbyte;                                      //~v440I~
//*****************                                                //~v440I~
    wordno=(int)((UINT)Pdataoffs>>2);                              //~v455R~
    resbyte=Pdataoffs%4;                                           //~v440I~
    hpos=wordno*9+resbyte+resbyte+Phpos;                           //~v440R~
    if (hpos>=Phpose)                                              //~v440R~
    	return -1;                                                 //~v440I~
    return hpos;                                                   //~v440I~
}//filegethexpos                                                   //~v440I~
//**************************************************************** //~v440I~
// filegetdatapos                                                  //~v440R~
//*get offset in data area for hex area offset                     //~v440R~
//*parm1:hex area top offset                                       //~v440I~
//*parm2:hex area end offset                                       //~v440I~
//*parm3:input offset in hex area                                  //~v440R~
//*parm4:output offset in line data                                //~v440I~
//*parm5:option to chk csr is on intermediate space                //~v440I~
//*rc   :1:byte split sw,-1:offs is on intermediate space sw       //~v440I~
//**************************************************************** //~v440I~
int filegetdatapos(int Phpos,int Phpose,int Poffs,int *Ppdpos,int Popt)//~v440I~
{                                                                  //~v440I~
    int hoffs,rem,wordno,rc;                                       //~v440I~
//*****************                                                //~v440I~
    *Ppdpos=-1;             //id of out of range                   //~v440I~
    if (Poffs>Phpose		//out of range                         //~v440R~
    ||  Poffs<Phpos)		                                       //~v440R~
        return 0;                                                  //~v440I~
    hoffs=Poffs-Phpos;                                             //~v440R~
    wordno=hoffs/9;                                                //~v440R~
    rem=hoffs%9;                                                   //~v440I~
    if (rem==8 && Popt==1)			//on intermediate space        //~v440I~
    	rc=-1;                                                     //~v440I~
    else                                                           //~v440I~
    	rc=rem%2;                                                  //~v440I~
    *Ppdpos=(int)((wordno<<2)+((UINT)rem>>1));                     //~v455R~
    return rc;                                                     //~v440I~
}//filegetdatapos                                                  //~v440I~
//**************************************************************** //~v53cI~
// filegetword                                                     //~v53cI~
//*get offset in data area for hex area offset                     //~v53cI~
//*parm1:pcw                                                       //~v53cI~
//*parm2:outarea                                                   //~v53cI~
//*parm3:outarea len                                               //~v53cI~
//*rc   :word len or 0 if err                                      //~v53cI~
//**************************************************************** //~v53cI~
int filegetword(PUCLIENTWE Ppcw,PULINEH *Ppplh,int *Ppos)          //~v53cR~
{                                                                  //~v53cI~
	PUFILEC pfc;                                                   //~v53cI~
	PUFILEH pfh;                                                   //~v53cI~
	PULINEH plh;                                                   //~v53cI~
	PUSCRD  psd;                                                   //~v53cI~
    char *pc,*pc0;   //word get area                               //~v53cR~
    int pos,pos1,ii,len,plhlen,margin,marginr,marginl;             //~v53cR~
//*******************                                              //~v53cI~
    if (!CSRONFILEDATA(Ppcw))               //out of screen        //~v53cR~
    {                                                              //~v53cI~
  		errcsrpos();                                               //~v53cI~
        return 0;                                                  //~v53cI~
    }                                                              //~v53cI~
    psd=Ppcw->UCWpsd;                                              //~v53cI~
    psd+=Ppcw->UCWrcsry;                                           //~v53cI~
    plh=psd->USDbuffc;                                             //~v53cI~
    pfc=Ppcw->UCWpfc;                                              //~v53cI~
    pfh=pfc->UFCpfh;                                               //~v53cI~
    pos=Ppcw->UCWrcsrx-Ppcw->UCWlinenosz+pfc->UFCleft;//target pos 1//~v53cI~
    pc0=plh->ULHdata+pos;                                          //~v53cI~
    plhlen=plh->ULHlen;                                            //~v53cI~
    if (plh->ULHtype!=ULHTDATA                                     //~v53cI~
    ||  pos>=plhlen                                                //~v53cR~
    ||  *pc0==' '||!*pc0)                                          //~v53cI~
    {                                                              //~v53cM~
        errcsrpos();                                               //~v53cM~
        return 0;                                                  //~v53cM~
    }                                                              //~v53cM~
//margin chk                                                       //~v53cI~
    margin=pfh->UFHmergin;                                         //~v53cR~
    if (pos<margin)                                                //~v53cI~
    {                                                              //~v53cI~
    	marginr=min(margin,plhlen);                                //~v53cI~
        marginl=0;                                                 //~v53cI~
    }                                                              //~v53cI~
    else                                                           //~v53cI~
    {                                                              //~v53cI~
    	marginl=margin;                                            //~v53cI~
	    marginr=plhlen;                                            //~v53cI~
    }                                                              //~v53cI~
    for (ii=pos-1,pc=pc0-1;ii>=marginl;ii--,pc--)                  //~v53cR~
    {                                                              //~v53cI~
        if (*pc==' '||!*pc)                                        //~v53cI~
            break;                                                 //~v53cI~
    }                                                              //~v53cI~
    pos1=ii+1;                                                     //~v53cI~
    for (ii=pos+1,pc=pc0+1;ii<marginr;ii++,pc++)                   //~v53cR~
    {                                                              //~v53cI~
        if (*pc==' '||!*pc)                                        //~v53cI~
            break;                                                 //~v53cI~
    }                                                              //~v53cI~
    len=ii-pos1;                                                   //~v53cR~
    *Ppplh=plh;                                                    //~v53cI~
    *Ppos=pos1;                                                    //~v53cR~
    return len;                                                    //~v53cI~
}//filegetword                                                     //~v53cI~
//**************************************************************** //~v59vI~
// filegetcsrdpos                                                  //~v59vI~
//*get offset in data area for hex area offset for drwa csr pos    //~v59vI~
//*opt:0:cur csr pos                                               //~v59vI~
//*dpos :output data part offset,-1:csr in data part,-2:intermediate or out of range//~v59vI~
//**************************************************************** //~v59vI~
int filegethexcsrdpos(int Popt,PUCLIENTWE Ppcw,PUFILEH Ppfh,int *Ppdpos)//~v59vR~
{                                                                  //~v59vI~
	PUSCRD psd;                                                    //~v59vI~
	PUFILEC pfc;                                                   //~v59vI~
    PULINEH plh;                                                   //~v59vI~
    int hpos,hpose,cpos,oddsw;                                     //~v59vR~
//**********                                                       //~v59vI~
	*Ppdpos=-2;		//-2:no update csr pos info                    //~v59vI~
	if (!CSRONFILEDATA(Ppcw))                                      //~v59vR~
    	return -2;                                                 //~v59vI~
	pfc=Ppcw->UCWpfc;                                              //~v59vI~
	psd=Ppcw->UCWpsd+Ppcw->UCWrcsry;                               //~v59vI~
	plh=psd->USDbuffc;                                             //~v59vI~
	if (plh->ULHtype!=ULHTDATA)	//file data                        //~v59vM~
    	return -2;                                                 //~v59vM~
	filegethposrange(Ppfh,plh->ULHlen,&hpos,&hpose);//get hex area range//~v59vR~
	cpos=pfc->UFCleft+Ppcw->UCWrcsrx-Ppcw->UCWlinenosz;            //~v59vI~
    if (cpos<hpos)                                                 //~v59vI~
    {                                                              //~v59vI~
    	*Ppdpos=-1;		//in data part                             //~v59vI~
    	return -1;                                                 //~v59vI~
    }                                                              //~v59vI~
    if (cpos>hpose)		//outof range                              //~v59vI~
    	return -2;                                                 //~v59vI~
    oddsw=filegetdatapos(hpos,hpose,cpos,Ppdpos,1);//left most data pos//~v59vI~
    if (oddsw<0)	//intermediate space                           //~v59vI~
    	return -2;                                                 //~v59vI~
    return 0;                                                      //~v59vI~
}//filegethexcsrdpos                                               //~v59vI~
//**************************************************************** //~v61wI~
// filevhexprint                                                   //~v61wI~
//*for xpr ** cmd;write vhex line                                  //~v61wI~
//*parm2:plh after tab disply expand                               //~v61wI~
//*rc   :none                                                      //~v61wI~
//**************************************************************** //~v61wI~
int filevhexprint(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,UCHAR *Plinenowk,int Plinenosz)//~v61wI~
{                                                                  //~v61wI~
	int  rc,len,wlen;                                              //~v61wR~
    UCHAR *pc,*pc0;                                                //~v61wI~
//*************************                                        //~v61wI~
    pc=pc0=Gfilebuff;                                              //~v61wI~
    if (Plinenosz)                                                 //~v61wI~
    {                                                              //~v61wI~
    	memset(pc,' ',(UINT)(Plinenosz-1));                        //~v61wI~
        *(pc+Plinenosz-1)=*(Plinenowk+Plinenosz-1);                //~v61wR~
        pc+=Plinenosz;                                             //~v61wI~
    }                                                              //~v61wI~
    len=Pplh->ULHlen;                                              //~v61wI~
    wlen=len+Plinenosz;                                            //~v61wI~
	filevhexdisplay(USDF2VHEXLINE1,Pplh->ULHdata,Pplh->ULHdbcs,pc,0,len);//~v61wI~
    if (rc=filewrite(Ppfh,pc0,(size_t)wlen),rc)                    //~v61wR~
        return rc;                                                 //~v61wI~
    if (rc=filewrite(Ppfh,"\n",1),rc)                              //~v61wI~
        return rc;                                                 //~v61wI~
	filevhexdisplay(USDF2VHEXLINE2,Pplh->ULHdata,Pplh->ULHdbcs,pc,0,len);//~v61wI~
    if (rc=filewrite(Ppfh,pc0,(size_t)wlen),rc)                    //~v61wR~
        return rc;                                                 //~v61wI~
    if (rc=filewrite(Ppfh,"\n",1),rc)                              //~v61wI~
        return rc;                                                 //~v61wI~
    return Shpose;		//print lenght                             //~v61wI~
}//filevhexprint                                                   //~v61wI~
//**************************************************************** //~v60vI~
// filevhexdisplay                                                 //~v60vI~
//*set hex data for virtical hex display mode                      //~v60vI~
//*rc   :none                                                      //~v60vI~
//**************************************************************** //~v60vI~
UCHAR *filevhexdisplay(int Popt,UCHAR *Pplhdata,UCHAR *Pplhdbcs,UCHAR *Ppsddata,UCHAR *Ppsddbcs,int Plen)//~v60vR~
{                                                                  //~v60vI~
	UCHAR *pci,*pcd,*pco,*pce;                                     //~v60vI~
	UCHAR *pcdo;                                                   //~v65bI~
    int ch,vhex1sw,uppersw;                                        //~v60vR~
//*****************                                                //~v60vI~
	vhex1sw=Popt & USDF2VHEXLINE1;	//1st line of virtical hex display line//~v60vR~
	uppersw=UCBITCHK(Goptopt,GOPT_HEX_UPPER);	//upper case hex digit//~v60vI~
    pci=Pplhdata;                                                  //~v60vI~
	pcd=Pplhdbcs;                                                  //~v60vI~
	pco=Ppsddata;                                                  //~v60vI~
	pcdo=Ppsddbcs;                                                 //~v65bI~
//  for (pce=pci+Plen;pci<pce;pci++,pcd++,pco++)                   //~v65bR~
    for (pce=pci+Plen;pci<pce;pci++,pcd++,pco++,pcdo++)            //~v65bI~
    {                                                              //~v60vI~
    	if (*pcd==TABPADCHAR)                                      //~v60vI~
        {                                                          //~v65bI~
        	*pco=' ';                                              //~v60vI~
            if (Ppsddbcs)                                          //~v65bI~
    	    	*pcdo=TABPADCHAR;                                  //~v65bI~
        }                                                          //~v65bI~
        else                                                       //~v60vI~
        {                                                          //~v60vI~
            if (*pcd==TABCHAR)                                     //~v60vI~
            {                                                      //~v65bI~
                ch=TABCHAR;                                        //~v65bR~
                if (Ppsddbcs)                                      //~v65bI~
                	*pcdo=TABCHAR;                                 //~v65bI~
            }                                                      //~v65bI~
            else                                                   //~v60vI~
            {                                                      //~v65bI~
	        	ch=*pci;                                           //~v60vI~
                if (Ppsddbcs)                                      //~v65bI~
    	            *pcdo=0;                                       //~v65bI~
            }                                                      //~v65bI~
        	if (vhex1sw)                                           //~v60vI~
            	ch=(int)((UINT)ch>>4);  	//1st 4 bit            //~v60vR~
            else                                                   //~v60vI~
            	ch=(int)(ch & 0x0f);    //2nd 4 bit                //~v60vR~
            if (ch>=10)                                            //~v60vI~
            {                                                      //~v60vI~
            	ch-=10;                                            //~v60vI~
			    if (uppersw)                                       //~v60vI~
	            	ch+='A';                                       //~v60vI~
                else                                               //~v60vI~
	            	ch+='a';                                       //~v60vI~
            }                                                      //~v60vI~
            else                                                   //~v60vI~
            	ch+='0';                                           //~v60vI~
            *pco=(UCHAR)ch;                                        //~v60vI~
        }                                                          //~v60vI~
    }//                                                            //~v60vI~
//  if (Ppsddbcs) //optional                                       //~v65bR~
//    memset(Ppsddbcs,0,(UINT)Plen);                               //~v65bR~
    return 0;                                                      //~v60vI~
}//filevhexdisplay                                                 //~v60vI~
//**************************************************************** //~v60vI~
// filecharhexinput_v                                              //~v60vI~
//*accept input on virtical hexline                                //~v60vR~
//       4:err                                                     //~v60vR~
//**************************************************************** //~v60vI~
int filecharhexinput_v(UCHAR *Pkeyindata,int Pkeyindatalen,int Poldvalue,int Pmode,int Pvhexmode,UCHAR *Ppnewchar)//~v60vR~
{                                                                  //~v60vI~
    int   oldch,chi,cho;                                           //~v60vR~
//*****************                                                //~v60vI~
	if (Pkeyindatalen!=1)                                          //~v60vI~
    	return errnotvalidhexchar();                               //~v60vI~
    if (Poldvalue<0)	//over EOL                                 //~v60vR~
    	return errcsrpos();                                        //~v60vI~
    else                                                           //~v60vI~
    	oldch=Poldvalue;                                           //~v60vI~
    chi=toupper(*Pkeyindata);                                      //~v60vR~
    if (chi>='0' && chi<='9')                                      //~v60vI~
		chi=chi-'0';                                               //~v60vI~
	else                                                           //~v60vI~
	if (chi>='A' && chi<='F')                                      //~v60vI~
		chi=chi-'A'+10;                                            //~v60vI~
    else                                                           //~v60vI~
    	return errnotvalidhexchar();                               //~v60vI~
    if (Pmode==CHAROPREP)                                          //~v60vI~
    {                                                              //~v60vI~
        if (Pvhexmode & USDF2VHEXLINE1)  //input on 1st line       //~v60vR~
            cho=(oldch & 0x0f)|(chi<<4);                           //~v60vR~
        else                                                       //~v60vI~
            cho=(oldch & 0xf0)|chi;                                //~v60vR~
    }                                                              //~v60vI~
    else                                                           //~v60vI~
    if (Pmode==CHAROPINS)                                          //~v60vI~
    {                                                              //~v60vI~
        uerrmsg("Insert avail on char display line",               //~v61wR~
        		"\x95\\ső}Ă");               //~v61wR~
        return 4;                                                  //~v60vI~
    }                                                              //~v60vI~
    else                                                           //~v60vI~
    	return 8;                                                  //~v60vI~
    *Ppnewchar=(UCHAR)cho;                                         //~v60vR~
    return 0;                                                      //~v60vR~
}//filecharhexinput_v                                              //~v60vR~
