//*CID://+v70mR~:                             update#=  305;       //~v70mR~
//*************************************************************
//*xefunct2.c
//* graphic char setup
//*************************************************************
//v70m:060811 (Win)change graph key input by Shift key not by opt linech on/off//~v70mI~
//v70g:060801*(BUG:XXE)lnx use acs console is version only         //~v70gI~
//v70d:060731 change "OPT LINECH RELOAD" function to reload default file not current file//~v70dI~
//v705:060727 NEW:graphic char setup by external file(2 string for opt linech on/off)//~v70dR~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
//**************************************************************
#ifdef LNX
	#include <locale.h>
#endif
#ifdef OS2                                                         //~v70mI~
	#define INCL_BASE                                              //~v70mI~
	#include <os2.h>                                               //~v70mI~
#endif                                                             //~v70mI~
//*******************************************************
#include <uque.h>
#include <ulib.h>
#include <uerr.h>
#include <ualloc.h>
#include <udbcschk.h>
#include <ustring.h>
#include <ufile.h>
#include <uedit.h>
#include <uedit2.h>
#include <uparse.h>
#include <ukbd.h>                                                  //~v70mI~

#include "xe.h"
#include "xescr.h"
#include "xefunc.h"
#include "xefunct.h"
#include "xesub.h"
//**************************************************
#define LINECHFILE   "xelch"

//**************************************************
//**************************************************
#ifdef XXEACS
#ifdef XXE
	int funct2utf8init(void);
#endif
#endif
int funct2setuplinech(char *Pbuff);
int funct2fmterr(char *Ppc);
static	char Sdefaultfnm[32]=WORKDIRPATHID LINECHFILE;
static	char Slinechfnm[_MAX_PATH];
static  int  Slinechferr;
static  LINECHTB Slchtb[GRAPHKEYENTNO];
//**************************************************
//*init
//  inifile naming  xelch__.ini[.locale] :locale is for lineux
//        xxx: gxe/wxe
//        us: when /N9
//*parm: none
//*return:none
//**************************************************
int funct2init(int Popt,char *Pinifnm)
{
	char fpath[_MAX_PATH];
	char fnm[_MAX_PATH];
    FILE *fh;
    int errline,lno,len;
    char buff[1024];
//************************************
	Slinechferr=1;
    if (Popt)
    {
        if (stricmp(Pinifnm,FUNCT_RELOAD))
        	strcpy(fnm,Pinifnm);
        else
//      	strcpy(fnm,Slinechfnm);                                //~v70dR~
        	strcpy(fnm,Sdefaultfnm);                               //~v70dI~
    }
    else        //initial
    {
#ifdef LNX
    	sprintf(fnm,"%s%s.ini.%s",Sdefaultfnm,Pinifnm,setlocale(LC_ALL,""));
#else
    	sprintf(fnm,"%s%s.ini",Sdefaultfnm,Pinifnm);//fnm:ostype
#endif
        strcpy(Sdefaultfnm,fnm);
		strcpy(Slinechfnm,fnm);	//selected file
    }
	if (!Popt)	//initial start
    {
#ifdef XXEACS
#ifdef XXE
    	funct2utf8init();
#endif
#endif
        ;                                                          //~v70mI~
	}
//*open parm file
    filefullpath(fpath,fnm,sizeof(fpath));
    if (!(fh=fopen(fpath,"r")))
    {
        if (Popt)	//not init
    		uerrmsg("LINECH file(%s) not found",0,
    					fnm);
        return 0;
    }
	strcpy(Slinechfnm,fnm);	//selected file
//*get linech parm
	for (lno=1,errline=0;;lno++)
    {
		if (!fgets(buff,sizeof(buff),fh))
        	break;
        if (*buff=='/' && *(buff+1)=='/')	// "//" is stopper
        	break;
        len=(int)strlen(buff);                                     //~v70mR~
        if (len && *(buff+len-1)=='\n')   //drop crlf
        	*(buff+--len)=0;
        if (len && *(buff+len-1)=='\r')   //drop crlf
        	*(buff+--len)=0;
        if (funct2setuplinech(buff))
            errline=lno;                //last err line

    }
    fclose(fh);
    if (errline)
    {
        uerrmsgcat(";err at line %d on %s",0,
                    errline,fnm);
        return 4;
    }
    else
    {
	    if (Popt)
        	uerrmsgcat("%s processed;to see result re-open =0.2 list",
        	           "%s ܂Bʂ =0.2 ăI[vĊmFĂ",
                    	fnm);
    }
	Slinechferr=0;
    return 1;
}//funct2init
//**************************************************
//*set filename to end of file line of 0.2 list
//**************************************************
int funct2getfnm(char *Pout,int Plen)
{
	char *pout,*pc;
	int len,rlen;
//************************
	pout=Pout;
	rlen=Plen;
    pc=" * linech-file = ";
    len=(int)strlen(pc);
    if (len>=rlen)
    	return 4;
    memcpy(pout,pc,(UINT)len);
    pout+=len; rlen-=len;
    pc=Slinechfnm;
    len=(int)strlen(pc);                                           //~v70mR~
    if (len<=rlen)
    {
    	memcpy(pout,pc,(UINT)len);
	    pout+=len; rlen-=len;
        if (Slinechferr)	//err
        	pc=" * ERR ";
        else
        	pc=" * OK  ";
    	len=(int)strlen(pc);                                       //~v70mR~
	    if (len<=rlen)
    	{
        	memcpy(pout,pc,(UINT)len);                             //~v70mR~
   		}
        return 0;
    }
    memcpy(pout,pc+len-rlen,(UINT)rlen);
    return 1;		//cut
}//funct2getfnm
#ifdef XXEACS
#ifdef XXE
//**************************************************
//*setup defauklt utf8 display code                *
//**************************************************
int funct2utf8init(void)
{
	UCHAR *graphchutfcode[GRAPHKEYENTNO]={
    			"\xe2\x94\x94", 	//1 :LLC low,left ,corner
    			"\xe2\x94\xb4", 	//2 :LHS low,horz ,stopper
    			"\xe2\x94\x98", 	//3 :LRC low,right,corner
    			"\xe2\x94\x9c", 	//4 :LVS low,vert ,stopper
    			"\xe2\x94\xbc", 	//5 :CX  center
    			"\xe2\x94\xa4", 	//6 :RVS rig,vert ,stopper
    			"\xe2\x94\x8c", 	//7 :ULC up ,left ,corner
    			"\xe2\x94\xac", 	//8 :UHS up ,horz ,stopper
    			"\xe2\x94\x90", 	//9 :URC up ,right,corner
    			"\xe2\x94\x80", 	//10:HL      horz ,line
    			"\xe2\x94\x82"}; 	//11:VL      vert ,line
	int funcid,ii,len;
    PLINECHTB plcht;
    FUNCTBL *pft;
//****************
	plcht=Slchtb;
	for (ii=0,funcid=FUNCID_GRAPHCHAR+1;funcid<=FUNCID_GRAPHCHAR_VL;funcid++,ii++,plcht++)
    {
  		pft=functblsrch(funcid);
    	if (!pft)
			continue;
        if (UCBITCHK(pft->FTflag,FTFLINECHSET))
            continue;
        UCBITON(pft->FTflag,FTFLINECHSET);
        len=strlen(graphchutfcode[ii]);
	    plcht->LCTonoff[0].LCSflag|=LCSFHEXDATA;
        plcht->LCTonoff[0].LCSlen=len;
        memcpy(plcht->LCTonoff[0].LCSdata,graphchutfcode[ii],(UINT)len);
    }
    return 0;
}//funct2utf8init
#endif
//**************************************************
//*get utf display string by ll+strz fmt tbl
//**************************************************
int funct2getdisplaystrtb(int *Pplentb,char **Ppaddrtb)
{
    int ii;
//****************
	for (ii=0;ii<GRAPHKEYENTNO;ii++)
    {
        *Ppaddrtb++=Slchtb[ii].LCTonoff[0].LCSdata;
        *Pplentb++=Slchtb[ii].LCTonoff[0].LCSlen;
    }
    return 0;
}//funct2getdisplaystrtb
#endif
#ifdef LNX
//**************************************************
//*get utf display string by ll+strz fmt tbl
//**************************************************
int funct2getacsch(int Pfuncid)
{
    int idx,len;
    FUNCTBL *pft;
//****************
    idx=Pfuncid-FUNCID_GRAPHCHAR-1;
    if (idx<0||idx>=GRAPHKEYENTNO)
    	return 0;
    len=Slchtb[idx].LCTonoff[0].LCSlen;
    if (len==1)
    	return *(Slchtb[idx].LCTonoff[0].LCSdata);
    if (len>1)
    	return 0;
  	pft=functblsrch(Pfuncid);
    if (!pft)
		return 0;
	return pft->FTchar;
}//funct2getacsch
#endif
//***********************************************************************
//*get linech parameter
//*fmt n=xxxx[=yyyyyy] n=1,2,..,9,h,v
//*    xx:str when OPT LINECH ON   for linex console version:use acs(single byte)
//*    yy:str when OPT LINECH OFF
//*ex) 1=c0 2=c1 3=d9 4=c3 5=c5 6=b4 7=da 8=c2 9=bf h=c4 v=b3  (eng)
//*    1=03 2=15 3=04 4=19 5=10 6=17 7=01 8=16 9=02 h=06 v=05  (jpn)
//*    1=84af 2=84b3 3=84ae 4=84b0 5=84b4 6=84b2 7=84ac 8=84b1 9=84ad h=84aa v=84ab  (jpn dbcs)
//*    1=e29494 2=e294b4 3=e29498 4=e2949c 5=e294bc 6=e294a4 7=e2948c 8=e294ac 9=e29490 h=e29480 v=e29482 (utf)
//*    1=c0=e29494 2=c1=e294b4 3=d9=e29498 4=c3=e2949c 5=c5=e294bc 6=b4=e294a4 7=da=e2948c 8=c2=e294ac 9=bf=e29490 h=c4=e29480 v=b3=e29482 (eng+utf)
//************************************************************************
int funct2setuplinech(char *Pbuff)
{
    int rc=0,opdno;
    UCHAR **pargc,*pc;
	int funct2setuplinechsub(int Popdno,char **Ppargc);
//************************************
    pc=Pbuff+strspn(Pbuff," \t");
    if (!*pc)
        return 0;
    uparsev(pc,&pargc,&opdno,0," =,\t;");//no ignore crlf,no delmstr
    if (opdno)
		rc=funct2setuplinechsub(opdno,(char**)pargc);
    if (pargc)
	    ufree(pargc);
    return rc;
}//funct2setuplinech
//************************************
//************************************
int funct2setuplinechsub(int Popdno,char **Ppargc)
{
    FUNCTBL *pft;
	LINECHTB lcht;
    char **pargc,*pc,editwk[4];
    int jj,idx,ch,len,opdno,len1,len2;
//************************************
	pargc=Ppargc;
    opdno=Popdno;
    memset(&lcht,0,sizeof(lcht));
//* n=
    pc=*pargc;
    ch=toupper(*pc);
    if (ch=='H')
        idx=9;
    else
    if (ch=='V')
        idx=10;
    else
    {
        idx=atoi(pc)-1;
        if (idx<0||idx>8)
            return funct2fmterr(pc);
    }
//* n=xx=yyyy
    for (jj=0;jj<2;jj++)
    {
        opdno--;pargc++;
        if (!opdno)
            break;
        pc=*pargc;
        if (*pc=='0' && toupper(*(pc+1))=='X')
        {
        	pc+=2;                                                 //~v70mR~
            len=(int)strlen(pc);                                   //~v70mR~
            if (len<=MAXSTRINPUT+MAXSTRINPUT)
            {
            	len=ugethex(pc,lcht.LCTonoff[jj].LCSdata,len);
	            if (len<0)
	            	return funct2fmterr(pc);
	            lcht.LCTonoff[jj].LCSflag|=LCSFHEXDATA;
            }
        }
        else
        {
            len=(int)strlen(pc);                                   //~v70mR~
            if (len<=MAXSTRINPUT)
                strcpy(lcht.LCTonoff[jj].LCSdata,pc);
        }
        if (len>MAXSTRINPUT)
        {
            uerrmsg("LINECH char string is max %d byte",
                    "LINECH͍ő %d",
					MAXSTRINPUT);
            return 4;
        }
	    lcht.LCTonoff[jj].LCSlen=len;
    }
//#if defined(LNX) && !defined(XXE)   //lnx console
//    if (lcht.LCTonoff[0].LCSlen>1)
//    {
//        uerrmsg("Line drawing char have to be single byte for Linux Console version",
//                "Linux R\x83\\[łł r͂PłȂ΂Ȃ܂");
//        return 4;
//    }
//#endif
  	if (UCBITCHK(Gscrstatus,GSCRSDBCS)	//japanese
    &&  lcht.LCTonoff[0].LCSlen==1)
    {
		ch=*(lcht.LCTonoff[0].LCSdata);
#ifdef LNX
        if (ISEUC(ch))
#else
        if (SJIS1(ch))  //dbcs 1st byte
#endif
        {
            CH2HEXU(ch,editwk);
            editwk[3]=0;
            uerrmsg("(%s) may be DBCS 1st byte",
                     "(%s) DBCS1oCg1ł͎g܂",
                     editwk);
            return 4;

        }
    }
    len1=lcht.LCTonoff[0].LCSlen;
    len2=lcht.LCTonoff[1].LCSlen;
    if (len1)
		setdbcstbl(lcht.LCTonoff[0].LCSdata,lcht.LCTonoff[0].LCSdbcs,len1);
    if (len2)
		setdbcstbl(lcht.LCTonoff[1].LCSdata,lcht.LCTonoff[1].LCSdbcs,len2);
	memcpy(Slchtb+idx,&lcht,sizeof(lcht));
    pft=functblsrch(idx+FUNCID_GRAPHCHAR+1);
    if (pft)
    {
        if (len1||len2)
        	UCBITON(pft->FTflag,FTFLINECHSET);
        else
        	UCBITOFF(pft->FTflag,FTFLINECHSET);
    }
	return 0;
}//funct2setuplinech
//***********************************************************************
//*setup fkct line data
//************************************************************************
int funct2getlinechstr(int Popt,FUNCTBL *Ppft,char *Pout)
{
	PLINECHTB plcht;
	char *pc,*pco,*pc0;
    int ii,jj,ch,len;
//*************************
    pco=Pout;
    plcht=Slchtb+(Ppft->FTfuncid-(FUNCID_GRAPHCHAR+1));
    if (!Popt)	//FTnamee print(max 3 byte area by hex)
    {
        len=plcht->LCTonoff[0].LCSlen;
        if (len==1)
        {
        	pc=plcht->LCTonoff[0].LCSdata;
        	ch=*pc;
        	pco++;
        	CH2HEXU(ch,pco);
        	pco+=3;
        	*pco=(char)ch;                                         //~v70mR~
        }
        else
        {
        	if (len)	//both specified
	        	memcpy(pco,"StrKey",6);
        }
        return 0;
    }
//fill FTnamej print area
    for (jj=0;jj<2;jj++)
    {
        len=plcht->LCTonoff[jj].LCSlen;
        if (len)
        {
            pc0=plcht->LCTonoff[jj].LCSdata;
            if (plcht->LCTonoff[jj].LCSflag & LCSFHEXDATA)
            {
                memcpy(pco,"0x",2);
                pco+=2;
                for (ii=len,pc=pc0;ii>0;ii--)
                {
                    ch=*pc++;
                    CH2HEXU(ch,pco);
                    pco+=2;
                }
                *pco++='(';
                memcpy(pco,pc0,(UINT)len);
                pco+=len;
                *pco++=')';
            }
            else
            {
                memcpy(pco,pc0,(UINT)len);
                pco+=len;
            }
        }
        else
        {
        	if (!jj)
            {
            	CH2HEXU(Ppft->FTchar,pco);
            	pco+=2;
            }
        }
        *pco++=';';
    }
    return (int)((ULONG)pco-(ULONG)Pout);
}//funct2getlinechstr
//***********************************************************************
//*set UCWkeydata
//rc:0:continue process data,-1:retry from kbd input,4:err
//************************************************************************
int funct2getinputgc(PUCLIENTWE Ppcw,FUNCTBL *Ppft)
{
static int Swarningsw[2];
	PLINECHTB plcht;
	char *pc,*pcd;                                                 //~v70mR~
    int len,acsoff;
//*************************
    Gstrinputlen=0;
    plcht=Slchtb+(Ppft->FTfuncid-(FUNCID_GRAPHCHAR+1));
#if defined(LNX) && !defined(XXE)                                  //~v70mM~
    acsoff=(UCBITCHK(Gopt5,GOPT5ACS)==0); //0:on,1:off( acs mode)  //~v70mR~
    if (acsoff) //no acs mode
    {
        if (Swarningsw[acsoff]<3) //3 times warning
            uerrmsg("\"OPT LINECH ON\" is required to display Line-Drawing-Character",
                  "r\\ɂ \"OPT LINECH ON\" Ɛݒ肷Kv܂");
    }
#else                                                              //~v70mM~
    acsoff=(Ppcw->UCWkeyshift & (KBDSTF_LEFTSHIFT|KBDSTF_RIGHTSHIFT))!=0; //2nd string when width shift key//~v70mM~
#endif
    len=plcht->LCTonoff[acsoff].LCSlen;
    if (!len)
    {
    	if (plcht->LCTonoff[!acsoff].LCSlen)
        {
        	acsoff=!acsoff;
		    len=plcht->LCTonoff[acsoff].LCSlen;
        }
    }
    if (!len)
    {
	    if (!Swarningsw[acsoff]) //1st times warning
            uerrmsg("line drawing char may be setup by using %s",  //~v70mR~
                      "r %s ݒł܂B",          //~v70mR~
						LINECHFILE "xx.ini");                      //~v70mR~
    }
    Swarningsw[acsoff]++;
    if (!len)
    	return 0;
    pc=plcht->LCTonoff[acsoff].LCSdata;
    pcd=plcht->LCTonoff[acsoff].LCSdbcs;
    if (len==1)
    {
    	Ppcw->UCWkeydata[0]=*pc;
        return 0;
    }
	if (len==2 && *pcd==DBCS1STCHAR)
    {
#ifdef UTF8SUPP
  		if (!XEUTF8MODE())
        {
#endif
			*Ppcw->UCWkeydata=*pc;
  			*(Ppcw->UCWkeydata+1)=*(pc+1);
			Ppcw->UCWkeytype=UCWKTDBCS;		//sbcs
            return 0;
#ifdef UTF8SUPP
        }
#endif
    }
//multibyte (not dbcs)
    Gstrinputlen=len;
    memcpy(Gstrinput,pc,(UINT)len);                                //~v70mR~
    memcpy(Gstrinputdbcs,pcd,(UINT)len);                           //~v70mR~
    return -1;
}//funct2getinputgc
//***********************************************************************
//*get string input
//************************************************************************
int funct2getnextinputgc(char *Pinput)
{
	int len,rc;
//*************************
	if (Gstrinputlen>=2 && *Gstrinputdbcs==DBCS1STCHAR)
    {
    	*Pinput=*Gstrinput;    //char code
    	*(Pinput+1)=*(Gstrinput+1);			   //scan code
        len=2;
	    rc=UCWKTDBCS;
	}
    else
    {
    	*Pinput=*Gstrinput;    //char code
    	*(Pinput+1)=0;			   //scan code
        len=1;
	    rc=UCWKTSBCS;
	}
	Gstrinputlen-=len;
    if (Gstrinputlen)
    {                                                              //~v70gI~
		memcpy(Gstrinput,Gstrinput+len,(UINT)Gstrinputlen);        //~v70mR~
		memcpy(Gstrinputdbcs,Gstrinputdbcs+len,(UINT)Gstrinputlen);//~v70mR~
    }                                                              //~v70gI~
    return rc;
}//funct2getnextinputgc
//***********************************************************************
//*errmsg
//************************************************************************
int funct2fmterr(char *Ppc)
{
	uerrmsg("LINECH char file format err around %s",0,
            		Ppc);
    return 4;
}//funct2fmterr
