//*CID://+v717R~:                             update#=  293;       //+v717R~
//*************************************************************
//*xemainl.c                                                       //~0924R~
//*	linux xe main                                                  //~0924R~
//*************************************************************
//v717:060926 3270:dirlist support                                 //+v717I~
//v70z:060904 3270 ftp support                                     //~v70zI~
//v705:060727 graphic char setup by external file                  //~v705I~
//v69e:060519 chk scroll-lock on status for up/down arrow key to scroll up/down//~v69eI~
//v67C:051228 support alias cmd(save in ini file using shortcut key table position ":")//~v67CI~
//v670:051224 cmd histry retrieve for each screen(A+F12)           //~v670I~
//v60m:050129 display different id from eolid for contline terminater.//~v60mI~
//v56p:040406 UCWFWAKEUP flag is cleared after filewakeup is called by scrpopup,//~v56pI~
//            so dirdraw cannot chk wakeup/resize flag when called //~v56pI~
//v55Q:040318 (LNX)generate mouse move event for cut & paste by mouse//~v55QI~
//v55q:040228 option to scroll by csr move(CSRSCROLL option)       //~v55qI~
//v53H:031019 set default to vt100 because telnet from aix to aix change $TERM to xterm//~v53HI~
//v53p:030930 (LNX) -x parameter(single -) err chk                 //~v53pI~
//v53m:030928 (LNX)mouse support                                   //~v53mI~
//v53k:030927 (LNX)support stdout output                           //~v53kI~
//v53j:030927 (LNX)terminfo mouse string print                     //~v53jI~
//v52e:030826 (BUG)user string is null when terminfo used          //~v52eI~
//v526:030819 no more need to force under X because it is determined by ps cmd//~v526I~
//v525:030819 force TTERM env(kbd and viol) option                 //~v525I~
//v524:030819 integrate UKBDLNXC_-->UKBDL_                         //~v524I~
//v51Z:030817 (BUG)printable char chk,it shoult be by char code not by scan code.//~v51ZI~
//v51Y:030802 (AIX) key option for 7f force to BS/DEL/CHAR for also AIX//~v51YI~
//v51R:030802 (LNX) key option for 7f force to BS/DEL/CHAR         //~v51RI~
//v51C:030713 (LNX)xefunct LKED required for functbl srch to chk pfk used//~v51CI~
//v51B:030712 (LNX)allow multiple string for a key                 //~v51BI~
//v51z:030709 (LNX)no setstring ioption to chk native string on TERM=linux(console)//~v51zI~
//v51b:030419 (LNX)dbcs input                                      //~v51bI~
//v518:030412 reduce exe size                                      //~v518I~
//v515:030405 (LNX)user key string specification file support      //~v515I~
//v483:020423 (AIX)aixterm support                                 //~v483I~
//v47m:020309 screen height parm support(/Hnn)                     //~v47mI~
//v45q:011212 (BUG)last \n prinyerd                                //~v45qI~
//v40b:010327 LINUX support:ajust after merge                      //~v40bI~
//v40a:010323 LINUX support:terminfo print option                  //~v40aI~
//v403:010306 AIX-X support:terminfo string                        //~v403I~
//v402:010306 AIX support:string print                             //~v402I~
//v400:010205 X support:for cursor key string not by terminfo for xterm/kterm//~v400I~
//*************************************************************    //~v19zI~
#include <stdlib.h>                                                //~0924R~
#include <stdio.h>                                                 //~0924I~
#include <string.h>                                                //~1122I~
                                                                   //~v40aI~
#ifdef UNX                                                         //~v40aI~
    #ifdef AIX                                                     //~v40bI~
		#include <ucurses.h>                                       //~v40bI~
    #else                                                          //~v51BI~
		#include <linux/keyboard.h>                                //~v51BI~
    #endif                                                         //~v40bI~
	#include <term.h>                                              //~v40aI~
#endif                                                             //~v40aI~
                                                                   //~1212I~
#ifdef OS2                                                         //~1212I~
    #define INCL_BASE                                              //~1212I~
    #include <os2.h>                                               //~1212I~
#endif                                                             //~1212I~
//**********************                                           //~0924I~
#include <ulib.h>                                                  //~v30eI~
#include <uque.h>                                                  //~1122R~
#include <ukbd.h>                                                  //~v30eI~
#include <uvio.h>                                                  //~1128I~
#ifdef UNX                                                         //~1128I~
	#include <uviol.h>                                             //~1128R~
	#include <ukbdl.h>                                             //~v51zI~
        #ifdef LNX                                                 //~1129I~
			#include <ukbdlnxc.h>                                  //~1129I~
			#include <ukbdlnxm.h>                                  //~v53mI~
        #else                                                      //~1129I~
			#include <ukbdlnxc.h>                                  //~v51YI~
			#include <ukbdaixt.h>                                  //~1129R~
        #endif                                                     //~1129I~
#endif                                                             //~1128I~
#include <uerr.h>                                                  //~1122I~
#include <udbcschk.h>                                              //~1122I~
#include <utrace.h>                                                //~1122I~
#include <ufile.h>                                                 //~v518I~
#include <uedit.h>                                                 //~v53mI~
//#include <ucurses.h>                                             //~1122R~
//**********************                                           //~v30eI~
//#ifdef UNX                                                       //~v518R~
//#else                                                            //~v518R~
	#define  GLOBAL                                            //~1129R~
//#endif                                                           //~v518R~
#include "xe.h"                                                    //~1128R~
#include "xegbl.h"                                                 //~1128R~
#include "xekbd.h"                                                 //~1128R~
#include "xescr.h"                                                 //~1128R~
#include "xecsr.h"                                                 //~v518I~
#include "xefunc.h"                                                //~1304I~
#include "xefunc2.h"                                               //~v518I~
                                                                   //~v705I~
#define GLOBAL_FUNCT                                               //~v705I~
#include "xefunct.h"                                               //~v518I~
                                                                   //~v705I~
#include "xepan.h"                                                 //~v518I~
#include "xefile.h"                                                //~v518I~
#include "xefile4.h"                                               //~v518I~
#include "xefile7.h"                                               //~v518I~
#include "xeopt.h"                                                 //~v518I~
#include "xeini2.h"                                                //~v518I~
//*************************************************************    //~0924I~
#undef VER      //for xegbl.h                                      //~v525I~
#define VER "v1.1"                                                 //~v525I~
#ifdef UNX                                                         //~v400R~
static char *Sstrfnm;                                              //~v403M~
static char *Sckfnm;                                               //~v40aI~
static char *Spreadbuff;                                           //~1304I~
static int  *Spreadlen;                                            //~1304I~
#ifdef LNX                                                         //~v51YI~
static long Sintvl=-1;  //use default                              //~v53mR~
static int Stermid=0;                                              //~v51BI~
#endif                                                             //~v51YI~
#endif                                                             //~v400I~
int xekbchk_main(void);                                            //~v30eI~
void printline(char *Pstr,int Pposy,int Pposx);                    //~1128I~
char *getshiftid(int);                                             //~v53mM~
int xekbchk_showmouse(KBDKEYINFO *Pkeyinf);                        //~v53mI~
//*************************************************************    //~v19ZI~
//helpmsg                                                          //~v19ZI~
//*********************************************************************//~v19ZI~
void helpmsg(void)                                                 //~v19ZI~
{                                                                  //~v19ZI~
#ifdef UNX                                                         //~v402I~
    #ifdef LNX                                                     //~v51zI~
//  char *optstr="[--n] [--cfilename] [--sfileneme]";              //~v51RR~
//  char *optstr="[--n] [--7{B|D|C}] [--cfilename] [--sfileneme]"; //~v53mR~
    char *optstr="[--n] [--Mi-j] [--7{B|D|C}] [--cfilename] [--sfileneme]";//~v53mR~
    #else                                                          //~v51zI~
//  char *optstr="[--cfilename] [--sfileneme]";                    //~v51YR~
//  char *optstr="[--cfilename] [--7{BS|DEL|CHAR}] [--sfileneme]"; //~v525R~
//  char *optstr="[--t] [--7{B|D|C}] [--cfilename] [--sfileneme]"; //~v53HR~
    char *optstr="[--tx] [--7{B|D|C}] [--cfilename] [--sfileneme]";//~v53HI~
    #endif                                                         //~v51zI~
#else                                                              //~v402I~
	char *optstr="";                                               //~v402I~
#endif                                                             //~v402I~
//********************************                                 //~v19ZI~
//#ifdef AIX                                                       //~v515R~
#ifdef UNX                                                         //~v515I~
    printf("%s: xekbchk [--h] %s [--kfilename]\n",VER,optstr);     //~v525R~
#else                                                              //~v30eI~
    printf("%s: xekbchk [--h] %s \n",VER,optstr);                  //~v525R~
#endif                                                             //~v30eI~
//#ifdef LNX                                                       //~v51YR~
#ifdef UNX                                                         //~v51YI~
	printf(" --7  : force assign 0x7f to BackSpace,Delete or Char 0x'7f'.\n");//~v51RR~
#ifdef LNX                                                         //~v51YI~
	printf("        default is by terminfo.\n");                   //~v51RI~
#else                                                              //~v51YI~
	printf("        default is BS for AIX.\n");                    //~v51YI~
#endif                                                             //~v51YI~
#endif                                                             //~v51RI~
	printf(" --h  : Help msg.\n");                                 //~v30eR~
#ifdef UNX                                                         //~1226I~
	printf(" --c  : Output curses-key by terminfo to the filename.\n");//~v40aI~
	printf(" --s  : Output strings assigned to key to the filename.\n");//~1304R~
#endif                                                             //~1226I~
#ifdef LNX                                                         //~v515I~
	printf(" --k  : key string specification file name.\n");       //~v515I~
	printf(" --n  : no set func-key-string to chk native console-string-setting.\n");//~v51zR~
#endif                                                             //~v515I~
#ifdef AIX                                                         //~v30eI~
	printf(" --k  : key string specification file name.\n");       //~v30eI~
    printf(" --t  : force TeraTerm keymap even if TERM!=vt100.(This is default)\n");//~v53HR~
//    printf(" --x  : execution under X.(default for aixterm).\n");//~v526R~
    printf(" --x  : force Not TeraTerm keymap even if TERM==vt100.\n");//~v53HI~
#endif                                                             //~v30eI~
#ifdef LNX                                                         //~v53mI~
	printf(" --M  : mouse click interval and dblclick interval by 0.1 sec.\n");//~v53mR~
	printf("        i:down->up interval for clisk, j:up->down interval for dblclick.\n");//~v53mR~
	printf("        default %d-%d.\n",UKLM_CLICK_INTVL,UKLM_DBLCLICK_INTVL);//~v53mR~
#endif                                                             //~v53mI~
	return;                                                        //~v19ZI~
}//helpmsg                                                         //~v19ZI~
//*************************************************************    //~0924I~
//default kbd opt                                                  //~0924I~
//*********************************************************************//~0229I~
int main(int argc,char **argp)
{
    int ii;                                                        //~1128R~
    char *pc;                                                      //~v30eR~
#ifdef UNX                                                         //~1128I~
#ifdef AIX                                                         //~v30eI~
    int opt;                                                       //~v51YI~
//    int   xxtermsw=0;                                            //~v526R~
    char *cnffnm=0;                                                //~v30eI~
#else                                                              //~v402I~
    int opt;                                                       //~v402M~
    int nosetstringsw=0;                                           //~v51zI~
    char *cnffnm=0;                                                //~v515I~
    long intvlclick,intvldblclick;                                 //~v53mI~
    int rc;                                                        //~v53mI~
#endif                                                             //~v30eI~
#endif                                                             //~1128I~
//********************************
#ifdef LNX                                                         //~v402R~
	opt=0                                                          //~0924I~
       +UKBDL_USEALTL  //  0x01      //use altL as ALT func key    //~v524R~
       +UKBDL_USEALTR  //  0x02      //use altR as ALT func key    //~v524R~
       +UKBDL_COMPOSE  //0x0100      //set katakana composer       //~v524R~
       +UKBDL_CURSES   //0x1000      //use curses                  //~v524R~
       +UKBDL_MONO 	//mono color                                   //~v524R~
       +0x00000fc0     //pf7-pf12    //alt+pfn usage               //~0924I~
       ; 		//default option to ukbdlnxc.c                     //~0924I~
#endif                                                             //~1128I~
#ifdef AIX                                                         //~v51YI~
	opt=0;                                                         //~v51YI~
    opt|=UKBDL_TNTT;	//default                                  //~v53HI~
#endif                                                             //~v51YI~
//select parm to xe                                                //~0924I~
    for (ii=1;ii<argc;ii++)                                        //~0807I~
    {                                                              //~0807I~
    	pc=argp[ii];                                               //~0924I~
        if (*pc!='-'||*(pc+1)!='-')                                //~v526I~
        {                                                          //~v53pI~
//          continue;                                              //~v53pR~
            printf("parm err(%s)\n",pc);                           //~v53pI~
            exit(1);                                               //~v53pI~
        }                                                          //~v53pI~
        pc+=2;                                                     //~v30eI~
//#ifdef AIX                                                       //~v515R~
#ifdef UNX		//aix and linux                                    //~v515I~
        if (*pc=='K' || *pc=='k')                                  //~v30eI~
        {                                                          //~v30eI~
            cnffnm=pc+1;                                           //~v30eI~
            continue;                                              //~v30eI~
        }                                                          //~v30eI~
#endif                                                             //~v30eI~
//#ifdef LNX                                                       //~v51YR~
#ifdef UNX                                                         //~v51YI~
        if (*pc=='7')                                              //~v51RI~
        {                                                          //~v51RI~
            switch(*(pc+1))                                        //~v51RI~
            {                                                      //~v51RI~
            case 'B':                                              //~v51RI~
            case 'b':                                              //~v51RI~
                opt|=UKBDL_7fBS;                                   //~v524R~
                break;                                             //~v51RI~
            case 'D':                                              //~v51RI~
            case 'd':                                              //~v51RI~
                opt|=UKBDL_7fDEL;                                  //~v524R~
                break;                                             //~v51RI~
            case 'C':                                              //~v51RI~
            case 'c':                                              //~v51RI~
                opt|=UKBDL_7fCHAR;                                 //~v524R~
                break;                                             //~v51RI~
            default:                                               //~v51RI~
                printf("parm err(%s)\n",pc);                       //~v51RR~
                helpmsg();                                         //~v51RI~
                exit(1);                                           //~v51RI~
            }                                                      //~v51RI~
            continue;                                              //~v51RI~
        }                                                          //~v51RI~
#endif                                                             //~v51RM~
        for (;*pc;pc++)                                            //~v30eR~
        	switch(*pc)                                            //~v19JI~
            {                                                      //~v19JI~
#ifdef UNX                                                         //~v40aI~
            case 'C':                                              //~v40aI~
            case 'c':                                              //~v40aI~
            	Sckfnm=pc+1;                                       //~v40aI~
//                if (!*Sckfnm)                                    //~v53kR~
//                {                                                //~v53kR~
//                    printf("specify output filename for curses-key print\n");//~v53kR~
//                    exit(1);                                     //~v53kR~
//                }                                                //~v53kR~
                pc+=strlen(pc)-1;                                  //~v40aI~
                break;                                             //~v40aI~
#endif                                                             //~v40aI~
            case 'H':                                              //~v19ZI~
            case 'h':                                              //~v19ZI~
            	helpmsg();                                         //~v19ZI~
            	exit(0);                                           //~v19ZI~
                break;                                             //~v19ZI~
#ifdef UNX                                                         //~1226I~
            case 'S':                                              //~1226I~
            case 's':                                              //~1226I~
            	Sstrfnm=pc+1;                                      //~1226R~
//                if (!*Sstrfnm)                                   //~v53kR~
//                {                                                //~v53kR~
//                    printf("specify output filename for string\n");//~v53kR~
//                    exit(1);                                     //~v53kR~
//                }                                                //~v53kR~
                pc+=strlen(pc)-1;                                  //~1226R~
                break;                                             //~1226I~
#ifdef LNX                                                         //~v53mI~
            case 'M':                                              //~v53mI~
                if (!*(pc+1))                                      //~v53mI~
                {                                                  //~v53mI~
                	printf("parm format err(%s)\n",pc);            //~v53mI~
                    exit(1);                                       //~v53mI~
                }                                                  //~v53mI~
                rc=ugetnumrange(pc+1,&intvlclick,&intvldblclick);  //~v53mI~
                switch (rc)                                        //~v53mI~
                {                                                  //~v53mI~
                case 0:                                            //~v53mR~
                	intvldblclick=UKLM_DBLCLICK_INTVL;             //~v53mI~
                    break;                                         //~v53mI~
                case 1:                                            //~v53mR~
                    break;                                         //~v53mI~
                default:                                           //~v53mI~
                	printf("parm format err(%s)\n",pc);            //~v53mI~
                    exit(1);                                       //~v53mR~
                }                                                  //~v53mI~
                Sintvl=(intvlclick<<16)+intvldblclick;             //~v53mR~
                for (;*pc;pc++)                                    //~v53mI~
                	if (*pc==' ')                                  //~v53mI~
                    	break;                                     //~v53mI~
                pc--;                                              //~v53mI~
                break;                                             //~v53mI~
#endif                                                             //~v53mI~
#ifdef AIX                                                         //~v483R~
            case 'T':                                              //~v525I~
            case 't':                                              //~v525I~
                opt|=UKBDL_TNTT;                                   //~v525I~
                opt&=~UKBDL_TNLNX;      //reset linux              //~v53HI~
                break;                                             //~v525I~
//            case 'X':                                            //~v526R~
//            case 'x':                                            //~v526R~
//                xxtermsw=1;                                      //~v526R~
//                break;                                           //~v526R~
            case 'X':                                              //~v53HI~
            case 'x':                                              //~v53HI~
                opt&=~UKBDL_TNTT; //reset teraterm                 //~v53HI~
                opt|=UKBDL_TNLNX; //set linux                      //~v53HI~
                break;                                             //~v53HI~
#else                                                              //~v51zI~
            case 'N':                                              //~v51zI~
            case 'n':                                              //~v51zI~
                nosetstringsw=1;                                   //~v51zI~
                break;                                             //~v51zI~
#endif                                                             //~v483R~
#endif                                                             //~1226I~
            default:                                               //~v19JI~
            	printf("parm err(%c)\n",*pc);                      //~v19ZR~
                helpmsg();                                         //~v19ZR~
                exit(1);                                           //~v19JI~
            }                                                      //~v19JI~
    }                                                              //~0807I~
//**********                                                       //~0924I~
#ifdef UNX                                                         //~v402R~
//  #ifdef LNX                                                     //~v51ZR~
    	xesetkbdopt(opt);//tell to xe                              //~v402R~
//  #endif                                                         //~v51ZR~
#ifdef AIX                                                         //~v30eI~
//    if (xxtermsw)                                                //~v526R~
//        Gkbdaixt_opt|=GKBAIX_XXTERM;                             //~v526R~
    if (cnffnm)                                                    //~v30eI~
//  	ukbdaixt_chngttkey(cnffnm);                                //~v525R~
    	ukbdaixt_chngttkey(opt,cnffnm);                            //~v525I~
#else                                                              //~v515I~
    if (nosetstringsw)                                             //~v51zI~
		Gukbdl_flag|=GUKBDL_NOSETSTR;  //bypass setstring of console//~v51zR~
    Stermid=ukbdl_gettermid();                                     //~v51BI~
    if (cnffnm)                                                    //~v515I~
    	ukbdlnxc_chngttkey(cnffnm);                                //~v515I~
#endif                                                             //~v515R~
#endif                                                             //~1128I~
    return xekbchk_main();                                         //~v30eR~
}//main
//******************************************************************//~v30eI~
int xekbchk_main(void)                                             //~v30eI~
{                                                                  //~v30eI~
int xekbchk_kbdproc(void);                                         //~1122I~
#ifdef UNX                                                         //~1226I~
    void xekbchk_printstring(void);                                //~v402R~
	void xekbchk_ckprint(char *Poutfnm);                           //~v40aR~
#endif                                                             //~1226I~
    char *pc1st;                                                   //~1128I~
//********************************                                 //~v30eI~
    gblinit();          //to avoid 0c4 for Gunpdispchartblj clear ar gblkon//~v400I~
//  funcinit();                                                    //~v518R~
//#ifdef LNX                                                       //~v52eR~
#ifdef UNX                                                         //~v52eI~
//  funcinit();                                                    //~v705R~
  #ifdef LNX                                                       //~v705I~
    funcinit("lnx");                                               //~v705I~
  #else                                                            //~v705I~
    funcinit("aix");                                               //~v705I~
  #endif                                                           //~v705I~
#endif                                                             //~v51CI~
    scrinit(0);                                                    //~v47mR~
    kbdinit();                                                     //~1122M~
#ifdef UNX                                                         //~1128M~
	if (Sckfnm)                                                    //~v40aI~
    {                                                              //~v40aI~
        kbdterm() ;                                                //~v53pI~
        scrreset();                                                //~v53pR~
    	xekbchk_ckprint(Sckfnm);                                   //~v40aI~
    }                                                              //~v40aI~
    else                                                           //~v40aI~
	if (Sstrfnm)                                                   //~1226R~
    {                                                              //~1226I~
        kbdterm() ;                                                //~v53pI~
        scrreset();                                                //~v53pR~
    	xekbchk_printstring();                                     //~1226I~
    }                                                              //~1226I~
    else                                                           //~1226I~
    {                                                              //~1226I~
#else                                                              //~1128M~
    scrcls(" \x07");                                               //~1128M~
#endif                                                             //~1128M~
#ifdef UNX                                                         //~v402R~
    #ifdef AIX                                                     //~v402I~
		ukbdaixt_gettbl(0,0,&Spreadbuff,&Spreadlen);               //~v402I~
    #else                                                          //~v402I~
	    ukbdlnxm_mouseopt(Sintvl);                                 //~v53mR~
		ukbdlnxc_gettbl(0,0,&Spreadbuff,&Spreadlen);               //~v402R~
    #endif                                                         //~v402I~
#endif                                                             //~v400I~
    pc1st="Hit any key; exit when doubled 'q'";                    //~1128I~
    printline(pc1st,1,1);                                          //~1128I~
    for (;;)    //until quit                                       //~v30eI~
    {                                                              //~v30eI~
        if (xekbchk_kbdproc()==-1)  //quit                         //~v30eI~
            break;                                                 //~v30eI~
    }                                                              //~v30eI~
    kbdterm();  //restore kbd rate at entry                        //~v53pI~
    scrterm();                                                     //~v53pI~
#ifdef UNX                                                         //~v400I~
    }//not string print                                            //~1226I~
#endif                                                             //~v400I~
//  kbdterm();  //restore kbd rate at entry                        //~v53pR~
//  scrterm();                                                     //~v53pR~
#ifdef UNX                                                         //~1304I~
	if (Sckfnm)                                                    //~v40aI~
    {                                                              //~v40aI~
    	printf("Curses-key printed to %s.\n",Sckfnm);              //~v51BR~
    }                                                              //~v40aI~
    else                                                           //~v40aI~
	if (Sstrfnm)                                                   //~1304I~
    {                                                              //~1304I~
    	printf("String printed to %s.\n",Sstrfnm);                 //~v51BR~
    }                                                              //~1304I~
#endif                                                             //~1304I~
    return 0;                                                      //~1122I~
}//xekbchk_main                                                    //~v30eI~
//**************************************************               //~v30eI~
//*get keyboard input and call key function                        //~v30eI~
//*rc   :rc from key function(-1 for quit)                         //~v30eI~
//**************************************************               //~v30eI~
//scancode/charcode                                                //~v30eI~
//      xx/yy:scan code/char code                                  //~v30eI~
//      00/yy:,Sp                                        //~v30eI~
//      xx/00:psude scancode                                       //~v30eI~
//      xx/e0:psude scancode                                       //~v30eI~
int xekbchk_kbdproc(void)                                          //~v30eI~
{                                                                  //~v30eI~
int xekbchk_showkey(int Pkeytyep,char *Pscanchar,int Pshift);      //~1122I~
    int rc;                                                        //~v30eI~
    int keytype;                                                   //~v30eI~
    KBDKEYINFO keyinf,keyinf2;                                     //~v30eI~
    UCHAR inputc[3];                                               //~v30eI~
    int shift;                                                     //~v30eI~
//**********************                                           //~v30eI~
    inputc[2]=0;                                                   //~v30eI~
    ukbdcharin(&keyinf,IO_WAIT);                                   //~v30eI~
UTRACED("ukbdcharin",&keyinf,sizeof(keyinf));                      //~v30eI~
#ifdef LNX                                                         //~v53mM~
    if (keyinf.chScan==UKLM_MOUSEID)                               //~v53mM~
    {                                                              //~v53mM~
    	xekbchk_showmouse(&keyinf);	                               //~v53mM~
        return 0;                                                  //~v53mM~
    }                                                              //~v53mM~
#endif                                                             //~v53mM~
    if (keyinf.chChar==0x0d && keyinf.chScan==0)    //0x000d       //~v30eI~
        *((USHORT*)(PVOID)(&keyinf.chChar))=KEY_ENTER;// 0xe00d force execute//~v30eI~
    if (!keyinf.chChar && !keyinf.chScan)   //break                //~v30eI~
        uerrexit("Break Key accepted",0);                          //~v30eI~
//    if (keyinf.chScan==KEY_PENTRID)                              //~1128R~
//    {                                                            //~1128R~
//        if (keyinf.chChar!=(KEY_PDIVIDE_CHK&255))//it char       //~1128R~
//        {                                                        //~1128R~
//            keyinf.chScan=keyinf.chChar;                         //~1128R~
//            keyinf.chChar=0;            //trate as ext key       //~1128R~
//        }                                                        //~1128R~
//    }                                                            //~1128R~
    if (keyinf.chChar==0x00 || keyinf.chChar==0xe0) //0x00 or 0xE0 //~v30eI~
    {                                                              //~v30eI~
        keytype=0;                                                 //~v30eI~
        inputc[0]=keyinf.chScan;    //psude code                   //~v30eI~
        inputc[1]=0;                                               //~v30eI~
    }                                                              //~v30eI~
    else                                                           //~v30eI~
    {                                                              //~v30eI~
        keytype=1;                                                 //~v30eI~
        inputc[0]=keyinf.chChar;    //char code                    //~v30eI~
        inputc[1]=keyinf.chScan;    //scan code                    //~v30eI~
        if (!keyinf.chScan)                                        //~v30eI~
        {                                                          //~v30eI~
            if (udbcschk(keyinf.chChar))            //DBCS         //~v30eI~
            {                                                      //~v30eI~
                keytype=2;                                         //~v30eI~
                ukbdcharin(&keyinf2,IO_WAIT);                      //~v30eI~
                UTRACED("ukbdcharin DBCS",&keyinf2,sizeof(keyinf2));//~v30eI~
                inputc[1]=keyinf2.chChar;       //2ndbyte          //~v30eI~
            }                                                      //~v30eI~
        }                                                          //~v30eI~
    }//char code                                                   //~v30eI~
                                                                   //~v30eI~
    shift=keyinf.fsState;    //shift key status                    //~v30eI~
    rc=xekbchk_showkey(keytype,inputc,shift);                      //~v30eI~
    return rc;                                                     //~v30eI~
}//kbdproc                                                         //~v30eI~
//**************************************************               //~v30eI~
//*show key                                                        //~v30eI~
//*rc   :rc -1:when double 'q' entered                             //~v30eI~
//**************************************************               //~v30eI~
int xekbchk_showkey(int Pkeytype,char *Pscanchar,int Pshift)       //~1122R~
{                                                                  //~v30eI~
#ifdef UNX                                                         //~v400I~
	int ii,pos;                                                    //~v400I~
	char *pc;                                                      //~v400I~
#endif                                                             //~v400I~
static int Sqctr=0;                                                //~v402R~
	int ch1,ch2,key;                                               //~v400R~
	char *shiftid,*keynm;                                          //~v51YR~
    char printwk[128];                                             //~1128I~
#define  LINE_STRING   3                                           //~1304R~
#define  LINE_KEY      4                                           //~1304R~
#define  LINE_CODE     5                                           //~1304R~
//**********************                                           //~v30eI~
	shiftid=getshiftid(Pshift);                                    //~v30eI~
    ch1=*Pscanchar;                                                //~1122I~
    ch2=*(Pscanchar+1);                                            //~1122I~
	if (Pkeytype)                                                  //~1122I~
    	keynm="normal";                                            //~v51YR~
    else                                                           //~1122I~
    {                                                              //~1122I~
    	key=(ch1<<8);                                              //~1122I~
		keynm=kbdgetname((USHORT)key,0);                           //~v51YR~
    }                                                              //~1122I~
#ifdef UNX                                                         //~v400I~
    sprintf(printwk,"Input String(len=%d)=",*Spreadlen);           //~1304R~
    printline(printwk,LINE_STRING,1);                              //~1304R~
    pos=strlen(printwk)+1;                                         //~1304R~
    for (ii=0,pc=Spreadbuff;ii<*Spreadlen;ii++,pc++)               //~1304R~
    {                                                              //~1304I~
    	if (*pc<' ' || *pc>0x7e)                                   //~1304R~
 		   	sprintf(printwk,"0x%02x",*pc);                         //~1304R~
        else                                                       //~1304I~
 		   	sprintf(printwk,"%c",*pc);                             //~1304R~
    	printline(printwk,LINE_STRING,pos);                        //~1304R~
        pos+=strlen(printwk);                                      //~1304I~
    }                                                              //~1304I~
#endif                                                             //~v400M~
    sprintf(printwk,"shift=%04x=%s: key=%s",Pshift,shiftid,keynm); //~v51YR~
    printline(printwk,LINE_KEY,1);                                 //~1304R~
	switch(Pkeytype)                                               //~v30eI~
    {                                                              //~v30eI~
    case 1:	//sbcs                                                 //~v30eI~
//  	if (ch2>=' ' && ch2<=0x7f)                                 //~v51ZR~
    	if (ch1>=' ' && ch1<=0x7f)                                 //~v51ZI~
//      	sprintf(printwk,"sbcs:%s:scan=x%02X/char=%02X=%c\n",shiftid,ch2,ch1,ch1);//~v45qR~
//      	sprintf(printwk,"sbcs:%s:scan=x%02X/char=%02X=%c",shiftid,ch2,ch1,ch1);//~v51bR~
        	sprintf(printwk,"sbcs:%s:scan=x%02X/char=%02X=%c%c",shiftid,ch2,ch1,ch1,0);//~v51bI~
        else                                                       //~v30eI~
//      	sprintf(printwk,"sbcs:%s:scan=x%02X/char=%02X\n",shiftid,ch2,ch1);//~v45qR~
//        	sprintf(printwk,"sbcs:%s:scan=x%02X/char=%02X",shiftid,ch2,ch1);//~v51bR~
          	sprintf(printwk,"sbcs:%s:scan=x%02X/char=%02X,%c",shiftid,ch2,ch1,0);//~v51bI~
	    printline(printwk,LINE_CODE,1);                            //~1304R~
        if (ch1=='q'||ch1=='Q')                                    //~1122R~
        	Sqctr++;                                               //~v30eI~
        if (Sqctr>1)                                               //~v30eI~
        	return -1;                                             //~v30eI~
    	break;                                                     //~v30eI~
    case 2:	//dbcs                                                 //~v30eI~
    	Sqctr=0;                                                   //~v30eI~
//      sprintf(printwk,"dbcs:0x%02X%02X=%c%c\n",ch1,ch2,ch1,ch2); //~v45qR~
//      sprintf(printwk,"dbcs:0x%02X%02X=%c%c",ch1,ch2,ch1,ch2);   //~v51bR~
        sprintf(printwk,"dbcs:0x%02X%02X=%c%c%c",ch1,ch2,ch1,ch2,0);//~v51bI~
	    printline(printwk,LINE_CODE,1);                            //~1304R~
    	break;                                                     //~v30eI~
    default:                                                       //~v30eI~
    	Sqctr=0;                                                   //~v30eI~
//      sprintf(printwk,"extk:scan=0x%02X/%02X\n",ch1,ch2);        //~v45qR~
//	    sprintf(printwk,"extk:scan=0x%02X/%02X",ch1,ch2);          //~v51bR~
  	    sprintf(printwk,"extk:scan=0x%02X/%02X%c",ch1,ch2,0);      //~v51bI~
	    printline(printwk,LINE_CODE,1);                            //~1304R~
    	break;                                                     //~v30eI~
    }                                                              //~v30eI~
    return 0;                                                      //~1122I~
}//xekbchk_showkey                                                 //~v30eI~
#ifdef LNX                                                         //~v53mI~
//**************************************************               //~v53mI~
//*show key                                                        //~v53mI~
//*rc   :rc -1:when double 'q' entered                             //~v53mI~
//**************************************************               //~v53mI~
int xekbchk_showmouse(KBDKEYINFO *Pkeyinf)                         //~v53mI~
{                                                                  //~v53mI~
    char printwk[128],*click,*modx,*pc;                            //~v53mR~
static char Sprintwk[128];                                         //~v53mR~
    int posx,posy,ch,button,pos,ii,upsw;                           //~v53mR~
static int Sdownposx,Sdownposy;                                    //~v55QR~
//**********************                                           //~v53mI~
    sprintf(printwk,"Input String(len=%d)=",*Spreadlen);           //~v53mI~
    printline(printwk,LINE_STRING,1);                              //~v53mI~
    pos=strlen(printwk)+1;                                         //~v53mI~
    for (ii=0,pc=Spreadbuff;ii<*Spreadlen;ii++,pc++)               //~v53mI~
    {                                                              //~v53mI~
    	if (*pc<' ' || *pc>0x7e)                                   //~v53mI~
 		   	sprintf(printwk,"0x%02x",*pc);                         //~v53mI~
        else                                                       //~v53mI~
 		   	sprintf(printwk,"%c",*pc);                             //~v53mI~
    	printline(printwk,LINE_STRING,pos);                        //~v53mI~
        pos+=strlen(printwk);                                      //~v53mI~
    }                                                              //~v53mI~
    posx=Pkeyinf->chMouseposx;                                     //~v53mR~
    posy=Pkeyinf->chMouseposy;                                     //~v53mR~
    ch=Pkeyinf->chChar;                                            //~v53mI~
    button=ch & 0x03;                                              //~v53mI~
//status                                                           //~v53mI~
    upsw=0;                                                        //~v53mR~
    if (ch & UKLM_CLICK)                                           //~v53mI~
        click="Click";                                             //~v53mI~
    else                                                           //~v53mI~
    if (ch & UKLM_DBLCLICK)                                        //~v53mI~
        click="DblClick";                                          //~v53mI~
    else                                                           //~v53mI~
    if (ch & UKLM_TRPCLICK)                                        //~v53mI~
        click="TrplClick";                                         //~v53mI~
    else                                                           //~v53mI~
    if (ch & UKLM_DOWN)                                            //~v53mI~
    {                                                              //~v55QI~
        click="Down";                                              //~v53mI~
        Sdownposx=posx;	//for move chk                             //~v55QI~
        Sdownposy=posy;                                            //~v55QI~
    }                                                              //~v55QI~
    else                                                           //~v53mI~
    {                                                              //~v53mI~
        if (posx!=Sdownposx || posy!=Sdownposy)                    //~v55QR~
        click="Move";                                              //~v55QI~
        else                                                       //~v55QI~
        click="Up";                                                //~v53mI~
        upsw=1;                                                    //~v53mR~
    }                                                              //~v53mI~
//modifier                                                         //~v53mM~
	modx=getshiftid(Pkeyinf->fsState);                             //~v53mI~
                                                                   //~v53mI~
    sprintf(printwk,"mouse:pos=(%2d,%2d),button=%-6s %d,status=%-9s",posx,posy,modx,button+1,click);//~v53mR~
    if (upsw)                                                      //~v53mI~
    {                                                              //~v53mI~
		printline(Sprintwk,LINE_KEY,1);                            //~v53mI~
		printline(printwk,LINE_CODE,1);                            //~v53mR~
    }                                                              //~v53mI~
    else                                                           //~v53mI~
    {                                                              //~v53mI~
		printline(printwk,LINE_KEY,1);                             //~v53mI~
		printline(" ",LINE_CODE,1);                                //~v53mI~
        memcpy(Sprintwk,printwk,sizeof(Sprintwk));                 //~v53mR~
    }                                                              //~v53mI~
    return 0;                                                      //~v53mI~
}//xekbchk_showmouse                                               //~v53mI~
#endif                                                             //~v53mI~
//********************************************************************//~v30eI~
char *getshiftid(int Pshift)                                       //~1122R~
{                                                                  //~v30eI~
static	char Sshiftid[64];                                         //~v30eI~
//******************************	                               //~v30eI~
	Sshiftid[0]=0;                                                 //~1122R~
	if (Pshift & (KBDSTF_RIGHTSHIFT|KBDSTF_LEFTSHIFT))             //~v30eI~
    	strcat(Sshiftid,"Shift+");                                 //~v30eI~
	if (Pshift & (KBDSTF_CONTROL|KBDSTF_LEFTCONTROL|KBDSTF_RIGHTCONTROL))//~v30eI~
    	strcat(Sshiftid,"Ctrl+");                                  //~v30eI~
	if (Pshift & (KBDSTF_ALT))                                     //~v30eI~
    	strcat(Sshiftid,"Alt+");                                     //~v30eI~
	if (Pshift & (KBDSTF_LEFTALT))                                 //~v30eI~
    	strcat(Sshiftid,"L-Alt+");                                   //~v30eI~
	if (Pshift & (KBDSTF_RIGHTALT))                                //~v30eI~
    	strcat(Sshiftid,"R-Alt+");                                   //~v30eI~
    return Sshiftid;                                               //~v30eI~
}//getshiftid                                                      //~v30eI~
void printline(char *Pstr,int Pposy,int Pposx)                     //~1128R~
{                                                                  //~1128I~
	char space[80];                                                //~1128I~
//****************************                                     //~1128I~
	memset(space,' ',sizeof(space));                               //~1128M~
    uviowrtcharstr(space,sizeof(space),Pposy,Pposx);               //~1128I~
    uviowrtcharstr(Pstr,(int)strlen(Pstr),Pposy,Pposx);            //~1212R~
#ifdef UNX                                                         //~1128I~
    uviol_refresh();                                               //~1128M~
#endif                                                             //~1128I~
    return;                                                        //~1128I~
}                                                                  //~1128I~
#ifdef UNX                                                         //~1226I~
#ifdef LNX                                                         //~v402I~
//*********************************************************************//~1226I~
//* print string                                                   //~1226I~
//*********************************************************************//~1226I~
void xekbchk_printstring(void)                                     //~1226I~
{                                                                  //~1226I~
	int jj,modx,pfktno,keysym;                                     //~v51BR~
	PFUNCKEYTBL *ppfkt,pfkt;                                       //~1304R~
	PFUNCSTRTBL pfst;                                              //~1226I~
    FILE *fh;                                                      //~1226I~
    char *xestr,*tistr,tistrwk[32],xestrwk[32],*infoid;            //~v51BR~
    char linehdr[80],tistrwk2[48];                                 //~v51BR~
    char *userparm;                                                //~v51BR~
static char *Sshiftid[4]={" ","+Shift","+Ctrl","+Alt"};            //~1304R~
	int ttyconsw,kk;                                               //~v51BR~
    char *envterm;                                                 //~v51BR~
//************************                                         //~1226I~
	ttyconsw=((Stermid & TERM_IDMASK)==TERM_TTYLCONS);             //~v51BI~
  if (*Sstrfnm)                                                    //~v53kI~
  {                                                                //~v53kI~
    fh=fopen(Sstrfnm,"w");                                         //~1226R~
    if (!fh)                                                       //~1226I~
        uerrexit("%s open failed",0,                               //~1226I~
                    Sstrfnm);                                      //~1226R~
  }                                                                //~v53kI~
  else                                                             //~v53kI~
    fh=stdout;                                                     //~v53kI~
    envterm=getenv("TERM");                                        //~v51BI~
    if (ttyconsw)                                                  //~v51BR~
    	fprintf(fh,"\n##### key string table for Console mode (TERM=%s) #####\n",envterm);//~v53pR~
    else                                                           //~v51BI~
    	fprintf(fh,"\n##### key string table for X mode       (TERM=%s) #####\n",envterm);//~v53pR~
//#ifdef AIX                                                       //~v51BR~
//    ukbdaixt_gettbl(&ppfkt,&pfktno,0,0);                         //~v51BR~
//#else                                                            //~v51BR~
	ukbdlnxc_gettbl(&ppfkt,&pfktno,0,0);                           //~1304R~
//#endif                                                           //~v51BR~
    for (jj=0;jj<pfktno;jj++,ppfkt++)        //keycode             //~1304R~
    {                                                              //~1304I~
    	pfkt=*ppfkt;                                               //~1304I~
    	for (modx=0;modx<4;modx++)                                 //~1304I~
        {                                                          //~1304I~
            keysym=pfkt->FKTfkassign[modx];                        //~1304I~
            if (!modx && !keysym)                                  //~1304I~
                keysym=pfkt->FKTsymid;                             //~1304I~
//          userparm=pfkt->FKTttstring[modx];	//by key file      //~v51BR~
            pfst=pfkt->FKTpfst[modx];                              //~1304I~
//          if (userparm)                                          //~v51BR~
//            xestr=userparm;                                      //~v51BR~
//          else                                                   //~v51BR~
//            if (pfst)                                            //~v51BR~
//            {                                                    //~v51BR~
//                xestr=pfst->FSTstrnew;                           //~v51BR~
//                if (!xestr)                                      //~v51BR~
//                    xestr="";                                    //~v51BR~
//            }                                                    //~v51BR~
//            else                                                 //~v51BR~
//                xestr="";                                        //~v51BR~
//            tistr=pfkt->FKTterminfo[modx];                       //~v51BR~
//            *tistrwk=0;                                          //~v51BR~
//            if (pfkt->FKTflag[modx] & FKT_TTREPKEY)              //~v51BR~
//                infoid2="user-parm  ";                           //~v51BR~
//            else                                                 //~v51BR~
//                infoid2="";                                      //~v51BR~
//            if (pfkt->FKTflag[modx] & FKT_USEXTERM)              //~v51BR~
//                infoid="xterm/kterm";                            //~v51BR~
//            else                                                 //~v51BR~
//                infoid="terminfo   ";                            //~v51BR~
//            if (tistr)          //terminfo defined               //~v51BR~
//            {                                                    //~v51BR~
//                if (*xestr)     //xe assigned string             //~v51BR~
//                {                                                //~v51BR~
//                    if (*tistr==0x1b)                            //~v51BR~
////                      sprintf(tistrwk,"(!= %s:^[%s)",infoid,tistr+1);//~v51BR~
//                        sprintf(tistrwk,"(%s!= %s:^[%s)",infoid2,infoid,tistr+1);//~v51BR~
//                    else                                         //~v51BR~
//                    {                                            //~v51BR~
////                      sprintf(tistrwk,"(!= %s:",infoid);       //~v51BR~
//                        sprintf(tistrwk,"(%s!= %s:",infoid2,infoid);//~v51BR~
//                        pc=tistrwk+strlen(tistrwk);              //~v51BR~
//                        for (ii=0;ii<strlen(tistr);ii++)         //~v51BR~
//                            pc+=sprintf(pc,"0x%02x ",*(tistr+ii));//~v51BR~
//                    }                                            //~v51BR~
//                }                                                //~v51BR~
//                else                                             //~v51BR~
//                {                                                //~v51BR~
//                    xestr=tistr;                                 //~v51BR~
//                    sprintf(tistrwk,"(== %s)",infoid);           //~v51BR~
//                }                                                //~v51BR~
//            }                                                    //~v51BR~
//            else                                                 //~v51BR~
//                if (userparm)                                    //~v51BR~
//                    sprintf(tistrwk,"(== %s)",infoid2);          //~v51BR~
//            if (*xestr)                                          //~v51BR~
//            {                                                    //~v51BR~
//                if (*xestr==0x1b)                                //~v51BR~
//                    sprintf(xestrwk,"^[%s",xestr+1);             //~v51BR~
//                else                                             //~v51BR~
//                {                                                //~v51BR~
//                    pc=xestrwk;                                  //~v51BR~
//                    for (ii=0;ii<strlen(xestr);ii++)             //~v51BR~
//                        pc+=sprintf(pc,"0x%02x ",*(xestr+ii));   //~v51BR~
//                }                                                //~v51BR~
//                fprintf(fh,"%-6s(sym=%04x):%-6s(sym=%04x),string=%-12s %s\n",//~v51BR~
//                        pfkt->FKTkeyname,                        //~v51BR~
//                        pfkt->FKTsymid,                          //~v51BR~
//                        Sshiftid[modx],                          //~v51BR~
//                        keysym,                                  //~v51BR~
//                        xestrwk,                                 //~v51BR~
//                        tistrwk);                                //~v51BR~
//            }                                                    //~v51BR~
            tistr=pfkt->FKTterminfo[modx];                         //~v51BM~
            sprintf(linehdr,"%-6s(sym=%04x):%-6s(sym=%04x)",       //~v51BR~
                        pfkt->FKTkeyname,                          //~v51BM~
                        pfkt->FKTsymid,                            //~v51BM~
                        Sshiftid[modx],                            //~v51BM~
                        keysym);                                   //~v51BI~
            if (ttyconsw)                                          //~v51BM~
            {                                                      //~v51BM~
                xestr="";                                          //~v51BM~
                if (keysym==0x08 && pfkt->FKTkeycode)   //backspace defined on keymap//~v51BI~
                {                                                  //~v51BI~
                    xestr="\x08";                                  //~v51BI~
                    tistr=0;    //ignore terminfo,                 //~v51BI~
                 }                                                 //~v51BI~
                else                                               //~v51BI~
                if (keysym==K_REMOVE && pfkt->FKTkeycode)   //del by 7f//~v51BI~
                {                                                  //~v51BI~
                    xestr="\x7f";                                  //~v51BI~
                    tistr=0;                                       //~v51BI~
                }                                                  //~v51BI~
                else                                               //~v51BI~
                if (pfst)                                          //~v51BM~
                {                                                  //~v51BM~
                    if (pfst->FSTstrnew)                           //~v51BM~
                        xestr=pfst->FSTstrnew;                     //~v51BM~
                    else                                           //~v51BM~
                    if (pfst->FSTstrold)                           //~v51BM~
                        xestr=pfst->FSTstrold;                     //~v51BM~
                }                                                  //~v51BM~
                if (*xestr||tistr)                                 //~v51BI~
                {                                                  //~v51BI~
                    ukbdl_editstring(xestr,xestrwk);               //~v51BR~
                    if (tistr)                                     //~v51BI~
                    {                                              //~v51BI~
                        ukbdl_editstring(tistr,tistrwk);           //~v51BR~
                		if (pfkt->FKTflag[modx][0]==FKT_USEORGSTR)	//use terminfo str//~v51BI~
                        {                                          //~v51BI~
                        	strcpy(xestrwk,tistrwk);               //~v51BI~
                            infoid=":terminfo";                    //~v51BR~
                        }                                          //~v51BI~
                        else                                       //~v51BI~
                        {                                          //~v51BI~
                        	sprintf(tistrwk2,":ti=%s",tistrwk);    //~v51BR~
                        	infoid=tistrwk2;                       //~v51BR~
                        }                                          //~v51BI~
                    }                                              //~v51BI~
                    else                                           //~v51BI~
                    {                                              //~v51BI~
                        if (xestr==pfst->FSTstrnew)                //~v51BR~
	                        infoid=":xe";                          //~v51BR~
                        else                                       //~v51BI~
	                        infoid=":loadkeys";                    //~v51BR~
                    }                                              //~v51BI~
                }//not normal char                                 //~v51BI~
                else                                               //~v51BI~
                {                                                  //~v51BI~
                	infoid=0;                                      //~v51BI~
//                    if (!modx)                                   //~v51BR~
//                    {                                            //~v51BR~
//                        ch=pfkt->FKTsymid;                       //~v51BR~
//                        if (ch==0x01||ch==0x08||ch==0x09||ch==0x7f)//~v51BR~
//                        {                                        //~v51BR~
//                            *tistrwk=ch;                         //~v51BR~
//                            *(tistrwk+1)=0;                      //~v51BR~
//                            ukbdl_editstring(tistrwk,xestrwk);   //~v51BR~
//                            infoid=" ";                          //~v51BR~
//                        }                                        //~v51BR~
//                    }//plain                                     //~v51BR~
                }                                                  //~v51BI~
                if (infoid)                                        //~v51BI~
	                fprintf(fh,"%-s,string=%-12s %s\n",linehdr,xestrwk,infoid);//~v51BR~
            }//console                                             //~v51BR~
    		for (kk=0;kk<FKT_MAX_STR;kk++)                         //~v51BI~
            {                                                      //~v51BI~
				userparm=pfkt->FKTttstring[modx][kk];              //~v51BI~
		    	if (!userparm||!*userparm)                         //~v51BI~
        		    continue;                                      //~v51BI~
                switch(pfkt->FKTflag[modx][kk])                    //~v51BI~
                {                                                  //~v51BI~
                case FKT_USEORGSTR:     //by terminfo              //~v51BI~
		            if (ttyconsw)		//printed already          //~v51BI~
                    	continue;                                  //~v51BI~
                    infoid=":terminfo";                            //~v51BR~
                	break;                                         //~v51BI~
                case FKT_XDEFAULT:      //default for X            //~v51BI~
                    infoid=":xe default";                          //~v51BR~
                	break;                                         //~v51BI~
                case FKT_TTREPKEY:      //by key file parm         //~v51BI~
                    infoid=":parm keyfile";                        //~v51BR~
                	break;                                         //~v51BI~
                default:                                           //~v51BR~
                	continue;                                      //~v51BI~
                }                                                  //~v51BI~
                ukbdl_editstring(userparm,xestrwk);                //~v51BR~
                fprintf(fh,"%-s,string=%-12s (%s)\n",linehdr,xestrwk,infoid);//~v51BR~
            }//multiple str                                        //~v51BI~
        }//modx                                                    //~1304I~
    }                                                              //~1304I~
    fclose(fh);                                                    //~1226I~
    return;                                                        //~1226I~
}//xekbchk_printstring                                             //~1226I~
#else		//AIX                                                  //~v402I~
//*********************************************************************//~v402I~
//* print string                                                   //~v402I~
//*********************************************************************//~v402I~
void xekbchk_printstring(void)                                     //~v402I~
{                                                                  //~v402I~
	int jj,modx,pfktno,keycode,strtype;                            //~v51YR~
	PFUNCKEYTBL *ppfkt,pfkt;                                       //~v402I~
    FILE *fh;                                                      //~v402I~
    int kk,aixpfkno;                                               //~v51YR~
    char linehdr[80];                                              //~v51YI~
    char *xestr,*tistr,*ttstr,xestrwk[32],*infoid,ticmp[32];       //~v51YR~
static char *Sshiftid[4]={" ","+Shift","+Ctrl","+Alt"};            //~v402I~
//************************                                         //~v402I~
  if (*Sstrfnm)                                                    //~v53kI~
  {                                                                //~v53kI~
    fh=fopen(Sstrfnm,"w");                                         //~v402I~
    if (!fh)                                                       //~v402I~
        uerrexit("%s open failed",0,                               //~v402I~
                    Sstrfnm);                                      //~v402I~
  }                                                                //~v53kI~
  else                                                             //~v53kI~
    fh=stdout;                                                     //~v53kI~
	ukbdaixt_gettbl(&ppfkt,&pfktno,0,0);                           //~v402I~
    for (jj=0;jj<pfktno;jj++,ppfkt++)        //keycode             //~v402I~
    {                                                              //~v402I~
    	pfkt=*ppfkt;                                               //~v402I~
        keycode=pfkt->FKTkeycode;                                  //~v402R~
    	for (modx=0;modx<4;modx++)                                 //~v402I~
        {                                                          //~v402I~
            *ticmp=0;                                              //~v403I~
            strtype=pfkt->FKTfkassign[modx];                       //~v402I~
            if (!strtype)                                          //~v51YI~
            	continue;                                          //~v51YI~
            xestr=pfkt->FKTuserstring[modx];                       //~v402R~
            tistr=pfkt->FKTtistring[modx];                         //~v403I~
//            switch(strtype)                                      //~v51YR~
//            {                                                    //~v51YR~
//            case FKT_TTORGKEY:                                   //~v51YR~
//                infoid="TeraTerm Org";                           //~v51YR~
//                break;                                           //~v51YR~
//            case FKT_TTREPKEY:                                   //~v51YR~
//                infoid="TeraTerm Mod";                           //~v51YR~
//                break;                                           //~v51YR~
//            default:                                             //~v51YR~
//                infoid="";                                       //~v51YR~
//            }                                                    //~v51YR~
//            ttstr=pfkt->FKTttstring[modx];                       //~v51YR~
//            if (ttstr)                                           //~v51YR~
//            {                                                    //~v51YR~
//                xestr=ttstr;                                     //~v51YR~
//                if (tistr && *tistr)                             //~v51YR~
//                {                                                //~v51YR~
//                    if (strcmp(ttstr,tistr))    //not same       //~v51YR~
//                    {                                            //~v51YR~
//                        if (*tistr==0x1b)                        //~v51YR~
//                            sprintf(ticmp,"(Terminfo=^[%s)",tistr+1);//~v51YR~
//                        else                                     //~v51YR~
//                        {                                        //~v51YR~
//                            strcpy(ticmp,"(Terminfo=");          //~v51YR~
//                            pc=ticmp+strlen(ticmp);              //~v51YR~
//                            for (ii=0;ii<strlen(tistr);ii++)     //~v51YR~
//                                pc+=sprintf(pc,"0x%02x ",*(tistr+ii));//~v51YR~
//                            strcat(ticmp,")");                   //~v51YR~
//                        }                                        //~v51YR~
//                    }                                            //~v51YR~
//                    else                                         //~v51YR~
//                        strcpy(ticmp,"(=Terminfo)");             //~v51YR~
//                }                                                //~v51YR~
//            }                                                    //~v51YR~
//            else                                                 //~v51YR~
//              if (tistr && *tistr)                               //~v51YR~
//              {                                                  //~v51YR~
//                xestr=tistr;                                     //~v51YR~
//                infoid="Terminfo";                               //~v51YR~
//              }                                                  //~v51YR~
//              else                                               //~v51YR~
//                xestr=pfkt->FKTuserstring[modx];                 //~v51YR~
//            if (*xestr)                                          //~v51YR~
//            {                                                    //~v51YR~
//                if (*xestr==0x1b)                                //~v51YR~
//                    sprintf(xestrwk,"^[%s",xestr+1);             //~v51YR~
//                else                                             //~v51YR~
//                {                                                //~v51YR~
//                    pc=xestrwk;                                  //~v51YR~
//                    for (ii=0;ii<strlen(xestr);ii++)             //~v51YR~
//                        pc+=sprintf(pc,"0x%02x ",*(xestr+ii));   //~v51YR~
//                }                                                //~v51YR~
//                fprintf(fh,"%-9s(keycode=%4d):%-6s,string=%-12s %-12s %s\n",//~v51YR~
//                        pfkt->FKTkeyname,                        //~v51YR~
//                        keycode,                                 //~v51YR~
//                        Sshiftid[modx],                          //~v51YR~
//                        xestrwk,                                 //~v51YR~
//                        infoid,ticmp);                           //~v51YR~
//            }                                                    //~v51YR~
            sprintf(linehdr,"%-9s(keycode=%4d):%-6s",              //~v51YR~
                    pfkt->FKTkeyname,                              //~v51YI~
                    keycode,                                       //~v51YI~
                    Sshiftid[modx]);                               //~v51YI~
          if (xestr && *xestr)                                     //~v52eI~
            if (tistr && *tistr)                                   //~v51YI~
            {                                                      //~v51YI~
                ukbdl_editstring(tistr,xestrwk);                   //~v51YI~
                sprintf(ticmp,"(Terminfo=%-9s)",xestrwk);          //~v52eR~
            }                                                      //~v51YI~
            else                                                   //~v51YI~
//          	*ticmp=0;                                          //~v52eR~
                strcpy(ticmp,"(:xe               )");              //~v52eI~
          else                                                     //~v52eI~
            if (tistr && *tistr)                                   //~v52eI~
            {                                                      //~v52eI~
                ukbdl_editstring(tistr,xestrwk);                   //~v52eI~
                xestr=xestrwk;                                     //~v52eI~
                strcpy(ticmp,"(:from Terminfo    )");              //~v52eR~
            }                                                      //~v52eI~
          if (xestr)                                               //~v52eI~
            fprintf(fh,"%-s,string=^[%-10s %s\n",linehdr,xestr+1,ticmp);//~v52eR~
            aixpfkno=pfkt->FKTaixfunckeyno[modx];                  //~v51YR~
            if (aixpfkno)                                          //~v51YI~
            {                                                      //~v51YI~
                sprintf(xestrwk,"^[%03dq",aixpfkno);               //~v51YI~
                fprintf(fh,"%-s,string=%-12s (%-18s)\n",linehdr,xestrwk,":for aixterm");//~v51YR~
            }                                                      //~v51YI~
    		for (kk=0;kk<FKT_MAX_STR;kk++)                         //~v51YI~
            {                                                      //~v51YI~
				ttstr=pfkt->FKTttstring[modx][kk];                 //~v51YR~
		    	if (!ttstr||!*ttstr)                               //~v51YR~
        		    continue;                                      //~v51YI~
                switch(pfkt->FKTflag[modx][kk])                    //~v51YI~
                {                                                  //~v51YI~
                case FKT_TTREPKEY:      //by key file parm         //~v51YI~
                    infoid=":parm keyfile";                        //~v51YI~
                	break;                                         //~v51YI~
                case FKT_TTORGKEY:     //teraterm originary generate key//~v51YI~
                    infoid=":for Vt100";                           //~v51YR~
                	break;                                         //~v51YI~
                case FKT_AIXORGKEY:     //teraterm originary generate key//~v51YI~
                    infoid=":for X-terminal";                      //~v51YR~
                	break;                                         //~v51YI~
                case FKT_LINUX:     //teraterm originary generate key//~v51YI~
                    infoid=":for linux telnet";                    //~v51YR~
                	break;                                         //~v51YI~
                default:                                           //~v51YI~
                	continue;                                      //~v51YI~
                }                                                  //~v51YI~
                ukbdl_editstring(ttstr,xestrwk);                   //~v51YR~
                fprintf(fh,"%-s,string=%-12s (%-18s)\n",linehdr,xestrwk,infoid);//~v51YR~
            }//multiple str                                        //~v51YI~
        }//modx                                                    //~v402I~
    }                                                              //~v402I~
    fclose(fh);                                                    //~v402I~
    return;                                                        //~v402I~
}//xekbchk_printstring                                             //~v402I~
#endif  //AIX                                                      //~v402I~
#endif	//UNX                                                      //~v402R~
                                                                   //~v40aI~
#ifdef UNX                                                         //~v40aI~
//*********************************************************************//~v40aI~
//* print curses key definition                                    //~v40aI~
//*********************************************************************//~v40aI~
void xekbchk_ckprint(char *Poutfnm)                                //~v40aR~
{                                                                  //~v40aI~
#define PTERM(name) ckprintsub(fh,#name,name)                      //~v40aR~
	FILE *fh;                                                      //~v40aI~
void ckprintsub(FILE *Pfh,char *Pkeyname,char *Pstring);           //~v40aR~
    char *envterm;                                                 //~v51BI~
//*************************                                        //~v40aI~
  if (*Poutfnm)                                                    //~v53kI~
  {                                                                //~v53kI~
    fh=fopen(Poutfnm,"w");                                         //~v40aI~
    if (!fh)                                                       //~v40aI~
        uerrexit("%s open failed",0,                               //~v40aI~
                    Poutfnm);                                      //~v53kR~
  }                                                                //~v53kI~
  else                                                             //~v53kI~
    fh=stdout;                                                     //~v53kI~
    envterm=getenv("TERM");                                        //~v51BI~
    fprintf(fh,"\n##### terminfo key for TERM=%s #####\n",envterm);//~v53pR~
PTERM( key_backspace);                                             //~v40aI~
PTERM( key_catab    );                                             //~v40aI~
PTERM( key_clear    );                                             //~v40aI~
PTERM( key_ctab     );                                             //~v40aI~
PTERM( key_dc       );                                             //~v40aI~
PTERM( key_dl       );                                             //~v40aI~
PTERM( key_down     );                                             //~v40aI~
PTERM( key_eic      );                                             //~v40aI~
PTERM( key_eol      );                                             //~v40aI~
PTERM( key_eos      );                                             //~v40aI~
PTERM( key_f0       );                                             //~v40aI~
PTERM( key_f1       );                                             //~v40aI~
PTERM( key_f10      );                                             //~v40aI~
PTERM( key_f2       );                                             //~v40aI~
PTERM( key_f3       );                                             //~v40aI~
PTERM( key_f4       );                                             //~v40aI~
PTERM( key_f5       );                                             //~v40aI~
PTERM( key_f6       );                                             //~v40aI~
PTERM( key_f7       );                                             //~v40aI~
PTERM( key_f8       );                                             //~v40aI~
PTERM( key_f9       );                                             //~v40aI~
PTERM( key_home     );                                             //~v40aI~
PTERM( key_ic       );                                             //~v40aI~
PTERM( key_il       );                                             //~v40aI~
PTERM( key_left     );                                             //~v40aI~
PTERM( key_ll       );                                             //~v40aI~
PTERM( key_npage    );                                             //~v40aI~
PTERM( key_ppage    );                                             //~v40aI~
PTERM( key_right    );                                             //~v40aI~
PTERM( key_sf       );                                             //~v40aI~
PTERM( key_sr       );                                             //~v40aI~
PTERM( key_stab     );                                             //~v40aI~
PTERM( key_up       );                                             //~v40aI~
PTERM( keypad_local );                                             //~v40aI~
PTERM( keypad_xmit  );                                             //~v40aI~
                                                                   //~v40aI~
PTERM( key_a1       );                                             //~v40aI~
PTERM( key_a3       );                                             //~v40aI~
PTERM( key_b2       );                                             //~v40aI~
PTERM( key_c1       );                                             //~v40aI~
PTERM( key_c3       );                                             //~v40aI~
                                                                   //~v40aR~
PTERM( key_btab     );                                             //~v40aI~
                                                                   //~v40aR~
PTERM( key_beg      );                                             //~v40aI~
PTERM( key_cancel   );                                             //~v40aI~
PTERM( key_close    );                                             //~v40aI~
PTERM( key_command  );                                             //~v40aI~
PTERM( key_copy     );                                             //~v40aI~
PTERM( key_create   );                                             //~v40aI~
PTERM( key_end      );                                             //~v40aI~
PTERM( key_enter    );                                             //~v40aI~
PTERM( key_exit     );                                             //~v40aI~
PTERM( key_find     );                                             //~v40aI~
PTERM( key_help     );                                             //~v40aI~
PTERM( key_mark     );                                             //~v40aI~
PTERM( key_message  );                                             //~v40aI~
PTERM( key_move     );                                             //~v40aI~
PTERM( key_next     );                                             //~v40aI~
PTERM( key_open     );                                             //~v40aI~
PTERM( key_options  );                                             //~v40aI~
PTERM( key_previous );                                             //~v40aI~
PTERM( key_print    );                                             //~v40aI~
PTERM( key_redo     );                                             //~v40aI~
PTERM( key_reference);                                             //~v40aI~
PTERM( key_refresh  );                                             //~v40aI~
PTERM( key_replace  );                                             //~v40aI~
PTERM( key_restart  );                                             //~v40aI~
PTERM( key_resume   );                                             //~v40aI~
PTERM( key_save     );                                             //~v40aI~
PTERM( key_suspend  );                                             //~v40aI~
PTERM( key_undo     );                                             //~v40aI~
PTERM( key_sbeg     );                                             //~v40aI~
PTERM( key_scancel  );                                             //~v40aI~
PTERM( key_scommand );                                             //~v40aI~
PTERM( key_scopy    );                                             //~v40aI~
PTERM( key_screate  );                                             //~v40aI~
PTERM( key_sdc      );                                             //~v40aI~
PTERM( key_sdl      );                                             //~v40aI~
PTERM( key_select   );                                             //~v40aI~
PTERM( key_send     );                                             //~v40aI~
PTERM( key_seol     );                                             //~v40aI~
PTERM( key_sexit    );                                             //~v40aI~
PTERM( key_sfind    );                                             //~v40aI~
PTERM( key_shelp    );                                             //~v40aI~
PTERM( key_shome    );                                             //~v40aI~
PTERM( key_sic      );                                             //~v40aI~
PTERM( key_sleft    );                                             //~v40aI~
PTERM( key_smessage );                                             //~v40aI~
PTERM( key_smove    );                                             //~v40aI~
PTERM( key_snext    );                                             //~v40aI~
PTERM( key_soptions );                                             //~v40aI~
PTERM( key_sprevious);                                             //~v40aI~
PTERM( key_sprint   );                                             //~v40aI~
PTERM( key_sredo    );                                             //~v40aI~
PTERM( key_sreplace );                                             //~v40aI~
PTERM( key_sright   );                                             //~v40aI~
PTERM( key_srsume   );                                             //~v40aI~
PTERM( key_ssave    );                                             //~v40aI~
PTERM( key_ssuspend );                                             //~v40aI~
PTERM( key_sundo    );                                             //~v40aI~
PTERM( key_f11      );                                             //~v40aI~
PTERM( key_f12      );                                             //~v40aI~
PTERM( key_f13      );                                             //~v40aI~
PTERM( key_f14      );                                             //~v40aI~
PTERM( key_f15      );                                             //~v40aI~
PTERM( key_f16      );                                             //~v40aI~
PTERM( key_f17      );                                             //~v40aI~
PTERM( key_f18      );                                             //~v40aI~
PTERM( key_f19      );                                             //~v40aI~
PTERM( key_f20      );                                             //~v40aI~
PTERM( key_f21      );                                             //~v40aI~
PTERM( key_f22      );                                             //~v40aI~
PTERM( key_f23      );                                             //~v40aI~
PTERM( key_f24      );                                             //~v40aI~
PTERM( key_f25      );                                             //~v40aI~
PTERM( key_f26      );                                             //~v40aI~
PTERM( key_f27      );                                             //~v40aI~
PTERM( key_f28      );                                             //~v40aI~
PTERM( key_f29      );                                             //~v40aI~
PTERM( key_f30      );                                             //~v40aI~
PTERM( key_f31      );                                             //~v40aI~
PTERM( key_f32      );                                             //~v40aI~
PTERM( key_f33      );                                             //~v40aI~
PTERM( key_f34      );                                             //~v40aI~
PTERM( key_f35      );                                             //~v40aI~
PTERM( key_f36      );                                             //~v40aI~
PTERM( key_f37      );                                             //~v40aI~
PTERM( key_f38      );                                             //~v40aI~
PTERM( key_f39      );                                             //~v40aI~
PTERM( key_f40      );                                             //~v40aI~
PTERM( key_f41      );                                             //~v40aI~
PTERM( key_f42      );                                             //~v40aI~
PTERM( key_f43      );                                             //~v40aI~
PTERM( key_f44      );                                             //~v40aI~
PTERM( key_f45      );                                             //~v40aI~
PTERM( key_f46      );                                             //~v40aI~
PTERM( key_f47      );                                             //~v40aI~
PTERM( key_f48      );                                             //~v40aI~
PTERM( key_f49      );                                             //~v40aI~
PTERM( key_f50      );                                             //~v40aI~
PTERM( key_f51      );                                             //~v40aI~
PTERM( key_f52      );                                             //~v40aI~
PTERM( key_f53      );                                             //~v40aI~
PTERM( key_f54      );                                             //~v40aI~
PTERM( key_f55      );                                             //~v40aI~
PTERM( key_f56      );                                             //~v40aI~
PTERM( key_f57      );                                             //~v40aI~
PTERM( key_f58      );                                             //~v40aI~
PTERM( key_f59      );                                             //~v40aI~
PTERM( key_f60      );                                             //~v40aI~
PTERM( key_f61      );                                             //~v40aI~
PTERM( key_f62      );                                             //~v40aI~
PTERM( key_f63      );                                             //~v40aI~
#ifdef LNX                                                         //~v53jR~
    PTERM(  key_mouse    );                                        //~v53jR~
    PTERM(  mouse_info   );                                        //~v53jR~
    PTERM(  req_mouse_pos);                                        //~v53jR~
    PTERM(  get_mouse    );                                        //~v53jR~
#endif                                                             //~v53jR~
    fclose(fh);                                                    //~v40aI~
	return;                                                        //~v40aR~
}//xekbchk_ckprint                                                 //~v40aR~
//*********************************************************************//~v40aI~
//* print curses key definition                                    //~v40aI~
//*********************************************************************//~v40aI~
void ckprintsub(FILE *Pfh,char *Pkeyname,char *Pstring)            //~v40aR~
{                                                                  //~v40aI~
	char *pc;                                                      //~v40aI~
    int  binsw=0;                                                  //~v40aI~
//*************************                                        //~v40aI~
	fprintf(Pfh,"%-16s=",Pkeyname);                                //~v40aR~
    if (!Pstring)                                                  //~v40aI~
    	Pstring="";                                                //~v40aI~
    if (*Pstring==0x1b)                                            //~v40aI~
    {                                                              //~v40aI~
    	for (pc=Pstring+1;*pc;pc++)                                //~v40aI~
         	if (*pc<' ')                                           //~v40aR~
            {                                                      //~v40aI~
            	binsw=1;                                           //~v40aI~
                break;                                             //~v40aI~
            }                                                      //~v40aI~
    }                                                              //~v40aI~
    else                                                           //~v40aI~
    	binsw=1;                                                   //~v40aI~
                                                                   //~v40aI~
    if (binsw)                                                     //~v40aI~
    {                                                              //~v40aI~
    	for (pc=Pstring;*pc;pc++)                                  //~v40aI~
        	fprintf(Pfh," x%02X",*pc);                             //~v40aI~
        fprintf(Pfh,"\n");                                         //~v40aI~
    }                                                              //~v40aI~
    else                                                           //~v40aI~
    	fprintf(Pfh," x1B%s\n",Pstring+1);                         //~v40aR~
}//ckprintsub                                                      //~v40aI~
#endif	//UNX                                                      //~v40aI~
//**dummy func to avoid link ***************************************//~v518I~
#ifdef UNX                                                         //~v51CR~
    #include "xekbchkl.h"                                          //~v51CR~
#else                                                              //~v51CI~
int funccall(int Pkeytype,UCHAR *Pkey,PUCLIENTWE Ppcw){return 0;}  //~v518I~
FUNCTBL *funcftsrch(int Pkeytype,USHORT Pkey,int Pshift){return 0;}//~v518I~
FUNCTBL *functblsrch(int Pfuncid)                                  //~v518R~
{                                                                  //~v518I~
	static FUNCTBL Sdummyft={"","",0};                             //~v518R~
//*****************************                                    //~v518I~
	return &Sdummyft;                                              //~v518R~
}                                                                  //~v518I~
#endif                                                             //~v51CI~
int funcsetlongcmd(PUCLIENTWE Ppcw,int Popt,UCHAR *Pcmd,int Plen,int *Psetlen){return 0;}//~v518I~
int funcgetlongcmd(PUCLIENTWE Ppcw,UCHAR *Pcmd){return 0;}         //~v518I~
//void funccmdstack(UCHAR *Pcmd,int Pcmdlen){return;}              //~v670R~
void funccmdstack(UCHAR *Pcmd,int Pcmdlen,int Pseqno){return;}     //~v670R~
#ifndef UNX                                                        //~v51CI~
int func_prevtab_file(PUCLIENTWE Ppcw){return 0;}                  //~v518I~
#endif                                                             //~v51CI~
int panwakeup(PUCLIENTWE Ppcw){return 0;}                          //~v518I~
PUCLIENTWE panregist(int Pmenuid){return 0;}                       //~v518I~
int panlinetopfld(PUFLD Ppfl){return 0;}                           //~v518I~
int filewakeup(PUCLIENTWE Ppcw){return 0;}                         //~v518I~
CIDTBL *filegetcidtbl(void){return 0;}                             //~v518I~
int filesetassign(PUCLIENTWE Ppcw,int Pextkeysw,USHORT Pkey,int Pshiftkeysw){return 0;}//~v518R~
void ini2term(void){return;}                                       //~v518I~
void optsetdisplayeolid(void){return;}                             //~v518I~
void optsetdisplayeolcontid(void){return;}                         //~v60mI~
int filepguphalf(PUCLIENTWE Ppcw){return 0;}                       //~v55qM~
int filepgdownhalf(PUCLIENTWE Ppcw){return 0;}                     //~v55qM~
int filepglefthalf(PUCLIENTWE Ppcw){return 0;}                     //~v55qM~
int filepgrighthalf(PUCLIENTWE Ppcw){return 0;}                    //~v55qM~
int filesetupalct(void){return 0;}                                 //~v67CI~
PALCT filesrchalct(char *Pcmd,UQUEH *Ppqhalct){return 0;}          //~v67CI~
void file7term(void){return;}                                      //~v67CI~
int dirwakeup(PUCLIENTWE Ppcw){return 0;}                          //~v56pI~
PULINEH getdisplayline(PULINEH Pplh,int Pstep,int *Ppstep){return 0;}//~v69eR~
#ifndef LNX                                                        //~v705I~
	int funct2getnextinputgc(char *Pinput){return 0;}              //~v705R~
#endif                                                             //~v705I~
#ifdef FTPSUPP                                                     //~v70zI~
	char *xetsofilefullpath2ndedit(char *Pfullpath,PUFILEH Ppfh,char *Pmodifier){return 0;}//~v70zR~
	char *xetsofilefullpath2(char *Pfullpath,char *Ptarget,size_t Plen,char *Psource){return 0;}//~v70zR~
	int xetsogetpathlen(UCHAR *Pfilename,UCHAR *Plevel,int Pdirsw){return 0;}//+v717I~
#endif                                                             //~v70zI~
