//*CID://+v72NR~:                             update#=   40;       //+v72NR~
//****************************************************************//~6104I~
//xeopt.h                                                       //~6104I~
//****************************************************************//~6104I~
//v72N:061214 CAPS:cmdline caps option "cap on/off cmd" to set caps optio to same as file contents option//+v72NI~
//v71L:061104 CAP option save and apply as default or apply TSO only//~v71LI~
//v705:060727 graphic char setup by external file                  //~v705I~
//v69X:060720 (XXE)line-draw support also fo gxe when OPT LINECH ON.(v69M)//~v69XI~
//v69M:060713 (LNX)Change line drawing char effectiveness to optional. OPT LINECHAR [on|off]//~v69MI~
//                 (no code in iso8859 but in old IBM-PC Extended Char Set(ECS) only)//~v69MI~
//v678:051227 opt option "RETTOL":return to top of line by return key//~v678I~
//v64t:050704 (XXE)xxe support;RCTL support                        //~v64tI~
//v645:050617 OPT DELZ ON/OFF;option to prohibit dlcmd z/0;default is on//~v645R~
//v62G:050412 cmdlog function                                      //~v62GI~
//v60m:050129 display different id from eolid for contline terminater.//~v60mI~
//v584:040823 cap option not to copy to ::cb when cap-delete for performance up for large file//~v584I~
//v55q:040228 option to scroll by csr move(CSRSCROLL option)       //~v55qI~
//v55j:040215 (LNX)use ctl+char as alternative of Shift+xx         //~v55jI~
//v55c:040208 (WXE)distingush L-CTL/R-CTL & report R-CTL           //~v55cI~
//v54S:040125 add opt cmd:beep on/off                              //~v54SI~
//v47N:020330 (UNX)mdos is option;set on of by opt dos cmd         //~v47NI~
//v47d:020223 opt eol char on/off;end of line char and attr specification cmd//~v47dI~
//v44m:011204 option of upper/lower hex code display               //~v44mI~
//v43y:011122 7bit dump mode                                       //~v43yI~
//v0g1:971207 print parm by short filename option(opt plfn on/off) //~v0g1I~
//v0f0:971010 long filename support                                //~v0f0I~
//            win95 alias dir list option(OPT FAT cmd)             //~v0f0I~
//v05B:960104:Option commnad                                    //~6104I~
//****************************************************************//~6104I~
#ifdef  XEOPT_GLOBAL                                               //~v44mI~
  #define XEOPT_EXT                                                //~v44mI~
  #define XEOPT_INIT(value) =value                                 //~v44mI~
#else                                                              //~v44mI~
  #define XEOPT_EXT extern                                         //~v44mI~
  #define XEOPT_INIT(value)                                        //~v44mI~
#endif                                                             //~v44mI~
//**************************************************************** //~v44mI~
//XEOPT_EXT UCHAR  Goptopt;                                        //~v71LR~
#define GOPT_HEX_UPPER        0x01   //hex display by UPPER case   //~v44mI~
#define GOPT_EOL_ATTRON       0x02   //eol char attr bit set       //~v47dI~
#define GOPT_EOL_ATTROFF      0x04   //eol char attr bit no set    //~v47dI~
#define GOPT_CMDLOG           0x08   //cmd log on                  //~v62GR~
#define GOPT_RETTOL           0x10   //return to tol on            //~v678I~
#define GOPT_CAPLOCK_TSO      0x20   //default for tso file        //~v71LI~
#define GOPT_CAPLOCK_DEFAULT  0x40   //default for all file        //~v71LI~
#define GOPT_CAPLOCK_CMD      0x80   //set cmd line to same status as file contents//+v72NI~
                                                                   //~v71LI~
XEOPT_EXT UCHAR  Goptopt XEOPT_INIT(GOPT_CAPLOCK_TSO);             //~v71LM~
                                                                   //~v71LI~
XEOPT_EXT UCHAR  Gopteol;   //0 for defauult                       //~v47dR~
XEOPT_EXT UCHAR  Gopteol2;  //some for default                     //~v47dI~
XEOPT_EXT UCHAR  Gopteolcont;   //conline termID specification     //~v60mI~
XEOPT_EXT UCHAR  Gopteolcont2;  //display char for contline termID //~v60mI~
//**************************************************************** //~v44mI~
typedef struct _UOPTWTBL                                        //~6104M~
{                                                               //~6104M~
		UCHAR  UOWcmd  [8];			//command word                 //~v43yR~
 		int    (*UOWfunc)(PUCLIENTWE,struct _UOPTWTBL*,int);//function addr//~6104I~
		UCHAR  UOWminopd;			//opd min count             //~6104I~
		UCHAR  UOWmaxopd;			//opd max count             //~6104I~
		UCHAR  UOWflag;				//flag                      //~6104I~
		UCHAR  UOWrsv;				//                          //~6104I~
} UOPTWTBL;                                                     //~6104M~
typedef UOPTWTBL *PUOPTWTBL;                                    //~6104M~
#define UOPTWTBLSZ (sizeof(UOPTWTBL))                           //~6104M~
typedef int (OPTFUNC)(PUCLIENTWE Ppcw,PUOPTWTBL Popt,int Popdno);//~6114R~
//*FUNCTION**************                                       //~6104I~
	OPTFUNC opt_undel;                                          //~6105R~
	OPTFUNC opt_fat;                                               //~v0f0I~
	OPTFUNC opt_pfat;                                              //~v0g1I~
	OPTFUNC opt_7bit;                                              //~v43yI~
	OPTFUNC opt_hex;                                               //~v44mI~
	OPTFUNC opt_eol;                                               //~v47dI~
	OPTFUNC opt_eolcont;                                           //~v60mI~
	OPTFUNC opt_beep;                                              //~v54SI~
	OPTFUNC opt_ccfunc;                                            //~v55jR~
	OPTFUNC opt_freecsr;                                           //~v55qI~
	OPTFUNC opt_cmdlog;                                            //~v62GI~
	OPTFUNC opt_delz;                                              //~v645I~
	OPTFUNC opt_rettol;                                            //~v678I~
#ifdef UNX                                                         //~v47NI~
	OPTFUNC opt_fd;                                                //~v47NR~
  #ifdef XXE                                                       //~v64tI~
	OPTFUNC opt_rctl;                                              //~v64tI~
  #endif                                                           //~v64tI~
#else                                                              //~v55cI~
	OPTFUNC opt_rctl;                                              //~v55cI~
#endif                                                             //~v47NI~
	OPTFUNC opt_cbcopy;                                            //~v584I~
//#if defined(LNX) && !defined(XXE)                                //~v69XR~
//#ifdef LNX                                                       //~v705R~
	OPTFUNC opt_acs;                                               //~v69MI~
//#endif                                                           //~v705R~
//**************************************************               //~v47dI~
void optsetdisplayeolid(void);                                     //~v47NR~
void optsetdisplayeolcontid(void);                                 //~v60mI~
